/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ve=["exports","require","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/path","vs/base/common/errors","vs/nls","vs/nls!vs/server/node/server.main","vs/base/common/types","vs/platform/log/common/log","vs/base/common/network","vs/base/common/async","vs/base/common/strings","vs/base/common/buffer","vs/platform/files/common/files","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/resources","vs/base/node/pfs","vs/base/common/uuid","vs/base/common/objects","vs/platform/configuration/common/configuration","vs/platform/product/common/productService","vs/base/common/map","vs/base/common/process","vs/platform/environment/common/environment","fs","os","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/telemetry/common/telemetry","vs/platform/registry/common/platform","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/extpath","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/errorMessage","vs/base/common/codicons","vs/base/parts/ipc/common/ipc","vs/platform/telemetry/common/telemetryUtils","vs/server/node/serverEnvironmentService","vs/base/common/stream","vs/base/common/performance","vs/editor/common/core/range","vs/base/common/marshalling","child_process","vs/base/common/semver/semver","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/iterator","vs/base/common/mime","vs/base/common/processes","vs/base/common/ternarySearchTree","vs/base/parts/ipc/node/ipc.net","vs/platform/environment/node/argv","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policy","vs/platform/remote/common/remoteHosts","vs/workbench/api/node/uriTransformer","vs/workbench/contrib/testing/common/testId","vs/base/common/functional","vs/base/common/json","vs/base/common/severity","vs/base/common/glob","vs/base/common/uriIpc","vs/platform/extensions/common/extensionValidator","vs/platform/credentials/common/credentials","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","url","vs/platform/shell/node/shellEnv","vs/platform/workspace/common/workspace","vs/workbench/common/editor","vs/workbench/contrib/testing/common/testTypes","vs/base/common/decorators","vs/base/common/assert","vs/base/common/linkedList","vs/base/common/normalization","path","net","vs/editor/common/core/position","vs/base/common/hash","vs/base/common/htmlContent","vs/base/node/id","vs/base/node/powershell","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/common/environmentService","vs/platform/contextkey/common/contextkey","vs/platform/files/common/io","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/fileService","vs/platform/log/common/logIpc","vs/platform/log/node/spdlogLog","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/languagePacks/node/languagePacks","crypto","vs/platform/telemetry/common/commonProperties","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/common/extensionGalleryService","vs/server/node/extensionHostStatusService","vs/server/node/remoteLanguagePacks","vs/server/node/extensionsScannerService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/editor/common/editorService","vs/server/node/extensionHostConnection","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/remote/common/remoteAgentService","vs/base/node/zip","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/base/common/amd","vs/base/common/lazy","vs/base/common/marked/marked","vs/base/common/skipList","vs/base/common/dataTransfer","vs/base/node/languagePacks","vs/base/node/macAddress","vs/base/node/ports","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/console","vs/base/common/labels","vs/base/node/extpath","vs/base/node/shell","vs/base/parts/storage/common/storage","vs/editor/common/tokenizationRegistry","vs/editor/common/languages","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/server/node/serverEnvironmentService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsUtil","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/download/common/downloadIpc","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/diagnostics/common/diagnostics","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/label/common/label","vs/platform/credentials/common/credentialsMainService","vs/platform/encryption/node/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/node/loggerService","vs/platform/markers/common/markers","vs/platform/credentials/node/credentialsMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","vs/platform/telemetry/common/errorTelemetry","vs/platform/telemetry/common/remoteTelemetryChannel","vs/platform/diagnostics/node/diagnosticsService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/common/serverTelemetryService","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/errorTelemetry","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalEnvironment","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/storage/common/storage","vs/server/node/remoteExtensionManagement","vs/server/node/serverConnectionToken","cookie","vs/server/node/webClientServer","vs/workbench/api/common/extHostRpcService","vs/server/node/remoteFileSystemProviderServer","vs/workbench/contrib/terminal/common/environmentVariableCollection","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/services/configuration/common/configuration","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/contrib/terminal/common/remoteTerminalChannel","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostTestItem","vs/workbench/services/extensions/common/extensionsUtil","vs/server/node/remoteAgentEnvironmentImpl","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostCommands","vs/workbench/api/node/extHostCLIServer","vs/server/node/remoteTerminalChannel","vs/workbench/services/remote/common/remoteFileSystemProviderClient","vs/platform/extensionManagement/node/extensionManagementUtil","vs/server/node/remoteExtensionHostAgentCli","vs/server/node/serverServices","vs/server/node/remoteExtensionHostAgentServer","perf_hooks","util","minimist","assert","graceful-fs","https","http","yauzl","yazl","zlib","vs/server/node/server.main"],be=function(ie){for(var e=[],b=0,t=ie.length;b<t;b++)e[b]=ve[ie[b]];return e};define(ve[135],be([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=void 0;class b{static get(){const k=new Map,S=new Map,I=new Map,A=new Map;function E(w,m){w.has(m.detail)||w.set(m.detail,-m.timestamp)}function y(w,m){const g=w.get(m.detail);!g||g>=0||w.set(m.detail,g+m.timestamp)}let D=[];typeof ie.getStats=="function"&&(D=ie.getStats().slice(0).sort((w,m)=>w.timestamp-m.timestamp));for(const w of D)switch(w.type){case 10:E(k,w);break;case 11:case 12:y(k,w);break;case 21:E(S,w);break;case 22:y(S,w);break;case 33:E(I,w);break;case 34:y(I,w);break;case 31:E(A,w);break;case 32:y(A,w);break}let T=0;I.forEach(w=>T+=w);function C(w){const m=[];return w.forEach((g,p)=>m.push([p,g])),m}return{amdLoad:C(k),amdInvoke:C(S),nodeRequire:C(I),nodeEval:C(A),nodeRequireTotal:T}}static toMarkdownTable(k,S){let I="";const A=[];return k.forEach((E,y)=>{A[y]=E.length}),S.forEach(E=>{E.forEach((y,D)=>{typeof y>"u"&&(y=E[D]="-");const T=y.toString().length;A[D]=Math.max(T,A[D])})}),k.forEach((E,y)=>{I+=`| ${E+" ".repeat(A[y]-E.toString().length)} `}),I+=`|
`,k.forEach((E,y)=>{I+=`| ${"-".repeat(A[y])} `}),I+=`|
`,S.forEach(E=>{E.forEach((y,D)=>{typeof y<"u"&&(I+=`| ${y+" ".repeat(A[D]-y.toString().length)} `)}),I+=`|
`}),I}}e.LoaderStats=b}),define(ve[40],be([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.Codicon=e.getCodiconAriaLabel=void 0;function b(S){return S?S.replace(/\$\((.*?)\)/g,(I,A)=>` ${A} `).trim():""}e.getCodiconAriaLabel=b;class t{constructor(I,A,E){this.id=I,this.definition=A,this.description=E,t.a.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t.a}}e.Codicon=t,t.a=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.commentDraft=new t("comment-draft",{fontCharacter:"\\ec0e"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);var k;(function(S){S.iconNameSegment="[A-Za-z0-9]+",S.iconNameExpression="[A-Za-z0-9-]+",S.iconModifierExpression="~[A-Za-z]+",S.iconNameCharacter="[A-Za-z0-9~-]";const I=new RegExp(`^(${S.iconNameExpression})(${S.iconModifierExpression})?$`);function A(D){if(D instanceof t)return["codicon","codicon-"+D.id];const T=I.exec(D.id);if(!T)return A(t.error);const[,C,w]=T,m=["codicon","codicon-"+C];return w&&m.push("codicon-modifier-"+w.substring(1)),m}S.asClassNameArray=A;function E(D){return A(D).join(" ")}S.asClassName=E;function y(D){return"."+A(D).join(".")}S.asCSSSelector=y})(k=e.CSSIcon||(e.CSSIcon={}))}),define(ve[84],be([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function b(I){return(A,E,y)=>{let D=null,T=null;if(typeof y.value=="function"?(D="value",T=y.value):typeof y.get=="function"&&(D="get",T=y.get),!T)throw new Error("not supported");y[D]=I(T,E)}}function t(I,A,E){let y=null,D=null;if(typeof E.value=="function"?(y="value",D=E.value,D.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&(y="get",D=E.get),!D)throw new Error("not supported");const T=`$memoize$${A}`;E[y]=function(...C){return this.hasOwnProperty(T)||Object.defineProperty(this,T,{configurable:!1,enumerable:!1,writable:!1,value:D.apply(this,C)}),this[T]}}e.memoize=t;function k(I,A,E){return b((y,D)=>{const T=`$debounce$${D}`,C=`$debounce$result$${D}`;return function(...w){this[C]||(this[C]=E?E():void 0),clearTimeout(this[T]),A&&(this[C]=A(this[C],...w),w=[this[C]]),this[T]=setTimeout(()=>{y.apply(this,w),this[C]=E?E():void 0},I)}})}e.debounce=k;function S(I,A,E){return b((y,D)=>{const T=`$throttle$timer$${D}`,C=`$throttle$result$${D}`,w=`$throttle$lastRun$${D}`,m=`$throttle$pending$${D}`;return function(...g){if(this[C]||(this[C]=E?E():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),A&&(this[C]=A(this[C],...g)),this[m])return;const p=this[w]+I;p<=Date.now()?(this[w]=Date.now(),y.apply(this,[this[C]]),this[C]=E?E():void 0):(this[m]=!0,this[T]=setTimeout(()=>{this[m]=!1,this[w]=Date.now(),y.apply(this,[this[C]]),this[C]=E?E():void 0},p-Date.now()))}})}e.throttle=S}),define(ve[8],be([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class b{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?c.isErrorNoTelemetry(i)?new c(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(n=>{n(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.ErrorHandler=b,e.errorHandler=new b;function t(f){e.errorHandler.setUnexpectedErrorHandler(f)}e.setUnexpectedErrorHandler=t;function k(f){E(f)||e.errorHandler.onUnexpectedError(f)}e.onUnexpectedError=k;function S(f){E(f)||e.errorHandler.onUnexpectedExternalError(f)}e.onUnexpectedExternalError=S;function I(f){if(f instanceof Error){const{name:i,message:n}=f,r=f.stacktrace||f.stack;return{$isError:!0,name:i,message:n,stack:r,noTelemetry:c.isErrorNoTelemetry(f)}}return f}e.transformErrorForSerialization=I;const A="Canceled";function E(f){return f instanceof y?!0:f instanceof Error&&f.name===A&&f.message===A}e.isCancellationError=E;class y extends Error{constructor(){super(A),this.name=this.message}}e.CancellationError=y;function D(){const f=new Error(A);return f.name=f.message,f}e.canceled=D;function T(f){return f?new Error(`Illegal argument: ${f}`):new Error("Illegal argument")}e.illegalArgument=T;function C(f){return f?new Error(`Illegal state: ${f}`):new Error("Illegal state")}e.illegalState=C;function w(f){return f?new Error(`readonly property '${f} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=w;function m(f){const i=new Error(`${f} has been disposed`);return i.name="DISPOSED",i}e.disposed=m;function g(f){return f?f.message?f.message:f.stack?f.stack.split(`
`)[0]:String(f):"Error"}e.getErrorMessage=g;class p extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.NotImplementedError=p;class d extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.NotSupportedError=d;class v extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=v;class c extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof c)return i;const n=new c;return n.message=i.message,n.stack=i.stack,n}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.ErrorNoTelemetry=c;class h extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,h.prototype);debugger}}e.BugIndicatingError=h}),define(ve[18],be([1,0,8]),function(ie,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t($,J=0){return $[$.length-(1+J)]}e.tail=t;function k($){if($.length===0)throw new Error("Invalid tail call");return[$.slice(0,$.length-1),$[$.length-1]]}e.tail2=k;function S($,J,_=(j,H)=>j===H){if($===J)return!0;if(!$||!J||$.length!==J.length)return!1;for(let j=0,H=$.length;j<H;j++)if(!_($[j],J[j]))return!1;return!0}e.equals=S;function I($,J){const _=$.length-1;J<_&&($[J]=$[_]),$.pop()}e.removeFastWithoutKeepingOrder=I;function A($,J,_){return E($.length,j=>_($[j],J))}e.binarySearch=A;function E($,J){let _=0,j=$-1;for(;_<=j;){const H=(_+j)/2|0,q=J(H);if(q<0)_=H+1;else if(q>0)j=H-1;else return H}return-(_+1)}e.binarySearch2=E;function y($,J){let _=0,j=$.length;if(j===0)return 0;for(;_<j;){const H=Math.floor((_+j)/2);J($[H])?j=H:_=H+1}return _}e.findFirstInSorted=y;function D($,J,_){if($=$|0,$>=J.length)throw new TypeError("invalid index");const j=J[Math.floor(J.length*Math.random())],H=[],q=[],Z=[];for(const ae of J){const we=_(ae,j);we<0?H.push(ae):we>0?q.push(ae):Z.push(ae)}return $<H.length?D($,H,_):$<H.length+Z.length?Z[0]:D($-(H.length+Z.length),q,_)}e.quickSelect=D;function T($,J){const _=[];let j;for(const H of $.slice(0).sort(J))!j||J(j[0],H)!==0?(j=[H],_.push(j)):j.push(H);return _}e.groupBy=T;function C($,J,_){const j=[];function H(ae,we,ke){if(we===0&&ke.length===0)return;const Ae=j[j.length-1];Ae&&Ae.start+Ae.deleteCount===ae?(Ae.deleteCount+=we,Ae.toInsert.push(...ke)):j.push({start:ae,deleteCount:we,toInsert:ke})}let q=0,Z=0;for(;;){if(q===$.length){H(q,0,J.slice(Z));break}if(Z===J.length){H(q,$.length-q,[]);break}const ae=$[q],we=J[Z],ke=_(ae,we);ke===0?(q+=1,Z+=1):ke<0?(H(q,1,[]),q+=1):ke>0&&(H(q,0,[we]),Z+=1)}return j}e.sortedDiff=C;function w($,J,_){const j=C($,J,_),H=[],q=[];for(const Z of j)H.push(...$.slice(Z.start,Z.start+Z.deleteCount)),q.push(...Z.toInsert);return{removed:H,added:q}}e.delta=w;function m($,J,_){if(_===0)return[];const j=$.slice(0,_).sort(J);return p($,J,j,_,$.length),j}e.top=m;function g($,J,_,j,H){return _===0?Promise.resolve([]):new Promise((q,Z)=>{(async()=>{const ae=$.length,we=$.slice(0,_).sort(J);for(let ke=_,Ae=Math.min(_+j,ae);ke<ae;ke=Ae,Ae=Math.min(Ae+j,ae)){if(ke>_&&await new Promise(Me=>setTimeout(Me)),H&&H.isCancellationRequested)throw new b.CancellationError;p($,J,we,ke,Ae)}return we})().then(q,Z)})}e.topAsync=g;function p($,J,_,j,H){for(const q=_.length;j<H;j++){const Z=$[j];if(J(Z,_[q-1])<0){_.pop();const ae=y(_,we=>J(Z,we)<0);_.splice(ae,0,Z)}}}function d($){return $.filter(J=>!!J)}e.coalesce=d;function v($){let J=0;for(let _=0;_<$.length;_++)$[_]&&($[J]=$[_],J+=1);$.length=J}e.coalesceInPlace=v;function c($,J,_){$.splice(_,0,$.splice(J,1)[0])}e.move=c;function h($){return!Array.isArray($)||$.length===0}e.isFalsyOrEmpty=h;function f($){return Array.isArray($)&&$.length>0}e.isNonEmptyArray=f;function i($,J=_=>_){const _=new Set;return $.filter(j=>{const H=J(j);return _.has(H)?!1:(_.add(H),!0)})}e.distinct=i;function n($){const J=new Set;return _=>{const j=$(_);return J.has(j)?!1:(J.add(j),!0)}}e.uniqueFilter=n;function r($,J){const _=o($,J);if(_!==-1)return $[_]}e.findLast=r;function o($,J){for(let _=$.length-1;_>=0;_--){const j=$[_];if(J(j))return _}return-1}e.lastIndex=o;function a($,J){return $.length>0?$[0]:J}e.firstOrDefault=a;function l($,J){return $.length>0?$[$.length-1]:J}e.lastOrDefault=l;function s($,J,_=(j,H)=>j===H){let j=0;for(let H=0,q=Math.min($.length,J.length);H<q&&_($[H],J[H]);H++)j++;return j}e.commonPrefixLength=s;function u($){return[].concat(...$)}e.flatten=u;function P($,J){let _=typeof J=="number"?$:0;typeof J=="number"?_=$:(_=0,J=$);const j=[];if(_<=J)for(let H=_;H<J;H++)j.push(H);else for(let H=_;H>J;H--)j.push(H);return j}e.range=P;function F($,J,_){return $.reduce((j,H)=>(j[J(H)]=_?_(H):H,j),Object.create(null))}e.index=F;function K($,J){return $.push(J),()=>ne($,J)}e.insert=K;function ne($,J){const _=$.indexOf(J);if(_>-1)return $.splice(_,1),J}e.remove=ne;function ue($,J,_){const j=$.slice(0,J),H=$.slice(J);return j.concat(_,H)}e.arrayInsert=ue;function se($,J){let _;if(typeof J=="number"){let j=J;_=()=>{const H=Math.sin(j++)*179426549;return H-Math.floor(H)}}else _=Math.random;for(let j=$.length-1;j>0;j-=1){const H=Math.floor(_()*(j+1)),q=$[j];$[j]=$[H],$[H]=q}}e.shuffle=se;function U($,J){const _=$.indexOf(J);_>-1&&($.splice(_,1),$.unshift(J))}e.pushToStart=U;function Q($,J){const _=$.indexOf(J);_>-1&&($.splice(_,1),$.push(J))}e.pushToEnd=Q;function z($,J){for(const _ of J)$.push(_)}e.pushMany=z;function G($,J){return Array.isArray($)?$.map(J):J($)}e.mapArrayOrNot=G;function X($){return Array.isArray($)?$:[$]}e.asArray=X;function ce($){return $[Math.floor(Math.random()*$.length)]}e.getRandomElement=ce;function L($,J){for(const _ of $){const j=J(_);if(j!==void 0)return j}}e.mapFind=L;function N($,J,_){const j=ee($,J),H=$.length,q=_.length;$.length=H+q;for(let Z=H-1;Z>=j;Z--)$[Z+q]=$[Z];for(let Z=0;Z<q;Z++)$[Z+j]=_[Z]}e.insertInto=N;function V($,J,_,j){const H=ee($,J),q=$.splice(H,_);return N($,H,j),q}e.splice=V;function ee($,J){return J<0?Math.max(J+$.length,0):Math.min(J,$.length)}var oe;(function($){function J(H){return H<0}$.isLessThan=J;function _(H){return H>0}$.isGreaterThan=_;function j(H){return H===0}$.isNeitherLessOrGreaterThan=j,$.greaterThan=1,$.lessThan=-1,$.neitherLessOrGreaterThan=0})(oe=e.CompareResult||(e.CompareResult={}));function ge($,J){return(_,j)=>J($(_),$(j))}e.compareBy=ge;function fe(...$){return(J,_)=>{for(const j of $){const H=j(J,_);if(!oe.isNeitherLessOrGreaterThan(H))return H}return oe.neitherLessOrGreaterThan}}e.tieBreakComparators=fe;const R=($,J)=>$-J;e.numberComparator=R;function M($,J){if($.length===0)return;let _=$[0];for(let j=1;j<$.length;j++){const H=$[j];J(H,_)>0&&(_=H)}return _}e.findMaxBy=M;function W($,J){if($.length===0)return;let _=$[0];for(let j=1;j<$.length;j++){const H=$[j];J(H,_)>=0&&(_=H)}return _}e.findLastMaxBy=W;function Y($,J){return M($,(_,j)=>-J(_,j))}e.findMinBy=Y;class re{constructor(J){this.f=J,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(J){let _=this.c;for(;_<this.f.length&&J(this.f[_]);)_++;const j=_===this.c?null:this.f.slice(this.c,_);return this.c=_,j}takeFromEndWhile(J){let _=this.d;for(;_>=0&&J(this.f[_]);)_--;const j=_===this.d?null:this.f.slice(_+1,this.d+1);return this.d=_,j}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const J=this.f[this.c];return this.c++,J}removeLast(){const J=this.f[this.d];return this.d--,J}takeCount(J){const _=this.f.slice(this.c,this.c+J);return this.c+=J,_}}e.ArrayQueue=re;class me{constructor(J){this.iterate=J}forEach(J){this.iterate(_=>(J(_),!0))}toArray(){const J=[];return this.iterate(_=>(J.push(_),!0)),J}filter(J){return new me(_=>this.iterate(j=>J(j)?_(j):!0))}map(J){return new me(_=>this.iterate(j=>_(J(j))))}some(J){let _=!1;return this.iterate(j=>(_=J(j),!_)),_}findFirst(J){let _;return this.iterate(j=>J(j)?(_=j,!1):!0),_}findLast(J){let _;return this.iterate(j=>(J(j)&&(_=j),!0)),_}findLastMaxBy(J){let _,j=!0;return this.iterate(H=>((j||oe.isGreaterThan(J(H,_)))&&(j=!1,_=H),!0)),_}}e.CallbackIterable=me,me.empty=new me($=>{})}),define(ve[85],be([1,0,8]),function(ie,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function t(E,y){if(!E)throw new Error(y?`Assertion failed (${y})`:"Assertion Failed")}e.ok=t;function k(E,y="Unreachable"){throw new Error(y)}e.assertNever=k;function S(E){if(!E)throw new b.BugIndicatingError("Assertion Failed")}e.assert=S;function I(E){if(!E()){debugger;E(),(0,b.onUnexpectedError)(new b.BugIndicatingError("Assertion Failed"))}}e.assertFn=I;function A(E,y){let D=0;for(;D<E.length-1;){const T=E[D],C=E[D+1];if(!y(T,C))return!1;D++}return!0}e.checkAdjacentItems=A}),define(ve[68],be([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function b(t){const k=this;let S=!1,I;return function(){return S||(S=!0,I=t.apply(k,arguments)),I}}e.once=b}),define(ve[55],be([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var b;(function(t){function k(h){return h&&typeof h=="object"&&typeof h[Symbol.iterator]=="function"}t.is=k;const S=Object.freeze([]);function I(){return S}t.empty=I;function*A(h){yield h}t.single=A;function E(h){return k(h)?h:A(h)}t.wrap=E;function y(h){return h||S}t.from=y;function D(h){return!h||h[Symbol.iterator]().next().done===!0}t.isEmpty=D;function T(h){return h[Symbol.iterator]().next().value}t.first=T;function C(h,f){for(const i of h)if(f(i))return!0;return!1}t.some=C;function w(h,f){for(const i of h)if(f(i))return i}t.find=w;function*m(h,f){for(const i of h)f(i)&&(yield i)}t.filter=m;function*g(h,f){let i=0;for(const n of h)yield f(n,i++)}t.map=g;function*p(...h){for(const f of h)for(const i of f)yield i}t.concat=p;function d(h,f,i){let n=i;for(const r of h)n=f(n,r);return n}t.reduce=d;function*v(h,f,i=h.length){for(f<0&&(f+=h.length),i<0?i+=h.length:i>h.length&&(i=h.length);f<i;f++)yield h[f]}t.slice=v;function c(h,f=Number.POSITIVE_INFINITY){const i=[];if(f===0)return[i,h];const n=h[Symbol.iterator]();for(let r=0;r<f;r++){const o=n.next();if(o.done)return[i,t.empty()];i.push(o.value)}return[i,{[Symbol.iterator](){return n}}]}t.consume=c})(b=e.Iterable||(e.Iterable={}))}),define(ve[69],be([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var b;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(b=e.ScanError||(e.ScanError={}));var t;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var S;(function(i){i.DEFAULT={allowTrailingComma:!0}})(S=e.ParseOptions||(e.ParseOptions={}));function I(i,n=!1){let r=0;const o=i.length;let a="",l=0,s=16,u=0;function P(Q){let z=0,G=0;for(;z<Q;){const X=i.charCodeAt(r);if(X>=48&&X<=57)G=G*16+X-48;else if(X>=65&&X<=70)G=G*16+X-65+10;else if(X>=97&&X<=102)G=G*16+X-97+10;else break;r++,z++}return z<Q&&(G=-1),G}function F(Q){r=Q,a="",l=0,s=16,u=0}function K(){const Q=r;if(i.charCodeAt(r)===48)r++;else for(r++;r<i.length&&y(i.charCodeAt(r));)r++;if(r<i.length&&i.charCodeAt(r)===46)if(r++,r<i.length&&y(i.charCodeAt(r)))for(r++;r<i.length&&y(i.charCodeAt(r));)r++;else return u=3,i.substring(Q,r);let z=r;if(r<i.length&&(i.charCodeAt(r)===69||i.charCodeAt(r)===101))if(r++,(r<i.length&&i.charCodeAt(r)===43||i.charCodeAt(r)===45)&&r++,r<i.length&&y(i.charCodeAt(r))){for(r++;r<i.length&&y(i.charCodeAt(r));)r++;z=r}else u=3;return i.substring(Q,z)}function ne(){let Q="",z=r;for(;;){if(r>=o){Q+=i.substring(z,r),u=2;break}const G=i.charCodeAt(r);if(G===34){Q+=i.substring(z,r),r++;break}if(G===92){if(Q+=i.substring(z,r),r++,r>=o){u=2;break}switch(i.charCodeAt(r++)){case 34:Q+='"';break;case 92:Q+="\\";break;case 47:Q+="/";break;case 98:Q+="\b";break;case 102:Q+="\f";break;case 110:Q+=`
`;break;case 114:Q+="\r";break;case 116:Q+="	";break;case 117:{const ce=P(4);ce>=0?Q+=String.fromCharCode(ce):u=4;break}default:u=5}z=r;continue}if(G>=0&&G<=31)if(E(G)){Q+=i.substring(z,r),u=2;break}else u=6;r++}return Q}function ue(){if(a="",u=0,l=r,r>=o)return l=o,s=17;let Q=i.charCodeAt(r);if(A(Q)){do r++,a+=String.fromCharCode(Q),Q=i.charCodeAt(r);while(A(Q));return s=15}if(E(Q))return r++,a+=String.fromCharCode(Q),Q===13&&i.charCodeAt(r)===10&&(r++,a+=`
`),s=14;switch(Q){case 123:return r++,s=1;case 125:return r++,s=2;case 91:return r++,s=3;case 93:return r++,s=4;case 58:return r++,s=6;case 44:return r++,s=5;case 34:return r++,a=ne(),s=10;case 47:{const z=r-1;if(i.charCodeAt(r+1)===47){for(r+=2;r<o&&!E(i.charCodeAt(r));)r++;return a=i.substring(z,r),s=12}if(i.charCodeAt(r+1)===42){r+=2;const G=o-1;let X=!1;for(;r<G;){if(i.charCodeAt(r)===42&&i.charCodeAt(r+1)===47){r+=2,X=!0;break}r++}return X||(r++,u=1),a=i.substring(z,r),s=13}return a+=String.fromCharCode(Q),r++,s=16}case 45:if(a+=String.fromCharCode(Q),r++,r===o||!y(i.charCodeAt(r)))return s=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=K(),s=11;default:for(;r<o&&se(Q);)r++,Q=i.charCodeAt(r);if(l!==r){switch(a=i.substring(l,r),a){case"true":return s=8;case"false":return s=9;case"null":return s=7}return s=16}return a+=String.fromCharCode(Q),r++,s=16}}function se(Q){if(A(Q)||E(Q))return!1;switch(Q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function U(){let Q;do Q=ue();while(Q>=12&&Q<=15);return Q}return{setPosition:F,getPosition:()=>r,scan:n?U:ue,getToken:()=>s,getTokenValue:()=>a,getTokenOffset:()=>l,getTokenLength:()=>r-l,getTokenError:()=>u}}e.createScanner=I;function A(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function E(i){return i===10||i===13||i===8232||i===8233}function y(i){return i>=48&&i<=57}var D;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(D||(D={}));function T(i,n){const r=[],o=new Object;let a;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let s=!1;function u(P,F,K,ne){l.value=P,l.offset=F,l.length=K,l.type=ne,l.colonOffset=void 0,a=l}try{c(i,{onObjectBegin:(P,F)=>{if(n<=P)throw o;a=void 0,s=n>P,r.push("")},onObjectProperty:(P,F,K)=>{if(n<F||(u(P,F,K,"property"),r[r.length-1]=P,n<=F+K))throw o},onObjectEnd:(P,F)=>{if(n<=P)throw o;a=void 0,r.pop()},onArrayBegin:(P,F)=>{if(n<=P)throw o;a=void 0,r.push(0)},onArrayEnd:(P,F)=>{if(n<=P)throw o;a=void 0,r.pop()},onLiteralValue:(P,F,K)=>{if(n<F||(u(P,F,K,f(P)),n<=F+K))throw o},onSeparator:(P,F,K)=>{if(n<=F)throw o;if(P===":"&&a&&a.type==="property")a.colonOffset=F,s=!1,a=void 0;else if(P===","){const ne=r[r.length-1];typeof ne=="number"?r[r.length-1]=ne+1:(s=!0,r[r.length-1]=""),a=void 0}}})}catch(P){if(P!==o)throw P}return{path:r,previousNode:a,isAtPropertyKey:s,matches:P=>{let F=0;for(let K=0;F<P.length&&K<r.length;K++)if(P[F]===r[K]||P[F]==="*")F++;else if(P[F]!=="**")return!1;return F===P.length}}}e.getLocation=T;function C(i,n=[],r=S.DEFAULT){let o=null,a=[];const l=[];function s(P){Array.isArray(a)?a.push(P):o!==null&&(a[o]=P)}return c(i,{onObjectBegin:()=>{const P={};s(P),l.push(a),a=P,o=null},onObjectProperty:P=>{o=P},onObjectEnd:()=>{a=l.pop()},onArrayBegin:()=>{const P=[];s(P),l.push(a),a=P,o=null},onArrayEnd:()=>{a=l.pop()},onLiteralValue:s,onError:(P,F,K)=>{n.push({error:P,offset:F,length:K})}},r),a[0]}e.parse=C;function w(i,n=[],r=S.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(P){o.type==="property"&&(o.length=P-o.offset,o=o.parent)}function l(P){return o.children.push(P),P}c(i,{onObjectBegin:P=>{o=l({type:"object",offset:P,length:-1,parent:o,children:[]})},onObjectProperty:(P,F,K)=>{o=l({type:"property",offset:F,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:P,offset:F,length:K,parent:o})},onObjectEnd:(P,F)=>{o.length=P+F-o.offset,o=o.parent,a(P+F)},onArrayBegin:(P,F)=>{o=l({type:"array",offset:P,length:-1,parent:o,children:[]})},onArrayEnd:(P,F)=>{o.length=P+F-o.offset,o=o.parent,a(P+F)},onLiteralValue:(P,F,K)=>{l({type:f(P),offset:F,length:K,parent:o,value:P}),a(F+K)},onSeparator:(P,F,K)=>{o.type==="property"&&(P===":"?o.colonOffset=F:P===","&&a(F))},onError:(P,F,K)=>{n.push({error:P,offset:F,length:K})}},r);const u=o.children[0];return u&&delete u.parent,u}e.parseTree=w;function m(i,n){if(!i)return;let r=i;for(const o of n)if(typeof o=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let a=!1;for(const l of r.children)if(Array.isArray(l.children)&&l.children[0].value===o){r=l.children[1],a=!0;break}if(!a)return}else{const a=o;if(r.type!=="array"||a<0||!Array.isArray(r.children)||a>=r.children.length)return;r=r.children[a]}return r}e.findNodeAtLocation=m;function g(i){if(!i.parent||!i.parent.children)return[];const n=g(i.parent);if(i.parent.type==="property"){const r=i.parent.children[0].value;n.push(r)}else if(i.parent.type==="array"){const r=i.parent.children.indexOf(i);r!==-1&&n.push(r)}return n}e.getNodePath=g;function p(i){switch(i.type){case"array":return i.children.map(p);case"object":{const n=Object.create(null);for(const r of i.children){const o=r.children[1];o&&(n[r.children[0].value]=p(o))}return n}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=p;function d(i,n,r=!1){return n>=i.offset&&n<i.offset+i.length||r&&n===i.offset+i.length}e.contains=d;function v(i,n,r=!1){if(d(i,n,r)){const o=i.children;if(Array.isArray(o))for(let a=0;a<o.length&&o[a].offset<=n;a++){const l=v(o[a],n,r);if(l)return l}return i}}e.findNodeAtOffset=v;function c(i,n,r=S.DEFAULT){const o=I(i,!1);function a(ge){return ge?()=>ge(o.getTokenOffset(),o.getTokenLength()):()=>!0}function l(ge){return ge?fe=>ge(fe,o.getTokenOffset(),o.getTokenLength()):()=>!0}const s=a(n.onObjectBegin),u=l(n.onObjectProperty),P=a(n.onObjectEnd),F=a(n.onArrayBegin),K=a(n.onArrayEnd),ne=l(n.onLiteralValue),ue=l(n.onSeparator),se=a(n.onComment),U=l(n.onError),Q=r&&r.disallowComments,z=r&&r.allowTrailingComma;function G(){for(;;){const ge=o.scan();switch(o.getTokenError()){case 4:X(14);break;case 5:X(15);break;case 3:X(13);break;case 1:Q||X(11);break;case 2:X(12);break;case 6:X(16);break}switch(ge){case 12:case 13:Q?X(10):se();break;case 16:X(1);break;case 15:case 14:break;default:return ge}}}function X(ge,fe=[],R=[]){if(U(ge),fe.length+R.length>0){let M=o.getToken();for(;M!==17;){if(fe.indexOf(M)!==-1){G();break}else if(R.indexOf(M)!==-1)break;M=G()}}}function ce(ge){const fe=o.getTokenValue();return ge?ne(fe):u(fe),G(),!0}function L(){switch(o.getToken()){case 11:{let ge=0;try{ge=JSON.parse(o.getTokenValue()),typeof ge!="number"&&(X(2),ge=0)}catch{X(2)}ne(ge);break}case 7:ne(null);break;case 8:ne(!0);break;case 9:ne(!1);break;default:return!1}return G(),!0}function N(){return o.getToken()!==10?(X(3,[],[2,5]),!1):(ce(!1),o.getToken()===6?(ue(":"),G(),oe()||X(4,[],[2,5])):X(5,[],[2,5]),!0)}function V(){s(),G();let ge=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(ge||X(4,[],[]),ue(","),G(),o.getToken()===2&&z)break}else ge&&X(6,[],[]);N()||X(4,[],[2,5]),ge=!0}return P(),o.getToken()!==2?X(7,[2],[]):G(),!0}function ee(){F(),G();let ge=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(ge||X(4,[],[]),ue(","),G(),o.getToken()===4&&z)break}else ge&&X(6,[],[]);oe()||X(4,[],[4,5]),ge=!0}return K(),o.getToken()!==4?X(8,[4],[]):G(),!0}function oe(){switch(o.getToken()){case 3:return ee();case 1:return V();case 10:return ce(!0);default:return L()}}return G(),o.getToken()===17?r.allowEmptyContent?!0:(X(4,[],[]),!1):oe()?(o.getToken()!==17&&X(9,[],[]),!0):(X(4,[],[]),!1)}e.visit=c;function h(i,n){const r=I(i),o=[];let a,l=0,s;do switch(s=r.getPosition(),a=r.scan(),a){case 12:case 13:case 17:l!==s&&o.push(i.substring(l,s)),n!==void 0&&o.push(r.getTokenValue().replace(/[^\r\n]/g,n)),l=r.getPosition();break}while(a!==17);return o.join("")}e.stripComments=h;function f(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=f}),define(ve[136],be([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class b{constructor(k){this.d=k,this.a=!1}hasValue(){return this.a}getValue(){if(!this.a)try{this.b=this.d()}catch(k){this.c=k}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}map(k){return new b(()=>k(this.getValue()))}}e.Lazy=b}),define(ve[2],be([1,0,68,55]),function(ie,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let S=null;function I(l){S=l}if(e.setDisposableTracker=I,k){const l="__is_disposable_tracked__";I(new class{trackDisposable(s){const u=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[l]||console.log(u)},3e3)}setParent(s,u){if(s&&s!==v.None)try{s[l]=!0}catch{}}markAsDisposed(s){if(s&&s!==v.None)try{s[l]=!0}catch{}}markAsSingleton(s){}})}function A(l){return S?.trackDisposable(l),l}function E(l){S?.markAsDisposed(l)}function y(l,s){S?.setParent(l,s)}function D(l,s){if(!!S)for(const u of l)S.setParent(u,s)}function T(l){return S?.markAsSingleton(l),l}e.markAsSingleton=T;function C(l){return typeof l.dispose=="function"&&l.dispose.length===0}e.isDisposable=C;function w(l){if(t.Iterable.is(l)){const s=[];for(const u of l)if(u)try{u.dispose()}catch(P){s.push(P)}if(s.length===1)throw s[0];if(s.length>1)throw new AggregateError(s,"Encountered errors while disposing of store");return Array.isArray(l)?[]:l}else if(l)return l.dispose(),l}e.dispose=w;function m(l){for(const s of l)C(s)&&s.dispose();return[]}e.disposeIfDisposable=m;function g(...l){const s=p(()=>w(l));return D(l,s),s}e.combinedDisposable=g;function p(l){const s=A({dispose:(0,b.once)(()=>{E(s),l()})});return s}e.toDisposable=p;class d{constructor(){this.c=new Set,this.f=!1,A(this)}dispose(){this.f||(E(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{w(this.c)}finally{this.c.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return y(s,this),this.f?d.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(s),s}}e.DisposableStore=d,d.DISABLE_DISPOSED_WARNING=!1;class v{constructor(){this.q=new d,A(this),y(this.q,this)}dispose(){E(this),this.q.dispose()}B(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(s)}}e.Disposable=v,v.None=Object.freeze({dispose(){}});class c{constructor(){this.b=!1,A(this)}get value(){return this.b?void 0:this.a}set value(s){this.b||s===this.a||(this.a?.dispose(),s&&y(s,this),this.a=s)}clear(){this.value=void 0}dispose(){this.b=!0,E(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const s=this.a;return this.a=void 0,s&&y(s,null),s}}e.MutableDisposable=c;class h{constructor(s){this.b=s,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=h;class f{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,A(this)}set(s){let u=s;return this.unset=()=>u=void 0,this.isset=()=>u!==void 0,this.dispose=()=>{u&&(u(),u=void 0,E(this))},this}}e.SafeDisposable=f;class i{constructor(){this.a=new Map}acquire(s,...u){let P=this.a.get(s);P||(P={counter:0,object:this.b(s,...u)},this.a.set(s,P));const{object:F}=P,K=(0,b.once)(()=>{--P.counter===0&&(this.c(s,P.object),this.a.delete(s))});return P.counter++,{object:F,dispose:K}}}e.ReferenceCollection=i;class n{constructor(s){this.a=s}async acquire(s,...u){const P=this.a.acquire(s,...u);try{return{object:await P.object,dispose:()=>P.dispose()}}catch(F){throw P.dispose(),F}}}e.AsyncReferenceCollection=n;class r{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=r;function o(l){const s=new d;try{l(s)}finally{s.dispose()}}e.disposeOnReturn=o;class a{constructor(){this.a=new Map,this.b=!1,A(this)}dispose(){E(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{w(this.a.values())}finally{this.a.clear()}}has(s){return this.a.has(s)}get(s){return this.a.get(s)}set(s,u,P=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),P||this.a.get(s)?.dispose(),this.a.set(s,u)}deleteAndDispose(s){this.a.get(s)?.dispose(),this.a.delete(s)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=a}),define(ve[86],be([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class b{constructor(S){this.element=S,this.next=b.Undefined,this.prev=b.Undefined}}b.Undefined=new b(void 0);class t{constructor(){this.a=b.Undefined,this.b=b.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===b.Undefined}clear(){let S=this.a;for(;S!==b.Undefined;){const I=S.next;S.prev=b.Undefined,S.next=b.Undefined,S=I}this.a=b.Undefined,this.b=b.Undefined,this.c=0}unshift(S){return this.d(S,!1)}push(S){return this.d(S,!0)}d(S,I){const A=new b(S);if(this.a===b.Undefined)this.a=A,this.b=A;else if(I){const y=this.b;this.b=A,A.prev=y,y.next=A}else{const y=this.a;this.a=A,A.next=y,y.prev=A}this.c+=1;let E=!1;return()=>{E||(E=!0,this.e(A))}}shift(){if(this.a!==b.Undefined){const S=this.a.element;return this.e(this.a),S}}pop(){if(this.b!==b.Undefined){const S=this.b.element;return this.e(this.b),S}}e(S){if(S.prev!==b.Undefined&&S.next!==b.Undefined){const I=S.prev;I.next=S.next,S.next.prev=I}else S.prev===b.Undefined&&S.next===b.Undefined?(this.a=b.Undefined,this.b=b.Undefined):S.next===b.Undefined?(this.b=this.b.prev,this.b.next=b.Undefined):S.prev===b.Undefined&&(this.a=this.a.next,this.a.prev=b.Undefined);this.c-=1}*[Symbol.iterator](){let S=this.a;for(;S!==b.Undefined;)yield S.element,S=S.next}}e.LinkedList=t}),define(ve[26],be([1,0]),function(ie,e){"use strict";var b,t,k;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function S(m,g,p){let d=m.get(g);return d===void 0&&(d=p,m.set(g,d)),d}e.getOrSet=S;function I(m){const g=[];return m.forEach((p,d)=>{g.push(`${d} => ${p}`)}),`Map(${m.size}) {${g.join(", ")}}`}e.mapToString=I;function A(m){const g=[];return m.forEach(p=>{g.push(p)}),`Set(${m.size}) {${g.join(", ")}}`}e.setToString=A;class E{constructor(g,p){this.uri=g,this.value=p}}class y{constructor(g,p){this[b]="ResourceMap",g instanceof y?(this.b=new Map(g.b),this.c=p??y.a):(this.b=new Map,this.c=g??y.a)}set(g,p){return this.b.set(this.c(g),new E(g,p)),this}get(g){return this.b.get(this.c(g))?.value}has(g){return this.b.has(this.c(g))}get size(){return this.b.size}clear(){this.b.clear()}delete(g){return this.b.delete(this.c(g))}forEach(g,p){typeof p<"u"&&(g=g.bind(p));for(const[d,v]of this.b)g(v.value,v.uri,this)}*values(){for(const g of this.b.values())yield g.value}*keys(){for(const g of this.b.values())yield g.uri}*entries(){for(const g of this.b.values())yield[g.uri,g.value]}*[(b=Symbol.toStringTag,Symbol.iterator)](){for(const[,g]of this.b)yield[g.uri,g.value]}}e.ResourceMap=y,y.a=m=>m.toString();class D{constructor(g,p){this[t]="ResourceSet",!g||typeof g=="function"?this.a=new y(g):(this.a=new y(p),g.forEach(this.add,this))}get size(){return this.a.size}add(g){return this.a.set(g,g),this}clear(){this.a.clear()}delete(g){return this.a.delete(g)}forEach(g,p){this.a.forEach((d,v)=>g.call(p,v,v,this))}has(g){return this.a.has(g)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=D;var T;(function(m){m[m.None=0]="None",m[m.AsOld=1]="AsOld",m[m.AsNew=2]="AsNew"})(T=e.Touch||(e.Touch={}));class C{constructor(){this[k]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(g){return this.a.has(g)}get(g,p=0){const d=this.a.get(g);if(!!d)return p!==0&&this.j(d,p),d.value}set(g,p,d=0){let v=this.a.get(g);if(v)v.value=p,d!==0&&this.j(v,d);else{switch(v={key:g,value:p,next:void 0,previous:void 0},d){case 0:this.h(v);break;case 1:this.g(v);break;case 2:this.h(v);break;default:this.h(v);break}this.a.set(g,v),this.d++}return this}delete(g){return!!this.remove(g)}remove(g){const p=this.a.get(g);if(!!p)return this.a.delete(g),this.i(p),this.d--,p.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const g=this.b;return this.a.delete(g.key),this.i(g),this.d--,g.value}forEach(g,p){const d=this.e;let v=this.b;for(;v;){if(p?g.bind(p)(v.value,v.key,this):g(v.value,v.key,this),this.e!==d)throw new Error("LinkedMap got modified during iteration.");v=v.next}}keys(){const g=this,p=this.e;let d=this.b;const v={[Symbol.iterator](){return v},next(){if(g.e!==p)throw new Error("LinkedMap got modified during iteration.");if(d){const c={value:d.key,done:!1};return d=d.next,c}else return{value:void 0,done:!0}}};return v}values(){const g=this,p=this.e;let d=this.b;const v={[Symbol.iterator](){return v},next(){if(g.e!==p)throw new Error("LinkedMap got modified during iteration.");if(d){const c={value:d.value,done:!1};return d=d.next,c}else return{value:void 0,done:!0}}};return v}entries(){const g=this,p=this.e;let d=this.b;const v={[Symbol.iterator](){return v},next(){if(g.e!==p)throw new Error("LinkedMap got modified during iteration.");if(d){const c={value:[d.key,d.value],done:!1};return d=d.next,c}else return{value:void 0,done:!0}}};return v}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(g){if(g>=this.size)return;if(g===0){this.clear();return}let p=this.b,d=this.size;for(;p&&d>g;)this.a.delete(p.key),p=p.next,d--;this.b=p,this.d=d,p&&(p.previous=void 0),this.e++}g(g){if(!this.b&&!this.c)this.c=g;else if(this.b)g.next=this.b,this.b.previous=g;else throw new Error("Invalid list");this.b=g,this.e++}h(g){if(!this.b&&!this.c)this.b=g;else if(this.c)g.previous=this.c,this.c.next=g;else throw new Error("Invalid list");this.c=g,this.e++}i(g){if(g===this.b&&g===this.c)this.b=void 0,this.c=void 0;else if(g===this.b){if(!g.next)throw new Error("Invalid list");g.next.previous=void 0,this.b=g.next}else if(g===this.c){if(!g.previous)throw new Error("Invalid list");g.previous.next=void 0,this.c=g.previous}else{const p=g.next,d=g.previous;if(!p||!d)throw new Error("Invalid list");p.previous=d,d.next=p}g.next=void 0,g.previous=void 0,this.e++}j(g,p){if(!this.b||!this.c)throw new Error("Invalid list");if(!(p!==1&&p!==2)){if(p===1){if(g===this.b)return;const d=g.next,v=g.previous;g===this.c?(v.next=void 0,this.c=v):(d.previous=v,v.next=d),g.previous=void 0,g.next=this.b,this.b.previous=g,this.b=g,this.e++}else if(p===2){if(g===this.c)return;const d=g.next,v=g.previous;g===this.b?(d.previous=void 0,this.b=d):(d.previous=v,v.next=d),g.next=void 0,g.previous=this.c,this.c.next=g,this.c=g,this.e++}}}toJSON(){const g=[];return this.forEach((p,d)=>{g.push([d,p])}),g}fromJSON(g){this.clear();for(const[p,d]of g)this.set(p,d)}}e.LinkedMap=C;class w extends C{constructor(g,p=1){super(),this.k=g,this.l=Math.min(Math.max(0,p),1)}get limit(){return this.k}set limit(g){this.k=g,this.m()}get ratio(){return this.l}set ratio(g){this.l=Math.min(Math.max(0,g),1),this.m()}get(g,p=2){return super.get(g,p)}peek(g){return super.get(g,0)}set(g,p){return super.set(g,p,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=w}),function(ie,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(ve[137],be([0]),e):(ie=typeof globalThis<"u"?globalThis:ie||self,e(ie.marked={}))}(this,function(ie){"use strict";function e($,J){for(var _=0;_<J.length;_++){var j=J[_];j.enumerable=j.enumerable||!1,j.configurable=!0,"value"in j&&(j.writable=!0),Object.defineProperty($,j.key,j)}}function b($,J,_){return J&&e($.prototype,J),_&&e($,_),Object.defineProperty($,"prototype",{writable:!1}),$}function t($,J){if(!!$){if(typeof $=="string")return k($,J);var _=Object.prototype.toString.call($).slice(8,-1);if(_==="Object"&&$.constructor&&(_=$.constructor.name),_==="Map"||_==="Set")return Array.from($);if(_==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(_))return k($,J)}}function k($,J){(J==null||J>$.length)&&(J=$.length);for(var _=0,j=new Array(J);_<J;_++)j[_]=$[_];return j}function S($,J){var _=typeof Symbol<"u"&&$[Symbol.iterator]||$["@@iterator"];if(_)return(_=_.call($)).next.bind(_);if(Array.isArray($)||(_=t($))||J&&$&&typeof $.length=="number"){_&&($=_);var j=0;return function(){return j>=$.length?{done:!0}:{done:!1,value:$[j++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function I(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ie.defaults=I();function A($){ie.defaults=$}var E=/[&<>"']/,y=/[&<>"']/g,D=/[<>"']|&(?!#?\w+;)/,T=/[<>"']|&(?!#?\w+;)/g,C={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},w=function(J){return C[J]};function m($,J){if(J){if(E.test($))return $.replace(y,w)}else if(D.test($))return $.replace(T,w);return $}var g=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function p($){return $.replace(g,function(J,_){return _=_.toLowerCase(),_==="colon"?":":_.charAt(0)==="#"?_.charAt(1)==="x"?String.fromCharCode(parseInt(_.substring(2),16)):String.fromCharCode(+_.substring(1)):""})}var d=/(^|[^\[])\^/g;function v($,J){$=typeof $=="string"?$:$.source,J=J||"";var _={replace:function(H,q){return q=q.source||q,q=q.replace(d,"$1"),$=$.replace(H,q),_},getRegex:function(){return new RegExp($,J)}};return _}var c=/[^\w:]/g,h=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function f($,J,_){if($){var j;try{j=decodeURIComponent(p(_)).replace(c,"").toLowerCase()}catch{return null}if(j.indexOf("javascript:")===0||j.indexOf("vbscript:")===0||j.indexOf("data:")===0)return null}J&&!h.test(_)&&(_=a(J,_));try{_=encodeURI(_).replace(/%25/g,"%")}catch{return null}return _}var i={},n=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function a($,J){i[" "+$]||(n.test($)?i[" "+$]=$+"/":i[" "+$]=P($,"/",!0)),$=i[" "+$];var _=$.indexOf(":")===-1;return J.substring(0,2)==="//"?_?J:$.replace(r,"$1")+J:J.charAt(0)==="/"?_?J:$.replace(o,"$1")+J:$+J}var l={exec:function(){}};function s($){for(var J=1,_,j;J<arguments.length;J++){_=arguments[J];for(j in _)Object.prototype.hasOwnProperty.call(_,j)&&($[j]=_[j])}return $}function u($,J){var _=$.replace(/\|/g,function(q,Z,ae){for(var we=!1,ke=Z;--ke>=0&&ae[ke]==="\\";)we=!we;return we?"|":" |"}),j=_.split(/ \|/),H=0;if(j[0].trim()||j.shift(),j.length>0&&!j[j.length-1].trim()&&j.pop(),j.length>J)j.splice(J);else for(;j.length<J;)j.push("");for(;H<j.length;H++)j[H]=j[H].trim().replace(/\\\|/g,"|");return j}function P($,J,_){var j=$.length;if(j===0)return"";for(var H=0;H<j;){var q=$.charAt(j-H-1);if(q===J&&!_)H++;else if(q!==J&&_)H++;else break}return $.slice(0,j-H)}function F($,J){if($.indexOf(J[1])===-1)return-1;for(var _=$.length,j=0,H=0;H<_;H++)if($[H]==="\\")H++;else if($[H]===J[0])j++;else if($[H]===J[1]&&(j--,j<0))return H;return-1}function K($){$&&$.sanitize&&!$.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function ne($,J){if(J<1)return"";for(var _="";J>1;)J&1&&(_+=$),J>>=1,$+=$;return _+$}function ue($,J,_,j){var H=J.href,q=J.title?m(J.title):null,Z=$[1].replace(/\\([\[\]])/g,"$1");if($[0].charAt(0)!=="!"){j.state.inLink=!0;var ae={type:"link",raw:_,href:H,title:q,text:Z,tokens:j.inlineTokens(Z)};return j.state.inLink=!1,ae}return{type:"image",raw:_,href:H,title:q,text:m(Z)}}function se($,J){var _=$.match(/^(\s+)(?:```)/);if(_===null)return J;var j=_[1];return J.split(`
`).map(function(H){var q=H.match(/^\s+/);if(q===null)return H;var Z=q[0];return Z.length>=j.length?H.slice(j.length):H}).join(`
`)}var U=function(){function $(_){this.options=_||ie.defaults}var J=$.prototype;return J.space=function(j){var H=this.rules.block.newline.exec(j);if(H&&H[0].length>0)return{type:"space",raw:H[0]}},J.code=function(j){var H=this.rules.block.code.exec(j);if(H){var q=H[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:H[0],codeBlockStyle:"indented",text:this.options.pedantic?q:P(q,`
`)}}},J.fences=function(j){var H=this.rules.block.fences.exec(j);if(H){var q=H[0],Z=se(q,H[3]||"");return{type:"code",raw:q,lang:H[2]?H[2].trim():H[2],text:Z}}},J.heading=function(j){var H=this.rules.block.heading.exec(j);if(H){var q=H[2].trim();if(/#$/.test(q)){var Z=P(q,"#");(this.options.pedantic||!Z||/ $/.test(Z))&&(q=Z.trim())}return{type:"heading",raw:H[0],depth:H[1].length,text:q,tokens:this.lexer.inline(q)}}},J.hr=function(j){var H=this.rules.block.hr.exec(j);if(H)return{type:"hr",raw:H[0]}},J.blockquote=function(j){var H=this.rules.block.blockquote.exec(j);if(H){var q=H[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:H[0],tokens:this.lexer.blockTokens(q,[]),text:q}}},J.list=function(j){var H=this.rules.block.list.exec(j);if(H){var q,Z,ae,we,ke,Ae,Me,ze,de,Ee,ye,Fe,Be=H[1].trim(),Ye=Be.length>1,Ve={type:"list",raw:"",ordered:Ye,start:Ye?+Be.slice(0,-1):"",loose:!1,items:[]};Be=Ye?"\\d{1,9}\\"+Be.slice(-1):"\\"+Be,this.options.pedantic&&(Be=Ye?Be:"[*+-]");for(var Je=new RegExp("^( {0,3}"+Be+")((?:[	 ][^\\n]*)?(?:\\n|$))");j&&(Fe=!1,!(!(H=Je.exec(j))||this.rules.block.hr.test(j)));){if(q=H[0],j=j.substring(q.length),ze=H[2].split(`
`,1)[0],de=j.split(`
`,1)[0],this.options.pedantic?(we=2,ye=ze.trimLeft()):(we=H[2].search(/[^ ]/),we=we>4?1:we,ye=ze.slice(we),we+=H[1].length),Ae=!1,!ze&&/^ *$/.test(de)&&(q+=de+`
`,j=j.substring(de.length+1),Fe=!0),!Fe)for(var Xe=new RegExp("^ {0,"+Math.min(3,we-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),tt=new RegExp("^ {0,"+Math.min(3,we-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),qe=new RegExp("^ {0,"+Math.min(3,we-1)+"}(?:```|~~~)"),$e=new RegExp("^ {0,"+Math.min(3,we-1)+"}#");j&&(Ee=j.split(`
`,1)[0],ze=Ee,this.options.pedantic&&(ze=ze.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(qe.test(ze)||$e.test(ze)||Xe.test(ze)||tt.test(j)));){if(ze.search(/[^ ]/)>=we||!ze.trim())ye+=`
`+ze.slice(we);else if(!Ae)ye+=`
`+ze;else break;!Ae&&!ze.trim()&&(Ae=!0),q+=Ee+`
`,j=j.substring(Ee.length+1)}Ve.loose||(Me?Ve.loose=!0:/\n *\n *$/.test(q)&&(Me=!0)),this.options.gfm&&(Z=/^\[[ xX]\] /.exec(ye),Z&&(ae=Z[0]!=="[ ] ",ye=ye.replace(/^\[[ xX]\] +/,""))),Ve.items.push({type:"list_item",raw:q,task:!!Z,checked:ae,loose:!1,text:ye}),Ve.raw+=q}Ve.items[Ve.items.length-1].raw=q.trimRight(),Ve.items[Ve.items.length-1].text=ye.trimRight(),Ve.raw=Ve.raw.trimRight();var xe=Ve.items.length;for(ke=0;ke<xe;ke++){this.lexer.state.top=!1,Ve.items[ke].tokens=this.lexer.blockTokens(Ve.items[ke].text,[]);var le=Ve.items[ke].tokens.filter(function(De){return De.type==="space"}),Ce=le.every(function(De){for(var Te=De.raw.split(""),Ne=0,We=S(Te),Ge;!(Ge=We()).done;){var rt=Ge.value;if(rt===`
`&&(Ne+=1),Ne>1)return!0}return!1});!Ve.loose&&le.length&&Ce&&(Ve.loose=!0,Ve.items[ke].loose=!0)}return Ve}},J.html=function(j){var H=this.rules.block.html.exec(j);if(H){var q={type:"html",raw:H[0],pre:!this.options.sanitizer&&(H[1]==="pre"||H[1]==="script"||H[1]==="style"),text:H[0]};if(this.options.sanitize){var Z=this.options.sanitizer?this.options.sanitizer(H[0]):m(H[0]);q.type="paragraph",q.text=Z,q.tokens=this.lexer.inline(Z)}return q}},J.def=function(j){var H=this.rules.block.def.exec(j);if(H){H[3]&&(H[3]=H[3].substring(1,H[3].length-1));var q=H[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:q,raw:H[0],href:H[2],title:H[3]}}},J.table=function(j){var H=this.rules.block.table.exec(j);if(H){var q={type:"table",header:u(H[1]).map(function(Me){return{text:Me}}),align:H[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:H[3]&&H[3].trim()?H[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(q.header.length===q.align.length){q.raw=H[0];var Z=q.align.length,ae,we,ke,Ae;for(ae=0;ae<Z;ae++)/^ *-+: *$/.test(q.align[ae])?q.align[ae]="right":/^ *:-+: *$/.test(q.align[ae])?q.align[ae]="center":/^ *:-+ *$/.test(q.align[ae])?q.align[ae]="left":q.align[ae]=null;for(Z=q.rows.length,ae=0;ae<Z;ae++)q.rows[ae]=u(q.rows[ae],q.header.length).map(function(Me){return{text:Me}});for(Z=q.header.length,we=0;we<Z;we++)q.header[we].tokens=this.lexer.inline(q.header[we].text);for(Z=q.rows.length,we=0;we<Z;we++)for(Ae=q.rows[we],ke=0;ke<Ae.length;ke++)Ae[ke].tokens=this.lexer.inline(Ae[ke].text);return q}}},J.lheading=function(j){var H=this.rules.block.lheading.exec(j);if(H)return{type:"heading",raw:H[0],depth:H[2].charAt(0)==="="?1:2,text:H[1],tokens:this.lexer.inline(H[1])}},J.paragraph=function(j){var H=this.rules.block.paragraph.exec(j);if(H){var q=H[1].charAt(H[1].length-1)===`
`?H[1].slice(0,-1):H[1];return{type:"paragraph",raw:H[0],text:q,tokens:this.lexer.inline(q)}}},J.text=function(j){var H=this.rules.block.text.exec(j);if(H)return{type:"text",raw:H[0],text:H[0],tokens:this.lexer.inline(H[0])}},J.escape=function(j){var H=this.rules.inline.escape.exec(j);if(H)return{type:"escape",raw:H[0],text:m(H[1])}},J.tag=function(j){var H=this.rules.inline.tag.exec(j);if(H)return!this.lexer.state.inLink&&/^<a /i.test(H[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(H[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(H[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(H[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:H[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(H[0]):m(H[0]):H[0]}},J.link=function(j){var H=this.rules.inline.link.exec(j);if(H){var q=H[2].trim();if(!this.options.pedantic&&/^</.test(q)){if(!/>$/.test(q))return;var Z=P(q.slice(0,-1),"\\");if((q.length-Z.length)%2===0)return}else{var ae=F(H[2],"()");if(ae>-1){var we=H[0].indexOf("!")===0?5:4,ke=we+H[1].length+ae;H[2]=H[2].substring(0,ae),H[0]=H[0].substring(0,ke).trim(),H[3]=""}}var Ae=H[2],Me="";if(this.options.pedantic){var ze=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ae);ze&&(Ae=ze[1],Me=ze[3])}else Me=H[3]?H[3].slice(1,-1):"";return Ae=Ae.trim(),/^</.test(Ae)&&(this.options.pedantic&&!/>$/.test(q)?Ae=Ae.slice(1):Ae=Ae.slice(1,-1)),ue(H,{href:Ae&&Ae.replace(this.rules.inline._escapes,"$1"),title:Me&&Me.replace(this.rules.inline._escapes,"$1")},H[0],this.lexer)}},J.reflink=function(j,H){var q;if((q=this.rules.inline.reflink.exec(j))||(q=this.rules.inline.nolink.exec(j))){var Z=(q[2]||q[1]).replace(/\s+/g," ");if(Z=H[Z.toLowerCase()],!Z||!Z.href){var ae=q[0].charAt(0);return{type:"text",raw:ae,text:ae}}return ue(q,Z,q[0],this.lexer)}},J.emStrong=function(j,H,q){q===void 0&&(q="");var Z=this.rules.inline.emStrong.lDelim.exec(j);if(!!Z&&!(Z[3]&&q.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ae=Z[1]||Z[2]||"";if(!ae||ae&&(q===""||this.rules.inline.punctuation.exec(q))){var we=Z[0].length-1,ke,Ae,Me=we,ze=0,de=Z[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(de.lastIndex=0,H=H.slice(-1*j.length+we);(Z=de.exec(H))!=null;)if(ke=Z[1]||Z[2]||Z[3]||Z[4]||Z[5]||Z[6],!!ke){if(Ae=ke.length,Z[3]||Z[4]){Me+=Ae;continue}else if((Z[5]||Z[6])&&we%3&&!((we+Ae)%3)){ze+=Ae;continue}if(Me-=Ae,!(Me>0)){if(Ae=Math.min(Ae,Ae+Me+ze),Math.min(we,Ae)%2){var Ee=j.slice(1,we+Z.index+Ae);return{type:"em",raw:j.slice(0,we+Z.index+Ae+1),text:Ee,tokens:this.lexer.inlineTokens(Ee)}}var ye=j.slice(2,we+Z.index+Ae-1);return{type:"strong",raw:j.slice(0,we+Z.index+Ae+1),text:ye,tokens:this.lexer.inlineTokens(ye)}}}}}},J.codespan=function(j){var H=this.rules.inline.code.exec(j);if(H){var q=H[2].replace(/\n/g," "),Z=/[^ ]/.test(q),ae=/^ /.test(q)&&/ $/.test(q);return Z&&ae&&(q=q.substring(1,q.length-1)),q=m(q,!0),{type:"codespan",raw:H[0],text:q}}},J.br=function(j){var H=this.rules.inline.br.exec(j);if(H)return{type:"br",raw:H[0]}},J.del=function(j){var H=this.rules.inline.del.exec(j);if(H)return{type:"del",raw:H[0],text:H[2],tokens:this.lexer.inlineTokens(H[2])}},J.autolink=function(j,H){var q=this.rules.inline.autolink.exec(j);if(q){var Z,ae;return q[2]==="@"?(Z=m(this.options.mangle?H(q[1]):q[1]),ae="mailto:"+Z):(Z=m(q[1]),ae=Z),{type:"link",raw:q[0],text:Z,href:ae,tokens:[{type:"text",raw:Z,text:Z}]}}},J.url=function(j,H){var q;if(q=this.rules.inline.url.exec(j)){var Z,ae;if(q[2]==="@")Z=m(this.options.mangle?H(q[0]):q[0]),ae="mailto:"+Z;else{var we;do we=q[0],q[0]=this.rules.inline._backpedal.exec(q[0])[0];while(we!==q[0]);Z=m(q[0]),q[1]==="www."?ae="http://"+Z:ae=Z}return{type:"link",raw:q[0],text:Z,href:ae,tokens:[{type:"text",raw:Z,text:Z}]}}},J.inlineText=function(j,H){var q=this.rules.inline.text.exec(j);if(q){var Z;return this.lexer.state.inRawBlock?Z=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(q[0]):m(q[0]):q[0]:Z=m(this.options.smartypants?H(q[0]):q[0]),{type:"text",raw:q[0],text:Z}}},$}(),Q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:l,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};Q._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,Q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,Q.def=v(Q.def).replace("label",Q._label).replace("title",Q._title).getRegex(),Q.bullet=/(?:[*+-]|\d{1,9}[.)])/,Q.listItemStart=v(/^( *)(bull) */).replace("bull",Q.bullet).getRegex(),Q.list=v(Q.list).replace(/bull/g,Q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+Q.def.source+")").getRegex(),Q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",Q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,Q.html=v(Q.html,"i").replace("comment",Q._comment).replace("tag",Q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),Q.paragraph=v(Q._paragraph).replace("hr",Q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",Q._tag).getRegex(),Q.blockquote=v(Q.blockquote).replace("paragraph",Q.paragraph).getRegex(),Q.normal=s({},Q),Q.gfm=s({},Q.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),Q.gfm.table=v(Q.gfm.table).replace("hr",Q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",Q._tag).getRegex(),Q.gfm.paragraph=v(Q._paragraph).replace("hr",Q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",Q.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",Q._tag).getRegex(),Q.pedantic=s({},Q.normal,{html:v(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",Q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:l,paragraph:v(Q.normal._paragraph).replace("hr",Q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",Q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var z={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:l,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:l,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};z._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",z.punctuation=v(z.punctuation).replace(/punctuation/g,z._punctuation).getRegex(),z.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,z.escapedEmSt=/\\\*|\\_/g,z._comment=v(Q._comment).replace("(?:-->|$)","-->").getRegex(),z.emStrong.lDelim=v(z.emStrong.lDelim).replace(/punct/g,z._punctuation).getRegex(),z.emStrong.rDelimAst=v(z.emStrong.rDelimAst,"g").replace(/punct/g,z._punctuation).getRegex(),z.emStrong.rDelimUnd=v(z.emStrong.rDelimUnd,"g").replace(/punct/g,z._punctuation).getRegex(),z._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,z._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,z._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,z.autolink=v(z.autolink).replace("scheme",z._scheme).replace("email",z._email).getRegex(),z._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,z.tag=v(z.tag).replace("comment",z._comment).replace("attribute",z._attribute).getRegex(),z._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,z._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,z._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,z.link=v(z.link).replace("label",z._label).replace("href",z._href).replace("title",z._title).getRegex(),z.reflink=v(z.reflink).replace("label",z._label).replace("ref",Q._label).getRegex(),z.nolink=v(z.nolink).replace("ref",Q._label).getRegex(),z.reflinkSearch=v(z.reflinkSearch,"g").replace("reflink",z.reflink).replace("nolink",z.nolink).getRegex(),z.normal=s({},z),z.pedantic=s({},z.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:v(/^!?\[(label)\]\((.*?)\)/).replace("label",z._label).getRegex(),reflink:v(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",z._label).getRegex()}),z.gfm=s({},z.normal,{escape:v(z.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),z.gfm.url=v(z.gfm.url,"i").replace("email",z.gfm._extended_email).getRegex(),z.breaks=s({},z.gfm,{br:v(z.br).replace("{2,}","*").getRegex(),text:v(z.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function G($){return $.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function X($){var J="",_,j,H=$.length;for(_=0;_<H;_++)j=$.charCodeAt(_),Math.random()>.5&&(j="x"+j.toString(16)),J+="&#"+j+";";return J}var ce=function(){function $(_){this.tokens=[],this.tokens.links=Object.create(null),this.options=_||ie.defaults,this.options.tokenizer=this.options.tokenizer||new U,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var j={block:Q.normal,inline:z.normal};this.options.pedantic?(j.block=Q.pedantic,j.inline=z.pedantic):this.options.gfm&&(j.block=Q.gfm,this.options.breaks?j.inline=z.breaks:j.inline=z.gfm),this.tokenizer.rules=j}$.lex=function(j,H){var q=new $(H);return q.lex(j)},$.lexInline=function(j,H){var q=new $(H);return q.inlineTokens(j)};var J=$.prototype;return J.lex=function(j){j=j.replace(/\r\n|\r/g,`
`),this.blockTokens(j,this.tokens);for(var H;H=this.inlineQueue.shift();)this.inlineTokens(H.src,H.tokens);return this.tokens},J.blockTokens=function(j,H){var q=this;H===void 0&&(H=[]),this.options.pedantic?j=j.replace(/\t/g,"    ").replace(/^ +$/gm,""):j=j.replace(/^( *)(\t+)/gm,function(Me,ze,de){return ze+"    ".repeat(de.length)});for(var Z,ae,we,ke;j;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Me){return(Z=Me.call({lexer:q},j,H))?(j=j.substring(Z.raw.length),H.push(Z),!0):!1}))){if(Z=this.tokenizer.space(j)){j=j.substring(Z.raw.length),Z.raw.length===1&&H.length>0?H[H.length-1].raw+=`
`:H.push(Z);continue}if(Z=this.tokenizer.code(j)){j=j.substring(Z.raw.length),ae=H[H.length-1],ae&&(ae.type==="paragraph"||ae.type==="text")?(ae.raw+=`
`+Z.raw,ae.text+=`
`+Z.text,this.inlineQueue[this.inlineQueue.length-1].src=ae.text):H.push(Z);continue}if(Z=this.tokenizer.fences(j)){j=j.substring(Z.raw.length),H.push(Z);continue}if(Z=this.tokenizer.heading(j)){j=j.substring(Z.raw.length),H.push(Z);continue}if(Z=this.tokenizer.hr(j)){j=j.substring(Z.raw.length),H.push(Z);continue}if(Z=this.tokenizer.blockquote(j)){j=j.substring(Z.raw.length),H.push(Z);continue}if(Z=this.tokenizer.list(j)){j=j.substring(Z.raw.length),H.push(Z);continue}if(Z=this.tokenizer.html(j)){j=j.substring(Z.raw.length),H.push(Z);continue}if(Z=this.tokenizer.def(j)){j=j.substring(Z.raw.length),ae=H[H.length-1],ae&&(ae.type==="paragraph"||ae.type==="text")?(ae.raw+=`
`+Z.raw,ae.text+=`
`+Z.raw,this.inlineQueue[this.inlineQueue.length-1].src=ae.text):this.tokens.links[Z.tag]||(this.tokens.links[Z.tag]={href:Z.href,title:Z.title});continue}if(Z=this.tokenizer.table(j)){j=j.substring(Z.raw.length),H.push(Z);continue}if(Z=this.tokenizer.lheading(j)){j=j.substring(Z.raw.length),H.push(Z);continue}if(we=j,this.options.extensions&&this.options.extensions.startBlock&&function(){var Me=1/0,ze=j.slice(1),de=void 0;q.options.extensions.startBlock.forEach(function(Ee){de=Ee.call({lexer:this},ze),typeof de=="number"&&de>=0&&(Me=Math.min(Me,de))}),Me<1/0&&Me>=0&&(we=j.substring(0,Me+1))}(),this.state.top&&(Z=this.tokenizer.paragraph(we))){ae=H[H.length-1],ke&&ae.type==="paragraph"?(ae.raw+=`
`+Z.raw,ae.text+=`
`+Z.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ae.text):H.push(Z),ke=we.length!==j.length,j=j.substring(Z.raw.length);continue}if(Z=this.tokenizer.text(j)){j=j.substring(Z.raw.length),ae=H[H.length-1],ae&&ae.type==="text"?(ae.raw+=`
`+Z.raw,ae.text+=`
`+Z.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ae.text):H.push(Z);continue}if(j){var Ae="Infinite loop on byte: "+j.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return this.state.top=!0,H},J.inline=function(j,H){return H===void 0&&(H=[]),this.inlineQueue.push({src:j,tokens:H}),H},J.inlineTokens=function(j,H){var q=this;H===void 0&&(H=[]);var Z,ae,we,ke=j,Ae,Me,ze;if(this.tokens.links){var de=Object.keys(this.tokens.links);if(de.length>0)for(;(Ae=this.tokenizer.rules.inline.reflinkSearch.exec(ke))!=null;)de.includes(Ae[0].slice(Ae[0].lastIndexOf("[")+1,-1))&&(ke=ke.slice(0,Ae.index)+"["+ne("a",Ae[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ae=this.tokenizer.rules.inline.blockSkip.exec(ke))!=null;)ke=ke.slice(0,Ae.index)+"["+ne("a",Ae[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ae=this.tokenizer.rules.inline.escapedEmSt.exec(ke))!=null;)ke=ke.slice(0,Ae.index)+"++"+ke.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;j;)if(Me||(ze=""),Me=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ye){return(Z=ye.call({lexer:q},j,H))?(j=j.substring(Z.raw.length),H.push(Z),!0):!1}))){if(Z=this.tokenizer.escape(j)){j=j.substring(Z.raw.length),H.push(Z);continue}if(Z=this.tokenizer.tag(j)){j=j.substring(Z.raw.length),ae=H[H.length-1],ae&&Z.type==="text"&&ae.type==="text"?(ae.raw+=Z.raw,ae.text+=Z.text):H.push(Z);continue}if(Z=this.tokenizer.link(j)){j=j.substring(Z.raw.length),H.push(Z);continue}if(Z=this.tokenizer.reflink(j,this.tokens.links)){j=j.substring(Z.raw.length),ae=H[H.length-1],ae&&Z.type==="text"&&ae.type==="text"?(ae.raw+=Z.raw,ae.text+=Z.text):H.push(Z);continue}if(Z=this.tokenizer.emStrong(j,ke,ze)){j=j.substring(Z.raw.length),H.push(Z);continue}if(Z=this.tokenizer.codespan(j)){j=j.substring(Z.raw.length),H.push(Z);continue}if(Z=this.tokenizer.br(j)){j=j.substring(Z.raw.length),H.push(Z);continue}if(Z=this.tokenizer.del(j)){j=j.substring(Z.raw.length),H.push(Z);continue}if(Z=this.tokenizer.autolink(j,X)){j=j.substring(Z.raw.length),H.push(Z);continue}if(!this.state.inLink&&(Z=this.tokenizer.url(j,X))){j=j.substring(Z.raw.length),H.push(Z);continue}if(we=j,this.options.extensions&&this.options.extensions.startInline&&function(){var ye=1/0,Fe=j.slice(1),Be=void 0;q.options.extensions.startInline.forEach(function(Ye){Be=Ye.call({lexer:this},Fe),typeof Be=="number"&&Be>=0&&(ye=Math.min(ye,Be))}),ye<1/0&&ye>=0&&(we=j.substring(0,ye+1))}(),Z=this.tokenizer.inlineText(we,G)){j=j.substring(Z.raw.length),Z.raw.slice(-1)!=="_"&&(ze=Z.raw.slice(-1)),Me=!0,ae=H[H.length-1],ae&&ae.type==="text"?(ae.raw+=Z.raw,ae.text+=Z.text):H.push(Z);continue}if(j){var Ee="Infinite loop on byte: "+j.charCodeAt(0);if(this.options.silent){console.error(Ee);break}else throw new Error(Ee)}}return H},b($,null,[{key:"rules",get:function(){return{block:Q,inline:z}}}]),$}(),L=function(){function $(_){this.options=_||ie.defaults}var J=$.prototype;return J.code=function(j,H,q){var Z=(H||"").match(/\S*/)[0];if(this.options.highlight){var ae=this.options.highlight(j,Z);ae!=null&&ae!==j&&(q=!0,j=ae)}return j=j.replace(/\n$/,"")+`
`,Z?'<pre><code class="'+this.options.langPrefix+m(Z,!0)+'">'+(q?j:m(j,!0))+`</code></pre>
`:"<pre><code>"+(q?j:m(j,!0))+`</code></pre>
`},J.blockquote=function(j){return`<blockquote>
`+j+`</blockquote>
`},J.html=function(j){return j},J.heading=function(j,H,q,Z){if(this.options.headerIds){var ae=this.options.headerPrefix+Z.slug(q);return"<h"+H+' id="'+ae+'">'+j+"</h"+H+`>
`}return"<h"+H+">"+j+"</h"+H+`>
`},J.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},J.list=function(j,H,q){var Z=H?"ol":"ul",ae=H&&q!==1?' start="'+q+'"':"";return"<"+Z+ae+`>
`+j+"</"+Z+`>
`},J.listitem=function(j){return"<li>"+j+`</li>
`},J.checkbox=function(j){return"<input "+(j?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},J.paragraph=function(j){return"<p>"+j+`</p>
`},J.table=function(j,H){return H&&(H="<tbody>"+H+"</tbody>"),`<table>
<thead>
`+j+`</thead>
`+H+`</table>
`},J.tablerow=function(j){return`<tr>
`+j+`</tr>
`},J.tablecell=function(j,H){var q=H.header?"th":"td",Z=H.align?"<"+q+' align="'+H.align+'">':"<"+q+">";return Z+j+("</"+q+`>
`)},J.strong=function(j){return"<strong>"+j+"</strong>"},J.em=function(j){return"<em>"+j+"</em>"},J.codespan=function(j){return"<code>"+j+"</code>"},J.br=function(){return this.options.xhtml?"<br/>":"<br>"},J.del=function(j){return"<del>"+j+"</del>"},J.link=function(j,H,q){if(j=f(this.options.sanitize,this.options.baseUrl,j),j===null)return q;var Z='<a href="'+m(j)+'"';return H&&(Z+=' title="'+H+'"'),Z+=">"+q+"</a>",Z},J.image=function(j,H,q){if(j=f(this.options.sanitize,this.options.baseUrl,j),j===null)return q;var Z='<img src="'+j+'" alt="'+q+'"';return H&&(Z+=' title="'+H+'"'),Z+=this.options.xhtml?"/>":">",Z},J.text=function(j){return j},$}(),N=function(){function $(){}var J=$.prototype;return J.strong=function(j){return j},J.em=function(j){return j},J.codespan=function(j){return j},J.del=function(j){return j},J.html=function(j){return j},J.text=function(j){return j},J.link=function(j,H,q){return""+q},J.image=function(j,H,q){return""+q},J.br=function(){return""},$}(),V=function(){function $(){this.seen={}}var J=$.prototype;return J.serialize=function(j){return j.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},J.getNextSafeSlug=function(j,H){var q=j,Z=0;if(this.seen.hasOwnProperty(q)){Z=this.seen[j];do Z++,q=j+"-"+Z;while(this.seen.hasOwnProperty(q))}return H||(this.seen[j]=Z,this.seen[q]=0),q},J.slug=function(j,H){H===void 0&&(H={});var q=this.serialize(j);return this.getNextSafeSlug(q,H.dryrun)},$}(),ee=function(){function $(_){this.options=_||ie.defaults,this.options.renderer=this.options.renderer||new L,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new N,this.slugger=new V}$.parse=function(j,H){var q=new $(H);return q.parse(j)},$.parseInline=function(j,H){var q=new $(H);return q.parseInline(j)};var J=$.prototype;return J.parse=function(j,H){H===void 0&&(H=!0);var q="",Z,ae,we,ke,Ae,Me,ze,de,Ee,ye,Fe,Be,Ye,Ve,Je,Xe,tt,qe,$e,xe=j.length;for(Z=0;Z<xe;Z++){if(ye=j[Z],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ye.type]&&($e=this.options.extensions.renderers[ye.type].call({parser:this},ye),$e!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ye.type))){q+=$e||"";continue}switch(ye.type){case"space":continue;case"hr":{q+=this.renderer.hr();continue}case"heading":{q+=this.renderer.heading(this.parseInline(ye.tokens),ye.depth,p(this.parseInline(ye.tokens,this.textRenderer)),this.slugger);continue}case"code":{q+=this.renderer.code(ye.text,ye.lang,ye.escaped);continue}case"table":{for(de="",ze="",ke=ye.header.length,ae=0;ae<ke;ae++)ze+=this.renderer.tablecell(this.parseInline(ye.header[ae].tokens),{header:!0,align:ye.align[ae]});for(de+=this.renderer.tablerow(ze),Ee="",ke=ye.rows.length,ae=0;ae<ke;ae++){for(Me=ye.rows[ae],ze="",Ae=Me.length,we=0;we<Ae;we++)ze+=this.renderer.tablecell(this.parseInline(Me[we].tokens),{header:!1,align:ye.align[we]});Ee+=this.renderer.tablerow(ze)}q+=this.renderer.table(de,Ee);continue}case"blockquote":{Ee=this.parse(ye.tokens),q+=this.renderer.blockquote(Ee);continue}case"list":{for(Fe=ye.ordered,Be=ye.start,Ye=ye.loose,ke=ye.items.length,Ee="",ae=0;ae<ke;ae++)Je=ye.items[ae],Xe=Je.checked,tt=Je.task,Ve="",Je.task&&(qe=this.renderer.checkbox(Xe),Ye?Je.tokens.length>0&&Je.tokens[0].type==="paragraph"?(Je.tokens[0].text=qe+" "+Je.tokens[0].text,Je.tokens[0].tokens&&Je.tokens[0].tokens.length>0&&Je.tokens[0].tokens[0].type==="text"&&(Je.tokens[0].tokens[0].text=qe+" "+Je.tokens[0].tokens[0].text)):Je.tokens.unshift({type:"text",text:qe}):Ve+=qe),Ve+=this.parse(Je.tokens,Ye),Ee+=this.renderer.listitem(Ve,tt,Xe);q+=this.renderer.list(Ee,Fe,Be);continue}case"html":{q+=this.renderer.html(ye.text);continue}case"paragraph":{q+=this.renderer.paragraph(this.parseInline(ye.tokens));continue}case"text":{for(Ee=ye.tokens?this.parseInline(ye.tokens):ye.text;Z+1<xe&&j[Z+1].type==="text";)ye=j[++Z],Ee+=`
`+(ye.tokens?this.parseInline(ye.tokens):ye.text);q+=H?this.renderer.paragraph(Ee):Ee;continue}default:{var le='Token with "'+ye.type+'" type was not found.';if(this.options.silent){console.error(le);return}else throw new Error(le)}}}return q},J.parseInline=function(j,H){H=H||this.renderer;var q="",Z,ae,we,ke=j.length;for(Z=0;Z<ke;Z++){if(ae=j[Z],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ae.type]&&(we=this.options.extensions.renderers[ae.type].call({parser:this},ae),we!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(ae.type))){q+=we||"";continue}switch(ae.type){case"escape":{q+=H.text(ae.text);break}case"html":{q+=H.html(ae.text);break}case"link":{q+=H.link(ae.href,ae.title,this.parseInline(ae.tokens,H));break}case"image":{q+=H.image(ae.href,ae.title,ae.text);break}case"strong":{q+=H.strong(this.parseInline(ae.tokens,H));break}case"em":{q+=H.em(this.parseInline(ae.tokens,H));break}case"codespan":{q+=H.codespan(ae.text);break}case"br":{q+=H.br();break}case"del":{q+=H.del(this.parseInline(ae.tokens,H));break}case"text":{q+=H.text(ae.text);break}default:{var Ae='Token with "'+ae.type+'" type was not found.';if(this.options.silent){console.error(Ae);return}else throw new Error(Ae)}}}return q},$}();function oe($,J,_){if(typeof $>"u"||$===null)throw new Error("marked(): input parameter is undefined or null");if(typeof $!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call($)+", string expected");if(typeof J=="function"&&(_=J,J=null),J=s({},oe.defaults,J||{}),K(J),_){var j=J.highlight,H;try{H=ce.lex($,J)}catch(ke){return _(ke)}var q=function(Ae){var Me;if(!Ae)try{J.walkTokens&&oe.walkTokens(H,J.walkTokens),Me=ee.parse(H,J)}catch(ze){Ae=ze}return J.highlight=j,Ae?_(Ae):_(null,Me)};if(!j||j.length<3||(delete J.highlight,!H.length))return q();var Z=0;oe.walkTokens(H,function(ke){ke.type==="code"&&(Z++,setTimeout(function(){j(ke.text,ke.lang,function(Ae,Me){if(Ae)return q(Ae);Me!=null&&Me!==ke.text&&(ke.text=Me,ke.escaped=!0),Z--,Z===0&&q()})},0))}),Z===0&&q();return}function ae(ke){if(ke.message+=`
Please report this to https://github.com/markedjs/marked.`,J.silent)return"<p>An error occurred:</p><pre>"+m(ke.message+"",!0)+"</pre>";throw ke}try{var we=ce.lex($,J);if(J.walkTokens){if(J.async)return Promise.all(oe.walkTokens(we,J.walkTokens)).then(function(){return ee.parse(we,J)}).catch(ae);oe.walkTokens(we,J.walkTokens)}return ee.parse(we,J)}catch(ke){ae(ke)}}oe.options=oe.setOptions=function($){return s(oe.defaults,$),A(oe.defaults),oe},oe.getDefaults=I,oe.defaults=ie.defaults,oe.use=function(){for(var $=arguments.length,J=new Array($),_=0;_<$;_++)J[_]=arguments[_];var j=s.apply(void 0,[{}].concat(J)),H=oe.defaults.extensions||{renderers:{},childTokens:{}},q;J.forEach(function(Z){if(Z.extensions&&(q=!0,Z.extensions.forEach(function(we){if(!we.name)throw new Error("extension name required");if(we.renderer){var ke=H.renderers?H.renderers[we.name]:null;ke?H.renderers[we.name]=function(){for(var Ae=arguments.length,Me=new Array(Ae),ze=0;ze<Ae;ze++)Me[ze]=arguments[ze];var de=we.renderer.apply(this,Me);return de===!1&&(de=ke.apply(this,Me)),de}:H.renderers[we.name]=we.renderer}if(we.tokenizer){if(!we.level||we.level!=="block"&&we.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");H[we.level]?H[we.level].unshift(we.tokenizer):H[we.level]=[we.tokenizer],we.start&&(we.level==="block"?H.startBlock?H.startBlock.push(we.start):H.startBlock=[we.start]:we.level==="inline"&&(H.startInline?H.startInline.push(we.start):H.startInline=[we.start]))}we.childTokens&&(H.childTokens[we.name]=we.childTokens)})),Z.renderer&&function(){var we=oe.defaults.renderer||new L,ke=function(ze){var de=we[ze];we[ze]=function(){for(var Ee=arguments.length,ye=new Array(Ee),Fe=0;Fe<Ee;Fe++)ye[Fe]=arguments[Fe];var Be=Z.renderer[ze].apply(we,ye);return Be===!1&&(Be=de.apply(we,ye)),Be}};for(var Ae in Z.renderer)ke(Ae);j.renderer=we}(),Z.tokenizer&&function(){var we=oe.defaults.tokenizer||new U,ke=function(ze){var de=we[ze];we[ze]=function(){for(var Ee=arguments.length,ye=new Array(Ee),Fe=0;Fe<Ee;Fe++)ye[Fe]=arguments[Fe];var Be=Z.tokenizer[ze].apply(we,ye);return Be===!1&&(Be=de.apply(we,ye)),Be}};for(var Ae in Z.tokenizer)ke(Ae);j.tokenizer=we}(),Z.walkTokens){var ae=oe.defaults.walkTokens;j.walkTokens=function(we){var ke=[];return ke.push(Z.walkTokens.call(this,we)),ae&&(ke=ke.concat(ae.call(this,we))),ke}}q&&(j.extensions=H),oe.setOptions(j)})},oe.walkTokens=function($,J){for(var _=[],j=function(){var ae=q.value;switch(_=_.concat(J.call(oe,ae)),ae.type){case"table":{for(var we=S(ae.header),ke;!(ke=we()).done;){var Ae=ke.value;_=_.concat(oe.walkTokens(Ae.tokens,J))}for(var Me=S(ae.rows),ze;!(ze=Me()).done;)for(var de=ze.value,Ee=S(de),ye;!(ye=Ee()).done;){var Fe=ye.value;_=_.concat(oe.walkTokens(Fe.tokens,J))}break}case"list":{_=_.concat(oe.walkTokens(ae.items,J));break}default:oe.defaults.extensions&&oe.defaults.extensions.childTokens&&oe.defaults.extensions.childTokens[ae.type]?oe.defaults.extensions.childTokens[ae.type].forEach(function(Be){_=_.concat(oe.walkTokens(ae[Be],J))}):ae.tokens&&(_=_.concat(oe.walkTokens(ae.tokens,J)))}},H=S($),q;!(q=H()).done;)j();return _},oe.parseInline=function($,J){if(typeof $>"u"||$===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof $!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call($)+", string expected");J=s({},oe.defaults,J||{}),K(J);try{var _=ce.lexInline($,J);return J.walkTokens&&oe.walkTokens(_,J.walkTokens),ee.parseInline(_,J)}catch(j){if(j.message+=`
Please report this to https://github.com/markedjs/marked.`,J.silent)return"<p>An error occurred:</p><pre>"+m(j.message+"",!0)+"</pre>";throw j}},oe.Parser=ee,oe.parser=ee.parse,oe.Renderer=L,oe.TextRenderer=N,oe.Lexer=ce,oe.lexer=ce.lex,oe.Tokenizer=U,oe.Slugger=V,oe.parse=oe;var ge=oe.options,fe=oe.setOptions,R=oe.use,M=oe.walkTokens,W=oe.parseInline,Y=oe,re=ee.parse,me=ce.lex;ie.Lexer=ce,ie.Parser=ee,ie.Renderer=L,ie.Slugger=V,ie.TextRenderer=N,ie.Tokenizer=U,ie.getDefaults=I,ie.lexer=me,ie.marked=oe,ie.options=ge,ie.parse=Y,ie.parseInline=W,ie.parser=re,ie.setOptions=fe,ie.use=R,ie.walkTokens=M,Object.defineProperty(ie,"__esModule",{value:!0})}),define(ve[87],be([1,0,26]),function(ie,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new b.LRUCache(1e4);function k(y){return E(y,"NFC",t)}e.normalizeNFC=k;const S=new b.LRUCache(1e4);function I(y){return E(y,"NFD",S)}e.normalizeNFD=I;const A=/[^\u0000-\u0080]/;function E(y,D,T){if(!y)return y;const C=T.get(y);if(C)return C;let w;return A.test(y)?w=y.normalize(D):w=y,T.set(y,w),w}e.removeAccents=function(){const y=/[\u0300-\u036f]/g;return function(D){return I(D).replace(y,"")}}()}),function(){function ie(k){const S=[];typeof k=="number"&&S.push("code/timeOrigin",k);function I(E){S.push(E,Date.now())}function A(){const E=[];for(let y=0;y<S.length;y+=2)E.push({name:S[y],startTime:S[y+1]});return E}return{mark:I,getMarks:A}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ie():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const S=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const I of performance.getEntriesByType("mark"))S.push({name:I.name,startTime:Math.round(k+I.startTime)});return S}};if(typeof process=="object"){const k=Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ie(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),ie()}function b(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return b(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=b(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=b(t))}(),function(ie,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var b=e();for(var t in b)(typeof exports=="object"?exports:ie)[t]=b[t]}}(typeof self<"u"?self:this,function(){return function(ie){var e={};function b(t){if(e[t])return e[t].exports;var k=e[t]={i:t,l:!1,exports:{}};return ie[t].call(k.exports,k,k.exports,b),k.l=!0,k.exports}return b.m=ie,b.c=e,b.d=function(t,k,S){b.o(t,k)||Object.defineProperty(t,k,{enumerable:!0,get:S})},b.r=function(t){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},b.t=function(t,k){if(1&k&&(t=b(t)),8&k||4&k&&typeof t=="object"&&t&&t.__esModule)return t;var S=Object.create(null);if(b.r(S),Object.defineProperty(S,"default",{enumerable:!0,value:t}),2&k&&typeof t!="string")for(var I in t)b.d(S,I,function(A){return t[A]}.bind(null,I));return S},b.n=function(t){var k=t&&t.__esModule?function(){return t.default}:function(){return t};return b.d(k,"a",k),k},b.o=function(t,k){return Object.prototype.hasOwnProperty.call(t,k)},b.p="",b(b.s=0)}([function(ie,e,b){(function(t){var k;e=ie.exports=R,k=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var de=Array.prototype.slice.call(arguments,0);de.unshift("SEMVER"),console.log.apply(console,de)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var S=256,I=Number.MAX_SAFE_INTEGER||9007199254740991,A=e.re=[],E=e.src=[],y=0,D=y++;E[D]="0|[1-9]\\d*";var T=y++;E[T]="[0-9]+";var C=y++;E[C]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var w=y++;E[w]="("+E[D]+")\\.("+E[D]+")\\.("+E[D]+")";var m=y++;E[m]="("+E[T]+")\\.("+E[T]+")\\.("+E[T]+")";var g=y++;E[g]="(?:"+E[D]+"|"+E[C]+")";var p=y++;E[p]="(?:"+E[T]+"|"+E[C]+")";var d=y++;E[d]="(?:-("+E[g]+"(?:\\."+E[g]+")*))";var v=y++;E[v]="(?:-?("+E[p]+"(?:\\."+E[p]+")*))";var c=y++;E[c]="[0-9A-Za-z-]+";var h=y++;E[h]="(?:\\+("+E[c]+"(?:\\."+E[c]+")*))";var f=y++,i="v?"+E[w]+E[d]+"?"+E[h]+"?";E[f]="^"+i+"$";var n="[v=\\s]*"+E[m]+E[v]+"?"+E[h]+"?",r=y++;E[r]="^"+n+"$";var o=y++;E[o]="((?:<|>)?=?)";var a=y++;E[a]=E[T]+"|x|X|\\*";var l=y++;E[l]=E[D]+"|x|X|\\*";var s=y++;E[s]="[v=\\s]*("+E[l]+")(?:\\.("+E[l]+")(?:\\.("+E[l]+")(?:"+E[d]+")?"+E[h]+"?)?)?";var u=y++;E[u]="[v=\\s]*("+E[a]+")(?:\\.("+E[a]+")(?:\\.("+E[a]+")(?:"+E[v]+")?"+E[h]+"?)?)?";var P=y++;E[P]="^"+E[o]+"\\s*"+E[s]+"$";var F=y++;E[F]="^"+E[o]+"\\s*"+E[u]+"$";var K=y++;E[K]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var ne=y++;E[ne]="(?:~>?)";var ue=y++;E[ue]="(\\s*)"+E[ne]+"\\s+",A[ue]=new RegExp(E[ue],"g");var se=y++;E[se]="^"+E[ne]+E[s]+"$";var U=y++;E[U]="^"+E[ne]+E[u]+"$";var Q=y++;E[Q]="(?:\\^)";var z=y++;E[z]="(\\s*)"+E[Q]+"\\s+",A[z]=new RegExp(E[z],"g");var G=y++;E[G]="^"+E[Q]+E[s]+"$";var X=y++;E[X]="^"+E[Q]+E[u]+"$";var ce=y++;E[ce]="^"+E[o]+"\\s*("+n+")$|^$";var L=y++;E[L]="^"+E[o]+"\\s*("+i+")$|^$";var N=y++;E[N]="(\\s*)"+E[o]+"\\s*("+n+"|"+E[s]+")",A[N]=new RegExp(E[N],"g");var V=y++;E[V]="^\\s*("+E[s]+")\\s+-\\s+("+E[s]+")\\s*$";var ee=y++;E[ee]="^\\s*("+E[u]+")\\s+-\\s+("+E[u]+")\\s*$";var oe=y++;E[oe]="(<|>)?=?\\s*\\*";for(var ge=0;ge<35;ge++)k(ge,E[ge]),A[ge]||(A[ge]=new RegExp(E[ge]));function fe(de,Ee){if(de instanceof R)return de;if(typeof de!="string"||de.length>S||!(Ee?A[r]:A[f]).test(de))return null;try{return new R(de,Ee)}catch{return null}}function R(de,Ee){if(de instanceof R){if(de.loose===Ee)return de;de=de.version}else if(typeof de!="string")throw new TypeError("Invalid Version: "+de);if(de.length>S)throw new TypeError("version is longer than "+S+" characters");if(!(this instanceof R))return new R(de,Ee);k("SemVer",de,Ee),this.loose=Ee;var ye=de.trim().match(Ee?A[r]:A[f]);if(!ye)throw new TypeError("Invalid Version: "+de);if(this.raw=de,this.major=+ye[1],this.minor=+ye[2],this.patch=+ye[3],this.major>I||this.major<0)throw new TypeError("Invalid major version");if(this.minor>I||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>I||this.patch<0)throw new TypeError("Invalid patch version");ye[4]?this.prerelease=ye[4].split(".").map(function(Fe){if(/^[0-9]+$/.test(Fe)){var Be=+Fe;if(Be>=0&&Be<I)return Be}return Fe}):this.prerelease=[],this.build=ye[5]?ye[5].split("."):[],this.format()}e.parse=fe,e.valid=function(de,Ee){var ye=fe(de,Ee);return ye?ye.version:null},e.clean=function(de,Ee){var ye=fe(de.trim().replace(/^[=v]+/,""),Ee);return ye?ye.version:null},e.SemVer=R,R.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},R.prototype.toString=function(){return this.version},R.prototype.compare=function(de){return k("SemVer.compare",this.version,this.loose,de),de instanceof R||(de=new R(de,this.loose)),this.compareMain(de)||this.comparePre(de)},R.prototype.compareMain=function(de){return de instanceof R||(de=new R(de,this.loose)),W(this.major,de.major)||W(this.minor,de.minor)||W(this.patch,de.patch)},R.prototype.comparePre=function(de){if(de instanceof R||(de=new R(de,this.loose)),this.prerelease.length&&!de.prerelease.length)return-1;if(!this.prerelease.length&&de.prerelease.length)return 1;if(!this.prerelease.length&&!de.prerelease.length)return 0;var Ee=0;do{var ye=this.prerelease[Ee],Fe=de.prerelease[Ee];if(k("prerelease compare",Ee,ye,Fe),ye===void 0&&Fe===void 0)return 0;if(Fe===void 0)return 1;if(ye===void 0)return-1;if(ye!==Fe)return W(ye,Fe)}while(++Ee)},R.prototype.inc=function(de,Ee){switch(de){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Ee);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Ee);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Ee),this.inc("pre",Ee);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Ee),this.inc("pre",Ee);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ye=this.prerelease.length;--ye>=0;)typeof this.prerelease[ye]=="number"&&(this.prerelease[ye]++,ye=-2);ye===-1&&this.prerelease.push(0)}Ee&&(this.prerelease[0]===Ee?isNaN(this.prerelease[1])&&(this.prerelease=[Ee,0]):this.prerelease=[Ee,0]);break;default:throw new Error("invalid increment argument: "+de)}return this.format(),this.raw=this.version,this},e.inc=function(de,Ee,ye,Fe){typeof ye=="string"&&(Fe=ye,ye=void 0);try{return new R(de,ye).inc(Ee,Fe).version}catch{return null}},e.diff=function(de,Ee){if($(de,Ee))return null;var ye=fe(de),Fe=fe(Ee);if(ye.prerelease.length||Fe.prerelease.length){for(var Be in ye)if((Be==="major"||Be==="minor"||Be==="patch")&&ye[Be]!==Fe[Be])return"pre"+Be;return"prerelease"}for(var Be in ye)if((Be==="major"||Be==="minor"||Be==="patch")&&ye[Be]!==Fe[Be])return Be},e.compareIdentifiers=W;var M=/^[0-9]+$/;function W(de,Ee){var ye=M.test(de),Fe=M.test(Ee);return ye&&Fe&&(de=+de,Ee=+Ee),ye&&!Fe?-1:Fe&&!ye?1:de<Ee?-1:de>Ee?1:0}function Y(de,Ee,ye){return new R(de,ye).compare(new R(Ee,ye))}function re(de,Ee,ye){return Y(de,Ee,ye)>0}function me(de,Ee,ye){return Y(de,Ee,ye)<0}function $(de,Ee,ye){return Y(de,Ee,ye)===0}function J(de,Ee,ye){return Y(de,Ee,ye)!==0}function _(de,Ee,ye){return Y(de,Ee,ye)>=0}function j(de,Ee,ye){return Y(de,Ee,ye)<=0}function H(de,Ee,ye,Fe){var Be;switch(Ee){case"===":typeof de=="object"&&(de=de.version),typeof ye=="object"&&(ye=ye.version),Be=de===ye;break;case"!==":typeof de=="object"&&(de=de.version),typeof ye=="object"&&(ye=ye.version),Be=de!==ye;break;case"":case"=":case"==":Be=$(de,ye,Fe);break;case"!=":Be=J(de,ye,Fe);break;case">":Be=re(de,ye,Fe);break;case">=":Be=_(de,ye,Fe);break;case"<":Be=me(de,ye,Fe);break;case"<=":Be=j(de,ye,Fe);break;default:throw new TypeError("Invalid operator: "+Ee)}return Be}function q(de,Ee){if(de instanceof q){if(de.loose===Ee)return de;de=de.value}if(!(this instanceof q))return new q(de,Ee);k("comparator",de,Ee),this.loose=Ee,this.parse(de),this.semver===Z?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(de,Ee){return W(Ee,de)},e.major=function(de,Ee){return new R(de,Ee).major},e.minor=function(de,Ee){return new R(de,Ee).minor},e.patch=function(de,Ee){return new R(de,Ee).patch},e.compare=Y,e.compareLoose=function(de,Ee){return Y(de,Ee,!0)},e.rcompare=function(de,Ee,ye){return Y(Ee,de,ye)},e.sort=function(de,Ee){return de.sort(function(ye,Fe){return e.compare(ye,Fe,Ee)})},e.rsort=function(de,Ee){return de.sort(function(ye,Fe){return e.rcompare(ye,Fe,Ee)})},e.gt=re,e.lt=me,e.eq=$,e.neq=J,e.gte=_,e.lte=j,e.cmp=H,e.Comparator=q;var Z={};function ae(de,Ee){if(de instanceof ae)return de.loose===Ee?de:new ae(de.raw,Ee);if(de instanceof q)return new ae(de.value,Ee);if(!(this instanceof ae))return new ae(de,Ee);if(this.loose=Ee,this.raw=de,this.set=de.split(/\s*\|\|\s*/).map(function(ye){return this.parseRange(ye.trim())},this).filter(function(ye){return ye.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+de);this.format()}function we(de){return!de||de.toLowerCase()==="x"||de==="*"}function ke(de,Ee,ye,Fe,Be,Ye,Ve,Je,Xe,tt,qe,$e,xe){return((Ee=we(ye)?"":we(Fe)?">="+ye+".0.0":we(Be)?">="+ye+"."+Fe+".0":">="+Ee)+" "+(Je=we(Xe)?"":we(tt)?"<"+(+Xe+1)+".0.0":we(qe)?"<"+Xe+"."+(+tt+1)+".0":$e?"<="+Xe+"."+tt+"."+qe+"-"+$e:"<="+Je)).trim()}function Ae(de,Ee){for(var ye=0;ye<de.length;ye++)if(!de[ye].test(Ee))return!1;if(Ee.prerelease.length){for(ye=0;ye<de.length;ye++)if(k(de[ye].semver),de[ye].semver!==Z&&de[ye].semver.prerelease.length>0){var Fe=de[ye].semver;if(Fe.major===Ee.major&&Fe.minor===Ee.minor&&Fe.patch===Ee.patch)return!0}return!1}return!0}function Me(de,Ee,ye){try{Ee=new ae(Ee,ye)}catch{return!1}return Ee.test(de)}function ze(de,Ee,ye,Fe){var Be,Ye,Ve,Je,Xe;switch(de=new R(de,Fe),Ee=new ae(Ee,Fe),ye){case">":Be=re,Ye=j,Ve=me,Je=">",Xe=">=";break;case"<":Be=me,Ye=_,Ve=re,Je="<",Xe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Me(de,Ee,Fe))return!1;for(var tt=0;tt<Ee.set.length;++tt){var qe=Ee.set[tt],$e=null,xe=null;if(qe.forEach(function(le){le.semver===Z&&(le=new q(">=0.0.0")),$e=$e||le,xe=xe||le,Be(le.semver,$e.semver,Fe)?$e=le:Ve(le.semver,xe.semver,Fe)&&(xe=le)}),$e.operator===Je||$e.operator===Xe||(!xe.operator||xe.operator===Je)&&Ye(de,xe.semver)||xe.operator===Xe&&Ve(de,xe.semver))return!1}return!0}q.prototype.parse=function(de){var Ee=this.loose?A[ce]:A[L],ye=de.match(Ee);if(!ye)throw new TypeError("Invalid comparator: "+de);this.operator=ye[1],this.operator==="="&&(this.operator=""),ye[2]?this.semver=new R(ye[2],this.loose):this.semver=Z},q.prototype.toString=function(){return this.value},q.prototype.test=function(de){return k("Comparator.test",de,this.loose),this.semver===Z||(typeof de=="string"&&(de=new R(de,this.loose)),H(de,this.operator,this.semver,this.loose))},q.prototype.intersects=function(de,Ee){if(!(de instanceof q))throw new TypeError("a Comparator is required");var ye;if(this.operator==="")return ye=new ae(de.value,Ee),Me(this.value,ye,Ee);if(de.operator==="")return ye=new ae(this.value,Ee),Me(de.semver,ye,Ee);var Fe=!(this.operator!==">="&&this.operator!==">"||de.operator!==">="&&de.operator!==">"),Be=!(this.operator!=="<="&&this.operator!=="<"||de.operator!=="<="&&de.operator!=="<"),Ye=this.semver.version===de.semver.version,Ve=!(this.operator!==">="&&this.operator!=="<="||de.operator!==">="&&de.operator!=="<="),Je=H(this.semver,"<",de.semver,Ee)&&(this.operator===">="||this.operator===">")&&(de.operator==="<="||de.operator==="<"),Xe=H(this.semver,">",de.semver,Ee)&&(this.operator==="<="||this.operator==="<")&&(de.operator===">="||de.operator===">");return Fe||Be||Ye&&Ve||Je||Xe},e.Range=ae,ae.prototype.format=function(){return this.range=this.set.map(function(de){return de.join(" ").trim()}).join("||").trim(),this.range},ae.prototype.toString=function(){return this.range},ae.prototype.parseRange=function(de){var Ee=this.loose;de=de.trim(),k("range",de,Ee);var ye=Ee?A[ee]:A[V];de=de.replace(ye,ke),k("hyphen replace",de),de=de.replace(A[N],"$1$2$3"),k("comparator trim",de,A[N]),de=(de=(de=de.replace(A[ue],"$1~")).replace(A[z],"$1^")).split(/\s+/).join(" ");var Fe=Ee?A[ce]:A[L],Be=de.split(" ").map(function(Ye){return function(Ve,Je){return k("comp",Ve),Ve=function(Xe,tt){return Xe.trim().split(/\s+/).map(function(qe){return function($e,xe){k("caret",$e,xe);var le=xe?A[X]:A[G];return $e.replace(le,function(Ce,De,Te,Ne,We){var Ge;return k("caret",$e,Ce,De,Te,Ne,We),we(De)?Ge="":we(Te)?Ge=">="+De+".0.0 <"+(+De+1)+".0.0":we(Ne)?Ge=De==="0"?">="+De+"."+Te+".0 <"+De+"."+(+Te+1)+".0":">="+De+"."+Te+".0 <"+(+De+1)+".0.0":We?(k("replaceCaret pr",We),We.charAt(0)!=="-"&&(We="-"+We),Ge=De==="0"?Te==="0"?">="+De+"."+Te+"."+Ne+We+" <"+De+"."+Te+"."+(+Ne+1):">="+De+"."+Te+"."+Ne+We+" <"+De+"."+(+Te+1)+".0":">="+De+"."+Te+"."+Ne+We+" <"+(+De+1)+".0.0"):(k("no pr"),Ge=De==="0"?Te==="0"?">="+De+"."+Te+"."+Ne+" <"+De+"."+Te+"."+(+Ne+1):">="+De+"."+Te+"."+Ne+" <"+De+"."+(+Te+1)+".0":">="+De+"."+Te+"."+Ne+" <"+(+De+1)+".0.0"),k("caret return",Ge),Ge})}(qe,tt)}).join(" ")}(Ve,Je),k("caret",Ve),Ve=function(Xe,tt){return Xe.trim().split(/\s+/).map(function(qe){return function($e,xe){var le=xe?A[U]:A[se];return $e.replace(le,function(Ce,De,Te,Ne,We){var Ge;return k("tilde",$e,Ce,De,Te,Ne,We),we(De)?Ge="":we(Te)?Ge=">="+De+".0.0 <"+(+De+1)+".0.0":we(Ne)?Ge=">="+De+"."+Te+".0 <"+De+"."+(+Te+1)+".0":We?(k("replaceTilde pr",We),We.charAt(0)!=="-"&&(We="-"+We),Ge=">="+De+"."+Te+"."+Ne+We+" <"+De+"."+(+Te+1)+".0"):Ge=">="+De+"."+Te+"."+Ne+" <"+De+"."+(+Te+1)+".0",k("tilde return",Ge),Ge})}(qe,tt)}).join(" ")}(Ve,Je),k("tildes",Ve),Ve=function(Xe,tt){return k("replaceXRanges",Xe,tt),Xe.split(/\s+/).map(function(qe){return function($e,xe){$e=$e.trim();var le=xe?A[F]:A[P];return $e.replace(le,function(Ce,De,Te,Ne,We,Ge){k("xRange",$e,Ce,De,Te,Ne,We,Ge);var rt=we(Te),it=rt||we(Ne),Qe=it||we(We);return De==="="&&Qe&&(De=""),rt?Ce=De===">"||De==="<"?"<0.0.0":"*":De&&Qe?(it&&(Ne=0),Qe&&(We=0),De===">"?(De=">=",it?(Te=+Te+1,Ne=0,We=0):Qe&&(Ne=+Ne+1,We=0)):De==="<="&&(De="<",it?Te=+Te+1:Ne=+Ne+1),Ce=De+Te+"."+Ne+"."+We):it?Ce=">="+Te+".0.0 <"+(+Te+1)+".0.0":Qe&&(Ce=">="+Te+"."+Ne+".0 <"+Te+"."+(+Ne+1)+".0"),k("xRange return",Ce),Ce})}(qe,tt)}).join(" ")}(Ve,Je),k("xrange",Ve),Ve=function(Xe,tt){return k("replaceStars",Xe,tt),Xe.trim().replace(A[oe],"")}(Ve,Je),k("stars",Ve),Ve}(Ye,Ee)}).join(" ").split(/\s+/);return this.loose&&(Be=Be.filter(function(Ye){return!!Ye.match(Fe)})),Be=Be.map(function(Ye){return new q(Ye,Ee)})},ae.prototype.intersects=function(de,Ee){if(!(de instanceof ae))throw new TypeError("a Range is required");return this.set.some(function(ye){return ye.every(function(Fe){return de.set.some(function(Be){return Be.every(function(Ye){return Fe.intersects(Ye,Ee)})})})})},e.toComparators=function(de,Ee){return new ae(de,Ee).set.map(function(ye){return ye.map(function(Fe){return Fe.value}).join(" ").trim().split(" ")})},ae.prototype.test=function(de){if(!de)return!1;typeof de=="string"&&(de=new R(de,this.loose));for(var Ee=0;Ee<this.set.length;Ee++)if(Ae(this.set[Ee],de))return!0;return!1},e.satisfies=Me,e.maxSatisfying=function(de,Ee,ye){var Fe=null,Be=null;try{var Ye=new ae(Ee,ye)}catch{return null}return de.forEach(function(Ve){Ye.test(Ve)&&(Fe&&Be.compare(Ve)!==-1||(Be=new R(Fe=Ve,ye)))}),Fe},e.minSatisfying=function(de,Ee,ye){var Fe=null,Be=null;try{var Ye=new ae(Ee,ye)}catch{return null}return de.forEach(function(Ve){Ye.test(Ve)&&(Fe&&Be.compare(Ve)!==1||(Be=new R(Fe=Ve,ye)))}),Fe},e.validRange=function(de,Ee){try{return new ae(de,Ee).range||"*"}catch{return null}},e.ltr=function(de,Ee,ye){return ze(de,Ee,"<",ye)},e.gtr=function(de,Ee,ye){return ze(de,Ee,">",ye)},e.outside=ze,e.prerelease=function(de,Ee){var ye=fe(de,Ee);return ye&&ye.prerelease.length?ye.prerelease:null},e.intersects=function(de,Ee,ye){return de=new ae(de,ye),Ee=new ae(Ee,ye),de.intersects(Ee)},e.coerce=function(de){if(de instanceof R)return de;if(typeof de!="string")return null;var Ee=de.match(A[K]);return Ee==null?null:fe((Ee[1]||"0")+"."+(Ee[2]||"0")+"."+(Ee[3]||"0"))}}).call(this,b(1))},function(ie,e){var b,t,k=ie.exports={};function S(){throw new Error("setTimeout has not been defined")}function I(){throw new Error("clearTimeout has not been defined")}function A(p){if(b===setTimeout)return setTimeout(p,0);if((b===S||!b)&&setTimeout)return b=setTimeout,setTimeout(p,0);try{return b(p,0)}catch{try{return b.call(null,p,0)}catch{return b.call(this,p,0)}}}(function(){try{b=typeof setTimeout=="function"?setTimeout:S}catch{b=S}try{t=typeof clearTimeout=="function"?clearTimeout:I}catch{t=I}})();var E,y=[],D=!1,T=-1;function C(){D&&E&&(D=!1,E.length?y=E.concat(y):T=-1,y.length&&w())}function w(){if(!D){var p=A(C);D=!0;for(var d=y.length;d;){for(E=y,y=[];++T<d;)E&&E[T].run();T=-1,d=y.length}E=null,D=!1,function(v){if(t===clearTimeout)return clearTimeout(v);if((t===I||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(v);try{t(v)}catch{try{return t.call(null,v)}catch{return t.call(this,v)}}}(p)}}function m(p,d){this.fun=p,this.array=d}function g(){}k.nextTick=function(p){var d=new Array(arguments.length-1);if(arguments.length>1)for(var v=1;v<arguments.length;v++)d[v-1]=arguments[v];y.push(new m(p,d)),y.length!==1||D||A(w)},m.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=g,k.addListener=g,k.once=g,k.off=g,k.removeListener=g,k.removeAllListeners=g,k.emit=g,k.prependListener=g,k.prependOnceListener=g,k.listeners=function(p){return[]},k.binding=function(p){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(p){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(ve[138],be([1,0]),function(ie,e){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class t{constructor(A,E,y){this.level=A,this.key=E,this.value=y,this.forward=[]}}const k=void 0;class S{constructor(A,E=2**16){this.comparator=A,this[b]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(E)|0),this.e=new t(this.c,k,k)}get size(){return this.f}clear(){this.e=new t(this.c,k,k)}has(A){return Boolean(S.g(this,A,this.comparator))}get(A){return S.g(this,A,this.comparator)?.value}set(A,E){return S.h(this,A,E,this.comparator)&&(this.f+=1),this}delete(A){const E=S.k(this,A,this.comparator);return E&&(this.f-=1),E}forEach(A,E){let y=this.e.forward[0];for(;y;)A.call(E,y.value,y.key,this),y=y.forward[0]}[(b=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let A=this.e.forward[0];for(;A;)yield[A.key,A.value],A=A.forward[0]}*keys(){let A=this.e.forward[0];for(;A;)yield A.key,A=A.forward[0]}*values(){let A=this.e.forward[0];for(;A;)yield A.value,A=A.forward[0]}toString(){let A="[SkipList]:",E=this.e.forward[0];for(;E;)A+=`node(${E.key}, ${E.value}, lvl:${E.level})`,E=E.forward[0];return A}static g(A,E,y){let D=A.e;for(let T=A.d-1;T>=0;T--)for(;D.forward[T]&&y(D.forward[T].key,E)<0;)D=D.forward[T];if(D=D.forward[0],D&&y(D.key,E)===0)return D}static h(A,E,y,D){const T=[];let C=A.e;for(let w=A.d-1;w>=0;w--){for(;C.forward[w]&&D(C.forward[w].key,E)<0;)C=C.forward[w];T[w]=C}if(C=C.forward[0],C&&D(C.key,E)===0)return C.value=y,!1;{const w=S.j(A);if(w>A.d){for(let m=A.d;m<w;m++)T[m]=A.e;A.d=w}C=new t(w,E,y);for(let m=0;m<w;m++)C.forward[m]=T[m].forward[m],T[m].forward[m]=C;return!0}}static j(A,E=.5){let y=1;for(;Math.random()<E&&y<A.c;)y+=1;return y}static k(A,E,y){const D=[];let T=A.e;for(let C=A.d-1;C>=0;C--){for(;T.forward[C]&&y(T.forward[C].key,E)<0;)T=T.forward[C];D[C]=T}if(T=T.forward[0],!T||y(T.key,E)!==0)return!1;for(let C=0;C<A.d&&D[C].forward[C]===T;C++)D[C].forward[C]=T.forward[C];for(;A.d>0&&A.e.forward[A.d-1]===k;)A.d-=1;return!0}}e.SkipList=S}),define(ve[44],be([1,0,8,2]),function(ie,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(h){const f=h;return f?typeof f.read=="function":!1}e.isReadable=k;function S(h){const f=h;return f?[f.on,f.pause,f.resume,f.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=S;function I(h){const f=h;return f?S(f.stream)&&Array.isArray(f.buffer)&&typeof f.ended=="boolean":!1}e.isReadableBufferedStream=I;function A(h,f){return new E(h,f)}e.newWriteableStream=A;class E{constructor(f,i){this.e=f,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(f){if(!this.a.destroyed){if(this.a.flowing)this.g(f);else if(this.b.data.push(f),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(f){this.a.destroyed||(this.a.flowing?this.h(f):this.b.error.push(f))}end(f){this.a.destroyed||(typeof f<"u"&&this.write(f),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(f){this.c.data.slice(0).forEach(i=>i(f))}h(f){this.c.error.length===0?(0,b.onUnexpectedError)(f):this.c.error.slice(0).forEach(i=>i(f))}i(){this.c.end.slice(0).forEach(f=>f())}on(f,i){if(!this.a.destroyed)switch(f){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(f,i){if(this.a.destroyed)return;let n;switch(f){case"data":n=this.c.data;break;case"end":n=this.c.end;break;case"error":n=this.c.error;break}if(n){const r=n.indexOf(i);r>=0&&n.splice(r,1)}}j(){if(this.b.data.length>0){const f=this.e(this.b.data);this.g(f),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(n=>n())}}k(){if(this.c.error.length>0){for(const f of this.b.error)this.h(f);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function y(h,f){const i=[];let n;for(;(n=h.read())!==null;)i.push(n);return f(i)}e.consumeReadable=y;function D(h,f,i){const n=[];let r;for(;(r=h.read())!==null&&n.length<i;)n.push(r);return r===null&&n.length>0?f(n):{read:()=>{if(n.length>0)return n.shift();if(typeof r<"u"){const o=r;return r=void 0,o}return h.read()}}}e.peekReadable=D;function T(h,f){return new Promise((i,n)=>{const r=[];C(h,{onData:o=>{f&&r.push(o)},onError:o=>{f?n(o):i(void 0)},onEnd:()=>{i(f?f(r):void 0)}})})}e.consumeStream=T;function C(h,f){let i=!1;return h.on("error",n=>{i||f.onError(n)}),h.on("end",()=>{i||f.onEnd()}),h.on("data",n=>{i||f.onData(n)}),(0,t.toDisposable)(()=>i=!0)}e.listenStream=C;function w(h,f){return new Promise((i,n)=>{const r=new t.DisposableStore,o=[],a=u=>{if(o.push(u),o.length>f)return r.dispose(),h.pause(),i({stream:h,buffer:o,ended:!1})},l=u=>n(u),s=()=>i({stream:h,buffer:o,ended:!0});r.add((0,t.toDisposable)(()=>h.removeListener("error",l))),h.on("error",l),r.add((0,t.toDisposable)(()=>h.removeListener("end",s))),h.on("end",s),r.add((0,t.toDisposable)(()=>h.removeListener("data",a))),h.on("data",a)})}e.peekStream=w;function m(h,f){const i=A(f);return i.end(h),i}e.toStream=m;function g(){const h=A(()=>{throw new Error("not supported")});return h.end(),h}e.emptyStream=g;function p(h){let f=!1;return{read:()=>f?null:(f=!0,h)}}e.toReadable=p;function d(h,f,i){const n=A(i);return C(h,{onData:r=>n.write(f.data(r)),onError:r=>n.error(f.error?f.error(r):r),onEnd:()=>n.end()}),n}e.transform=d;function v(h,f,i){let n=!1;return{read:()=>{const r=f.read();return n?r:(n=!0,r!==null?i([h,r]):h)}}}e.prefixedReadable=v;function c(h,f,i){let n=!1;const r=A(i);return C(f,{onData:o=>n?r.write(o):(n=!0,r.write(i([h,o]))),onError:o=>r.error(o),onEnd:()=>{n||(n=!0,r.write(h)),r.end()}}),r}e.prefixedStream=c}),define(ve[16],be([1,0,44]),function(ie,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer<"u";let k,S;class I{static alloc(u){return t?new I(Buffer.allocUnsafe(u)):new I(new Uint8Array(u))}static wrap(u){return t&&!Buffer.isBuffer(u)&&(u=Buffer.from(u.buffer,u.byteOffset,u.byteLength)),new I(u)}static fromString(u,P){return!(P?.dontUseNodeBuffer||!1)&&t?new I(Buffer.from(u)):(k||(k=new TextEncoder),new I(k.encode(u)))}static fromByteArray(u){const P=I.alloc(u.length);for(let F=0,K=u.length;F<K;F++)P.buffer[F]=u[F];return P}static concat(u,P){if(typeof P>"u"){P=0;for(let ne=0,ue=u.length;ne<ue;ne++)P+=u[ne].byteLength}const F=I.alloc(P);let K=0;for(let ne=0,ue=u.length;ne<ue;ne++){const se=u[ne];F.set(se,K),K+=se.byteLength}return F}constructor(u){this.buffer=u,this.byteLength=this.buffer.byteLength}clone(){const u=I.alloc(this.byteLength);return u.set(this),u}toString(){return t?this.buffer.toString():(S||(S=new TextDecoder),S.decode(this.buffer))}slice(u,P){return new I(this.buffer.subarray(u,P))}set(u,P){if(u instanceof I)this.buffer.set(u.buffer,P);else if(u instanceof Uint8Array)this.buffer.set(u,P);else if(u instanceof ArrayBuffer)this.buffer.set(new Uint8Array(u),P);else if(ArrayBuffer.isView(u))this.buffer.set(new Uint8Array(u.buffer,u.byteOffset,u.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(u){return y(this.buffer,u)}writeUInt32BE(u,P){D(this.buffer,u,P)}readUInt32LE(u){return T(this.buffer,u)}writeUInt32LE(u,P){C(this.buffer,u,P)}readUInt8(u){return w(this.buffer,u)}writeUInt8(u,P){m(this.buffer,u,P)}}e.VSBuffer=I;function A(s,u){return s[u+0]<<0>>>0|s[u+1]<<8>>>0}e.readUInt16LE=A;function E(s,u,P){s[P+0]=u&255,u=u>>>8,s[P+1]=u&255}e.writeUInt16LE=E;function y(s,u){return s[u]*2**24+s[u+1]*2**16+s[u+2]*2**8+s[u+3]}e.readUInt32BE=y;function D(s,u,P){s[P+3]=u,u=u>>>8,s[P+2]=u,u=u>>>8,s[P+1]=u,u=u>>>8,s[P]=u}e.writeUInt32BE=D;function T(s,u){return s[u+0]<<0>>>0|s[u+1]<<8>>>0|s[u+2]<<16>>>0|s[u+3]<<24>>>0}e.readUInt32LE=T;function C(s,u,P){s[P+0]=u&255,u=u>>>8,s[P+1]=u&255,u=u>>>8,s[P+2]=u&255,u=u>>>8,s[P+3]=u&255}e.writeUInt32LE=C;function w(s,u){return s[u]}e.readUInt8=w;function m(s,u,P){s[P]=u}e.writeUInt8=m;function g(s){return b.consumeReadable(s,u=>I.concat(u))}e.readableToBuffer=g;function p(s){return b.toReadable(s)}e.bufferToReadable=p;function d(s){return b.consumeStream(s,u=>I.concat(u))}e.streamToBuffer=d;async function v(s){return s.ended?I.concat(s.buffer):I.concat([...s.buffer,await d(s.stream)])}e.bufferedStreamToBuffer=v;function c(s){return b.toStream(s,u=>I.concat(u))}e.bufferToStream=c;function h(s){return b.transform(s,{data:u=>typeof u=="string"?I.fromString(u):I.wrap(u)},u=>I.concat(u))}e.streamToBufferReadableStream=h;function f(s){return b.newWriteableStream(u=>I.concat(u),s)}e.newWriteableBufferStream=f;function i(s,u){return b.prefixedReadable(s,u,P=>I.concat(P))}e.prefixedBufferReadable=i;function n(s,u){return b.prefixedStream(s,u,P=>I.concat(P))}e.prefixedBufferStream=n;function r(s){let u=0,P=0,F=0;const K=new Uint8Array(Math.floor(s.length/4*3)),ne=se=>{switch(P){case 3:K[F++]=u|se,P=0;break;case 2:K[F++]=u|se>>>2,u=se<<6,P=3;break;case 1:K[F++]=u|se>>>4,u=se<<4,P=2;break;default:u=se<<2,P=1}};for(let se=0;se<s.length;se++){const U=s.charCodeAt(se);if(U>=65&&U<=90)ne(U-65);else if(U>=97&&U<=122)ne(U-97+26);else if(U>=48&&U<=57)ne(U-48+52);else if(U===43||U===45)ne(62);else if(U===47||U===95)ne(63);else{if(U===61)break;throw new SyntaxError(`Unexpected base64 character ${s[se]}`)}}const ue=F;for(;P>0;)ne(0);return I.wrap(K).slice(0,ue)}e.decodeBase64=r;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function l({buffer:s},u=!0,P=!1){const F=P?a:o;let K="";const ne=s.byteLength%3;let ue=0;for(;ue<s.byteLength-ne;ue+=3){const se=s[ue+0],U=s[ue+1],Q=s[ue+2];K+=F[se>>>2],K+=F[(se<<4|U>>>4)&63],K+=F[(U<<2|Q>>>6)&63],K+=F[Q&63]}if(ne===1){const se=s[ue+0];K+=F[se>>>2],K+=F[se<<4&63],u&&(K+="==")}else if(ne===2){const se=s[ue+0],U=s[ue+1];K+=F[se>>>2],K+=F[(se<<4|U>>>4)&63],K+=F[U<<2&63],u&&(K+="=")}return K}e.encodeBase64=l}),define(ve[11],be([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function b(n){return typeof n=="string"}e.isString=b;function t(n){return Array.isArray(n)&&n.every(r=>b(r))}e.isStringArray=t;function k(n){return typeof n=="object"&&n!==null&&!Array.isArray(n)&&!(n instanceof RegExp)&&!(n instanceof Date)}e.isObject=k;function S(n){const r=Object.getPrototypeOf(Uint8Array);return typeof n=="object"&&n instanceof r}e.isTypedArray=S;function I(n){return typeof n=="number"&&!isNaN(n)}e.isNumber=I;function A(n){return!!n&&typeof n[Symbol.iterator]=="function"}e.isIterable=A;function E(n){return n===!0||n===!1}e.isBoolean=E;function y(n){return typeof n>"u"}e.isUndefined=y;function D(n){return!T(n)}e.isDefined=D;function T(n){return y(n)||n===null}e.isUndefinedOrNull=T;function C(n,r){if(!n)throw new Error(r?`Unexpected type, expected '${r}'`:"Unexpected type")}e.assertType=C;function w(n){if(T(n))throw new Error("Assertion Failed: argument is undefined or null");return n}e.assertIsDefined=w;function m(...n){const r=[];for(let o=0;o<n.length;o++){const a=n[o];if(T(a))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);r.push(a)}return r}e.assertAllDefined=m;const g=Object.prototype.hasOwnProperty;function p(n){if(!k(n))return!1;for(const r in n)if(g.call(n,r))return!1;return!0}e.isEmptyObject=p;function d(n){return typeof n=="function"}e.isFunction=d;function v(...n){return n.length>0&&n.every(d)}e.areFunctions=v;function c(n,r){const o=Math.min(n.length,r.length);for(let a=0;a<o;a++)h(n[a],r[a])}e.validateConstraints=c;function h(n,r){if(b(r)){if(typeof n!==r)throw new Error(`argument does not match constraint: typeof ${r}`)}else if(d(r)){try{if(n instanceof r)return}catch{}if(!T(n)&&n.constructor===r||r.length===1&&r.call(void 0,n)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=h;function f(n){return n===null?void 0:n}e.withNullAsUndefined=f;function i(n){return typeof n>"u"?null:n}e.withUndefinedAsNull=i}),define(ve[23],be([1,0,11]),function(ie,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const v=Array.isArray(d)?[]:{};return Object.entries(d).forEach(([c,h])=>{v[c]=h&&typeof h=="object"?t(h):h}),v}e.deepClone=t;function k(d){if(!d||typeof d!="object")return d;const v=[d];for(;v.length>0;){const c=v.shift();Object.freeze(c);for(const h in c)if(S.call(c,h)){const f=c[h];typeof f=="object"&&!Object.isFrozen(f)&&!(0,b.isTypedArray)(f)&&v.push(f)}}return d}e.deepFreeze=k;const S=Object.prototype.hasOwnProperty;function I(d,v){return A(d,v,new Set)}e.cloneAndChange=I;function A(d,v,c){if((0,b.isUndefinedOrNull)(d))return d;const h=v(d);if(typeof h<"u")return h;if(Array.isArray(d)){const f=[];for(const i of d)f.push(A(i,v,c));return f}if((0,b.isObject)(d)){if(c.has(d))throw new Error("Cannot clone recursive data-structure");c.add(d);const f={};for(const i in d)S.call(d,i)&&(f[i]=A(d[i],v,c));return c.delete(d),f}return d}function E(d,v,c=!0){return(0,b.isObject)(d)?((0,b.isObject)(v)&&Object.keys(v).forEach(h=>{h in d?c&&((0,b.isObject)(d[h])&&(0,b.isObject)(v[h])?E(d[h],v[h],c):d[h]=v[h]):d[h]=v[h]}),d):v}e.mixin=E;function y(d,v){if(d===v)return!0;if(d==null||v===null||v===void 0||typeof d!=typeof v||typeof d!="object"||Array.isArray(d)!==Array.isArray(v))return!1;let c,h;if(Array.isArray(d)){if(d.length!==v.length)return!1;for(c=0;c<d.length;c++)if(!y(d[c],v[c]))return!1}else{const f=[];for(h in d)f.push(h);f.sort();const i=[];for(h in v)i.push(h);if(i.sort(),!y(f,i))return!1;for(c=0;c<f.length;c++)if(!y(d[f[c]],v[f[c]]))return!1}return!0}e.equals=y;function D(d){const v=new Set;return JSON.stringify(d,(c,h)=>{if((0,b.isObject)(h)||Array.isArray(h)){if(v.has(h))return"[Circular]";v.add(h)}return h})}e.safeStringify=D;function T(d,v){const c=Object.create(null);return!d||!v||Object.keys(v).forEach(f=>{const i=d[f],n=v[f];y(i,n)||(c[f]=n)}),c}e.distinct=T;function C(d,v){const c=v.toLowerCase(),h=Object.keys(d).find(f=>f.toLowerCase()===c);return h?d[h]:d[v]}e.getCaseInsensitive=C;function w(d,v){const c=Object.create(null);for(const[h,f]of Object.entries(d))v(h,f)&&(c[h]=f);return c}e.filter=w;function m(d){let v=[],c=Object.getPrototypeOf(d);for(;Object.prototype!==c;)v=v.concat(Object.getOwnPropertyNames(c)),c=Object.getPrototypeOf(c);return v}e.getAllPropertyNames=m;function g(d){const v=[];for(const c of m(d))typeof d[c]=="function"&&v.push(c);return v}e.getAllMethodNames=g;function p(d,v){const c=f=>function(){const i=Array.prototype.slice.call(arguments,0);return v(f,i)},h={};for(const f of d)h[f]=c(f);return h}e.createProxyObject=p}),define(ve[22],be([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const b=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(k){return b.test(k)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(A){for(let E=0;E<A.length;E++)A[E]=Math.floor(Math.random()*256);return A};const S=new Uint8Array(16),I=[];for(let A=0;A<256;A++)I.push(A.toString(16).padStart(2,"0"));return function(){k(S),S[6]=S[6]&15|64,S[8]=S[8]&63|128;let E=0,y="";return y+=I[S[E++]],y+=I[S[E++]],y+=I[S[E++]],y+=I[S[E++]],y+="-",y+=I[S[E++]],y+=I[S[E++]],y+="-",y+=I[S[E++]],y+=I[S[E++]],y+="-",y+=I[S[E++]],y+=I[S[E++]],y+="-",y+=I[S[E++]],y+=I[S[E++]],y+=I[S[E++]],y+=I[S[E++]],y+=I[S[E++]],y+=I[S[E++]],y}}()}),define(ve[139],be([1,0,18,22]),function(ie,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function k(A){return{id:(0,t.generateUuid)(),asString:async()=>A,asFile:()=>{},value:typeof A=="string"?A:void 0}}e.createStringDataTransferItem=k;function S(A,E,y){return{id:(0,t.generateUuid)(),asString:async()=>"",asFile:()=>({name:A,uri:E,data:y}),value:void 0}}e.createFileDataTransferItem=S;class I{constructor(){this.a=new Map}get size(){return this.a.size}has(E){return this.a.has(this.b(E))}get(E){return this.a.get(this.b(E))?.[0]}append(E,y){const D=this.a.get(E);D?D.push(y):this.a.set(this.b(E),[y])}replace(E,y){this.a.set(this.b(E),[y])}delete(E){this.a.delete(this.b(E))}*entries(){for(const[E,y]of this.a.entries())for(const D of y)yield[E,D]}values(){return Array.from(this.a.values()).flat()}forEach(E){for(const[y,D]of this.entries())E(D,y)}b(E){return E.toLowerCase()}}e.VSDataTransfer=I,e.UriList=Object.freeze({create:A=>(0,b.distinct)(A.map(E=>E.toString())).join(`\r
`),split:A=>A.split(`\r
`),parse:A=>e.UriList.split(A).filter(E=>!E.startsWith("#"))})}),function(){"use strict";function ie(e,b,t){function k(w){return new Promise(m=>b.exists(w,m))}function S(w){return new Promise((m,g)=>{const p=new Date;b.utimes(w,p,p,d=>d?g(d):m())})}function I(w){return new Promise((m,g)=>b.mkdir(w,{recursive:!0},p=>p&&p.code!=="EEXIST"?g(p):m(w)))}function A(w){return new Promise((m,g)=>b.rm(w,{recursive:!0,force:!0,maxRetries:3},p=>p?g(p):m()))}function E(w){return new Promise((m,g)=>b.readFile(w,"utf8",(p,d)=>p?g(p):m(d)))}function y(w,m){return new Promise((g,p)=>b.writeFile(w,m,"utf8",d=>d?p(d):g()))}async function D(w){const m=e.join(w,"languagepacks.json");try{return JSON.parse(await E(m))}catch{}}function T(w,m){try{for(;m;){if(w[m])return m;{const g=m.lastIndexOf("-");if(g>0)m=m.substring(0,g);else return}}}catch(g){console.error("Resolving language pack configuration failed.",g)}}function C(w,m,g,p){if(p==="pseudo")return Promise.resolve({locale:p,availableLanguages:{},pseudo:!0});if(process.env.VSCODE_DEV)return Promise.resolve({locale:p,availableLanguages:{}});if(p&&(p==="en"||p==="en-us"))return Promise.resolve({locale:p,availableLanguages:{}});const d=p;t.mark("code/willGenerateNls");const v=function(c){return t.mark("code/didGenerateNls"),Promise.resolve({locale:c,availableLanguages:{}})};try{return w?D(m).then(c=>{if(!c||(p=T(c,p),!p))return v(d);const h=c[p];let f;return!h||typeof h.hash!="string"||!h.translations||typeof(f=h.translations.vscode)!="string"?v(d):k(f).then(i=>{if(!i)return v(d);const n=h.hash+"."+p,r=e.join(m,"clp",n),o=e.join(r,w),a=e.join(r,"tcf.json"),l=e.join(r,"corrupted.info"),s={locale:d,availableLanguages:{"*":p},_languagePackId:n,_translationsConfigFile:a,_cacheRoot:r,_resolvedLanguagePackCoreLocation:o,_corruptedFile:l};return k(l).then(u=>{let P;return u?P=A(r):P=Promise.resolve(void 0),P.then(()=>k(o).then(F=>F?(S(o).catch(()=>{}),t.mark("code/didGenerateNls"),s):I(o).then(()=>Promise.all([E(g),E(f)])).then(K=>{const ne=JSON.parse(K[0]),ue=JSON.parse(K[1]).contents,se=Object.keys(ne.bundles),U=[];for(const Q of se){const z=ne.bundles[Q],G=Object.create(null);for(const X of z){const ce=ne.keys[X],L=ne.messages[X],N=ue[X];let V;if(N){V=[];for(let ee=0;ee<ce.length;ee++){const oe=ce[ee],ge=typeof oe=="string"?oe:oe.key;let fe=N[ge];fe===void 0&&(fe=L[ee]),V.push(fe)}}else V=L;G[X]=V}U.push(y(e.join(o,Q.replace(/\//g,"!")+".nls.json"),JSON.stringify(G)))}return U.push(y(a,JSON.stringify(h.translations))),Promise.all(U)}).then(()=>(t.mark("code/didGenerateNls"),s)).catch(K=>(console.error("Generating translation files failed.",K),v(p)))))})})}):v(d)}catch(c){return console.error("Generating translation files failed.",c),v(p)}}return{getNLSConfiguration:C}}if(typeof define=="function")define(ve[140],be([88,29,45]),function(e,b,t){return ie(e,b,t)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),b=require("fs"),t=require("../common/performance");module.exports=ie(e,b,t)}else throw new Error("Unknown context")}(),define(ve[141],be([1,0,30]),function(ie,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const t=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(I){const A=I.replace(/\-/g,":").toLowerCase();return!t.has(A)}function S(){const I=(0,b.networkInterfaces)();for(const A in I){const E=I[A];if(E){for(const{mac:y}of E)if(k(y))return y}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=S}),define(ve[142],be([1,0,89]),function(ie,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function t(A,E,y,D=1){let T=!1;return new Promise(C=>{const w=setTimeout(()=>{if(!T)return T=!0,C(0)},y);k(A,E,D,m=>{if(!T)return T=!0,clearTimeout(w),C(m)})})}e.findFreePort=t;function k(A,E,y,D){if(E===0)return D(0);const T=new b.Socket;T.once("connect",()=>(I(T),k(A+y,E-1,y,D))),T.once("data",()=>{}),T.once("error",C=>(I(T),C.code!=="ECONNREFUSED"?k(A+y,E-1,y,D):D(A))),T.connect(A,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function S(A,E,y,D="127.0.0.1"){let T=!1,C,w=1;const m=b.createServer({pauseOnConnect:!0});function g(p,d){T||(T=!0,m.removeAllListeners(),m.close(),C&&clearTimeout(C),d(p))}return new Promise(p=>{C=setTimeout(()=>{g(0,p)},y),m.on("listening",()=>{g(A,p)}),m.on("error",d=>{d&&(d.code==="EADDRINUSE"||d.code==="EACCES")&&w<E?(A++,w++,m.listen(A,D)):g(0,p)}),m.on("close",()=>{g(0,p)}),m.listen(A,D)})}e.findFreePortFaster=S;function I(A){try{A.removeAllListeners("connect"),A.removeAllListeners("error"),A.end(),A.destroy(),A.unref()}catch(E){console.error(E)}}}),define(ve[90],be([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class b{constructor(k,S){this.lineNumber=k,this.column=S}with(k=this.lineNumber,S=this.column){return k===this.lineNumber&&S===this.column?this:new b(k,S)}delta(k=0,S=0){return this.with(this.lineNumber+k,this.column+S)}equals(k){return b.equals(this,k)}static equals(k,S){return!k&&!S?!0:!!k&&!!S&&k.lineNumber===S.lineNumber&&k.column===S.column}isBefore(k){return b.isBefore(this,k)}static isBefore(k,S){return k.lineNumber<S.lineNumber?!0:S.lineNumber<k.lineNumber?!1:k.column<S.column}isBeforeOrEqual(k){return b.isBeforeOrEqual(this,k)}static isBeforeOrEqual(k,S){return k.lineNumber<S.lineNumber?!0:S.lineNumber<k.lineNumber?!1:k.column<=S.column}static compare(k,S){const I=k.lineNumber|0,A=S.lineNumber|0;if(I===A){const E=k.column|0,y=S.column|0;return E-y}return I-A}clone(){return new b(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(k){return new b(k.lineNumber,k.column)}static isIPosition(k){return k&&typeof k.lineNumber=="number"&&typeof k.column=="number"}}e.Position=b}),define(ve[46],be([1,0,90]),function(ie,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class t{constructor(S,I,A,E){S>A||S===A&&I>E?(this.startLineNumber=A,this.startColumn=E,this.endLineNumber=S,this.endColumn=I):(this.startLineNumber=S,this.startColumn=I,this.endLineNumber=A,this.endColumn=E)}isEmpty(){return t.isEmpty(this)}static isEmpty(S){return S.startLineNumber===S.endLineNumber&&S.startColumn===S.endColumn}containsPosition(S){return t.containsPosition(this,S)}static containsPosition(S,I){return!(I.lineNumber<S.startLineNumber||I.lineNumber>S.endLineNumber||I.lineNumber===S.startLineNumber&&I.column<S.startColumn||I.lineNumber===S.endLineNumber&&I.column>S.endColumn)}static strictContainsPosition(S,I){return!(I.lineNumber<S.startLineNumber||I.lineNumber>S.endLineNumber||I.lineNumber===S.startLineNumber&&I.column<=S.startColumn||I.lineNumber===S.endLineNumber&&I.column>=S.endColumn)}containsRange(S){return t.containsRange(this,S)}static containsRange(S,I){return!(I.startLineNumber<S.startLineNumber||I.endLineNumber<S.startLineNumber||I.startLineNumber>S.endLineNumber||I.endLineNumber>S.endLineNumber||I.startLineNumber===S.startLineNumber&&I.startColumn<S.startColumn||I.endLineNumber===S.endLineNumber&&I.endColumn>S.endColumn)}strictContainsRange(S){return t.strictContainsRange(this,S)}static strictContainsRange(S,I){return!(I.startLineNumber<S.startLineNumber||I.endLineNumber<S.startLineNumber||I.startLineNumber>S.endLineNumber||I.endLineNumber>S.endLineNumber||I.startLineNumber===S.startLineNumber&&I.startColumn<=S.startColumn||I.endLineNumber===S.endLineNumber&&I.endColumn>=S.endColumn)}plusRange(S){return t.plusRange(this,S)}static plusRange(S,I){let A,E,y,D;return I.startLineNumber<S.startLineNumber?(A=I.startLineNumber,E=I.startColumn):I.startLineNumber===S.startLineNumber?(A=I.startLineNumber,E=Math.min(I.startColumn,S.startColumn)):(A=S.startLineNumber,E=S.startColumn),I.endLineNumber>S.endLineNumber?(y=I.endLineNumber,D=I.endColumn):I.endLineNumber===S.endLineNumber?(y=I.endLineNumber,D=Math.max(I.endColumn,S.endColumn)):(y=S.endLineNumber,D=S.endColumn),new t(A,E,y,D)}intersectRanges(S){return t.intersectRanges(this,S)}static intersectRanges(S,I){let A=S.startLineNumber,E=S.startColumn,y=S.endLineNumber,D=S.endColumn;const T=I.startLineNumber,C=I.startColumn,w=I.endLineNumber,m=I.endColumn;return A<T?(A=T,E=C):A===T&&(E=Math.max(E,C)),y>w?(y=w,D=m):y===w&&(D=Math.min(D,m)),A>y||A===y&&E>D?null:new t(A,E,y,D)}equalsRange(S){return t.equalsRange(this,S)}static equalsRange(S,I){return!S&&!I?!0:!!S&&!!I&&S.startLineNumber===I.startLineNumber&&S.startColumn===I.startColumn&&S.endLineNumber===I.endLineNumber&&S.endColumn===I.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(S){return new b.Position(S.endLineNumber,S.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(S){return new b.Position(S.startLineNumber,S.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(S,I){return new t(this.startLineNumber,this.startColumn,S,I)}setStartPosition(S,I){return new t(S,I,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}delta(S){return new t(this.startLineNumber+S,this.startColumn,this.endLineNumber+S,this.endColumn)}static collapseToStart(S){return new t(S.startLineNumber,S.startColumn,S.startLineNumber,S.startColumn)}static fromPositions(S,I=S){return new t(S.lineNumber,S.column,I.lineNumber,I.column)}static lift(S){return S?new t(S.startLineNumber,S.startColumn,S.endLineNumber,S.endColumn):null}static isIRange(S){return S&&typeof S.startLineNumber=="number"&&typeof S.startColumn=="number"&&typeof S.endLineNumber=="number"&&typeof S.endColumn=="number"}static areIntersectingOrTouching(S,I){return!(S.endLineNumber<I.startLineNumber||S.endLineNumber===I.startLineNumber&&S.endColumn<I.startColumn||I.endLineNumber<S.startLineNumber||I.endLineNumber===S.startLineNumber&&I.endColumn<S.startColumn)}static areIntersecting(S,I){return!(S.endLineNumber<I.startLineNumber||S.endLineNumber===I.startLineNumber&&S.endColumn<=I.startColumn||I.endLineNumber<S.startLineNumber||I.endLineNumber===S.startLineNumber&&I.endColumn<=S.startColumn)}static compareRangesUsingStarts(S,I){if(S&&I){const y=S.startLineNumber|0,D=I.startLineNumber|0;if(y===D){const T=S.startColumn|0,C=I.startColumn|0;if(T===C){const w=S.endLineNumber|0,m=I.endLineNumber|0;if(w===m){const g=S.endColumn|0,p=I.endColumn|0;return g-p}return w-m}return T-C}return y-D}return(S?1:0)-(I?1:0)}static compareRangesUsingEnds(S,I){return S.endLineNumber===I.endLineNumber?S.endColumn===I.endColumn?S.startLineNumber===I.startLineNumber?S.startColumn-I.startColumn:S.startLineNumber-I.startLineNumber:S.endColumn-I.endColumn:S.endLineNumber-I.endLineNumber}static spansMultipleLines(S){return S.endLineNumber>S.startLineNumber}toJSON(){return this}}e.Range=t}),define(ve[143],be([9,10]),function(ie,e){return ie.create("vs/base/common/date",e)}),define(ve[144],be([1,0,143]),function(ie,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,k=t*60,S=k*24,I=S*7,A=S*30,E=S*365;function y(T,C,w){typeof T!="number"&&(T=T.getTime());const m=Math.round((new Date().getTime()-T)/1e3);if(m<-30)return(0,b.localize)(0,null,y(new Date().getTime()+m*1e3,!1));if(m<30)return(0,b.localize)(1,null);let g;return m<t?(g=m,C?g===1?w?(0,b.localize)(2,null,g):(0,b.localize)(3,null,g):w?(0,b.localize)(4,null,g):(0,b.localize)(5,null,g):g===1?w?(0,b.localize)(6,null,g):(0,b.localize)(7,null,g):w?(0,b.localize)(8,null,g):(0,b.localize)(9,null,g)):m<k?(g=Math.floor(m/t),C?g===1?w?(0,b.localize)(10,null,g):(0,b.localize)(11,null,g):w?(0,b.localize)(12,null,g):(0,b.localize)(13,null,g):g===1?w?(0,b.localize)(14,null,g):(0,b.localize)(15,null,g):w?(0,b.localize)(16,null,g):(0,b.localize)(17,null,g)):m<S?(g=Math.floor(m/k),C?g===1?w?(0,b.localize)(18,null,g):(0,b.localize)(19,null,g):w?(0,b.localize)(20,null,g):(0,b.localize)(21,null,g):g===1?w?(0,b.localize)(22,null,g):(0,b.localize)(23,null,g):w?(0,b.localize)(24,null,g):(0,b.localize)(25,null,g)):m<I?(g=Math.floor(m/S),C?g===1?(0,b.localize)(26,null,g):(0,b.localize)(27,null,g):g===1?(0,b.localize)(28,null,g):(0,b.localize)(29,null,g)):m<A?(g=Math.floor(m/I),C?g===1?w?(0,b.localize)(30,null,g):(0,b.localize)(31,null,g):w?(0,b.localize)(32,null,g):(0,b.localize)(33,null,g):g===1?w?(0,b.localize)(34,null,g):(0,b.localize)(35,null,g):w?(0,b.localize)(36,null,g):(0,b.localize)(37,null,g)):m<E?(g=Math.floor(m/A),C?g===1?w?(0,b.localize)(38,null,g):(0,b.localize)(39,null,g):w?(0,b.localize)(40,null,g):(0,b.localize)(41,null,g):g===1?w?(0,b.localize)(42,null,g):(0,b.localize)(43,null,g):w?(0,b.localize)(44,null,g):(0,b.localize)(45,null,g)):(g=Math.floor(m/E),C?g===1?w?(0,b.localize)(46,null,g):(0,b.localize)(47,null,g):w?(0,b.localize)(48,null,g):(0,b.localize)(49,null,g):g===1?w?(0,b.localize)(50,null,g):(0,b.localize)(51,null,g):w?(0,b.localize)(52,null,g):(0,b.localize)(53,null,g))}e.fromNow=y;function D(T){return T.getFullYear()+"-"+String(T.getMonth()+1).padStart(2,"0")+"-"+String(T.getDate()).padStart(2,"0")+"T"+String(T.getHours()).padStart(2,"0")+":"+String(T.getMinutes()).padStart(2,"0")+":"+String(T.getSeconds()).padStart(2,"0")+"."+(T.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=D}),define(ve[145],be([9,10]),function(ie,e){return ie.create("vs/base/common/errorMessage",e)}),define(ve[39],be([1,0,18,11,145]),function(ie,e,b,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function S(T,C){return C&&(T.stack||T.stacktrace)?k.localize(0,null,A(T),I(T.stack)||I(T.stacktrace)):A(T)}function I(T){return Array.isArray(T)?T.join(`
`):T}function A(T){return typeof T.code=="string"&&typeof T.errno=="number"&&typeof T.syscall=="string"?k.localize(1,null,T.message):T.message||k.localize(2,null)}function E(T=null,C=!1){if(!T)return k.localize(3,null);if(Array.isArray(T)){const w=b.coalesce(T),m=E(w[0],C);return w.length>1?k.localize(4,null,m,w.length):m}if(t.isString(T))return T;if(T.detail){const w=T.detail;if(w.error)return S(w.error,C);if(w.exception)return S(w.exception,C)}return T.stack?S(T,C):T.message?T.message:k.localize(5,null)}e.toErrorMessage=E;function y(T){const C=T;return C instanceof Error&&Array.isArray(C.actions)}e.isErrorWithActions=y;function D(T,C){let w;return typeof T=="string"?w=new Error(T):w=T,w.actions=C,w}e.createErrorWithActions=D}),define(ve[146],be([9,10]),function(ie,e){return ie.create("vs/base/common/jsonErrorMessages",e)}),define(ve[147],be([1,0,146]),function(ie,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function t(k){switch(k){case 1:return(0,b.localize)(0,null);case 2:return(0,b.localize)(1,null);case 3:return(0,b.localize)(2,null);case 4:return(0,b.localize)(3,null);case 5:return(0,b.localize)(4,null);case 6:return(0,b.localize)(5,null);case 7:return(0,b.localize)(6,null);case 8:return(0,b.localize)(7,null);case 9:return(0,b.localize)(8,null);default:return""}}e.getParseErrorMessage=t}),define(ve[148],be([9,10]),function(ie,e){return ie.create("vs/base/common/platform",e)}),define(ve[3],be([1,0,148]),function(ie,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let t=!1,k=!1,S=!1,I=!1,A=!1,E=!1,y=!1,D=!1,T=!1,C=!1,w,m=e.LANGUAGE_DEFAULT,g,p;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let d;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?d=e.globals.vscode.process:typeof process<"u"&&(d=process);const v=typeof d?.versions?.electron=="string",c=v&&d?.type==="renderer";if(typeof navigator=="object"&&!c)p=navigator.userAgent,t=p.indexOf("Windows")>=0,k=p.indexOf("Macintosh")>=0,D=(p.indexOf("Macintosh")>=0||p.indexOf("iPad")>=0||p.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,S=p.indexOf("Linux")>=0,C=p?.indexOf("Mobi")>=0,E=!0,w=b.getConfiguredDefaultLocale(b.localize(0,null))||e.LANGUAGE_DEFAULT,m=w;else if(typeof d=="object"){t=d.platform==="win32",k=d.platform==="darwin",S=d.platform==="linux",I=S&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,y=v,T=!!d.env.CI||!!d.env.BUILD_ARTIFACTSTAGINGDIRECTORY,w=e.LANGUAGE_DEFAULT,m=e.LANGUAGE_DEFAULT;const s=d.env.VSCODE_NLS_CONFIG;if(s)try{const u=JSON.parse(s),P=u.availableLanguages["*"];w=u.locale,m=P||e.LANGUAGE_DEFAULT,g=u._translationsConfigFile}catch{}A=!0}else console.error("Unable to resolve platform.");var h;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(h=e.Platform||(e.Platform={}));function f(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=f;let i=0;k?i=1:t?i=3:S&&(i=2),e.isWindows=t,e.isMacintosh=k,e.isLinux=S,e.isLinuxSnap=I,e.isNative=A,e.isElectron=y,e.isWeb=E,e.isWebWorker=E&&typeof e.globals.importScripts=="function",e.isIOS=D,e.isMobile=C,e.isCI=T,e.platform=i,e.userAgent=p,e.language=m;var n;(function(s){function u(){return e.language}s.value=u;function P(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=P;function F(){return e.language==="en"}s.isDefault=F})(n=e.Language||(e.Language={})),e.locale=w,e.translationsConfigFile=g,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const s=[];e.globals.addEventListener("message",P=>{if(P.data&&P.data.vscodeScheduleAsyncWork)for(let F=0,K=s.length;F<K;F++){const ne=s[F];if(ne.id===P.data.vscodeScheduleAsyncWork){s.splice(F,1),ne.callback();return}}});let u=0;return P=>{const F=++u;s.push({id:F,callback:P}),e.globals.postMessage({vscodeScheduleAsyncWork:F},"*")}}return s=>setTimeout(s)})();var r;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(r=e.OperatingSystem||(e.OperatingSystem={})),e.OS=k||D?2:t?1:3;let o=!0,a=!1;function l(){if(!a){a=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,o=new Uint16Array(s.buffer)[0]===(2<<8)+1}return o}e.isLittleEndian=l,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ve[27],be([1,0,3]),function(ie,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof b.globals.vscode<"u"&&typeof b.globals.vscode.process<"u"){const k=b.globals.vscode.process;t={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return b.isWindows?"win32":b.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(ve[7],be([1,0,27]),function(ie,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,k=97,S=90,I=122,A=46,E=47,y=92,D=58,T=63;class C extends Error{constructor(h,f,i){let n;typeof f=="string"&&f.indexOf("not ")===0?(n="must not be",f=f.replace(/^not /,"")):n="must be";const r=h.indexOf(".")!==-1?"property":"argument";let o=`The "${h}" ${r} ${n} of type ${f}`;o+=`. Received type ${typeof i}`,super(o),this.code="ERR_INVALID_ARG_TYPE"}}function w(c,h){if(typeof c!="string")throw new C(h,"string",c)}function m(c){return c===E||c===y}function g(c){return c===E}function p(c){return c>=t&&c<=S||c>=k&&c<=I}function d(c,h,f,i){let n="",r=0,o=-1,a=0,l=0;for(let s=0;s<=c.length;++s){if(s<c.length)l=c.charCodeAt(s);else{if(i(l))break;l=E}if(i(l)){if(!(o===s-1||a===1))if(a===2){if(n.length<2||r!==2||n.charCodeAt(n.length-1)!==A||n.charCodeAt(n.length-2)!==A){if(n.length>2){const u=n.lastIndexOf(f);u===-1?(n="",r=0):(n=n.slice(0,u),r=n.length-1-n.lastIndexOf(f)),o=s,a=0;continue}else if(n.length!==0){n="",r=0,o=s,a=0;continue}}h&&(n+=n.length>0?`${f}..`:"..",r=2)}else n.length>0?n+=`${f}${c.slice(o+1,s)}`:n=c.slice(o+1,s),r=s-o-1;o=s,a=0}else l===A&&a!==-1?++a:a=-1}return n}function v(c,h){if(h===null||typeof h!="object")throw new C("pathObject","Object",h);const f=h.dir||h.root,i=h.base||`${h.name||""}${h.ext||""}`;return f?f===h.root?`${f}${i}`:`${f}${c}${i}`:i}e.win32={resolve(...c){let h="",f="",i=!1;for(let n=c.length-1;n>=-1;n--){let r;if(n>=0){if(r=c[n],w(r,"path"),r.length===0)continue}else h.length===0?r=b.cwd():(r=b.env[`=${h}`]||b.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==h.toLowerCase()&&r.charCodeAt(2)===y)&&(r=`${h}\\`));const o=r.length;let a=0,l="",s=!1;const u=r.charCodeAt(0);if(o===1)m(u)&&(a=1,s=!0);else if(m(u))if(s=!0,m(r.charCodeAt(1))){let P=2,F=P;for(;P<o&&!m(r.charCodeAt(P));)P++;if(P<o&&P!==F){const K=r.slice(F,P);for(F=P;P<o&&m(r.charCodeAt(P));)P++;if(P<o&&P!==F){for(F=P;P<o&&!m(r.charCodeAt(P));)P++;(P===o||P!==F)&&(l=`\\\\${K}\\${r.slice(F,P)}`,a=P)}}}else a=1;else p(u)&&r.charCodeAt(1)===D&&(l=r.slice(0,2),a=2,o>2&&m(r.charCodeAt(2))&&(s=!0,a=3));if(l.length>0)if(h.length>0){if(l.toLowerCase()!==h.toLowerCase())continue}else h=l;if(i){if(h.length>0)break}else if(f=`${r.slice(a)}\\${f}`,i=s,s&&h.length>0)break}return f=d(f,!i,"\\",m),i?`${h}\\${f}`:`${h}${f}`||"."},normalize(c){w(c,"path");const h=c.length;if(h===0)return".";let f=0,i,n=!1;const r=c.charCodeAt(0);if(h===1)return g(r)?"\\":c;if(m(r))if(n=!0,m(c.charCodeAt(1))){let a=2,l=a;for(;a<h&&!m(c.charCodeAt(a));)a++;if(a<h&&a!==l){const s=c.slice(l,a);for(l=a;a<h&&m(c.charCodeAt(a));)a++;if(a<h&&a!==l){for(l=a;a<h&&!m(c.charCodeAt(a));)a++;if(a===h)return`\\\\${s}\\${c.slice(l)}\\`;a!==l&&(i=`\\\\${s}\\${c.slice(l,a)}`,f=a)}}}else f=1;else p(r)&&c.charCodeAt(1)===D&&(i=c.slice(0,2),f=2,h>2&&m(c.charCodeAt(2))&&(n=!0,f=3));let o=f<h?d(c.slice(f),!n,"\\",m):"";return o.length===0&&!n&&(o="."),o.length>0&&m(c.charCodeAt(h-1))&&(o+="\\"),i===void 0?n?`\\${o}`:o:n?`${i}\\${o}`:`${i}${o}`},isAbsolute(c){w(c,"path");const h=c.length;if(h===0)return!1;const f=c.charCodeAt(0);return m(f)||h>2&&p(f)&&c.charCodeAt(1)===D&&m(c.charCodeAt(2))},join(...c){if(c.length===0)return".";let h,f;for(let r=0;r<c.length;++r){const o=c[r];w(o,"path"),o.length>0&&(h===void 0?h=f=o:h+=`\\${o}`)}if(h===void 0)return".";let i=!0,n=0;if(typeof f=="string"&&m(f.charCodeAt(0))){++n;const r=f.length;r>1&&m(f.charCodeAt(1))&&(++n,r>2&&(m(f.charCodeAt(2))?++n:i=!1))}if(i){for(;n<h.length&&m(h.charCodeAt(n));)n++;n>=2&&(h=`\\${h.slice(n)}`)}return e.win32.normalize(h)},relative(c,h){if(w(c,"from"),w(h,"to"),c===h)return"";const f=e.win32.resolve(c),i=e.win32.resolve(h);if(f===i||(c=f.toLowerCase(),h=i.toLowerCase(),c===h))return"";let n=0;for(;n<c.length&&c.charCodeAt(n)===y;)n++;let r=c.length;for(;r-1>n&&c.charCodeAt(r-1)===y;)r--;const o=r-n;let a=0;for(;a<h.length&&h.charCodeAt(a)===y;)a++;let l=h.length;for(;l-1>a&&h.charCodeAt(l-1)===y;)l--;const s=l-a,u=o<s?o:s;let P=-1,F=0;for(;F<u;F++){const ne=c.charCodeAt(n+F);if(ne!==h.charCodeAt(a+F))break;ne===y&&(P=F)}if(F!==u){if(P===-1)return i}else{if(s>u){if(h.charCodeAt(a+F)===y)return i.slice(a+F+1);if(F===2)return i.slice(a+F)}o>u&&(c.charCodeAt(n+F)===y?P=F:F===2&&(P=3)),P===-1&&(P=0)}let K="";for(F=n+P+1;F<=r;++F)(F===r||c.charCodeAt(F)===y)&&(K+=K.length===0?"..":"\\..");return a+=P,K.length>0?`${K}${i.slice(a,l)}`:(i.charCodeAt(a)===y&&++a,i.slice(a,l))},toNamespacedPath(c){if(typeof c!="string")return c;if(c.length===0)return"";const h=e.win32.resolve(c);if(h.length<=2)return c;if(h.charCodeAt(0)===y){if(h.charCodeAt(1)===y){const f=h.charCodeAt(2);if(f!==T&&f!==A)return`\\\\?\\UNC\\${h.slice(2)}`}}else if(p(h.charCodeAt(0))&&h.charCodeAt(1)===D&&h.charCodeAt(2)===y)return`\\\\?\\${h}`;return c},dirname(c){w(c,"path");const h=c.length;if(h===0)return".";let f=-1,i=0;const n=c.charCodeAt(0);if(h===1)return m(n)?c:".";if(m(n)){if(f=i=1,m(c.charCodeAt(1))){let a=2,l=a;for(;a<h&&!m(c.charCodeAt(a));)a++;if(a<h&&a!==l){for(l=a;a<h&&m(c.charCodeAt(a));)a++;if(a<h&&a!==l){for(l=a;a<h&&!m(c.charCodeAt(a));)a++;if(a===h)return c;a!==l&&(f=i=a+1)}}}}else p(n)&&c.charCodeAt(1)===D&&(f=h>2&&m(c.charCodeAt(2))?3:2,i=f);let r=-1,o=!0;for(let a=h-1;a>=i;--a)if(m(c.charCodeAt(a))){if(!o){r=a;break}}else o=!1;if(r===-1){if(f===-1)return".";r=f}return c.slice(0,r)},basename(c,h){h!==void 0&&w(h,"ext"),w(c,"path");let f=0,i=-1,n=!0,r;if(c.length>=2&&p(c.charCodeAt(0))&&c.charCodeAt(1)===D&&(f=2),h!==void 0&&h.length>0&&h.length<=c.length){if(h===c)return"";let o=h.length-1,a=-1;for(r=c.length-1;r>=f;--r){const l=c.charCodeAt(r);if(m(l)){if(!n){f=r+1;break}}else a===-1&&(n=!1,a=r+1),o>=0&&(l===h.charCodeAt(o)?--o===-1&&(i=r):(o=-1,i=a))}return f===i?i=a:i===-1&&(i=c.length),c.slice(f,i)}for(r=c.length-1;r>=f;--r)if(m(c.charCodeAt(r))){if(!n){f=r+1;break}}else i===-1&&(n=!1,i=r+1);return i===-1?"":c.slice(f,i)},extname(c){w(c,"path");let h=0,f=-1,i=0,n=-1,r=!0,o=0;c.length>=2&&c.charCodeAt(1)===D&&p(c.charCodeAt(0))&&(h=i=2);for(let a=c.length-1;a>=h;--a){const l=c.charCodeAt(a);if(m(l)){if(!r){i=a+1;break}continue}n===-1&&(r=!1,n=a+1),l===A?f===-1?f=a:o!==1&&(o=1):f!==-1&&(o=-1)}return f===-1||n===-1||o===0||o===1&&f===n-1&&f===i+1?"":c.slice(f,n)},format:v.bind(null,"\\"),parse(c){w(c,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return h;const f=c.length;let i=0,n=c.charCodeAt(0);if(f===1)return m(n)?(h.root=h.dir=c,h):(h.base=h.name=c,h);if(m(n)){if(i=1,m(c.charCodeAt(1))){let P=2,F=P;for(;P<f&&!m(c.charCodeAt(P));)P++;if(P<f&&P!==F){for(F=P;P<f&&m(c.charCodeAt(P));)P++;if(P<f&&P!==F){for(F=P;P<f&&!m(c.charCodeAt(P));)P++;P===f?i=P:P!==F&&(i=P+1)}}}}else if(p(n)&&c.charCodeAt(1)===D){if(f<=2)return h.root=h.dir=c,h;if(i=2,m(c.charCodeAt(2))){if(f===3)return h.root=h.dir=c,h;i=3}}i>0&&(h.root=c.slice(0,i));let r=-1,o=i,a=-1,l=!0,s=c.length-1,u=0;for(;s>=i;--s){if(n=c.charCodeAt(s),m(n)){if(!l){o=s+1;break}continue}a===-1&&(l=!1,a=s+1),n===A?r===-1?r=s:u!==1&&(u=1):r!==-1&&(u=-1)}return a!==-1&&(r===-1||u===0||u===1&&r===a-1&&r===o+1?h.base=h.name=c.slice(o,a):(h.name=c.slice(o,r),h.base=c.slice(o,a),h.ext=c.slice(r,a))),o>0&&o!==i?h.dir=c.slice(0,o-1):h.dir=h.root,h},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...c){let h="",f=!1;for(let i=c.length-1;i>=-1&&!f;i--){const n=i>=0?c[i]:b.cwd();w(n,"path"),n.length!==0&&(h=`${n}/${h}`,f=n.charCodeAt(0)===E)}return h=d(h,!f,"/",g),f?`/${h}`:h.length>0?h:"."},normalize(c){if(w(c,"path"),c.length===0)return".";const h=c.charCodeAt(0)===E,f=c.charCodeAt(c.length-1)===E;return c=d(c,!h,"/",g),c.length===0?h?"/":f?"./":".":(f&&(c+="/"),h?`/${c}`:c)},isAbsolute(c){return w(c,"path"),c.length>0&&c.charCodeAt(0)===E},join(...c){if(c.length===0)return".";let h;for(let f=0;f<c.length;++f){const i=c[f];w(i,"path"),i.length>0&&(h===void 0?h=i:h+=`/${i}`)}return h===void 0?".":e.posix.normalize(h)},relative(c,h){if(w(c,"from"),w(h,"to"),c===h||(c=e.posix.resolve(c),h=e.posix.resolve(h),c===h))return"";const f=1,i=c.length,n=i-f,r=1,o=h.length-r,a=n<o?n:o;let l=-1,s=0;for(;s<a;s++){const P=c.charCodeAt(f+s);if(P!==h.charCodeAt(r+s))break;P===E&&(l=s)}if(s===a)if(o>a){if(h.charCodeAt(r+s)===E)return h.slice(r+s+1);if(s===0)return h.slice(r+s)}else n>a&&(c.charCodeAt(f+s)===E?l=s:s===0&&(l=0));let u="";for(s=f+l+1;s<=i;++s)(s===i||c.charCodeAt(s)===E)&&(u+=u.length===0?"..":"/..");return`${u}${h.slice(r+l)}`},toNamespacedPath(c){return c},dirname(c){if(w(c,"path"),c.length===0)return".";const h=c.charCodeAt(0)===E;let f=-1,i=!0;for(let n=c.length-1;n>=1;--n)if(c.charCodeAt(n)===E){if(!i){f=n;break}}else i=!1;return f===-1?h?"/":".":h&&f===1?"//":c.slice(0,f)},basename(c,h){h!==void 0&&w(h,"ext"),w(c,"path");let f=0,i=-1,n=!0,r;if(h!==void 0&&h.length>0&&h.length<=c.length){if(h===c)return"";let o=h.length-1,a=-1;for(r=c.length-1;r>=0;--r){const l=c.charCodeAt(r);if(l===E){if(!n){f=r+1;break}}else a===-1&&(n=!1,a=r+1),o>=0&&(l===h.charCodeAt(o)?--o===-1&&(i=r):(o=-1,i=a))}return f===i?i=a:i===-1&&(i=c.length),c.slice(f,i)}for(r=c.length-1;r>=0;--r)if(c.charCodeAt(r)===E){if(!n){f=r+1;break}}else i===-1&&(n=!1,i=r+1);return i===-1?"":c.slice(f,i)},extname(c){w(c,"path");let h=-1,f=0,i=-1,n=!0,r=0;for(let o=c.length-1;o>=0;--o){const a=c.charCodeAt(o);if(a===E){if(!n){f=o+1;break}continue}i===-1&&(n=!1,i=o+1),a===A?h===-1?h=o:r!==1&&(r=1):h!==-1&&(r=-1)}return h===-1||i===-1||r===0||r===1&&h===i-1&&h===f+1?"":c.slice(h,i)},format:v.bind(null,"/"),parse(c){w(c,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return h;const f=c.charCodeAt(0)===E;let i;f?(h.root="/",i=1):i=0;let n=-1,r=0,o=-1,a=!0,l=c.length-1,s=0;for(;l>=i;--l){const u=c.charCodeAt(l);if(u===E){if(!a){r=l+1;break}continue}o===-1&&(a=!1,o=l+1),u===A?n===-1?n=l:s!==1&&(s=1):n!==-1&&(s=-1)}if(o!==-1){const u=r===0&&f?1:r;n===-1||s===0||s===1&&n===o-1&&n===r+1?h.base=h.name=c.slice(u,o):(h.name=c.slice(u,n),h.base=c.slice(u,o),h.ext=c.slice(n,o))}return r>0?h.dir=c.slice(0,r-1):f&&(h.dir="/"),h},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=b.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=b.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=b.platform==="win32"?e.win32.join:e.posix.join,e.resolve=b.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=b.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=b.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=b.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=b.platform==="win32"?e.win32.extname:e.posix.extname,e.format=b.platform==="win32"?e.win32.format:e.posix.format,e.parse=b.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=b.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=b.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=b.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ve[56],be([1,0,7]),function(ie,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const t={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},k={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function S(D){const T=(0,b.extname)(D),C=t[T.toLowerCase()];return C!==void 0?C:I(D)}e.getMediaOrTextMime=S;function I(D){const T=(0,b.extname)(D);return k[T.toLowerCase()]}e.getMediaMime=I;function A(D){for(const T in k)if(k[T]===D)return T}e.getExtensionForMimeType=A;const E=/^(.+)\/(.+?)(;.+)?$/;function y(D,T){const C=E.exec(D);return C?`${C[1].toLowerCase()}/${C[2].toLowerCase()}${C[3]??""}`:T?void 0:D}e.normalizeMimeType=y}),define(ve[57],be([1,0,3]),function(ie,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(A){A[A.stdout=0]="stdout",A[A.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var k;(function(A){A[A.Success=0]="Success",A[A.Unknown=1]="Unknown",A[A.AccessDenied=2]="AccessDenied",A[A.ProcessNotFound=3]="ProcessNotFound"})(k=e.TerminateResponseCode||(e.TerminateResponseCode={}));function S(A,...E){const y=E.reduce((C,w)=>(C[w]=!0,C),{}),D=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(A).filter(C=>!y[C]).forEach(C=>{for(let w=0;w<D.length;w++)if(C.search(D[w])!==-1){delete A[C];break}})}e.sanitizeProcessEnvironment=S;function I(A){!A||(delete A.DEBUG,b.isMacintosh&&delete A.DYLD_LIBRARY_PATH,b.isLinux&&delete A.LD_PRELOAD)}e.removeDangerousEnvVariables=I}),define(ve[149],be([1,0,3]),function(ie,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=b.globals.performance&&typeof b.globals.performance.now=="function";class k{static create(I=!0){return new k(I)}constructor(I){this.a=t&&I,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?b.globals.performance.now():Date.now()}}e.StopWatch=k}),define(ve[6],be([1,0,8,68,2,86,149]),function(ie,e,b,t,k,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const A=!1,E=!1;var y;(function(l){l.None=()=>k.Disposable.None;function s(Y){if(E){const{onDidAddListener:re}=Y,me=m.create();let $=0;Y.onDidAddListener=()=>{++$===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),me.print()),re?.()}}}function u(Y,re){return z(Y,()=>{},0,void 0,void 0,re)}l.defer=u;function P(Y){return(re,me=null,$)=>{let J=!1,_;return _=Y(j=>{if(!J)return _?_.dispose():J=!0,re.call(me,j)},null,$),J&&_.dispose(),_}}l.once=P;function F(Y,re,me){return Q(($,J=null,_)=>Y(j=>$.call(J,re(j)),null,_),me)}l.map=F;function K(Y,re,me){return Q(($,J=null,_)=>Y(j=>{re(j),$.call(J,j)},null,_),me)}l.forEach=K;function ne(Y,re,me){return Q(($,J=null,_)=>Y(j=>re(j)&&$.call(J,j),null,_),me)}l.filter=ne;function ue(Y){return Y}l.signal=ue;function se(...Y){return(re,me=null,$)=>(0,k.combinedDisposable)(...Y.map(J=>J(_=>re.call(me,_),null,$)))}l.any=se;function U(Y,re,me,$){let J=me;return F(Y,_=>(J=re(J,_),J),$)}l.reduce=U;function Q(Y,re){let me;const $={onWillAddFirstListener(){me=Y(J.fire,J)},onDidRemoveLastListener(){me?.dispose()}};re||s($);const J=new p($);return re?.add(J),J.event}function z(Y,re,me=100,$=!1,J,_){let j,H,q,Z=0;const ae={leakWarningThreshold:J,onWillAddFirstListener(){j=Y(ke=>{Z++,H=re(H,ke),$&&!q&&(we.fire(H),H=void 0),clearTimeout(q),q=setTimeout(()=>{const Ae=H;H=void 0,q=void 0,(!$||Z>1)&&we.fire(Ae),Z=0},me)})},onDidRemoveLastListener(){j.dispose()}};_||s(ae);const we=new p(ae);return _?.add(we),we.event}l.debounce=z;function G(Y,re=0,me){return l.debounce(Y,($,J)=>$?($.push(J),$):[J],re,void 0,void 0,me)}l.accumulate=G;function X(Y,re=($,J)=>$===J,me){let $=!0,J;return ne(Y,_=>{const j=$||!re(_,J);return $=!1,J=_,j},me)}l.latch=X;function ce(Y,re,me){return[l.filter(Y,re,me),l.filter(Y,$=>!re($),me)]}l.split=ce;function L(Y,re=!1,me=[]){let $=me.slice(),J=Y(H=>{$?$.push(H):j.fire(H)});const _=()=>{$?.forEach(H=>j.fire(H)),$=null},j=new p({onWillAddFirstListener(){J||(J=Y(H=>j.fire(H)))},onDidAddFirstListener(){$&&(re?setTimeout(_):_())},onDidRemoveLastListener(){J&&J.dispose(),J=null}});return j.event}l.buffer=L;class N{constructor(re){this.event=re,this.c=new k.DisposableStore}map(re){return new N(F(this.event,re,this.c))}forEach(re){return new N(K(this.event,re,this.c))}filter(re){return new N(ne(this.event,re,this.c))}reduce(re,me){return new N(U(this.event,re,me,this.c))}latch(){return new N(X(this.event,void 0,this.c))}debounce(re,me=100,$=!1,J){return new N(z(this.event,re,me,$,J,this.c))}on(re,me,$){return this.event(re,me,$)}once(re,me,$){return P(this.event)(re,me,$)}dispose(){this.c.dispose()}}function V(Y){return new N(Y)}l.chain=V;function ee(Y,re,me=$=>$){const $=(...H)=>j.fire(me(...H)),J=()=>Y.on(re,$),_=()=>Y.removeListener(re,$),j=new p({onWillAddFirstListener:J,onDidRemoveLastListener:_});return j.event}l.fromNodeEventEmitter=ee;function oe(Y,re,me=$=>$){const $=(...H)=>j.fire(me(...H)),J=()=>Y.addEventListener(re,$),_=()=>Y.removeEventListener(re,$),j=new p({onWillAddFirstListener:J,onDidRemoveLastListener:_});return j.event}l.fromDOMEventEmitter=oe;function ge(Y){return new Promise(re=>P(Y)(re))}l.toPromise=ge;function fe(Y,re){return re(void 0),Y(me=>re(me))}l.runAndSubscribe=fe;function R(Y,re){let me=null;function $(_){me?.dispose(),me=new k.DisposableStore,re(_,me)}$(void 0);const J=Y(_=>$(_));return(0,k.toDisposable)(()=>{J.dispose(),me?.dispose()})}l.runAndSubscribeWithStore=R;class M{constructor(re,me){this.obs=re,this.c=0,this.d=!1;const $={onWillAddFirstListener:()=>{re.addObserver(this)},onDidRemoveLastListener:()=>{re.removeObserver(this)}};me||s($),this.emitter=new p($),me&&me.add(this.emitter)}beginUpdate(re){this.c++}handleChange(re,me){this.d=!0}endUpdate(re){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function W(Y,re){return new M(Y,re).emitter.event}l.fromObservable=W})(y=e.Event||(e.Event={}));class D{constructor(s){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${s}_${D.c++}`,D.all.add(this)}start(s){this.d=new I.StopWatch(!0),this.listenerCount=s}stop(){if(this.d){const s=this.d.elapsed();this.durations.push(s),this.elapsedOverall+=s,this.invocationCount+=1,this.d=void 0}}}e.EventProfiling=D,D.all=new Set,D.c=0;let T=-1;function C(l){const s=T;return T=l,{dispose(){T=s}}}e.setGlobalLeakWarningThreshold=C;class w{constructor(s,u=Math.random().toString(18).slice(2,5)){this.threshold=s,this.name=u,this.d=0}dispose(){this.c?.clear()}check(s,u){const P=this.threshold;if(P<=0||u<P)return;this.c||(this.c=new Map);const F=this.c.get(s.value)||0;if(this.c.set(s.value,F+1),this.d-=1,this.d<=0){this.d=P*.5;let K,ne=0;for(const[ue,se]of this.c)(!K||ne<se)&&(K=ue,ne=se);console.warn(`[${this.name}] potential listener LEAK detected, having ${u} listeners already. MOST frequent listener (${ne}):`),console.warn(K)}return()=>{const K=this.c.get(s.value)||0;this.c.set(s.value,K-1)}}}class m{static create(){return new m(new Error().stack??"")}constructor(s){this.value=s}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class g{constructor(s,u,P){this.callback=s,this.callbackThis=u,this.stack=P,this.subscription=new k.SafeDisposable}invoke(s){this.callback.call(this.callbackThis,s)}}class p{constructor(s){this.j=!1,this.d=s,this.f=T>0||this.d?.leakWarningThreshold?new w(this.d?.leakWarningThreshold??T):void 0,this.g=this.d?._profName?new D(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(A){const s=Array.from(this.q);queueMicrotask(()=>{for(const u of s)u.subscription.isset()&&(u.subscription.unset(),u.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(s,u,P)=>{if(this.q||(this.q=new S.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),k.Disposable.None;const F=this.q.isEmpty();F&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let K,ne;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(ne=m.create(),K=this.f.check(ne,this.q.size+1)),A&&(ne=ne??m.create());const ue=new g(s,u,ne),se=this.q.push(ue);F&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,s,u);const U=ue.subscription.set(()=>{K?.(),this.j||(se(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return P instanceof k.DisposableStore?P.add(U):Array.isArray(P)&&P.push(U),U}),this.l}fire(s){if(this.q){this.m||(this.m=new v);for(const u of this.q)this.m.push(this,u,s);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=p;class d{constructor(){this.c=new S.LinkedList}get size(){return this.c.size}push(s,u,P){this.c.push(new c(s,u,P))}clear(s){const u=new S.LinkedList;for(const P of this.c)P.emitter!==s&&u.push(P);this.c=u}deliver(){for(;this.c.size>0;){const s=this.c.shift();try{s.listener.invoke(s.event)}catch(u){(0,b.onUnexpectedError)(u)}}}}e.EventDeliveryQueue=d;class v extends d{clear(s){this.c.clear()}}class c{constructor(s,u,P){this.emitter=s,this.listener=u,this.event=P}}class h extends p{async fireAsync(s,u,P){if(!!this.q){this.c||(this.c=new S.LinkedList);for(const F of this.q)this.c.push([F,s]);for(;this.c.size>0&&!u.isCancellationRequested;){const[F,K]=this.c.shift(),ne=[],ue={...K,token:u,waitUntil:se=>{if(Object.isFrozen(ne))throw new Error("waitUntil can NOT be called asynchronous");P&&(se=P(se,F.callback)),ne.push(se)}};try{F.invoke(ue)}catch(se){(0,b.onUnexpectedError)(se);continue}Object.freeze(ne),await Promise.allSettled(ne).then(se=>{for(const U of se)U.status==="rejected"&&(0,b.onUnexpectedError)(U.reason)})}}}}e.AsyncEmitter=h;class f extends p{constructor(s){super(s),this.h=0,this.s=new S.LinkedList,this.t=s?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const s=Array.from(this.s);this.s.clear(),super.fire(this.t(s))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(s){this.q&&(this.h!==0?this.s.push(s):super.fire(s))}}e.PauseableEmitter=f;class i extends f{constructor(s){super(s),this.c=s.delay??100}fire(s){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(s)}}e.DebounceEmitter=i;class n extends p{constructor(s){super(s),this.c=[],this.h=s?.merge}fire(s){!this.hasListeners()||(this.c.push(s),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(u=>super.fire(u)),this.c=[]}))}}e.MicrotaskEmitter=n;class r{constructor(){this.d=!1,this.f=[],this.c=new p({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(s){const u={event:s,listener:null};this.f.push(u),this.d&&this.j(u);const P=()=>{this.d&&this.k(u);const F=this.f.indexOf(u);this.f.splice(F,1)};return(0,k.toDisposable)((0,t.once)(P))}g(){this.d=!0,this.f.forEach(s=>this.j(s))}h(){this.d=!1,this.f.forEach(s=>this.k(s))}j(s){s.listener=s.event(u=>this.c.fire(u))}k(s){s.listener&&s.listener.dispose(),s.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=r;class o{constructor(){this.c=[]}wrapEvent(s){return(u,P,F)=>s(K=>{const ne=this.c[this.c.length-1];ne?ne.push(()=>u.call(P,K)):u.call(P,K)},void 0,F)}bufferEvents(s){const u=[];this.c.push(u);const P=s();return this.c.pop(),u.forEach(F=>F()),P}}e.EventBufferer=o;class a{constructor(){this.c=!1,this.d=y.None,this.f=k.Disposable.None,this.g=new p({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(s){this.d=s,this.c&&(this.f.dispose(),this.f=s(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=a}),define(ve[19],be([1,0,6]),function(ie,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(A,E){const y=setTimeout(A.bind(E),0);return{dispose(){clearTimeout(y)}}});var k;(function(A){function E(y){return y===A.None||y===A.Cancelled||y instanceof S?!0:!y||typeof y!="object"?!1:typeof y.isCancellationRequested=="boolean"&&typeof y.onCancellationRequested=="function"}A.isCancellationToken=E,A.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:b.Event.None}),A.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(k=e.CancellationToken||(e.CancellationToken={}));class S{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?t:(this.b||(this.b=new b.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class I{constructor(E){this.a=void 0,this.b=void 0,this.b=E&&E.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new S),this.a}cancel(){this.a?this.a instanceof S&&this.a.cancel():this.a=k.Cancelled}dispose(E=!1){E&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof S&&this.a.dispose():this.a=k.None}}e.CancellationTokenSource=I}),define(ve[150],be([1,0,19]),function(ie,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(A){this.b=A,this.a=null}get(){if(this.a)return this.a;const A=new b.CancellationTokenSource,E=this.b(A.token);return this.a={promise:E,dispose:()=>{this.a=null,A.cancel(),A.dispose()}},this.a}}e.Cache=t;class k{constructor(A){this.c=A,this.a=void 0,this.b=void 0}get(A){const E=JSON.stringify(A);return this.b!==E&&(this.b=E,this.a=this.c(A)),this.a}}e.LRUCachedFunction=k;class S{get cachedValues(){return this.a}constructor(A){this.b=A,this.a=new Map}get(A){if(this.a.has(A))return this.a.get(A);const E=this.b(A);return this.a.set(A,E),E}}e.CachedFunction=S}),define(ve[15],be([1,0,150,136]),function(ie,e,b,t){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function S(le){return!le||typeof le!="string"?!0:le.trim().length===0}e.isFalsyOrWhitespace=S;const I=/{(\d+)}/g;function A(le,...Ce){return Ce.length===0?le:le.replace(I,function(De,Te){const Ne=parseInt(Te,10);return isNaN(Ne)||Ne<0||Ne>=Ce.length?De:Ce[Ne]})}e.format=A;const E=/{([^}]+)}/g;function y(le,Ce){return le.replace(E,(De,Te)=>Ce[Te]??De)}e.format2=y;function D(le){return le.replace(/[<>&]/g,function(Ce){switch(Ce){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ce}})}e.escape=D;function T(le){return le.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=T;function C(le,Ce){let De=0;const Te=Ce.charCodeAt(0);for(let Ne=le.length-1;Ne>=0;Ne--)le.charCodeAt(Ne)===Te&&De++;return De}e.count=C;function w(le,Ce,De="\u2026"){return le.length<=Ce?le:`${le.substr(0,Ce)}${De}`}e.truncate=w;function m(le,Ce=" "){const De=g(le,Ce);return p(De,Ce)}e.trim=m;function g(le,Ce){if(!le||!Ce)return le;const De=Ce.length;if(De===0||le.length===0)return le;let Te=0;for(;le.indexOf(Ce,Te)===Te;)Te=Te+De;return le.substring(Te)}e.ltrim=g;function p(le,Ce){if(!le||!Ce)return le;const De=Ce.length,Te=le.length;if(De===0||Te===0)return le;let Ne=Te,We=-1;for(;We=le.lastIndexOf(Ce,Ne-1),!(We===-1||We+De!==Ne);){if(We===0)return"";Ne=We}return le.substring(0,Ne)}e.rtrim=p;function d(le){return le.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=d;function v(le){return le.replace(/\*/g,"")}e.stripWildcards=v;function c(le,Ce,De={}){if(!le)throw new Error("Cannot create regex from empty string");Ce||(le=T(le)),De.wholeWord&&(/\B/.test(le.charAt(0))||(le="\\b"+le),/\B/.test(le.charAt(le.length-1))||(le=le+"\\b"));let Te="";return De.global&&(Te+="g"),De.matchCase||(Te+="i"),De.multiline&&(Te+="m"),De.unicode&&(Te+="u"),new RegExp(le,Te)}e.createRegExp=c;function h(le){return le.source==="^"||le.source==="^$"||le.source==="$"||le.source==="^\\s*$"?!1:!!(le.exec("")&&le.lastIndex===0)}e.regExpLeadsToEndlessLoop=h;function f(le){return!!le.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=f;function i(le){return(le.global?"g":"")+(le.ignoreCase?"i":"")+(le.multiline?"m":"")+(le.unicode?"u":"")}e.regExpFlags=i;function n(le){return le.split(/\r\n|\r|\n/)}e.splitLines=n;function r(le){for(let Ce=0,De=le.length;Ce<De;Ce++){const Te=le.charCodeAt(Ce);if(Te!==32&&Te!==9)return Ce}return-1}e.firstNonWhitespaceIndex=r;function o(le,Ce=0,De=le.length){for(let Te=Ce;Te<De;Te++){const Ne=le.charCodeAt(Te);if(Ne!==32&&Ne!==9)return le.substring(Ce,Te)}return le.substring(Ce,De)}e.getLeadingWhitespace=o;function a(le,Ce=le.length-1){for(let De=Ce;De>=0;De--){const Te=le.charCodeAt(De);if(Te!==32&&Te!==9)return De}return-1}e.lastNonWhitespaceIndex=a;function l(le,Ce,De){const Te=[];let Ne=0;for(const We of le.matchAll(Ce)){if(Te.push(le.slice(Ne,We.index)),We.index===void 0)throw new Error("match.index should be defined");Ne=We.index+We[0].length,Te.push(De(We[0],...We.slice(1),We.index,le,We.groups))}return Te.push(le.slice(Ne)),Promise.all(Te).then(We=>We.join(""))}e.replaceAsync=l;function s(le,Ce){return le<Ce?-1:le>Ce?1:0}e.compare=s;function u(le,Ce,De=0,Te=le.length,Ne=0,We=Ce.length){for(;De<Te&&Ne<We;De++,Ne++){const it=le.charCodeAt(De),Qe=Ce.charCodeAt(Ne);if(it<Qe)return-1;if(it>Qe)return 1}const Ge=Te-De,rt=We-Ne;return Ge<rt?-1:Ge>rt?1:0}e.compareSubstring=u;function P(le,Ce){return F(le,Ce,0,le.length,0,Ce.length)}e.compareIgnoreCase=P;function F(le,Ce,De=0,Te=le.length,Ne=0,We=Ce.length){for(;De<Te&&Ne<We;De++,Ne++){let it=le.charCodeAt(De),Qe=Ce.charCodeAt(Ne);if(it===Qe)continue;if(it>=128||Qe>=128)return u(le.toLowerCase(),Ce.toLowerCase(),De,Te,Ne,We);ne(it)&&(it-=32),ne(Qe)&&(Qe-=32);const ot=it-Qe;if(ot!==0)return ot}const Ge=Te-De,rt=We-Ne;return Ge<rt?-1:Ge>rt?1:0}e.compareSubstringIgnoreCase=F;function K(le){return le>=48&&le<=57}e.isAsciiDigit=K;function ne(le){return le>=97&&le<=122}e.isLowerAsciiLetter=ne;function ue(le){return le>=65&&le<=90}e.isUpperAsciiLetter=ue;function se(le,Ce){return le.length===Ce.length&&F(le,Ce)===0}e.equalsIgnoreCase=se;function U(le,Ce){const De=Ce.length;return Ce.length>le.length?!1:F(le,Ce,0,De)===0}e.startsWithIgnoreCase=U;function Q(le,Ce){const De=Math.min(le.length,Ce.length);let Te;for(Te=0;Te<De;Te++)if(le.charCodeAt(Te)!==Ce.charCodeAt(Te))return Te;return De}e.commonPrefixLength=Q;function z(le,Ce){const De=Math.min(le.length,Ce.length);let Te;const Ne=le.length-1,We=Ce.length-1;for(Te=0;Te<De;Te++)if(le.charCodeAt(Ne-Te)!==Ce.charCodeAt(We-Te))return Te;return De}e.commonSuffixLength=z;function G(le){return 55296<=le&&le<=56319}e.isHighSurrogate=G;function X(le){return 56320<=le&&le<=57343}e.isLowSurrogate=X;function ce(le,Ce){return(le-55296<<10)+(Ce-56320)+65536}e.computeCodePoint=ce;function L(le,Ce,De){const Te=le.charCodeAt(De);if(G(Te)&&De+1<Ce){const Ne=le.charCodeAt(De+1);if(X(Ne))return ce(Te,Ne)}return Te}e.getNextCodePoint=L;function N(le,Ce){const De=le.charCodeAt(Ce-1);if(X(De)&&Ce>1){const Te=le.charCodeAt(Ce-2);if(G(Te))return ce(Te,De)}return De}class V{get offset(){return this.e}constructor(Ce,De=0){this.c=Ce,this.d=Ce.length,this.e=De}setOffset(Ce){this.e=Ce}prevCodePoint(){const Ce=N(this.c,this.e);return this.e-=Ce>=65536?2:1,Ce}nextCodePoint(){const Ce=L(this.c,this.d,this.e);return this.e+=Ce>=65536?2:1,Ce}eol(){return this.e>=this.d}}e.CodePointIterator=V;class ee{get offset(){return this.c.offset}constructor(Ce,De=0){this.c=new V(Ce,De)}nextGraphemeLength(){const Ce=Ye.getInstance(),De=this.c,Te=De.offset;let Ne=Ce.getGraphemeBreakType(De.nextCodePoint());for(;!De.eol();){const We=De.offset,Ge=Ce.getGraphemeBreakType(De.nextCodePoint());if(Fe(Ne,Ge)){De.setOffset(We);break}Ne=Ge}return De.offset-Te}prevGraphemeLength(){const Ce=Ye.getInstance(),De=this.c,Te=De.offset;let Ne=Ce.getGraphemeBreakType(De.prevCodePoint());for(;De.offset>0;){const We=De.offset,Ge=Ce.getGraphemeBreakType(De.prevCodePoint());if(Fe(Ge,Ne)){De.setOffset(We);break}Ne=Ge}return Te-De.offset}eol(){return this.c.eol()}}e.GraphemeIterator=ee;function oe(le,Ce){return new ee(le,Ce).nextGraphemeLength()}e.nextCharLength=oe;function ge(le,Ce){return new ee(le,Ce).prevGraphemeLength()}e.prevCharLength=ge;function fe(le,Ce){Ce>0&&X(le.charCodeAt(Ce))&&Ce--;const De=Ce+oe(le,Ce);return[De-ge(le,De),De]}e.getCharContainingOffset=fe;function R(le){const Ce=new ee(le);let De=0;for(;!Ce.eol();)De++,Ce.nextGraphemeLength();return De}e.charCount=R;let M;function W(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Y(le){return M||(M=W()),M.test(le)}e.containsRTL=Y;const re=/^[\t\n\r\x20-\x7E]*$/;function me(le){return re.test(le)}e.isBasicASCII=me,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function $(le){return e.UNUSUAL_LINE_TERMINATORS.test(le)}e.containsUnusualLineTerminators=$;function J(le){return le>=11904&&le<=55215||le>=63744&&le<=64255||le>=65281&&le<=65374}e.isFullWidthCharacter=J;function _(le){return le>=127462&&le<=127487||le===8986||le===8987||le===9200||le===9203||le>=9728&&le<=10175||le===11088||le===11093||le>=127744&&le<=128591||le>=128640&&le<=128764||le>=128992&&le<=129008||le>=129280&&le<=129535||le>=129648&&le<=129782}e.isEmojiImprecise=_;function j(le,Ce){if(le.length<Ce)return le;const De=/\b/g;let Te=0;for(;De.test(le)&&!(le.length-De.lastIndex<Ce);)Te=De.lastIndex,De.lastIndex+=1;return le.substring(Te).replace(/^\s/,"")}e.lcut=j;const H=/\x1B\x5B[12]?K/g,q=/\x1b\[\d+m/g,Z=/\x1b\[0?m/g;function ae(le){return le&&(le=le.replace(H,""),le=le.replace(q,""),le=le.replace(Z,"")),le}e.removeAnsiEscapeCodes=ae,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function we(le){return!!(le&&le.length>0&&le.charCodeAt(0)===65279)}e.startsWithUTF8BOM=we;function ke(le){return we(le)?le.substr(1):le}e.stripUTF8BOM=ke;function Ae(le,Ce){if(!le||!Ce||le.length<Ce.length)return!1;const De=Ce.length,Te=le.toLowerCase();let Ne=0,We=-1;for(;Ne<De;){const Ge=Te.indexOf(Ce[Ne],We+1);if(Ge<0)return!1;We=Ge,Ne++}return!0}e.fuzzyContains=Ae;function Me(le,Ce=!1){return le?(Ce&&(le=le.replace(/\\./g,"")),le.toLowerCase()!==le):!1}e.containsUppercaseCharacter=Me;function ze(le){return le.charAt(0).toUpperCase()+le.slice(1)}e.uppercaseFirstLetter=ze;function de(le,Ce=1){if(Ce===0)return"";let De=-1;do De=le.indexOf(`
`,De+1),Ce--;while(Ce>0&&De>=0);return De===-1?le:(le[De-1]==="\r"&&De--,le.substr(0,De))}e.getNLines=de;function Ee(le){return le=le%(2*26),le<26?String.fromCharCode(97+le):String.fromCharCode(65+le-26)}e.singleLetterHash=Ee;function ye(le){return Ye.getInstance().getGraphemeBreakType(le)}e.getGraphemeBreakType=ye;function Fe(le,Ce){return le===0?Ce!==5&&Ce!==7:le===2&&Ce===3?!1:le===4||le===2||le===3||Ce===4||Ce===2||Ce===3?!0:!(le===8&&(Ce===8||Ce===9||Ce===11||Ce===12)||(le===11||le===9)&&(Ce===9||Ce===10)||(le===12||le===10)&&Ce===10||Ce===5||Ce===13||Ce===7||le===1||le===13&&Ce===14||le===6&&Ce===6)}var Be;(function(le){le[le.Other=0]="Other",le[le.Prepend=1]="Prepend",le[le.CR=2]="CR",le[le.LF=3]="LF",le[le.Control=4]="Control",le[le.Extend=5]="Extend",le[le.Regional_Indicator=6]="Regional_Indicator",le[le.SpacingMark=7]="SpacingMark",le[le.L=8]="L",le[le.V=9]="V",le[le.T=10]="T",le[le.LV=11]="LV",le[le.LVT=12]="LVT",le[le.ZWJ=13]="ZWJ",le[le.Extended_Pictographic=14]="Extended_Pictographic"})(Be=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ye{static getInstance(){return Ye.c||(Ye.c=new Ye),Ye.c}constructor(){this.d=Ve()}getGraphemeBreakType(Ce){if(Ce<32)return Ce===10?3:Ce===13?2:4;if(Ce<127)return 0;const De=this.d,Te=De.length/3;let Ne=1;for(;Ne<=Te;)if(Ce<De[3*Ne])Ne=2*Ne;else if(Ce>De[3*Ne+1])Ne=2*Ne+1;else return De[3*Ne+2];return 0}}Ye.c=null;function Ve(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Je(le,Ce){if(le===0)return 0;const De=Xe(le,Ce);if(De!==void 0)return De;const Te=new V(Ce,le);return Te.prevCodePoint(),Te.offset}e.getLeftDeleteOffset=Je;function Xe(le,Ce){const De=new V(Ce,le);let Te=De.prevCodePoint();for(;tt(Te)||Te===65039||Te===8419;){if(De.offset===0)return;Te=De.prevCodePoint()}if(!_(Te))return;let Ne=De.offset;return Ne>0&&De.prevCodePoint()===8205&&(Ne=De.offset),Ne}function tt(le){return 127995<=le&&le<=127999}var qe;(function(le){le[le.zwj=8205]="zwj",le[le.emojiVariantSelector=65039]="emojiVariantSelector",le[le.enclosingKeyCap=8419]="enclosingKeyCap"})(qe||(qe={})),e.noBreakWhitespace="\xA0";class $e{static getInstance(Ce){return $e.d.get(Array.from(Ce))}static getLocales(){return $e.e.getValue()}constructor(Ce){this.f=Ce}isAmbiguous(Ce){return this.f.has(Ce)}getPrimaryConfusable(Ce){return this.f.get(Ce)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.AmbiguousCharacters=$e,k=$e,$e.c=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),$e.d=new b.LRUCachedFunction(le=>{function Ce(Qe){const ot=new Map;for(let lt=0;lt<Qe.length;lt+=2)ot.set(Qe[lt],Qe[lt+1]);return ot}function De(Qe,ot){const lt=new Map(Qe);for(const[ft,vt]of ot)lt.set(ft,vt);return lt}function Te(Qe,ot){if(!Qe)return ot;const lt=new Map;for(const[ft,vt]of Qe)ot.has(ft)&&lt.set(ft,vt);return lt}const Ne=k.c.getValue();let We=le.filter(Qe=>!Qe.startsWith("_")&&Qe in Ne);We.length===0&&(We=["_default"]);let Ge;for(const Qe of We){const ot=Ce(Ne[Qe]);Ge=Te(Ge,ot)}const rt=Ce(Ne._common),it=De(rt,Ge);return new $e(it)}),$e.e=new t.Lazy(()=>Object.keys($e.c.getValue()).filter(le=>!le.startsWith("_")));class xe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(xe.c())),this.d}static isInvisibleCharacter(Ce){return xe.e().has(Ce)}static get codePoints(){return xe.e()}}e.InvisibleCharacters=xe,xe.d=void 0}),define(ve[37],be([1,0,7,3,15,11]),function(ie,e,b,t,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function I(a){return a===47||a===92}e.isPathSeparator=I;function A(a){return a.replace(/[\\/]/g,b.posix.sep)}e.toSlashes=A;function E(a){return a.indexOf("/")===-1&&(a=A(a)),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a),a}e.toPosixPath=E;function y(a,l=b.posix.sep){if(!a)return"";const s=a.length,u=a.charCodeAt(0);if(I(u)){if(I(a.charCodeAt(1))&&!I(a.charCodeAt(2))){let F=3;const K=F;for(;F<s&&!I(a.charCodeAt(F));F++);if(K!==F&&!I(a.charCodeAt(F+1))){for(F+=1;F<s;F++)if(I(a.charCodeAt(F)))return a.slice(0,F+1).replace(/[\\/]/g,l)}}return l}else if(d(u)&&a.charCodeAt(1)===58)return I(a.charCodeAt(2))?a.slice(0,2)+l:a.slice(0,2);let P=a.indexOf("://");if(P!==-1){for(P+=3;P<s;P++)if(I(a.charCodeAt(P)))return a.slice(0,P+1)}return""}e.getRoot=y;function D(a){if(!t.isWindows||!a||a.length<5)return!1;let l=a.charCodeAt(0);if(l!==92||(l=a.charCodeAt(1),l!==92))return!1;let s=2;const u=s;for(;s<a.length&&(l=a.charCodeAt(s),l!==92);s++);return!(u===s||(l=a.charCodeAt(s+1),isNaN(l)||l===92))}e.isUNC=D;const T=/[\\/:\*\?"<>\|]/g,C=/[\\/]/g,w=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(a,l=t.isWindows){const s=l?T:C;return!(!a||a.length===0||/^\s+$/.test(a)||(s.lastIndex=0,s.test(a))||l&&w.test(a)||a==="."||a===".."||l&&a[a.length-1]==="."||l&&a.length!==a.trim().length||a.length>255)}e.isValidBasename=m;function g(a,l,s){const u=a===l;return!s||u?u:!a||!l?!1:(0,k.equalsIgnoreCase)(a,l)}e.isEqual=g;function p(a,l,s,u=b.sep){if(a===l)return!0;if(!a||!l||l.length>a.length)return!1;if(s){if(!(0,k.startsWithIgnoreCase)(a,l))return!1;if(l.length===a.length)return!0;let F=l.length;return l.charAt(l.length-1)===u&&F--,a.charAt(F)===u}return l.charAt(l.length-1)!==u&&(l+=u),a.indexOf(l)===0}e.isEqualOrParent=p;function d(a){return a>=65&&a<=90||a>=97&&a<=122}e.isWindowsDriveLetter=d;function v(a,l){return t.isWindows&&a.endsWith(":")&&(a+=b.sep),(0,b.isAbsolute)(a)||(a=(0,b.join)(l,a)),a=(0,b.normalize)(a),t.isWindows?(a=(0,k.rtrim)(a,b.sep),a.endsWith(":")&&(a+=b.sep)):(a=(0,k.rtrim)(a,b.sep),a||(a=b.sep)),a}e.sanitizeFilePath=v;function c(a){const l=(0,b.normalize)(a);return t.isWindows?a.length>3?!1:h(l)&&(a.length===2||l.charCodeAt(2)===92):l===b.posix.sep}e.isRootOrDriveLetter=c;function h(a,l=t.isWindows){return l?d(a.charCodeAt(0))&&a.charCodeAt(1)===58:!1}e.hasDriveLetter=h;function f(a){return h(a)?a[0]:void 0}e.getDriveLetter=f;function i(a,l,s){return l.length>a.length?-1:a===l?0:(s&&(a=a.toLowerCase(),l=l.toLowerCase()),a.indexOf(l))}e.indexOfPath=i;function n(a){const l=a.split(":");let s,u,P;for(const F of l){const K=Number(F);(0,S.isNumber)(K)?u===void 0?u=K:P===void 0&&(P=K):s=s?[s,F].join(":"):F}if(!s)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:s,line:u!==void 0?u:void 0,column:P!==void 0?P:u!==void 0?1:void 0}}e.parseLineAndColumnAware=n;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function o(a,l,s=8){let u="";for(let F=0;F<s;F++)u+=r.charAt(Math.floor(Math.random()*r.length));let P;return l?P=`${l}-${u}`:P=u,a?(0,b.join)(a,P):P}e.randomPath=o}),define(ve[151],be([1,0,26,15]),function(ie,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function k(...q){return function(Z,ae){for(let we=0,ke=q.length;we<ke;we++){const Ae=q[we](Z,ae);if(Ae)return Ae}return null}}e.or=k,e.matchesStrictPrefix=S.bind(void 0,!1),e.matchesPrefix=S.bind(void 0,!0);function S(q,Z,ae){if(!ae||ae.length<Z.length)return null;let we;return q?we=t.startsWithIgnoreCase(ae,Z):we=ae.indexOf(Z)===0,we?Z.length>0?[{start:0,end:Z.length}]:[]:null}function I(q,Z){const ae=Z.toLowerCase().indexOf(q.toLowerCase());return ae===-1?null:[{start:ae,end:ae+q.length}]}e.matchesContiguousSubString=I;function A(q,Z){return E(q.toLowerCase(),Z.toLowerCase(),0,0)}e.matchesSubString=A;function E(q,Z,ae,we){if(ae===q.length)return[];if(we===Z.length)return null;if(q[ae]===Z[we]){let ke=null;return(ke=E(q,Z,ae+1,we+1))?d({start:we,end:we+1},ke):null}return E(q,Z,ae,we+1)}function y(q){return 97<=q&&q<=122}function D(q){return 65<=q&&q<=90}e.isUpper=D;function T(q){return 48<=q&&q<=57}function C(q){return q===32||q===9||q===10||q===13}const w=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(q=>w.add(q.charCodeAt(0)));function m(q){return C(q)||w.has(q)}function g(q,Z){return q===Z||m(q)&&m(Z)}function p(q){return y(q)||D(q)||T(q)}function d(q,Z){return Z.length===0?Z=[q]:q.end===Z[0].start?Z[0].start=q.start:Z.unshift(q),Z}function v(q,Z){for(let ae=Z;ae<q.length;ae++){const we=q.charCodeAt(ae);if(D(we)||T(we)||ae>0&&!p(q.charCodeAt(ae-1)))return ae}return q.length}function c(q,Z,ae,we){if(ae===q.length)return[];if(we===Z.length)return null;if(q[ae]!==Z[we].toLowerCase())return null;{let ke=null,Ae=we+1;for(ke=c(q,Z,ae+1,we+1);!ke&&(Ae=v(Z,Ae))<Z.length;)ke=c(q,Z,ae+1,Ae),Ae++;return ke===null?null:d({start:we,end:we+1},ke)}}function h(q){let Z=0,ae=0,we=0,ke=0,Ae=0;for(let ye=0;ye<q.length;ye++)Ae=q.charCodeAt(ye),D(Ae)&&Z++,y(Ae)&&ae++,p(Ae)&&we++,T(Ae)&&ke++;const Me=Z/q.length,ze=ae/q.length,de=we/q.length,Ee=ke/q.length;return{upperPercent:Me,lowerPercent:ze,alphaPercent:de,numericPercent:Ee}}function f(q){const{upperPercent:Z,lowerPercent:ae}=q;return ae===0&&Z>.6}function i(q){const{upperPercent:Z,lowerPercent:ae,alphaPercent:we,numericPercent:ke}=q;return ae>.2&&Z<.8&&we>.6&&ke<.2}function n(q){let Z=0,ae=0,we=0,ke=0;for(let Ae=0;Ae<q.length;Ae++)we=q.charCodeAt(Ae),D(we)&&Z++,y(we)&&ae++,C(we)&&ke++;return(Z===0||ae===0)&&ke===0?q.length<=30:Z<=5}function r(q,Z){if(!Z||(Z=Z.trim(),Z.length===0)||!n(q)||Z.length>60)return null;const ae=h(Z);if(!i(ae)){if(!f(ae))return null;Z=Z.toLowerCase()}let we=null,ke=0;for(q=q.toLowerCase();ke<Z.length&&(we=c(q,Z,0,ke))===null;)ke=v(Z,ke+1);return we}e.matchesCamelCase=r;function o(q,Z,ae=!1){if(!Z||Z.length===0)return null;let we=null,ke=0;for(q=q.toLowerCase(),Z=Z.toLowerCase();ke<Z.length&&(we=a(q,Z,0,ke,ae))===null;)ke=l(Z,ke+1);return we}e.matchesWords=o;function a(q,Z,ae,we,ke){if(ae===q.length)return[];if(we===Z.length)return null;if(g(q.charCodeAt(ae),Z.charCodeAt(we))){let Ae=null,Me=we+1;if(Ae=a(q,Z,ae+1,we+1,ke),!ke)for(;!Ae&&(Me=l(Z,Me))<Z.length;)Ae=a(q,Z,ae+1,Me,ke),Me++;return Ae?q.charCodeAt(ae)!==Z.charCodeAt(we)?Ae:d({start:we,end:we+1},Ae):null}else return null}function l(q,Z){for(let ae=Z;ae<q.length;ae++)if(m(q.charCodeAt(ae))||ae>0&&m(q.charCodeAt(ae-1)))return ae;return q.length}const s=k(e.matchesPrefix,r,I),u=k(e.matchesPrefix,r,A),P=new b.LRUCache(1e4);function F(q,Z,ae=!1){if(typeof q!="string"||typeof Z!="string")return null;let we=P.get(q);we||(we=new RegExp(t.convertSimple2RegExpPattern(q),"i"),P.set(q,we));const ke=we.exec(Z);return ke?[{start:ke.index,end:ke.index+ke[0].length}]:ae?u(q,Z):s(q,Z)}e.matchesFuzzy=F;function K(q,Z){const ae=re(q,q.toLowerCase(),0,Z,Z.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return ae?ue(ae):null}e.matchesFuzzy2=K;function ne(q,Z,ae,we,ke,Ae){const Me=Math.min(13,q.length);for(;ae<Me;ae++){const ze=re(q,Z,ae,we,ke,Ae,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(ze)return ze}return[0,Ae]}e.anyScore=ne;function ue(q){if(typeof q>"u")return[];const Z=[],ae=q[1];for(let we=q.length-1;we>1;we--){const ke=q[we]+ae,Ae=Z[Z.length-1];Ae&&Ae.end===ke?Ae.end=ke+1:Z.push({start:ke,end:ke+1})}return Z}e.createMatches=ue;const se=128;function U(){const q=[],Z=[];for(let ae=0;ae<=se;ae++)Z[ae]=0;for(let ae=0;ae<=se;ae++)q.push(Z.slice(0));return q}function Q(q){const Z=[];for(let ae=0;ae<=q;ae++)Z[ae]=0;return Z}const z=Q(2*se),G=Q(2*se),X=U(),ce=U(),L=U(),N=!1;function V(q,Z,ae,we,ke){function Ae(ze,de,Ee=" "){for(;ze.length<de;)ze=Ee+ze;return ze}let Me=` |   |${we.split("").map(ze=>Ae(ze,3)).join("|")}
`;for(let ze=0;ze<=ae;ze++)ze===0?Me+=" |":Me+=`${Z[ze-1]}|`,Me+=q[ze].slice(0,ke+1).map(de=>Ae(de.toString(),3)).join("|")+`
`;return Me}function ee(q,Z,ae,we){q=q.substr(Z),ae=ae.substr(we),console.log(V(ce,q,q.length,ae,ae.length)),console.log(V(L,q,q.length,ae,ae.length)),console.log(V(X,q,q.length,ae,ae.length))}function oe(q,Z){if(Z<0||Z>=q.length)return!1;const ae=q.codePointAt(Z);switch(ae){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise(ae)}}function ge(q,Z){if(Z<0||Z>=q.length)return!1;switch(q.charCodeAt(Z)){case 32:case 9:return!0;default:return!1}}function fe(q,Z,ae){return Z[q]!==ae[q]}function R(q,Z,ae,we,ke,Ae,Me=!1){for(;Z<ae&&ke<Ae;)q[Z]===we[ke]&&(Me&&(z[Z]=ke),Z+=1),ke+=1;return Z===ae}e.isPatternInWord=R;var M;(function(q){q[q.Diag=1]="Diag",q[q.Left=2]="Left",q[q.LeftLeft=3]="LeftLeft"})(M||(M={}));var W;(function(q){q.Default=[-100,0];function Z(ae){return!ae||ae.length===2&&ae[0]===-100&&ae[1]===0}q.isDefault=Z})(W=e.FuzzyScore||(e.FuzzyScore={}));class Y{constructor(Z,ae){this.firstMatchCanBeWeak=Z,this.boostFullMatch=ae}}e.FuzzyScoreOptions=Y,Y.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function re(q,Z,ae,we,ke,Ae,Me=Y.default){const ze=q.length>se?se:q.length,de=we.length>se?se:we.length;if(ae>=ze||Ae>=de||ze-ae>de-Ae||!R(Z,ae,ze,ke,Ae,de,!0))return;me(ze,de,ae,Ae,Z,ke);let Ee=1,ye=1,Fe=ae,Be=Ae;const Ye=[!1];for(Ee=1,Fe=ae;Fe<ze;Ee++,Fe++){const qe=z[Fe],$e=G[Fe],xe=Fe+1<ze?G[Fe+1]:de;for(ye=qe-Ae+1,Be=qe;Be<xe;ye++,Be++){let le=Number.MIN_SAFE_INTEGER,Ce=!1;Be<=$e&&(le=$(q,Z,Fe,ae,we,ke,Be,de,Ae,X[Ee-1][ye-1]===0,Ye));let De=0;le!==Number.MAX_SAFE_INTEGER&&(Ce=!0,De=le+ce[Ee-1][ye-1]);const Te=Be>qe,Ne=Te?ce[Ee][ye-1]+(X[Ee][ye-1]>0?-5:0):0,We=Be>qe+1&&X[Ee][ye-1]>0,Ge=We?ce[Ee][ye-2]+(X[Ee][ye-2]>0?-5:0):0;if(We&&(!Te||Ge>=Ne)&&(!Ce||Ge>=De))ce[Ee][ye]=Ge,L[Ee][ye]=3,X[Ee][ye]=0;else if(Te&&(!Ce||Ne>=De))ce[Ee][ye]=Ne,L[Ee][ye]=2,X[Ee][ye]=0;else if(Ce)ce[Ee][ye]=De,L[Ee][ye]=1,X[Ee][ye]=X[Ee-1][ye-1]+1;else throw new Error("not possible")}}if(N&&ee(q,ae,we,Ae),!Ye[0]&&!Me.firstMatchCanBeWeak)return;Ee--,ye--;const Ve=[ce[Ee][ye],Ae];let Je=0,Xe=0;for(;Ee>=1;){let qe=ye;do{const $e=L[Ee][qe];if($e===3)qe=qe-2;else if($e===2)qe=qe-1;else break}while(qe>=1);Je>1&&Z[ae+Ee-1]===ke[Ae+ye-1]&&!fe(qe+Ae-1,we,ke)&&Je+1>X[Ee][qe]&&(qe=ye),qe===ye?Je++:Je=1,Xe||(Xe=qe),Ee--,ye=qe-1,Ve.push(ye)}de===ze&&Me.boostFullMatch&&(Ve[0]+=2);const tt=Xe-ze;return Ve[0]-=tt,Ve}e.fuzzyScore=re;function me(q,Z,ae,we,ke,Ae){let Me=q-1,ze=Z-1;for(;Me>=ae&&ze>=we;)ke[Me]===Ae[ze]&&(G[Me]=ze,Me--),ze--}function $(q,Z,ae,we,ke,Ae,Me,ze,de,Ee,ye){if(Z[ae]!==Ae[Me])return Number.MIN_SAFE_INTEGER;let Fe=1,Be=!1;return Me===ae-we?Fe=q[ae]===ke[Me]?7:5:fe(Me,ke,Ae)&&(Me===0||!fe(Me-1,ke,Ae))?(Fe=q[ae]===ke[Me]?7:5,Be=!0):oe(Ae,Me)&&(Me===0||!oe(Ae,Me-1))?Fe=5:(oe(Ae,Me-1)||ge(Ae,Me-1))&&(Fe=5,Be=!0),Fe>1&&ae===we&&(ye[0]=!0),Be||(Be=fe(Me,ke,Ae)||oe(Ae,Me-1)||ge(Ae,Me-1)),ae===we?Me>de&&(Fe-=Be?3:5):Ee?Fe+=Be?2:0:Fe+=Be?0:1,Me+1===ze&&(Fe-=Be?3:5),Fe}function J(q,Z,ae,we,ke,Ae,Me){return j(q,Z,ae,we,ke,Ae,!0,Me)}e.fuzzyScoreGracefulAggressive=J;function _(q,Z,ae,we,ke,Ae,Me){return j(q,Z,ae,we,ke,Ae,!1,Me)}e.fuzzyScoreGraceful=_;function j(q,Z,ae,we,ke,Ae,Me,ze){let de=re(q,Z,ae,we,ke,Ae,ze);if(de&&!Me)return de;if(q.length>=3){const Ee=Math.min(7,q.length-1);for(let ye=ae+1;ye<Ee;ye++){const Fe=H(q,ye);if(Fe){const Be=re(Fe,Fe.toLowerCase(),ae,we,ke,Ae,ze);Be&&(Be[0]-=3,(!de||Be[0]>de[0])&&(de=Be))}}}return de}function H(q,Z){if(Z+1>=q.length)return;const ae=q[Z],we=q[Z+1];if(ae!==we)return q.slice(0,Z)+we+ae+q.slice(Z+2)}}),define(ve[91],be([1,0,15]),function(ie,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(d){return k(d,0)}e.hash=t;function k(d,v){switch(typeof d){case"object":return d===null?S(349,v):Array.isArray(d)?E(d,v):y(d,v);case"string":return A(d,v);case"boolean":return I(d,v);case"number":return S(d,v);case"undefined":return S(937,v);default:return S(617,v)}}e.doHash=k;function S(d,v){return(v<<5)-v+d|0}e.numberHash=S;function I(d,v){return S(d?433:863,v)}function A(d,v){v=S(149417,v);for(let c=0,h=d.length;c<h;c++)v=S(d.charCodeAt(c),v);return v}e.stringHash=A;function E(d,v){return v=S(104579,v),d.reduce((c,h)=>k(h,c),v)}function y(d,v){return v=S(181387,v),Object.keys(d).sort().reduce((c,h)=>(c=A(h,c),k(d[h],c)),v)}class D{constructor(){this.g=0}get value(){return this.g}hash(v){return this.g=k(v,this.g),this.g}}e.Hasher=D;var T;(function(d){d[d.BLOCK_SIZE=64]="BLOCK_SIZE",d[d.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(T||(T={}));function C(d,v,c=32){const h=c-v,f=~((1<<h)-1);return(d<<v|(f&d)>>>h)>>>0}function w(d,v=0,c=d.byteLength,h=0){for(let f=0;f<c;f++)d[v+f]=h}function m(d,v,c="0"){for(;d.length<v;)d=c+d;return d}function g(d,v=32){return d instanceof ArrayBuffer?Array.from(new Uint8Array(d)).map(c=>c.toString(16).padStart(2,"0")).join(""):m((d>>>0).toString(16),v/4)}e.toHexString=g;class p{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(v){const c=v.length;if(c===0)return;const h=this.p;let f=this.r,i=this.u,n,r;for(i!==0?(n=i,r=-1,i=0):(n=v.charCodeAt(0),r=0);;){let o=n;if(b.isHighSurrogate(n))if(r+1<c){const a=v.charCodeAt(r+1);b.isLowSurrogate(a)?(r++,o=b.computeCodePoint(n,a)):o=65533}else{i=n;break}else b.isLowSurrogate(n)&&(o=65533);if(f=this.w(h,f,o),r++,r<c)n=v.charCodeAt(r);else break}this.r=f,this.u=i}w(v,c,h){return h<128?v[c++]=h:h<2048?(v[c++]=192|(h&1984)>>>6,v[c++]=128|(h&63)>>>0):h<65536?(v[c++]=224|(h&61440)>>>12,v[c++]=128|(h&4032)>>>6,v[c++]=128|(h&63)>>>0):(v[c++]=240|(h&1835008)>>>18,v[c++]=128|(h&258048)>>>12,v[c++]=128|(h&4032)>>>6,v[c++]=128|(h&63)>>>0),c>=64&&(this.y(),c-=64,this.t+=64,v[0]=v[64+0],v[1]=v[64+1],v[2]=v[64+2]),c}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),g(this.h)+g(this.l)+g(this.m)+g(this.n)+g(this.o)}x(){this.p[this.r++]=128,w(this.p,this.r),this.r>56&&(this.y(),w(this.p));const v=8*this.t;this.q.setUint32(56,Math.floor(v/4294967296),!1),this.q.setUint32(60,v%4294967296,!1),this.y()}y(){const v=p.g,c=this.q;for(let s=0;s<64;s+=4)v.setUint32(s,c.getUint32(s,!1),!1);for(let s=64;s<320;s+=4)v.setUint32(s,C(v.getUint32(s-12,!1)^v.getUint32(s-32,!1)^v.getUint32(s-56,!1)^v.getUint32(s-64,!1),1),!1);let h=this.h,f=this.l,i=this.m,n=this.n,r=this.o,o,a,l;for(let s=0;s<80;s++)s<20?(o=f&i|~f&n,a=1518500249):s<40?(o=f^i^n,a=1859775393):s<60?(o=f&i|f&n|i&n,a=2400959708):(o=f^i^n,a=3395469782),l=C(h,5)+o+r+a+v.getUint32(s*4,!1)&4294967295,r=n,n=i,i=C(f,30),f=h,h=l;this.h=this.h+h&4294967295,this.l=this.l+f&4294967295,this.m=this.m+i&4294967295,this.n=this.n+n&4294967295,this.o=this.o+r&4294967295}}e.StringSHA1=p,p.g=new DataView(new ArrayBuffer(320))}),define(ve[152],be([1,0,40,151,15]),function(ie,e,b,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const S="$(",I=new RegExp(`\\$\\(${b.CSSIcon.iconNameExpression}(?:${b.CSSIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(b.CSSIcon.iconNameCharacter),E=new RegExp(`(\\\\)?${I.source}`,"g");function y(d){return d.replace(E,(v,c)=>c?v:`\\${v}`)}e.escapeIcons=y;const D=new RegExp(`\\\\${I.source}`,"g");function T(d){return d.replace(D,v=>`\\${v}`)}e.markdownEscapeEscapedIcons=T;const C=new RegExp(`(\\s)?(\\\\)?${I.source}(\\s)?`,"g");function w(d){return d.indexOf(S)===-1?d:d.replace(C,(v,c,h,f)=>h?v:c||f||"")}e.stripIcons=w;function m(d){const v=d.indexOf(S);return v===-1?{text:d}:g(d,v)}e.parseLabelWithIcons=m;function g(d,v){const c=[];let h="";function f(u){if(u){h+=u;for(const P of u)c.push(r)}}let i=-1,n="",r=0,o,a,l=v;const s=d.length;for(f(d.substr(0,v));l<s;)o=d[l],a=d[l+1],o===S[0]&&a===S[1]?(i=l,f(n),n=S,l++):o===")"&&i!==-1?(r+=l-i+1,i=-1,n=""):i!==-1?A.test(o)?n+=o:(f(n),i=-1,n=""):f(o),l++;return f(n),{text:h,iconOffsets:c}}function p(d,v,c=!1){const{text:h,iconOffsets:f}=v;if(!f||f.length===0)return(0,t.matchesFuzzy)(d,h,c);const i=(0,k.ltrim)(h," "),n=h.length-i.length,r=(0,t.matchesFuzzy)(d,i,c);if(r)for(const o of r){const a=f[o.start+n]+n;o.start+=a,o.end+=a}return r}e.matchesFuzzyIconAware=p}),define(ve[70],be([1,0,15]),function(ie,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(t||(t={})),function(k){const S="error",I="warning",A="warn",E="info",y="ignore";function D(C){return C?b.equalsIgnoreCase(S,C)?k.Error:b.equalsIgnoreCase(I,C)||b.equalsIgnoreCase(A,C)?k.Warning:b.equalsIgnoreCase(E,C)?k.Info:k.Ignore:k.Ignore}k.fromValue=D;function T(C){switch(C){case k.Error:return S;case k.Warning:return I;case k.Info:return E;default:return y}}k.toString=T}(t||(t={})),e.default=t}),define(ve[58],be([1,0,18,15]),function(ie,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class k{constructor(){this.b="",this.c=0}reset(w){return this.b=w,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(w){const m=w.charCodeAt(0),g=this.b.charCodeAt(this.c);return m-g}value(){return this.b[this.c]}}e.StringIterator=k;class S{constructor(w=!0){this.e=w}reset(w){return this.b=w,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let w=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(w)this.c++;else break;else w=!1;return this}cmp(w){return this.e?(0,t.compareSubstring)(w,this.b,0,w.length,this.c,this.d):(0,t.compareSubstringIgnoreCase)(w,this.b,0,w.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=S;class I{constructor(w=!0,m=!0){this.f=w,this.g=m}reset(w){this.d=0,this.e=0,this.b=w,this.c=w.length;for(let m=w.length-1;m>=0;m--,this.c--){const g=this.b.charCodeAt(m);if(!(g===47||this.f&&g===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let w=!0;for(;this.e<this.c;this.e++){const m=this.b.charCodeAt(this.e);if(m===47||this.f&&m===92)if(w)this.d++;else break;else w=!1}return this}cmp(w){return this.g?(0,t.compareSubstring)(w,this.b,0,w.length,this.d,this.e):(0,t.compareSubstringIgnoreCase)(w,this.b,0,w.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=I;var A;(function(C){C[C.Scheme=1]="Scheme",C[C.Authority=2]="Authority",C[C.Path=3]="Path",C[C.Query=4]="Query",C[C.Fragment=5]="Fragment"})(A||(A={}));class E{constructor(w,m){this.f=w,this.g=m,this.d=[],this.e=0}reset(w){return this.c=w,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new I(!1,!this.f(w)),this.b.reset(w.path),this.b.value()&&this.d.push(3)),this.g(w)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(w){if(this.d[this.e]===1)return(0,t.compareIgnoreCase)(w,this.c.scheme);if(this.d[this.e]===2)return(0,t.compareIgnoreCase)(w,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(w);if(this.d[this.e]===4)return(0,t.compare)(w,this.c.query);if(this.d[this.e]===5)return(0,t.compare)(w,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=E;class y{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const w=this.right;return this.right=w.left,w.left=this,this.updateHeight(),w.updateHeight(),w}rotateRight(){const w=this.left;return this.left=w.right,w.right=this,this.updateHeight(),w.updateHeight(),w}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var D;(function(C){C[C.Left=-1]="Left",C[C.Mid=0]="Mid",C[C.Right=1]="Right"})(D||(D={}));class T{static forUris(w=()=>!1,m=()=>!1){return new T(new E(w,m))}static forPaths(w=!1){return new T(new I(void 0,!w))}static forStrings(){return new T(new k)}static forConfigKeys(){return new T(new S)}constructor(w){this.b=w}clear(){this.c=void 0}fill(w,m){if(m){const g=m.slice(0);(0,b.shuffle)(g);for(const p of g)this.set(p,w)}else{const g=w.slice(0);(0,b.shuffle)(g);for(const p of g)this.set(p[0],p[1])}}set(w,m){const g=this.b.reset(w);let p;this.c||(this.c=new y,this.c.segment=g.value());const d=[];for(p=this.c;;){const c=g.cmp(p.segment);if(c>0)p.left||(p.left=new y,p.left.segment=g.value()),d.push([-1,p]),p=p.left;else if(c<0)p.right||(p.right=new y,p.right.segment=g.value()),d.push([1,p]),p=p.right;else if(g.hasNext())g.next(),p.mid||(p.mid=new y,p.mid.segment=g.value()),d.push([0,p]),p=p.mid;else break}const v=p.value;p.value=m,p.key=w;for(let c=d.length-1;c>=0;c--){const h=d[c][1];h.updateHeight();const f=h.balanceFactor();if(f<-1||f>1){const i=d[c][0],n=d[c+1][0];if(i===1&&n===1)d[c][1]=h.rotateLeft();else if(i===-1&&n===-1)d[c][1]=h.rotateRight();else if(i===1&&n===-1)h.right=d[c+1][1]=d[c+1][1].rotateRight(),d[c][1]=h.rotateLeft();else if(i===-1&&n===1)h.left=d[c+1][1]=d[c+1][1].rotateLeft(),d[c][1]=h.rotateRight();else throw new Error;if(c>0)switch(d[c-1][0]){case-1:d[c-1][1].left=d[c][1];break;case 1:d[c-1][1].right=d[c][1];break;case 0:d[c-1][1].mid=d[c][1];break}else this.c=d[0][1]}}return v}get(w){return this.d(w)?.value}d(w){const m=this.b.reset(w);let g=this.c;for(;g;){const p=m.cmp(g.segment);if(p>0)g=g.left;else if(p<0)g=g.right;else if(m.hasNext())m.next(),g=g.mid;else break}return g}has(w){const m=this.d(w);return!(m?.value===void 0&&m?.mid===void 0)}delete(w){return this.e(w,!1)}deleteSuperstr(w){return this.e(w,!0)}e(w,m){const g=this.b.reset(w),p=[];let d=this.c;for(;d;){const v=g.cmp(d.segment);if(v>0)p.push([-1,d]),d=d.left;else if(v<0)p.push([1,d]),d=d.right;else if(g.hasNext())g.next(),p.push([0,d]),d=d.mid;else break}if(!!d){if(m?(d.left=void 0,d.mid=void 0,d.right=void 0,d.height=1):(d.key=void 0,d.value=void 0),!d.mid&&!d.value)if(d.left&&d.right){const v=this.f(d.right);if(v.key){const{key:c,value:h,segment:f}=v;this.e(v.key,!1),d.key=c,d.value=h,d.segment=f}}else{const v=d.left??d.right;if(p.length>0){const[c,h]=p[p.length-1];switch(c){case-1:h.left=v;break;case 0:h.mid=v;break;case 1:h.right=v;break}}else this.c=v}for(let v=p.length-1;v>=0;v--){const c=p[v][1];c.updateHeight();const h=c.balanceFactor();if(h>1?(c.right.balanceFactor()>=0||(c.right=c.right.rotateRight()),p[v][1]=c.rotateLeft()):h<-1&&(c.left.balanceFactor()<=0||(c.left=c.left.rotateLeft()),p[v][1]=c.rotateRight()),v>0)switch(p[v-1][0]){case-1:p[v-1][1].left=p[v][1];break;case 1:p[v-1][1].right=p[v][1];break;case 0:p[v-1][1].mid=p[v][1];break}else this.c=p[0][1]}}}f(w){for(;w.left;)w=w.left;return w}findSubstr(w){const m=this.b.reset(w);let g=this.c,p;for(;g;){const d=m.cmp(g.segment);if(d>0)g=g.left;else if(d<0)g=g.right;else if(m.hasNext())m.next(),p=g.value||p,g=g.mid;else break}return g&&g.value||p}findSuperstr(w){const m=this.b.reset(w);let g=this.c;for(;g;){const p=m.cmp(g.segment);if(p>0)g=g.left;else if(p<0)g=g.right;else if(m.hasNext())m.next(),g=g.mid;else return g.mid?this.g(g.mid):void 0}}forEach(w){for(const[m,g]of this)w(g,m)}*[Symbol.iterator](){yield*this.g(this.c)}g(w){const m=[];return this.h(w,m),m[Symbol.iterator]()}h(w,m){!w||(w.left&&this.h(w.left,m),w.value&&m.push([w.key,w.value]),w.mid&&this.h(w.mid,m),w.right&&this.h(w.right,m))}_isBalanced(){const w=m=>{if(!m)return!0;const g=m.balanceFactor();return g<-1||g>1?!1:w(m.left)&&w(m.right)};return w(this.c)}}e.TernarySearchTree=T}),define(ve[4],be([1,0,7,3]),function(ie,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,S=/^\//,I=/^\/\//;function A(r,o){if(!r.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!k.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!S.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(I.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function E(r,o){return!r&&!o?"file":r}function y(r,o){switch(r){case"https":case"http":case"file":o?o[0]!==T&&(o=T+o):o=T;break}return o}const D="",T="/",C=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class w{static isUri(o){return o instanceof w?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}constructor(o,a,l,s,u,P=!1){typeof o=="object"?(this.scheme=o.scheme||D,this.authority=o.authority||D,this.path=o.path||D,this.query=o.query||D,this.fragment=o.fragment||D):(this.scheme=E(o,P),this.authority=a||D,this.path=y(this.scheme,l||D),this.query=s||D,this.fragment=u||D,A(this,P))}get fsPath(){return c(this,!1)}with(o){if(!o)return this;let{scheme:a,authority:l,path:s,query:u,fragment:P}=o;return a===void 0?a=this.scheme:a===null&&(a=D),l===void 0?l=this.authority:l===null&&(l=D),s===void 0?s=this.path:s===null&&(s=D),u===void 0?u=this.query:u===null&&(u=D),P===void 0?P=this.fragment:P===null&&(P=D),a===this.scheme&&l===this.authority&&s===this.path&&u===this.query&&P===this.fragment?this:new g(a,l,s,u,P)}static parse(o,a=!1){const l=C.exec(o);return l?new g(l[2]||D,n(l[4]||D),n(l[5]||D),n(l[7]||D),n(l[9]||D),a):new g(D,D,D,D,D)}static file(o){let a=D;if(t.isWindows&&(o=o.replace(/\\/g,T)),o[0]===T&&o[1]===T){const l=o.indexOf(T,2);l===-1?(a=o.substring(2),o=T):(a=o.substring(2,l),o=o.substring(l)||T)}return new g("file",a,o,D,D)}static from(o){const a=new g(o.scheme,o.authority,o.path,o.query,o.fragment);return A(a,!0),a}static joinPath(o,...a){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return t.isWindows&&o.scheme==="file"?l=w.file(b.win32.join(c(o,!0),...a)).path:l=b.posix.join(o.path,...a),o.with({path:l})}toString(o=!1){return h(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof w)return o;{const a=new g(o);return a._formatted=o.external,a._fsPath=o._sep===m?o.fsPath:null,a}}else return o}}e.URI=w;const m=t.isWindows?1:void 0;class g extends w{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(o=!1){return o?h(this,!0):(this._formatted||(this._formatted=h(this,!1)),this._formatted)}toJSON(){const o={$mid:1};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=m),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const p={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function d(r,o){let a,l=-1;for(let s=0;s<r.length;s++){const u=r.charCodeAt(s);if(u>=97&&u<=122||u>=65&&u<=90||u>=48&&u<=57||u===45||u===46||u===95||u===126||o&&u===47)l!==-1&&(a+=encodeURIComponent(r.substring(l,s)),l=-1),a!==void 0&&(a+=r.charAt(s));else{a===void 0&&(a=r.substr(0,s));const P=p[u];P!==void 0?(l!==-1&&(a+=encodeURIComponent(r.substring(l,s)),l=-1),a+=P):l===-1&&(l=s)}}return l!==-1&&(a+=encodeURIComponent(r.substring(l))),a!==void 0?a:r}function v(r){let o;for(let a=0;a<r.length;a++){const l=r.charCodeAt(a);l===35||l===63?(o===void 0&&(o=r.substr(0,a)),o+=p[l]):o!==void 0&&(o+=r[a])}return o!==void 0?o:r}function c(r,o){let a;return r.authority&&r.path.length>1&&r.scheme==="file"?a=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?o?a=r.path.substr(1):a=r.path[1].toLowerCase()+r.path.substr(2):a=r.path,t.isWindows&&(a=a.replace(/\//g,"\\")),a}e.uriToFsPath=c;function h(r,o){const a=o?v:d;let l="",{scheme:s,authority:u,path:P,query:F,fragment:K}=r;if(s&&(l+=s,l+=":"),(u||s==="file")&&(l+=T,l+=T),u){let ne=u.indexOf("@");if(ne!==-1){const ue=u.substr(0,ne);u=u.substr(ne+1),ne=ue.indexOf(":"),ne===-1?l+=a(ue,!1):(l+=a(ue.substr(0,ne),!1),l+=":",l+=a(ue.substr(ne+1),!1)),l+="@"}u=u.toLowerCase(),ne=u.indexOf(":"),ne===-1?l+=a(u,!1):(l+=a(u.substr(0,ne),!1),l+=u.substr(ne))}if(P){if(P.length>=3&&P.charCodeAt(0)===47&&P.charCodeAt(2)===58){const ne=P.charCodeAt(1);ne>=65&&ne<=90&&(P=`/${String.fromCharCode(ne+32)}:${P.substr(3)}`)}else if(P.length>=2&&P.charCodeAt(1)===58){const ne=P.charCodeAt(0);ne>=65&&ne<=90&&(P=`${String.fromCharCode(ne+32)}:${P.substr(2)}`)}l+=a(P,!0)}return F&&(l+="?",l+=a(F,!1)),K&&(l+="#",l+=o?K:d(K,!1)),l}function f(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+f(r.substr(3)):r}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(r){return r.match(i)?r.replace(i,o=>f(o)):r}}),define(ve[153],be([1,0,4]),function(ie,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function t(y){const D=y;return D&&typeof D.type=="string"&&typeof D.severity=="string"}e.isRemoteConsoleLog=t;function k(y){const D=[];let T;try{const C=JSON.parse(y.arguments),w=C[C.length-1];w&&w.__$stack&&(C.pop(),T=w.__$stack),D.push(...C)}catch{D.push("Unable to log remote console arguments",y.arguments)}return{args:D,stack:T}}e.parse=k;function S(y){if(typeof y!="string")return S(k(y).stack);const D=y;if(D){const T=I(D),C=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(T||"");if(C&&C.length===4)return{uri:b.URI.file(C[1]),line:Number(C[2]),column:Number(C[3])}}}e.getFirstFrame=S;function I(y){if(!y)return y;const D=y.indexOf(`
`);return D===-1?y:y.substring(0,D)}function A(y,D){const{args:T,stack:C}=k(y),w=typeof T[0]=="string"&&T.length===1;let m=I(C);m&&(m=`(${m.trim()})`);let g=[];if(typeof T[0]=="string"?m&&w?g=[`%c[${D}] %c${T[0]} %c${m}`,E("blue"),E(""),E("grey")]:g=[`%c[${D}] %c${T[0]}`,E("blue"),E(""),...T.slice(1)]:g=[`%c[${D}]%`,E("blue"),...T],m&&!w&&g.push(m),typeof console[y.severity]!="function")throw new Error("Unknown console method");console[y.severity].apply(console,g)}e.log=A;function E(y){return`color: ${y}`}}),define(ve[47],be([1,0,16,15,4]),function(ie,e,b,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function S(y){return JSON.stringify(y,A)}e.stringify=S;function I(y){let D=JSON.parse(y);return D=E(D),D}e.parse=I;function A(y,D){return D instanceof RegExp?{$mid:2,source:D.source,flags:(0,t.regExpFlags)(D)}:D}function E(y,D=0){if(!y||D>200)return y;if(typeof y=="object"){switch(y.$mid){case 1:return k.URI.revive(y);case 2:return new RegExp(y.source,y.flags);case 16:return new Date(y.source)}if(y instanceof b.VSBuffer||y instanceof Uint8Array)return y;if(Array.isArray(y))for(let T=0;T<y.length;++T)y[T]=E(y[T],D+1);else for(const T in y)Object.hasOwnProperty.call(y,T)&&(y[T]=E(y[T],D+1))}return y}e.revive=E}),define(ve[13],be([1,0,3,4]),function(ie,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var k;(function(E){E.inMemory="inmemory",E.vscode="vscode",E.internal="private",E.walkThrough="walkThrough",E.walkThroughSnippet="walkThroughSnippet",E.http="http",E.https="https",E.file="file",E.mailto="mailto",E.untitled="untitled",E.data="data",E.command="command",E.vscodeRemote="vscode-remote",E.vscodeRemoteResource="vscode-remote-resource",E.vscodeUserData="vscode-userdata",E.vscodeCustomEditor="vscode-custom-editor",E.vscodeNotebook="vscode-notebook",E.vscodeNotebookCell="vscode-notebook-cell",E.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",E.vscodeNotebookCellOutput="vscode-notebook-cell-output",E.vscodeInteractive="vscode-interactive",E.vscodeInteractiveInput="vscode-interactive-input",E.vscodeSettings="vscode-settings",E.vscodeWorkspaceTrust="vscode-workspace-trust",E.vscodeTerminal="vscode-terminal",E.webviewPanel="webview-panel",E.vscodeWebview="vscode-webview",E.extension="extension",E.vscodeFileResource="vscode-file",E.tmp="tmp",E.vsls="vsls",E.vscodeSourceControl="vscode-scm"})(k=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class S{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${k.vscodeRemoteResource}`}setPreferredWebSchema(y){this.d=y}setDelegate(y){this.e=y}setServerRootPath(y){this.f=`${y}/${k.vscodeRemoteResource}`}set(y,D,T){this.a[y]=D,this.b[y]=T}setConnectionToken(y,D){this.c[y]=D}getPreferredWebSchema(){return this.d}rewrite(y){if(this.e)return this.e(y);const D=y.authority;let T=this.a[D];T&&T.indexOf(":")!==-1&&T.indexOf("[")===-1&&(T=`[${T}]`);const C=this.b[D],w=this.c[D];let m=`path=${encodeURIComponent(y.path)}`;return typeof w=="string"&&(m+=`&${e.connectionTokenQueryName}=${encodeURIComponent(w)}`),t.URI.from({scheme:b.isWeb?this.d:k.vscodeRemoteResource,authority:`${T}:${C}`,path:this.f,query:m})}}e.RemoteAuthorities=new S,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class I{asBrowserUri(y){const D=this.b(y,ie);return this.uriToBrowserUri(D)}uriToBrowserUri(y){return y.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(y):y.scheme===k.file&&(b.isNative||b.isWebWorker&&b.globals.origin===`${k.vscodeFileResource}://${I.a}`)?y.with({scheme:k.vscodeFileResource,authority:y.authority||I.a,query:null,fragment:null}):y}asFileUri(y){const D=this.b(y,ie);return this.uriToFileUri(D)}uriToFileUri(y){return y.scheme===k.vscodeFileResource?y.with({scheme:k.file,authority:y.authority!==I.a?y.authority:null,query:null,fragment:null}):y}b(y,D){return t.URI.isUri(y)?y:t.URI.parse(D.toUrl(y))}}I.a="vscode-app",e.FileAccess=new I;var A;(function(E){const y=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);E.CoopAndCoep=Object.freeze(y.get("3"));const D="vscode-coi";function T(w){let m;typeof w=="string"?m=new URL(w).searchParams:w instanceof URL?m=w.searchParams:t.URI.isUri(w)&&(m=new URL(w.toString(!0)).searchParams);const g=m?.get(D);if(!!g)return y.get(g)}E.getHeadersFromQuery=T;function C(w,m,g){if(!globalThis.crossOriginIsolated)return;const p=m&&g?"3":g?"2":"1";w instanceof URLSearchParams?w.set(D,p):w[D]=p}E.addSearchParam=C})(A=e.COI||(e.COI={}))}),define(ve[20],be([1,0,37,13,7,3,15,4]),function(ie,e,b,t,k,S,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function E(w){return(0,A.uriToFsPath)(w,!0)}e.originalFSPath=E;class y{constructor(m){this.a=m}compare(m,g,p=!1){return m===g?0:(0,I.compare)(this.getComparisonKey(m,p),this.getComparisonKey(g,p))}isEqual(m,g,p=!1){return m===g?!0:!m||!g?!1:this.getComparisonKey(m,p)===this.getComparisonKey(g,p)}getComparisonKey(m,g=!1){return m.with({path:this.a(m)?m.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(m){return this.a(m)}isEqualOrParent(m,g,p=!1){if(m.scheme===g.scheme){if(m.scheme===t.Schemas.file)return b.isEqualOrParent(E(m),E(g),this.a(m))&&m.query===g.query&&(p||m.fragment===g.fragment);if((0,e.isEqualAuthority)(m.authority,g.authority))return b.isEqualOrParent(m.path,g.path,this.a(m),"/")&&m.query===g.query&&(p||m.fragment===g.fragment)}return!1}joinPath(m,...g){return A.URI.joinPath(m,...g)}basenameOrAuthority(m){return(0,e.basename)(m)||m.authority}basename(m){return k.posix.basename(m.path)}extname(m){return k.posix.extname(m.path)}dirname(m){if(m.path.length===0)return m;let g;return m.scheme===t.Schemas.file?g=A.URI.file(k.dirname(E(m))).path:(g=k.posix.dirname(m.path),m.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${m.toString})) resulted in a relative path`),g="/")),m.with({path:g})}normalizePath(m){if(!m.path.length)return m;let g;return m.scheme===t.Schemas.file?g=A.URI.file(k.normalize(E(m))).path:g=k.posix.normalize(m.path),m.with({path:g})}relativePath(m,g){if(m.scheme!==g.scheme||!(0,e.isEqualAuthority)(m.authority,g.authority))return;if(m.scheme===t.Schemas.file){const v=k.relative(E(m),E(g));return S.isWindows?b.toSlashes(v):v}let p=m.path||"/";const d=g.path||"/";if(this.a(m)){let v=0;for(const c=Math.min(p.length,d.length);v<c&&!(p.charCodeAt(v)!==d.charCodeAt(v)&&p.charAt(v).toLowerCase()!==d.charAt(v).toLowerCase());v++);p=d.substr(0,v)+p.substr(v)}return k.posix.relative(p,d)}resolvePath(m,g){if(m.scheme===t.Schemas.file){const p=A.URI.file(k.resolve(E(m),g));return m.with({authority:p.authority,path:p.path})}return g=b.toPosixPath(g),m.with({path:k.posix.resolve(m.path,g)})}isAbsolutePath(m){return!!m.path&&m.path[0]==="/"}isEqualAuthority(m,g){return m===g||m!==void 0&&g!==void 0&&(0,I.equalsIgnoreCase)(m,g)}hasTrailingPathSeparator(m,g=k.sep){if(m.scheme===t.Schemas.file){const p=E(m);return p.length>b.getRoot(p).length&&p[p.length-1]===g}else{const p=m.path;return p.length>1&&p.charCodeAt(p.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(m.fsPath)}}removeTrailingPathSeparator(m,g=k.sep){return(0,e.hasTrailingPathSeparator)(m,g)?m.with({path:m.path.substr(0,m.path.length-1)}):m}addTrailingPathSeparator(m,g=k.sep){let p=!1;if(m.scheme===t.Schemas.file){const d=E(m);p=d!==void 0&&d.length===b.getRoot(d).length&&d[d.length-1]===g}else{g="/";const d=m.path;p=d.length===1&&d.charCodeAt(d.length-1)===47}return!p&&!(0,e.hasTrailingPathSeparator)(m,g)?m.with({path:m.path+"/"}):m}}e.ExtUri=y,e.extUri=new y(()=>!1),e.extUriBiasedIgnorePathCase=new y(w=>w.scheme===t.Schemas.file?!S.isLinux:!0),e.extUriIgnorePathCase=new y(w=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function D(w,m){const g=[];for(let p=0;p<w.length;p++){const d=m(w[p]);w.some((v,c)=>c===p?!1:(0,e.isEqualOrParent)(d,m(v)))||g.push(w[p])}return g}e.distinctParents=D;var T;(function(w){w.META_DATA_LABEL="label",w.META_DATA_DESCRIPTION="description",w.META_DATA_SIZE="size",w.META_DATA_MIME="mime";function m(g){const p=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(c=>{const[h,f]=c.split(":");h&&f&&p.set(h,f)});const v=g.path.substring(0,g.path.indexOf(";"));return v&&p.set(w.META_DATA_MIME,v),p}w.parseMetaData=m})(T=e.DataUri||(e.DataUri={}));function C(w,m,g){if(m){let p=w.path;return p&&p[0]!==k.posix.sep&&(p=k.posix.sep+p),w.with({scheme:g,authority:m,path:p})}return w.with({scheme:g})}e.toLocalResource=C}),define(ve[14],be([1,0,19,8,6,2,20,3]),function(ie,e,b,t,k,S,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function E(fe){return!!fe&&typeof fe.then=="function"}e.isThenable=E;function y(fe){const R=new b.CancellationTokenSource,M=fe(R.token),W=new Promise((Y,re)=>{const me=R.token.onCancellationRequested(()=>{me.dispose(),R.dispose(),re(new t.CancellationError)});Promise.resolve(M).then($=>{me.dispose(),R.dispose(),Y($)},$=>{me.dispose(),R.dispose(),re($)})});return new class{cancel(){R.cancel()}then(Y,re){return W.then(Y,re)}catch(Y){return this.then(void 0,Y)}finally(Y){return W.finally(Y)}}}e.createCancelablePromise=y;function D(fe,R,M){return new Promise((W,Y)=>{const re=R.onCancellationRequested(()=>{re.dispose(),W(M)});fe.then(W,Y).finally(()=>re.dispose())})}e.raceCancellation=D;function T(fe,R){return new Promise((M,W)=>{const Y=R.onCancellationRequested(()=>{Y.dispose(),W(new t.CancellationError)});fe.then(M,W).finally(()=>Y.dispose())})}e.raceCancellationError=T;async function C(fe){let R=-1;const M=fe.map((Y,re)=>Y.then(me=>(R=re,me))),W=await Promise.race(M);return fe.forEach((Y,re)=>{re!==R&&Y.cancel()}),W}e.raceCancellablePromises=C;function w(fe,R,M){let W;const Y=setTimeout(()=>{W?.(void 0),M?.()},R);return Promise.race([fe.finally(()=>clearTimeout(Y)),new Promise(re=>W=re)])}e.raceTimeout=w;function m(fe){return new Promise((R,M)=>{const W=fe();E(W)?W.then(R,M):R(W)})}e.asPromise=m;class g{constructor(){this.a=null,this.b=null,this.d=null}queue(R){if(this.a){if(this.d=R,!this.b){const M=()=>{this.b=null;const W=this.queue(this.d);return this.d=null,W};this.b=new Promise(W=>{this.a.then(M,M).then(W)})}return new Promise((M,W)=>{this.b.then(M,W)})}return this.a=R(),new Promise((M,W)=>{this.a.then(Y=>{this.a=null,M(Y)},Y=>{this.a=null,W(Y)})})}}e.Throttler=g;class p{constructor(){this.a=Promise.resolve(null)}queue(R){return this.a=this.a.then(()=>R(),()=>R())}}e.Sequencer=p;class d{constructor(){this.a=new Map}queue(R,M){const Y=(this.a.get(R)??Promise.resolve()).catch(()=>{}).then(M).finally(()=>{this.a.get(R)===Y&&this.a.delete(R)});return this.a.set(R,Y),Y}}e.SequencerByKey=d;const v=(fe,R)=>{let M=!0;const W=setTimeout(()=>{M=!1,R()},fe);return{isTriggered:()=>M,dispose:()=>{clearTimeout(W),M=!1}}},c=fe=>{let R=!0;return queueMicrotask(()=>{R&&(R=!1,fe())}),{isTriggered:()=>R,dispose:()=>{R=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class h{constructor(R){this.defaultDelay=R,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(R,M=this.defaultDelay){this.g=R,this.h(),this.b||(this.b=new Promise((Y,re)=>{this.d=Y,this.f=re}).then(()=>{if(this.b=null,this.d=null,this.g){const Y=this.g;return this.g=null,Y()}}));const W=()=>{this.a=null,this.d?.(null)};return this.a=M===e.MicrotaskDelay?c(W):v(M,W),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new t.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=h;class f{constructor(R){this.a=new h(R),this.b=new g}trigger(R,M){return this.a.trigger(()=>this.b.queue(R),M)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=f;class i{constructor(){this.a=!1,this.b=new Promise((R,M)=>{this.d=R})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=i;class n extends i{constructor(R){super(),this.f=setTimeout(()=>this.open(),R)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=n;function r(fe,R){return R?new Promise((M,W)=>{const Y=setTimeout(()=>{re.dispose(),M()},fe),re=R.onCancellationRequested(()=>{clearTimeout(Y),re.dispose(),W(new t.CancellationError)})}):y(M=>r(fe,M))}e.timeout=r;function o(fe,R=0){const M=setTimeout(fe,R);return(0,S.toDisposable)(()=>clearTimeout(M))}e.disposableTimeout=o;function a(fe){const R=[];let M=0;const W=fe.length;function Y(){return M<W?fe[M++]():null}function re(me){me!=null&&R.push(me);const $=Y();return $?$.then(re):Promise.resolve(R)}return Promise.resolve(null).then(re)}e.sequence=a;function l(fe,R=W=>!!W,M=null){let W=0;const Y=fe.length,re=()=>{if(W>=Y)return Promise.resolve(M);const me=fe[W++];return Promise.resolve(me()).then(J=>R(J)?Promise.resolve(J):re())};return re()}e.first=l;function s(fe,R=W=>!!W,M=null){if(fe.length===0)return Promise.resolve(M);let W=fe.length;const Y=()=>{W=-1;for(const re of fe)re.cancel?.()};return new Promise((re,me)=>{for(const $ of fe)$.then(J=>{--W>=0&&R(J)?(Y(),re(J)):W===0&&re(M)}).catch(J=>{--W>=0&&(Y(),me(J))})})}e.firstParallel=s;class u{constructor(R){this.a=0,this.d=R,this.f=[],this.b=0,this.g=new k.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(R){return this.a++,new Promise((M,W)=>{this.f.push({factory:R,c:M,e:W}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const R=this.f.shift();this.b++;const M=R.factory();M.then(R.c,R.e),M.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=u;class P extends u{constructor(){super(1)}}e.Queue=P;class F{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const R=new L;return this.b.add(R),R.p}d(){for(const[,R]of this.a)if(R.size>0)return!1;return!0}queueFor(R,M=I.extUri){const W=M.getComparisonKey(R);let Y=this.a.get(W);return Y||(Y=new P,k.Event.once(Y.onDrained)(()=>{Y?.dispose(),this.a.delete(W),this.f()}),this.a.set(W,Y)),Y}f(){!this.d()||this.g()}g(){for(const R of this.b)R.complete();this.b.clear()}dispose(){for(const[,R]of this.a)R.dispose();this.a.clear(),this.g()}}e.ResourceQueue=F;class K{constructor(R,M){this.a=-1,typeof R=="function"&&typeof M=="number"&&this.setIfNotSet(R,M)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(R,M){this.cancel(),this.a=setTimeout(()=>{this.a=-1,R()},M)}setIfNotSet(R,M){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,R()},M))}}e.TimeoutTimer=K;class ne{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(R,M){this.cancel(),this.a=setInterval(()=>{R()},M)}}e.IntervalTimer=ne;class ue{constructor(R,M){this.b=-1,this.a=R,this.d=M,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(R=this.d){this.cancel(),this.b=setTimeout(this.f,R)}get delay(){return this.d}set delay(R){this.d=R}isScheduled(){return this.b!==-1}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=ue;class se{constructor(R,M){M%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${M}ms is not a multiple of 1000ms.`),this.a=R,this.b=M,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(R=this.b){R%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${R}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(R/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=se;class U extends ue{constructor(R,M){super(R,M),this.j=[]}work(R){this.j.push(R),this.isScheduled()||this.schedule()}h(){const R=this.j;this.j=[],this.a?.(R)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=U;class Q extends S.Disposable{constructor(R,M){super(),this.g=R,this.h=M,this.a=[],this.b=this.B(new S.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(R){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+R.length>this.g.maxBufferedWork)return!1}else if(this.pending+R.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}return this.a.push(...R),this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ue(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=Q,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=fe=>{(0,A.setTimeout0)(()=>{if(R)return;const M=Date.now()+15;fe(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,M-Date.now())}}))});let R=!1;return{dispose(){R||(R=!0)}}}:e.runWhenIdle=(fe,R)=>{const M=requestIdleCallback(fe,typeof R=="number"?{timeout:R}:void 0);let W=!1;return{dispose(){W||(W=!0,cancelIdleCallback(M))}}}}();class z{constructor(R){this.d=!1,this.a=()=>{try{this.f=R()}catch(M){this.g=M}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=z;async function G(fe,R,M){let W;for(let Y=0;Y<M;Y++)try{return await fe()}catch(re){W=re,await r(R)}throw W}e.retry=G;class X{hasPending(R){return this.a?typeof R=="number"?this.a.taskId===R:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(R,M,W){return this.a={taskId:R,cancel:()=>W?.(),promise:M},M.then(()=>this.d(R),()=>this.d(R)),M}d(R){this.a&&R===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const R=this.b;this.b=void 0,R.run().then(R.promiseResolve,R.promiseReject)}}setNext(R){if(this.b)this.b.run=R;else{let M,W;const Y=new Promise((re,me)=>{M=re,W=me});this.b={run:R,promise:Y,promiseResolve:M,promiseReject:W}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=X;class ce{constructor(R,M=()=>Date.now()){this.d=R,this.f=M,this.a=0,this.b=0}increment(){const R=this.f();return R-this.a>this.d&&(this.a=R,this.b=0),this.b++,this.b}}e.IntervalCounter=ce;class L{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((R,M)=>{this.a=R,this.b=M})}complete(R){return new Promise(M=>{this.a(R),this.f=!0,M()})}error(R){return new Promise(M=>{this.b(R),this.d=!0,M()})}cancel(){new Promise(R=>{this.b(new t.CancellationError),this.d=!0,R()})}}e.DeferredPromise=L;var N;(function(fe){async function R(W){let Y;const re=await Promise.all(W.map(me=>me.then($=>$,$=>{Y||(Y=$)})));if(typeof Y<"u")throw Y;return re}fe.settled=R;function M(W){return new Promise(async(Y,re)=>{try{await W(Y,re)}catch(me){re(me)}})}fe.withAsyncBody=M})(N=e.Promises||(e.Promises={}));var V;(function(fe){fe[fe.Initial=0]="Initial",fe[fe.DoneOK=1]="DoneOK",fe[fe.DoneError=2]="DoneError"})(V||(V={}));class ee{static fromArray(R){return new ee(M=>{M.emitMany(R)})}static fromPromise(R){return new ee(async M=>{M.emitMany(await R)})}static fromPromises(R){return new ee(async M=>{await Promise.all(R.map(async W=>M.emitOne(await W)))})}static merge(R){return new ee(async M=>{await Promise.all(R.map(async W=>{for await(const Y of W)M.emitOne(Y)}))})}constructor(R){this.a=0,this.b=[],this.d=null,this.f=new k.Emitter,queueMicrotask(async()=>{const M={emitOne:W=>this.g(W),emitMany:W=>this.h(W),reject:W=>this.k(W)};try{await Promise.resolve(R(M)),this.j()}catch(W){this.k(W)}finally{M.emitOne=void 0,M.emitMany=void 0,M.reject=void 0}})}[Symbol.asyncIterator](){let R=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(R<this.b.length)return{done:!1,value:this.b[R++]};if(this.a===1)return{done:!0,value:void 0};await k.Event.toPromise(this.f.event)}while(!0)}}}static map(R,M){return new ee(async W=>{for await(const Y of R)W.emitOne(M(Y))})}map(R){return ee.map(this,R)}static filter(R,M){return new ee(async W=>{for await(const Y of R)M(Y)&&W.emitOne(Y)})}filter(R){return ee.filter(this,R)}static coalesce(R){return ee.filter(R,M=>!!M)}coalesce(){return ee.coalesce(this)}static async toPromise(R){const M=[];for await(const W of R)M.push(W);return M}toPromise(){return ee.toPromise(this)}g(R){this.a===0&&(this.b.push(R),this.f.fire())}h(R){this.a===0&&(this.b=this.b.concat(R),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(R){this.a===0&&(this.a=2,this.d=R,this.f.fire())}}e.AsyncIterableObject=ee,ee.EMPTY=ee.fromArray([]);class oe extends ee{constructor(R,M){super(M),this.l=R}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=oe;function ge(fe){const R=new b.CancellationTokenSource,M=fe(R.token);return new oe(R,async W=>{const Y=R.token.onCancellationRequested(()=>{Y.dispose(),R.dispose(),W.reject(new t.CancellationError)});try{for await(const re of M){if(R.token.isCancellationRequested)return;W.emitOne(re)}Y.dispose(),R.dispose()}catch(re){Y.dispose(),R.dispose(),W.reject(re)}})}e.createCancelableAsyncIterable=ge}),define(ve[71],be([1,0,18,14,37,26,7,3,15]),function(ie,e,b,t,k,S,I,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function y(){return Object.create(null)}e.getEmptyExpression=y,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const D="[/\\\\]",T="[^/\\\\]",C=/\//g;function w(L,N){switch(L){case 0:return"";case 1:return`${T}*?`;default:return`(?:${D}|${T}+${D}${N?`|${D}${T}+`:""})*?`}}function m(L,N){if(!L)return[];const V=[];let ee=!1,oe=!1,ge="";for(const fe of L){switch(fe){case N:if(!ee&&!oe){V.push(ge),ge="";continue}break;case"{":ee=!0;break;case"}":ee=!1;break;case"[":oe=!0;break;case"]":oe=!1;break}ge+=fe}return ge&&V.push(ge),V}e.splitGlobAware=m;function g(L){if(!L)return"";let N="";const V=m(L,e.GLOB_SPLIT);if(V.every(ee=>ee===e.GLOBSTAR))N=".*";else{let ee=!1;V.forEach((oe,ge)=>{if(oe===e.GLOBSTAR){if(ee)return;N+=w(2,ge===V.length-1)}else{let fe=!1,R="",M=!1,W="";for(const Y of oe){if(Y!=="}"&&fe){R+=Y;continue}if(M&&(Y!=="]"||!W)){let re;Y==="-"?re=Y:(Y==="^"||Y==="!")&&!W?re="^":Y===e.GLOB_SPLIT?re="":re=(0,E.escapeRegExpCharacters)(Y),W+=re;continue}switch(Y){case"{":fe=!0;continue;case"[":M=!0;continue;case"}":{N+=`(?:${m(R,",").map($=>g($)).join("|")})`,fe=!1,R="";break}case"]":{N+="["+W+"]",M=!1,W="";break}case"?":N+=T;continue;case"*":N+=w(1);continue;default:N+=(0,E.escapeRegExpCharacters)(Y)}}ge<V.length-1&&(V[ge+1]!==e.GLOBSTAR||ge+2<V.length)&&(N+=D)}ee=oe===e.GLOBSTAR})}return N}const p=/^\*\*\/\*\.[\w\.-]+$/,d=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,c=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,h=/^\*\*((\/[\w\.-]+)+)\/?$/,f=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new S.LRUCache(1e4),n=function(){return!1},r=function(){return null};function o(L,N){if(!L)return r;let V;typeof L!="string"?V=L.pattern:V=L,V=V.trim();const ee=`${V}_${!!N.trimForExclusions}`;let oe=i.get(ee);if(oe)return a(oe,L);let ge;return p.test(V)?oe=s(V.substr(4),V):(ge=d.exec(l(V,N)))?oe=u(ge[1],V):(N.trimForExclusions?c:v).test(V)?oe=P(V,N):(ge=h.exec(l(V,N)))?oe=F(ge[1].substr(1),V,!0):(ge=f.exec(l(V,N)))?oe=F(ge[1],V,!1):oe=K(V),i.set(ee,oe),a(oe,L)}function a(L,N){if(typeof N=="string")return L;const V=function(ee,oe){return(0,k.isEqualOrParent)(ee,N.base,!A.isLinux)?L((0,E.ltrim)(ee.substr(N.base.length),I.sep),oe):null};return V.allBasenames=L.allBasenames,V.allPaths=L.allPaths,V.basenames=L.basenames,V.patterns=L.patterns,V}function l(L,N){return N.trimForExclusions&&L.endsWith("/**")?L.substr(0,L.length-2):L}function s(L,N){return function(V,ee){return typeof V=="string"&&V.endsWith(L)?N:null}}function u(L,N){const V=`/${L}`,ee=`\\${L}`,oe=function(fe,R){return typeof fe!="string"?null:R?R===L?N:null:fe===L||fe.endsWith(V)||fe.endsWith(ee)?N:null},ge=[L];return oe.basenames=ge,oe.patterns=[N],oe.allBasenames=ge,oe}function P(L,N){const V=X(L.slice(1,-1).split(",").map(R=>o(R,N)).filter(R=>R!==r),L),ee=V.length;if(!ee)return r;if(ee===1)return V[0];const oe=function(R,M){for(let W=0,Y=V.length;W<Y;W++)if(V[W](R,M))return L;return null},ge=V.find(R=>!!R.allBasenames);ge&&(oe.allBasenames=ge.allBasenames);const fe=V.reduce((R,M)=>M.allPaths?R.concat(M.allPaths):R,[]);return fe.length&&(oe.allPaths=fe),oe}function F(L,N,V){const ee=I.sep===I.posix.sep,oe=ee?L:L.replace(C,I.sep),ge=I.sep+oe,fe=I.posix.sep+L;let R;return V?R=function(M,W){return typeof M=="string"&&(M===oe||M.endsWith(ge)||!ee&&(M===L||M.endsWith(fe)))?N:null}:R=function(M,W){return typeof M=="string"&&(M===oe||!ee&&M===L)?N:null},R.allPaths=[(V?"*/":"./")+L],R}function K(L){try{const N=new RegExp(`^${g(L)}$`);return function(V){return N.lastIndex=0,typeof V=="string"&&N.test(V)?L:null}}catch{return r}}function ne(L,N,V){return!L||typeof N!="string"?!1:ue(L)(N,void 0,V)}e.match=ne;function ue(L,N={}){if(!L)return n;if(typeof L=="string"||se(L)){const V=o(L,N);if(V===r)return n;const ee=function(oe,ge){return!!V(oe,ge)};return V.allBasenames&&(ee.allBasenames=V.allBasenames),V.allPaths&&(ee.allPaths=V.allPaths),ee}return z(L,N)}e.parse=ue;function se(L){const N=L;return N?typeof N.base=="string"&&typeof N.pattern=="string":!1}e.isRelativePattern=se;function U(L){return L.allBasenames||[]}e.getBasenameTerms=U;function Q(L){return L.allPaths||[]}e.getPathTerms=Q;function z(L,N){const V=X(Object.getOwnPropertyNames(L).map(R=>G(R,L[R],N)).filter(R=>R!==r)),ee=V.length;if(!ee)return r;if(!V.some(R=>!!R.requiresSiblings)){if(ee===1)return V[0];const R=function(Y,re){let me;for(let $=0,J=V.length;$<J;$++){const _=V[$](Y,re);if(typeof _=="string")return _;(0,t.isThenable)(_)&&(me||(me=[]),me.push(_))}return me?(async()=>{for(const $ of me){const J=await $;if(typeof J=="string")return J}return null})():null},M=V.find(Y=>!!Y.allBasenames);M&&(R.allBasenames=M.allBasenames);const W=V.reduce((Y,re)=>re.allPaths?Y.concat(re.allPaths):Y,[]);return W.length&&(R.allPaths=W),R}const oe=function(R,M,W){let Y,re;for(let me=0,$=V.length;me<$;me++){const J=V[me];J.requiresSiblings&&W&&(M||(M=(0,I.basename)(R)),Y||(Y=M.substr(0,M.length-(0,I.extname)(R).length)));const _=J(R,M,Y,W);if(typeof _=="string")return _;(0,t.isThenable)(_)&&(re||(re=[]),re.push(_))}return re?(async()=>{for(const me of re){const $=await me;if(typeof $=="string")return $}return null})():null},ge=V.find(R=>!!R.allBasenames);ge&&(oe.allBasenames=ge.allBasenames);const fe=V.reduce((R,M)=>M.allPaths?R.concat(M.allPaths):R,[]);return fe.length&&(oe.allPaths=fe),oe}function G(L,N,V){if(N===!1)return r;const ee=o(L,V);if(ee===r)return r;if(typeof N=="boolean")return ee;if(N){const oe=N.when;if(typeof oe=="string"){const ge=(fe,R,M,W)=>{if(!W||!ee(fe,R))return null;const Y=oe.replace("$(basename)",M),re=W(Y);return(0,t.isThenable)(re)?re.then(me=>me?L:null):re?L:null};return ge.requiresSiblings=!0,ge}}return ee}function X(L,N){const V=L.filter(R=>!!R.basenames);if(V.length<2)return L;const ee=V.reduce((R,M)=>{const W=M.basenames;return W?R.concat(W):R},[]);let oe;if(N){oe=[];for(let R=0,M=ee.length;R<M;R++)oe.push(N)}else oe=V.reduce((R,M)=>{const W=M.patterns;return W?R.concat(W):R},[]);const ge=function(R,M){if(typeof R!="string")return null;if(!M){let Y;for(Y=R.length;Y>0;Y--){const re=R.charCodeAt(Y-1);if(re===47||re===92)break}M=R.substr(Y)}const W=ee.indexOf(M);return W!==-1?oe[W]:null};ge.basenames=ee,ge.patterns=oe,ge.allBasenames=ee;const fe=L.filter(R=>!R.basenames);return fe.push(ge),fe}function ce(L,N){return(0,b.equals)(L,N,(V,ee)=>typeof V=="string"&&typeof ee=="string"?V===ee:typeof V!="string"&&typeof ee!="string"?V.base===ee.base&&V.pattern===ee.pattern:!1)}e.patternsEquals=ce}),define(ve[92],be([1,0,8,152,20,15,4]),function(ie,e,b,t,k,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var A;(function(p){p[p.Paragraph=0]="Paragraph",p[p.Break=1]="Break"})(A=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class E{constructor(d="",v=!1){if(this.value=d,typeof this.value!="string")throw(0,b.illegalArgument)("value");typeof v=="boolean"?(this.isTrusted=v,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=v.isTrusted??void 0,this.supportThemeIcons=v.supportThemeIcons??!1,this.supportHtml=v.supportHtml??!1)}appendText(d,v=0){return this.value+=C(this.supportThemeIcons?(0,t.escapeIcons)(d):d).replace(/([ \t]+)/g,(c,h)=>"&nbsp;".repeat(h.length)).replace(/\>/gm,"\\>").replace(/\n/g,v===1?`\\
`:`

`),this}appendMarkdown(d){return this.value+=d,this}appendCodeblock(d,v){return this.value+="\n```",this.value+=d,this.value+=`
`,this.value+=v,this.value+="\n```\n",this}appendLink(d,v,c){return this.value+="[",this.value+=this.c(v,"]"),this.value+="](",this.value+=this.c(String(d),")"),c&&(this.value+=` "${this.c(this.c(c,'"'),")")}"`),this.value+=")",this}c(d,v){const c=new RegExp((0,S.escapeRegExpCharacters)(v),"g");return d.replace(c,(h,f)=>d.charAt(f-1)!=="\\"?`\\${h}`:h)}}e.MarkdownString=E;function y(p){return D(p)?!p.value:Array.isArray(p)?p.every(y):!0}e.isEmptyMarkdownString=y;function D(p){return p instanceof E?!0:p&&typeof p=="object"?typeof p.value=="string"&&(typeof p.isTrusted=="boolean"||p.isTrusted===void 0)&&(typeof p.supportThemeIcons=="boolean"||p.supportThemeIcons===void 0):!1}e.isMarkdownString=D;function T(p,d){return p===d?!0:!p||!d?!1:p.value===d.value&&p.isTrusted===d.isTrusted&&p.supportThemeIcons===d.supportThemeIcons&&p.supportHtml===d.supportHtml&&(p.baseUri===d.baseUri||!!p.baseUri&&!!d.baseUri&&(0,k.isEqual)(I.URI.from(p.baseUri),I.URI.from(d.baseUri)))}e.markdownStringEqual=T;function C(p){return p.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=C;function w(p){return p.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=w;function m(p){return p&&p.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=m;function g(p){const d=[],v=p.split("|").map(h=>h.trim());p=v[0];const c=v[1];if(c){const h=/height=(\d+)/.exec(c),f=/width=(\d+)/.exec(c),i=h?h[1]:"",n=f?f[1]:"",r=isFinite(parseInt(n)),o=isFinite(parseInt(i));r&&d.push(`width="${n}"`),o&&d.push(`height="${i}"`)}return{href:p,dimensions:d}}e.parseHrefAndDimensions=g}),define(ve[154],be([1,0,18,37,7,3,20,15]),function(ie,e,b,t,k,S,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function E(r,o){const{os:a,tildify:l,relative:s}=o;if(s){const F=y(r,s,a);if(typeof F=="string")return F}let u=r.fsPath;if(a===1&&!S.isWindows?u=u.replace(/\//g,"\\"):a!==1&&S.isWindows&&(u=u.replace(/\\/g,"/")),a!==1&&l?.userHome){const F=l.userHome.fsPath;let K;r.scheme!==l.userHome.scheme&&r.path.startsWith(k.posix.sep)?K=l.userHome.with({path:r.path}).fsPath:K=r.fsPath,u=C(K,F,a)}return(a===1?k.win32:k.posix).normalize(D(u,a===1))}e.getPathLabel=E;function y(r,o,a){const l=a===1?k.win32:k.posix,s=a===3?I.extUri:I.extUriIgnorePathCase,u=o.getWorkspace(),P=(0,b.firstOrDefault)(u.folders);if(!P)return;r.scheme!==P.uri.scheme&&r.path.startsWith(k.posix.sep)&&(r=P.uri.with({path:r.path}));const F=o.getWorkspaceFolder(r);if(!F)return;let K;if(s.isEqual(F.uri,r)?K="":K=s.relativePath(F.uri,r)??"",K&&(K=l.normalize(K)),u.folders.length>1&&!o.noPrefix){const ne=F.name?F.name:s.basenameOrAuthority(F.uri);K=K?`${ne} \u2022 ${K}`:ne}return K}function D(r,o=S.isWindows){return(0,t.hasDriveLetter)(r,o)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=D;let T=Object.create(null);function C(r,o,a=S.OS){if(a===1||!r||!o)return r;let l=T.original===o?T.normalized:void 0;l||(l=o,S.isWindows&&(l=(0,t.toSlashes)(l)),l=`${(0,A.rtrim)(l,k.posix.sep)}${k.posix.sep}`,T={original:o,normalized:l});let s=r;return S.isWindows&&(s=(0,t.toSlashes)(s)),(a===3?s.startsWith(l):(0,A.startsWithIgnoreCase)(s,l))?`~/${s.substr(l.length)}`:r}e.tildify=C;function w(r,o){return r.replace(/^~($|\/|\\)/,`${o}$1`)}e.untildify=w;const m="\u2026",g="\\\\",p="~";function d(r,o=k.sep){const a=new Array(r.length);let l=!1;for(let s=0;s<r.length;s++){const u=r[s];if(u===""){a[s]=`.${o}`;continue}if(!u){a[s]=u;continue}l=!0;let P="",F=u;F.indexOf(g)===0?(P=F.substr(0,F.indexOf(g)+g.length),F=F.substr(F.indexOf(g)+g.length)):F.indexOf(o)===0?(P=F.substr(0,F.indexOf(o)+o.length),F=F.substr(F.indexOf(o)+o.length)):F.indexOf(p)===0&&(P=F.substr(0,F.indexOf(p)+p.length),F=F.substr(F.indexOf(p)+p.length));const K=F.split(o);for(let ne=1;l&&ne<=K.length;ne++)for(let ue=K.length-ne;l&&ue>=0;ue--){l=!1;let se=K.slice(ue,ue+ne).join(o);for(let U=0;!l&&U<r.length;U++)if(U!==s&&r[U]&&r[U].indexOf(se)>-1){const Q=ue+ne===K.length,z=ue>0&&r[U].indexOf(o)>-1?o+se:se,G=r[U].endsWith(z);l=!Q||G}if(!l){let U="";(K[0].endsWith(":")||P!=="")&&(ue===1&&(ue=0,ne++,se=K[0]+o+se),ue>0&&(U=K[0]+o),U=P+U),ue>0&&(U=U+m+o),U=U+se,ue+ne<K.length&&(U=U+o+m),a[s]=U}}l&&(a[s]=u)}return a}e.shorten=d;var v;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(v||(v={}));function c(r,o=Object.create(null)){const a=[];let l=!1,s="";for(const u of r)if(u==="$"||l&&u==="{")s&&a.push({value:s,type:v.TEXT}),s="",l=!0;else if(u==="}"&&l){const P=o[s];if(typeof P=="string")P.length&&a.push({value:P,type:v.VARIABLE});else if(P){const F=a[a.length-1];(!F||F.type!==v.SEPARATOR)&&a.push({value:P.label,type:v.SEPARATOR})}s="",l=!1}else s+=u;return s&&!l&&a.push({value:s,type:v.TEXT}),a.filter((u,P)=>{if(u.type===v.SEPARATOR){const F=a[P-1],K=a[P+1];return[F,K].every(ne=>ne&&(ne.type===v.VARIABLE||ne.type===v.TEXT)&&ne.value.length>0)}return!0}).map(u=>u.value).join("")}e.template=c;function h(r,o){return S.isMacintosh||o?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,S.isMacintosh?"&":"&&"):r.replace(/&&|&/g,a=>a==="&"?"&&":"&")}e.mnemonicMenuLabel=h;function f(r,o){return S.isMacintosh||o?r.replace(/\(&&\w\)|&&/g,""):S.isWindows?r.replace(/&&|&/g,a=>a==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=f;function i(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=i;function n(r){const o=r.indexOf("/")!==-1?k.posix:k.win32,a=o.basename(r),l=o.dirname(r);return a.length?{name:a,parentPath:l}:{name:l,parentPath:""}}e.splitName=n}),define(ve[72],be([1,0,4]),function(ie,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(D){return D.toJSON()}class k{constructor(T){this.a=T}transformIncoming(T){const C=this.a.transformIncoming(T);return C===T?T:t(b.URI.from(C))}transformOutgoing(T){const C=this.a.transformOutgoing(T);return C===T?T:t(b.URI.from(C))}transformOutgoingURI(T){const C=this.a.transformOutgoing(T);return C===T?T:b.URI.from(C)}transformOutgoingScheme(T){return this.a.transformOutgoingScheme(T)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(D){return D}transformOutgoing(D){return D}transformOutgoingURI(D){return D}transformOutgoingScheme(D){return D}};function S(D,T,C){if(!D||C>200)return null;if(typeof D=="object"){if(D instanceof b.URI)return T.transformOutgoing(D);for(const w in D)if(Object.hasOwnProperty.call(D,w)){const m=S(D[w],T,C+1);m!==null&&(D[w]=m)}}return null}function I(D,T){const C=S(D,T,0);return C===null?D:C}e.transformOutgoingURIs=I;function A(D,T,C,w){if(!D||w>200)return null;if(typeof D=="object"){if(D.$mid===1)return C?b.URI.revive(T.transformIncoming(D)):T.transformIncoming(D);for(const m in D)if(Object.hasOwnProperty.call(D,m)){const g=A(D[m],T,C,w+1);g!==null&&(D[m]=g)}}return null}function E(D,T){const C=A(D,T,!1,0);return C===null?D:C}e.transformIncomingURIs=E;function y(D,T){const C=A(D,T,!0,0);return C===null?D:C}e.transformAndReviveIncomingURIs=y}),define(ve[93],be([1,0,30,8,58,22,141]),function(ie,e,b,t,k,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(D){return this.a||(this.a=k.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(D)}value(){if(this.b===void 0){let D=0,T=0;const C=(0,b.networkInterfaces)();for(const w in C){const m=C[w];if(m)for(const{mac:g,internal:p}of m)p||(T+=1,this.c(g.toUpperCase())&&(D+=1))}this.b=T>0?D/T:0}return this.b}};let A;async function E(){return A||(A=(async()=>await y()||S.generateUuid())()),A}e.getMachineId=E;async function y(){try{const D=await new Promise((C,w)=>{ie(["crypto"],C,w)}),T=(0,I.getMac)();return D.createHash("sha256").update(T,"utf8").digest("hex")}catch(D){t.onUnexpectedError(D);return}}}),define(ve[21],be([1,0,29,30,271,14,37,87,7,3,20,4]),function(ie,e,b,t,k,S,I,A,E,y,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var C;(function(z){z[z.UNLINK=0]="UNLINK",z[z.MOVE=1]="MOVE"})(C=e.RimRafMode||(e.RimRafMode={}));async function w(z,G=C.UNLINK){if((0,I.isRootOrDriveLetter)(z))throw new Error("rimraf - will refuse to recursively delete root");return G===C.UNLINK?g(z):m(z)}async function m(z){try{const G=(0,I.randomPath)((0,t.tmpdir)());try{await b.promises.rename(z,G)}catch(X){return X.code==="ENOENT"?void 0:g(z)}g(G).catch(X=>{})}catch(G){if(G.code!=="ENOENT")throw G}}async function g(z){return(0,k.promisify)(b.rm)(z,{recursive:!0,force:!0,maxRetries:3})}function p(z){if((0,I.isRootOrDriveLetter)(z))throw new Error("rimraf - will refuse to recursively delete root");b.rmSync(z,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=p;async function d(z,G){return h(await(G?v(z):(0,k.promisify)(b.readdir)(z)))}async function v(z){try{return await(0,k.promisify)(b.readdir)(z,{withFileTypes:!0})}catch(ce){console.warn("[node.js fs] readdir with filetypes failed with error: ",ce)}const G=[],X=await d(z);for(const ce of X){let L=!1,N=!1,V=!1;try{const ee=await e.Promises.lstat((0,E.join)(z,ce));L=ee.isFile(),N=ee.isDirectory(),V=ee.isSymbolicLink()}catch(ee){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ee)}G.push({name:ce,isFile:()=>L,isDirectory:()=>N,isSymbolicLink:()=>V})}return G}function c(z){return h(b.readdirSync(z))}e.readdirSync=c;function h(z){return z.map(G=>typeof G=="string"?y.isMacintosh?(0,A.normalizeNFC)(G):G:(G.name=y.isMacintosh?(0,A.normalizeNFC)(G.name):G.name,G))}async function f(z){const G=await d(z),X=[];for(const ce of G)await n.existsDirectory((0,E.join)(z,ce))&&X.push(ce);return X}function i(z,G=1e3){return new Promise(X=>{let ce=!1;const L=setInterval(()=>{ce||(ce=!0,b.access(z,N=>{ce=!1,N&&(clearInterval(L),X(void 0))}))},G)})}e.whenDeleted=i;var n;(function(z){async function G(L){let N;try{if(N=await e.Promises.lstat(L),!N.isSymbolicLink())return{stat:N}}catch{}try{return{stat:await e.Promises.stat(L),symbolicLink:N?.isSymbolicLink()?{dangling:!1}:void 0}}catch(V){if(V.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};if(y.isWindows&&V.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(L)),symbolicLink:{dangling:!1}}}catch(ee){if(ee.code==="ENOENT"&&N)return{stat:N,symbolicLink:{dangling:!0}};throw ee}throw V}}z.stat=G;async function X(L){try{const{stat:N,symbolicLink:V}=await z.stat(L);return N.isFile()&&V?.dangling!==!0}catch{}return!1}z.existsFile=X;async function ce(L){try{const{stat:N,symbolicLink:V}=await z.stat(L);return N.isDirectory()&&V?.dangling!==!0}catch{}return!1}z.existsDirectory=ce})(n=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new S.ResourceQueue;function o(z,G,X){return r.queueFor(T.URI.file(z),D.extUriBiasedIgnorePathCase).queue(()=>{const ce=P(X);return new Promise((L,N)=>s(z,G,ce,V=>V?N(V):L()))})}let a=!0;function l(z){a=z}e.configureFlushOnWrite=l;function s(z,G,X,ce){if(!a)return b.writeFile(z,G,{mode:X.mode,flag:X.flag},ce);b.open(z,X.flag,X.mode,(L,N)=>{if(L)return ce(L);b.writeFile(N,G,V=>{if(V)return b.close(N,()=>ce(V));b.fdatasync(N,ee=>(ee&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ee),l(!1)),b.close(N,oe=>ce(oe))))})})}function u(z,G,X){const ce=P(X);if(!a)return b.writeFileSync(z,G,{mode:ce.mode,flag:ce.flag});const L=b.openSync(z,ce.flag,ce.mode);try{b.writeFileSync(L,G);try{b.fdatasyncSync(L)}catch(N){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",N),l(!1)}}finally{b.closeSync(L)}}e.writeFileSync=u;function P(z){return z?{mode:typeof z.mode=="number"?z.mode:438,flag:typeof z.flag=="string"?z.flag:"w"}:{mode:438,flag:"w"}}async function F(z,G){if(z!==G)try{await e.Promises.rename(z,G)}catch(X){if(z.toLowerCase()!==G.toLowerCase()&&X.code==="EXDEV"||z.endsWith("."))await K(z,G,{preserveSymlinks:!1}),await w(z,C.MOVE);else throw X}}async function K(z,G,X){return ue(z,G,{root:{source:z,target:G},options:X,handledSourcePaths:new Set})}const ne=511;async function ue(z,G,X){if(X.handledSourcePaths.has(z))return;X.handledSourcePaths.add(z);const{stat:ce,symbolicLink:L}=await n.stat(z);if(L){if(X.options.preserveSymlinks)try{return await Q(z,G,X)}catch(N){console.warn("[node.js fs] copy of symlink failed: ",N)}if(L.dangling)return}return ce.isDirectory()?se(z,G,ce.mode&ne,X):U(z,G,ce.mode&ne)}async function se(z,G,X,ce){await e.Promises.mkdir(G,{recursive:!0,mode:X});const L=await d(z);for(const N of L)await ue((0,E.join)(z,N),(0,E.join)(G,N),ce)}async function U(z,G,X){await e.Promises.copyFile(z,G),await e.Promises.chmod(G,X)}async function Q(z,G,X){let ce=await e.Promises.readlink(z);(0,I.isEqualOrParent)(ce,X.root.source,!y.isLinux)&&(ce=(0,E.join)(X.root.target,ce.substr(X.root.source.length+1))),await e.Promises.symlink(ce,G)}e.Promises=new class{get access(){return(0,k.promisify)(b.access)}get stat(){return(0,k.promisify)(b.stat)}get lstat(){return(0,k.promisify)(b.lstat)}get utimes(){return(0,k.promisify)(b.utimes)}get read(){return(z,G,X,ce,L)=>new Promise((N,V)=>{b.read(z,G,X,ce,L,(ee,oe,ge)=>ee?V(ee):N({bytesRead:oe,buffer:ge}))})}get readFile(){return(0,k.promisify)(b.readFile)}get write(){return(z,G,X,ce,L)=>new Promise((N,V)=>{b.write(z,G,X,ce,L,(ee,oe,ge)=>ee?V(ee):N({bytesWritten:oe,buffer:ge}))})}get appendFile(){return(0,k.promisify)(b.appendFile)}get fdatasync(){return(0,k.promisify)(b.fdatasync)}get truncate(){return(0,k.promisify)(b.truncate)}get rename(){return(0,k.promisify)(b.rename)}get copyFile(){return(0,k.promisify)(b.copyFile)}get open(){return(0,k.promisify)(b.open)}get close(){return(0,k.promisify)(b.close)}get symlink(){return(0,k.promisify)(b.symlink)}get readlink(){return(0,k.promisify)(b.readlink)}get chmod(){return(0,k.promisify)(b.chmod)}get mkdir(){return(0,k.promisify)(b.mkdir)}get unlink(){return(0,k.promisify)(b.unlink)}get rmdir(){return(0,k.promisify)(b.rmdir)}get realpath(){return(0,k.promisify)(b.realpath)}async exists(z){try{return await e.Promises.access(z),!0}catch{return!1}}get readdir(){return d}get readDirsInDir(){return f}get writeFile(){return o}get rm(){return w}get move(){return F}get copy(){return K}}}),define(ve[155],be([1,0,29,7,3,15,21]),function(ie,e,b,t,k,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function A(C){if(k.isLinux)return C;const w=(0,t.dirname)(C);if(C===w)return C;const m=((0,t.basename)(C)||C).toLowerCase();try{const p=(0,I.readdirSync)(w).filter(d=>d.toLowerCase()===m);if(p.length===1){const d=A(w);if(d)return(0,t.join)(d,p[0])}else if(p.length>1){const d=p.indexOf(m);if(d>=0){const v=A(w);if(v)return(0,t.join)(v,p[d])}}}catch{}return null}e.realcaseSync=A;async function E(C){if(k.isLinux)return C;const w=(0,t.dirname)(C);if(C===w)return C;const m=((0,t.basename)(C)||C).toLowerCase();try{const p=(await I.Promises.readdir(w)).filter(d=>d.toLowerCase()===m);if(p.length===1){const d=await E(w);if(d)return(0,t.join)(d,p[0])}else if(p.length>1){const d=p.indexOf(m);if(d>=0){const v=await E(w);if(v)return(0,t.join)(v,p[d])}}}catch{}return null}e.realcase=E;async function y(C){try{return await I.Promises.realpath(C)}catch{const m=T(C);return await I.Promises.access(m,b.constants.R_OK),m}}e.realpath=y;function D(C){try{return b.realpathSync(C)}catch{const m=T(C);return b.accessSync(m,b.constants.R_OK),m}}e.realpathSync=D;function T(C){return(0,S.rtrim)((0,t.normalize)(C),t.sep)}}),define(ve[94],be([1,0,30,7,21]),function(ie,e,b,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const S=/^\d+$/,I=/^Microsoft.PowerShell_.*/,A=/^Microsoft.PowerShellPreview_.*/;var E;(function(h){h[h.x64=0]="x64",h[h.x86=1]="x86",h[h.ARM=2]="ARM"})(E||(E={}));let y;switch(process.arch){case"ia32":case"x32":y=1;break;case"arm":case"arm64":y=2;break;default:y=0;break}let D;process.env.PROCESSOR_ARCHITEW6432?D=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?D=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?D=1:D=0;class T{constructor(f,i,n){this.exePath=f,this.displayName=i,this.a=n}async exists(){return this.a===void 0&&(this.a=await k.SymlinkSupport.existsFile(this.exePath)),this.a}}function C({useAlternateBitness:h=!1}={}){return h?y===0?process.env["ProgramFiles(x86)"]||null:D===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function w({useAlternateBitness:h=!1,findPreview:f=!1}={}){const i=C({useAlternateBitness:h});if(!i)return null;const n=t.join(i,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(n))return null;let r=-1,o=null;for(const s of await k.Promises.readdir(n)){let u=-1;if(f){const F=s.indexOf("-");if(F<0)continue;const K=s.substring(0,F);if(!S.test(K)||s.substring(F+1)!=="preview")continue;u=parseInt(K,10)}else{if(!S.test(s))continue;u=parseInt(s,10)}if(u<=r)continue;const P=t.join(n,s,"pwsh.exe");!await k.SymlinkSupport.existsFile(P)||(o=P,r=u)}if(!o)return null;const a=i.includes("x86")?" (x86)":"",l=f?" Preview":"";return new T(o,`PowerShell${l}${a}`,!0)}async function m({findPreview:h}={}){if(!process.env.LOCALAPPDATA)return null;const f=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(f))return null;const{pwshMsixDirRegex:i,pwshMsixName:n}=h?{pwshMsixDirRegex:A,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:I,pwshMsixName:"PowerShell (Store)"};for(const r of await k.Promises.readdir(f))if(i.test(r)){const o=t.join(f,r,"pwsh.exe");return new T(o,n)}return null}function g(){const h=t.join(b.homedir(),".dotnet","tools","pwsh.exe");return new T(h,".NET Core PowerShell Global Tool")}function p(){const h=t.join(process.env.windir,y===1&&D!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new T(h,"Windows PowerShell",!0)}async function*d(){let h=await w();h&&(yield h),h=await w({useAlternateBitness:!0}),h&&(yield h),h=await m(),h&&(yield h),h=g(),h&&(yield h),h=await w({findPreview:!0}),h&&(yield h),h=await m({findPreview:!0}),h&&(yield h),h=await w({useAlternateBitness:!0,findPreview:!0}),h&&(yield h),h=p(),h&&(yield h)}async function*v(){for await(const h of d())await h.exists()&&(yield h)}e.enumeratePowerShellInstallations=v;async function c(){for await(const h of v())return h;return null}e.getFirstAvailablePowerShellInstallation=c}),define(ve[95],be([1,0,7,3,27,57,11,21]),function(ie,e,b,t,k,S,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return S.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return S.TerminateResponseCode}});function E(T=k.env){return T.comspec||"cmd.exe"}e.getWindowsShell=E;function y(T){let C=[],w=!1;const m=function(g){if(w){C.push(g);return}(!T.send(g,d=>{if(d&&console.error(d),w=!1,C.length>0){const v=C.slice(0);C=[],v.forEach(c=>m(c))}})||t.isWindows)&&(w=!0)};return{send:m}}e.createQueuedSender=y;var D;(function(T){async function C(w,m,g){if(b.isAbsolute(w))return w;if(m===void 0&&(m=k.cwd()),b.dirname(w)!=="."||(g===void 0&&I.isString(k.env.PATH)&&(g=k.env.PATH.split(b.delimiter)),g===void 0||g.length===0))return b.join(m,w);async function d(v){if(await A.Promises.exists(v)){let c;try{c=await A.Promises.stat(v)}catch(h){h.message.startsWith("EACCES")&&(c=await A.Promises.lstat(v))}return c?!c.isDirectory():!1}return!1}for(const v of g){let c;if(b.isAbsolute(v)?c=b.join(v,w):c=b.join(m,v,w),await d(c))return c;let h=c+".com";if(await d(h)||(h=c+".exe",await d(h)))return h}return b.join(m,w)}T.findExecutable=C})(D=e.win32||(e.win32={}))}),define(ve[96],be([1,0,48,13]),function(ie,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function k(I){return new Promise((A,E)=>{let y;const D=new Map;function T(w,m,g,p,d){const v=D.get(m);if(w===I||v){const c={name:C(g),cmd:g,pid:w,ppid:m,load:p,mem:d};D.set(w,c),w===I&&(y=c),v&&(v.children||(v.children=[]),v.children.push(c),v.children.length>1&&(v.children=v.children.sort((h,f)=>h.pid-f.pid)))}}function C(w){const m=/--vscode-window-kind=shared-process/,g=/--vscode-window-kind=issue-reporter/,p=/--vscode-window-kind=process-explorer/,d=/--utility-sub-type=network/,v=/--utility-sub-type=node.mojom.NodeService/,c=/--crashes-directory/,h=/\\pipe\\winpty-control/,f=/conhost\.exe/,i=/--type=([a-zA-Z-]+)/;if(c.exec(w))return"electron-crash-reporter";if(h.exec(w))return"winpty-process";if(f.exec(w))return"console-window-host (Windows internal process)";let n=i.exec(w);if(n&&n.length===2){if(n[1]==="renderer")return m.exec(w)?"shared-process":g.exec(w)?"issue-reporter":p.exec(w)?"process-explorer":"window";if(n[1]==="utility"){if(d.exec(w))return"utility-network-service";if(v.exec(w))return"extension-host"}return n[1]}const r=/[a-zA-Z-]+\.js/g;let o="";do n=r.exec(w),n&&(o+=n+" ");while(n);return o&&w.indexOf("node ")<0&&w.indexOf("node.exe")<0?`electron_node ${o}`:w}if(process.platform==="win32"){const w=m=>m.indexOf("\\\\?\\")===0||m.indexOf("\\??\\")===0?m.substr(4):m.indexOf('"\\\\?\\')===0||m.indexOf('"\\??\\')===0?'"'+m.substr(5):m;new Promise((m,g)=>{ie(["windows-process-tree"],m,g)}).then(m=>{m.getProcessList(I,g=>{if(!g){E(new Error(`Root process ${I} not found`));return}m.getProcessCpuUsage(g,p=>{const d=new Map;p.forEach(v=>{const c=w(v.commandLine||"");d.set(v.pid,{name:C(c),cmd:c,pid:v.pid,ppid:v.ppid,load:v.cpu||0,mem:v.memory||0})}),y=d.get(I),y?(d.forEach(v=>{const c=d.get(v.ppid);c&&(c.children||(c.children=[]),c.children.push(v))}),d.forEach(v=>{v.children&&(v.children=v.children.sort((c,h)=>c.pid-h.pid))}),A(y)):E(new Error(`Root process ${I} not found`))})},m.ProcessDataFlag.CommandLine|m.ProcessDataFlag.Memory)})}else{let w=function(){let m=[y];const g=[];for(;m.length;){const d=m.shift();d&&(g.push(d.pid),d.children&&(m=m.concat(d.children)))}let p=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);p+=" "+g.join(" "),(0,b.exec)(p,{},(d,v,c)=>{if(d||c)E(d||new Error(c.toString()));else{const h=v.toString().split(`
`);for(let f=0;f<g.length;f++){const i=D.get(g[f]);i.load=parseFloat(h[f])}if(!y){E(new Error(`Root process ${I} not found`));return}A(y)}})};(0,b.exec)("which ps",{},(m,g,p)=>{if(m||p)if(process.platform!=="linux")E(m||new Error(p.toString()));else{const d=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,b.exec)(d,{},(v,c,h)=>{v||h?E(v||new Error(h.toString())):(S(c,T),w())})}else{const d=g.toString().trim(),v="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,b.exec)(`${d} ${v}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(c,h,f)=>{c||f&&!f.includes("screen size is bogus")?E(c||new Error(f.toString())):(S(h,T),process.platform==="linux"?w():y?A(y):E(new Error(`Root process ${I} not found`)))})}})}})}e.listProcesses=k;function S(I,A){const E=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,y=I.toString().split(`
`);for(const D of y){const T=E.exec(D.trim());T&&T.length===6&&A(parseInt(T[1]),parseInt(T[2]),T[5],parseFloat(T[3]),parseFloat(T[4]))}}}),define(ve[156],be([1,0,30,3,94,95]),function(ie,e,b,t,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function I(w,m){return w===1?t.isWindows?T():S.getWindowsShell(m):y(w,m)}e.getSystemShell=I;function A(w,m){return w===1?t.isWindows?C(m):S.getWindowsShell(m):y(w,m)}e.getSystemShellSync=A;let E=null;function y(w,m){if(t.isLinux&&w===2||t.isMacintosh&&w===3)return"/bin/bash";if(!E){let g;if(t.isWindows)g="/bin/bash";else{if(g=m.SHELL,!g)try{g=(0,b.userInfo)().shell}catch{}g||(g="sh"),g==="/bin/false"&&(g="/bin/bash")}E=g}return E}let D=null;async function T(){return D||(D=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),D}function C(w){if(D)return D;const m=t.isWindows&&parseFloat((0,b.release)())>=10,g=w.hasOwnProperty("PROCESSOR_ARCHITEW6432"),p=`${w.windir}\\${g?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return m?p:S.getWindowsShell(w)}});var Le=this&&this.__decorate||function(ie,e,b,t){var k=arguments.length,S=k<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,b):t,I;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")S=Reflect.decorate(ie,e,b,t);else for(var A=ie.length-1;A>=0;A--)(I=ie[A])&&(S=(k<3?I(S):k>3?I(e,b,S):I(e,b))||S);return k>3&&S&&Object.defineProperty(e,b,S),S};define(ve[41],be([1,0,18,14,16,19,84,8,6,2,47,15,11]),function(ie,e,b,t,k,S,I,A,E,y,D,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=void 0;var w;(function(L){L[L.Promise=100]="Promise",L[L.PromiseCancel=101]="PromiseCancel",L[L.EventListen=102]="EventListen",L[L.EventDispose=103]="EventDispose"})(w||(w={}));function m(L){switch(L){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var g;(function(L){L[L.Initialize=200]="Initialize",L[L.PromiseSuccess=201]="PromiseSuccess",L[L.PromiseError=202]="PromiseError",L[L.PromiseErrorObj=203]="PromiseErrorObj",L[L.EventFire=204]="EventFire"})(g||(g={}));function p(L){switch(L){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var d;(function(L){L[L.Uninitialized=0]="Uninitialized",L[L.Idle=1]="Idle"})(d||(d={}));class v{constructor(N){this.b=N,this.a=0}read(N){const V=this.b.slice(this.a,this.a+N);return this.a+=V.byteLength,V}}class c{constructor(){this.a=[]}get buffer(){return k.VSBuffer.concat(this.a)}write(N){this.a.push(N)}}var h;(function(L){L[L.Undefined=0]="Undefined",L[L.String=1]="String",L[L.Buffer=2]="Buffer",L[L.VSBuffer=3]="VSBuffer",L[L.Array=4]="Array",L[L.Object=5]="Object"})(h||(h={}));function f(L){const N=k.VSBuffer.alloc(4);return N.writeUInt32BE(L,0),N}function i(L){return L.read(4).readUInt32BE(0)}function n(L){const N=k.VSBuffer.alloc(1);return N.writeUInt8(L,0),N}const r={Undefined:n(h.Undefined),String:n(h.String),Buffer:n(h.Buffer),VSBuffer:n(h.VSBuffer),Array:n(h.Array),Object:n(h.Object)},o=typeof Buffer<"u";function a(L,N){if(typeof N>"u")L.write(r.Undefined);else if(typeof N=="string"){const V=k.VSBuffer.fromString(N);L.write(r.String),L.write(f(V.byteLength)),L.write(V)}else if(o&&Buffer.isBuffer(N)){const V=k.VSBuffer.wrap(N);L.write(r.Buffer),L.write(f(V.byteLength)),L.write(V)}else if(N instanceof k.VSBuffer)L.write(r.VSBuffer),L.write(f(N.byteLength)),L.write(N);else if(Array.isArray(N)){L.write(r.Array),L.write(f(N.length));for(const V of N)a(L,V)}else{const V=k.VSBuffer.fromString(JSON.stringify(N));L.write(r.Object),L.write(f(V.byteLength)),L.write(V)}}function l(L){switch(L.read(1).readUInt8(0)){case h.Undefined:return;case h.String:return L.read(i(L)).toString();case h.Buffer:return L.read(i(L)).buffer;case h.VSBuffer:return L.read(i(L));case h.Array:{const V=i(L),ee=[];for(let oe=0;oe<V;oe++)ee.push(l(L));return ee}case h.Object:return JSON.parse(L.read(i(L)).toString())}}class s{constructor(N,V,ee=null,oe=1e3){this.h=N,this.j=V,this.k=ee,this.l=oe,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ge=>this.p(ge)),this.m({type:200})}registerChannel(N,V){this.b.set(N,V),setTimeout(()=>this.v(N),0)}m(N){switch(N.type){case 200:{const V=this.n([N.type]);this.k?.logOutgoing(V,0,1,p(N.type));return}case 201:case 202:case 204:case 203:{const V=this.n([N.type,N.id],N.data);this.k?.logOutgoing(V,N.id,1,p(N.type),N.data);return}}}n(N,V=void 0){const ee=new c;return a(ee,N),a(ee,V),this.o(ee.buffer)}o(N){try{return this.h.send(N),N.byteLength}catch{return 0}}p(N){const V=new v(N),ee=l(V),oe=l(V),ge=ee[0];switch(ge){case 100:return this.k?.logIncoming(N.byteLength,ee[1],1,`${m(ge)}: ${ee[2]}.${ee[3]}`,oe),this.q({type:ge,id:ee[1],channelName:ee[2],name:ee[3],arg:oe});case 102:return this.k?.logIncoming(N.byteLength,ee[1],1,`${m(ge)}: ${ee[2]}.${ee[3]}`,oe),this.s({type:ge,id:ee[1],channelName:ee[2],name:ee[3],arg:oe});case 101:return this.k?.logIncoming(N.byteLength,ee[1],1,`${m(ge)}`),this.t({type:ge,id:ee[1]});case 103:return this.k?.logIncoming(N.byteLength,ee[1],1,`${m(ge)}`),this.t({type:ge,id:ee[1]})}}q(N){const V=this.b.get(N.channelName);if(!V){this.u(N);return}const ee=new S.CancellationTokenSource;let oe;try{oe=V.call(this.j,N.name,N.arg,ee.token)}catch(R){oe=Promise.reject(R)}const ge=N.id;oe.then(R=>{this.m({id:ge,data:R,type:201}),this.d.delete(N.id)},R=>{R instanceof Error?this.m({id:ge,data:{message:R.message,name:R.name,stack:R.stack?R.stack.split?R.stack.split(`
`):R.stack:void 0},type:202}):this.m({id:ge,data:R,type:203}),this.d.delete(N.id)});const fe=(0,y.toDisposable)(()=>ee.cancel());this.d.set(N.id,fe)}s(N){const V=this.b.get(N.channelName);if(!V){this.u(N);return}const ee=N.id,ge=V.listen(this.j,N.name,N.arg)(fe=>this.m({id:ee,data:fe,type:204}));this.d.set(N.id,ge)}t(N){const V=this.d.get(N.id);V&&(V.dispose(),this.d.delete(N.id))}u(N){let V=this.g.get(N.channelName);V||(V=[],this.g.set(N.channelName,V));const ee=setTimeout(()=>{console.error(`Unknown channel: ${N.channelName}`),N.type===100&&this.m({id:N.id,data:{name:"Unknown channel",message:`Channel name '${N.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);V.push({request:N,timeoutTimer:ee})}v(N){const V=this.g.get(N);if(V){for(const ee of V)switch(clearTimeout(ee.timeoutTimer),ee.request.type){case 100:this.q(ee.request);break;case 102:this.s(ee.request);break}this.g.delete(N)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,y.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=s;var u;(function(L){L[L.LocalSide=0]="LocalSide",L[L.OtherSide=1]="OtherSide"})(u=e.RequestInitiator||(e.RequestInitiator={}));class P{constructor(N,V=null){this.l=N,this.a=!1,this.b=d.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new E.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ee=>this.r(ee)),this.j=V}getChannel(N){const V=this;return{call(ee,oe,ge){return V.a?Promise.reject(new A.CancellationError):V.m(N,ee,oe,ge)},listen(ee,oe){return V.a?E.Event.None:V.n(N,ee,oe)}}}m(N,V,ee,oe=S.CancellationToken.None){const ge=this.g++,R={id:ge,type:100,channelName:N,name:V,arg:ee};if(oe.isCancellationRequested)return Promise.reject(new A.CancellationError);let M;return new Promise((Y,re)=>{if(oe.isCancellationRequested)return re(new A.CancellationError);const me=()=>{const j=H=>{switch(H.type){case 201:this.f.delete(ge),Y(H.data);break;case 202:{this.f.delete(ge);const q=new Error(H.data.message);q.stack=Array.isArray(H.data.stack)?H.data.stack.join(`
`):H.data.stack,q.name=H.data.name,re(q);break}case 203:this.f.delete(ge),re(H.data);break}};this.f.set(ge,j),this.o(R)};let $=null;this.b===d.Idle?me():($=(0,t.createCancelablePromise)(j=>this.t()),$.then(()=>{$=null,me()}));const J=()=>{$?($.cancel(),$=null):this.o({id:ge,type:101}),re(new A.CancellationError)},_=oe.onCancellationRequested(J);M=(0,y.combinedDisposable)((0,y.toDisposable)(J),_),this.d.add(M)}).finally(()=>{this.d.delete(M)})}n(N,V,ee){const oe=this.g++,fe={id:oe,type:102,channelName:N,name:V,arg:ee};let R=null;const M=new E.Emitter({onWillAddFirstListener:()=>{R=(0,t.createCancelablePromise)(Y=>this.t()),R.then(()=>{R=null,this.d.add(M),this.o(fe)})},onDidRemoveLastListener:()=>{R?(R.cancel(),R=null):(this.d.delete(M),this.o({id:oe,type:103}))}}),W=Y=>M.fire(Y.data);return this.f.set(oe,W),M.event}o(N){switch(N.type){case 100:case 102:{const V=this.p([N.type,N.id,N.channelName,N.name],N.arg);this.j?.logOutgoing(V,N.id,0,`${m(N.type)}: ${N.channelName}.${N.name}`,N.arg);return}case 101:case 103:{const V=this.p([N.type,N.id]);this.j?.logOutgoing(V,N.id,0,m(N.type));return}}}p(N,V=void 0){const ee=new c;return a(ee,N),a(ee,V),this.q(ee.buffer)}q(N){try{return this.l.send(N),N.byteLength}catch{return 0}}r(N){const V=new v(N),ee=l(V),oe=l(V),ge=ee[0];switch(ge){case 200:return this.j?.logIncoming(N.byteLength,0,0,p(ge)),this.s({type:ee[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(N.byteLength,ee[1],0,p(ge),oe),this.s({type:ee[0],id:ee[1],data:oe})}}s(N){if(N.type===200){this.b=d.Idle,this.k.fire();return}this.f.get(N.id)?.(N)}get onDidInitializePromise(){return E.Event.toPromise(this.onDidInitialize)}t(){return this.b===d.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,y.dispose)(this.d.values()),this.d.clear()}}Le([I.memoize],P.prototype,"onDidInitializePromise",null),e.ChannelClient=P;class F{get connections(){const N=[];return this.f.forEach(V=>N.push(V)),N}constructor(N){this.a=new Map,this.f=new Set,this.g=new E.Emitter,this.onDidAddConnection=this.g.event,this.h=new E.Emitter,this.onDidRemoveConnection=this.h.event,N(({protocol:V,onDidClientDisconnect:ee})=>{E.Event.once(V.onMessage)(ge=>{const fe=new v(ge),R=l(fe),M=new s(V,R),W=new P(V);this.a.forEach((re,me)=>M.registerChannel(me,re));const Y={channelServer:M,channelClient:W,ctx:R};this.f.add(Y),this.g.fire(Y),ee(()=>{M.dispose(),W.dispose(),this.f.delete(Y),this.h.fire(Y)})})})}getChannel(N,V){const ee=this;return{call(oe,ge,fe){let R;if((0,C.isFunction)(V)){const W=(0,b.getRandomElement)(ee.connections.filter(V));R=W?Promise.resolve(W):E.Event.toPromise(E.Event.filter(ee.onDidAddConnection,V))}else R=V.routeCall(ee,oe,ge);const M=R.then(W=>W.channelClient.getChannel(N));return ne(M).call(oe,ge,fe)},listen(oe,ge){if((0,C.isFunction)(V))return ee.j(N,V,oe,ge);const fe=V.routeEvent(ee,oe,ge).then(R=>R.channelClient.getChannel(N));return ne(fe).listen(oe,ge)}}}j(N,V,ee,oe){const ge=this;let fe=new y.DisposableStore;const R=new E.Emitter({onWillAddFirstListener:()=>{fe=new y.DisposableStore;const M=new E.EventMultiplexer,W=new Map,Y=me=>{const J=me.channelClient.getChannel(N).listen(ee,oe),_=M.add(J);W.set(me,_)},re=me=>{const $=W.get(me);!$||($.dispose(),W.delete(me))};ge.connections.filter(V).forEach(Y),E.Event.filter(ge.onDidAddConnection,V)(Y,void 0,fe),ge.onDidRemoveConnection(re,void 0,fe),M.event(R.fire,R,fe),fe.add(M)},onDidRemoveLastListener:()=>{fe.dispose()}});return R.event}registerChannel(N,V){this.a.set(N,V),this.f.forEach(ee=>{ee.channelServer.registerChannel(N,V)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=F;class K{constructor(N,V,ee=null){const oe=new c;a(oe,V),N.send(oe.buffer),this.a=new P(N,ee),this.d=new s(N,V,ee)}getChannel(N){return this.a.getChannel(N)}registerChannel(N,V){this.d.registerChannel(N,V)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=K;function ne(L){return{call(N,V,ee){return L.then(oe=>oe.call(N,V,ee))},listen(N,V){const ee=new E.Relay;return L.then(oe=>ee.input=oe.listen(N,V)),ee.event}}}e.getDelayedChannel=ne;function ue(L){let N=!1;return{call(V,ee,oe){return N?L.call(V,ee,oe):(0,t.timeout)(0).then(()=>N=!0).then(()=>L.call(V,ee,oe))},listen(V,ee){if(N)return L.listen(V,ee);const oe=new E.Relay;return(0,t.timeout)(0).then(()=>N=!0).then(()=>oe.input=L.listen(V,ee)),oe.event}}}e.getNextTickChannel=ue;class se{constructor(N){this.a=N}routeCall(N){return this.b(N)}routeEvent(N){return this.b(N)}async b(N){for(const V of N.connections)if(await Promise.resolve(this.a(V.ctx)))return Promise.resolve(V);return await E.Event.toPromise(N.onDidAddConnection),await this.b(N)}}e.StaticRouter=se;var U;(function(L){function N(ge,fe){const R=ge,M=fe&&fe.disableMarshalling,W=new Map;for(const Y in R)ee(Y)&&W.set(Y,E.Event.buffer(R[Y],!0));return new class{listen(Y,re,me){const $=W.get(re);if($)return $;if(oe(re)){const J=R[re];if(typeof J=="function")return J.call(R,me)}throw new Error(`Event not found: ${re}`)}call(Y,re,me){const $=R[re];if(typeof $=="function"){if(!M&&Array.isArray(me))for(let J=0;J<me.length;J++)me[J]=(0,D.revive)(me[J]);return $.apply(R,me)}throw new Error(`Method not found: ${re}`)}}}L.fromService=N;function V(ge,fe){const R=fe&&fe.disableMarshalling;return new Proxy({},{get(M,W){if(typeof W=="string")return fe?.properties?.has(W)?fe.properties.get(W):oe(W)?function(Y){return ge.listen(W,Y)}:ee(W)?ge.listen(W):async function(...Y){let re;fe&&!(0,C.isUndefinedOrNull)(fe.context)?re=[fe.context,...Y]:re=Y;const me=await ge.call(W,re);return R?me:(0,D.revive)(me)};throw new Error(`Property not found: ${String(W)}`)}})}L.toService=V;function ee(ge){return ge[0]==="o"&&ge[1]==="n"&&T.isUpperAsciiLetter(ge.charCodeAt(2))}function oe(ge){return/^onDynamic/.test(ge)&&T.isUpperAsciiLetter(ge.charCodeAt(9))}})(U=e.ProxyChannel||(e.ProxyChannel={}));const Q=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function z(L){if(Array.isArray(L))return L;if(L&&typeof L=="object"&&typeof L.toString=="function"){const N=L.toString();if(N!=="[object Object]")return N}return L}function G(L){return Array.isArray(L)?L.map(z):z(L)}function X(L,N,V,ee,oe,ge,fe){fe=G(fe);const R=Q[oe],M=R[ee%R.length];let W=[`%c[${L}]%c[${String(N).padStart(7," ")}]%c[len: ${String(V).padStart(5," ")}]%c${String(ee).padStart(5," ")} - ${ge}`,"color: darkgreen","color: grey","color: grey",`color: ${M}`];/\($/.test(ge)?(W=W.concat(fe),W.push(")")):W.push(fe),console.log.apply(console,W)}class ce{constructor(N,V){this.d=N,this.f=V,this.a=0,this.b=0}logOutgoing(N,V,ee,oe,ge){this.b+=N,X(this.d,this.b,N,V,ee,oe,ge)}logIncoming(N,V,ee,oe,ge){this.a+=N,X(this.f,this.a,N,V,ee,oe,ge)}}e.IPCLogger=ce}),define(ve[97],be([1,0,16,6,2,41]),function(ie,e,b,t,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var I;(function(o){o.Created="created",o.Read="read",o.Write="write",o.Open="open",o.Error="error",o.Close="close",o.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",o.NodeEndReceived="nodeEndReceived",o.NodeEndSent="nodeEndSent",o.NodeDrainBegin="nodeDrainBegin",o.NodeDrainEnd="nodeDrainEnd",o.zlibInflateError="zlibInflateError",o.zlibInflateData="zlibInflateData",o.zlibInflateInitialWrite="zlibInflateInitialWrite",o.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",o.zlibInflateWrite="zlibInflateWrite",o.zlibInflateFlushFired="zlibInflateFlushFired",o.zlibDeflateError="zlibDeflateError",o.zlibDeflateData="zlibDeflateData",o.zlibDeflateWrite="zlibDeflateWrite",o.zlibDeflateFlushFired="zlibDeflateFlushFired",o.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",o.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",o.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",o.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",o.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",o.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",o.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",o.ProtocolHeaderRead="protocolHeaderRead",o.ProtocolMessageRead="protocolMessageRead",o.ProtocolHeaderWrite="protocolHeaderWrite",o.ProtocolMessageWrite="protocolMessageWrite",o.ProtocolWrite="protocolWrite"})(I=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var A;(function(o){o.enableDiagnostics=!1,o.records=[];const a=new WeakMap;let l=0;function s(P,F){if(!a.has(P)){const K=String(++l);a.set(P,K)}return a.get(P)}function u(P,F,K,ne){if(!o.enableDiagnostics)return;const ue=s(P,F);if(ne instanceof b.VSBuffer||ne instanceof Uint8Array||ne instanceof ArrayBuffer||ArrayBuffer.isView(ne)){const se=b.VSBuffer.alloc(ne.byteLength);se.set(ne),o.records.push({timestamp:Date.now(),id:ue,label:F,type:K,buff:se})}else o.records.push({timestamp:Date.now(),id:ue,label:F,type:K,data:ne})}o.traceSocketEvent=u})(A=e.SocketDiagnostics||(e.SocketDiagnostics={}));var E;(function(o){o[o.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",o[o.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(E=e.SocketCloseEventType||(e.SocketCloseEventType={}));let y=null;function D(){return y||(y=b.VSBuffer.alloc(0)),y}class T{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(a){this.a.push(a),this.b+=a.byteLength}read(a){return this.c(a,!0)}peek(a){return this.c(a,!1)}c(a,l){if(a===0)return D();if(a>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===a){const F=this.a[0];return l&&(this.a.shift(),this.b-=a),F}if(this.a[0].byteLength>a){const F=this.a[0].slice(0,a);return l&&(this.a[0]=this.a[0].slice(a),this.b-=a),F}const s=b.VSBuffer.alloc(a);let u=0,P=0;for(;a>0;){const F=this.a[P];if(F.byteLength>a){const K=F.slice(0,a);s.set(K,u),u+=a,l&&(this.a[P]=F.slice(a),this.b-=a),a-=a}else s.set(F,u),u+=F.byteLength,l?(this.a.shift(),this.b-=F.byteLength):P++,a-=F.byteLength}return s}}e.ChunkStream=T;var C;(function(o){o[o.None=0]="None",o[o.Regular=1]="Regular",o[o.Control=2]="Control",o[o.Ack=3]="Ack",o[o.Disconnect=5]="Disconnect",o[o.ReplayRequest=6]="ReplayRequest",o[o.Pause=7]="Pause",o[o.Resume=8]="Resume",o[o.KeepAlive=9]="KeepAlive"})(C||(C={}));function w(o){switch(o){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var m;(function(o){o[o.HeaderLength=13]="HeaderLength",o[o.AcknowledgeTime=2e3]="AcknowledgeTime",o[o.TimeoutTime=2e4]="TimeoutTime",o[o.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",o[o.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(m=e.ProtocolConstants||(e.ProtocolConstants={}));class g{constructor(a,l,s,u){this.type=a,this.id=l,this.ack=s,this.data=u,this.writtenTime=0}get size(){return this.data.byteLength}}class p extends k.Disposable{constructor(a){super(),this.f=this.B(new t.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=a,this.b=!1,this.c=new T,this.B(this.a.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(a){if(!(!a||a.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(a);this.c.byteLength>=this.g.readLen;){const l=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=l.readUInt32BE(9),this.g.messageType=l.readUInt8(0),this.g.id=l.readUInt32BE(1),this.g.ack=l.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:w(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const s=this.g.messageType,u=this.g.id,P=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",l),this.f.fire(new g(s,u,P,l)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class d{constructor(a){this.k=null,this.a=!1,this.b=!1,this.c=a,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(a){if(this.a)return;a.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=b.VSBuffer.alloc(13);l.writeUInt8(a.type,0),l.writeUInt32BE(a.id,1),l.writeUInt32BE(a.ack,5),l.writeUInt32BE(a.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:w(a.type),id:a.id,ack:a.ack,messageSize:a.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",a.data),this.j(l,a.data)}g(a,l){const s=this.f===0;return this.d.push(a,l),this.f+=a.byteLength+l.byteLength,s}h(){const a=b.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,a}j(a,l){this.g(a,l)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const a=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:a.byteLength}),this.c.write(a)}}class v extends k.Disposable{constructor(a){super(),this.f=new t.Emitter,this.onMessage=this.f.event,this.g=new t.Emitter,this.onDidDispose=this.g.event,this.a=a,this.b=this.B(new d(this.a)),this.c=this.B(new p(this.a)),this.B(this.c.onMessage(l=>{l.type===1&&this.f.fire(l.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(a){this.b.write(new g(1,0,0,a))}}e.Protocol=v;class c extends S.IPCClient{static fromSocket(a,l){return new c(new v(a),l)}get onDidDispose(){return this.b.onDidDispose}constructor(a,l,s=null){super(a,l,s),this.b=a}dispose(){super.dispose();const a=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),a.end()}}e.Client=c;class h{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new t.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(a){this.b?this.d.length>0?this.d.push(a):this.a.fire(a):this.d.push(a)}flushBuffer(){this.d=[]}}e.BufferedEmitter=h;class f{constructor(a){this.data=a,this.next=null}}class i{constructor(){this.a=null,this.b=null}length(){let a=0,l=this.a;for(;l;)l=l.next,a++;return a}peek(){return this.a?this.a.data:null}toArray(){const a=[];let l=0,s=this.a;for(;s;)a[l++]=s.data,s=s.next;return a}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(a){const l=new f(a);if(!this.a){this.a=l,this.b=l;return}this.b.next=l,this.b=l}}class n{static getInstance(){return n.b||(n.b=new n),n.b}constructor(){this.c=[];const a=Date.now();for(let l=0;l<n.a;l++)this.c[l]=a-1e3*l;setInterval(()=>{for(let l=n.a;l>=1;l--)this.c[l]=this.c[l-1];this.c[0]=Date.now()},1e3)}d(){const a=Date.now(),l=(1+n.a)*1e3;let s=0;for(let u=0;u<n.a;u++)a-this.c[u]<=l&&s++;return 1-s/n.a}hasHighLoad(){return this.d()>=.5}}n.a=10,n.b=null;class r{get unacknowledgedCount(){return this.c-this.d}constructor(a,l=null,s=n.getInstance()){this.t=new h,this.onControlMessage=this.t.event,this.u=new h,this.onMessage=this.u.event,this.v=new h,this.onDidDispose=this.v.event,this.w=new h,this.onSocketClose=this.w.event,this.x=new h,this.onSocketTimeout=this.x.event,this.s=s,this.a=!1,this.b=new i,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=[],this.o=a,this.p=new d(this.o),this.r.push(this.p),this.q=new p(this.o),this.r.push(this.q),this.r.push(this.q.onMessage(u=>this.y(u))),this.r.push(this.o.onClose(u=>this.w.fire(u))),l&&this.q.acceptChunk(l),this.l=setInterval(()=>{this.C()},5e3)}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r=(0,k.dispose)(this.r)}drain(){return this.p.drain()}sendDisconnect(){const a=new g(5,0,0,D());this.p.write(a),this.p.flush()}sendPause(){const a=new g(7,0,0,D());this.p.write(a)}sendResume(){const a=new g(8,0,0,D());this.p.write(a)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(a,l){this.a=!0,this.r=(0,k.dispose)(this.r),this.t.flushBuffer(),this.w.flushBuffer(),this.x.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=a,this.p=new d(this.o),this.r.push(this.p),this.q=new p(this.o),this.r.push(this.q),this.r.push(this.q.onMessage(s=>this.y(s))),this.r.push(this.o.onClose(s=>this.w.fire(s))),this.q.acceptChunk(l)}endAcceptReconnection(){this.a=!1,this.h=this.g;const a=new g(3,0,this.h,D());this.p.write(a);const l=this.b.toArray();for(let s=0,u=l.length;s<u;s++)this.p.write(l[s]);this.A()}acceptDisconnect(){this.v.fire()}y(a){if(a.ack>this.d){this.d=a.ack;do{const l=this.b.peek();if(l&&l.id<=a.ack)this.b.pop();else break}while(!0)}switch(a.type){case 0:break;case 1:{if(a.id>this.g)if(a.id!==this.g+1){const l=Date.now();l-this.m>1e4&&(this.m=l,this.p.write(new g(6,0,0,D())))}else this.g=a.id,this.j=Date.now(),this.z(),this.u.fire(a.data);break}case 2:{this.t.fire(a.data);break}case 3:break;case 5:{this.v.fire();break}case 6:{const l=this.b.toArray();for(let s=0,u=l.length;s<u;s++)this.p.write(l[s]);this.A();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(a){const l=++this.c;this.h=this.g;const s=new g(1,l,this.h,a);this.b.push(s),this.a||(this.p.write(s),this.A())}sendControl(a){const l=new g(2,0,0,a);this.p.write(l)}z(){if(this.g<=this.h||this.k)return;const a=Date.now()-this.j;if(a>=2e3){this.B();return}this.k=setTimeout(()=>{this.k=null,this.z()},2e3-a+5)}A(){if(this.c<=this.d||this.f||this.a)return;const a=this.b.peek(),l=Date.now()-a.writtenTime,s=Date.now()-this.q.lastReadTime,u=Date.now()-this.n;if(l>=2e4&&s>=2e4&&u>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.x.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:l,timeSinceLastReceivedSomeData:s});return}const P=Math.max(2e4-l,2e4-s,2e4-u,500);this.f=setTimeout(()=>{this.f=null,this.A()},P)}B(){if(this.g<=this.h)return;this.h=this.g;const a=new g(3,0,this.h,D());this.p.write(a)}C(){const a=new g(9,0,0,D());this.p.write(a)}}e.PersistentProtocol=r}),define(ve[98],be([1,0,48,14,16,19,153,8,6,2,23,95,57,41]),function(ie,e,b,t,k,S,I,A,E,y,D,T,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class m extends w.ChannelServer{constructor(d){super({send:v=>{try{process.send?.(v.buffer.toString("base64"))}catch{}},onMessage:E.Event.fromNodeEventEmitter(process,"message",v=>k.VSBuffer.wrap(Buffer.from(v,"base64")))},d),process.once("disconnect",()=>this.dispose())}}e.Server=m;class g{constructor(d,v){this.i=d,this.j=v,this.c=new Set,this.g=new Map,this.h=new E.Emitter,this.onDidProcessExit=this.h.event;const c=v&&v.timeout?v.timeout:6e4;this.b=new t.Delayer(c),this.d=null,this.f=null}getChannel(d){const v=this;return{call(c,h,f){return v.k(d,c,h,f)},listen(c,h){return v.l(d,c,h)}}}k(d,v,c,h=S.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(h.isCancellationRequested)return Promise.reject(A.canceled());this.b.cancel();const f=this.n(d),i=(0,t.createCancelablePromise)(o=>f.call(v,c,o)),n=h.onCancellationRequested(()=>i.cancel()),r=(0,y.toDisposable)(()=>i.cancel());return this.c.add(r),i.finally(()=>{n.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(d,v,c){if(!this.b)return E.Event.None;this.b.cancel();let h;const f=new E.Emitter({onWillAddFirstListener:()=>{h=this.n(d).listen(v,c)(f.fire,f),this.c.add(h)},onDidRemoveLastListener:()=>{this.c.delete(h),h.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return f.event}get m(){if(!this.f){const d=this.j&&this.j.args?this.j.args:[],v=Object.create(null);v.env={...(0,D.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(v.env={...v.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(v.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(v.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(v.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),v.execArgv===void 0&&(v.execArgv=process.execArgv.filter(a=>!/^--inspect(-brk)?=/.test(a))),(0,C.removeDangerousEnvVariables)(v.env),this.d=(0,b.fork)(this.i,d,v);const c=new E.Emitter;E.Event.fromNodeEventEmitter(this.d,"message",a=>a)(a=>{if((0,I.isRemoteConsoleLog)(a)){(0,I.log)(a,`IPC Library: ${this.j.serverName}`);return}c.fire(k.VSBuffer.wrap(Buffer.from(a,"base64")))});const f=this.j.useQueue?(0,T.createQueuedSender)(this.d):this.d,i=a=>this.d&&this.d.connected&&f.send(a.buffer.toString("base64")),n=c.event,r={send:i,onMessage:n};this.f=new w.ChannelClient(r);const o=()=>this.o();process.once("exit",o),this.d.on("error",a=>console.warn('IPC "'+this.j.serverName+'" errored with '+a)),this.d.on("exit",(a,l)=>{process.removeListener("exit",o),this.c.forEach(s=>(0,y.dispose)(s)),this.c.clear(),a!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+a+" and signal "+l),this.b?.cancel(),this.o(),this.h.fire({code:a,signal:l})})}return this.f}n(d){let v=this.g.get(d);return v||(v=this.m.getChannel(d),this.g.set(d,v)),v}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=g}),define(ve[59],be([1,0,16,8,6,2,7,3,22,41,97]),function(ie,e,b,t,k,S,I,A,E,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function T(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class C{traceSocketEvent(s,u){D.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,s,u)}constructor(s,u=""){this.f=!0,this.debugLabel=u,this.socket=s,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=P=>{if(this.traceSocketEvent("error",{code:P?.code,message:P?.message}),P){if(P.code==="EPIPE")return;(0,t.onUnexpectedError)(P)}},this.socket.on("error",this.a),this.b=P=>{this.traceSocketEvent("close",{hadError:P}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(s){const u=P=>{this.traceSocketEvent("read",P),s(b.VSBuffer.wrap(P))};return this.socket.on("data",u),{dispose:()=>this.socket.off("data",u)}}onClose(s){const u=P=>{s({type:0,hadError:P,error:void 0})};return this.socket.on("close",u),{dispose:()=>this.socket.off("close",u)}}onEnd(s){const u=()=>{s()};return this.socket.on("end",u),{dispose:()=>this.socket.off("end",u)}}write(s){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",s),this.socket.write(s.buffer,u=>{if(u){if(u.code==="EPIPE")return;(0,t.onUnexpectedError)(u)}})}catch(u){if(u.code==="EPIPE")return;(0,t.onUnexpectedError)(u)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((s,u)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),s();return}const P=()=>{this.socket.off("close",P),this.socket.off("end",P),this.socket.off("error",P),this.socket.off("timeout",P),this.socket.off("drain",P),this.traceSocketEvent("nodeDrainEnd"),s()};this.socket.on("close",P),this.socket.on("end",P),this.socket.on("error",P),this.socket.on("timeout",P),this.socket.on("drain",P)})}}e.NodeSocket=C;var w;(function(l){l[l.MinHeaderByteSize=2]="MinHeaderByteSize"})(w||(w={}));var m;(function(l){l[l.PeekHeader=1]="PeekHeader",l[l.ReadHeader=2]="ReadHeader",l[l.ReadBody=3]="ReadBody",l[l.Fin=4]="Fin"})(m||(m={}));class g extends S.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(s,u){this.socket.traceSocketEvent(s,u)}constructor(s,u,P,F){super(),this.f=this.B(new k.Emitter),this.g=this.B(new k.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=s,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:u,inflateBytesLength:P?.byteLength||0,recordInflateBytes:F}),this.a=this.B(new p(this,u,P,F,this.f,(K,ne)=>this.k(K,ne))),this.B(this.a.onError(K=>{console.error(K),(0,t.onUnexpectedError)(K),this.g.fire({type:0,hadError:!0,error:K})})),this.b=new D.ChunkStream,this.B(this.socket.onData(K=>this.l(K))),this.B(this.socket.onClose(K=>this.g.fire(K)))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(s){return this.f.event(s)}onClose(s){return this.g.event(s)}onEnd(s){return this.socket.onEnd(s)}write(s){this.a.writeMessage(s)}k(s,u){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",s);let P=2;s.byteLength<126?P+=0:s.byteLength<2**16?P+=2:P+=8;const F=b.VSBuffer.alloc(P);if(u?F.writeUInt8(194,0):F.writeUInt8(130,0),s.byteLength<126)F.writeUInt8(s.byteLength,1);else if(s.byteLength<2**16){F.writeUInt8(126,1);let K=1;F.writeUInt8(s.byteLength>>>8&255,++K),F.writeUInt8(s.byteLength>>>0&255,++K)}else{F.writeUInt8(127,1);let K=1;F.writeUInt8(0,++K),F.writeUInt8(0,++K),F.writeUInt8(0,++K),F.writeUInt8(0,++K),F.writeUInt8(s.byteLength>>>24&255,++K),F.writeUInt8(s.byteLength>>>16&255,++K),F.writeUInt8(s.byteLength>>>8&255,++K),F.writeUInt8(s.byteLength>>>0&255,++K)}this.socket.write(b.VSBuffer.concat([F,s]))}end(){this.h=!0,this.socket.end()}l(s){if(s.byteLength!==0){for(this.b.acceptChunk(s);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const u=this.b.peek(this.j.readLen),P=u.readUInt8(0),F=(P&128)>>>7,K=(P&64)>>>6,ne=u.readUInt8(1),ue=(ne&128)>>>7,se=ne&127;this.j.state=2,this.j.readLen=2+(ue?4:0)+(se===126?2:0)+(se===127?8:0),this.j.fin=F,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(K)),this.j.firstFrameOfMessage=Boolean(F),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const u=this.b.read(this.j.readLen),P=u.readUInt8(1),F=(P&128)>>>7;let K=P&127,ne=1;K===126?K=u.readUInt8(++ne)*2**8+u.readUInt8(++ne):K===127&&(K=u.readUInt8(++ne)*0+u.readUInt8(++ne)*0+u.readUInt8(++ne)*0+u.readUInt8(++ne)*0+u.readUInt8(++ne)*2**24+u.readUInt8(++ne)*2**16+u.readUInt8(++ne)*2**8+u.readUInt8(++ne));let ue=0;F&&(ue=u.readUInt8(++ne)*2**24+u.readUInt8(++ne)*2**16+u.readUInt8(++ne)*2**8+u.readUInt8(++ne)),this.j.state=3,this.j.readLen=K,this.j.mask=ue,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const u=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",u),c(u,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",u),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(u,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await k.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=g;class p extends S.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:b.VSBuffer.alloc(0)}constructor(s,u,P,F,K,ne){super(),this.k=s,this.l=K,this.m=ne,this.a=this.B(new k.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new k.Emitter),this.onDidFinishProcessingWriteQueue=this.j.event,this.n=!1,this.s=!1,u?(this.b=this.B(new d(this.k,F,P,{windowBits:15})),this.f=this.B(new v(this.k,{windowBits:15})),this.B(this.b.onError(ue=>this.a.fire(ue))),this.B(this.f.onError(ue=>this.a.fire(ue)))):(this.b=null,this.f=null)}writeMessage(s){this.g.push(s),this.p()}async p(){if(!this.n){for(this.n=!0;this.g.length>0;){const s=this.g.shift();if(this.f){const u=await this.r(this.f,s);this.m(u,!0)}else this.m(s,!1)}this.n=!1,this.j.fire()}}isProcessingWriteQueue(){return this.n}r(s,u){return new Promise((P,F)=>{s.write(u),s.flush(K=>P(K))})}acceptFrame(s,u,P){this.h.push({data:s,isCompressed:u,isLastFrameOfMessage:P}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const s=this.h.shift();if(this.b&&s.isCompressed){const u=await this.u(this.b,s.data,s.isLastFrameOfMessage);this.l.fire(u)}else this.l.fire(s.data)}this.s=!1}}u(s,u,P){return new Promise((F,K)=>{s.write(u),P&&s.write(b.VSBuffer.fromByteArray([0,0,255,255])),s.flush(ne=>F(ne))})}}class d extends S.Disposable{get recordedInflateBytes(){return this.j?b.VSBuffer.concat(this.f):b.VSBuffer.alloc(0)}constructor(s,u,P,F){super(),this.h=s,this.j=u,this.a=this.B(new k.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=T().zlib.createInflateRaw(F),this.b.on("error",K=>{this.h.traceSocketEvent("zlibInflateError",{message:K?.message,code:K?.code}),this.a.fire(K)}),this.b.on("data",K=>{this.h.traceSocketEvent("zlibInflateData",K),this.g.push(b.VSBuffer.wrap(K))}),P&&(this.h.traceSocketEvent("zlibInflateInitialWrite",P.buffer),this.b.write(P.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(s){this.j&&this.f.push(s.clone()),this.h.traceSocketEvent("zlibInflateWrite",s),this.b.write(s.buffer)}flush(s){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const u=b.VSBuffer.concat(this.g);this.g.length=0,s(u)})}}class v extends S.Disposable{constructor(s,u){super(),this.g=s,this.a=this.B(new k.Emitter),this.onError=this.a.event,this.f=[],this.b=T().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",P=>{this.g.traceSocketEvent("zlibDeflateError",{message:P?.message,code:P?.code}),this.a.fire(P)}),this.b.on("data",P=>{this.g.traceSocketEvent("zlibDeflateData",P),this.f.push(b.VSBuffer.wrap(P))})}write(s){this.g.traceSocketEvent("zlibDeflateWrite",s.buffer),this.b.write(s.buffer)}flush(s){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let u=b.VSBuffer.concat(this.f);this.f.length=0,u=u.slice(0,u.byteLength-4),s(u)})}}function c(l,s){if(s===0)return;const u=l.byteLength>>>2;for(let se=0;se<u;se++){const U=l.readUInt32BE(se*4);l.writeUInt32BE(U^s,se*4)}const P=u*4,F=l.byteLength-P,K=s>>>24&255,ne=s>>>16&255,ue=s>>>8&255;F>=1&&l.writeUInt8(l.readUInt8(P)^K,P),F>=2&&l.writeUInt8(l.readUInt8(P+1)^ne,P+1),F>=3&&l.writeUInt8(l.readUInt8(P+2)^ue,P+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const h={[2]:107,[1]:103};function f(){const l=(0,E.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${l}-sock`;let s;return e.XDG_RUNTIME_DIR?s=(0,I.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${l}.sock`):s=(0,I.join)(T().os.tmpdir(),`vscode-ipc-${l}.sock`),n(s),s}e.createRandomIPCHandle=f;function i(l,s,u){const P=T().crypto.createHash("md5").update(l).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${P}-${u}-${s}-sock`;let F;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?F=(0,I.join)(e.XDG_RUNTIME_DIR,`vscode-${P.substr(0,8)}-${u}-${s}.sock`):F=(0,I.join)(l,`${u}-${s}.sock`),n(F),F}e.createStaticIPCHandle=i;function n(l){const s=h[A.platform];typeof s=="number"&&l.length>=s&&console.warn(`WARNING: IPC handle "${l}" is longer than ${s} chars, try a shorter --user-data-dir`)}class r extends y.IPCServer{static b(s){const u=k.Event.fromNodeEventEmitter(s,"connection");return k.Event.map(u,P=>({protocol:new D.Protocol(new C(P,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(P,"close"))}))}constructor(s){super(r.b(s)),this.d=s}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=r;function o(l){return new Promise((s,u)=>{const P=T().net.createServer();P.on("error",u),P.listen(l,()=>{P.removeListener("error",u),s(new r(P))})})}e.serve=o;function a(l,s){return new Promise((u,P)=>{const F=T().net.createConnection(l,()=>{F.removeListener("error",P),u(D.Client.fromSocket(new C(F,`ipc-client${s}`),s))});F.once("error",P)})}e.connect=a}),define(ve[157],be([1,0,14,6,2,11]),function(ie,e,b,t,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var I;(function(T){T[T.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",T[T.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(I=e.StorageHint||(e.StorageHint={}));function A(T){const C=T;return C?.changed instanceof Map||C?.deleted instanceof Set}e.isStorageItemsChangeEvent=A;var E;(function(T){T[T.None=0]="None",T[T.Initialized=1]="Initialized",T[T.Closed=2]="Closed"})(E=e.StorageState||(e.StorageState={}));class y extends k.Disposable{constructor(C,w=Object.create(null)){super(),this.m=C,this.n=w,this.b=this.B(new t.Emitter),this.onDidChangeStorage=this.b.event,this.c=E.None,this.f=new Map,this.g=new b.ThrottledDelayer(y.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(C=>this.r(C)))}r(C){C.changed?.forEach((w,m)=>this.s(m,w)),C.deleted?.forEach(w=>this.s(w,void 0))}s(C,w){if(this.c===E.Closed)return;let m=!1;(0,S.isUndefinedOrNull)(w)?m=this.f.delete(C):this.f.get(C)!==w&&(this.f.set(C,w),m=!0),m&&this.b.fire(C)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===E.None&&(this.c=E.Initialized,this.n.hint!==I.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(C,w){const m=this.f.get(C);return(0,S.isUndefinedOrNull)(m)?w:m}getBoolean(C,w){const m=this.get(C);return(0,S.isUndefinedOrNull)(m)?w:m==="true"}getNumber(C,w){const m=this.get(C);return(0,S.isUndefinedOrNull)(m)?w:parseInt(m,10)}async set(C,w){if(this.c===E.Closed)return;if((0,S.isUndefinedOrNull)(w))return this.delete(C);const m=String(w);if(this.f.get(C)!==m)return this.f.set(C,m),this.j.set(C,m),this.h.delete(C),this.b.fire(C),this.w()}async delete(C){if(!(this.c===E.Closed||!this.f.delete(C)))return this.h.has(C)||this.h.add(C),this.j.delete(C),this.b.fire(C),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=E.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const C={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(C).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(C){if(!!this.u)return this.w(C)}async w(C){return this.g.trigger(()=>this.v(),C)}async whenFlushed(){if(!!this.u)return new Promise(C=>this.l.push(C))}isInMemory(){return this.n.hint===I.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}e.Storage=y,y.a=100;class D{constructor(){this.onDidChangeItemsExternal=t.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(C){C.insert?.forEach((w,m)=>this.a.set(m,w)),C.delete?.forEach(w=>this.a.delete(w))}async close(){}}e.InMemoryStorageDatabase=D}),define(ve[158],be([1,0,6,2]),function(ie,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class k{constructor(){this.a=new Map,this.b=new Map,this.c=new b.Emitter,this.onDidChange=this.c.event,this.d=null}fire(A){this.c.fire({changedLanguages:A,changedColorMap:!1})}register(A,E){return this.a.set(A,E),this.fire([A]),(0,t.toDisposable)(()=>{this.a.get(A)===E&&(this.a.delete(A),this.fire([A]))})}registerFactory(A,E){this.b.get(A)?.dispose();const y=new S(this,A,E);return this.b.set(A,y),(0,t.toDisposable)(()=>{const D=this.b.get(A);!D||D!==y||(this.b.delete(A),D.dispose())})}async getOrCreate(A){const E=this.get(A);if(E)return E;const y=this.b.get(A);return!y||y.isResolved?null:(await y.resolve(),this.get(A))}get(A){return this.a.get(A)||null}isResolved(A){if(this.get(A))return!0;const y=this.b.get(A);return!!(!y||y.isResolved)}setColorMap(A){this.d=A,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.TokenizationRegistry=k;class S extends t.Disposable{get isResolved(){return this.c}constructor(A,E,y){super(),this.f=A,this.g=E,this.h=y,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.i()),this.b}async i(){const A=await Promise.resolve(this.h.createTokenizationSupport());this.c=!0,A&&!this.a&&this.B(this.f.register(this.g,A))}}}),define(ve[159],be([1,0,40,4,46,158]),function(ie,e,b,t,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class I{constructor(P,F,K){this._tokenBrand=void 0,this.offset=P,this.type=F,this.language=K}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=I;class A{constructor(P,F){this._tokenizationResultBrand=void 0,this.tokens=P,this.endState=F}}e.TokenizationResult=A;class E{constructor(P,F){this._encodedTokenizationResultBrand=void 0,this.tokens=P,this.endState=F}}e.EncodedTokenizationResult=E;var y;(function(u){u[u.Method=0]="Method",u[u.Function=1]="Function",u[u.Constructor=2]="Constructor",u[u.Field=3]="Field",u[u.Variable=4]="Variable",u[u.Class=5]="Class",u[u.Struct=6]="Struct",u[u.Interface=7]="Interface",u[u.Module=8]="Module",u[u.Property=9]="Property",u[u.Event=10]="Event",u[u.Operator=11]="Operator",u[u.Unit=12]="Unit",u[u.Value=13]="Value",u[u.Constant=14]="Constant",u[u.Enum=15]="Enum",u[u.EnumMember=16]="EnumMember",u[u.Keyword=17]="Keyword",u[u.Text=18]="Text",u[u.Color=19]="Color",u[u.File=20]="File",u[u.Reference=21]="Reference",u[u.Customcolor=22]="Customcolor",u[u.Folder=23]="Folder",u[u.TypeParameter=24]="TypeParameter",u[u.User=25]="User",u[u.Issue=26]="Issue",u[u.Snippet=27]="Snippet"})(y=e.CompletionItemKind||(e.CompletionItemKind={}));var D;(function(u){const P=new Map;P.set(0,b.Codicon.symbolMethod),P.set(1,b.Codicon.symbolFunction),P.set(2,b.Codicon.symbolConstructor),P.set(3,b.Codicon.symbolField),P.set(4,b.Codicon.symbolVariable),P.set(5,b.Codicon.symbolClass),P.set(6,b.Codicon.symbolStruct),P.set(7,b.Codicon.symbolInterface),P.set(8,b.Codicon.symbolModule),P.set(9,b.Codicon.symbolProperty),P.set(10,b.Codicon.symbolEvent),P.set(11,b.Codicon.symbolOperator),P.set(12,b.Codicon.symbolUnit),P.set(13,b.Codicon.symbolValue),P.set(15,b.Codicon.symbolEnum),P.set(14,b.Codicon.symbolConstant),P.set(15,b.Codicon.symbolEnum),P.set(16,b.Codicon.symbolEnumMember),P.set(17,b.Codicon.symbolKeyword),P.set(27,b.Codicon.symbolSnippet),P.set(18,b.Codicon.symbolText),P.set(19,b.Codicon.symbolColor),P.set(20,b.Codicon.symbolFile),P.set(21,b.Codicon.symbolReference),P.set(22,b.Codicon.symbolCustomColor),P.set(23,b.Codicon.symbolFolder),P.set(24,b.Codicon.symbolTypeParameter),P.set(25,b.Codicon.account),P.set(26,b.Codicon.issues);function F(ue){let se=P.get(ue);return se||(console.info("No codicon found for CompletionItemKind "+ue),se=b.Codicon.symbolProperty),se}u.toIcon=F;const K=new Map;K.set("method",0),K.set("function",1),K.set("constructor",2),K.set("field",3),K.set("variable",4),K.set("class",5),K.set("struct",6),K.set("interface",7),K.set("module",8),K.set("property",9),K.set("event",10),K.set("operator",11),K.set("unit",12),K.set("value",13),K.set("constant",14),K.set("enum",15),K.set("enum-member",16),K.set("enumMember",16),K.set("keyword",17),K.set("snippet",27),K.set("text",18),K.set("color",19),K.set("file",20),K.set("reference",21),K.set("customcolor",22),K.set("folder",23),K.set("type-parameter",24),K.set("typeParameter",24),K.set("account",25),K.set("issue",26);function ne(ue,se){let U=K.get(ue);return typeof U>"u"&&!se&&(U=9),U}u.fromString=ne})(D=e.CompletionItemKinds||(e.CompletionItemKinds={}));var T;(function(u){u[u.Deprecated=1]="Deprecated"})(T=e.CompletionItemTag||(e.CompletionItemTag={}));var C;(function(u){u[u.KeepWhitespace=1]="KeepWhitespace",u[u.InsertAsSnippet=4]="InsertAsSnippet"})(C=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var w;(function(u){u[u.Invoke=0]="Invoke",u[u.TriggerCharacter=1]="TriggerCharacter",u[u.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(w=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var m;(function(u){u[u.Automatic=0]="Automatic",u[u.Explicit=1]="Explicit"})(m=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var g;(function(u){u[u.Invoke=1]="Invoke",u[u.Auto=2]="Auto"})(g=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var p;(function(u){u[u.Invoke=1]="Invoke",u[u.TriggerCharacter=2]="TriggerCharacter",u[u.ContentChange=3]="ContentChange"})(p=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var d;(function(u){u[u.Text=0]="Text",u[u.Read=1]="Read",u[u.Write=2]="Write"})(d=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function v(u){return u&&t.URI.isUri(u.uri)&&k.Range.isIRange(u.range)&&(k.Range.isIRange(u.originSelectionRange)||k.Range.isIRange(u.targetSelectionRange))}e.isLocationLink=v;var c;(function(u){u[u.File=0]="File",u[u.Module=1]="Module",u[u.Namespace=2]="Namespace",u[u.Package=3]="Package",u[u.Class=4]="Class",u[u.Method=5]="Method",u[u.Property=6]="Property",u[u.Field=7]="Field",u[u.Constructor=8]="Constructor",u[u.Enum=9]="Enum",u[u.Interface=10]="Interface",u[u.Function=11]="Function",u[u.Variable=12]="Variable",u[u.Constant=13]="Constant",u[u.String=14]="String",u[u.Number=15]="Number",u[u.Boolean=16]="Boolean",u[u.Array=17]="Array",u[u.Object=18]="Object",u[u.Key=19]="Key",u[u.Null=20]="Null",u[u.EnumMember=21]="EnumMember",u[u.Struct=22]="Struct",u[u.Event=23]="Event",u[u.Operator=24]="Operator",u[u.TypeParameter=25]="TypeParameter"})(c=e.SymbolKind||(e.SymbolKind={}));var h;(function(u){u[u.Deprecated=1]="Deprecated"})(h=e.SymbolTag||(e.SymbolTag={}));var f;(function(u){const P=new Map;P.set(0,b.Codicon.symbolFile),P.set(1,b.Codicon.symbolModule),P.set(2,b.Codicon.symbolNamespace),P.set(3,b.Codicon.symbolPackage),P.set(4,b.Codicon.symbolClass),P.set(5,b.Codicon.symbolMethod),P.set(6,b.Codicon.symbolProperty),P.set(7,b.Codicon.symbolField),P.set(8,b.Codicon.symbolConstructor),P.set(9,b.Codicon.symbolEnum),P.set(10,b.Codicon.symbolInterface),P.set(11,b.Codicon.symbolFunction),P.set(12,b.Codicon.symbolVariable),P.set(13,b.Codicon.symbolConstant),P.set(14,b.Codicon.symbolString),P.set(15,b.Codicon.symbolNumber),P.set(16,b.Codicon.symbolBoolean),P.set(17,b.Codicon.symbolArray),P.set(18,b.Codicon.symbolObject),P.set(19,b.Codicon.symbolKey),P.set(20,b.Codicon.symbolNull),P.set(21,b.Codicon.symbolEnumMember),P.set(22,b.Codicon.symbolStruct),P.set(23,b.Codicon.symbolEvent),P.set(24,b.Codicon.symbolOperator),P.set(25,b.Codicon.symbolTypeParameter);function F(K){let ne=P.get(K);return ne||(console.info("No codicon found for SymbolKind "+K),ne=b.Codicon.symbolProperty),ne}u.toIcon=F})(f=e.SymbolKinds||(e.SymbolKinds={}));class i{constructor(P){this.value=P}}e.FoldingRangeKind=i,i.Comment=new i("comment"),i.Imports=new i("imports"),i.Region=new i("region");var n;(function(u){function P(F){return!F||typeof F!="object"?!1:typeof F.id=="string"&&typeof F.title=="string"}u.is=P})(n=e.Command||(e.Command={}));var r;(function(u){u[u.Collapsed=0]="Collapsed",u[u.Expanded=1]="Expanded"})(r=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var o;(function(u){u[u.Unresolved=0]="Unresolved",u[u.Resolved=1]="Resolved"})(o=e.CommentThreadState||(e.CommentThreadState={}));var a;(function(u){u[u.Editing=0]="Editing",u[u.Preview=1]="Preview"})(a=e.CommentMode||(e.CommentMode={}));var l;(function(u){u[u.Type=1]="Type",u[u.Parameter=2]="Parameter"})(l=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new S.TokenizationRegistry;var s;(function(u){u[u.None=0]="None",u[u.Option=1]="Option",u[u.Default=2]="Default",u[u.Preferred=3]="Preferred"})(s=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ve[160],be([9,10]),function(ie,e){return ie.create("vs/base/node/zip",e)}),define(ve[161],be([9,10]),function(ie,e){return ie.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ve[162],be([9,10]),function(ie,e){return ie.create("vs/platform/environment/node/argv",e)}),define(ve[163],be([9,10]),function(ie,e){return ie.create("vs/platform/environment/node/argvHelper",e)}),define(ve[164],be([9,10]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ve[165],be([9,10]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ve[166],be([9,10]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(ve[167],be([9,10]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ve[168],be([9,10]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ve[169],be([9,10]),function(ie,e){return ie.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ve[170],be([9,10]),function(ie,e){return ie.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ve[171],be([9,10]),function(ie,e){return ie.create("vs/platform/extensions/common/extensionValidator",e)}),define(ve[172],be([9,10]),function(ie,e){return ie.create("vs/platform/files/common/fileService",e)}),define(ve[173],be([9,10]),function(ie,e){return ie.create("vs/platform/files/common/files",e)}),define(ve[174],be([9,10]),function(ie,e){return ie.create("vs/platform/files/common/io",e)}),define(ve[175],be([9,10]),function(ie,e){return ie.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ve[176],be([9,10]),function(ie,e){return ie.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ve[177],be([9,10]),function(ie,e){return ie.create("vs/platform/markers/common/markers",e)}),define(ve[178],be([9,10]),function(ie,e){return ie.create("vs/platform/request/common/request",e)}),define(ve[179],be([9,10]),function(ie,e){return ie.create("vs/platform/shell/node/shellEnv",e)}),define(ve[180],be([9,10]),function(ie,e){return ie.create("vs/platform/telemetry/common/telemetryService",e)}),define(ve[181],be([9,10]),function(ie,e){return ie.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ve[182],be([9,10]),function(ie,e){return ie.create("vs/platform/terminal/common/terminalProfiles",e)}),define(ve[183],be([9,10]),function(ie,e){return ie.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ve[184],be([9,10]),function(ie,e){return ie.create("vs/platform/workspace/common/workspace",e)}),define(ve[185],be([9,10]),function(ie,e){return ie.create("vs/server/node/serverEnvironmentService",e)}),define(ve[186],be([9,10]),function(ie,e){return ie.create("vs/workbench/common/editor",e)}),define(ve[187],be([9,10]),function(ie,e){return ie.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ve[188],be([9,10]),function(ie,e){return ie.create("vs/workbench/services/extensions/common/extensionsUtil",e)}),define(ve[189],be([1,0,6,2]),function(ie,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class k{constructor(){this.a=new b.Emitter,this.b=new b.Emitter,this.c=new b.Emitter,this.d=new b.Emitter}call(A,E,y){switch(E){case"close":return Promise.resolve(this.a.fire({sessionId:y[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:y[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:y[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:y[0],port:y[1],subId:y[2]}))}throw new Error("Method not implemented.")}listen(A,E,y){switch(E){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=k,k.ChannelName="extensionhostdebugservice";class S extends t.Disposable{constructor(A){super(),this.b=A}reload(A){this.b.call("reload",[A])}get onReload(){return this.b.listen("reload")}close(A){this.b.call("close",[A])}get onClose(){return this.b.listen("close")}attachSession(A,E,y){this.b.call("attach",[A,E,y])}get onAttachSession(){return this.b.listen("attach")}terminateSession(A,E){this.b.call("terminate",[A,E])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(A,E){return this.b.call("openExtensionDevelopmentHostWindow",[A,E])}}e.ExtensionHostDebugChannelClient=S}),define(ve[190],be([1,0,4]),function(ie,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadServiceChannelClient=e.DownloadServiceChannel=void 0;class t{constructor(I){this.a=I}listen(I,A,E){throw new Error("Invalid listen")}call(I,A,E){switch(A){case"download":return this.a.download(b.URI.revive(E[0]),b.URI.revive(E[1]))}throw new Error("Invalid call")}}e.DownloadServiceChannel=t;class k{constructor(I,A){this.a=I,this.b=A}async download(I,A){const E=this.b();E&&(I=E.transformOutgoingURI(I),A=E.transformOutgoingURI(A)),await this.a.call("download",[I,A])}}e.DownloadServiceChannelClient=k}),define(ve[99],be([1,0,144,84,13,7,27,20,4]),function(ie,e,b,t,k,S,I,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class y{get appRoot(){return(0,S.dirname)(k.FileAccess.asFileUri("").fsPath)}get userHome(){return E.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return E.URI.file((0,S.join)(this.userDataPath,"User"))}get tmpDir(){return E.URI.file(this.b.tmpDir)}get cacheHome(){return E.URI.file(this.userDataPath)}get stateResource(){return(0,A.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,A.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const g=(0,b.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,S.join)(this.userDataPath,"logs",g)}return this.args.logsPath}get userDataSyncLogResource(){return E.URI.file((0,S.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return E.URI.file((0,S.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,A.joinPath)(E.URI.file((0,S.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,A.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,A.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,A.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const g=I.env.VSCODE_PORTABLE;return g?E.URI.file((0,S.join)(g,"argv.json")):(0,A.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return E.URI.file((0,S.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,S.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const g=this.args["builtin-extensions-dir"];return g?(0,S.resolve)(g):(0,S.normalize)((0,S.join)(k.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const g=this.args["extensions-download-dir"];return g?E.URI.file((0,S.resolve)(g)):E.URI.file((0,S.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const g=this.args["extensions-dir"];if(g)return(0,S.resolve)(g);const p=I.env.VSCODE_EXTENSIONS;if(p)return p;const d=I.env.VSCODE_PORTABLE;return d?(0,S.join)(d,"extensions"):(0,A.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const g=this.args.extensionDevelopmentPath;if(Array.isArray(g))return g.map(p=>/^[^:/?#]+?:\/\//.test(p)?E.URI.parse(p):E.URI.file((0,S.normalize)(p)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(g=>g==="ui"||g==="workspace"||g==="web"?g:"workspace")}get extensionTestsLocationURI(){const g=this.args.extensionTestsPath;if(g)return/^[^:/?#]+?:\/\//.test(g)?E.URI.parse(g):E.URI.file((0,S.normalize)(g))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const g=this.args["disable-extension"];if(g){if(typeof g=="string")return[g];if(Array.isArray(g)&&g.length>0)return g}return!1}get debugExtensionHost(){return D(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!I.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(g=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(g))}get extensionLogLevel(){const g=[];for(const p of this.args.log||[]){const d=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(p);d&&d[1]&&d[2]&&g.push([d[1],d[2]])}return g.length?g:void 0}get serviceMachineIdResource(){return(0,A.joinPath)(E.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return E.URI.file((0,S.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const g=I.env.VSCODE_PORTABLE;return g?E.URI.file((0,S.join)(g,"policy.json")):(0,A.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(g){this.args.continueOn=g}get args(){return this.a}constructor(g,p,d){this.a=g,this.b=p,this.c=d,this.editSessionId=this.args.editSessionId}}Le([t.memoize],y.prototype,"appRoot",null),Le([t.memoize],y.prototype,"userHome",null),Le([t.memoize],y.prototype,"userDataPath",null),Le([t.memoize],y.prototype,"appSettingsHome",null),Le([t.memoize],y.prototype,"tmpDir",null),Le([t.memoize],y.prototype,"cacheHome",null),Le([t.memoize],y.prototype,"stateResource",null),Le([t.memoize],y.prototype,"userRoamingDataHome",null),Le([t.memoize],y.prototype,"userDataSyncHome",null),Le([t.memoize],y.prototype,"userDataSyncLogResource",null),Le([t.memoize],y.prototype,"editSessionsLogResource",null),Le([t.memoize],y.prototype,"sync",null),Le([t.memoize],y.prototype,"machineSettingsResource",null),Le([t.memoize],y.prototype,"workspaceStorageHome",null),Le([t.memoize],y.prototype,"localHistoryHome",null),Le([t.memoize],y.prototype,"keyboardLayoutResource",null),Le([t.memoize],y.prototype,"argvResource",null),Le([t.memoize],y.prototype,"isExtensionDevelopment",null),Le([t.memoize],y.prototype,"untitledWorkspacesHome",null),Le([t.memoize],y.prototype,"installSourcePath",null),Le([t.memoize],y.prototype,"builtinExtensionsPath",null),Le([t.memoize],y.prototype,"extensionsPath",null),Le([t.memoize],y.prototype,"extensionDevelopmentLocationURI",null),Le([t.memoize],y.prototype,"extensionDevelopmentKind",null),Le([t.memoize],y.prototype,"extensionTestsLocationURI",null),Le([t.memoize],y.prototype,"debugExtensionHost",null),Le([t.memoize],y.prototype,"logLevel",null),Le([t.memoize],y.prototype,"extensionLogLevel",null),Le([t.memoize],y.prototype,"serviceMachineIdResource",null),Le([t.memoize],y.prototype,"telemetryLogResource",null),Le([t.memoize],y.prototype,"disableWorkspaceTrust",null),Le([t.memoize],y.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=y;function D(m,g){return w(m["inspect-extensions"],m["inspect-brk-extensions"],5870,g,m.debugId,m.extensionEnvironment)}e.parseExtensionHostPort=D;function T(m,g){return w(m["inspect-search"],m["inspect-brk-search"],5876,g,m.extensionEnvironment)}e.parseSearchPort=T;function C(m,g){return w(m["inspect-ptyhost"],m["inspect-brk-ptyhost"],5877,g,m.extensionEnvironment)}e.parsePtyHostPort=C;function w(m,g,p,d,v,c){const f=Number(g||m)||(d?null:p),i=f?Boolean(!!g):!1;let n;if(c)try{n=JSON.parse(c)}catch{}return{port:f,break:i,debugId:v,env:n}}}),define(ve[60],be([1,0,272,3,162]),function(ie,e,b,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const S={o:(0,k.localize)(0,null),e:(0,k.localize)(1,null),t:(0,k.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,k.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,k.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,k.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,k.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,k.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,k.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,k.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,k.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,k.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,k.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,k.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,k.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,k.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,k.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,k.localize)(17,null)},category:{type:"string",cat:"e",description:(0,k.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,k.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,k.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,k.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,k.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,k.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,k.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,k.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,k.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,k.localize)(27,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,k.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,k.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,k.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,k.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,k.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,k.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,k.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,k.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const I={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function A(g,p,d=I){const v=g.find(l=>l.length>0&&l[0]!=="-"),c={},h=["_"],f=[],i={};let n;for(const l in p){const s=p[l];s.type==="subcommand"?l===v&&(n=s):(s.alias&&(c[l]=s.alias),s.type==="string"||s.type==="string[]"?(h.push(l),s.deprecates&&h.push(...s.deprecates)):s.type==="boolean"&&(f.push(l),s.deprecates&&f.push(...s.deprecates)),s.global&&(i[l]=s))}if(n&&v){const l=i;for(const F in n.options)l[F]=n.options[F];const s=g.filter(F=>F!==v),u=d.getSubcommandReporter?d.getSubcommandReporter(v):void 0,P=A(s,l,u);return{[v]:P,_:[]}}const r=b(g,{string:h,boolean:f,alias:c}),o={},a=r;o._=r._.map(l=>String(l)).filter(l=>l.length>0),delete a._;for(const l in p){const s=p[l];if(s.type==="subcommand")continue;s.alias&&delete a[s.alias];let u=a[l];if(s.deprecates)for(const P of s.deprecates)a.hasOwnProperty(P)&&(u||(u=a[P],u&&d.onDeprecatedOption(P,s.deprecationMessage||(0,k.localize)(36,null,l))),delete a[P]);if(typeof u<"u"){if(s.type==="string[]"){if(Array.isArray(u)||(u=[u]),!s.allowEmptyValue){const P=u.filter(F=>F.length>0);P.length!==u.length&&(d.onEmptyValue(l),u=P.length>0?P:void 0)}}else s.type==="string"&&(Array.isArray(u)?(u=u.pop(),d.onMultipleValues(l,u)):!u&&!s.allowEmptyValue&&(d.onEmptyValue(l),u=void 0));o[l]=u,s.deprecationMessage&&d.onDeprecatedOption(l,s.deprecationMessage)}delete a[l]}for(const l in a)d.onUnknownOption(l);return o}e.parseArgs=A;function E(g,p){let d="";return p.args&&(Array.isArray(p.args)?d=` <${p.args.join("> <")}>`:d=` <${p.args}>`),p.alias?`-${p.alias} --${g}${d}`:`--${g}${d}`}function y(g,p){const d=[];for(const v in g){const c=g[v],h=E(v,c);d.push([h,c.description])}return D(d,p)}e.formatOptions=y;function D(g,p){const v=g.reduce((f,i)=>Math.max(f,i[0].length),12)+2+1;if(p-v<25)return g.reduce((f,i)=>f.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);const c=p-v-1,h=[];for(const f of g){const i=f[0],n=C(f[1],c),r=T(v-i.length-2);h.push("  "+i+r+n[0]);for(let o=1;o<n.length;o++)h.push(T(v)+n[o])}return h}function T(g){return" ".repeat(g)}function C(g,p){const d=[];for(;g.length;){const v=g.length<p?g.length:g.lastIndexOf(" ",p),c=g.slice(0,v).trim();g=g.slice(v),d.push(c)}return d}function w(g,p,d,v,c){const h=process.stdout.isTTY&&process.stdout.columns||80,f=c?.noInputFiles!==!0?`[${(0,k.localize)(37,null)}...]`:"",i=[`${g} ${d}`];i.push(""),i.push(`${(0,k.localize)(38,null)}: ${p} [${(0,k.localize)(39,null)}]${f}`),i.push(""),c?.noPipe!==!0&&(t.isWindows?i.push((0,k.localize)(40,null,p)):i.push((0,k.localize)(41,null,p)),i.push(""));const n={},r=[];for(const o in v){const a=v[o];if(a.type==="subcommand")a.description&&r.push({command:o,description:a.description});else if(a.description&&a.cat){let l=n[a.cat];l||(n[a.cat]=l={}),l[o]=a}}for(const o in n){const a=o,l=n[a];l&&(i.push(S[a]),i.push(...y(l,h)),i.push(""))}return r.length&&(i.push((0,k.localize)(42,null)),i.push(...D(r.map(o=>[o.command,o.description]),h)),i.push("")),i.join(`
`)}e.buildHelpMessage=w;function m(g,p){return`${g||(0,k.localize)(43,null)}
${p||(0,k.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=m}),define(ve[191],be([1,0,273,163,60]),function(ie,e,b,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const S=2048;function I(C,w){const m=(h,f)=>{console.warn((0,t.localize)(0,null,h,f))},g=h=>{console.warn((0,t.localize)(1,null,h))},p=(h,f)=>{console.warn((0,t.localize)(2,null,h,f))},d=h=>({onUnknownOption:f=>{h!=="tunnel"&&console.warn((0,t.localize)(3,null,f,h))},onMultipleValues:m,onEmptyValue:g,onDeprecatedOption:p,getSubcommandReporter:h!=="tunnel"?d:void 0}),v={onUnknownOption:h=>{console.warn((0,t.localize)(4,null,h))},onMultipleValues:m,onEmptyValue:g,onDeprecatedOption:p,getSubcommandReporter:d},c=(0,k.parseArgs)(C,k.OPTIONS,w?v:void 0);return c.goto&&c._.forEach(h=>b(/^(\w:)?[^:]+(:\d*){0,2}$/.test(h),(0,t.localize)(5,null))),c["max-memory"]&&b(parseInt(c["max-memory"])>=S,`The max-memory argument cannot be specified lower than ${S} MB.`),c}function A(C){const w=C.findIndex(m=>!/^-/.test(m));if(w>-1)return[...C.slice(0,w),...C.slice(w+1)]}function E(C){let[,...w]=C;process.env.VSCODE_DEV&&(w=A(w)||[]);const m=!T(process.env);return I(w,m)}e.parseMainProcessArgv=E;function y(C){let[,,...w]=C;return process.env.VSCODE_DEV&&(w=A(w)||[]),I(w,!0)}e.parseCLIProcessArgv=y;function D(C,...w){const m=C.indexOf("--");return m===-1?C.push(...w):C.splice(m,0,...w),C}e.addArg=D;function T(C){return C.VSCODE_CLI==="1"}e.isLaunchedFromCli=T}),function(){"use strict";function ie(e,b,t){function k(I,A){const E=S(I,A),y=[E];return e.isAbsolute(E)||y.unshift(t),e.resolve(...y)}function S(I,A){process.env.VSCODE_DEV&&(A="code-oss-dev");const E=process.env.VSCODE_PORTABLE;if(E)return e.join(E,"user-data");let y=process.env.VSCODE_APPDATA;if(y)return e.join(y,A);const D=I["user-data-dir"];if(D)return D;switch(process.platform){case"win32":if(y=process.env.APPDATA,!y){const T=process.env.USERPROFILE;if(typeof T!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");y=e.join(T,"AppData","Roaming")}break;case"darwin":y=e.join(b.homedir(),"Library","Application Support");break;case"linux":y=process.env.XDG_CONFIG_HOME||e.join(b.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(y,A)}return{getUserDataPath:k}}if(typeof define=="function")define(ve[192],be([88,30,27]),function(e,b,t){return ie(e,b,t.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),b=require("os");module.exports=ie(e,b,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ve[193],be([1,0,30,99,192]),function(ie,e,b,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class S extends t.AbstractNativeEnvironmentService{constructor(A,E){super(A,{homeDir:(0,b.homedir)(),tmpDir:(0,b.tmpdir)(),userDataDir:(0,k.getUserDataPath)(A,E.nameShort)},E)}}e.NativeEnvironmentService=S}),define(ve[194],be([1,0,11,167]),function(ie,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function k(I,A,E){try{S(I,A,E)}catch(y){console.error(y?.message??y)}return I}e.localizeManifest=k;function S(I,A,E){const y=(D,T,C)=>{const w=D[T];if((0,b.isString)(w)){const m=w,g=m.length;if(g>1&&m[0]==="%"&&m[g-1]==="%"){const p=m.substr(1,g-2);let d=A[p];d===void 0&&E&&(d=E[p]);const v=typeof d=="string"?d:d?.message,c=E?.[p],h=typeof c=="string"?c:c?.message;if(!v){h||console.warn(`[${I.name}]: ${(0,t.localize)(0,null,p)}`);return}if(C&&(T==="title"||T==="category")&&h&&h!==v){const f={value:v,original:h};D[T]=f}else D[T]=v}}else if((0,b.isObject)(w))for(const m in w)w.hasOwnProperty(m)&&(m==="commands"?y(w,m,!0):y(w,m,C));else if(Array.isArray(w))for(let m=0;m<w.length;m++)y(w,m,C)};for(const D in I)I.hasOwnProperty(D)&&y(I,D)}}),define(ve[195],be([1,0,8]),function(ie,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class t{constructor(){this.a=new Map}register(S,I){this.a.set(S,I)}updateManifest(S){if(!(typeof S.main>"u"&&typeof S.browser>"u")&&(S.activationEvents===void 0&&Object.assign(S,{activationEvents:[]}),!(!Array.isArray(S.activationEvents)||!S.contributes)))for(const I in S.contributes){const A=this.a.get(I);if(!A)continue;const E=S.contributes[I],y=Array.isArray(E)?E:[E];try{A(y,S.activationEvents)}catch(D){(0,b.onUnexpectedError)(D)}}}}e.ImplicitActivationEventsImpl=t,e.ImplicitActivationEvents=new t}),define(ve[73],be([1,0,20,70,171,49]),function(ie,e,b,t,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const I=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,A=/^-(\d{4})(\d{2})(\d{2})$/;function E(d){return d=d.trim(),d==="*"||I.test(d)}e.isValidVersionStr=E;function y(d){if(!E(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const v=d.match(I);return v?{hasCaret:v[1]==="^",hasGreaterEquals:v[1]===">=",majorBase:v[2]==="x"?0:parseInt(v[2],10),majorMustEqual:v[2]!=="x",minorBase:v[4]==="x"?0:parseInt(v[4],10),minorMustEqual:v[4]!=="x",patchBase:v[6]==="x"?0:parseInt(v[6],10),patchMustEqual:v[6]!=="x",preRelease:v[8]||null}:null}e.parseVersion=y;function D(d){if(!d)return null;const v=d.majorBase,c=d.majorMustEqual,h=d.minorBase;let f=d.minorMustEqual;const i=d.patchBase;let n=d.patchMustEqual;d.hasCaret&&(v===0||(f=!1),n=!1);let r=0;if(d.preRelease){const o=A.exec(d.preRelease);if(o){const[,a,l,s]=o;r=Date.UTC(Number(a),Number(l)-1,Number(s))}}return{majorBase:v,majorMustEqual:c,minorBase:h,minorMustEqual:f,patchBase:i,patchMustEqual:n,isMinimum:d.hasGreaterEquals,notBefore:r}}e.normalizeVersion=D;function T(d,v,c){let h;typeof d=="string"?h=D(y(d)):h=d;let f;v instanceof Date?f=v.getTime():typeof v=="string"&&(f=new Date(v).getTime());let i;if(typeof c=="string"?i=D(y(c)):i=c,!h||!i)return!1;const n=h.majorBase,r=h.minorBase,o=h.patchBase;let a=i.majorBase,l=i.minorBase,s=i.patchBase;const u=i.notBefore;let P=i.majorMustEqual,F=i.minorMustEqual,K=i.patchMustEqual;return i.isMinimum?n>a?!0:n<a?!1:r>l?!0:r<l||f&&f<u?!1:o>=s:(n===1&&a===0&&(!P||!F||!K)&&(a=1,l=0,s=0,P=!0,F=!1,K=!1),n<a?!1:n>a?!P:r<l?!1:r>l?!F:o<s?!1:o>s?!K:!(f&&f<u))}e.isValidVersion=T;function C(d,v,c,h,f){const i=[];if(typeof h.publisher<"u"&&typeof h.publisher!="string")return i.push([t.default.Error,k.localize(0,null)]),i;if(typeof h.name!="string")return i.push([t.default.Error,k.localize(1,null,"name")]),i;if(typeof h.version!="string")return i.push([t.default.Error,k.localize(2,null,"version")]),i;if(!h.engines)return i.push([t.default.Error,k.localize(3,null,"engines")]),i;if(typeof h.engines.vscode!="string")return i.push([t.default.Error,k.localize(4,null,"engines.vscode")]),i;if(typeof h.extensionDependencies<"u"&&!p(h.extensionDependencies))return i.push([t.default.Error,k.localize(5,null,"extensionDependencies")]),i;if(typeof h.activationEvents<"u"){if(!p(h.activationEvents))return i.push([t.default.Error,k.localize(6,null,"activationEvents")]),i;if(typeof h.main>"u"&&typeof h.browser>"u")return i.push([t.default.Error,k.localize(7,null,"activationEvents","main")]),i}if(typeof h.extensionKind<"u"&&typeof h.main>"u"&&i.push([t.default.Warning,k.localize(8,null,"extensionKind")]),typeof h.main<"u"){if(typeof h.main!="string")return i.push([t.default.Error,k.localize(9,null,"main")]),i;{const o=(0,b.joinPath)(c,h.main);(0,b.isEqualOrParent)(o,c)||i.push([t.default.Warning,k.localize(10,null,o.path,c.path)])}if(typeof h.activationEvents>"u")return i.push([t.default.Error,k.localize(11,null,"activationEvents","main")]),i}if(typeof h.browser<"u"){if(typeof h.browser!="string")return i.push([t.default.Error,k.localize(12,null,"browser")]),i;{const o=(0,b.joinPath)(c,h.browser);(0,b.isEqualOrParent)(o,c)||i.push([t.default.Warning,k.localize(13,null,o.path,c.path)])}if(typeof h.activationEvents>"u")return i.push([t.default.Error,k.localize(14,null,"activationEvents","browser")]),i}if(!S.valid(h.version))return i.push([t.default.Error,k.localize(15,null)]),i;const n=[];if(!w(d,v,h,f,n))for(const o of n)i.push([t.default.Error,o]);return i}e.validateExtensionManifest=C;function w(d,v,c,h,f){return h||typeof c.main>"u"&&typeof c.browser>"u"?!0:g(d,v,c.engines.vscode,f)}e.isValidExtensionVersion=w;function m(d,v,c){return d==="*"||g(v,c,d)}e.isEngineValid=m;function g(d,v,c,h=[]){const f=D(y(c));if(!f)return h.push(k.localize(16,null,c)),!1;if(f.majorBase===0){if(!f.majorMustEqual||!f.minorMustEqual)return h.push(k.localize(17,null,c)),!1}else if(!f.majorMustEqual)return h.push(k.localize(18,null,c)),!1;return T(d,v,f)?!0:(h.push(k.localize(19,null,d,c)),!1)}function p(d){if(!Array.isArray(d))return!1;for(let v=0,c=d.length;v<c;v++)if(typeof d[v]!="string")return!1;return!0}}),define(ve[196],be([1,0,16,22]),function(ie,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(S,I,A){let E=A&&A.get("storage.serviceMachineId",-1)||null;if(E)return E;try{const D=(await I.readFile(S.serviceMachineIdResource)).value.toString();E=(0,t.isUUID)(D)?D:null}catch{E=null}if(!E){E=(0,t.generateUuid)();try{await I.writeFile(S.serviceMachineIdResource,b.VSBuffer.fromString(E))}catch{}}return A?.store("storage.serviceMachineId",E,-1,1),E}e.getServiceMachineId=k}),define(ve[61],be([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class b{constructor(k,S=[],I=!1){this.ctor=k,this.staticArguments=S,this.supportsDelayedInstantiation=I}}e.SyncDescriptor=b}),define(ve[197],be([1,0,61]),function(ie,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const t=[];var k;(function(A){A[A.Eager=0]="Eager",A[A.Delayed=1]="Delayed"})(k=e.InstantiationType||(e.InstantiationType={}));function S(A,E,y){E instanceof b.SyncDescriptor||(E=new b.SyncDescriptor(E,[],Boolean(y))),t.push([A,E])}e.registerSingleton=S;function I(){return t}e.getSingletonServiceDescriptors=I}),define(ve[198],be([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class b{constructor(S,I){this.key=S,this.data=I,this.incoming=new Map,this.outgoing=new Map}}e.Node=b;class t{constructor(S){this.b=S,this.a=new Map}roots(){const S=[];for(const I of this.a.values())I.outgoing.size===0&&S.push(I);return S}insertEdge(S,I){const A=this.lookupOrInsertNode(S),E=this.lookupOrInsertNode(I);A.outgoing.set(E.key,E),E.incoming.set(A.key,A)}removeNode(S){const I=this.b(S);this.a.delete(I);for(const A of this.a.values())A.outgoing.delete(I),A.incoming.delete(I)}lookupOrInsertNode(S){const I=this.b(S);let A=this.a.get(I);return A||(A=new b(I,S),this.a.set(I,A)),A}lookup(S){return this.a.get(this.b(S))}isEmpty(){return this.a.size===0}toString(){const S=[];for(const[I,A]of this.a)S.push(`${I}
	(-> incoming)[${[...A.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...A.outgoing.keys()].join(",")}]
`);return S.join(`
`)}findCycleSlow(){for(const[S,I]of this.a){const A=new Set([S]),E=this.c(I,A);if(E)return E}}c(S,I){for(const[A,E]of S.outgoing){if(I.has(A))return[...I,A].join(" -> ");I.add(A);const y=this.c(E,I);if(y)return y;I.delete(A)}}}e.Graph=t}),define(ve[5],be([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var b;(function(I){I.serviceIds=new Map,I.DI_TARGET="$di$target",I.DI_DEPENDENCIES="$di$dependencies";function A(E){return E[I.DI_DEPENDENCIES]||[]}I.getServiceDependencies=A})(b=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function t(I,A,E){A[b.DI_TARGET]===A?A[b.DI_DEPENDENCIES].push({id:I,index:E}):(A[b.DI_DEPENDENCIES]=[{id:I,index:E}],A[b.DI_TARGET]=A)}function k(I){if(b.serviceIds.has(I))return b.serviceIds.get(I);const A=function(E,y,D){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(A,E,D)};return A.toString=()=>I,b.serviceIds.set(I,A),A}e.createDecorator=k;function S(I){return I}e.refineServiceDecorator=S}),define(ve[24],be([1,0,11,4,5]),function(ie,e,b,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function S(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof t.URI)}e.isConfigurationOverrides=S;function I(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||Array.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=I;var A;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.USER=2]="USER",d[d.USER_LOCAL=3]="USER_LOCAL",d[d.USER_REMOTE=4]="USER_REMOTE",d[d.WORKSPACE=5]="WORKSPACE",d[d.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",d[d.DEFAULT=7]="DEFAULT",d[d.MEMORY=8]="MEMORY"})(A=e.ConfigurationTarget||(e.ConfigurationTarget={}));function E(d){switch(d){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=E;function y(d,v){const c=Object.create(null);for(const h in d)D(c,h,d[h],v);return c}e.toValuesTree=y;function D(d,v,c,h){const f=v.split("."),i=f.pop();let n=d;for(let r=0;r<f.length;r++){const o=f[r];let a=n[o];switch(typeof a){case"undefined":a=n[o]=Object.create(null);break;case"object":break;default:h(`Ignoring ${v} as ${f.slice(0,r+1).join(".")} is ${JSON.stringify(a)}`);return}n=a}if(typeof n=="object"&&n!==null)try{n[i]=c}catch{h(`Ignoring ${v} as ${f.join(".")} is ${JSON.stringify(n)}`)}else h(`Ignoring ${v} as ${f.join(".")} is ${JSON.stringify(n)}`)}e.addToValueTree=D;function T(d,v){const c=v.split(".");C(d,c)}e.removeFromValueTree=T;function C(d,v){const c=v.shift();if(v.length===0){delete d[c];return}if(Object.keys(d).indexOf(c)!==-1){const h=d[c];typeof h=="object"&&!Array.isArray(h)&&(C(h,v),Object.keys(h).length===0&&delete d[c])}}function w(d,v,c){function h(n,r){let o=n;for(const a of r){if(typeof o!="object"||o===null)return;o=o[a]}return o}const f=v.split("."),i=h(d,f);return typeof i>"u"?c:i}e.getConfigurationValue=w;function m(d,v,c){Object.keys(v).forEach(h=>{h!=="__proto__"&&(h in d?b.isObject(d[h])&&b.isObject(v[h])?m(d[h],v[h],c):c&&(d[h]=v[h]):d[h]=v[h])})}e.merge=m;function g(d,v,c){const h=d.inspect(v),f=d.inspect(c);return typeof h.userValue<"u"||typeof h.workspaceValue<"u"||typeof h.workspaceFolderValue<"u"?h.value:typeof f.userValue<"u"||typeof f.workspaceValue<"u"||typeof f.workspaceFolderValue<"u"?f.value:h.defaultValue}e.getMigratedSettingValue=g;function p(d){return d.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=p}),define(ve[100],be([1,0,3,15,5]),function(ie,e,b,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const S=new Map;S.set("false",!1),S.set("true",!0),S.set("isMac",b.isMacintosh),S.set("isLinux",b.isLinux),S.set("isWindows",b.isWindows),S.set("isWeb",b.isWeb),S.set("isMacNative",b.isMacintosh&&!b.isWeb),S.set("isEdge",b.isEdge),S.set("isFirefox",b.isFirefox),S.set("isChrome",b.isChrome),S.set("isSafari",b.isSafari);const I=Object.prototype.hasOwnProperty;var A;(function(se){se[se.False=0]="False",se[se.True=1]="True",se[se.Defined=2]="Defined",se[se.Not=3]="Not",se[se.Equals=4]="Equals",se[se.NotEquals=5]="NotEquals",se[se.And=6]="And",se[se.Regex=7]="Regex",se[se.NotRegex=8]="NotRegex",se[se.Or=9]="Or",se[se.In=10]="In",se[se.NotIn=11]="NotIn",se[se.Greater=12]="Greater",se[se.GreaterEquals=13]="GreaterEquals",se[se.Smaller=14]="Smaller",se[se.SmallerEquals=15]="SmallerEquals"})(A=e.ContextKeyExprType||(e.ContextKeyExprType={}));class E{static false(){return T.INSTANCE}static true(){return C.INSTANCE}static has(U){return w.create(U)}static equals(U,Q){return m.create(U,Q)}static notEquals(U,Q){return d.create(U,Q)}static regex(U,Q){return r.create(U,Q)}static in(U,Q){return g.create(U,Q)}static notIn(U,Q){return p.create(U,Q)}static not(U){return v.create(U)}static and(...U){return l.create(U,null,!0)}static or(...U){return s.create(U,null,!0)}static greater(U,Q){return h.create(U,Q)}static greaterEquals(U,Q){return f.create(U,Q)}static smaller(U,Q){return i.create(U,Q)}static smallerEquals(U,Q){return n.create(U,Q)}static deserialize(U,Q=!1){if(!!U)return this.c(U,Q)}static c(U,Q){const z=U.split("||");return s.create(z.map(G=>this.d(G,Q)),null,!0)}static d(U,Q){const z=U.split("&&");return l.create(z.map(G=>this.f(G,Q)),null,!0)}static f(U,Q){if(U=U.trim(),U.indexOf("!=")>=0){const z=U.split("!=");return d.create(z[0].trim(),this.g(z[1],Q))}if(U.indexOf("==")>=0){const z=U.split("==");return m.create(z[0].trim(),this.g(z[1],Q))}if(U.indexOf("=~")>=0){const z=U.split("=~");return r.create(z[0].trim(),this.h(z[1],Q))}if(U.indexOf(" not in ")>=0){const z=U.split(" not in ");return p.create(z[0].trim(),this.g(z[1],Q))}if(U.indexOf(" in ")>=0){const z=U.split(" in ");return g.create(z[0].trim(),this.g(z[1],Q))}if(/^[^<=>]+>=[^<=>]+$/.test(U)){const z=U.split(">=");return f.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(U)){const z=U.split(">");return h.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(U)){const z=U.split("<=");return n.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(U)){const z=U.split("<");return i.create(z[0].trim(),z[1].trim())}return/^\!\s*/.test(U)?v.create(U.substr(1).trim()):w.create(U)}static g(U,Q){if(U=U.trim(),U==="true")return!0;if(U==="false")return!1;const z=/^'([^']*)'$/.exec(U);return z?z[1].trim():U}static h(U,Q){if((0,t.isFalsyOrWhitespace)(U)){if(Q)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const z=U.indexOf("/"),G=U.lastIndexOf("/");if(z===G||z<0){if(Q)throw new Error(`bad regexp-value '${U}', missing /-enclosure`);return console.warn(`bad regexp-value '${U}', missing /-enclosure`),null}const X=U.slice(z+1,G),ce=U[G+1]==="i"?"i":"";try{return new RegExp(X,ce)}catch(L){if(Q)throw new Error(`bad regexp-value '${U}', parse error: ${L}`);return console.warn(`bad regexp-value '${U}', parse error: ${L}`),null}}}e.ContextKeyExpr=E;function y(se,U){const Q=se?se.substituteConstants():void 0,z=U?U.substituteConstants():void 0;return!Q&&!z?!0:!Q||!z?!1:Q.equals(z)}e.expressionsAreEqualWithConstantSubstitution=y;function D(se,U){return se.cmp(U)}class T{constructor(){this.type=0}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!1}serialize(){return"false"}keys(){return[]}map(U){return this}negate(){return C.INSTANCE}}e.ContextKeyFalseExpr=T,T.INSTANCE=new T;class C{constructor(){this.type=1}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!0}serialize(){return"true"}keys(){return[]}map(U){return this}negate(){return T.INSTANCE}}e.ContextKeyTrueExpr=C,C.INSTANCE=new C;class w{static create(U,Q=null){const z=S.get(U);return typeof z=="boolean"?z?C.INSTANCE:T.INSTANCE:new w(U,Q)}constructor(U,Q){this.key=U,this.c=Q,this.type=2}cmp(U){return U.type!==this.type?this.type-U.type:P(this.key,U.key)}equals(U){return U.type===this.type?this.key===U.key:!1}substituteConstants(){const U=S.get(this.key);return typeof U=="boolean"?U?C.INSTANCE:T.INSTANCE:this}evaluate(U){return!!U.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(U){return U.mapDefined(this.key)}negate(){return this.c||(this.c=v.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=w;class m{static create(U,Q,z=null){if(typeof Q=="boolean")return Q?w.create(U,z):v.create(U,z);const G=S.get(U);return typeof G=="boolean"?Q===(G?"true":"false")?C.INSTANCE:T.INSTANCE:new m(U,Q,z)}constructor(U,Q,z){this.c=U,this.d=Q,this.f=z,this.type=4}cmp(U){return U.type!==this.type?this.type-U.type:F(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=S.get(this.c);if(typeof U=="boolean"){const Q=U?"true":"false";return this.d===Q?C.INSTANCE:T.INSTANCE}return this}evaluate(U){return U.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(U){return U.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=d.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=m;class g{static create(U,Q){return new g(U,Q)}constructor(U,Q){this.d=U,this.f=Q,this.type=10,this.c=null}cmp(U){return U.type!==this.type?this.type-U.type:F(this.d,this.f,U.d,U.f)}equals(U){return U.type===this.type?this.d===U.d&&this.f===U.f:!1}substituteConstants(){return this}evaluate(U){const Q=U.getValue(this.f),z=U.getValue(this.d);return Array.isArray(Q)?Q.includes(z):typeof z=="string"&&typeof Q=="object"&&Q!==null?I.call(Q,z):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(U){return U.mapIn(this.d,this.f)}negate(){return this.c||(this.c=p.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=g;class p{static create(U,Q){return new p(U,Q)}constructor(U,Q){this.d=U,this.f=Q,this.type=11,this.c=g.create(U,Q)}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(U){return U.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=p;class d{static create(U,Q,z=null){if(typeof Q=="boolean")return Q?v.create(U,z):w.create(U,z);const G=S.get(U);return typeof G=="boolean"?Q===(G?"true":"false")?T.INSTANCE:C.INSTANCE:new d(U,Q,z)}constructor(U,Q,z){this.c=U,this.d=Q,this.f=z,this.type=5}cmp(U){return U.type!==this.type?this.type-U.type:F(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=S.get(this.c);if(typeof U=="boolean"){const Q=U?"true":"false";return this.d===Q?T.INSTANCE:C.INSTANCE}return this}evaluate(U){return U.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(U){return U.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=m.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=d;class v{static create(U,Q=null){const z=S.get(U);return typeof z=="boolean"?z?T.INSTANCE:C.INSTANCE:new v(U,Q)}constructor(U,Q){this.c=U,this.d=Q,this.type=3}cmp(U){return U.type!==this.type?this.type-U.type:P(this.c,U.c)}equals(U){return U.type===this.type?this.c===U.c:!1}substituteConstants(){const U=S.get(this.c);return typeof U=="boolean"?U?T.INSTANCE:C.INSTANCE:this}evaluate(U){return!U.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(U){return U.mapNot(this.c)}negate(){return this.d||(this.d=w.create(this.c,this)),this.d}}e.ContextKeyNotExpr=v;function c(se,U){if(typeof se=="string"){const Q=parseFloat(se);isNaN(Q)||(se=Q)}return typeof se=="string"||typeof se=="number"?U(se):T.INSTANCE}class h{static create(U,Q,z=null){return c(Q,G=>new h(U,G,z))}constructor(U,Q,z){this.c=U,this.d=Q,this.f=z,this.type=12}cmp(U){return U.type!==this.type?this.type-U.type:F(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=n.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=h;class f{static create(U,Q,z=null){return c(Q,G=>new f(U,G,z))}constructor(U,Q,z){this.c=U,this.d=Q,this.f=z,this.type=13}cmp(U){return U.type!==this.type?this.type-U.type:F(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=i.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=f;class i{static create(U,Q,z=null){return c(Q,G=>new i(U,G,z))}constructor(U,Q,z){this.c=U,this.d=Q,this.f=z,this.type=14}cmp(U){return U.type!==this.type?this.type-U.type:F(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=f.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=i;class n{static create(U,Q,z=null){return c(Q,G=>new n(U,G,z))}constructor(U,Q,z){this.c=U,this.d=Q,this.f=z,this.type=15}cmp(U){return U.type!==this.type?this.type-U.type:F(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=h.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=n;class r{static create(U,Q){return new r(U,Q)}constructor(U,Q){this.d=U,this.f=Q,this.type=7,this.c=null}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.d<U.d)return-1;if(this.d>U.d)return 1;const Q=this.f?this.f.source:"",z=U.f?U.f.source:"";return Q<z?-1:Q>z?1:0}equals(U){if(U.type===this.type){const Q=this.f?this.f.source:"",z=U.f?U.f.source:"";return this.d===U.d&&Q===z}return!1}substituteConstants(){return this}evaluate(U){const Q=U.getValue(this.d);return this.f?this.f.test(Q):!1}serialize(){const U=this.f?`/${this.f.source}/${this.f.ignoreCase?"i":""}`:"/invalid/";return`${this.d} =~ ${U}`}keys(){return[this.d]}map(U){return U.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=o.create(this)),this.c}}e.ContextKeyRegexExpr=r;class o{static create(U){return new o(U)}constructor(U){this.c=U,this.type=8}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(U){return new o(this.c.map(U))}negate(){return this.c}}e.ContextKeyNotRegexExpr=o;function a(se){let U=null;for(let Q=0,z=se.length;Q<z;Q++){const G=se[Q].substituteConstants();if(se[Q]!==G&&U===null){U=[];for(let X=0;X<Q;X++)U[X]=se[X]}U!==null&&(U[Q]=G)}return U===null?se:U}class l{static create(U,Q,z){return l.d(U,Q,z)}constructor(U,Q){this.expr=U,this.c=Q,this.type=6}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let Q=0,z=this.expr.length;Q<z;Q++){const G=D(this.expr[Q],U.expr[Q]);if(G!==0)return G}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let Q=0,z=this.expr.length;Q<z;Q++)if(!this.expr[Q].equals(U.expr[Q]))return!1;return!0}return!1}substituteConstants(){const U=a(this.expr);return U===this.expr?this:l.create(U,this.c,!1)}evaluate(U){for(let Q=0,z=this.expr.length;Q<z;Q++)if(!this.expr[Q].evaluate(U))return!1;return!0}static d(U,Q,z){const G=[];let X=!1;for(const ce of U)if(!!ce){if(ce.type===1){X=!0;continue}if(ce.type===0)return T.INSTANCE;if(ce.type===6){G.push(...ce.expr);continue}G.push(ce)}if(G.length===0&&X)return C.INSTANCE;if(G.length!==0){if(G.length===1)return G[0];G.sort(D);for(let ce=1;ce<G.length;ce++)G[ce-1].equals(G[ce])&&(G.splice(ce,1),ce--);if(G.length===1)return G[0];for(;G.length>1;){const ce=G[G.length-1];if(ce.type!==9)break;G.pop();const L=G.pop(),N=G.length===0,V=s.create(ce.expr.map(ee=>l.create([ee,L],null,z)),null,N);V&&(G.push(V),G.sort(D))}if(G.length===1)return G[0];if(z){for(let ce=0;ce<G.length;ce++)for(let L=ce+1;L<G.length;L++)if(G[ce].negate().equals(G[L]))return T.INSTANCE;if(G.length===1)return G[0]}return new l(G,Q)}}serialize(){return this.expr.map(U=>U.serialize()).join(" && ")}keys(){const U=[];for(const Q of this.expr)U.push(...Q.keys());return U}map(U){return new l(this.expr.map(Q=>Q.map(U)),null)}negate(){if(!this.c){const U=[];for(const Q of this.expr)U.push(Q.negate());this.c=s.create(U,this,!0)}return this.c}}class s{static create(U,Q,z){return s.d(U,Q,z)}constructor(U,Q){this.expr=U,this.c=Q,this.type=9}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let Q=0,z=this.expr.length;Q<z;Q++){const G=D(this.expr[Q],U.expr[Q]);if(G!==0)return G}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let Q=0,z=this.expr.length;Q<z;Q++)if(!this.expr[Q].equals(U.expr[Q]))return!1;return!0}return!1}substituteConstants(){const U=a(this.expr);return U===this.expr?this:s.create(U,this.c,!1)}evaluate(U){for(let Q=0,z=this.expr.length;Q<z;Q++)if(this.expr[Q].evaluate(U))return!0;return!1}static d(U,Q,z){let G=[],X=!1;if(U){for(let ce=0,L=U.length;ce<L;ce++){const N=U[ce];if(!!N){if(N.type===0){X=!0;continue}if(N.type===1)return C.INSTANCE;if(N.type===9){G=G.concat(N.expr);continue}G.push(N)}}if(G.length===0&&X)return T.INSTANCE;G.sort(D)}if(G.length!==0){if(G.length===1)return G[0];for(let ce=1;ce<G.length;ce++)G[ce-1].equals(G[ce])&&(G.splice(ce,1),ce--);if(G.length===1)return G[0];if(z){for(let ce=0;ce<G.length;ce++)for(let L=ce+1;L<G.length;L++)if(G[ce].negate().equals(G[L]))return C.INSTANCE;if(G.length===1)return G[0]}return new s(G,Q)}}serialize(){return this.expr.map(U=>U.serialize()).join(" || ")}keys(){const U=[];for(const Q of this.expr)U.push(...Q.keys());return U}map(U){return new s(this.expr.map(Q=>Q.map(U)),null)}negate(){if(!this.c){const U=[];for(const Q of this.expr)U.push(Q.negate());for(;U.length>1;){const Q=U.shift(),z=U.shift(),G=[];for(const X of ue(Q))for(const ce of ue(z))G.push(l.create([X,ce],null,!1));U.unshift(s.create(G,null,!1))}this.c=s.create(U,this,!0)}return this.c}}class u extends w{static all(){return u.d.values()}constructor(U,Q,z){super(U,null),this.f=Q,typeof z=="object"?u.d.push({...z,key:U}):z!==!0&&u.d.push({key:U,description:z,type:Q!=null?typeof Q:void 0})}bindTo(U){return U.createKey(this.key,this.f)}getValue(U){return U.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(U){return m.create(this.key,U)}notEqualsTo(U){return d.create(this.key,U)}}e.RawContextKey=u,u.d=[],e.IContextKeyService=(0,k.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function P(se,U){return se<U?-1:se>U?1:0}function F(se,U,Q,z){return se<Q?-1:se>Q?1:U<z?-1:U>z?1:0}function K(se,U){if(se.type===0||U.type===1)return!0;if(se.type===9)return U.type===9?ne(se.expr,U.expr):!1;if(U.type===9){for(const Q of U.expr)if(K(se,Q))return!0;return!1}if(se.type===6){if(U.type===6)return ne(U.expr,se.expr);for(const Q of se.expr)if(K(Q,U))return!0;return!1}return se.equals(U)}e.implies=K;function ne(se,U){let Q=0,z=0;for(;Q<se.length&&z<U.length;){const G=se[Q].cmp(U[z]);if(G<0)return!1;G===0&&Q++,z++}return Q===se.length}function ue(se){return se.type===9?se.expr:[se]}}),define(ve[74],be([1,0,5]),function(ie,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,b.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,b.createDecorator)("credentialsMainService");class t{constructor(){this.a={}}async getPassword(S,I){return this.a[S]?.[I]??null}async setPassword(S,I,A){this.a[S]=this.a[S]??{},this.a[S][I]=A}async deletePassword(S,I){return this.a[S]?.[I]?(delete this.a[S][I],Object.keys(this.a[S]).length===0&&delete this.a[S],!0):!1}async findPassword(S){return JSON.stringify(this.a[S])??null}async findCredentials(S){const I=[];for(const A of Object.keys(this.a[S]||{}))I.push({account:A,password:this.a[S][A]});return I}async clear(){this.a={}}}e.InMemoryCredentialsProvider=t}),define(ve[199],be([1,0,5]),function(ie,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,b.createDecorator)(e.ID);function t(S){return!!S.hostName&&!!S.errorMessage}e.isRemoteDiagnosticError=t;class k{async getPerformanceInfo(I,A){return{}}async getSystemInfo(I,A){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(I,A){return""}async getWorkspaceFileExtensions(I){return{extensions:[]}}async reportWorkspaceStats(I){}}e.NullDiagnosticsService=k}),define(ve[75],be([1,0,5]),function(ie,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,b.createDecorator)("downloadService")}),define(ve[200],be([1,0,5]),function(ie,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,b.createDecorator)("encryptionMainService")}),define(ve[28],be([1,0,5]),function(ie,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,b.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,b.refineServiceDecorator)(e.IEnvironmentService)}),define(ve[31],be([1,0,165,5]),function(ie,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function k(d){switch(d){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function S(d){switch(d){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=S;function I(d,v){switch(d){case 3:return v==="x64"?"win32-x64":v==="ia32"?"win32-ia32":v==="arm64"?"win32-arm64":"unknown";case 2:return v==="x64"?"linux-x64":v==="arm64"?"linux-arm64":v==="arm"?"linux-armhf":"unknown";case"alpine":return v==="x64"?"alpine-x64":v==="arm64"?"alpine-arm64":"unknown";case 1:return v==="x64"?"darwin-x64":v==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=I;function A(d,v){return v==="web"&&!d.includes("web")}e.isNotWebExtensionInWebTargetPlatform=A;function E(d,v,c){return A(v,c)?!1:d==="undefined"||d==="universal"?!0:d==="unknown"?!1:d===c?!0:y(c).includes(d)}e.isTargetPlatformCompatible=E;function y(d){switch(d){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=y;function D(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=D;var T;(function(d){d[d.NoneOrRelevance=0]="NoneOrRelevance",d[d.LastUpdatedDate=1]="LastUpdatedDate",d[d.Title=2]="Title",d[d.PublisherName=3]="PublisherName",d[d.InstallCount=4]="InstallCount",d[d.PublishedDate=10]="PublishedDate",d[d.AverageRating=6]="AverageRating",d[d.WeightedRating=12]="WeightedRating"})(T=e.SortBy||(e.SortBy={}));var C;(function(d){d[d.Default=0]="Default",d[d.Ascending=1]="Ascending",d[d.Descending=2]="Descending"})(C=e.SortOrder||(e.SortOrder={}));var w;(function(d){d.Install="install",d.Uninstall="uninstall"})(w=e.StatisticType||(e.StatisticType={}));var m;(function(d){d[d.None=1]="None",d[d.Install=2]="Install",d[d.Update=3]="Update",d[d.Migrate=4]="Migrate"})(m=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var g;(function(d){d.Unsupported="Unsupported",d.Deprecated="Deprecated",d.Malicious="Malicious",d.Incompatible="Incompatible",d.IncompatiblePreRelease="IncompatiblePreRelease",d.IncompatibleTargetPlatform="IncompatibleTargetPlatform",d.ReleaseVersionNotFound="ReleaseVersionNotFound",d.Invalid="Invalid",d.Download="Download",d.Extract="Extract",d.Delete="Delete",d.Rename="Rename",d.CorruptZip="CorruptZip",d.IncompleteZip="IncompleteZip",d.Internal="Internal",d.Signature="Signature"})(g=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class p extends Error{constructor(v,c){super(v),this.code=c,this.name=c}}e.ExtensionManagementError=p,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,b.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,b.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(ve[201],be([1,0,6,2,47,23,4,72,31]),function(ie,e,b,t,k,S,I,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function y(p,d){return I.URI.revive(d?d.transformIncoming(p):p)}function D(p,d){return d?d.transformOutgoingURI(p):p}function T(p,d){d=d||A.DefaultURITransformer;const v=p.manifest;return{...(0,A.transformAndReviveIncomingURIs)({...p,manifest:void 0},d),manifest:v}}function C(p,d){return d?(0,S.cloneAndChange)(p,v=>v instanceof I.URI?d.transformOutgoingURI(v):void 0):p}class w{constructor(d,v){this.a=d,this.b=v,this.onInstallExtension=b.Event.buffer(d.onInstallExtension,!0),this.onDidInstallExtensions=b.Event.buffer(d.onDidInstallExtensions,!0),this.onUninstallExtension=b.Event.buffer(d.onUninstallExtension,!0),this.onDidUninstallExtension=b.Event.buffer(d.onDidUninstallExtension,!0)}listen(d,v){const c=this.b(d);switch(v){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return b.Event.map(this.onDidInstallExtensions,h=>h.map(f=>({...f,local:f.local?C(f.local,c):f.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(d,v,c){const h=this.b(d);switch(v){case"zip":return this.a.zip(T(c[0],h)).then(f=>D(f,h));case"unzip":return this.a.unzip(y(c[0],h));case"install":return this.a.install(y(c[0],h),(0,k.revive)(c[1]));case"installFromLocation":return this.a.installFromLocation(y(c[0],h),I.URI.revive(c[1]));case"getManifest":return this.a.getManifest(y(c[0],h));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(c[0]);case"installFromGallery":return this.a.installFromGallery(c[0],(0,k.revive)(c[1]));case"uninstall":return this.a.uninstall(T(c[0],h),(0,k.revive)(c[1]));case"reinstallFromGallery":return this.a.reinstallFromGallery(T(c[0],h));case"getInstalled":return this.a.getInstalled(c[0],I.URI.revive(c[1])).then(f=>f.map(i=>C(i,h)));case"getMetadata":return this.a.getMetadata(T(c[0],h));case"updateMetadata":return this.a.updateMetadata(T(c[0],h),c[1]).then(f=>C(f,h));case"updateExtensionScope":return this.a.updateExtensionScope(T(c[0],h),c[1]).then(f=>C(f,h));case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(c[0],c[1])}throw new Error("Invalid call")}}e.ExtensionManagementChannel=w;class m extends t.Disposable{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}constructor(d){super(),this.j=d,this.c=this.B(new b.Emitter),this.f=this.B(new b.Emitter),this.g=this.B(new b.Emitter),this.h=this.B(new b.Emitter),this.B(this.j.listen("onInstallExtension")(v=>this.c.fire({identifier:v.identifier,source:this.k(v.source)?I.URI.revive(v.source):v.source,profileLocation:I.URI.revive(v.profileLocation)}))),this.B(this.j.listen("onDidInstallExtensions")(v=>this.f.fire(v.map(c=>({...c,local:c.local?T(c.local,null):c.local,source:this.k(c.source)?I.URI.revive(c.source):c.source,profileLocation:I.URI.revive(c.profileLocation)}))))),this.B(this.j.listen("onUninstallExtension")(v=>this.g.fire({identifier:v.identifier,profileLocation:I.URI.revive(v.profileLocation)}))),this.B(this.j.listen("onDidUninstallExtension")(v=>this.h.fire({...v,profileLocation:I.URI.revive(v.profileLocation)})))}k(d){return d?typeof d.path=="string"&&typeof d.scheme=="string":!1}getTargetPlatform(){return this.l||(this.l=this.j.call("getTargetPlatform")),this.l}async canInstall(d){const v=await this.getTargetPlatform();return d.allTargetPlatforms.some(c=>(0,E.isTargetPlatformCompatible)(c,d.allTargetPlatforms,v))}zip(d){return Promise.resolve(this.j.call("zip",[d]).then(v=>I.URI.revive(v)))}unzip(d){return Promise.resolve(this.j.call("unzip",[d]))}install(d,v){return Promise.resolve(this.j.call("install",[d,v])).then(c=>T(c,null))}installFromLocation(d,v){return Promise.resolve(this.j.call("installFromLocation",[d,v])).then(c=>T(c,null))}getManifest(d){return Promise.resolve(this.j.call("getManifest",[d]))}installFromGallery(d,v){return Promise.resolve(this.j.call("installFromGallery",[d,v])).then(c=>T(c,null))}uninstall(d,v){return Promise.resolve(this.j.call("uninstall",[d,v]))}reinstallFromGallery(d){return Promise.resolve(this.j.call("reinstallFromGallery",[d]))}getInstalled(d=null,v){return Promise.resolve(this.j.call("getInstalled",[d,v])).then(c=>c.map(h=>T(h,null)))}getMetadata(d){return Promise.resolve(this.j.call("getMetadata",[d]))}updateMetadata(d,v){return Promise.resolve(this.j.call("updateMetadata",[d,v])).then(c=>T(c,null))}updateExtensionScope(d,v){return Promise.resolve(this.j.call("updateExtensionScope",[d,v])).then(c=>T(c,null))}getExtensionsControlManifest(){return Promise.resolve(this.j.call("getExtensionsControlManifest"))}async download(d,v){const c=await this.j.call("download",[d,v]);return I.URI.revive(c)}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=m;class g{constructor(d){this.a=d}listen(d,v){throw new Error("Invalid listen")}call(d,v,c){switch(v){case"getConfigBasedTips":return this.a.getConfigBasedTips(I.URI.revive(c[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=g}),define(ve[76],be([1,0,5]),function(ie,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,b.createDecorator)("IExtensionSignatureVerificationService");class t{b(){return this.a||(this.a=new Promise((S,I)=>ie(["node-vsce-sign"],async A=>S(A),I))),this.a}async verify(S,I){let A;try{A=await this.b()}catch{return!1}return A.verify(S,I)}}e.ExtensionSignatureVerificationService=t}),define(ve[17],be([1,0,58,7,15,11,4,173,5]),function(ie,e,b,t,k,S,I,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,E.createDecorator)("fileService");function y(X){return X.create===!0}e.isFileOpenForWriteOptions=y;var D;(function(X){X[X.Unknown=0]="Unknown",X[X.File=1]="File",X[X.Directory=2]="Directory",X[X.SymbolicLink=64]="SymbolicLink"})(D=e.FileType||(e.FileType={}));var T;(function(X){X[X.Readonly=1]="Readonly"})(T=e.FilePermission||(e.FilePermission={}));var C;(function(X){X[X.FileReadWrite=2]="FileReadWrite",X[X.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",X[X.FileReadStream=16]="FileReadStream",X[X.FileFolderCopy=8]="FileFolderCopy",X[X.PathCaseSensitive=1024]="PathCaseSensitive",X[X.Readonly=2048]="Readonly",X[X.Trash=4096]="Trash",X[X.FileWriteUnlock=8192]="FileWriteUnlock",X[X.FileAtomicRead=16384]="FileAtomicRead",X[X.FileClone=32768]="FileClone"})(C=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function w(X){return!!(X.capabilities&2)}e.hasReadWriteCapability=w;function m(X){return!!(X.capabilities&8)}e.hasFileFolderCopyCapability=m;function g(X){return!!(X.capabilities&32768)}e.hasFileCloneCapability=g;function p(X){return!!(X.capabilities&4)}e.hasOpenReadWriteCloseCapability=p;function d(X){return!!(X.capabilities&16)}e.hasFileReadStreamCapability=d;function v(X){return w(X)?!!(X.capabilities&16384):!1}e.hasFileAtomicReadCapability=v;var c;(function(X){X.FileExists="EntryExists",X.FileNotFound="EntryNotFound",X.FileNotADirectory="EntryNotADirectory",X.FileIsADirectory="EntryIsADirectory",X.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",X.FileTooLarge="EntryTooLarge",X.FileWriteLocked="EntryWriteLocked",X.NoPermissions="NoPermissions",X.Unavailable="Unavailable",X.Unknown="Unknown"})(c=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class h extends Error{constructor(ce,L){super(ce),this.code=L}}e.FileSystemProviderError=h;function f(X,ce){const L=new h(X.toString(),ce);return n(L,ce),L}e.createFileSystemProviderError=f;function i(X){return X||f((0,A.localize)(0,null),c.Unknown)}e.ensureFileSystemProviderError=i;function n(X,ce){return X.name=ce?`${ce} (FileSystemError)`:"FileSystemError",X}e.markAsFileSystemProviderError=n;function r(X){if(!X)return c.Unknown;if(X instanceof h)return X.code;const ce=/^(.+) \(FileSystemError\)$/.exec(X.name);if(!ce)return c.Unknown;switch(ce[1]){case c.FileExists:return c.FileExists;case c.FileIsADirectory:return c.FileIsADirectory;case c.FileNotADirectory:return c.FileNotADirectory;case c.FileNotFound:return c.FileNotFound;case c.FileExceedsMemoryLimit:return c.FileExceedsMemoryLimit;case c.FileTooLarge:return c.FileTooLarge;case c.FileWriteLocked:return c.FileWriteLocked;case c.NoPermissions:return c.NoPermissions;case c.Unavailable:return c.Unavailable}return c.Unknown}e.toFileSystemProviderErrorCode=r;function o(X){if(X instanceof F)return X.fileOperationResult;switch(r(X)){case c.FileNotFound:return 1;case c.FileIsADirectory:return 0;case c.FileNotADirectory:return 10;case c.FileWriteLocked:return 5;case c.NoPermissions:return 6;case c.FileExists:return 4;case c.FileExceedsMemoryLimit:return 9;case c.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=o;var a;(function(X){X[X.CREATE=0]="CREATE",X[X.DELETE=1]="DELETE",X[X.MOVE=2]="MOVE",X[X.COPY=3]="COPY",X[X.WRITE=4]="WRITE"})(a=e.FileOperation||(e.FileOperation={}));class l{constructor(ce,L,N){this.resource=ce,this.operation=L,this.target=N}isOperation(ce){return this.operation===ce}}e.FileOperationEvent=l;var s;(function(X){X[X.UPDATED=0]="UPDATED",X[X.ADDED=1]="ADDED",X[X.DELETED=2]="DELETED"})(s=e.FileChangeType||(e.FileChangeType={}));class u{constructor(ce,L){this.a=void 0,this.b=void 0,this.c=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=ce;const N=new Map;for(const V of ce){const ee=N.get(V.type);switch(ee?ee.push([V.resource,V]):N.set(V.type,[[V.resource,V]]),V.type){case 1:this.rawAdded.push(V.resource);break;case 0:this.rawUpdated.push(V.resource);break;case 2:this.rawDeleted.push(V.resource);break}}for(const[V,ee]of N)switch(V){case 1:this.a=b.TernarySearchTree.forUris(()=>L),this.a.fill(ee);break;case 0:this.b=b.TernarySearchTree.forUris(()=>L),this.b.fill(ee);break;case 2:this.c=b.TernarySearchTree.forUris(()=>L),this.c.fill(ee);break}}contains(ce,...L){return this.d(ce,{includeChildren:!1},...L)}affects(ce,...L){return this.d(ce,{includeChildren:!0},...L)}d(ce,L,...N){if(!ce)return!1;const V=N.length>0;return!!((!V||N.includes(1))&&(this.a?.get(ce)||L.includeChildren&&this.a?.findSuperstr(ce))||(!V||N.includes(0))&&(this.b?.get(ce)||L.includeChildren&&this.b?.findSuperstr(ce))||(!V||N.includes(2))&&(this.c?.findSubstr(ce)||L.includeChildren&&this.c?.findSuperstr(ce)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=u;function P(X,ce,L){return!X||!ce||X===ce||ce.length>X.length?!1:(ce.charAt(ce.length-1)!==t.sep&&(ce+=t.sep),L?(0,k.startsWithIgnoreCase)(X,ce):X.indexOf(ce)===0)}e.isParent=P;class F extends Error{constructor(ce,L,N){super(ce),this.fileOperationResult=L,this.options=N}}e.FileOperationError=F;class K extends F{constructor(ce,L,N){super(ce,2,N),this.stat=L}}e.NotModifiedSinceFileOperationError=K;var ne;(function(X){X[X.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",X[X.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",X[X.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",X[X.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",X[X.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",X[X.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",X[X.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",X[X.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",X[X.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",X[X.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",X[X.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",X[X.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(ne=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var ue;(function(X){X[X.FILE=0]="FILE",X[X.FOLDER=1]="FOLDER",X[X.ROOT_FOLDER=2]="ROOT_FOLDER"})(ue=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function se(X){if(!(typeof X.size!="number"||typeof X.mtime!="number"))return X.mtime.toString(29)+X.size.toString(31)}e.etag=se;async function U(X,ce){if(!ce.hasProvider(I.URI.from({scheme:X.scheme})))return new Promise(L=>{const N=ce.onDidChangeFileSystemProviderRegistrations(V=>{V.scheme===X.scheme&&V.added&&(N.dispose(),L())})})}e.whenProviderRegistered=U,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class Q{static formatSize(ce){return(0,S.isNumber)(ce)||(ce=0),ce<Q.KB?(0,A.localize)(1,null,ce.toFixed(0)):ce<Q.MB?(0,A.localize)(2,null,(ce/Q.KB).toFixed(2)):ce<Q.GB?(0,A.localize)(3,null,(ce/Q.MB).toFixed(2)):ce<Q.TB?(0,A.localize)(4,null,(ce/Q.GB).toFixed(2)):(0,A.localize)(5,null,(ce/Q.TB).toFixed(2))}}e.ByteSize=Q,Q.KB=1024,Q.MB=Q.KB*Q.KB,Q.GB=Q.MB*Q.KB,Q.TB=Q.GB*Q.KB;var z;(function(X){X[X.IA32=0]="IA32",X[X.OTHER=1]="OTHER"})(z=e.Arch||(e.Arch={}));function G(X){return{maxFileSize:X===0?300*Q.MB:16*Q.GB,maxHeapSize:X===0?700*Q.MB:2*700*Q.MB}}e.getPlatformLimits=G}),define(ve[202],be([1,0,16,39,8,6,2,44,4,22,17]),function(ie,e,b,t,k,S,I,A,E,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class T extends I.Disposable{constructor(w,m){super(),this.a=w,this.b=m,this.onDidChangeCapabilities=S.Event.None,this.f=this.B(new S.Emitter),this.onDidChangeFile=this.f.event,this.g=this.B(new S.Emitter),this.onDidWatchError=this.g.event,this.h=(0,y.generateUuid)(),this.i()}get capabilities(){return this.c||(this.c=57374,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(w){return this.a.call("stat",[w])}readdir(w){return this.a.call("readdir",[w])}async readFile(w,m){const{buffer:g}=await this.a.call("readFile",[w,m]);return g}readFileStream(w,m,g){const p=(0,A.newWriteableStream)(v=>b.VSBuffer.concat(v.map(c=>b.VSBuffer.wrap(c))).buffer),d=this.a.listen("readFileStream",[w,m])(v=>{if(v instanceof b.VSBuffer)p.write(v.buffer);else{if(v==="end")p.end();else{let c=v;c instanceof Error||(c=(0,D.createFileSystemProviderError)((0,t.toErrorMessage)(c),D.FileSystemProviderErrorCode.Unknown)),p.error(c),p.end()}d.dispose()}});return g.onCancellationRequested(()=>{p.error((0,k.canceled)()),p.end(),d.dispose()}),p}writeFile(w,m,g){return this.a.call("writeFile",[w,b.VSBuffer.wrap(m),g])}open(w,m){return this.a.call("open",[w,m])}close(w){return this.a.call("close",[w])}async read(w,m,g,p,d){const[v,c]=await this.a.call("read",[w,m,d]);return g.set(v.buffer.slice(0,c),p),c}write(w,m,g,p,d){return this.a.call("write",[w,m,b.VSBuffer.wrap(g),p,d])}mkdir(w){return this.a.call("mkdir",[w])}delete(w,m){return this.a.call("delete",[w,m])}rename(w,m,g){return this.a.call("rename",[w,m,g])}copy(w,m,g){return this.a.call("copy",[w,m,g])}cloneFile(w,m){return this.a.call("cloneFile",[w,m])}i(){this.B(this.a.listen("fileChange",[this.h])(w=>{if(Array.isArray(w)){const m=w;this.f.fire(m.map(g=>({resource:E.URI.revive(g.resource),type:g.type})))}else{const m=w;this.g.fire(m)}}))}watch(w,m){const g=(0,y.generateUuid)();return this.a.call("watch",[this.h,g,w,m]),(0,I.toDisposable)(()=>this.a.call("unwatch",[this.h,g]))}}e.DiskFileSystemProviderClient=T}),define(ve[101],be([1,0,16,8,174,17]),function(ie,e,b,t,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function I(D,T,C,w,m,g){let p;try{await A(D,T,C,w,m,g)}catch(d){p=d}finally{p&&m.errorTransformer&&(p=m.errorTransformer(p)),typeof p<"u"&&C.error(p),C.end()}}e.readFileIntoStream=I;async function A(D,T,C,w,m,g){E(g);const p=await D.open(T,{create:!1});try{E(g);let d=0,v=0,c=m&&typeof m.length=="number"?m.length:void 0,h=b.VSBuffer.alloc(Math.min(m.bufferSize,typeof c=="number"?c:m.bufferSize)),f=m&&typeof m.position=="number"?m.position:0,i=0;do v=await D.read(p,f,h.buffer,i,h.byteLength-i),f+=v,i+=v,d+=v,typeof c=="number"&&(c-=v),i===h.byteLength&&(await C.write(w(h)),h=b.VSBuffer.alloc(Math.min(m.bufferSize,typeof c=="number"?c:m.bufferSize)),i=0);while(v>0&&(typeof c!="number"||c>0)&&E(g)&&y(d,m));if(i>0){let n=i;typeof c=="number"&&(n=Math.min(i,c)),C.write(w(h.slice(0,n)))}}catch(d){throw(0,S.ensureFileSystemProviderError)(d)}finally{await D.close(p)}}function E(D){if(D.isCancellationRequested)throw(0,t.canceled)();return!0}function y(D,T){if(T?.limits){if(typeof T.limits.memory=="number"&&D>T.limits.memory)throw(0,S.createFileSystemProviderError)((0,k.localize)(0,null),S.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof T.limits.size=="number"&&D>T.limits.size)throw(0,S.createFileSystemProviderError)((0,k.localize)(1,null),S.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ve[62],be([1,0,71,2,7,3,4,17]),function(ie,e,b,t,k,S,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function E(d){return d.recursive===!0}e.isRecursiveWatchRequest=E;class y extends t.Disposable{constructor(v,c,h,f){super(),this.h=v,this.i=c,this.j=h,this.k=f,this.c=this.B(new t.MutableDisposable),this.f=void 0,this.g=0}m(){const v=new t.DisposableStore;this.c.value=v,this.b=this.l(v),this.b.setVerboseLogging(this.j),v.add(this.b.onDidChangeFile(c=>this.h(c))),v.add(this.b.onDidLogMessage(c=>this.i(c))),v.add(this.b.onDidError(c=>this.n(c)))}n(v){this.k.restartOnError?this.g<y.a&&this.f?(this.r(`restarting watcher after error: ${v}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${v}`):this.r(v)}p(v){this.g++,this.m(),this.watch(v)}async watch(v){this.f=v,await this.b?.watch(v)}async setVerboseLogging(v){this.j=v,await this.b?.setVerboseLogging(v)}r(v){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${v}`})}dispose(){return this.b=void 0,super.dispose()}}e.AbstractWatcherClient=y,y.a=5;class D extends y{constructor(v,c,h){super(v,c,h,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=D;class T extends y{constructor(v,c,h){super(v,c,h,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=T;function C(d){return d.map(v=>({type:v.type,resource:I.URI.file(v.path)}))}e.toFileChanges=C;function w(d){const v=new p;for(const c of d)v.processEvent(c);return v.coalesce()}e.coalesceEvents=w;function m(d,v){return typeof v=="string"&&!v.startsWith(b.GLOBSTAR)&&!(0,k.isAbsolute)(v)?{base:d,pattern:v}:v}e.normalizeWatcherPattern=m;function g(d,v){const c=[];for(const h of v)c.push((0,b.parse)(m(d,h)));return c}e.parseWatcherPatterns=g;class p{constructor(){this.a=new Set,this.b=new Map}c(v){return S.isLinux?v.path:v.path.toLowerCase()}processEvent(v){const c=this.b.get(this.c(v));let h=!1;if(c){const f=c.type,i=v.type;c.path!==v.path&&(v.type===2||v.type===1)?h=!0:f===1&&i===2?(this.b.delete(this.c(v)),this.a.delete(c)):f===2&&i===1?c.type=0:f===1&&i===0||(c.type=i)}else h=!0;h&&(this.a.add(v),this.b.set(this.c(v),v))}coalesce(){const v=[],c=[];return Array.from(this.a).filter(h=>h.type!==2?(v.push(h),!1):!0).sort((h,f)=>h.path.length-f.path.length).filter(h=>c.some(f=>(0,A.isParent)(h.path,f,!S.isLinux))?!1:(c.push(h.path),!0)).concat(v)}}}),define(ve[203],be([1,0,29,14,19,37,2,87,7,3,155,21,62]),function(ie,e,b,t,k,S,I,A,E,y,D,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class w extends I.Disposable{constructor(p,d,v,c){super(),this.k=p,this.l=d,this.m=v,this.n=c,this.c=new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},h=>this.l(h)),this.f=this.B(new t.ThrottledDelayer(w.b)),this.g=[],this.h=(0,C.parseWatcherPatterns)(this.k.path,this.k.excludes),this.i=this.k.includes?(0,C.parseWatcherPatterns)(this.k.path,this.k.includes):void 0,this.j=new k.CancellationTokenSource,this.ready=this.r()}async r(){try{const p=await this.s(this.k);if(this.j.token.isCancellationRequested)return;const d=await T.Promises.stat(p);this.B(await this.t(p,d.isDirectory()))}catch(p){p.code!=="ENOENT"?this.w(p):this.z(p)}}async s(p){let d=p.path;try{d=await T.Promises.realpath(p.path),p.path===d&&(d=await(0,D.realcase)(p.path)??p.path),p.path!==d&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${p.path}, real: ${d})`)}catch{}return d}async t(p,d){if(y.isMacintosh&&(0,S.isEqualOrParent)(p,"/Volumes/",!0))return this.w(`Refusing to watch ${p} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),I.Disposable.None;const v=new k.CancellationTokenSource(this.j.token),c=new I.DisposableStore;try{const h=(0,E.basename)(p),f=(0,b.watch)(p);c.add((0,I.toDisposable)(()=>{f.removeAllListeners(),f.close()})),this.z(`Started watching: '${p}'`);const i=new Set;if(d)try{for(const r of await T.Promises.readdir(p))i.add(r)}catch(r){this.w(r)}const n=new Map;c.add((0,I.toDisposable)(()=>{for(const[,r]of n)r.dispose();n.clear()})),f.on("error",(r,o)=>{this.w(`Failed to watch ${p} for changes using fs.watch() (${r}, ${o})`),this.dispose()}),f.on("change",(r,o)=>{if(v.token.isCancellationRequested)return;this.z(`[raw] ["${r}"] ${o}`);let a="";if(o&&(a=o.toString(),y.isMacintosh&&(a=(0,A.normalizeNFC)(a))),!(!a||r!=="change"&&r!=="rename"))if(d)if(r==="rename"){n.get(a)?.dispose();const l=setTimeout(async()=>{if(n.delete(a),a===h&&!await T.Promises.exists(p)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const s=await this.v((0,E.join)(p,a));if(v.token.isCancellationRequested)return;let u;s?i.has(a)?u=0:(u=1,i.add(a)):(i.delete(a),u=2),this.u({path:(0,E.join)(this.k.path,a),type:u})},w.a);n.set(a,(0,I.toDisposable)(()=>clearTimeout(l)))}else{let l;i.has(a)?l=0:(l=1,i.add(a)),this.u({path:(0,E.join)(this.k.path,a),type:l})}else if(r==="rename"||a!==h){const l=setTimeout(async()=>{const s=await T.Promises.exists(p);v.token.isCancellationRequested||(s?(this.u({path:this.k.path,type:0},!0),c.add(await this.t(p,!1))):(await this.u({path:this.k.path,type:2},!0),this.dispose()))},w.a);c.clear(),c.add((0,I.toDisposable)(()=>clearTimeout(l)))}else this.u({path:this.k.path,type:0},!0)})}catch(h){await T.Promises.exists(p)&&!v.token.isCancellationRequested&&this.w(`Failed to watch ${p} for changes using fs.watch() (${h.toString()})`)}return(0,I.toDisposable)(()=>{v.dispose(!0),c.dispose()})}async u(p,d=!1){if(!this.j.token.isCancellationRequested){this.n&&this.z(`${p.type===1?"[ADDED]":p.type===2?"[DELETED]":"[CHANGED]"} ${p.path}`),!d&&this.h.some(v=>v(p.path))?this.n&&this.z(` >> ignored (excluded) ${p.path}`):!d&&this.i&&this.i.length>0&&!this.i.some(v=>v(p.path))?this.n&&this.z(` >> ignored (not included) ${p.path}`):this.g.push(p);try{await this.f.trigger(async()=>{const v=this.g;this.g=[];const c=(0,C.coalesceEvents)(v);if(c.length>0){if(this.n)for(const f of c)this.z(`>> normalized ${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.path}`);this.c.work(c)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${c[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${c.length}, most recent change: ${c[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async v(p){if(y.isLinux)return T.Promises.exists(p);try{const d=(0,E.basename)(p);return(await T.Promises.readdir((0,E.dirname)(p))).some(c=>c===d)}catch(d){return this.z(d),!1}}setVerboseLogging(p){this.n=p}w(p){this.j.token.isCancellationRequested||this.m?.({type:"error",message:`[File Watcher (node.js)] ${p}`})}y(p){this.j.token.isCancellationRequested||this.m?.({type:"warn",message:`[File Watcher (node.js)] ${p}`})}z(p){!this.j.token.isCancellationRequested&&this.n&&this.m?.({type:"trace",message:`[File Watcher (node.js)] ${p}`})}dispose(){this.z(`stopping file watcher on ${this.k.path}`),this.j.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=w,w.a=100,w.b=50;async function m(g,p,d,v,c=512){const h=await T.Promises.open(g,"r"),f=Buffer.allocUnsafe(c),i=new k.CancellationTokenSource(v);let n,r=!1;const o={path:g,excludes:[],recursive:!1},a=new w(o,l=>{(async()=>{for(const{type:s}of l)if(s===0){if(r)return;r=!0;try{for(;!i.token.isCancellationRequested;){const{bytesRead:u}=await T.Promises.read(h,f,0,c,null);if(!u||i.token.isCancellationRequested)break;p(f.slice(0,u))}}catch(u){n=new Error(u),i.dispose(!0)}finally{r=!1}}})()});return await a.ready,d(),new Promise((l,s)=>{i.token.onCancellationRequested(async()=>{a.dispose();try{await T.Promises.close(h)}catch(u){n=new Error(u)}n?s(n):l()})})}e.watchFileContents=m}),define(ve[204],be([1,0,6,71,2,3,203]),function(ie,e,b,t,k,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class A extends k.Disposable{constructor(){super(...arguments),this.a=this.B(new b.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new b.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=b.Event.None,this.c=new Map,this.f=!1}async watch(y){const D=this.i(y),T=D.filter(w=>{const m=this.c.get(w.path);return m?!(0,t.patternsEquals)(m.request.excludes,w.excludes)||!(0,t.patternsEquals)(m.request.includes,w.includes):!0}),C=Array.from(this.c.values()).filter(({request:w})=>!D.find(m=>m.path===w.path&&(0,t.patternsEquals)(m.excludes,w.excludes)&&(0,t.patternsEquals)(m.includes,w.includes))).map(({request:w})=>w.path);T.length&&this.j(`Request to start watching: ${T.map(w=>`${w.path} (excludes: ${w.excludes.length>0?w.excludes:"<none>"}, includes: ${w.includes&&w.includes.length>0?JSON.stringify(w.includes):"<all>"})`).join(",")}`),C.length&&this.j(`Request to stop watching: ${C.join(",")}`);for(const w of C)this.h(w);for(const w of T)this.g(w)}g(y){const D=new I.NodeJSFileWatcherLibrary(y,C=>this.a.fire(C),C=>this.b.fire(C),this.f),T={request:y,instance:D};this.c.set(y.path,T)}async stop(){for(const[y]of this.c)this.h(y);this.c.clear()}h(y){const D=this.c.get(y);D&&(this.c.delete(y),D.instance.dispose())}i(y){const D=new Map;for(const T of y){const C=S.isLinux?T.path:T.path.toLowerCase();D.set(C,T)}return Array.from(D.values())}async setVerboseLogging(y){this.f=y;for(const[,D]of this.c)D.instance.setVerboseLogging(y)}j(y){this.f&&this.b.fire({type:"trace",message:this.k(y)})}k(y,D){return D?`[File Watcher (node.js)] ${y} (path: ${D.request.path})`:`[File Watcher (node.js)] ${y}`}}e.NodeJSWatcher=A}),define(ve[205],be([1,0,62,204]),function(ie,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class k extends b.AbstractNonRecursiveWatcherClient{constructor(I,A,E){super(I,A,E),this.m()}l(){return new t.NodeJSWatcher}}e.NodeJSWatcherClient=k}),define(ve[206],be([1,0,13,41,98,62]),function(ie,e,b,t,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class I extends S.AbstractUniversalWatcherClient{constructor(E,y,D){super(E,y,D),this.m()}l(E){const y=E.add(new k.Client(b.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return E.add(y.onDidProcessExit(({code:D,signal:T})=>this.n(`terminated by itself with code ${D}, signal: ${T}`))),t.ProxyChannel.toService((0,t.getNextTickChannel)(y.getChannel("watcher")))}}e.UniversalWatcherClient=I}),define(ve[77],be([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class b{constructor(...k){this.a=new Map;for(const[S,I]of k)this.set(S,I)}set(k,S){const I=this.a.get(k);return this.a.set(k,S),I}has(k){return this.a.has(k)}get(k){return this.a.get(k)}}e.ServiceCollection=b}),define(ve[102],be([1,0,14,8,2,61,198,5,77,86]),function(ie,e,b,t,k,S,I,A,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const D=!1;class T extends Error{constructor(p){super("cyclic dependency between services"),this.message=p.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${p.toString()}`}}class C{constructor(p=new E.ServiceCollection,d=!1,v,c=D){this.f=p,this.g=d,this.h=v,this.i=c,this.o=new Set,this.f.set(A.IInstantiationService,this),this._globalGraph=c?v?._globalGraph??new I.Graph(h=>h):void 0}createChild(p){return new C(p,this.g,this,this.i)}invokeFunction(p,...d){const v=m.traceInvocation(this.i,p);let c=!1;try{return p({get:f=>{if(c)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const i=this.m(f,v);if(!i)throw new Error(`[invokeFunction] unknown service '${f}'`);return i}},...d)}finally{c=!0,v.stop()}}createInstance(p,...d){let v,c;return p instanceof S.SyncDescriptor?(v=m.traceCreation(this.i,p.ctor),c=this.j(p.ctor,p.staticArguments.concat(d),v)):(v=m.traceCreation(this.i,p),c=this.j(p,d,v)),v.stop(),c}j(p,d=[],v){const c=A._util.getServiceDependencies(p).sort((i,n)=>i.index-n.index),h=[];for(const i of c){const n=this.m(i.id,v);n||this.u(`[createInstance] ${p.name} depends on UNKNOWN service ${i.id}.`,!1),h.push(n)}const f=c.length>0?c[0].index:d.length;if(d.length!==f){console.trace(`[createInstance] First service dependency of ${p.name} at position ${f+1} conflicts with ${d.length} static arguments`);const i=f-d.length;i>0?d=d.concat(new Array(i)):d=d.slice(0,f)}return Reflect.construct(p,d.concat(h))}k(p,d){if(this.f.get(p)instanceof S.SyncDescriptor)this.f.set(p,d);else if(this.h)this.h.k(p,d);else throw new Error("illegalState - setting UNKNOWN service instance")}l(p){const d=this.f.get(p);return!d&&this.h?this.h.l(p):d}m(p,d){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(p));const v=this.l(p);return v instanceof S.SyncDescriptor?this.q(p,v,d.branch(p,!0)):(d.branch(p,!1),v)}q(p,d,v){if(this.o.has(p))throw new Error(`illegal state - RECURSIVELY instantiating service '${p}'`);this.o.add(p);try{return this.r(p,d,v)}finally{this.o.delete(p)}}r(p,d,v){const c=new I.Graph(i=>i.id.toString());let h=0;const f=[{id:p,desc:d,_trace:v}];for(;f.length;){const i=f.pop();if(c.lookupOrInsertNode(i),h++>1e3)throw new T(c);for(const n of A._util.getServiceDependencies(i.desc.ctor)){const r=this.l(n.id);if(r||this.u(`[createInstance] ${p} depends on ${n.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(n.id)),r instanceof S.SyncDescriptor){const o={id:n.id,desc:r,_trace:i._trace.branch(n.id,!0)};c.insertEdge(i,o),f.push(o)}}}for(;;){const i=c.roots();if(i.length===0){if(!c.isEmpty())throw new T(c);break}for(const{data:n}of i){if(this.l(n.id)instanceof S.SyncDescriptor){const o=this.s(n.id,n.desc.ctor,n.desc.staticArguments,n.desc.supportsDelayedInstantiation,n._trace);this.k(n.id,o)}c.removeNode(n)}}return this.l(p)}s(p,d,v=[],c,h){if(this.f.get(p)instanceof S.SyncDescriptor)return this.t(p,d,v,c,h);if(this.h)return this.h.s(p,d,v,c,h);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}t(p,d,v=[],c,h){if(c){const f=new C(void 0,this.g,this,this.i);f.c=String(p);const i=new Map,n=new b.IdleValue(()=>{const r=f.j(d,v,h);for(const[o,a]of i){const l=r[o];if(typeof l=="function")for(const s of a)l.apply(r,s)}return i.clear(),r});return new Proxy(Object.create(null),{get(r,o){if(!n.isInitialized&&typeof o=="string"&&(o.startsWith("onDid")||o.startsWith("onWill"))){let s=i.get(o);return s||(s=new y.LinkedList,i.set(o,s)),(P,F,K)=>{const ne=s.push([P,F,K]);return(0,k.toDisposable)(ne)}}if(o in r)return r[o];const a=n.value;let l=a[o];return typeof l!="function"||(l=l.bind(a),r[o]=l),l},set(r,o,a){return n.value[o]=a,!0},getPrototypeOf(r){return d.prototype}})}else return this.j(d,v,h)}u(p,d){if(d&&console.warn(p),this.g)throw new Error(p)}}e.InstantiationService=C;var w;(function(g){g[g.Creation=0]="Creation",g[g.Invocation=1]="Invocation",g[g.Branch=2]="Branch"})(w||(w={}));class m{static traceInvocation(p,d){return p?new m(1,d.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):m.c}static traceCreation(p,d){return p?new m(0,d.name):m.c}constructor(p,d){this.type=p,this.name=d,this.g=Date.now(),this.h=[]}branch(p,d){const v=new m(2,p.toString());return this.h.push([p,d,v]),v}stop(){const p=Date.now()-this.g;m.f+=p;let d=!1;function v(h,f){const i=[],n=new Array(h+1).join("	");for(const[r,o,a]of f.h)if(o&&a){d=!0,i.push(`${n}CREATES -> ${r}`);const l=v(h+1,a);l&&i.push(l)}else i.push(`${n}uses -> ${r}`);return i.join(`
`)}const c=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${p.toFixed(2)}ms (grand total ${m.f.toFixed(2)}ms)`];(p>2||d)&&m.all.add(c.join(`
`))}}e.Trace=m,m.all=new Set,m.c=new class extends m{constructor(){super(-1,null)}stop(){}branch(){return this}},m.f=0}),define(ve[207],be([1,0,5]),function(ie,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILabelService=void 0,e.ILabelService=(0,b.createDecorator)("labelService")});var Oe=this&&this.__param||function(ie,e){return function(b,t){e(b,t,ie)}};define(ve[78],be([1,0,19,2,3,176,31,5]),function(ie,e,b,t,k,S,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function E(D){return D.tags.find(T=>T.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=E,e.ILanguagePackService=(0,A.createDecorator)("languagePackService");let y=class extends t.Disposable{constructor(T){super(),this.c=T}async getAvailableLanguages(){const T=new b.CancellationTokenSource;setTimeout(()=>T.cancel(),1e3);let C;try{C=await this.c.query({text:'category:"language packs"',pageSize:20},T.token)}catch{return[]}const m=C.firstPage.filter(g=>g.properties.localizedLanguages?.length&&g.tags.some(p=>p.startsWith("lp-"))).map(g=>{const p=g.properties.localizedLanguages?.[0],d=E(g);return{...this.f(d,p,g),extensionId:g.identifier.id,galleryExtension:g}});return m.push({...this.f("en","English"),extensionId:"default"}),m}f(T,C,w){const m=C??T;let g;if(m!==T&&(g=`(${T})`),T.toLowerCase()===k.language.toLowerCase()&&(g??="",g+=(0,S.localize)(0,null)),w?.installCount){g??="";const p=w.installCount;let d;p>1e6?d=`${Math.floor(p/1e5)/10}M`:p>1e3?d=`${Math.floor(p/1e3)}K`:d=String(p),g+=` $(cloud-download) ${d}`}return{id:T,label:m,description:g}}};y=Le([Oe(0,I.IExtensionGalleryService)],y),e.LanguagePackBaseService=y}),define(ve[12],be([1,0,39,6,2,26,3,4,5]),function(ie,e,b,t,k,S,I,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,E.createDecorator)("logService"),e.ILoggerService=(0,E.createDecorator)("loggerService");function y(){return new Date().toISOString()}var D;(function(l){l[l.Off=0]="Off",l[l.Trace=1]="Trace",l[l.Debug=2]="Debug",l[l.Info=3]="Info",l[l.Warning=4]="Warning",l[l.Error=5]="Error"})(D=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=D.Info;function T(l,s,u){switch(s){case D.Trace:l.trace(u);break;case D.Debug:l.debug(u);break;case D.Info:l.info(u);break;case D.Warning:l.warn(u);break;case D.Error:l.error(u);break;case D.Off:break;default:throw new Error(`Invalid log level ${s}`)}}e.log=T;function C(l){let s="";for(let u=0;u<l.length;u++){let P=l[u];if(typeof P=="object")try{P=JSON.stringify(P)}catch{}s+=(u>0?" ":"")+P}return s}e.format=C;class w extends k.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new t.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(s){this.b!==s&&(this.b=s,this.c.fire(this.b))}getLevel(){return this.b}f(s){return this.b!==D.Off&&this.b<=s}}e.AbstractLogger=w;class m extends w{constructor(s){super(),this.h=s}f(s){return this.h||super.f(s)}trace(s,...u){this.f(D.Trace)&&this.g(D.Trace,C([s,...u]))}debug(s,...u){this.f(D.Debug)&&this.g(D.Debug,C([s,...u]))}info(s,...u){this.f(D.Info)&&this.g(D.Info,C([s,...u]))}warn(s,...u){this.f(D.Warning)&&this.g(D.Warning,C([s,...u]))}error(s,...u){if(this.f(D.Error))if(s instanceof Error){const P=Array.prototype.slice.call(arguments);P[0]=s.stack,this.g(D.Error,C(P))}else this.g(D.Error,C([s,...u]))}flush(){}}e.AbstractMessageLogger=m;class g extends w{constructor(s=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(s),this.g=!I.isWindows}trace(s,...u){this.f(D.Trace)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,s,...u):console.log(`[main ${y()}]`,s,...u))}debug(s,...u){this.f(D.Debug)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,s,...u):console.log(`[main ${y()}]`,s,...u))}info(s,...u){this.f(D.Info)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,s,...u):console.log(`[main ${y()}]`,s,...u))}warn(s,...u){this.f(D.Warning)&&(this.g?console.warn(`\x1B[93m[main ${y()}]\x1B[0m`,s,...u):console.warn(`[main ${y()}]`,s,...u))}error(s,...u){this.f(D.Error)&&(this.g?console.error(`\x1B[91m[main ${y()}]\x1B[0m`,s,...u):console.error(`[main ${y()}]`,s,...u))}dispose(){}flush(){}}e.ConsoleMainLogger=g;class p extends w{constructor(s=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(s)}trace(s,...u){this.f(D.Trace)&&console.log("%cTRACE","color: #888",s,...u)}debug(s,...u){this.f(D.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",s,...u)}info(s,...u){this.f(D.Info)&&console.log("%c INFO","color: #33f",s,...u)}warn(s,...u){this.f(D.Warning)&&console.log("%c WARN","color: #993",s,...u)}error(s,...u){this.f(D.Error)&&console.log("%c  ERR","color: #f33",s,...u)}dispose(){}flush(){}}e.ConsoleLogger=p;class d extends w{constructor(s,u=e.DEFAULT_LOG_LEVEL){super(),this.g=s,this.setLevel(u)}trace(s,...u){this.f(D.Trace)&&this.g.log(D.Trace,[this.h(s),...u])}debug(s,...u){this.f(D.Debug)&&this.g.log(D.Debug,[this.h(s),...u])}info(s,...u){this.f(D.Info)&&this.g.log(D.Info,[this.h(s),...u])}warn(s,...u){this.f(D.Warning)&&this.g.log(D.Warning,[this.h(s),...u])}error(s,...u){this.f(D.Error)&&this.g.log(D.Error,[this.h(s),...u])}h(s){return typeof s=="string"?s:(0,b.toErrorMessage)(s,this.f(D.Trace))}dispose(){}flush(){}}e.AdapterLogger=d;class v extends w{constructor(s){super(),this.g=s,s.length&&this.setLevel(s[0].getLevel())}setLevel(s){for(const u of this.g)u.setLevel(s);super.setLevel(s)}trace(s,...u){for(const P of this.g)P.trace(s,...u)}debug(s,...u){for(const P of this.g)P.debug(s,...u)}info(s,...u){for(const P of this.g)P.info(s,...u)}warn(s,...u){for(const P of this.g)P.warn(s,...u)}error(s,...u){for(const P of this.g)P.error(s,...u)}flush(){for(const s of this.g)s.flush()}dispose(){for(const s of this.g)s.dispose()}}e.MultiplexLogService=v;class c extends k.Disposable{constructor(s){super(),this.b=s,this.B(s)}get onDidChangeLogLevel(){return this.b.onDidChangeLogLevel}setLevel(s){this.b.setLevel(s)}getLevel(){return this.b.getLevel()}trace(s,...u){this.b.trace(s,...u)}debug(s,...u){this.b.debug(s,...u)}info(s,...u){this.b.info(s,...u)}warn(s,...u){this.b.warn(s,...u)}error(s,...u){this.b.error(s,...u)}flush(){this.b.flush()}}e.LogService=c;class h extends k.Disposable{constructor(s,u){super(),this.c=s,this.b=new S.ResourceMap,this.B(u(P=>this.setLevel(P)))}getLoggers(){return[...this.b.values()].map(({logger:s})=>s)}getLogger(s){return this.b.get(s)?.logger}createLogger(s,u,P){let F=this.b.get(s)?.logger;return F||(P=u?.always?D.Trace:P,F=this.f(s,P??this.c,u),this.b.set(s,{logger:F,logLevel:P})),F}setLevel(s,u){const P=A.URI.isUri(s)?s:void 0,F=P?u:s;if(P){const K=this.b.get(P);K&&K.logLevel!==F&&(K.logLevel=F,K.logger.setLevel(F))}else this.c=F,this.b.forEach(({logLevel:K,logger:ne})=>{K===void 0&&ne.setLevel(this.c)})}getLogLevel(s){return this.b.get(s)?.logLevel}dispose(){this.b.forEach(({logger:s})=>s.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=h;class f{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(s){}getLevel(){return D.Info}trace(s,...u){}debug(s,...u){}info(s,...u){}warn(s,...u){}error(s,...u){}critical(s,...u){}dispose(){}flush(){}}e.NullLogger=f;class i extends f{}e.NullLogService=i;class n extends h{constructor(){super(D.Info,t.Event.None)}f(s,u,P){return new f}}e.NullLoggerService=n;function r(l){if(l.verbose)return D.Trace;if(typeof l.logLevel=="string"){const s=a(l.logLevel.toLowerCase());if(s!==void 0)return s}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=r;function o(l){switch(l){case D.Trace:return"trace";case D.Debug:return"debug";case D.Info:return"info";case D.Warning:return"warn";case D.Error:return"error";case D.Off:return"off"}}e.LogLevelToString=o;function a(l){switch(l){case"trace":return D.Trace;case"debug":return D.Debug;case"info":return D.Info;case"warn":return D.Warning;case"error":return D.Error;case"critical":return D.Error;case"off":return D.Off}}e.parseLogLevel=a}),define(ve[208],be([1,0,74,6,2,12,3,14]),function(ie,e,b,t,k,S,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let E=class Ht extends k.Disposable{constructor(D){super(),this.g=D,this.c=this.B(new t.Emitter),this.onDidChangePassword=this.c.event}async getPassword(D,T){this.g.trace("Getting password from keytar:",D,T);let C;try{C=await this.h()}catch{return null}const w=await(0,A.retry)(()=>C.getPassword(D,T),50,3);if(!w)return this.g.trace("Did not get a password from keytar for account:",T),w;let m,g;try{const p=JSON.parse(w);m=p.content,g=p.hasNextChunk}catch{}if(!m||!g)return this.g.trace("Got password from keytar for account:",T),w;try{let p=1;for(;g;){const d=await(0,A.retry)(()=>C.getPassword(D,`${T}-${p}`),50,3),v=JSON.parse(d);m+=v.content,g=v.hasNextChunk,p++}return this.g.trace(`Got ${p}-chunked password from keytar for account:`,T),m}catch(p){return this.g.error(p),w}}async setPassword(D,T,C){this.g.trace("Setting password using keytar:",D,T);let w;try{w=await this.h()}catch(m){throw this.i?.(m),m}if(I.isWindows&&C.length>Ht.a){let m=0,g=0,p=!0;for(;p;){const d=C.substring(m,m+Ht.b);m+=Ht.b,p=C.length-m>0;const v={content:d,hasNextChunk:p};await(0,A.retry)(()=>w.setPassword(D,g?`${T}-${g}`:T,JSON.stringify(v)),50,3),g++}this.g.trace(`Got${g?` ${g}-chunked`:""} password from keytar for account:`,T)}else await(0,A.retry)(()=>w.setPassword(D,T,C),50,3),this.g.trace("Got password from keytar for account:",T);this.c.fire({service:D,account:T})}async deletePassword(D,T){this.g.trace("Deleting password using keytar:",D,T);let C;try{C=await this.h()}catch(d){throw this.i?.(d),d}const w=await C.getPassword(D,T);if(!w)return this.g.trace("Did not get a password to delete from keytar for account:",T),!1;let m,g;try{const d=JSON.parse(w);m=d.content,g=d.hasNextChunk}catch{}let p=0;if(m&&g)try{for(p++;g;){const d=`${T}-${p}`,v=await C.getPassword(D,d);await C.deletePassword(D,d),g=JSON.parse(v).hasNextChunk,p++}}catch(d){this.g.error(d)}return await C.deletePassword(D,T)?(this.c.fire({service:D,account:T}),this.g.trace(`Deleted${p?` ${p}-chunked`:""} password from keytar for account:`,T),!0):(this.g.trace(`Keytar failed to delete${p?` ${p}-chunked`:""} password for account:`,T),!1)}async findPassword(D){let T;try{T=await this.h()}catch{return null}return await T.findPassword(D)}async findCredentials(D){let T;try{T=await this.h()}catch{return[]}return await T.findCredentials(D)}clear(){return this.f instanceof b.InMemoryCredentialsProvider?this.f.clear():Promise.resolve()}};E.a=2500,E.b=E.a-100,E=Le([Oe(0,S.ILogService)],E),e.BaseCredentialsMainService=E}),define(ve[209],be([1,0,12]),function(ie,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;let t=class{constructor(S,I){this.a=S,this.b=I}c(){return new Promise((S,I)=>ie(["vscode-encrypt"],S,I))}async encrypt(S){let I;try{I=await this.c()}catch{return S}try{return I.encrypt(this.a,S)}catch(A){return this.b.error(A),S}}async decrypt(S){let I;try{I=await this.c()}catch{return S}try{return I.decrypt(this.a,S)}catch(A){return this.b.error(A),S}}};t=Le([Oe(1,b.ILogService)],t),e.EncryptionMainService=t}),define(ve[210],be([1,0,18,14,8,6,2,7,62,12]),function(ie,e,b,t,k,S,I,A,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class D extends I.Disposable{constructor(C,w){super(),this.a=C,this.b=w,this.c=this.B(new S.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new S.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new t.ThrottledDelayer(0)),this.s=[],this.t=this.B(new t.ThrottledDelayer(0))}watch(C,w){return w.recursive||this.b?.watcher?.forceUniversal?this.l(C,w):this.u(C,w)}l(C,w){const m={path:this.C(C),excludes:w.excludes,includes:w.includes,recursive:w.recursive},g=(0,b.insert)(this.j,m);return this.m(),(0,I.toDisposable)(()=>{g(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(C=>(0,k.onUnexpectedError)(C))}n(){this.h||(this.h=this.B(this.p(w=>this.c.fire((0,E.toFileChanges)(w)),w=>this.z(w),this.a.getLevel()===y.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===y.LogLevel.Trace)})));const C=this.b?.watcher?.recursive?.usePolling;if(C===!0)for(const w of this.j)(0,E.isRecursiveWatchRequest)(w)&&(w.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(C))for(const w of this.j)(0,E.isRecursiveWatchRequest)(w)&&C.includes(w.path)&&(w.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(C,w){const m={path:this.C(C),excludes:w.excludes,includes:w.includes,recursive:!1},g=(0,b.insert)(this.s,m);return this.v(),(0,I.toDisposable)(()=>{g(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(C=>(0,k.onUnexpectedError)(C))}w(){return this.r||(this.r=this.B(this.y(C=>this.c.fire((0,E.toFileChanges)(C)),C=>this.z(C),this.a.getLevel()===y.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===y.LogLevel.Trace)}))),this.r.watch(this.s)}z(C){C.type==="error"&&this.g.fire(C.message),this.a[C.type](C.message)}C(C){return(0,A.normalize)(C.fsPath)}}e.AbstractDiskFileSystemProvider=D}),define(ve[103],be([1,0,18,14,16,19,6,91,55,2,58,13,45,20,44,172,17,101,12]),function(ie,e,b,t,k,S,I,A,E,y,D,T,C,w,m,g,p,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let c=class extends y.Disposable{constructor(f){super(),this.b=f,this.a=256*1024,this.c=this.B(new I.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new I.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new I.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new I.Emitter),this.onDidRunOperation=this.m.event,this.Q=this.B(new I.Emitter),this.onDidFilesChange=this.Q.event,this.R=this.B(new I.Emitter),this.onDidWatchError=this.R.event,this.S=new Map,this.W=this.B(new t.ResourceQueue)}registerProvider(f,i){if(this.h.has(f))throw new Error(`A filesystem provider for the scheme '${f}' is already registered.`);(0,C.mark)(`code/registerFilesystem/${f}`);const n=new y.DisposableStore;return this.h.set(f,i),this.c.fire({added:!0,scheme:f,provider:i}),n.add(i.onDidChangeFile(r=>this.Q.fire(new p.FileChangesEvent(r,!this.N(i))))),typeof i.onDidWatchError=="function"&&n.add(i.onDidWatchError(r=>this.R.fire(new Error(r)))),n.add(i.onDidChangeCapabilities(()=>this.g.fire({provider:i,scheme:f}))),(0,y.toDisposable)(()=>{this.c.fire({added:!1,scheme:f,provider:i}),this.h.delete(f),(0,y.dispose)(n)})}getProvider(f){return this.h.get(f)}async activateProvider(f){const i=[];this.f.fire({scheme:f,join(n){i.push(n)}}),!this.h.has(f)&&await t.Promises.settled(i)}async canHandleResource(f){return await this.activateProvider(f.scheme),this.hasProvider(f)}hasProvider(f){return this.h.has(f.scheme)}hasCapability(f,i){const n=this.h.get(f.scheme);return!!(n&&n.capabilities&i)}listCapabilities(){return E.Iterable.map(this.h,([f,i])=>({scheme:f,capabilities:i.capabilities}))}async j(f){if(!(0,w.isAbsolutePath)(f))throw new p.FileOperationError((0,g.localize)(0,null,this.mb(f)),8);await this.activateProvider(f.scheme);const i=this.h.get(f.scheme);if(!i){const n=new Error;throw n.name="ENOPRO",n.message=(0,g.localize)(1,null,f.toString()),n}return i}async k(f){const i=await this.j(f);if((0,p.hasOpenReadWriteCloseCapability)(i)||(0,p.hasReadWriteCapability)(i)||(0,p.hasFileReadStreamCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${f.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(f){const i=await this.j(f);if((0,p.hasOpenReadWriteCloseCapability)(i)||(0,p.hasReadWriteCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${f.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(f,i){try{return await this.n(f,i)}catch(n){throw(0,p.toFileSystemProviderErrorCode)(n)===p.FileSystemProviderErrorCode.FileNotFound?new p.FileOperationError((0,g.localize)(2,null,this.mb(f)),1):(0,p.ensureFileSystemProviderError)(n)}}async n(f,i){const n=await this.j(f),r=this.N(n),o=i?.resolveTo,a=i?.resolveSingleChildDescendants,l=i?.resolveMetadata,s=await n.stat(f);let u;return this.p(n,f,s,void 0,!!l,(P,F)=>(u||(u=D.TernarySearchTree.forUris(()=>!r),u.set(f,!0),o&&u.fill(!0,o)),u.get(P.resource)||u.findSuperstr(P.resource.with({query:null,fragment:null}))?!0:P.isDirectory&&a?F===1:!1))}async p(f,i,n,r,o,a){const{providerExtUri:l}=this.M(f),s={resource:i,name:l.basename(i),isFile:(n.type&p.FileType.File)!==0,isDirectory:(n.type&p.FileType.Directory)!==0,isSymbolicLink:(n.type&p.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:Boolean((n.permissions??0)&p.FilePermission.Readonly)||Boolean(f.capabilities&2048),etag:(0,p.etag)({mtime:n.mtime,size:n.size}),children:void 0};if(s.isDirectory&&a(s,r)){try{const u=await f.readdir(i),P=await t.Promises.settled(u.map(async([F,K])=>{try{const ne=l.joinPath(i,F),ue=o?await f.stat(ne):{type:K};return await this.p(f,ne,ue,u.length,o,a)}catch(ne){return this.b.trace(ne),null}}));s.children=(0,b.coalesce)(P)}catch(u){this.b.trace(u),s.children=[]}return s}return s}async resolveAll(f){return t.Promises.settled(f.map(async i=>{try{return{stat:await this.n(i.resource,i.options),success:!0}}catch(n){return this.b.trace(n),{stat:void 0,success:!1}}}))}async stat(f){const i=await this.j(f),n=await i.stat(f);return this.p(i,f,n,void 0,!0,()=>!1)}async exists(f){const i=await this.j(f);try{return!!await i.stat(f)}catch{return!1}}async canCreateFile(f,i){try{await this.r(f,i)}catch(n){return n}return!0}async r(f,i){if(!i?.overwrite&&await this.exists(f))throw new p.FileOperationError((0,g.localize)(3,null,this.mb(f)),3,i)}async createFile(f,i=k.VSBuffer.fromString(""),n){await this.r(f,n);const r=await this.writeFile(f,i);return this.m.fire(new p.FileOperationEvent(f,0,r)),r}async writeFile(f,i,n){const r=this.kb(await this.l(f),f),{providerExtUri:o}=this.M(r);try{await this.s(r,f,n)||await this.O(r,o.dirname(f));let l;if((0,p.hasReadWriteCapability)(r)&&!(i instanceof k.VSBuffer))if((0,m.isReadableStream)(i)){const s=await(0,m.peekStream)(i,3);s.ended?l=k.VSBuffer.concat(s.buffer):l=s}else l=(0,m.peekReadable)(i,s=>k.VSBuffer.concat(s),3);else l=i;!(0,p.hasOpenReadWriteCloseCapability)(r)||(0,p.hasReadWriteCapability)(r)&&l instanceof k.VSBuffer?await this.bb(r,f,n,l):await this.X(r,f,n,l instanceof k.VSBuffer?(0,k.bufferToReadable)(l):l),this.m.fire(new p.FileOperationEvent(f,4))}catch(a){throw new p.FileOperationError((0,g.localize)(4,null,this.mb(f),(0,p.ensureFileSystemProviderError)(a).toString()),(0,p.toFileOperationResult)(a),n)}return this.resolve(f,{resolveMetadata:!0})}async s(f,i,n){if(!!n?.unlock&&!(f.capabilities&8192))throw new Error((0,g.localize)(5,null,this.mb(i)));let o;try{o=await f.stat(i)}catch{return}if((o.type&p.FileType.Directory)!==0)throw new p.FileOperationError((0,g.localize)(6,null,this.mb(i)),0,n);if(this.lb(i,o),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==p.ETAG_DISABLED&&typeof o.mtime=="number"&&typeof o.size=="number"&&n.mtime<o.mtime&&n.etag!==(0,p.etag)({mtime:n.mtime,size:o.size}))throw new p.FileOperationError((0,g.localize)(7,null),3,n);return o}async readFile(f,i,n){const r=await this.k(f);return i?.atomic?this.t(r,f,i,n):this.u(r,f,i,n)}async t(f,i,n,r){return new Promise((o,a)=>{this.W.queueFor(i,this.M(f).providerExtUri).queue(async()=>{try{const l=await this.u(f,i,n,r);o(l)}catch(l){a(l)}})})}async u(f,i,n,r){const o=await this.v(f,i,{...n,preferUnbuffered:!0},r);return{...o,value:await(0,k.streamToBuffer)(o.value)}}async readFileStream(f,i,n){const r=await this.k(f);return this.v(r,f,i,n)}async v(f,i,n,r){const o=new S.CancellationTokenSource(r),a=this.D(i,n).then(s=>s,s=>{throw o.cancel(),s});let l;try{return typeof n?.etag=="string"&&n.etag!==p.ETAG_DISABLED&&await a,n?.atomic&&(0,p.hasFileAtomicReadCapability)(f)||!((0,p.hasOpenReadWriteCloseCapability)(f)||(0,p.hasFileReadStreamCapability)(f))||(0,p.hasReadWriteCapability)(f)&&n?.preferUnbuffered?l=this.C(f,i,n):(0,p.hasFileReadStreamCapability)(f)?l=this.w(f,i,o.token,n):l=this.z(f,i,o.token,n),{...await a,value:l}}catch(s){l&&await(0,m.consumeStream)(l);const u=(0,g.localize)(8,null,this.mb(i),(0,p.ensureFileSystemProviderError)(s).toString());throw s instanceof p.NotModifiedSinceFileOperationError?new p.NotModifiedSinceFileOperationError(u,s.stat,n):new p.FileOperationError(u,(0,p.toFileOperationResult)(s),n)}}w(f,i,n,r=Object.create(null)){const o=f.readFileStream(i,r,n);return(0,m.transform)(o,{data:a=>a instanceof k.VSBuffer?a:k.VSBuffer.wrap(a),error:a=>new p.FileOperationError((0,g.localize)(9,null,this.mb(i),(0,p.ensureFileSystemProviderError)(a).toString()),(0,p.toFileOperationResult)(a),r)},a=>k.VSBuffer.concat(a))}z(f,i,n,r=Object.create(null)){const o=(0,k.newWriteableBufferStream)();return(0,d.readFileIntoStream)(f,i,o,a=>a,{...r,bufferSize:this.a,errorTransformer:a=>new p.FileOperationError((0,g.localize)(10,null,this.mb(i),(0,p.ensureFileSystemProviderError)(a).toString()),(0,p.toFileOperationResult)(a),r)},n),o}C(f,i,n){const r=(0,m.newWriteableStream)(o=>k.VSBuffer.concat(o));return(async()=>{try{let o;n?.atomic&&(0,p.hasFileAtomicReadCapability)(f)?o=await f.readFile(i,{atomic:!0}):o=await f.readFile(i),typeof n?.position=="number"&&(o=o.slice(n.position)),typeof n?.length=="number"&&(o=o.slice(0,n.length)),this.F(i,o.byteLength,n),r.end(k.VSBuffer.wrap(o))}catch(o){r.error(o),r.end()}})(),r}async D(f,i){const n=await this.resolve(f,{resolveMetadata:!0});if(n.isDirectory)throw new p.FileOperationError((0,g.localize)(11,null,this.mb(f)),0,i);if(typeof i?.etag=="string"&&i.etag!==p.ETAG_DISABLED&&i.etag===n.etag)throw new p.NotModifiedSinceFileOperationError((0,g.localize)(12,null),n,i);return this.F(f,n.size,i),n}F(f,i,n){if(n?.limits){let r;if(typeof n.limits.memory=="number"&&i>n.limits.memory&&(r=9),typeof n.limits.size=="number"&&i>n.limits.size&&(r=7),typeof r=="number")throw new p.FileOperationError((0,g.localize)(13,null,this.mb(f)),r)}}async canMove(f,i,n){return this.G(f,i,"move",n)}async canCopy(f,i,n){return this.G(f,i,"copy",n)}async G(f,i,n,r){if(f.toString()!==i.toString())try{const o=n==="move"?this.kb(await this.l(f),f):await this.k(f),a=this.kb(await this.l(i),i);await this.L(o,f,a,i,n,r)}catch(o){return o}return!0}async move(f,i,n){const r=this.kb(await this.l(f),f),o=this.kb(await this.l(i),i),a=await this.H(r,f,o,i,"move",!!n),l=await this.resolve(i,{resolveMetadata:!0});return this.m.fire(new p.FileOperationEvent(f,a==="move"?2:3,l)),l}async copy(f,i,n){const r=await this.k(f),o=this.kb(await this.l(i),i),a=await this.H(r,f,o,i,"copy",!!n),l=await this.resolve(i,{resolveMetadata:!0});return this.m.fire(new p.FileOperationEvent(f,a==="copy"?3:2,l)),l}async H(f,i,n,r,o,a){if(i.toString()===r.toString())return o;const{exists:l,isSameResourceWithDifferentPathCase:s}=await this.L(f,i,n,r,o,a);if(l&&!s&&a&&await this.del(r,{recursive:!0}),await this.O(n,this.M(n).providerExtUri.dirname(r)),o==="copy"){if(f===n&&(0,p.hasFileFolderCopyCapability)(f))await f.copy(i,r,{overwrite:a});else{const u=await this.resolve(i);u.isDirectory?await this.J(f,u,n,r):await this.I(f,i,n,r)}return o}else return f===n?(await f.rename(i,r,{overwrite:a}),o):(await this.H(f,i,n,r,"copy",a),await this.del(i,{recursive:!0}),"copy")}async I(f,i,n,r){if((0,p.hasOpenReadWriteCloseCapability)(f)&&(0,p.hasOpenReadWriteCloseCapability)(n))return this.db(f,i,n,r);if((0,p.hasOpenReadWriteCloseCapability)(f)&&(0,p.hasReadWriteCapability)(n))return this.jb(f,i,n,r);if((0,p.hasReadWriteCapability)(f)&&(0,p.hasOpenReadWriteCloseCapability)(n))return this.hb(f,i,n,r);if((0,p.hasReadWriteCapability)(f)&&(0,p.hasReadWriteCapability)(n))return this.fb(f,i,n,r)}async J(f,i,n,r){await n.mkdir(r),Array.isArray(i.children)&&await t.Promises.settled(i.children.map(async o=>{const a=this.M(n).providerExtUri.joinPath(r,o.name);return o.isDirectory?this.J(f,await this.resolve(o.resource),n,a):this.I(f,o.resource,n,a)}))}async L(f,i,n,r,o,a){let l=!1;if(f===n){const{providerExtUri:u,isPathCaseSensitive:P}=this.M(f);if(P||(l=u.isEqual(i,r)),l&&o==="copy")throw new Error((0,g.localize)(14,null,this.mb(i),this.mb(r)));if(!l&&u.isEqualOrParent(r,i))throw new Error((0,g.localize)(15,null,this.mb(i),this.mb(r)))}const s=await this.exists(r);if(s&&!l){if(!a)throw new p.FileOperationError((0,g.localize)(16,null,this.mb(i),this.mb(r)),4);if(f===n){const{providerExtUri:u}=this.M(f);if(u.isEqualOrParent(i,r))throw new Error((0,g.localize)(17,null,this.mb(i),this.mb(r)))}}return{exists:s,isSameResourceWithDifferentPathCase:l}}M(f){const i=this.N(f);return{providerExtUri:i?w.extUri:w.extUriIgnorePathCase,isPathCaseSensitive:i}}N(f){return!!(f.capabilities&1024)}async createFolder(f){const i=this.kb(await this.j(f),f);await this.O(i,f);const n=await this.resolve(f,{resolveMetadata:!0});return this.m.fire(new p.FileOperationEvent(f,0,n)),n}async O(f,i){const n=[],{providerExtUri:r}=this.M(f);for(;!r.isEqual(i,r.dirname(i));)try{if(((await f.stat(i)).type&p.FileType.Directory)===0)throw new Error((0,g.localize)(18,null,this.mb(i)));break}catch(o){if((0,p.toFileSystemProviderErrorCode)(o)!==p.FileSystemProviderErrorCode.FileNotFound)throw o;n.push(r.basename(i)),i=r.dirname(i)}for(let o=n.length-1;o>=0;o--){i=r.joinPath(i,n[o]);try{await f.mkdir(i)}catch(a){if((0,p.toFileSystemProviderErrorCode)(a)!==p.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(f,i){try{await this.P(f,i)}catch(n){return n}return!0}async P(f,i){const n=this.kb(await this.j(f),f);if(!!i?.useTrash&&!(n.capabilities&4096))throw new Error((0,g.localize)(19,null,this.mb(f)));let o;try{o=await n.stat(f)}catch{}if(o)this.lb(f,o);else throw new p.FileOperationError((0,g.localize)(20,null,this.mb(f)),1);if(!!!i?.recursive){const l=await this.resolve(f);if(l.isDirectory&&Array.isArray(l.children)&&l.children.length>0)throw new Error((0,g.localize)(21,null,this.mb(f)))}return n}async del(f,i){const n=await this.P(f,i),r=!!i?.useTrash,o=!!i?.recursive;await n.delete(f,{recursive:o,useTrash:r}),this.m.fire(new p.FileOperationEvent(f,1))}async cloneFile(f,i){const n=await this.j(f),r=this.kb(await this.l(i),i);if(n===r&&this.M(n).providerExtUri.isEqual(f,i))return;if(n===r&&(0,p.hasFileCloneCapability)(n))return n.cloneFile(f,i);await this.O(r,this.M(r).providerExtUri.dirname(i));const o=this.W.queueFor(f,this.M(n).providerExtUri);return n===r&&(0,p.hasFileFolderCopyCapability)(n)?o.queue(()=>n.copy(f,i,{overwrite:!0})):o.queue(()=>this.I(n,f,r,i))}watch(f,i={recursive:!1,excludes:[]}){const n=new y.DisposableStore;let r=!1,o=()=>{r=!0};return n.add((0,y.toDisposable)(()=>o())),(async()=>{try{const a=await this.U(f,i);r?(0,y.dispose)(a):o=()=>(0,y.dispose)(a)}catch(a){this.b.error(a)}})(),n}async U(f,i){const n=await this.j(f),r=(0,A.hash)([this.M(n).providerExtUri.getComparisonKey(f),i]);let o=this.S.get(r);return o||(o={count:0,disposable:n.watch(f,i)},this.S.set(r,o)),o.count+=1,(0,y.toDisposable)(()=>{o&&(o.count--,o.count===0&&((0,y.dispose)(o.disposable),this.S.delete(r)))})}dispose(){super.dispose();for(const[,f]of this.S)(0,y.dispose)(f.disposable);this.S.clear()}async X(f,i,n,r){return this.W.queueFor(i,this.M(f).providerExtUri).queue(async()=>{const o=await f.open(i,{create:!0,unlock:n?.unlock??!1});try{(0,m.isReadableStream)(r)||(0,m.isReadableBufferedStream)(r)?await this.Y(f,o,r):await this.Z(f,o,r)}catch(a){throw(0,p.ensureFileSystemProviderError)(a)}finally{await f.close(o)}})}async Y(f,i,n){let r=0,o;if((0,m.isReadableBufferedStream)(n)){if(n.buffer.length>0){const a=k.VSBuffer.concat(n.buffer);await this.ab(f,i,a,a.byteLength,r,0),r+=a.byteLength}if(n.ended)return;o=n.stream}else o=n;return new Promise((a,l)=>{(0,m.listenStream)(o,{onData:async s=>{o.pause();try{await this.ab(f,i,s,s.byteLength,r,0)}catch(u){return l(u)}r+=s.byteLength,setTimeout(()=>o.resume())},onError:s=>l(s),onEnd:()=>a()})})}async Z(f,i,n){let r=0,o;for(;(o=n.read())!==null;)await this.ab(f,i,o,o.byteLength,r,0),r+=o.byteLength}async ab(f,i,n,r,o,a){let l=0;for(;l<r;)l+=await f.write(i,o+l,n.buffer,a+l,r-l)}async bb(f,i,n,r){return this.W.queueFor(i,this.M(f).providerExtUri).queue(()=>this.cb(f,i,n,r))}async cb(f,i,n,r){let o;r instanceof k.VSBuffer?o=r:(0,m.isReadableStream)(r)?o=await(0,k.streamToBuffer)(r):(0,m.isReadableBufferedStream)(r)?o=await(0,k.bufferedStreamToBuffer)(r):o=(0,k.readableToBuffer)(r),await f.writeFile(i,o.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1})}async db(f,i,n,r){return this.W.queueFor(r,this.M(n).providerExtUri).queue(()=>this.eb(f,i,n,r))}async eb(f,i,n,r){let o,a;try{o=await f.open(i,{create:!1}),a=await n.open(r,{create:!0,unlock:!1});const l=k.VSBuffer.alloc(this.a);let s=0,u=0,P=0;do P=await f.read(o,s,l.buffer,u,l.byteLength-u),await this.ab(n,a,l,P,s,u),s+=P,u+=P,u===l.byteLength&&(u=0);while(P>0)}catch(l){throw(0,p.ensureFileSystemProviderError)(l)}finally{await t.Promises.settled([typeof o=="number"?f.close(o):Promise.resolve(),typeof a=="number"?n.close(a):Promise.resolve()])}}async fb(f,i,n,r){return this.W.queueFor(r,this.M(n).providerExtUri).queue(()=>this.gb(f,i,n,r))}async gb(f,i,n,r){return n.writeFile(r,await f.readFile(i),{create:!0,overwrite:!0,unlock:!1})}async hb(f,i,n,r){return this.W.queueFor(r,this.M(n).providerExtUri).queue(()=>this.ib(f,i,n,r))}async ib(f,i,n,r){const o=await n.open(r,{create:!0,unlock:!1});try{const a=await f.readFile(i);await this.ab(n,o,k.VSBuffer.wrap(a),a.byteLength,0,0)}catch(a){throw(0,p.ensureFileSystemProviderError)(a)}finally{await n.close(o)}}async jb(f,i,n,r){const o=await(0,k.streamToBuffer)(this.z(f,i,S.CancellationToken.None));await this.bb(n,r,void 0,o)}kb(f,i){if(f.capabilities&2048)throw new p.FileOperationError((0,g.localize)(22,null,this.mb(i)),6);return f}lb(f,i){if((i.permissions??0)&p.FilePermission.Readonly)throw new p.FileOperationError((0,g.localize)(23,null,this.mb(f)),6)}mb(f){return f.scheme===T.Schemas.file?f.fsPath:f.toString(!0)}};c=Le([Oe(0,v.ILogService)],c),e.FileService=c}),define(ve[63],be([1,0,29,274,14,26,16,6,37,2,7,3,20,44,21,175,17,101,210,39,206,205]),function(ie,e,b,t,k,S,I,A,E,y,D,T,C,w,m,g,p,d,v,c,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,t.gracefulify)(b)}catch(n){console.error(`Error enabling graceful-fs: ${(0,c.toErrorMessage)(n)}`)}})();class i extends v.AbstractDiskFileSystemProvider{constructor(r,o){super(r,o),this.onDidChangeCapabilities=A.Event.None,this.H=new S.ResourceMap(a=>C.extUriBiasedIgnorePathCase.getComparisonKey(a)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,T.isLinux&&(this.F|=1024)),this.F}async stat(r){try{const{stat:o,symbolicLink:a}=await m.SymlinkSupport.stat(this.C(r));return{type:this.G(o,a),ctime:o.birthtime.getTime(),mtime:o.mtime.getTime(),size:o.size}}catch(o){throw this.Y(o)}}async readdir(r){try{const o=await m.Promises.readdir(this.C(r),{withFileTypes:!0}),a=[];return await Promise.all(o.map(async l=>{try{let s;l.isSymbolicLink()?s=(await this.stat((0,C.joinPath)(r,l.name))).type:s=this.G(l),a.push([l.name,s])}catch(s){this.a.trace(s)}})),a}catch(o){throw this.Y(o)}}G(r,o){let a;return o?.dangling?a=p.FileType.Unknown:r.isFile()?a=p.FileType.File:r.isDirectory()?a=p.FileType.Directory:a=p.FileType.Unknown,o&&(a|=p.FileType.SymbolicLink),a}async I(r){const o=this.C(r);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${o})`);let a;for(;a=this.H.get(r);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${o})`),await a.wait();const l=new k.Barrier;return this.H.set(r,l),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${o})`),(0,y.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${o})`),this.H.get(r)===l&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${o})`),this.H.delete(r)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${o})`),l.open()})}async readFile(r,o){let a;try{o?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(r)})`),a=await this.I(r));const l=this.C(r);return await m.Promises.readFile(l)}catch(l){throw this.Y(l)}finally{a?.dispose()}}J(r){i.D&&this.a.trace(r)}readFileStream(r,o,a){const l=(0,w.newWriteableStream)(s=>I.VSBuffer.concat(s.map(u=>I.VSBuffer.wrap(u))).buffer);return(0,d.readFileIntoStream)(this,r,l,s=>s.buffer,{...o,bufferSize:256*1024},a),l}async writeFile(r,o,a){let l;try{const s=this.C(r);if(!a.create||!a.overwrite){if(await m.Promises.exists(s)){if(!a.overwrite)throw(0,p.createFileSystemProviderError)((0,g.localize)(0,null),p.FileSystemProviderErrorCode.FileExists)}else if(!a.create)throw(0,p.createFileSystemProviderError)((0,g.localize)(1,null),p.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(r,{create:!0,unlock:a.unlock}),await this.write(l,0,o,0,o.byteLength)}catch(s){throw await this.Z(r,s)}finally{typeof l=="number"&&await this.close(l)}}static configureFlushOnWrite(r){i.O=r}async open(r,o){const a=this.C(r);let l;(0,p.isFileOpenForWriteOptions)(o)&&(l=await this.I(r));let s;try{if((0,p.isFileOpenForWriteOptions)(o)&&o.unlock)try{const{stat:P}=await m.SymlinkSupport.stat(a);P.mode&128||await m.Promises.chmod(a,P.mode|128)}catch(P){this.a.trace(P)}let u;if((0,p.isFileOpenForWriteOptions)(o)){if(T.isWindows)try{await m.Promises.truncate(a,0),u="r+"}catch(P){P.code!=="ENOENT"&&this.a.trace(P)}u||(u="w")}else u="r";s=await m.Promises.open(a,u)}catch(u){throw l?.dispose(),(0,p.isFileOpenForWriteOptions)(o)?await this.Z(r,u):this.Y(u)}if(this.L.set(s,0),(0,p.isFileOpenForWriteOptions)(o)&&this.N.set(s,r),l){const u=this.M.get(s);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${s} (${a})`),this.M.set(s,l),u&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${s} (${a})`),u.dispose())}return s}async close(r){const o=this.M.get(r);try{if(this.L.delete(r),this.N.delete(r)&&i.O)try{await m.Promises.fdatasync(r)}catch(a){i.configureFlushOnWrite(!1),this.a.error(a)}return await m.Promises.close(r)}catch(a){throw this.Y(a)}finally{o&&(this.M.get(r)===o&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.M.delete(r)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),o.dispose())}}async read(r,o,a,l,s){const u=this.P(r,o);let P=null;try{P=(await m.Promises.read(r,a,l,s,u)).bytesRead}catch(F){throw this.Y(F)}finally{this.Q(r,u,P)}return P}P(r,o){return o===this.L.get(r)?null:o}Q(r,o,a){const l=this.L.get(r);typeof l=="number"&&(typeof o=="number"||(typeof a=="number"?this.L.set(r,l+a):this.L.delete(r)))}async write(r,o,a,l,s){return(0,k.retry)(()=>this.R(r,o,a,l,s),100,3)}async R(r,o,a,l,s){const u=this.P(r,o);let P=null;try{P=(await m.Promises.write(r,a,l,s,u)).bytesWritten}catch(F){throw await this.Z(this.N.get(r),F)}finally{this.Q(r,u,P)}return P}async mkdir(r){try{await m.Promises.mkdir(this.C(r))}catch(o){throw this.Y(o)}}async delete(r,o){try{const a=this.C(r);o.recursive?await m.Promises.rm(a,m.RimRafMode.MOVE):await m.Promises.unlink(a)}catch(a){throw this.Y(a)}}async rename(r,o,a){const l=this.C(r),s=this.C(o);if(l!==s)try{await this.S(r,o,"move",a.overwrite),await m.Promises.move(l,s)}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,g.localize)(2,null,(0,D.basename)(l),(0,D.basename)((0,D.dirname)(s)),u.toString()))),this.Y(u)}}async copy(r,o,a){const l=this.C(r),s=this.C(o);if(l!==s)try{await this.S(r,o,"copy",a.overwrite),await m.Promises.copy(l,s,{preserveSymlinks:!0})}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,g.localize)(3,null,(0,D.basename)(l),(0,D.basename)((0,D.dirname)(s)),u.toString()))),this.Y(u)}}async S(r,o,a,l){const s=this.C(r),u=this.C(o);let P=!1;if(!!(this.capabilities&1024)||(P=(0,E.isEqual)(s,u,!0)),P&&a==="copy")throw(0,p.createFileSystemProviderError)((0,g.localize)(4,null),p.FileSystemProviderErrorCode.FileExists);if(!P&&await m.Promises.exists(u)){if(!l)throw(0,p.createFileSystemProviderError)((0,g.localize)(5,null),p.FileSystemProviderErrorCode.FileExists);await this.delete(o,{recursive:!0,useTrash:!1})}}async cloneFile(r,o){return this.U(r,o,!1)}async U(r,o,a){const l=this.C(r),s=this.C(o),u=!!(this.capabilities&1024);if((0,E.isEqual)(l,s,!u))return;const P=new y.DisposableStore;try{const[F,K]=await Promise.all([this.I(r),this.I(o)]);P.add(F),P.add(K),a&&await m.Promises.mkdir((0,D.dirname)(s),{recursive:!0}),await m.Promises.copyFile(l,s)}catch(F){if(F.code==="ENOENT"&&!a)return this.U(r,o,!0);throw this.Y(F)}finally{P.dispose()}}p(r,o,a){return new h.UniversalWatcherClient(l=>r(l),l=>o(l),a)}y(r,o,a){return new f.NodeJSWatcherClient(l=>r(l),l=>o(l),a)}Y(r){if(r instanceof p.FileSystemProviderError)return r;let o;switch(r.code){case"ENOENT":o=p.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=p.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=p.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=p.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=p.FileSystemProviderErrorCode.NoPermissions;break;default:o=p.FileSystemProviderErrorCode.Unknown}return(0,p.createFileSystemProviderError)(r,o)}async Z(r,o){let a=this.Y(o);if(r&&a.code===p.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await m.SymlinkSupport.stat(this.C(r));l.mode&128||(a=(0,p.createFileSystemProviderError)(o,p.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.a.trace(l)}return a}}e.DiskFileSystemProvider=i,i.D=!1,i.O=!0}),define(ve[211],be([1,0,6,63,2,16,44,19]),function(ie,e,b,t,k,S,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class E extends k.Disposable{constructor(T,C){super(),this.a=T,this.b=C,this.w=new Map,this.y=new Map}call(T,C,w){const m=this.c(T);switch(C){case"stat":return this.g(m,w[0]);case"readdir":return this.h(m,w[0]);case"open":return this.l(m,w[0],w[1]);case"close":return this.m(w[0]);case"read":return this.n(w[0],w[1],w[2]);case"readFile":return this.i(m,w[0],w[1]);case"write":return this.p(w[0],w[1],w[2],w[3],w[4]);case"writeFile":return this.k(m,w[0],w[1],w[2]);case"rename":return this.t(m,w[0],w[1],w[2]);case"copy":return this.u(m,w[0],w[1],w[2]);case"cloneFile":return this.v(m,w[0],w[1]);case"mkdir":return this.r(m,w[0]);case"delete":return this.s(m,w[0],w[1]);case"watch":return this.C(m,w[0],w[1],w[2],w[3]);case"unwatch":return this.D(w[0],w[1])}throw new Error(`IPC Command ${C} not found`)}listen(T,C,w){const m=this.c(T);switch(C){case"fileChange":return this.z(m,w[0]);case"readFileStream":return this.j(m,w[0],w[1])}throw new Error(`Unknown event ${C}`)}g(T,C){const w=this.f(T,C,!0);return this.a.stat(w)}h(T,C){const w=this.f(T,C);return this.a.readdir(w)}async i(T,C,w){const m=this.f(T,C,!0),g=await this.a.readFile(m,w);return S.VSBuffer.wrap(g)}j(T,C,w){const m=this.f(T,C,!0),g=new A.CancellationTokenSource,p=new b.Emitter({onDidRemoveLastListener:()=>{g.cancel()}}),d=this.a.readFileStream(m,w,g.token);return(0,I.listenStream)(d,{onData:v=>p.fire(S.VSBuffer.wrap(v)),onError:v=>p.fire(v),onEnd:()=>{p.fire("end"),p.dispose(),g.dispose()}}),p.event}k(T,C,w,m){const g=this.f(T,C);return this.a.writeFile(g,w.buffer,m)}l(T,C,w){const m=this.f(T,C,!0);return this.a.open(m,w)}m(T){return this.a.close(T)}async n(T,C,w){const m=S.VSBuffer.alloc(w),g=0,p=await this.a.read(T,C,m.buffer,g,w);return[m,p]}p(T,C,w,m,g){return this.a.write(T,C,w.buffer,m,g)}r(T,C){const w=this.f(T,C);return this.a.mkdir(w)}s(T,C,w){const m=this.f(T,C);return this.a.delete(m,w)}t(T,C,w,m){const g=this.f(T,C),p=this.f(T,w);return this.a.rename(g,p,m)}u(T,C,w,m){const g=this.f(T,C),p=this.f(T,w);return this.a.copy(g,p,m)}v(T,C,w){const m=this.f(T,C),g=this.f(T,w);return this.a.cloneFile(m,g)}z(T,C){const w=new b.Emitter({onWillAddFirstListener:()=>{this.w.set(C,this.F(T,w))},onDidRemoveLastListener:()=>{(0,k.dispose)(this.w.get(C)),this.w.delete(C)}});return w.event}async C(T,C,w,m,g){const p=this.w.get(C);if(p){const d=this.f(T,m),v=p.watch(w,d,g);this.y.set(C+w,v)}}async D(T,C){const w=T+C,m=this.y.get(w);m&&((0,k.dispose)(m),this.y.delete(w))}dispose(){super.dispose();for(const[,T]of this.y)T.dispose();this.y.clear();for(const[,T]of this.w)T.dispose();this.w.clear()}}e.AbstractDiskFileSystemProviderChannel=E;class y extends k.Disposable{constructor(T,C,w,m){super(),this.c=T,this.f=w,this.g=m,this.a=new Map,this.b=this.B(new t.DiskFileSystemProvider(this.f,{watcher:{recursive:this.i(this.g)}})),this.h(C)}h(T){const C=this.B(new b.Emitter);this.B(C.event(w=>{T.fire(w.map(m=>({resource:this.c.transformOutgoingURI(m.resource),type:m.type})))})),this.B(this.b.onDidChangeFile(w=>C.fire(w))),this.B(this.b.onDidWatchError(w=>T.fire(w)))}i(T){}j(T){}watch(T,C,w){const m=this.j(this.g);return Array.isArray(m)&&(w.excludes=[...w.excludes,...m]),this.a.set(T,this.b.watch(C,w)),(0,k.toDisposable)(()=>{(0,k.dispose)(this.a.get(T)),this.a.delete(T)})}dispose(){super.dispose();for(const[,T]of this.a)T.dispose();this.a.clear()}}e.AbstractSessionFileWatcher=y}),define(ve[212],be([1,0,12]),function(ie,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;class t extends b.AbstractMessageLogger{constructor(S=b.DEFAULT_LOG_LEVEL){super(),this.k=[],this.l=void 0,this.setLevel(S),this.B(this.onDidChangeLogLevel(I=>{this.l?.setLevel(I)}))}set logger(S){this.l=S;for(const{level:I,message:A}of this.k)(0,b.log)(S,I,A);this.k=[]}g(S,I){this.l?(0,b.log)(this.l,S,I):this.getLevel()<=S&&this.k.push({level:S,message:I})}dispose(){this.l?.dispose()}flush(){this.l?.flush()}}e.BufferLogService=t}),define(ve[104],be([1,0,6,4,12]),function(ie,e,b,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class S{constructor(C,w){this.a=C,this.b=w,this.onDidChangeLogLevel=b.Event.buffer(C.onDidChangeLogLevel,!0)}listen(C,w){switch(w){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${w}`)}async call(C,w,m){switch(w){case"setLevel":return m[1]?this.b.setLevel(t.URI.revive(m[1]),m[0]):this.a.setLevel(m[0])}throw new Error(`Call not found: ${w}`)}}e.LogLevelChannel=S;class I{constructor(C){this.a=C}get onDidChangeLogLevel(){return this.a.listen("onDidChangeLogLevel")}setLevel(C,w){I.setLevel(this.a,C,w)}static setLevel(C,w,m){return C.call("setLevel",[w,m])}}e.LogLevelChannelClient=I;class A{constructor(C){this.b=C,this.a=new Map}listen(C,w){throw new Error(`Event not found: ${w}`)}async call(C,w,m){switch(w){case"createLogger":this.c(t.URI.revive(m[0]),m[1]);return;case"log":return this.e(t.URI.revive(m[0]),m[1]);case"consoleLog":return this.d(m[0],m[1])}throw new Error(`Call not found: ${w}`)}c(C,w){this.a.set(C.toString(),this.b.createLogger(C,w))}d(C,w){let m=console.log;switch(C){case k.LogLevel.Error:m=console.error;break;case k.LogLevel.Warning:m=console.warn;break;case k.LogLevel.Info:m=console.info;break}m.call(console,...w)}e(C,w){const m=this.a.get(C.toString());if(!m)throw new Error("Create the logger before logging");for(const[g,p]of w)(0,k.log)(m,g,p)}}e.LoggerChannel=A;class E extends k.AbstractLoggerService{constructor(C,w,m){super(C,w),this.g=m}createConsoleMainLogger(){return new k.AdapterLogger({log:(C,w)=>{this.g.call("consoleLog",[C,w])}})}f(C,w,m){return new y(this.g,C,w,m)}}e.LoggerChannelClient=E;class y extends k.AbstractMessageLogger{constructor(C,w,m,g){super(g?.always),this.m=C,this.n=w,this.k=!1,this.l=[],this.setLevel(m),this.m.call("createLogger",[w,g]).then(()=>{this.r(this.l),this.k=!0})}g(C,w){const m=[[C,w]];this.k?this.r(m):this.l.push(...m)}r(C){this.m.call("log",[this.n,C])}}class D extends k.LogService{constructor(C,w){super(w),this.c=C,this.B(C.onDidChangeLogLevel(m=>w.setLevel(m)))}setLevel(C){super.setLevel(C),this.c.setLevel(C)}}e.FollowerLogService=D}),define(ve[105],be([1,0,17,12]),function(ie,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var k;(function(y){y[y.Trace=0]="Trace",y[y.Debug=1]="Debug",y[y.Info=2]="Info",y[y.Warning=3]="Warning",y[y.Error=4]="Error",y[y.Critical=5]="Critical",y[y.Off=6]="Off"})(k||(k={}));async function S(y,D,T,C,w){try{const m=await new Promise((p,d)=>{ie(["spdlog"],p,d)});m.setFlushOn(k.Trace);const g=await m.createAsyncRotatingLogger(y,D,T,C);return w?g.clearFormatters():g.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),g}catch(m){console.error(m)}return null}function I(y,D,T){switch(D){case t.LogLevel.Trace:y.trace(T);break;case t.LogLevel.Debug:y.debug(T);break;case t.LogLevel.Info:y.info(T);break;case t.LogLevel.Warning:y.warn(T);break;case t.LogLevel.Error:y.error(T);break;case t.LogLevel.Off:break;default:throw new Error(`Invalid log level ${D}`)}}function A(y,D){switch(D){case t.LogLevel.Trace:y.setLevel(k.Trace);break;case t.LogLevel.Debug:y.setLevel(k.Debug);break;case t.LogLevel.Info:y.setLevel(k.Info);break;case t.LogLevel.Warning:y.setLevel(k.Warning);break;case t.LogLevel.Error:y.setLevel(k.Error);break;case t.LogLevel.Off:y.setLevel(k.Off);break;default:throw new Error(`Invalid log level ${D}`)}}class E extends t.AbstractMessageLogger{constructor(D,T,C,w,m){super(),this.k=[],this.setLevel(m),this.l=this.n(D,T,C,w),this.B(this.onDidChangeLogLevel(g=>{this.m&&A(this.m,g)}))}async n(D,T,C,w){const m=C?6:1,g=30/m*b.ByteSize.MB,p=await S(D,T,g,m,w);if(p){this.m=p,A(this.m,this.getLevel());for(const{level:d,message:v}of this.k)I(this.m,d,v);this.k=[]}}g(D,T){this.m?I(this.m,D,T):this.getLevel()<=D&&this.k.push({level:D,message:T})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=E}),define(ve[213],be([1,0,22,12,105]),function(ie,e,b,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let S=class extends t.AbstractLoggerService{constructor(A){super(A.getLevel(),A.onDidChangeLogLevel)}f(A,E,y){return new k.SpdLogLogger(y?.name||(0,b.generateUuid)(),A.fsPath,!y?.donotRotate,!!y?.donotUseFormatters,E)}};S=Le([Oe(0,t.ILogService)],S),e.LoggerService=S}),define(ve[214],be([1,0,70,177,5]),function(ie,e,b,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var S;(function(E){E[E.Unnecessary=1]="Unnecessary",E[E.Deprecated=2]="Deprecated"})(S=e.MarkerTag||(e.MarkerTag={}));var I;(function(E){E[E.Hint=1]="Hint",E[E.Info=2]="Info",E[E.Warning=4]="Warning",E[E.Error=8]="Error"})(I=e.MarkerSeverity||(e.MarkerSeverity={})),function(E){function y(m,g){return g-m}E.compare=y;const D=Object.create(null);D[E.Error]=(0,t.localize)(0,null),D[E.Warning]=(0,t.localize)(1,null),D[E.Info]=(0,t.localize)(2,null);function T(m){return D[m]||""}E.toString=T;function C(m){switch(m){case b.default.Error:return E.Error;case b.default.Warning:return E.Warning;case b.default.Info:return E.Info;case b.default.Ignore:return E.Hint}}E.fromSeverity=C;function w(m){switch(m){case E.Error:return b.default.Error;case E.Warning:return b.default.Warning;case E.Info:return b.default.Info;case E.Hint:return b.default.Ignore}}E.toSeverity=w}(I=e.MarkerSeverity||(e.MarkerSeverity={}));var A;(function(E){const y="";function D(C){return T(C,!0)}E.makeKey=D;function T(C,w){const m=[y];return C.source?m.push(C.source.replace("\xA6","\\\xA6")):m.push(y),C.code?typeof C.code=="string"?m.push(C.code.replace("\xA6","\\\xA6")):m.push(C.code.value.replace("\xA6","\\\xA6")):m.push(y),C.severity!==void 0&&C.severity!==null?m.push(I.toString(C.severity)):m.push(y),C.message&&w?m.push(C.message.replace("\xA6","\\\xA6")):m.push(y),C.startLineNumber!==void 0&&C.startLineNumber!==null?m.push(C.startLineNumber.toString()):m.push(y),C.startColumn!==void 0&&C.startColumn!==null?m.push(C.startColumn.toString()):m.push(y),C.endLineNumber!==void 0&&C.endLineNumber!==null?m.push(C.endLineNumber.toString()):m.push(y),C.endColumn!==void 0&&C.endColumn!==null?m.push(C.endColumn.toString()):m.push(y),m.push(y),m.join("\xA6")}E.makeKeyOptionalMessage=T})(A=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,k.createDecorator)("markerService")}),define(ve[64],be([1,0,6,55,2,5]),function(ie,e,b,t,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,S.createDecorator)("policy");class I extends k.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new b.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(y){const D=Object.keys(this.f).length;return this.f={...y,...this.f},D!==Object.keys(this.f).length&&await this.i(y),t.Iterable.reduce(this.g.entries(),(T,[C,w])=>({...T,[C]:w}),{})}getPolicyValue(y){return this.g.get(y)}serialize(){return t.Iterable.reduce(Object.entries(this.f),(y,[D,T])=>({...y,[D]:{definition:T,value:this.g.get(D)}}),{})}}e.AbstractPolicyService=I;class A{constructor(){this.onDidChange=b.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=A}),define(ve[50],be([1,0,3,27]),function(ie,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let k;if(typeof b.globals.vscode<"u"&&typeof b.globals.vscode.context<"u"){const S=b.globals.vscode.context.configuration();if(S)k=S.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(k=globalThis._VSCODE_PRODUCT_JSON,t.env.VSCODE_DEV&&Object.assign(k,{nameShort:`${k.nameShort} Dev`,nameLong:`${k.nameLong} Dev`,dataFolderName:`${k.dataFolderName}-dev`,serverDataFolderName:k.serverDataFolderName?`${k.serverDataFolderName}-dev`:void 0}),!k.version){const S=globalThis._VSCODE_PACKAGE_JSON;Object.assign(k,{version:S.version})}}else k={nameShort:"Code",nameLong:"Visual Studio Code",applicationName:"code",win32AppId:"{{F8A2A208-72B3-4D61-95FC-8A65D340689B}",win32x64AppId:"{{EA457B21-F73E-494C-ACAB-524FDE069978}",win32arm64AppId:"{{A5270FC5-65AD-483E-AC30-2C276B63D0AC}",win32UserAppId:"{{D628A17A-9713-46BF-8D57-E671B46A741E}",win32x64UserAppId:"{{771FD6B0-FA20-440A-A002-3B3BAC16DC50}",win32arm64UserAppId:"{{D9E514E7-1A56-452D-9337-2990C0DC4310}",win32NameVersion:"Microsoft Visual Studio Code",win32DirName:"Microsoft VS Code",win32SetupExeBasename:"VSCodeSetup",win32AppUserModelId:"Microsoft.VisualStudioCode",win32ShellNameShort:"Code",win32MutexName:"vscode",win32RegValueName:"VSCode",darwinCredits:"resources/darwin/Credits.rtf",darwinBundleIdentifier:"com.microsoft.VSCode",darwinExecutable:"VSCode",linuxIconName:"com.visualstudio.code",licenseFileName:"LICENSE.rtf",licenseName:"Multiple, see https://code.visualstudio.com/license",serverLicense:["*","* Visual Studio Code Server","*","* By using the software, you agree to","* the Visual Studio Code Server License Terms (https://aka.ms/vscode-server-license) and","* the Microsoft Privacy Statement (https://privacy.microsoft.com/en-US/privacystatement).","*"],serverLicensePrompt:"Do you accept the terms in the License Agreement (Y/n)?",serverApplicationName:"code-server",urlProtocol:"vscode",dataFolderName:".vscode",serverDataFolderName:".vscode-server",downloadUrl:"https://code.visualstudio.com",updateUrl:"https://update.code.visualstudio.com",webEndpointUrl:"https://main.vscode-cdn.net",webEndpointUrlTemplate:"https://{{uuid}}.vscode-cdn.net/{{quality}}/{{commit}}",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/{{quality}}/{{commit}}/out/vs/workbench/contrib/webview/browser/pre/",quality:"stable",extensionsGallery:{nlsBaseUrl:"https://www.vscode-unpkg.net/_lp/",serviceUrl:"https://marketplace.visualstudio.com/_apis/public/gallery",cacheUrl:"https://vscode.blob.core.windows.net/gallery/index",itemUrl:"https://marketplace.visualstudio.com/items",publisherUrl:"https://marketplace.visualstudio.com/publishers",resourceUrlTemplate:"https://{publisher}.vscode-unpkg.net/{publisher}/{name}/{version}/{path}",controlUrl:"https://az764295.vo.msecnd.net/extensions/marketplace.json"},extensionTips:{"ms-dotnettools.csharp":"{**/*.cs,**/project.json,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln,**/appsettings.json}","firefox-devtools.vscode-firefox-debug":"{**/*.ts,**/*.tsx,**/*.js,**/*.jsx,**/*.es6,**/.babelrc}","ms-edgedevtools.vscode-edge-devtools":"{**/*.ts,**/*.tsx,**/*.js,**/*.css,**/*.html}","golang.Go":"**/*.go","ms-vscode.PowerShell":"{**/*.ps1,**/*.psd1,**/*.psm1,**/*.ps.config,**/*.ps1.config}","Ionide.Ionide-fsharp":"{**/*.fsx,**/*.fsi,**/*.fs,**/*.ml,**/*.mli}","dbaeumer.vscode-eslint":"{**/*.js,**/*.jsx,**/*.es6,**/.eslintrc.*,**/.eslintrc,**/.babelrc,**/jsconfig.json}","ms-vscode.vscode-typescript-tslint-plugin":"{**/tslint.json}","bmewburn.vscode-intelephense-client":"{**/*.php,**/php.ini}","xdebug.php-debug":"{**/*.php,**/php.ini}","rust-lang.rust-analyzer":"{**/*.rs,**/*.rslib}","ms-vscode.cpptools-extension-pack":"{**/*.c,**/*.cpp,**/*.cc,**/.cxx,**/*.hh,**/*.hpp,**/*.hxx,**/*.h}","DavidAnson.vscode-markdownlint":"{**/*.md}","ms-azuretools.vscode-docker":"{**/dockerfile,**/Dockerfile,**/docker-compose.yml,**/docker-compose.*.yml,**/*.cs,**/project.json,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln,**/appsettings.json,**/*.py,**/*.ipynb,**/*.js,**/*.ts,**/package.json}","EditorConfig.EditorConfig":"{**/.editorconfig}","HookyQR.beautify":"{**/.jsbeautifyrc}","donjayamanne.githistory":"{**/.gitignore,**/.git}","felipecaputo.git-project-manager":"{**/.gitignore,**/.git}","eamodio.gitlens":"{**/.gitignore,**/.git}","rebornix.Ruby":"{**/*.rb,**/*.erb,**/*.reek,**/.fasterer.yml,**/ruby-lint.yml,**/.rubocop.yml}","DotJoshJohnson.xml":"{**/*.xml}","stylelint.vscode-stylelint":"{**/.stylelintrc,**/stylelint.config.js}","ms-mssql.mssql":"{**/*.sql}","mtxr.sqltools":"{**/*.sql}","usqlextpublisher.usql-vscode-ext":"{**/*.usql}","ms-vscode.sublime-keybindings":"{**/.sublime-project,**/.sublime-workspace}","k--kato.intellij-idea-keybindings":"{**/.idea}","christian-kohler.npm-intellisense":"{**/package.json}","vue.volar":"{**/*.vue}","ms-python.python":"{**/*.py,**/*.ipynb}","ms-toolsai.jupyter":"{**/*.ipynb}","cake-build.cake-vscode":"{**/build.cake}","Angular.ng-template":"{**/.angular-cli.json,**/angular.json,**/*.ng.html,**/*.ng,**/*.ngml}","vscjava.vscode-maven":"**/pom.xml","ms-azuretools.vscode-azureterraform":"**/*.tf","HashiCorp.terraform":"**/*.tf","vsciot-vscode.vscode-arduino":"**/*.ino","ms-kubernetes-tools.vscode-kubernetes-tools":"{**/Chart.yaml}","GoogleCloudTools.cloudcode":"{**/skaffold.yaml}","Oracle.oracledevtools":"{**/*.sql}","ms-vscode.vscode-github-issue-notebooks":"{**/*.github-issues}","REditorSupport.r":"**/*.r","betterthantomorrow.calva":"{**/*.clj,**/*.cljs}","Pivotal.vscode-boot-dev-pack":"{**/application.properties}"},extensionImportantTips:{"ms-dotnettools.csharp":{name:"C#",languages:["csharp"],pattern:"{**/*.cs,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln}"},"ms-python.python":{name:"Python",languages:["python"],pattern:"{**/*.py}"},"golang.Go":{name:"Go",languages:["go"],pattern:"**/*.go"},"vscjava.vscode-java-pack":{name:"Java",languages:["java"],pattern:"{**/*.java}",isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]},"ms-vscode.PowerShell":{name:"PowerShell",languages:["powershell"],pattern:"{**/*.ps1,**/*.psd1,**/*.psm1}"},"ms-vscode.cpptools-extension-pack":{name:"C/C++",languages:["c","cpp"],pattern:"{**/*.c,**/*.cpp,**/*.cc,**/.cxx,**/*.hh,**/*.hpp,**/*.hxx,**/*.h}",whenNotInstalled:["llvm-vs-code-extensions.vscode-clangd"]},"ms-azuretools.vscode-docker":{name:"Docker",languages:["dockerfile"],pattern:"{**/dockerfile,**/Dockerfile,**/docker-compose.yml,**/docker-compose.*.yml}"},"vue.volar":{name:"Vetur",languages:["vue"],pattern:"{**/*.vue}"},"ms-vscode.makefile-tools":{name:"Makefile Tools",languages:["makefile"],pattern:"{**/makefile,**/Makefile}"},"ms-vscode.cmake-tools":{name:"CMake Tools",pattern:"{**/CMakeLists.txt}"},"ms-azure-devops.azure-pipelines":{name:"Azure Pipelines",pattern:"{**/azure-pipelines.yaml}"},"msazurermtools.azurerm-vscode-tools":{name:"Azure Resource Manager",pattern:"{**/azuredeploy.json}"},"ms-vscode-remote.remote-containers":{name:"Dev Containers",pattern:"{**/devcontainer.json}"},"ms-azuretools.vscode-bicep":{name:"Bicep",pattern:"{**/*.bicep}"},"svelte.svelte-vscode":{name:"Svelte",pattern:"{**/*.svelte}"},"ms-vscode.vscode-github-issue-notebooks":{name:"GitHub Issue Notebooks",pattern:"{**/*.github-issues}"},"ms-playwright.playwright":{name:"Playwright",pattern:"{**/*playwright*.config.ts,**/*playwright*.config.js,**/*playwright*.config.mjs}"},"vscjava.vscode-gradle":{name:"Gradle for Java",pattern:"{**/gradlew,**/gradlew.bat,**/build.gradle,**/build.gradle.kts,**/settings.gradle,**/settings.gradle.kts}"},"REditorSupport.r":{name:"R",languages:["r"],pattern:"{**/*.r}"}},keymapExtensionTips:["vscodevim.vim","ms-vscode.sublime-keybindings","ms-vscode.atom-keybindings","ms-vscode.brackets-keybindings","ms-vscode.vs-keybindings","ms-vscode.notepadplusplus-keybindings","k--kato.intellij-idea-keybindings","lfs.vscode-emacs-friendly","alphabotsec.vscode-eclipse-keybindings","alefragnani.delphi-keybindings"],languageExtensionTips:["ms-python.python","ms-vscode.cpptools-extension-pack","ms-dotnettools.csharp","ms-toolsai.jupyter","vscjava.vscode-java-pack","ecmel.vscode-html-css","vue.volar","bmewburn.vscode-intelephense-client","dsznajder.es7-react-js-snippets","golang.go","ms-vscode.powershell","dart-code.dart-code","rust-lang.rust-analyzer","rebornix.ruby"],configBasedExtensionTips:{git:{configPath:".git/config",configName:"Git",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",remotes:["github.com"]},"eamodio.gitlens":{name:"GitLens"}}},devContainer:{configPath:".devcontainer/devcontainer.json",configName:"Dev Container",recommendations:{"ms-vscode-remote.remote-containers":{name:"Dev Containers",important:!0}}},maven:{configPath:"pom.xml",configName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]},"Pivotal.vscode-boot-dev-pack":{name:"Spring Boot Extension Pack",isExtensionPack:!0}}},gradle:{configPath:"build.gradle",configName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},"github-pull-request":{configPath:".vscode/.github-pull-request.rec",configName:"GitHub",configScheme:"vscode-vfs",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",important:!0}}}},exeBasedExtensionTips:{az:{friendlyName:"Azure CLI",windowsPath:"%ProgramFiles(x86)%\\Microsoft SDKs\\Azure\\CLI2\\wbin\\az.cmd",recommendations:{"ms-vscode.azurecli":{name:"Azure CLI Tools"}}},heroku:{friendlyName:"Heroku CLI",windowsPath:"%ProgramFiles%\\Heroku\\bin\\heroku.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"pkosta2005.heroku-command":{name:"heroku-cli"}}},mongo:{friendlyName:"Mongo",windowsPath:"%ProgramFiles%\\MongoDB\\Server\\3.6\\bin\\mongod.exe",recommendations:{"ms-azuretools.vscode-cosmosdb":{name:"Azure Databases"}}},serverless:{friendlyName:"Serverless framework",windowsPath:"%APPDATA%\\npm\\serverless.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},func:{friendlyName:"Azure Function SDK",windowsPath:"%APPDATA%\\npm\\func.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},mysql:{friendlyName:"MySQL",windowsPath:"%ProgramFiles%\\MySQL\\MySQL Server 8.0\\bin\\mysqld.exe",recommendations:{"mtxr.sqltools":{name:"SQLTools"}}},postgres:{friendlyName:"PostgreSQL",windowsPath:"%ProgramFiles%\\PostgreSQL\\11\\bin\\psql.exe",recommendations:{"ms-ossdata.vscode-postgresql":{name:"PostgreSQL"},"mtxr.sqltools":{name:"SQLTools"}}},sqlcmd:{friendlyName:"SQL CLI",recommendations:{"ms-mssql.mssql":{name:"SQL Server (mssql)"}}},now:{friendlyName:"Now CLI",windowsPath:"%APPDATA%\\npm\\now.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"ms-azuretools.vscode-docker":{name:"Docker"}}},docker:{friendlyName:"Docker",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\docker.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker",important:!0},"ms-vscode-remote.remote-containers":{name:"Dev Containers",important:!0},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},kubectl:{friendlyName:"Kubernetes",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\kubectl.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},ng:{friendlyName:"Angular CLI",windowsPath:"%APPDATA%\\npmexit\\ng.cmd",recommendations:{"johnpapa.Angular2":{name:"Angular Snippets"}}},"create-react-app":{friendlyName:"Create React App",windowsPath:"%APPDATA%\\npm\\create-react-app.cmd",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},"react-native":{friendlyName:"React Native",windowsPath:"%APPDATA%\\npm\\react-native-cli",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},p4:{friendlyName:"Perforce",recommendations:{"slevesque.perforce":{name:"Perforce for VS Code"}}},hg:{friendlyName:"Mercurial",recommendations:{"mrcrowl.hg":{name:"Hg"}}},git:{friendlyName:"Git",windowsPath:"%ProgramFiles%\\Git\\git-bash.exe",recommendations:{"eamodio.gitlens":{name:"GitLens"}}},svn:{friendlyName:"Subversion",windowsPath:"%ProgramFiles%\\TortoiseSVN\\bin\\TortoiseProc.exe",recommendations:{"johnstoncode.svn-scm":{name:"SVN"}}},subl:{friendlyName:"Sublime",windowsPath:"%ProgramFiles%\\Sublime Text3\\sublime_text.exe",recommendations:{"ms-vscode.sublime-keybindings":{name:"Sublime Text Keymap and Settings Importer"}}},atom:{friendlyName:"Atom",windowsPath:"%USERPROFILE%\\AppData\\Local\\atom\\bin\\atom.cmd",recommendations:{"ms-vscode.atom-keybindings":{name:"Atom Keymap"}}},brackets:{friendlyName:"Brackets",windowsPath:"%ProgramFiles(x86)%\\Brackets\\Brackets.exe",recommendations:{"ms-vscode.brackets-keybindings":{name:"Brackets Keymap"}}},notepadplusplus:{friendlyName:"Notepad++",windowsPath:"%ProgramFiles%\\Notepad++\\Notepad++.exe",recommendations:{"ms-vscode.notepadplusplus-keybindings":{name:"Notepad++ keymap"}}},vi:{friendlyName:"VIM",windowsPath:"%ProgramFiles(x86)%\\Vim\\vim80\\gvim.exe",recommendations:{"vscodevim.vim":{name:"Vim"}}},mvn:{friendlyName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},gradle:{friendlyName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},"Microsoft Edge":{friendlyName:"Microsoft Edge",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Dev":{friendlyName:"Microsoft Edge Dev",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Dev\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Beta":{friendlyName:"Microsoft Edge Beta",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Beta\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Canary":{friendlyName:"Microsoft Edge Canary",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge SxS\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Mozilla Firefox (x86)":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles(x86)%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition (x86)":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles(x86)%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},cordova:{friendlyName:"Cordova",windowsPath:"%APPDATA%\\npm\\cordova",recommendations:{"msjsdiag.cordova-tools":{name:"Cordova Tools"}}},gcloud:{friendlyName:"Google GCloud CLI",windowsPath:"%ProgramFiles(x86)%\\Google\\Cloud SDK\\google-cloud-sdk\\bin\\gcloud.cmd",recommendations:{"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},skaffold:{friendlyName:"Skaffold Code to Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},minikube:{friendlyName:"MiniKube Local Kubernetes Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},podman:{friendlyName:"Podman",recommendations:{"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},wsl:{friendlyName:"Windows Subsystem for Linux (WSL)",windowsPath:"%WINDIR%\\system32\\lxss\\LxssManager.dll",important:!0,recommendations:{"ms-vscode-remote.remote-wsl":{name:"WSL",important:!0}}}},webExtensionTips:["tyriar.luna-paint","codespaces-contrib.codeswing","ms-vscode.vscode-github-issue-notebooks","esbenp.prettier-vscode","hediet.vscode-drawio"],remoteExtensionTips:{wsl:{friendlyName:"WSL",extensionId:"ms-vscode-remote.remote-wsl"},"ssh-remote":{friendlyName:"Remote - SSH",extensionId:"ms-vscode-remote.remote-ssh"},"dev-container":{friendlyName:"Dev Containers",extensionId:"ms-vscode-remote.remote-containers"},"attached-container":{friendlyName:"Dev Containers",extensionId:"ms-vscode-remote.remote-containers"},vsonline:{friendlyName:"Visual Studio Online",extensionId:"ms-vsonline.vsonline"},tunnel:{friendlyName:"Remote - Tunnels",extensionId:"ms-vscode.remote-server"}},extensionKeywords:{md:["Markdown"],js:["JavaScript"],jsx:["JavaScript"],es6:["JavaScript"],html:["Html"],ts:["TypeScript"],tsx:["TypeScript"],css:["CSS"],scss:["SASS"],txt:["Text"],php:["PHP"],php3:["PHP"],php4:["PHP"],ph3:["PHP"],ph4:["PHP"],xml:["XML"],py:["Python"],pyc:["Python"],pyd:["Python"],pyo:["Python"],pyw:["Python"],pyz:["Python"],java:["Java"],class:["Java"],jar:["Java"],c:["c","objective c","objective-c"],m:["objective c","objective-c"],mm:["objective c","objective-c"],cpp:["cpp","c plus plus","c","c++"],cc:["cpp","c plus plus","c","c++"],cxx:["cpp","c plus plus","c++"],hh:["cpp","c plus plus","c++"],hpp:["cpp","c++"],h:["cpp","c plus plus","c++","c","objective c","objective-c"],sql:["sql"],sh:["bash"],bash:["bash"],zsh:["bash","zshell"],cs:["c#","csharp"],csproj:["c#","csharp"],sln:["c#","csharp"],go:["go"],sty:["latex"],tex:["latex"],ps:["powershell"],ps1:["powershell"],rs:["rust"],rslib:["rust"],hs:["haskell"],lhs:["haskell"],scm:["scheme"],ss:["scheme"],clj:["clojure"],cljs:["clojure"],cljc:["clojure"],edn:["clojure"],erl:["erlang"],hrl:["erlang"],scala:["scala"],sc:["scala"],pl:["perl"],pm:["perl"],t:["perl"],pod:["perl"],groovy:["groovy"],swift:["swift"],rb:["ruby"],rbw:["ruby"],jl:["julia"],f:["fortran"],for:["fortran"],f90:["fortran"],f95:["fortran"],coffee:["CoffeeScript"],litcoffee:["CoffeeScript"],yaml:["yaml"],yml:["yaml"],dart:["dart"],json:["json"]},extensionAllowedBadgeProviders:["api.bintray.com","api.travis-ci.com","api.travis-ci.org","app.fossa.io","badge.buildkite.com","badge.fury.io","badge.waffle.io","badgen.net","badges.frapsoft.com","badges.gitter.im","badges.greenkeeper.io","cdn.travis-ci.com","cdn.travis-ci.org","ci.appveyor.com","circleci.com","cla.opensource.microsoft.com","codacy.com","codeclimate.com","codecov.io","coveralls.io","david-dm.org","deepscan.io","dev.azure.com","docs.rs","flat.badgen.net","gemnasium.com","githost.io","gitlab.com","godoc.org","goreportcard.com","img.shields.io","isitmaintained.com","marketplace.visualstudio.com","nodesecurity.io","opencollective.com","snyk.io","travis-ci.com","travis-ci.org","visualstudio.com","vsmarketplacebadge.apphb.com","www.bithound.io","www.versioneye.com"],extensionAllowedBadgeProvidersRegex:["^https:\\/\\/github\\.com\\/[^/]+\\/[^/]+\\/(actions\\/)?workflows\\/.*badge\\.svg"],crashReporter:{productName:"VSCode",companyName:"Microsoft"},appCenter:{"win32-ia32":"appcenter://code?aid=f4289815-a66e-4ad9-b74f-d8e5bc093e41","win32-x64":"appcenter://code?aid=a4e3233c-699c-46ec-b4f4-9c2a77254662","win32-arm64":"appcenter://code?aid=3712d786-7cc8-4f11-8b08-cc12eab6d4f7","linux-x64":"appcenter://code?aid=fba07a4d-84bd-4fc8-a125-9640fc8ce171",darwin:"appcenter://code?aid=860d6632-f65b-490b-85a8-3e72944f7774","darwin-arm64":"appcenter://code?aid=be71415d-3893-4ae5-b453-e537b9668a10","darwin-universal":"appcenter://code?aid=de75e3cc-e22f-4f42-a03f-1409c21d8af8"},enableTelemetry:!0,aiConfig:{ariaKey:"5bbf946d11a54f6783919c455abaddaf-fd62977b-c92d-4714-a45d-649d06980372-7168"},msftInternalDomains:["redmond.corp.microsoft.com","northamerica.corp.microsoft.com","fareast.corp.microsoft.com","ntdev.corp.microsoft.com","wingroup.corp.microsoft.com","southpacific.corp.microsoft.com","wingroup.windeploy.ntdev.microsoft.com","ddnet.microsoft.com","europe.corp.microsoft.com"],sendASmile:{reportIssueUrl:"https://go.microsoft.com/fwlink/?LinkId=534872",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482"},documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",releaseNotesUrl:"https://go.microsoft.com/fwlink/?LinkID=533483#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",twitterUrl:"https://go.microsoft.com/fwlink/?LinkID=533687",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482",reportIssueUrl:"https://github.com/Microsoft/vscode/issues/new",reportMarketplaceIssueUrl:"https://github.com/microsoft/vsmarketplace/issues/new",licenseUrl:"https://go.microsoft.com/fwlink/?LinkID=533485",privacyStatementUrl:"https://go.microsoft.com/fwlink/?LinkId=786907",showTelemetryOptOut:!0,npsSurveyUrl:"https://aka.ms/vscode-nps",cesSurveyUrl:"https://aka.ms/new-to-vscode-feedback",checksumFailMoreInfoUrl:"https://go.microsoft.com/fwlink/?LinkId=828886",electronRepository:"Microsoft/vscode-electron-prebuilt",settingsSearchUrl:"https://bingsettingssearch.trafficmanager.net/api/Search",surveys:[{surveyId:"cpp.1",surveyUrl:"https://www.research.net/r/VBVV6C6",languageId:"cpp",editCount:10,userProbability:.15},{surveyId:"java.2",surveyUrl:"https://www.research.net/r/vscodejava",languageId:"java",editCount:10,userProbability:.3},{surveyId:"javascript.1",surveyUrl:"https://www.research.net/r/vscode-js",languageId:"javascript",editCount:10,userProbability:.05},{surveyId:"typescript.1",surveyUrl:"https://www.research.net/r/vscode-ts",languageId:"typescript",editCount:10,userProbability:.05}],extensionEnabledApiProposals:{"ms-vscode.vscode-selfhost-test-provider":["testObserver"],"VisualStudioExptTeam.vscodeintellicode-completions":["inlineCompletionsAdditions"],"ms-vsliveshare.vsliveshare":["contribMenuBarHome","diffCommand","documentFiltersExclusive","fileSearchProvider","findTextInFiles","notebookCellExecutionState","notebookLiveShare","terminalDimensions","terminalDataWriteEvent","textSearchProvider"],"ms-vscode.js-debug":["portsAttributes","findTextInFiles","workspaceTrust","tunnels"],"ms-toolsai.vscode-ai-remote":["resolvers"],"ms-python.python":["quickPickSortByLabel","testObserver","telemetryLogger"],"ms-dotnettools.dotnet-interactive-vscode":["notebookMessaging"],"GitHub.codespaces":["contribEditSessions","contribMenuBarHome","contribRemoteHelp","contribViewsRemote","resolvers","tunnels","terminalDataWriteEvent","treeViewReveal","notebookKernelSource"],"ms-vscode.azure-repos":["extensionRuntime","fileSearchProvider","telemetryLogger","textSearchProvider"],"ms-vscode.remote-repositories":["contribEditSessions","contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","contribShareMenu","documentFiltersExclusive","editSessionIdentityProvider","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","scmActionButton","scmSelectedProvider","scmValidation","telemetryLogger","textSearchProvider","timeline"],"ms-vscode-remote.remote-wsl":["resolvers","contribViewsRemote","telemetry"],"ms-vscode-remote.remote-ssh":["resolvers","tunnels","terminalDataWriteEvent","contribViewsRemote","telemetry"],"ms-vscode.remote-server":["resolvers"],"ms-vscode.remote-explorer":["contribViewsRemote","extensionsAny"],"ms-vscode-remote.remote-containers":["contribEditSessions","resolvers","tunnels","workspaceTrust","terminalDimensions","contribViewsRemote"],"ms-vscode.js-debug-nightly":["portsAttributes","findTextInFiles","workspaceTrust","tunnels"],"ms-vscode.lsif-browser":["documentFiltersExclusive"],"GitHub.vscode-pull-request-github":["contribCommentThreadAdditionalMenu","tokenInformation","commentsResolvedState","contribShareMenu","contribCommentPeekContext","treeItemCheckbox","codiconDecoration","diffCommand"],"GitHub.copilot":["inlineCompletionsAdditions"],"GitHub.copilot-nightly":["inlineCompletionsAdditions"],"GitHub.remotehub":["contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","documentFiltersExclusive","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","scmSelectedProvider","scmValidation","textSearchProvider","timeline","telemetryLogger"],"ms-python.gather":["notebookCellExecutionState"],"ms-python.vscode-pylance":["notebookCellExecutionState"],"ms-toolsai.jupyter-renderers":["contribNotebookStaticPreloads"],"ms-toolsai.jupyter":["notebookControllerKind","notebookDeprecated","notebookMessaging","notebookMime","notebookCellExecutionState","portsAttributes","quickPickSortByLabel","notebookKernelSource","interactiveWindow","notebookControllerAffinityHidden","contribNotebookStaticPreloads"],"dbaeumer.vscode-eslint":["notebookCellExecutionState"],"ms-vscode.azure-sphere-tools-ui":["tunnels"],"ms-azuretools.vscode-azureappservice":["terminalDataWriteEvent"],"ms-vscode.anycode":["extensionsAny"],"ms-vscode.cpptools":["terminalDataWriteEvent"],"redhat.java":["documentPaste"]},tasConfig:{endpoint:"https://default.exp-tas.com/vscode/ab",telemetryEventName:"query-expfeature",featuresTelemetryPropertyName:"VSCode.ABExp.Features",assignmentContextTelemetryPropertyName:"abexp.assignmentcontext"},experimentsUrl:"https://vscodeexperiments.azureedge.net/experiments/vscode-experiments.json",extensionKind:{"Shan.code-settings-sync":["ui"],"shalldie.background":["ui"],"techer.open-in-browser":["ui"],"CoenraadS.bracket-pair-colorizer-2":["ui"],"CoenraadS.bracket-pair-colorizer":["ui","workspace"],"hiro-sun.vscode-emacs":["ui","workspace"],"hnw.vscode-auto-open-markdown-preview":["ui","workspace"],"wayou.vscode-todo-highlight":["ui","workspace"],"aaron-bond.better-comments":["ui","workspace"],"vscodevim.vim":["ui"],"ollyhayes.colmak-vim":["ui"]},extensionPointExtensionKind:{typescriptServerPlugins:["workspace"]},extensionSyncedKeys:{"ritwickdey.liveserver":["liveServer.setup.version"]},extensionVirtualWorkspacesSupport:{"esbenp.prettier-vscode":{default:!1},"msjsdiag.debugger-for-chrome":{default:!1},"redhat.java":{default:!1},"HookyQR.beautify":{default:!1},"ritwickdey.LiveServer":{default:!1},"VisualStudioExptTeam.vscodeintellicode":{default:!1},"octref.vetur":{default:!1},"formulahendry.code-runner":{default:!1},"xdebug.php-debug":{default:!1},"ms-mssql.mssql":{default:!1},"christian-kohler.path-intellisense":{default:!1},"eg2.tslint":{default:!1},"eg2.vscode-npm-script":{default:!1},"donjayamanne.githistory":{default:!1},"Zignd.html-css-class-completion":{default:!1},"christian-kohler.npm-intellisense":{default:!1},"EditorConfig.EditorConfig":{default:!1},"austin.code-gnu-global":{default:!1},"johnpapa.Angular2":{default:!1},"ms-vscode.vscode-typescript-tslint-plugin":{default:!1},"DotJoshJohnson.xml":{default:!1},"techer.open-in-browser":{default:!1},"tht13.python":{default:!1},"bmewburn.vscode-intelephense-client":{default:!1},"Angular.ng-template":{default:!1},"xdebug.php-pack":{default:!1},"dbaeumer.jshint":{default:!1},"yzhang.markdown-all-in-one":{default:!1},"Dart-Code.flutter":{default:!1},"streetsidesoftware.code-spell-checker":{default:!1},"rebornix.Ruby":{default:!1},"ms-vscode.sublime-keybindings":{default:!1},"mitaki28.vscode-clang":{default:!1},"steoates.autoimport":{default:!1},"donjayamanne.python-extension-pack":{default:!1},"shd101wyy.markdown-preview-enhanced":{default:!1},"mikestead.dotenv":{default:!1},"pranaygp.vscode-css-peek":{default:!1},"ikappas.phpcs":{default:!1},"platformio.platformio-ide":{default:!1},"jchannon.csharpextensions":{default:!1},"gruntfuggly.todo-tree":{default:!1}},linkProtectionTrustedDomains:["https://*.visualstudio.com","https://*.microsoft.com","https://aka.ms","https://*.gallerycdn.vsassets.io","https://*.github.com","https://login.microsoftonline.com","https://*.vscode.dev","https://*.github.dev"],trustedExtensionAuthAccess:["vscode.git","vscode.github","ms-vscode.remote-repositories","github.remotehub","ms-vscode.azure-repos","ms-vscode.remote-server","github.vscode-pull-request-github","github.codespaces","ms-vsliveshare.vsliveshare"],auth:{loginUrl:"https://login.microsoftonline.com/common/oauth2/authorize",tokenUrl:"https://login.microsoftonline.com/common/oauth2/token",redirectUrl:"https://vscode-redirect.azurewebsites.net/",clientId:"aebc6443-996d-45c2-90f0-388ff96faa56"},"configurationSync.store":{url:"https://vscode-sync.trafficmanager.net/",stableUrl:"https://vscode-sync.trafficmanager.net/",insidersUrl:"https://vscode-sync-insiders.trafficmanager.net/",canSwitch:!1,authenticationProviders:{microsoft:{scopes:["openid","profile","email","offline_access"]},github:{scopes:["user:email"]}}},"editSessions.store":{url:"https://vscode-sync.trafficmanager.net/",authenticationProviders:{microsoft:{scopes:["openid","profile","email","offline_access"]},github:{scopes:["user:email"]}}},tunnelApplicationName:"code-tunnel",tunnelApplicationConfig:{editorWebUrl:"https://vscode.dev",extension:{friendlyName:"Remote - Tunnels",extensionId:"ms-vscode.remote-server"},authenticationProviders:{github:{scopes:["user:email","read:org"]}}},builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.0.18",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.74.1",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.3",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode-remote.remote-wsl-recommender",version:"0.0.18",repo:"https://github.com/microsoft/vscode-remote-wsl-recommender",metadata:{id:"cb296d3c-017a-4dee-83af-ebb5a5a16e9a",publisherId:{publisherId:"ac9410a2-0d75-40ec-90de-b59bb705801d",publisherName:"ms-vscode-remote",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"},platforms:["win32"],clientOnly:!0}],version:"1.74.2",commit:"e8a3071ea4344d9d48ef8a4df2c097372b0c5161",date:"2022-12-20T10:07:26.718Z"},Object.keys(k).length===0&&Object.assign(k,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=k}),define(ve[25],be([1,0,5]),function(ie,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,b.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ve[215],be([1,0,74,12,28,25,208]),function(ie,e,b,t,k,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsWebMainService=void 0;let A=class extends I.BaseCredentialsMainService{constructor(y,D,T){super(y),this.k=D,this.l=T}async getSecretStoragePrefix(){return Promise.resolve(`${this.l.urlProtocol}-server`)}async h(){if(this.f)return this.f;if(this.k.disableKeytar)return this.g.info("Keytar is disabled. Using in-memory credential store instead."),this.f=new b.InMemoryCredentialsProvider,this.f;try{this.f=await new Promise((y,D)=>{ie(["keytar"],y,D)}),await this.f.findCredentials("test-keytar-loads")}catch(y){this.g.warn(`Using the in-memory credential store as the operating system's credential store could not be accessed. Please see https://aka.ms/vscode-server-keyring on how to set this up. Details: ${y.message??y}`),this.f=new b.InMemoryCredentialsProvider}return this.f}};A=Le([Oe(0,t.ILogService),Oe(1,k.INativeEnvironmentService),Oe(2,S.IProductService)],A),e.CredentialsWebMainService=A}),define(ve[35],be([1,0,85,11]),function(ie,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.a=new Map}add(I,A){b.ok(t.isString(I)),b.ok(t.isObject(A)),b.ok(!this.a.has(I),"There is already an extension with this id"),this.a.set(I,A)}knows(I){return this.a.has(I)}as(I){return this.a.get(I)||null}}e.Registry=new k}),define(ve[216],be([1,0,6,35]),function(ie,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class S{constructor(){this.b=new b.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(E,y){this.a[k(E)]=y,this.b.fire(E)}notifySchemaChanged(E){this.b.fire(E)}getSchemaContributions(){return{schemas:this.a}}}const I=new S;t.Registry.add(e.Extensions.JSONContribution,I)}),define(ve[51],be([1,0,18,6,11,161,24,216,35]),function(ie,e,b,t,k,S,I,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var y;(function(f){f.Multiline="multilineText",f.Singleline="singlelineText"})(y=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var D;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.MACHINE=2]="MACHINE",f[f.WINDOW=3]="WINDOW",f[f.RESOURCE=4]="RESOURCE",f[f.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",f[f.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(D=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const T=E.Registry.as(A.Extensions.JSONContribution);class C{constructor(){this.h=new Set,this.i=new t.Emitter,this.onDidSchemaChange=this.i.event,this.j=new t.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:S.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},T.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.r()}registerConfiguration(i,n=!0){this.registerConfigurations([i],n)}registerConfigurations(i,n=!0){const r=this.k(i,n);T.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(i){const n=this.l(i);T.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:n})}updateConfigurations({add:i,remove:n}){const r=[];r.push(...this.l(n)),r.push(...this.k(i,!1)),T.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:(0,b.distinct)(r)})}registerDefaultConfigurations(i){const n=[],r=[];for(const{overrides:o,source:a}of i)for(const l in o)if(n.push(l),e.OVERRIDE_PROPERTY_REGEX.test(l)){const s=this.a.get(l),u=s?.valuesSources??new Map;if(a)for(const ne of Object.keys(o[l]))u.set(ne,a);const P={...s?.value||{},...o[l]};this.a.set(l,{source:a,value:P,valuesSources:u});const F=(0,I.getLanguageTagSettingPlainKey)(l),K={type:"object",default:P,description:S.localize(1,null,F),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:P,source:k.isString(a)?void 0:a,defaultValueSource:a};r.push(...g(l)),this.d[l]=K,this.b.properties[l]=K}else{this.a.set(l,{value:o[l],source:a});const s=this.d[l];s&&(this.s(l,s),this.o(l,s))}this.registerOverrideIdentifiers(r),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:!0})}deregisterDefaultConfigurations(i){const n=[];for(const{overrides:r,source:o}of i)for(const a in r){const l=this.a.get(a),s=k.isString(o)?o:o?.id,u=k.isString(l?.source)?l?.source:l?.source?.id;if(s===u)if(n.push(a),this.a.delete(a),e.OVERRIDE_PROPERTY_REGEX.test(a))delete this.d[a],delete this.b.properties[a];else{const P=this.d[a];P&&(this.s(a,P),this.o(a,P))}}this.q(),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){for(const n of i)this.h.add(n);this.q()}k(i,n){const r=[];return i.forEach(o=>{r.push(...this.m(o,n,o.extensionInfo,o.restrictedProperties)),this.c.push(o),this.n(o)}),r}l(i){const n=[],r=o=>{if(o.properties)for(const a in o.properties){n.push(a);const l=this.d[a];l?.policy?.name&&this.e.delete(l.policy.name),delete this.d[a],this.p(a,o.properties[a])}o.allOf?.forEach(a=>r(a))};for(const o of i){r(o);const a=this.c.indexOf(o);a!==-1&&this.c.splice(a,1)}return n}m(i,n=!0,r,o,a=3){a=k.isUndefinedOrNull(i.scope)?a:i.scope;const l=[],s=i.properties;if(s)for(const P in s){const F=s[P];if(n&&c(P,F)){delete s[P];continue}if(F.source=r,F.defaultDefaultValue=s[P].default,this.s(P,F),e.OVERRIDE_PROPERTY_REGEX.test(P)?F.scope=void 0:(F.scope=k.isUndefinedOrNull(F.scope)?a:F.scope,F.restricted=k.isUndefinedOrNull(F.restricted)?!!o?.includes(P):F.restricted),s[P].hasOwnProperty("included")&&!s[P].included){this.f[P]=s[P],delete s[P];continue}else this.d[P]=s[P],s[P].policy?.name&&this.e.set(s[P].policy.name,P);!s[P].deprecationMessage&&s[P].markdownDeprecationMessage&&(s[P].deprecationMessage=s[P].markdownDeprecationMessage),l.push(P)}const u=i.allOf;if(u)for(const P of u)l.push(...this.m(P,n,r,o,a));return l}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}n(i){const n=r=>{const o=r.properties;if(o)for(const l in o)this.o(l,o[l]);r.allOf?.forEach(n)};n(i)}o(i,n){switch(e.allSettings.properties[i]=n,n.scope){case 1:e.applicationSettings.properties[i]=n;break;case 2:e.machineSettings.properties[i]=n;break;case 6:e.machineOverridableSettings.properties[i]=n;break;case 3:e.windowSettings.properties[i]=n;break;case 4:e.resourceSettings.properties[i]=n;break;case 5:e.resourceSettings.properties[i]=n,this.g.properties[i]=n;break}}p(i,n){switch(delete e.allSettings.properties[i],n.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.g.properties[i];break}}q(){for(const i of this.h.values()){const n=`[${i}]`,r={type:"object",description:S.localize(2,null),errorMessage:S.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.s(n,r),e.allSettings.properties[n]=r,e.applicationSettings.properties[n]=r,e.machineSettings.properties[n]=r,e.machineOverridableSettings.properties[n]=r,e.windowSettings.properties[n]=r,e.resourceSettings.properties[n]=r}this.i.fire()}r(){const i={type:"object",description:S.localize(4,null),errorMessage:S.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this.i.fire()}s(i,n){const r=this.a.get(i);let o=r?.value,a=r?.source;k.isUndefined(o)&&(o=n.defaultDefaultValue,a=void 0),k.isUndefined(o)&&(o=d(n.type)),n.default=o,n.defaultValueSource=a}}const w="\\[([^\\]]+)\\]",m=new RegExp(w,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${w})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function g(f){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(f)){let n=m.exec(f);for(;n?.length;){const r=n[1].trim();r&&i.push(r),n=m.exec(f)}}return(0,b.distinct)(i)}e.overrideIdentifiersFromKey=g;function p(f){return f.reduce((i,n)=>`${i}[${n}]`,"")}e.keyFromOverrideIdentifiers=p;function d(f){switch(Array.isArray(f)?f[0]:f){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const v=new C;E.Registry.add(e.Extensions.Configuration,v);function c(f,i){return f.trim()?e.OVERRIDE_PROPERTY_REGEX.test(f)?S.localize(7,null,f):v.getConfigurationProperties()[f]!==void 0?S.localize(8,null,f):i.policy?.name&&v.getPolicyConfigurations().get(i.policy?.name)!==void 0?S.localize(9,null,f,i.policy?.name,v.getPolicyConfigurations().get(i.policy?.name)):null:S.localize(6,null)}e.validateProperty=c;function h(){const f=[],i=v.getConfigurationProperties();for(const n of Object.keys(i))f.push([n,i[n].scope]);return f.push(["launch",4]),f.push(["task",4]),f}e.getScopes=h}),define(ve[106],be([1,0,18,6,69,2,26,23,11,4,24,51,35]),function(ie,e,b,t,k,S,I,A,E,y,D,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class w{constructor(n={},r=[],o=[],a){this.c=n,this.d=r,this.f=o,this.raw=a,this.a=!1,this.b=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const n=this.raw.map(r=>{if(r instanceof w)return r;const o=new m("");return o.parseRaw(r),o.configurationModel});this.g=n.reduce((r,o)=>o===r?o:r.merge(o),n[0])}else this.g=this;return this.g}get contents(){return this.k(this.c)}get overrides(){return this.k(this.f)}get keys(){return this.k(this.d)}isEmpty(){return this.d.length===0&&Object.keys(this.c).length===0&&this.f.length===0}isFrozen(){return this.a}getValue(n){return n?(0,D.getConfigurationValue)(this.contents,n):this.contents}inspect(n,r){const o=this.rawConfiguration.getValue(n),a=r?this.rawConfiguration.getOverrideValue(n,r):void 0,l=r?this.rawConfiguration.override(r).getValue(n):o;return{value:o,override:a,merged:l}}getOverrideValue(n,r){const o=this.l(r);return o?n?(0,D.getConfigurationValue)(o,n):o:void 0}getKeysForOverrideIdentifier(n){const r=[];for(const o of this.overrides)o.identifiers.includes(n)&&r.push(...o.keys);return b.distinct(r)}getAllOverrideIdentifiers(){const n=[];for(const r of this.overrides)n.push(...r.identifiers);return b.distinct(n)}override(n){let r=this.b.get(n);return r||(r=this.h(n),this.b.set(n,r)),r}merge(...n){const r=A.deepClone(this.contents),o=A.deepClone(this.overrides),a=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const s of n)if(l.push(...s.raw?.length?s.raw:[s]),!s.isEmpty()){this.j(r,s.contents);for(const u of s.overrides){const[P]=o.filter(F=>b.equals(F.identifiers,u.identifiers));P?(this.j(P.contents,u.contents),P.keys.push(...u.keys),P.keys=b.distinct(P.keys)):o.push(A.deepClone(u))}for(const u of s.keys)a.indexOf(u)===-1&&a.push(u)}return new w(r,a,o,l.every(s=>s instanceof w)?void 0:l)}freeze(){return this.a=!0,this}clone(){return new w(A.deepClone(this.contents),[...this.keys],A.deepClone(this.overrides))}h(n){const r=this.l(n);if(!r||typeof r!="object"||!Object.keys(r).length)return this;const o={};for(const a of b.distinct([...Object.keys(this.contents),...Object.keys(r)])){let l=this.contents[a];const s=r[a];s&&(typeof l=="object"&&typeof s=="object"?(l=A.deepClone(l),this.j(l,s)):l=s),o[a]=l}return new w(o,this.keys,this.overrides)}j(n,r){for(const o of Object.keys(r)){if(o in n&&E.isObject(n[o])&&E.isObject(r[o])){this.j(n[o],r[o]);continue}n[o]=A.deepClone(r[o])}}k(n){return this.a&&!Object.isFrozen(n)?A.deepFreeze(n):n}l(n){let r=null,o=null;const a=l=>{l&&(o?this.j(o,l):o=A.deepClone(l))};for(const l of this.overrides)b.equals(l.identifiers,[n])?r=l.contents:l.identifiers.includes(n)&&a(l.contents);return a(r),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,r){this.m(n),(0,D.addToValueTree)(this.contents,n,r,o=>{throw new Error(o)})}removeValue(n){this.n(n)&&(0,D.removeFromValueTree)(this.contents,n)}m(n){let r=this.keys.length;for(let o=0;o<r;o++)n.indexOf(this.keys[o])===0&&(r=o);this.keys.splice(r,1,n)}n(n){const r=this.keys.indexOf(n);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=w;class m{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new w}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,r){if(!E.isUndefinedOrNull(n)){const o=this.g(n);this.parseRaw(o,r)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,r){this.a=n;const{contents:o,keys:a,overrides:l,restricted:s,hasExcludedProperties:u}=this.h(n,r);this.b=new w(o,a,l,u?[n]:void 0),this.c=s||[]}g(n){let r={},o=null,a=[];const l=[],s=[];function u(F){Array.isArray(a)?a.push(F):o!==null&&(a[o]=F)}const P={onObjectBegin:()=>{const F={};u(F),l.push(a),a=F,o=null},onObjectProperty:F=>{o=F},onObjectEnd:()=>{a=l.pop()},onArrayBegin:()=>{const F=[];u(F),l.push(a),a=F,o=null},onArrayEnd:()=>{a=l.pop()},onLiteralValue:u,onError:(F,K,ne)=>{s.push({error:F,offset:K,length:ne})}};if(n)try{k.visit(n,P),r=a[0]||{}}catch(F){console.error(`Error while parsing settings file ${this.f}: ${F}`),this.d=[F]}return r}h(n,r){const o=C.Registry.as(T.Extensions.Configuration).getConfigurationProperties(),a=this.j(n,o,!0,r);n=a.raw;const l=(0,D.toValuesTree)(n,P=>console.error(`Conflict in settings file ${this.f}: ${P}`)),s=Object.keys(n),u=this.l(n,P=>console.error(`Conflict in settings file ${this.f}: ${P}`));return{contents:l,keys:s,overrides:u,restricted:a.restricted,hasExcludedProperties:a.hasExcludedProperties}}j(n,r,o,a){let l=!1;if(!a?.scopes&&!a?.skipRestricted)return{raw:n,restricted:[],hasExcludedProperties:l};const s={},u=[];for(const P in n)if(T.OVERRIDE_PROPERTY_REGEX.test(P)&&o){const F=this.j(n[P],r,!1,a);s[P]=F.raw,l=l||F.hasExcludedProperties,u.push(...F.restricted)}else{const F=r[P],K=F?typeof F.scope<"u"?F.scope:3:void 0;F?.restricted&&u.push(P),(K===void 0||a.scopes===void 0||a.scopes.includes(K))&&!(a.skipRestricted&&F?.restricted)?s[P]=n[P]:l=!0}return{raw:s,restricted:u,hasExcludedProperties:l}}l(n,r){const o=[];for(const a of Object.keys(n))if(T.OVERRIDE_PROPERTY_REGEX.test(a)){const l={};for(const s in n[a])l[s]=n[a][s];o.push({identifiers:(0,T.overrideIdentifiersFromKey)(a),keys:Object.keys(l),contents:(0,D.toValuesTree)(l,r)})}return o}}e.ConfigurationModelParser=m;class g extends S.Disposable{constructor(n,r,o,a){super(),this.f=n,this.g=r,this.h=a,this.c=this.B(new t.Emitter),this.onDidChange=this.c.event,this.a=new m(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(o.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(t.Event.any(t.Event.filter(this.h.onDidFilesChange,l=>l.contains(this.f)),t.Event.filter(this.h.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&o.isEqual(l.resource,n)))(()=>this.c.fire()))}async loadConfiguration(){try{const n=await this.h.readFile(this.f);return this.a.parse(n.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new w}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=g;class p{constructor(n,r,o,a,l,s,u,P,F,K,ne,ue,se){this.a=n,this.b=r,this.value=o,this.overrideIdentifiers=a,this.c=l,this.d=s,this.f=u,this.g=P,this.h=F,this.j=K,this.k=ne,this.l=ue,this.m=se}get p(){return this.n||(this.n=this.c.inspect(this.a,this.b.overrideIdentifier)),this.n}get defaultValue(){return this.p.merged}get default(){return this.p.value!==void 0||this.p.override!==void 0?{value:this.p.value,override:this.p.override}:void 0}get r(){return this.q===void 0&&(this.q=this.d?this.d.inspect(this.a):null),this.q}get policyValue(){return this.r?.merged}get policy(){return this.r?.value!==void 0?{value:this.r.value}:void 0}get t(){return this.s===void 0&&(this.s=this.f?this.f.inspect(this.a):null),this.s}get applicationValue(){return this.t?.merged}get application(){return this.t?.value!==void 0||this.t?.override!==void 0?{value:this.t.value,override:this.t.override}:void 0}get v(){return this.u||(this.u=this.g.inspect(this.a,this.b.overrideIdentifier)),this.u}get userValue(){return this.v.merged}get user(){return this.v.value!==void 0||this.v.override!==void 0?{value:this.v.value,override:this.v.override}:void 0}get x(){return this.w||(this.w=this.h.inspect(this.a,this.b.overrideIdentifier)),this.w}get userLocalValue(){return this.x.merged}get userLocal(){return this.x.value!==void 0||this.x.override!==void 0?{value:this.x.value,override:this.x.override}:void 0}get z(){return this.y||(this.y=this.j.inspect(this.a,this.b.overrideIdentifier)),this.y}get userRemoteValue(){return this.z.merged}get userRemote(){return this.z.value!==void 0||this.z.override!==void 0?{value:this.z.value,override:this.z.override}:void 0}get B(){return this.A===void 0&&(this.A=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.A}get workspaceValue(){return this.B?.merged}get workspace(){return this.B?.value!==void 0||this.B?.override!==void 0?{value:this.B.value,override:this.B.override}:void 0}get E(){return this.D===void 0&&(this.D=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.D}get workspaceFolderValue(){return this.E?.merged}get workspaceFolder(){return this.E?.value!==void 0||this.E?.override!==void 0?{value:this.E.value,override:this.E.override}:void 0}get memoryValue(){return this.m.merged}get memory(){return this.m.value!==void 0||this.m.override!==void 0?{value:this.m.value,override:this.m.override}:void 0}}class d{constructor(n,r,o,a,l=new w,s=new w,u=new I.ResourceMap,P=new w,F=new I.ResourceMap,K=!0){this.c=n,this.d=r,this.f=o,this.g=a,this.h=l,this.j=s,this.l=u,this.m=P,this.n=F,this.p=K,this.a=null,this.b=new I.ResourceMap,this.q=null}getValue(n,r,o){return this.s(n,r,o).getValue(n)}updateValue(n,r,o={}){let a;o.resource?(a=this.n.get(o.resource),a||(a=new w,this.n.set(o.resource,a))):a=this.m,r===void 0?a.removeValue(n):a.setValue(n,r),o.resource||(this.a=null)}inspect(n,r,o){const a=this.s(n,r,o),l=b.distinct(a.overrides.map(P=>P.identifiers).flat()).filter(P=>a.getOverrideValue(n,P)!==void 0),s=this.w(r.resource,o),u=r.resource?this.n.get(r.resource)||this.m:this.m;return new p(n,r,a.getValue(n),l.length?l:void 0,this.c,this.d.isEmpty()?void 0:this.d.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),o?this.j.freeze():void 0,s?s.freeze():void 0,u.inspect(n,r.overrideIdentifier))}keys(n){const r=this.w(void 0,n);return{default:this.c.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this.j.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.q=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.q=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.j=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,r){this.l.set(n,r),this.b.delete(n)}deleteFolderConfiguration(n){this.r.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,r){const o=[];if(!r){const{added:a,updated:l,removed:s}=h(this.c,n);r=[...a,...l,...s]}for(const a of r)for(const l of(0,T.overrideIdentifiersFromKey)(a)){const s=this.c.getKeysForOverrideIdentifier(l),u=n.getKeysForOverrideIdentifier(l),P=[...u.filter(F=>s.indexOf(F)===-1),...s.filter(F=>u.indexOf(F)===-1),...s.filter(F=>!A.equals(this.c.override(l).getValue(F),n.override(l).getValue(F)))];o.push([l,P])}return this.updateDefaultConfiguration(n),{keys:r,overrides:o}}compareAndUpdatePolicyConfiguration(n){const{added:r,updated:o,removed:a}=h(this.d,n),l=[...r,...o,...a];return l.length&&this.updatePolicyConfiguration(n),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:r,updated:o,removed:a,overrides:l}=h(this.applicationConfiguration,n),s=[...r,...o,...a];return s.length&&this.updateApplicationConfiguration(n),{keys:s,overrides:l}}compareAndUpdateLocalUserConfiguration(n){const{added:r,updated:o,removed:a,overrides:l}=h(this.localUserConfiguration,n),s=[...r,...o,...a];return s.length&&this.updateLocalUserConfiguration(n),{keys:s,overrides:l}}compareAndUpdateRemoteUserConfiguration(n){const{added:r,updated:o,removed:a,overrides:l}=h(this.remoteUserConfiguration,n),s=[...r,...o,...a];return s.length&&this.updateRemoteUserConfiguration(n),{keys:s,overrides:l}}compareAndUpdateWorkspaceConfiguration(n){const{added:r,updated:o,removed:a,overrides:l}=h(this.workspaceConfiguration,n),s=[...r,...o,...a];return s.length&&this.updateWorkspaceConfiguration(n),{keys:s,overrides:l}}compareAndUpdateFolderConfiguration(n,r){const o=this.r.get(n),{added:a,updated:l,removed:s,overrides:u}=h(o,r),P=[...a,...l,...s];return(P.length||!o)&&this.updateFolderConfiguration(n,r),{keys:P,overrides:u}}compareAndDeleteFolderConfiguration(n){const r=this.r.get(n);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:o,updated:a,removed:l,overrides:s}=h(r,void 0);return{keys:[...o,...a,...l],overrides:s}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.q||(this.q=this.h.isEmpty()?this.g:this.g.merge(this.h),this.p&&this.q.freeze()),this.q}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.j}get r(){return this.l}s(n,r,o){let a=this.t(r,o);return r.overrideIdentifier&&(a=a.override(r.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(a=a.merge(this.d)),a}t({resource:n},r){let o=this.u();if(r&&n){const a=r.getFolder(n);a&&(o=this.v(a.uri)||o);const l=this.n.get(n);l&&(o=o.merge(l))}return o}u(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.j,this.m),this.p&&(this.j=this.j.freeze())),this.a}v(n){let r=this.b.get(n);if(!r){const o=this.u(),a=this.l.get(n);a?(r=o.merge(a),this.p&&(r=r.freeze()),this.b.set(n,r)):r=o}return r}w(n,r){if(r&&n){const o=r.getFolder(n);if(o)return this.l.get(o.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},folders:[...this.l.keys()].reduce((n,r)=>{const{contents:o,overrides:a,keys:l}=this.l.get(r);return n.push([r,{contents:o,overrides:a,keys:l}]),n},[])}}allKeys(){const n=new Set;return this.c.freeze().keys.forEach(r=>n.add(r)),this.userConfiguration.freeze().keys.forEach(r=>n.add(r)),this.j.freeze().keys.forEach(r=>n.add(r)),this.l.forEach(r=>r.freeze().keys.forEach(o=>n.add(o))),[...n.values()]}x(){const n=new Set;return this.c.freeze().getAllOverrideIdentifiers().forEach(r=>n.add(r)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(r=>n.add(r)),this.j.freeze().getAllOverrideIdentifiers().forEach(r=>n.add(r)),this.l.forEach(r=>r.freeze().getAllOverrideIdentifiers().forEach(o=>n.add(o))),[...n.values()]}y(n){const r=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(o=>r.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(o=>r.add(o)),this.j.getKeysForOverrideIdentifier(n).forEach(o=>r.add(o)),this.l.forEach(o=>o.getKeysForOverrideIdentifier(n).forEach(a=>r.add(a))),[...r.values()]}static parse(n){const r=this.z(n.defaults),o=this.z(n.policy),a=this.z(n.application),l=this.z(n.user),s=this.z(n.workspace),u=n.folders.reduce((P,F)=>(P.set(y.URI.revive(F[0]),this.z(F[1])),P),new I.ResourceMap);return new d(r,o,a,l,new w,s,u,new w,new I.ResourceMap,!1)}static z(n){return new w(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=d;function v(...i){if(i.length===0)return{keys:[],overrides:[]};if(i.length===1)return i[0];const n=new Set,r=new Map;for(const a of i)a.keys.forEach(l=>n.add(l)),a.overrides.forEach(([l,s])=>{const u=(0,I.getOrSet)(r,l,new Set);s.forEach(P=>u.add(P))});const o=[];return r.forEach((a,l)=>o.push([l,[...a.values()]])),{keys:[...n.values()],overrides:o}}e.mergeChanges=v;class c{constructor(n,r,o,a){this.change=n,this.b=r,this.c=o,this.d=a,this.f=void 0;const l=new Set;n.keys.forEach(u=>l.add(u)),n.overrides.forEach(([,u])=>u.forEach(P=>l.add(P))),this.affectedKeys=[...l.values()];const s=new w;this.affectedKeys.forEach(u=>s.setValue(u,{})),this.a=s.contents}get previousConfiguration(){return!this.f&&this.b&&(this.f=d.parse(this.b.data)),this.f}affectsConfiguration(n,r){if(this.g(this.a,n)){if(r){const o=this.previousConfiguration?this.previousConfiguration.getValue(n,r,this.b?.workspace):void 0,a=this.c.getValue(n,r,this.d);return!A.equals(o,a)}return!0}return!1}g(n,r){let o=(0,D.toValuesTree)({[r]:!0},()=>{}),a;for(;typeof o=="object"&&(a=Object.keys(o)[0]);){if(n=n[a],!n)return!1;o=o[a]}return!0}}e.ConfigurationChangeEvent=c;function h(i,n){const{added:r,removed:o,updated:a}=f(n?.rawConfiguration,i?.rawConfiguration),l=[],s=i?.getAllOverrideIdentifiers()||[],u=n?.getAllOverrideIdentifiers()||[];if(n){const P=u.filter(F=>!s.includes(F));for(const F of P)l.push([F,n.getKeysForOverrideIdentifier(F)])}if(i){const P=s.filter(F=>!u.includes(F));for(const F of P)l.push([F,i.getKeysForOverrideIdentifier(F)])}if(n&&i){for(const P of s)if(u.includes(P)){const F=f({contents:i.getOverrideValue(void 0,P)||{},keys:i.getKeysForOverrideIdentifier(P)},{contents:n.getOverrideValue(void 0,P)||{},keys:n.getKeysForOverrideIdentifier(P)});l.push([P,[...F.added,...F.removed,...F.updated]])}}return{added:r,removed:o,updated:a,overrides:l}}function f(i,n){const r=i?n?i.keys.filter(l=>n.keys.indexOf(l)===-1):[...i.keys]:[],o=n?i?n.keys.filter(l=>i.keys.indexOf(l)===-1):[...n.keys]:[],a=[];if(i&&n){for(const l of n.keys)if(i.keys.indexOf(l)!==-1){const s=(0,D.getConfigurationValue)(n.contents,l),u=(0,D.getConfigurationValue)(i.contents,l);A.equals(s,u)||a.push(l)}}return{added:r,removed:o,updated:a}}}),define(ve[217],be([1,0,18,6,2,23,11,24,106,51,12,64,35]),function(ie,e,b,t,k,S,I,A,E,y,D,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class w extends k.Disposable{constructor(){super(...arguments),this.a=this.B(new t.Emitter),this.onDidChangeConfiguration=this.a.event}get configurationModel(){return this.b||(this.b=new m(this.f())),this.b}async initialize(){return this.b=void 0,this.B(C.Registry.as(y.Extensions.Configuration).onDidUpdateConfiguration(({properties:v,defaultsOverrides:c})=>this.c(v,c))),this.configurationModel}reload(){return this.b=void 0,this.configurationModel}c(v,c){this.b=void 0,this.a.fire({defaults:this.configurationModel,properties:v})}f(){return{}}}e.DefaultConfiguration=w;class m extends E.ConfigurationModel{constructor(v={}){const c=C.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),h=Object.keys(c),f=Object.create(null),i=[];for(const n in c){const r=v[n],o=r!==void 0?r:c[n].default;(0,A.addToValueTree)(f,n,o,a=>console.error(`Conflict in default settings: ${a}`))}for(const n of Object.keys(f))y.OVERRIDE_PROPERTY_REGEX.test(n)&&i.push({identifiers:(0,y.overrideIdentifiersFromKey)(n),keys:Object.keys(f[n]),contents:(0,A.toValuesTree)(f[n],r=>console.error(`Conflict in default settings file: ${r}`))});super(f,h,i)}}e.DefaultConfigurationModel=m;class g{constructor(){this.onDidChangeConfiguration=t.Event.None,this.configurationModel=new E.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=g;let p=class extends k.Disposable{get configurationModel(){return this.b}constructor(v,c,h){super(),this.c=v,this.f=c,this.g=h,this.a=this.B(new t.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new E.ConfigurationModel}async initialize(){return this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(v=>this.i(v))),this.B(this.c.onDidChangeConfiguration(async({properties:v})=>this.j(await this.h(v),!0))),this.b}async h(v){const c={},h=[],f=C.Registry.as(y.Extensions.Configuration).getConfigurationProperties();for(const i of v){const n=f[i];if(!n){h.push(i);continue}if(n.policy){if(n.type!=="string"&&n.type!=="number"){this.g.warn(`Policy ${n.policy.name} has unsupported type ${n.type}`);continue}h.push(i),c[n.policy.name]={type:n.type}}}return(0,I.isEmptyObject)(c)||await this.f.updatePolicyDefinitions(c),h}i(v){const c=C.Registry.as(y.Extensions.Configuration).getPolicyConfigurations(),h=(0,b.coalesce)(v.map(f=>c.get(f)));this.j(h,!0)}j(v,c){const h=C.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),f=[],i=this.b.isEmpty();for(const n of v){const r=h[n]?.policy?.name;if(r){const o=this.f.getPolicyValue(r);(i?o!==void 0:!(0,S.equals)(this.b.getValue(n),o))&&f.push([n,o])}else this.b.getValue(n)!==void 0&&f.push([n,void 0])}if(f.length){const n=this.b;this.b=new E.ConfigurationModel;for(const r of n.keys)this.b.setValue(r,n.getValue(r));for(const[r,o]of f)o===void 0?this.b.removeValue(r):this.b.setValue(r,o);c&&this.a.fire(this.b)}}};p=Le([Oe(1,T.IPolicyService),Oe(2,D.ILogService)],p),e.PolicyConfiguration=p}),define(ve[107],be([1,0,14,6,2,20,24,106,217,64]),function(ie,e,b,t,k,S,I,A,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class D extends k.Disposable{constructor(C,w,m,g){super(),this.i=C,this.h=this.B(new t.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new E.DefaultConfiguration),this.c=m instanceof y.NullPolicyService?new E.NullPolicyConfiguration:this.B(new E.PolicyConfiguration(this.b,m,g)),this.f=this.B(new A.UserSettings(this.i,void 0,S.extUriBiasedIgnorePathCase,w)),this.a=new A.Configuration(this.b.configurationModel,this.c.configurationModel,new A.ConfigurationModel,new A.ConfigurationModel),this.g=this.B(new b.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:p,properties:d})=>this.k(p,d))),this.B(this.c.onDidChangeConfiguration(p=>this.l(p))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[C,w,m]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new A.Configuration(C,w,new A.ConfigurationModel,m)}getConfigurationData(){return this.a.toData()}getValue(C,w){const m=typeof C=="string"?C:void 0,g=(0,I.isConfigurationOverrides)(C)?C:(0,I.isConfigurationOverrides)(w)?w:{};return this.a.getValue(m,g,void 0)}updateValue(C,w,m,g){return Promise.reject(new Error("not supported"))}inspect(C){return this.a.inspect(C,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const C=await this.f.loadConfiguration();this.j(C)}j(C){const w=this.a.toData(),m=this.a.compareAndUpdateLocalUserConfiguration(C);this.m(m,w,2)}k(C,w){const m=this.a.toData(),g=this.a.compareAndUpdateDefaultConfiguration(C,w);this.m(g,m,7)}l(C){const w=this.a.toData(),m=this.a.compareAndUpdatePolicyConfiguration(C);this.m(m,w,7)}m(C,w,m){const g=new A.ConfigurationChangeEvent(C,{data:w},this.a);g.source=m,g.sourceConfig=this.n(m),this.h.fire(g)}n(C){switch(C){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=D}),define(ve[108],be([1,0,8,5]),function(ie,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var k;(function(I){I.Unknown="Unknown",I.NotAvailable="NotAvailable",I.TemporarilyNotAvailable="TemporarilyNotAvailable",I.NoResolverFound="NoResolverFound"})(k=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class S extends b.ErrorNoTelemetry{static isNotAvailable(A){return A instanceof S&&A._code===k.NotAvailable}static isTemporarilyNotAvailable(A){return A instanceof S&&A._code===k.TemporarilyNotAvailable}static isNoResolverFound(A){return A instanceof S&&A._code===k.NoResolverFound}static isHandled(A){return A instanceof S&&A.isHandled}constructor(A,E=k.Unknown,y){super(A),this._message=A,this._code=E,this._detail=y,this.isHandled=E===k.NotAvailable&&y===!0,Object.setPrototypeOf(this,S.prototype)}}e.RemoteAuthorityResolverError=S}),define(ve[65],be([1,0,13]),function(ie,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(y){return y.scheme===b.Schemas.vscodeRemote?y.authority:void 0}e.getRemoteAuthority=t;function k(y){if(!y)return;const D=y.indexOf("+");return D<0?y:y.substr(0,D)}e.getRemoteName=k;function S(y){return`/${y.quality??"oss"}-${y.commit??"dev"}`}e.getRemoteServerRootPath=S;function I(y){const{host:D,port:T}=E(y);if(typeof T>"u")throw new Error("Remote authority doesn't contain a port!");return{host:D,port:T}}e.parseAuthorityWithPort=I;function A(y,D){let{host:T,port:C}=E(y);return typeof C>"u"&&(C=D),{host:T,port:C}}e.parseAuthorityWithOptionalPort=A;function E(y){const D=y.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(D)return{host:D[1],port:parseInt(D[2],10)};const T=y.match(/^(\[[0-9a-z:]+\])$/);if(T)return{host:T[1],port:void 0};const C=y.match(/(.*):(\d+)$/);return C?{host:C[1],port:parseInt(C[2],10)}:{host:y,port:void 0}}}),define(ve[32],be([1,0,15,5,65]),function(ie,e,b,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function S(m){if(typeof m=="object"&&m!==null&&m.supported!==!0)return m.description}e.getWorkspaceSupportTypeMessage=S;function I(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}e.isIExtensionIdentifier=I,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(m){m[m.System=0]="System",m[m.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));var E;(function(m){m.WIN32_X64="win32-x64",m.WIN32_IA32="win32-ia32",m.WIN32_ARM64="win32-arm64",m.LINUX_X64="linux-x64",m.LINUX_ARM64="linux-arm64",m.LINUX_ARMHF="linux-armhf",m.ALPINE_X64="alpine-x64",m.ALPINE_ARM64="alpine-arm64",m.DARWIN_X64="darwin-x64",m.DARWIN_ARM64="darwin-arm64",m.WEB="web",m.UNIVERSAL="universal",m.UNKNOWN="unknown",m.UNDEFINED="undefined"})(E=e.TargetPlatform||(e.TargetPlatform={}));class y{constructor(g){this.value=g,this.c=g.toLowerCase()}static equals(g,p){if(typeof g>"u"||g===null)return typeof p>"u"||p===null;if(typeof p>"u"||p===null)return!1;if(typeof g=="string"||typeof p=="string"){const d=typeof g=="string"?g:g.value,v=typeof p=="string"?p:p.value;return b.equalsIgnoreCase(d,v)}return g.c===p.c}static toKey(g){return typeof g=="string"?g.toLowerCase():g.c}}e.ExtensionIdentifier=y;function D(m){return T(m)}e.isApplicationScopedExtension=D;function T(m){return m.contributes&&m.contributes.localizations?m.contributes.localizations.length>0:!1}e.isLanguagePackExtension=T;function C(m){return m.contributes&&m.contributes.authentication?m.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=C;function w(m,g){if(g){const p=`onResolveRemoteAuthority:${(0,k.getRemoteName)(g)}`;return m.activationEvents?.indexOf(p)!==-1}return!1}e.isResolverExtension=w,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(ve[33],be([1,0,15,31,32,3,4,8,27]),function(ie,e,b,t,k,S,I,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function y(n,r){return n.uuid&&r.uuid?n.uuid===r.uuid:n.id===r.id?!0:(0,b.compareIgnoreCase)(n.id,r.id)===0}e.areSameExtensions=y;const D=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class T{static create(r){const o=r.manifest?r.manifest.version:r.version,a=r.manifest?r.targetPlatform:r.properties.targetPlatform;return new T(r.identifier,o,a)}static parse(r){const o=D.exec(r);return o&&o[1]&&o[2]?new T({id:o[1]},o[2],o[4]||void 0):null}constructor(r,o,a="undefined"){this.version=o,this.targetPlatform=a,this.id=r.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(r){return r instanceof T?y(this,r)&&this.version===r.version&&this.targetPlatform===r.targetPlatform:!1}}e.ExtensionKey=T;const C=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function w(n){const r=C.exec(n);return r&&r[1]?[g(r[1]),r[2]]:[g(n),void 0]}e.getIdAndVersion=w;function m(n,r){return`${n}.${r}`}e.getExtensionId=m;function g(n){return n.toLocaleLowerCase()}e.adoptToGalleryExtensionId=g;function p(n,r){return g(m(n,r))}e.getGalleryExtensionId=p;function d(n,r){const o=[],a=l=>{for(const s of o)if(s.some(u=>y(r(u),r(l))))return s;return null};for(const l of n){const s=a(l);s?s.push(l):o.push([l])}return o}e.groupByExtension=d;function v(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=v;function c(n){return{id:n.identifier.id,name:n.name,galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.getGalleryExtensionTelemetryData=c,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function h(n,r){const o=[],a=r.manifest.extensionDependencies?.slice(0)??[];for(;a.length;){const l=a.shift();if(l&&o.every(s=>!y(s.identifier,{id:l}))){const s=n.filter(u=>y(u.identifier,{id:l}));s.length===1&&(o.push(s[0]),a.push(...s[0].manifest.extensionDependencies?.slice(0)??[]))}}return o}e.getExtensionDependencies=h;async function f(n,r){if(!S.isLinux)return!1;let o;try{o=(await n.readFile(I.URI.file("/etc/os-release"))).value.toString()}catch{try{o=(await n.readFile(I.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){r.debug("Error while getting the os-release file.",(0,A.getErrorMessage)(l))}}return!!o&&(o.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=f;async function i(n,r){const o=await f(n,r),a=(0,t.getTargetPlatform)(o?"alpine":S.platform,E.arch);return r.debug("ComputeTargetPlatform:",a),a}e.computeTargetPlatform=i}),define(ve[109],be([1,0,19,8,13,20,49,4,166,31,33,32]),function(ie,e,b,t,k,S,I,A,E,y,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLI=void 0;const C=p=>(0,E.localize)(0,null,p),w=(0,E.localize)(1,null,"ms-dotnettools.csharp");function m(p,d){return d?`${p.publisher}.${p.name}@${p.version}`:`${p.publisher}.${p.name}`}let g=class{constructor(d,v){this.a=d,this.b=v}get d(){}async listExtensions(d,v,c,h=console){let f=await this.a.getInstalled(1,c);const i=T.EXTENSION_CATEGORIES.map(r=>r.toLowerCase());if(v&&v!==""){if(i.indexOf(v.toLowerCase())<0){h.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}f=f.filter(r=>r.manifest.categories?r.manifest.categories.map(a=>a.toLowerCase()).indexOf(v.toLowerCase())>-1:!1)}else if(v===""){h.log("Possible Categories: "),i.forEach(r=>{h.log(r)});return}this.d&&h.log((0,E.localize)(2,null,this.d)),f=f.sort((r,o)=>r.identifier.id.localeCompare(o.identifier.id));let n;for(const r of f)n!==r.identifier.id&&(n=r.identifier.id,h.log(m(r.manifest,d)))}async installExtensions(d,v,c,h,f=console){const i=[],n=[];d.length&&f.log(this.d?(0,E.localize)(3,null,this.d):(0,E.localize)(4,null));const r=await this.a.getInstalled(1,c.profileLocation),o=(u,P)=>{const F=r.find(K=>(0,D.areSameExtensions)(K.identifier,{id:u}));if(F){if(!h&&(!P||P==="prerelease"&&F.preRelease))return f.log((0,E.localize)(5,null,u,F.manifest.version,u)),!1;if(P&&F.manifest.version===P)return f.log((0,E.localize)(6,null,`${u}@${P}`)),!1}return!0},a=(u,P,F)=>{s.push({id:u,version:P!=="prerelease"?P:void 0,installOptions:{...c,isBuiltin:F,installPreReleaseVersion:P==="prerelease"||c.installPreReleaseVersion}})},l=[],s=[];for(const u of d)if(u instanceof A.URI)l.push(u);else{const[P,F]=(0,D.getIdAndVersion)(u);o(P,F)&&a(P,F,!1)}for(const u of v){const[P,F]=(0,D.getIdAndVersion)(u);o(P,F)&&a(P,F,!0)}if(l.length&&await Promise.all(l.map(async u=>{try{const P=await this.f(u,{...c,isBuiltin:!1},h,f);P&&n.push(P)}catch(P){f.error(P.message||P.stack||P),i.push(u.toString())}})),s.length){const u=await this.g(s);await Promise.all(s.map(async P=>{const F=u.get(P.id.toLowerCase());if(F)try{const K=await this.h(P,F,r,h,f);K&&n.push(K)}catch(K){f.error(K.message||K.stack||K),i.push(P.id)}else f.error(`${C(P.version?`${P.id}@${P.version}`:P.id)}
${w}`),i.push(P.id)}))}if(i.length)throw new Error((0,E.localize)(7,null,i.join(", ")))}async f(d,v,c,h){const f=await this.a.getManifest(d);if(!f)throw new Error("Invalid vsix");if(await this.k(f,c,v.profileLocation,h))try{return await this.a.install(d,v),h.log((0,E.localize)(8,null,(0,S.basename)(d))),f}catch(n){if((0,t.isCancellationError)(n))return h.log((0,E.localize)(9,null,(0,S.basename)(d))),null;throw n}return null}async g(d){const v=new Map,c=d.some(f=>f.installOptions.installPreReleaseVersion),h=await this.b.getExtensions(d.map(f=>({...f,preRelease:c})),b.CancellationToken.None);for(const f of h)v.set(f.identifier.id.toLowerCase(),f);return v}async h({id:d,version:v,installOptions:c},h,f,i,n){const r=await this.b.getManifest(h,b.CancellationToken.None);if(r&&!this.j(r,n))return null;const o=f.find(a=>(0,D.areSameExtensions)(a.identifier,h.identifier));if(o){if(h.version===o.manifest.version)return n.log((0,E.localize)(10,null,v?`${d}@${v}`:d)),null;n.log((0,E.localize)(11,null,d,h.version))}try{c.isBuiltin?n.log(v?(0,E.localize)(12,null,d,v):(0,E.localize)(13,null,d)):n.log(v?(0,E.localize)(14,null,d,v):(0,E.localize)(15,null,d));const a=await this.a.installFromGallery(h,{...c,installGivenVersion:!!v});return n.log((0,E.localize)(16,null,d,a.manifest.version)),r}catch(a){if((0,t.isCancellationError)(a))return n.log((0,E.localize)(17,null,d)),null;throw a}}j(d,v){return!0}async k(d,v,c,h){const f={id:(0,D.getGalleryExtensionId)(d.publisher,d.name)},n=(await this.a.getInstalled(1,c)).find(r=>(0,D.areSameExtensions)(f,r.identifier)&&(0,I.gt)(r.manifest.version,d.version));return n&&!v?(h.log((0,E.localize)(18,null,n.identifier.id,n.manifest.version,d.version)),!1):this.j(d,h)}async uninstallExtensions(d,v,c,h=console){const f=async n=>{if(n instanceof A.URI){const r=await this.a.getManifest(n);return m(r)}return n},i=[];for(const n of d){const r=await f(n),a=(await this.a.getInstalled(void 0,c)).filter(l=>(0,D.areSameExtensions)(l.identifier,{id:r}));if(!a.length)throw new Error(`${this.l(r)}
${w}`);if(a.some(l=>l.type===0)){h.log((0,E.localize)(19,null,r));return}if(!v&&a.some(l=>l.isBuiltin)){h.log((0,E.localize)(20,null,r));return}h.log((0,E.localize)(21,null,r));for(const l of a)await this.a.uninstall(l,{profileLocation:c}),i.push(l);this.d?h.log((0,E.localize)(22,null,r,this.d)):h.log((0,E.localize)(23,null,r))}}async locateExtension(d,v=console){const c=await this.a.getInstalled();d.forEach(h=>{c.forEach(f=>{if(f.identifier.id===h&&f.location.scheme===k.Schemas.file){v.log(f.location.fsPath);return}})})}l(d){return this.d?(0,E.localize)(24,null,d,this.d):(0,E.localize)(25,null,d)}};g=Le([Oe(0,y.IExtensionManagementService),Oe(1,y.IExtensionGalleryService)],g),e.ExtensionManagementCLI=g}),define(ve[218],be([1,0,14,8,2,13,3,20,49,11,22,21,24,28,31,33,76,17,12,25]),function(ie,e,b,t,k,S,I,A,E,y,D,T,C,w,m,g,p,d,v,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let h=class Cn extends k.Disposable{constructor(i,n,r,o,a,l,s,u){super(),this.h=i,this.i=r,this.j=o,this.k=a,this.l=l,this.m=s,this.n=u,this.extensionsDownloadDir=n.extensionsDownloadLocation,this.f=20,this.g=this.w()}async download(i,n){await this.g;const r=(0,A.joinPath)(this.extensionsDownloadDir,this.y(i));try{await this.u(i,r,a=>this.j.download(i,a,n))}catch(a){throw new m.ExtensionManagementError(a.message,m.ExtensionManagementErrorCode.Download)}let o=!1;if(await this.r(i)){const a=await this.t(i);try{o=await this.m.verify(r.fsPath,a.fsPath),this.n.info(`Verified extension: ${i.identifier.id}`,o)}catch(l){throw await this.delete(a),await this.delete(r),new m.ExtensionManagementError(l.code,m.ExtensionManagementErrorCode.Signature)}}return{location:r,verified:o}}async r(i){if(!i.isSigned||await this.h==="linux-armhf")return!1;const r=this.k.getValue("extensions.verifySignature");return(0,y.isBoolean)(r)?r:this.l.quality!=="stable"}async t(i){await this.g;const n=(0,A.joinPath)(this.extensionsDownloadDir,`${this.y(i)}${Cn.c}`);return await this.u(i,n,r=>this.j.downloadSignatureArchive(i,r)),n}async u(i,n,r){if(await this.i.exists(n))return;if(n.scheme!==S.Schemas.file){await r(n);return}const o=(0,A.joinPath)(this.extensionsDownloadDir,`.${(0,D.generateUuid)()}`);await this.i.exists(o)||await r(o);try{await this.v(o,n,Date.now()+2*60*1e3)}catch(a){try{await this.i.del(o)}catch{}if(a.code==="ENOTEMPTY")this.n.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",i.identifier.id,n.path);else throw this.n.info(`Rename failed because of ${(0,t.getErrorMessage)(a)}. Deleted the file from downloaded location`,o.path),a}}async delete(i){await this.g,await this.i.del(i)}async v(i,n,r){try{await T.Promises.rename(i.fsPath,n.fsPath)}catch(o){if(I.isWindows&&o&&o.code==="EPERM"&&Date.now()<r)return this.n.info(`Failed renaming ${i} to ${n} with 'EPERM' error. Trying again...`),this.v(i,n,r);throw o}}async w(){try{if(!await this.i.exists(this.extensionsDownloadDir)){this.n.trace("Extension VSIX downloads cache dir does not exist");return}const i=await this.i.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(i.children){const n=[],r=[],o=[];for(const s of i.children)if(s.name.endsWith(Cn.c))o.push(s.resource);else{const u=g.ExtensionKey.parse(s.name);u&&r.push([u,s])}const a=(0,g.groupByExtension)(r,([s])=>s),l=[];for(const s of a)s.sort((u,P)=>E.rcompare(u[0].version,P[0].version)),n.push(...s.slice(1).map(u=>u[1].resource)),l.push(s[0][1]);l.sort((s,u)=>s.mtime-u.mtime),n.push(...l.slice(0,Math.max(0,l.length-this.f)).map(s=>s.resource)),n.push(...o),await b.Promises.settled(n.map(s=>(this.n.trace("Deleting from cache",s.path),this.i.del(s))))}}catch(i){this.n.error(i)}}y(i){return this.f?g.ExtensionKey.create(i).toString().toLowerCase():(0,D.generateUuid)()}};h.c=".sigzip",h=Le([Oe(1,w.INativeEnvironmentService),Oe(2,d.IFileService),Oe(3,m.IExtensionGalleryService),Oe(4,C.IConfigurationService),Oe(5,c.IProductService),Oe(6,p.IExtensionSignatureVerificationService),Oe(7,v.ILogService)],h),e.ExtensionsDownloader=h}),define(ve[219],be([1,0,2,7,21,32]),function(ie,e,b,t,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class I extends b.Disposable{constructor(E,y){super(),this.b=E,this.a=(0,t.join)(this.b.userDataPath,S.MANIFEST_CACHE_FOLDER,S.USER_MANIFEST_CACHE_FILE),this.B(y.onDidInstallExtensions(D=>this.c(D))),this.B(y.onDidUninstallExtension(D=>this.f(D)))}c(E){E.some(y=>!!y.local)&&this.invalidate()}f(E){E.error||this.invalidate()}invalidate(){k.Promises.rm(this.a,k.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=I}),define(ve[220],be([1,0,6,2,26,33,32]),function(ie,e,b,t,k,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class A extends t.Disposable{constructor(y,D,T,C,w,m,g){super(),this.f=y,this.g=D,this.h=T,this.i=C,this.j=w,this.k=m,this.l=g,this.a=this.B(new b.Emitter),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new t.DisposableMap),this.m().then(null,p=>g.error(p))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles,[]),this.n(),await this.C()}n(){this.B(this.h.onDidChangeProfiles(y=>this.p(y.added,y.removed))),this.B(this.i.onAddExtensions(y=>this.r(y))),this.B(this.i.onDidAddExtensions(y=>this.s(y))),this.B(this.i.onRemoveExtensions(y=>this.t(y))),this.B(this.i.onDidRemoveExtensions(y=>this.u(y))),this.B(this.k.onDidFilesChange(y=>this.v(y)))}async p(y,D){try{await Promise.all(D.map(T=>(this.c.deleteAndDispose(T.id),this.z(T.extensionsResource)))),y.length&&await Promise.all(y.map(T=>(this.c.set(T.id,(0,t.combinedDisposable)(this.k.watch(this.j.extUri.dirname(T.extensionsResource)),this.k.watch(T.extensionsResource))),this.y(T.extensionsResource))))}catch(T){throw this.l.error(T),T}}async r(y){for(const D of y.extensions)this.D(this.G(D.identifier,D.version),y.profileLocation)}async s(y){for(const D of y.extensions){const T=this.G(D.identifier,D.version);y.error?this.F(T,y.profileLocation):this.D(T,y.profileLocation)}}async t(y){for(const D of y.extensions)this.F(this.G(D.identifier,D.version),y.profileLocation)}async u(y){let D=!1;for(const T of y.extensions){const C=this.G(T.identifier,T.version);y.error?this.D(C,y.profileLocation):(this.F(C,y.profileLocation),D=D||!this.b.has(C))}D&&await this.C()}v(y){for(const D of this.h.profiles)y.contains(D.extensionsResource,0,1)&&this.w(D.extensionsResource)}async w(y){const D=[],T=[],C=await this.i.scanProfileExtensions(y),w=new Set,m=new Set;for(const[g,p]of this.b)p.has(y)&&m.add(g);for(const g of C){const p=this.G(g.identifier,g.version);w.add(p),m.has(p)||(D.push(g.identifier),this.D(p,y))}for(const g of m)if(!w.has(g)){const p=this.H(g);p&&(T.push(p.identifier),this.F(g,y))}(D.length||T.length)&&this.a.fire({added:D.length?{extensions:D,profileLocation:y}:void 0,removed:T.length?{extensions:T,profileLocation:y}:void 0})}async y(y){const D=await this.i.scanProfileExtensions(y);for(const T of D)this.D(this.G(T.identifier,T.version),y)}async z(y){for(const D of[...this.b.keys()])this.F(D,y);await this.C()}async C(){const D=(await this.f.getAllUserInstalled()).filter(T=>T.installedTimestamp&&!this.b.has(this.G(T.identifier,T.manifest.version)));D.length&&await this.f.markAsUninstalled(...D)}D(y,D){let T=this.b.get(y);T||this.b.set(y,T=new k.ResourceSet(C=>this.j.extUri.getComparisonKey(C))),T.add(D)}F(y,D){const T=this.b.get(y);T&&T.delete(D),T?.size||this.b.delete(y)}G(y,D){return`${I.ExtensionIdentifier.toKey(y.id)}@${D}`}H(y){const[D,T]=(0,S.getIdAndVersion)(y);return T?{identifier:{id:D},version:T}:void 0}}e.ExtensionsWatcher=A}),define(ve[110],be([1,0,111,18,14,2,13,7,21,28,31,33,12,78,3,4]),function(ie,e,b,t,k,S,I,A,E,y,D,T,C,w,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let p=class extends w.LanguagePackBaseService{constructor(h,f,i,n){super(i),this.h=h,this.i=n,this.g=this.B(new d(f,n)),this.h.registerParticipant({postInstall:async r=>this.j(r),postUninstall:async r=>this.k(r)})}async getBuiltInExtensionTranslationsUri(h){const i=(await this.g.getLanguagePacks())[m.Language.value()];if(!i){this.i.warn(`No language pack found for ${m.Language.value()}`);return}const n=i.translations[h];return n?g.URI.file(n):void 0}async getInstalledLanguages(){const h=await this.g.getLanguagePacks(),f=Object.keys(h).map(i=>{const n=h[i];return{...this.f(i,n.label),extensionId:n.extensions[0].extensionIdentifier.id}});return f.push({...this.f("en","English"),extensionId:"default"}),f.sort((i,n)=>i.label.localeCompare(n.label)),f}async j(h){h&&h.manifest&&h.manifest.contributes&&h.manifest.contributes.localizations&&h.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",h.identifier.id),await this.update())}async k(h){const f=await this.g.getLanguagePacks();Object.keys(f).some(i=>f[i]&&f[i].extensions.some(n=>(0,T.areSameExtensions)(n.extensionIdentifier,h.identifier)))&&(this.i.info("Removing language packs from the extension",h.identifier.id),await this.update())}async update(){const[h,f]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),i=await this.g.update(f);return!(0,t.equals)(Object.keys(h),Object.keys(i))}};p=Le([Oe(0,D.IExtensionManagementService),Oe(1,y.INativeEnvironmentService),Oe(2,D.IExtensionGalleryService),Oe(3,C.ILogService)],p),e.NativeLanguagePackService=p;let d=class extends S.Disposable{constructor(h,f){super(),this.i=f,this.c={},this.f=(0,A.join)(h.userDataPath,"languagepacks.json"),this.g=new k.Queue}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(h){return this.m(f=>{Object.keys(f).forEach(i=>delete f[i]),this.j(f,...h)}).then(()=>this.c)}j(h,...f){for(const i of f)i&&i.manifest&&i.manifest.contributes&&i.manifest.contributes.localizations&&i.manifest.contributes.localizations.length&&this.k(h,i);Object.keys(h).forEach(i=>this.l(h[i]))}k(h,f){const i=f.identifier,n=f.manifest.contributes&&f.manifest.contributes.localizations?f.manifest.contributes.localizations:[];for(const r of n)if(f.location.scheme===I.Schemas.file&&v(r)){let o=h[r.languageId];o||(o={hash:"",extensions:[],translations:{},label:r.localizedLanguageName??r.languageName},h[r.languageId]=o);const a=o.extensions.filter(l=>(0,T.areSameExtensions)(l.extensionIdentifier,i))[0];a?a.version=f.manifest.version:o.extensions.push({extensionIdentifier:i,version:f.manifest.version});for(const l of r.translations)o.translations[l.id]=(0,A.join)(f.location.fsPath,l.path)}}l(h){if(h){const f=(0,b.createHash)("md5");for(const i of h.extensions)f.update(i.extensionIdentifier.uuid||i.extensionIdentifier.id).update(i.version);h.hash=f.digest("hex")}}m(h=()=>null){return this.g.queue(()=>{let f=null;return E.Promises.readFile(this.f,"utf8").then(void 0,i=>i.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(i)).then(i=>{try{return JSON.parse(i)}catch{return{}}}).then(i=>(f=h(i),i)).then(i=>{for(const r of Object.keys(i))i[r]||delete i[r];this.c=i,this.h=!0;const n=JSON.stringify(this.c);return this.i.debug("Writing language packs",n),E.Promises.writeFile(this.f,n)}).then(()=>f,i=>this.i.error(i))})}};d=Le([Oe(0,y.INativeEnvironmentService),Oe(1,C.ILogService)],d);function v(c){if(typeof c.languageId!="string"||!Array.isArray(c.translations)||c.translations.length===0)return!1;for(const h of c.translations)if(typeof h.id!="string"||typeof h.path!="string")return!1;return!(c.languageName&&typeof c.languageName!="string"||c.localizedLanguageName&&typeof c.localizedLanguageName!="string")}}),define(ve[52],be([1,0,16,178,51,5,35]),function(ie,e,b,t,k,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,S.createDecorator)("requestService");function A(g){return g.res.statusCode&&g.res.statusCode>=200&&g.res.statusCode<300||g.res.statusCode===1223}e.isSuccess=A;function E(g){return g.res.statusCode===204}async function y(g){return E(g)?null:(await(0,b.streamToBuffer)(g.stream)).toString()}e.asText=y;async function D(g){if(!A(g))throw new Error("Server returned "+g.res.statusCode);return y(g)}e.asTextOrError=D;async function T(g){if(!A(g))throw new Error("Server returned "+g.res.statusCode);if(E(g))return null;const d=(await(0,b.streamToBuffer)(g.stream)).toString();try{return JSON.parse(d)}catch(v){throw v.message+=`:
`+d,v}}e.asJson=T;function C(g){m(g)}e.updateProxyConfigurationsScope=C;let w;function m(g){const p=I.Registry.as(k.Extensions.Configuration),d=w;w={id:"http",order:15,title:(0,t.localize)(0,null),type:"object",scope:g,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,t.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,t.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,t.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,t.localize)(4,null),(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],default:"override",description:(0,t.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,t.localize)(9,null),restricted:!0}}},p.updateConfigurations({add:[w],remove:d?[d]:[]})}m(2)}),define(ve[221],be([1,0,19,13,17,52]),function(ie,e,b,t,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let I=class{constructor(E,y){this.a=E,this.b=y}async download(E,y,D=b.CancellationToken.None){if(E.scheme===t.Schemas.file||E.scheme===t.Schemas.vscodeRemote){await this.b.copy(E,y);return}const T={type:"GET",url:E.toString(!0)},C=await this.a.request(T,D);if(C.res.statusCode===200)await this.b.writeFile(y,C.stream);else{const w=await(0,S.asTextOrError)(C);throw new Error(`Expected 200, got back ${C.res.statusCode} instead.

${w}`)}}};I=Le([Oe(0,S.IRequestService),Oe(1,k.IFileService)],I),e.DownloadService=I}),define(ve[222],be([1,0,16,19]),function(ie,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class k{constructor(A){this.a=A}listen(A,E){throw new Error("Invalid listen")}call(A,E,y,D=t.CancellationToken.None){switch(E){case"request":return this.a.request(y[0],D).then(async({res:T,stream:C})=>{const w=await(0,b.streamToBuffer)(C);return[{statusCode:T.statusCode,headers:T.headers},w]});case"resolveProxy":return this.a.resolveProxy(y[0])}throw new Error("Invalid call")}}e.RequestChannel=k;class S{constructor(A){this.a=A}async request(A,E){const[y,D]=await this.a.call("request",[A],E);return{res:y,stream:(0,b.bufferToStream)(D)}}async resolveProxy(A){return this.a.call("resolveProxy",[A])}}e.RequestChannelClient=S}),define(ve[223],be([1,0,79,11]),function(ie,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function k(I,A){return I.protocol==="http:"?A.HTTP_PROXY||A.http_proxy||null:I.protocol==="https:"&&(A.HTTPS_PROXY||A.https_proxy||A.HTTP_PROXY||A.http_proxy)||null}async function S(I,A,E={}){const y=(0,b.parse)(I),D=E.proxyUrl||k(y,A);if(!D)return null;const T=(0,b.parse)(D);if(!/^https?:$/.test(T.protocol||""))return null;const C={host:T.hostname||"",port:T.port||(T.protocol==="https"?"443":"80"),auth:T.auth,rejectUnauthorized:(0,t.isBoolean)(E.strictSSL)?E.strictSSL:!0};return y.protocol==="http:"?new(await new Promise((w,m)=>{ie(["http-proxy-agent"],w,m)}))(C):new(await new Promise((w,m)=>{ie(["https-proxy-agent"],w,m)}))(C)}e.getProxyAgent=S}),define(ve[80],be([1,0,48,7,179,19,39,8,3,22,156,191,14]),function(ie,e,b,t,k,S,I,A,E,y,D,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const w=1e4;let m;async function g(d,v,c){return v["force-disable-user-env"]?(d.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):E.isWindows?(d.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,T.isLaunchedFromCli)(c)&&!v["force-user-env"]?(d.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,T.isLaunchedFromCli)(c)?d.trace("resolveShellEnv(): running (--force-user-env)"):d.trace("resolveShellEnv(): running (macOS/Linux)"),m||(m=C.Promises.withAsyncBody(async(h,f)=>{const i=new S.CancellationTokenSource,n=setTimeout(()=>{i.dispose(!0),f(new Error((0,k.localize)(0,null)))},w);try{h(await p(d,i.token))}catch(r){!(0,A.isCancellationError)(r)&&!i.token.isCancellationRequested?f(new Error((0,k.localize)(1,null,(0,I.toErrorMessage)(r)))):h({})}finally{clearTimeout(n),i.dispose()}})),m)}e.getResolvedShellEnv=g;async function p(d,v){const c=process.env.ELECTRON_RUN_AS_NODE;d.trace("getUnixShellEnvironment#runAsNode",c);const h=process.env.ELECTRON_NO_ATTACH_CONSOLE;d.trace("getUnixShellEnvironment#noAttach",h);const f=(0,y.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(f+"(.*)"+f),n={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};d.trace("getUnixShellEnvironment#env",n);const r=await(0,D.getSystemShell)(E.OS,n);return d.trace("getUnixShellEnvironment#shell",r),new Promise((o,a)=>{if(v.isCancellationRequested)return a((0,A.canceled)());const l=(0,t.basename)(r);let s,u;const P=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(l)?(s=`& '${process.execPath}' ${P} -p '''${f}'' + JSON.stringify(process.env) + ''${f}'''`,u=["-Login","-Command"]):(s=`'${process.execPath}' ${P} -p '"${f}" + JSON.stringify(process.env) + "${f}"'`,l==="tcsh"?u=["-ic"]:u=["-ilc"]),d.trace("getUnixShellEnvironment#spawn",JSON.stringify(u),s);const F=(0,b.spawn)(r,[...u,s],{detached:!0,stdio:["ignore","pipe","pipe"],env:n});v.onCancellationRequested(()=>(F.kill(),a((0,A.canceled)()))),F.on("error",ue=>{d.error("getUnixShellEnvironment#errorChildProcess",(0,I.toErrorMessage)(ue)),a(ue)});const K=[];F.stdout.on("data",ue=>K.push(ue));const ne=[];F.stderr.on("data",ue=>ne.push(ue)),F.on("close",(ue,se)=>{const U=Buffer.concat(K).toString("utf8");d.trace("getUnixShellEnvironment#raw",U);const Q=Buffer.concat(ne).toString("utf8");if(Q.trim()&&d.trace("getUnixShellEnvironment#stderr",Q),ue||se)return a(new Error((0,k.localize)(2,null,ue,se)));const z=i.exec(U),G=z?z[1]:"{}";try{const X=JSON.parse(G);c?X.ELECTRON_RUN_AS_NODE=c:delete X.ELECTRON_RUN_AS_NODE,h?X.ELECTRON_NO_ATTACH_CONSOLE=h:delete X.ELECTRON_NO_ATTACH_CONSOLE,delete X.XDG_RUNTIME_DIR,d.trace("getUnixShellEnvironment#result",X),o(X)}catch(X){d.error("getUnixShellEnvironment#errorCaught",(0,I.toErrorMessage)(X)),a(X)}})})}}),define(ve[112],be([1,0,3,27,4,22]),function(ie,e,b,t,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function I(y){if(b.platform===2&&/^penguin(\.|$)/i.test(y))return"chromebook"}async function A(y,D,T,C,w,m,g,p,d,v){const c=Object.create(null);c["common.machineId"]=g,c.sessionID=(0,S.generateUuid)()+Date.now(),c.commitHash=w,c.version=m,c["common.platformVersion"]=(D||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,b.PlatformToString)(b.platform),c["common.nodePlatform"]=t.platform,c["common.nodeArch"]=C,c["common.product"]=v||"desktop",p&&(c["common.msftInternal"]=p);let h=0;const f=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-f,enumerable:!0},"common.sequence":{get:()=>h++,enumerable:!0}}),b.isLinuxSnap&&(c["common.snap"]="true");const i=I(T);i&&(c["common.platformDetail"]=i);try{const n=await y.readFile(k.URI.file(d));c["common.source"]=n.value.toString().slice(0,30)}catch{}return c}e.resolveCommonProperties=A;function E(y){const D=t.env.USERDNSDOMAIN;if(!D)return!1;const T=D.toLowerCase();return y.some(C=>T===C)}e.verifyMicrosoftInternalDomain=E}),define(ve[224],be([1,0,18,8,2,23,17]),function(ie,e,b,t,k,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorEvent=void 0;var A;(function(y){function D(T,C){return T.callstack<C.callstack?-1:T.callstack>C.callstack?1:0}y.compare=D})(A=e.ErrorEvent||(e.ErrorEvent={}));class E{constructor(D,T=E.ERROR_FLUSH_TIMEOUT){this.f=-1,this.g=[],this.h=new k.DisposableStore,this.c=D,this.d=T;const C=t.errorHandler.addListener(w=>this.j(w));this.h.add((0,k.toDisposable)(C)),this.i()}dispose(){clearTimeout(this.f),this.l(),this.h.dispose()}i(){}j(D){if(!D||(D.detail&&D.detail.stack&&(D=D.detail),t.ErrorNoTelemetry.isErrorNoTelemetry(D)||D instanceof I.FileOperationError))return;const T=Array.isArray(D.stack)?D.stack.join(`
`):D.stack,C=D.message?D.message:(0,S.safeStringify)(D);!T||this.k({msg:C,callstack:T})}k(D){const T=(0,b.binarySearch)(this.g,D,A.compare);T<0?(D.count=1,this.g.splice(~T,0,D)):(this.g[T].count||(this.g[T].count=0),this.g[T].count+=1),this.f===-1&&(this.f=setTimeout(()=>{this.l(),this.f=-1},this.d))}l(){for(const D of this.g)this.c.publicLogError2("UnhandledError",D);this.g.length=0}}e.default=E,E.ERROR_FLUSH_TIMEOUT=5*1e3}),define(ve[225],be([1,0,2]),function(ie,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerTelemetryChannel=void 0;class t extends b.Disposable{constructor(S,I){super(),this.a=S,this.b=I}async call(S,I,A){switch(I){case"updateTelemetryLevel":{const{telemetryLevel:E}=A;return this.a.updateInjectedTelemetryLevel(E)}case"logTelemetry":{const{eventName:E,data:y}=A;return this.b?this.b.log(E,y):Promise.resolve()}case"flushTelemetry":return this.b?this.b.flush():Promise.resolve();case"ping":return}throw new Error(`IPC Command ${I} not found`)}listen(S,I,A){throw new Error("Not supported")}dispose(){this.a.updateInjectedTelemetryLevel(0),super.dispose()}}e.ServerTelemetryChannel=t}),define(ve[34],be([1,0,5]),function(ie,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,b.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,b.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(S){S[S.NONE=0]="NONE",S[S.CRASH=1]="CRASH",S[S.ERROR=2]="ERROR",S[S.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var k;(function(S){S.OFF="off",S.CRASH="crash",S.ERROR="error",S.ON="all"})(k=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ve[226],be([1,0,30,14,69,13,7,3,4,93,21,96,199,17,25,34]),function(ie,e,b,t,k,S,I,A,E,y,D,T,C,w,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const p=new Map;async function d(i,n){const r=`${i}::${n.join(":")}`,o=p.get(r);if(o)return o;const a=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],l=new Map,s=new Map,u=2e4;function P(K,ne,ue,se){const U=ne.substring(K.length+1);return t.Promises.withAsyncBody(async Q=>{let z;try{z=await D.Promises.readdir(ne,{withFileTypes:!0})}catch{Q();return}if(se.count>=u){se.count+=z.length,se.maxReached=!0,Q();return}let G=z.length;if(G===0){Q();return}let X=z;se.count+z.length>u&&(se.maxReached=!0,G=u-se.count,X=z.slice(0,G)),se.count+=z.length;for(const ce of X)if(ce.isDirectory()){if(ue.includes(ce.name)||await P(K,(0,I.join)(ne,ce.name),ue,se),--G===0){Q();return}}else{const L=ce.name.lastIndexOf(".");if(L>=0){const N=ce.name.substring(L+1);N&&l.set(N,(l.get(N)??0)+1)}for(const N of a)N.relativePathPattern?.test(U)!==!1&&N.filePattern.test(ce.name)&&s.set(N.tag,(s.get(N.tag)??0)+1);if(--G===0){Q();return}}})}const F=t.Promises.withAsyncBody(async K=>{const ne={count:0,maxReached:!1};await P(i,i,n,ne);const ue=await h(i);K({configFiles:v(s),fileTypes:v(l),fileCount:ne.count,maxFilesReached:ne.maxReached,launchConfigFiles:ue})});return p.set(r,F),F}e.collectWorkspaceStats=d;function v(i){return Array.from(i.entries(),([n,r])=>({name:n,count:r})).sort((n,r)=>r.count-n.count)}function c(){const i={os:`${b.type()} ${b.arch()} ${b.release()}`,memory:`${(b.totalmem()/w.ByteSize.GB).toFixed(2)}GB (${(b.freemem()/w.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(y.virtualMachineHint.value()*100)}%`},n=b.cpus();return n&&n.length>0&&(i.cpus=`${n[0].model} (${n.length} x ${n[0].speed})`),i}e.getMachineInfo=c;async function h(i){try{const n=new Map,r=(0,I.join)(i,".vscode","launch.json"),o=await D.Promises.readFile(r),a=[],l=(0,k.parse)(o.toString(),a);if(a.length)return console.log(`Unable to parse ${r}`),[];if((0,k.getNodeType)(l)==="object"&&l.configurations)for(const s of l.configurations){const u=s.type;u&&(n.has(u)?n.set(u,n.get(u)+1):n.set(u,1))}return v(n)}catch{return[]}}e.collectLaunchConfigs=h;let f=class{constructor(n,r){this.c=n,this.d=r}f(n){const r=[];return r.push(`OS Version:       ${n.os}`),r.push(`CPUs:             ${n.cpus}`),r.push(`Memory (System):  ${n.memory}`),r.push(`VM:               ${n.vmHint}`),r.join(`
`)}g(n){const r=[];r.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),r.push(`OS Version:       ${b.type()} ${b.arch()} ${b.release()}`);const o=b.cpus();return o&&o.length>0&&r.push(`CPUs:             ${o[0].model} (${o.length} x ${o[0].speed})`),r.push(`Memory (System):  ${(b.totalmem()/w.ByteSize.GB).toFixed(2)}GB (${(b.freemem()/w.ByteSize.GB).toFixed(2)}GB free)`),A.isWindows||r.push(`Load (avg):       ${b.loadavg().map(a=>Math.round(a)).join(", ")}`),r.push(`VM:               ${Math.round(y.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${n.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${n.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.j(n.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(n,r){return Promise.all([(0,T.listProcesses)(n.mainPID),this.k(n)]).then(async o=>{let[a,l]=o,s=this.m(n,a);return r.forEach(u=>{if((0,C.isRemoteDiagnosticError)(u))s+=`
${u.errorMessage}`,l+=`
${u.errorMessage}`;else if(s+=`

Remote: ${u.hostName}`,u.processes&&(s+=`
${this.m(n,u.processes)}`),u.workspaceMetadata){l+=`
|  Remote: ${u.hostName}`;for(const P of Object.keys(u.workspaceMetadata)){const F=u.workspaceMetadata[P];let K=`${F.fileCount} files`;F.maxFilesReached&&(K=`more than ${K}`),l+=`|    Folder (${P}): ${K}`,l+=this.h(F)}}}),{processInfo:s,workspaceInfo:l}})}async getSystemInfo(n,r){const{memory:o,vmHint:a,os:l,cpus:s}=c(),u={os:l,memory:o,cpus:s,vmHint:a,processArgs:`${n.mainArguments.join(" ")}`,gpuStatus:n.gpuFeatureStatus,screenReader:`${n.screenReader?"yes":"no"}`,remoteData:r};return A.isWindows||(u.load=`${b.loadavg().map(P=>Math.round(P)).join(", ")}`),A.isLinux&&(u.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(u)}async getDiagnostics(n,r){const o=[];return(0,T.listProcesses)(n.mainPID).then(async a=>(o.push(""),o.push(this.g(n)),o.push(""),o.push(this.m(n,a)),n.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(o.push(""),o.push("Workspace Stats: "),o.push(await this.k(n))),r.forEach(l=>{if((0,C.isRemoteDiagnosticError)(l))o.push(`
${l.errorMessage}`);else if(o.push(`

`),o.push(`Remote:           ${l.hostName}`),o.push(this.f(l.machineInfo)),l.processes&&o.push(this.m(n,l.processes)),l.workspaceMetadata)for(const s of Object.keys(l.workspaceMetadata)){const u=l.workspaceMetadata[s];let P=`${u.fileCount} files`;u.maxFilesReached&&(P=`more than ${P}`),o.push(`Folder (${s}): ${P}`),o.push(this.h(u))}}),o.push(""),o.push(""),o.join(`
`)))}h(n){const r=[];let a=0;const l=(F,K)=>{const ne=` ${F}(${K})`;a+ne.length>60?(r.push(s),s="|                 ",a=s.length):a+=ne.length,s+=ne};let s="|      File types:";const u=10,P=n.fileTypes.length>u?u:n.fileTypes.length;for(let F=0;F<P;F++){const K=n.fileTypes[F];l(K.name,K.count)}if(r.push(s),n.configFiles.length>=0&&(s="|      Conf files:",a=0,n.configFiles.forEach(F=>{l(F.name,F.count)}),r.push(s)),n.launchConfigFiles.length>0){let F="|      Launch Configs:";n.launchConfigFiles.forEach(K=>{F+=K.count>1?` ${K.name}(${K.count})`:` ${K.name}`}),r.push(F)}return r.join(`
`)}j(n){const r=Math.max(...Object.keys(n).map(o=>o.length));return Object.keys(n).map(o=>`${o}:  ${" ".repeat(r-o.length)}  ${n[o]}`).join(`
                  `)}k(n){const r=[],o=[];return n.windows.forEach(a=>{a.folderURIs.length===0||!!a.remoteAuthority||(r.push(`|  Window (${a.title})`),a.folderURIs.forEach(l=>{const s=E.URI.revive(l);if(s.scheme===S.Schemas.file){const u=s.fsPath;o.push(d(u,["node_modules",".git"]).then(P=>{let F=`${P.fileCount} files`;P.maxFilesReached&&(F=`more than ${F}`),r.push(`|    Folder (${(0,I.basename)(u)}): ${F}`),r.push(this.h(P))}).catch(P=>{r.push(`|      Error: Unable to collect workspace stats for folder ${u} (${P.toString()})`)}))}else r.push(`|    Folder (${s.toString()}): Workspace stats not available.`)}))}),Promise.all(o).then(a=>r.join(`
`)).catch(a=>`Unable to collect workspace stats: ${a}`)}m(n,r){const o=new Map;n.windows.forEach(l=>o.set(l.pid,l.title));const a=[];return a.push("CPU %	Mem MB	   PID	Process"),r&&this.n(n.mainPID,o,a,r,0),a.join(`
`)}n(n,r,o,a,l){const s=l===0;let u;s?u=a.pid===n?`${this.d.applicationName} main`:"remote agent":(u=`${"  ".repeat(l)} ${a.name}`,a.name==="window"&&(u=`${u} (${r.get(a.pid)})`));const P=process.platform==="win32"?a.mem:b.totalmem()*(a.mem/100);o.push(`${a.load.toFixed(0).padStart(5," ")}	${(P/w.ByteSize.MB).toFixed(0).padStart(6," ")}	${a.pid.toFixed(0).padStart(6," ")}	${u}`),Array.isArray(a.children)&&a.children.forEach(F=>this.n(n,r,o,F,l+1))}async getWorkspaceFileExtensions(n){const r=new Set;for(const{uri:o}of n.folders){const a=E.URI.revive(o);if(a.scheme!==S.Schemas.file)continue;const l=a.fsPath;try{(await d(l,["node_modules",".git"])).fileTypes.forEach(u=>r.add(u.name))}catch{}}return{extensions:[...r]}}async reportWorkspaceStats(n){for(const{uri:r}of n.folders){const o=E.URI.revive(r);if(o.scheme!==S.Schemas.file)continue;const a=o.fsPath;try{const l=await d(a,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":n.telemetryId,rendererSessionId:n.rendererSessionId}),l.fileTypes.forEach(s=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:n.rendererSessionId,type:s.name,count:s.count})}),l.launchConfigFiles.forEach(s=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:n.rendererSessionId,type:s.name,count:s.count})}),l.configFiles.forEach(s=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:n.rendererSessionId,type:s.name,count:s.count})})}catch{}}}};f=Le([Oe(0,g.ITelemetryService),Oe(1,m.IProductService)],f),e.DiagnosticsService=f}),define(ve[42],be([1,0,23,11,24,65,112,34]),function(ie,e,b,t,k,S,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TrustedTelemetryValue=void 0;class E{constructor(l){this.value=l}}e.TrustedTelemetryValue=E;class y{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(l,s){return Promise.resolve(void 0)}publicLog2(l,s){return this.publicLog(l,s)}publicLogError(l,s){return Promise.resolve(void 0)}publicLogError2(l,s){return this.publicLogError(l,s)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=y,e.NullTelemetryService=new y;class D{async publicLog(l,s,u){}async publicLogError(l,s,u){}}e.NullEndpointTelemetryService=D,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function T(a,l){return l.onDidChangeConfiguration(s=>{s.source!==7&&a.publicLog2("updateConfiguration",{configurationSource:(0,k.ConfigurationTargetToString)(s.source),configurationKeys:c(s.sourceConfig)})})}e.configurationTelemetry=T;function C(a,l){return!l.isBuilt&&!l.disableTelemetry?!0:!(l.disableTelemetry||!a.enableTelemetry||l.extensionTestsLocationURI)}e.supportsTelemetry=C;function w(a,l){return!(l.isBuilt||l.disableTelemetry||a.enableTelemetry&&a.aiConfig?.ariaKey)}e.isLoggingOnly=w;function m(a){const l=a.getValue(A.TELEMETRY_SETTING_ID),s=a.getValue("telemetry.enableCrashReporter");if(a.getValue(A.TELEMETRY_OLD_SETTING_ID)===!1||s===!1)return 0;switch(l??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=m;function g(a){const l={},s={},u={};v(a,u);for(let P in u){P=P.length>150?P.substr(P.length-149):P;const F=u[P];typeof F=="number"?s[P]=F:typeof F=="boolean"?s[P]=F?1:0:typeof F=="string"?(F.length>8192&&console.warn(`Telemetry property: ${P} has been trimmed to 8192, the original length is ${F.length}`),l[P]=F.substring(0,8191)):typeof F<"u"&&F!==null&&(l[P]=F)}return{properties:l,measurements:s}}e.validateTelemetryData=g;const p=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function d(a){if(!a)return"none";const l=(0,S.getRemoteName)(a);return p.has(l)?l:"other"}e.cleanRemoteAuthority=d;function v(a,l,s=0,u){if(!!a)for(const P of Object.getOwnPropertyNames(a)){const F=a[P],K=u?u+P:P;Array.isArray(F)?l[K]=(0,b.safeStringify)(F):F instanceof Date?l[K]=F.toISOString():(0,t.isObject)(F)?s<2?v(F,l,s+1,K+"."):l[K]=(0,b.safeStringify)(F):l[K]=F}}function c(a){if(!a)return[];const l=[];return h(l,"",a),l}function h(a,l,s){s&&typeof s=="object"&&!Array.isArray(s)?Object.keys(s).forEach(u=>h(a,l?`${l}.${u}`:u,s[u])):a.push(l)}function f(a,l){const s=a.msftInternalDomains||[],u=l.getValue("telemetry.internalTesting");return(0,I.verifyMicrosoftInternalDomain)(s)||u}e.isInternalTelemetry=f;function i(a){return[a.appRoot,a.extensionsPath,a.userHome.fsPath,a.tmpDir.fsPath,a.userDataPath]}e.getPiiPathsFromEnvironment=i;function n(a,l){if(!a||!a.includes("/")&&!a.includes("\\"))return a;let s=a;const u=[];for(const ne of l)for(;;){const ue=ne.exec(a);if(!ue)break;u.push([ue.index,ne.lastIndex])}const P=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,F=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let K=0;for(s="";;){const ne=F.exec(a);if(!ne)break;const ue=u.some(([se,U])=>ne.index<U&&se<F.lastIndex);!P.test(ne[0])&&!ue&&(s+=a.substring(K,ne.index)+"<REDACTED: user-file-path>",K=F.lastIndex)}return K<a.length&&(s+=a.substr(K)),s}function r(a){if(!a)return a;const l=a.toLowerCase(),s=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const u of s)if(u.regex.test(l))return`<REDACTED: ${u.label}>`;return a}function o(a,l){return(0,b.cloneAndChange)(a,s=>{if(s instanceof E)return s.value;if(typeof s=="string"){let u=s.replaceAll("%20"," ");u=n(u,l);for(const P of l)u=u.replace(P,"");return u=r(u),u}})}e.cleanData=o}),define(ve[227],be([1,0,196,42]),function(ie,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function k(S,I,A,E,y,D,T){const C={"X-Market-Client-Id":`VSCode ${S}`,"User-Agent":`VSCode ${S} (${I.nameShort})`};if((0,t.supportsTelemetry)(I,A)&&(0,t.getTelemetryLevel)(E)===3){const w=await(0,b.getServiceMachineId)(A,y,D),{machineId:m}=await T.getTelemetryInfo();C["X-Market-User-Id"]=w,C["VSCode-SessionId"]=m||w}return C}e.resolveMarketplaceHeaders=k}),define(ve[228],be([1,0,8,23,42]),function(ie,e,b,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const S="https://mobile.events.data.microsoft.com/OneCollector/1.0";async function I(E,y,D){const T=await new Promise((p,d)=>{ie(["@microsoft/1ds-core-js"],p,d)}),C=await new Promise((p,d)=>{ie(["@microsoft/1ds-post-js"],p,d)}),w=new T.AppInsightsCore,m=new C.PostChannel,g={instrumentationKey:E,endpointUrl:S,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[m]]};if(D){g.extensionConfig={};const p={alwaysUseXhrOverride:!0,httpXHROverride:D};g.extensionConfig[m.identifier]=p}return w.initialize(g,[]),w.addTelemetryInitializer(p=>{y&&(p.ext=p.ext??{},p.ext.utc=p.ext.utc??{},p.ext.utc.flags=8462029)}),w}class A{constructor(y,D,T,C,w){this.d=y,this.e=D,this.f=T,this.g=w,this.c=S,this.f||(this.f={}),typeof C=="function"?this.a=C():this.a=C,this.b=null}h(y){if(!!this.a){if(typeof this.a!="string"){y(this.a);return}this.b||(this.b=I(this.a,this.d,this.g)),this.b.then(D=>{y(D)},D=>{(0,b.onUnexpectedError)(D),console.error(D)})}}log(y,D){if(!this.a)return;D=(0,t.mixin)(D,this.f),D=(0,k.validateTelemetryData)(D);const T=this.e+"/"+y;try{this.h(C=>{C.pluginVersionString=D?.properties.version??"Unknown",C.track({name:T,baseData:{name:T,properties:D?.properties,measurements:D?.measurements}})})}catch{}}flush(){return this.a?new Promise(y=>{this.h(D=>{D.unload(!0,()=>{this.a=void 0,y(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=A}),define(ve[229],be([1,0,2,23,3,15,180,24,51,50,25,35,34,42]),function(ie,e,b,t,k,S,I,A,E,y,D,T,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let m=class{constructor(d,v,c){this.k=v,this.l=c,this.d={},this.i=new b.DisposableStore,this.j=[],this.b=d.appenders,this.c=d.commonProperties||Promise.resolve({}),this.f=d.piiPaths||[],this.g=3,this.h=!!d.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const h of this.f)this.j.push(new RegExp((0,S.escapeRegExpCharacters)(h),"gi")),h.indexOf("\\")>=0&&this.j.push(new RegExp((0,S.escapeRegExpCharacters)(h.replace(/\\/g,"/")),"gi"));this.m(),this.k.onDidChangeConfiguration(this.m,this,this.i)}setExperimentProperty(d,v){this.d[d]=v}m(){let d=(0,w.getTelemetryLevel)(this.k);const v=this.l.enabledTelemetryLevels;if(v){this.h=this.sendErrorTelemetry?v.error:!1;const c=v.usage?3:v.error?2:0;d=Math.min(d,c)}this.g=d}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}async getTelemetryInfo(){const d=await this.c,v=d.sessionID,c=d["common.machineId"],h=d["common.firstSessionDate"],f=d["common.msftInternal"];return{sessionId:v,machineId:c,firstSessionDate:h,msftInternal:f}}dispose(){this.i.dispose()}n(d,v,c){return this.g<v?Promise.resolve(void 0):this.c.then(h=>{c=(0,t.mixin)(c,this.d),c=(0,w.cleanData)(c,this.j),c=(0,t.mixin)(c,h),this.b.forEach(f=>f.log(d,c))},h=>{console.error(h)})}publicLog(d,v){return this.n(d,3,v)}publicLog2(d,v){return this.publicLog(d,v)}publicLogError(d,v){return this.h?this.n(d,2,v):Promise.resolve(void 0)}publicLogError2(d,v){return this.publicLogError(d,v)}};m.IDLE_START_EVENT_NAME="UserIdleStart",m.IDLE_STOP_EVENT_NAME="UserIdleStop",m=Le([Oe(1,A.IConfigurationService),Oe(2,D.IProductService)],m),e.TelemetryService=m;function g(){const p=(0,I.localize)(0,null,y.default.nameLong),d=y.default.privacyStatementUrl?(0,I.localize)(2,null,"https://aka.ms/vscode-telemetry",y.default.privacyStatementUrl):(0,I.localize)(1,null,"https://aka.ms/vscode-telemetry"),v=k.isWeb?"":(0,I.localize)(3,null),c=(0,I.localize)(4,null),h=(0,I.localize)(5,null),f=(0,I.localize)(6,null),i=(0,I.localize)(7,null),n=`
|       | ${c} | ${h} | ${f} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,I.localize)(8,null);return`
${p} ${d} ${v}

&nbsp;

${i}
${n}

&nbsp;

${r}
`}T.Registry.as(E.Extensions.Configuration).registerConfiguration({id:C.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,I.localize)(9,null),properties:{[C.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,I.localize)(10,null),(0,I.localize)(11,null),(0,I.localize)(12,null),(0,I.localize)(13,null)],markdownDescription:g(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),T.Registry.as(E.Extensions.Configuration).registerConfiguration({id:C.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,I.localize)(14,null),properties:{[C.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:y.default.privacyStatementUrl?(0,I.localize)(16,null,y.default.nameLong,y.default.privacyStatementUrl):(0,I.localize)(15,null,y.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,I.localize)(17,null,`\`#${C.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ve[230],be([1,0,24,5,25,34,229,42]),function(ie,e,b,t,k,S,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IServerTelemetryService=e.ServerNullTelemetryService=e.ServerTelemetryService=void 0;let E=class extends I.TelemetryService{constructor(D,T,C,w){super(D,C,w),this.e=T}publicLog(D,T){return this.e<3?Promise.resolve(void 0):super.publicLog(D,T)}publicLog2(D,T){return this.publicLog(D,T)}publicLogError(D,T){return this.e<2?Promise.resolve(void 0):super.publicLogError(D,T)}publicLogError2(D,T){return this.publicLogError(D,T)}async updateInjectedTelemetryLevel(D){if(D===void 0)throw this.e=0,new Error("Telemetry level cannot be undefined. This will cause infinite looping!");this.e=this.e?Math.min(this.e,D):D,this.e===0&&this.dispose()}};E=Le([Oe(2,b.IConfigurationService),Oe(3,k.IProductService)],E),e.ServerTelemetryService=E,e.ServerNullTelemetryService=new class extends A.NullTelemetryServiceShape{async updateInjectedTelemetryLevel(){}},e.IServerTelemetryService=(0,t.refineServiceDecorator)(S.ITelemetryService)}),define(ve[231],be([1,0,275,228]),function(ie,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class k extends t.AbstractOneDataSystemAppender{constructor(I,A,E,y){const D={sendPOST:(T,C)=>{const w={method:"POST",headers:{...T.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(T.data)}};try{const m=b.request(T.urlString,w,g=>{g.on("data",function(p){C(g.statusCode??200,g.headers,p.toString())}),g.on("error",function(p){C(0,{})})});m.write(T.data),m.end()}catch{C(0,{})}}};super(I,A,E,y,D)}}e.OneDataSystemAppender=k}),define(ve[232],be([1,0,8,224]),function(ie,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class k extends t.default{i(){(0,b.setUnexpectedErrorHandler)(A=>console.error(A));const I=[];process.on("unhandledRejection",(A,E)=>{I.push(E),setTimeout(()=>{const y=I.indexOf(E);y>=0&&E.catch(D=>{I.splice(y,1),(0,b.isCancellationError)(D)||(console.warn(`rejected promise not handled within 1 second: ${D}`),D.stack&&console.warn(`stack trace: ${D.stack}`),A&&(0,b.onUnexpectedError)(A))})},1e3)}),process.on("rejectionHandled",A=>{const E=I.indexOf(A);E>=0&&I.splice(E,1)}),process.on("uncaughtException",A=>{(0,b.onUnexpectedError)(A)})}}e.default=k}),define(ve[233],be([1,0,14,19,6,2,12]),function(ie,e,b,t,k,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let A=class extends S.Disposable{constructor(y,D){super(),this.h=D,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new k.Emitter),this.onCreateRequest=this.g.event,this.b=y===void 0?15e3:y}createRequest(y){return new Promise((D,T)=>{const C=++this.a;this.c.set(C,D),this.g.fire({requestId:C,...y});const w=new t.CancellationTokenSource;(0,b.timeout)(this.b,w.token).then(()=>T(`Request ${C} timed out (${this.b}ms)`)),this.f.set(C,[(0,S.toDisposable)(()=>w.cancel())])})}acceptReply(y,D){const T=this.c.get(y);T?(this.c.delete(y),(0,S.dispose)(this.f.get(y)||[]),this.f.delete(y),T(D)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${y}`)}};A=Le([Oe(1,I.ILogService)],A),e.RequestStore=A}),define(ve[113],be([1,0,5]),function(ie,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalLogConstants=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var t;(function(c){c.Shell="terminal.integrated.shell.",c.ShellArgs="terminal.integrated.shellArgs.",c.DefaultProfile="terminal.integrated.defaultProfile.",c.Profiles="terminal.integrated.profiles."})(t=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var k;(function(c){c.ShellLinux="terminal.integrated.shell.linux",c.ShellMacOs="terminal.integrated.shell.osx",c.ShellWindows="terminal.integrated.shell.windows",c.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",c.AutomationShellLinux="terminal.integrated.automationShell.linux",c.AutomationShellMacOs="terminal.integrated.automationShell.osx",c.AutomationShellWindows="terminal.integrated.automationShell.windows",c.AutomationProfileLinux="terminal.integrated.automationProfile.linux",c.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",c.AutomationProfileWindows="terminal.integrated.automationProfile.windows",c.ShellArgsLinux="terminal.integrated.shellArgs.linux",c.ShellArgsMacOs="terminal.integrated.shellArgs.osx",c.ShellArgsWindows="terminal.integrated.shellArgs.windows",c.ProfilesWindows="terminal.integrated.profiles.windows",c.ProfilesMacOs="terminal.integrated.profiles.osx",c.ProfilesLinux="terminal.integrated.profiles.linux",c.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",c.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",c.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",c.UseWslProfiles="terminal.integrated.useWslProfiles",c.TabsDefaultColor="terminal.integrated.tabs.defaultColor",c.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",c.TabsEnabled="terminal.integrated.tabs.enabled",c.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",c.TabsHideCondition="terminal.integrated.tabs.hideCondition",c.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",c.TabsShowActions="terminal.integrated.tabs.showActions",c.TabsLocation="terminal.integrated.tabs.location",c.TabsFocusMode="terminal.integrated.tabs.focusMode",c.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",c.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",c.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",c.CopyOnSelection="terminal.integrated.copyOnSelection",c.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",c.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",c.FontFamily="terminal.integrated.fontFamily",c.FontSize="terminal.integrated.fontSize",c.LetterSpacing="terminal.integrated.letterSpacing",c.LineHeight="terminal.integrated.lineHeight",c.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",c.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",c.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",c.BellDuration="terminal.integrated.bellDuration",c.FontWeight="terminal.integrated.fontWeight",c.FontWeightBold="terminal.integrated.fontWeightBold",c.CursorBlinking="terminal.integrated.cursorBlinking",c.CursorStyle="terminal.integrated.cursorStyle",c.CursorWidth="terminal.integrated.cursorWidth",c.Scrollback="terminal.integrated.scrollback",c.DetectLocale="terminal.integrated.detectLocale",c.DefaultLocation="terminal.integrated.defaultLocation",c.GpuAcceleration="terminal.integrated.gpuAcceleration",c.TerminalTitleSeparator="terminal.integrated.tabs.separator",c.TerminalTitle="terminal.integrated.tabs.title",c.TerminalDescription="terminal.integrated.tabs.description",c.RightClickBehavior="terminal.integrated.rightClickBehavior",c.Cwd="terminal.integrated.cwd",c.ConfirmOnExit="terminal.integrated.confirmOnExit",c.ConfirmOnKill="terminal.integrated.confirmOnKill",c.EnableBell="terminal.integrated.enableBell",c.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",c.AllowChords="terminal.integrated.allowChords",c.AllowMnemonics="terminal.integrated.allowMnemonics",c.EnvMacOs="terminal.integrated.env.osx",c.EnvLinux="terminal.integrated.env.linux",c.EnvWindows="terminal.integrated.env.windows",c.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",c.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",c.ShowExitAlert="terminal.integrated.showExitAlert",c.SplitCwd="terminal.integrated.splitCwd",c.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",c.WordSeparators="terminal.integrated.wordSeparators",c.EnableFileLinks="terminal.integrated.enableFileLinks",c.UnicodeVersion="terminal.integrated.unicodeVersion",c.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",c.LocalEchoEnabled="terminal.integrated.localEchoEnabled",c.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",c.LocalEchoStyle="terminal.integrated.localEchoStyle",c.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",c.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",c.CustomGlyphs="terminal.integrated.customGlyphs",c.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",c.InheritEnv="terminal.integrated.inheritEnv",c.ShowLinkHover="terminal.integrated.showLinkHover",c.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",c.AutoReplies="terminal.integrated.autoReplies",c.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",c.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",c.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",c.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",c.SmoothScrolling="terminal.integrated.smoothScrolling"})(k=e.TerminalSettingId||(e.TerminalSettingId={}));var S;(function(c){c.FileName="ptyhost"})(S=e.TerminalLogConstants||(e.TerminalLogConstants={}));var I;(function(c){c.PowerShell="pwsh",c.Bash="bash",c.Fish="fish",c.Sh="sh",c.Csh="csh",c.Ksh="ksh",c.Zsh="zsh"})(I=e.PosixShellType||(e.PosixShellType={}));var A;(function(c){c.CommandPrompt="cmd",c.PowerShell="pwsh",c.Wsl="wsl",c.GitBash="gitbash"})(A=e.WindowsShellType||(e.WindowsShellType={}));var E;(function(c){c[c.Api=0]="Api",c[c.Process=1]="Process",c[c.Sequence=2]="Sequence",c[c.Config=3]="Config"})(E=e.TitleEventSource||(e.TitleEventSource={}));var y;(function(c){c.LocalPty="localPty",c.PtyHost="ptyHost",c.Log="log",c.Heartbeat="heartbeat"})(y=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,b.createDecorator)("ptyService");var D;(function(c){c.Cwd="cwd",c.InitialCwd="initialCwd",c.FixedDimensions="fixedDimensions",c.Title="title",c.ShellType="shellType",c.HasChildProcesses="hasChildProcesses",c.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",c.OverrideDimensions="overrideDimensions",c.FailedShellIntegrationActivation="failedShellIntegrationActivation",c.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(D=e.ProcessPropertyType||(e.ProcessPropertyType={}));var T;(function(c){c[c.BeatInterval=5e3]="BeatInterval",c[c.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",c[c.SecondWaitMultiplier=1]="SecondWaitMultiplier",c[c.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(T=e.HeartbeatConstants||(e.HeartbeatConstants={}));var C;(function(c){c[c.Panel=1]="Panel",c[c.Editor=2]="Editor"})(C=e.TerminalLocation||(e.TerminalLocation={}));var w;(function(c){c.TerminalView="view",c.Editor="editor"})(w=e.TerminalLocationString||(e.TerminalLocationString={}));var m;(function(c){c[c.GraceTime=6e4]="GraceTime",c[c.ShortGraceTime=6e3]="ShortGraceTime"})(m=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var g;(function(c){c[c.HighWatermarkChars=1e5]="HighWatermarkChars",c[c.LowWatermarkChars=5e3]="LowWatermarkChars",c[c.CharCountAckSize=5e3]="CharCountAckSize"})(g=e.FlowControlConstants||(e.FlowControlConstants={}));var p;(function(c){c.GitBash="Git Bash",c.Pwsh="PowerShell"})(p=e.ProfileSource||(e.ProfileSource={}));var d;(function(c){c[c.Off=0]="Off",c[c.FinalTerm=1]="FinalTerm",c[c.VSCode=2]="VSCode"})(d=e.ShellIntegrationStatus||(e.ShellIntegrationStatus={}));var v;(function(c){c[c.Unknown=0]="Unknown",c[c.Shutdown=1]="Shutdown",c[c.Process=2]="Process",c[c.User=3]="User",c[c.Extension=4]="Extension"})(v=e.TerminalExitReason||(e.TerminalExitReason={}))}),define(ve[234],be([1,0,3]),function(ie,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeCwd=e.collapseTildePath=e.escapeNonWindowsPath=void 0;function t(I){let A=I;A.indexOf("\\")!==0&&(A=A.replace(/\\/g,"\\\\"));const E=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return A=A.replace(E,""),`'${A}'`}e.escapeNonWindowsPath=t;function k(I,A,E){if(!I)return"";if(!A)return I;A.match(/[\/\\]$/)&&(A=A.slice(0,A.length-1));const y=I.replace(/\\/g,"/").toLowerCase(),D=A.replace(/\\/g,"/").toLowerCase();return y.includes(D)?`~${E}${I.slice(A.length+1)}`:I}e.collapseTildePath=k;function S(I){return I.match(/^['"].*['"]$/)&&(I=I.substring(1,I.length-1)),b.OS===1&&I&&I[1]===":"?I[0].toUpperCase()+I.substring(1):I}e.sanitizeCwd=S}),define(ve[235],be([1,0,30,13,23,7,3,27,15,11,21]),function(ie,e,b,t,k,S,I,A,E,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shellIntegrationArgs=e.ShellIntegrationExecutable=e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function T(){const h=/(\d+)\.(\d+)\.(\d+)/g.exec(b.release());let f=0;return h&&h.length===4&&(f=parseInt(h[3])),f}e.getWindowsBuildNumber=T;async function C(h,f,i,n=A.env,r=D.Promises.exists){if(S.isAbsolute(h))return await r(h)?h:void 0;if(f===void 0&&(f=A.cwd()),S.dirname(h)!=="."){const s=S.join(f,h);return await r(s)?s:void 0}const a=(0,k.getCaseInsensitive)(n,"PATH");if(i===void 0&&(0,y.isString)(a)&&(i=a.split(S.delimiter)),i===void 0||i.length===0){const s=S.join(f,h);return await r(s)?s:void 0}for(const s of i){let u;if(S.isAbsolute(s)?u=S.join(s,h):u=S.join(f,s,h),await r(u))return u;if(I.isWindows){let P=u+".com";if(await r(P)||(P=u+".exe",await r(P)))return P}}const l=S.join(f,h);return await r(l)?l:void 0}e.findExecutable=C;function w(h,f,i,n,r){if(!f.shellIntegration.enabled||!h.executable||h.isFeatureTerminal||h.hideFromUser||h.ignoreShellIntegration||I.isWindows&&!f.windowsEnableConpty)return;const o=h.args,a=A.platform==="win32"?S.basename(h.executable).toLowerCase():S.basename(h.executable),l=S.dirname(t.FileAccess.asFileUri("").fsPath);let s;const u={VSCODE_INJECTION:"1"};if(I.isWindows){if(a==="pwsh.exe"||a==="powershell.exe")return!o||v(o)?s=e.shellIntegrationArgs.get(m.WindowsPwsh):d(o)&&(s=e.shellIntegrationArgs.get(m.WindowsPwshLogin)),s?(s=[...s],s[s.length-1]=(0,E.format)(s[s.length-1],l,""),{newArgs:s,envMixin:u}):void 0;n.warn(`Shell integration cannot be enabled for executable "${h.executable}" and args`,h.args);return}switch(a){case"bash":return!o||o.length===0?s=e.shellIntegrationArgs.get(m.Bash):c(o)&&(u.VSCODE_SHELL_LOGIN="1",s=e.shellIntegrationArgs.get(m.Bash)),s?(s=[...s],s[s.length-1]=(0,E.format)(s[s.length-1],l),{newArgs:s,envMixin:u}):void 0;case"pwsh":return!o||v(o)?s=e.shellIntegrationArgs.get(m.Pwsh):d(o)&&(s=e.shellIntegrationArgs.get(m.PwshLogin)),s?(s=[...s],s[s.length-1]=(0,E.format)(s[s.length-1],l,""),{newArgs:s,envMixin:u}):void 0;case"zsh":{if(!o||o.length===0?s=e.shellIntegrationArgs.get(m.Zsh):c(o)?s=e.shellIntegrationArgs.get(m.ZshLogin):(o===e.shellIntegrationArgs.get(m.Zsh)||o===e.shellIntegrationArgs.get(m.ZshLogin))&&(s=o),!s)return;s=[...s],s[s.length-1]=(0,E.format)(s[s.length-1],l);const P=S.join(b.tmpdir(),`${b.userInfo().username}-${r.applicationName}-zsh`);u.ZDOTDIR=P;const F=i?.ZDOTDIR??b.homedir()??"~";u.USER_ZDOTDIR=F;const K=[];return K.push({source:S.join(l,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:S.join(P,".zshrc")}),K.push({source:S.join(l,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:S.join(P,".zprofile")}),K.push({source:S.join(l,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:S.join(P,".zshenv")}),K.push({source:S.join(l,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:S.join(P,".zlogin")}),{newArgs:s,envMixin:u,filesToCopy:K}}}n.warn(`Shell integration cannot be enabled for executable "${h.executable}" and args`,h.args)}e.getShellIntegrationInjection=w;var m;(function(h){h.WindowsPwsh="windows-pwsh",h.WindowsPwshLogin="windows-pwsh-login",h.Pwsh="pwsh",h.PwshLogin="pwsh-login",h.Zsh="zsh",h.ZshLogin="zsh-login",h.Bash="bash"})(m=e.ShellIntegrationExecutable||(e.ShellIntegrationExecutable={})),e.shellIntegrationArgs=new Map,e.shellIntegrationArgs.set(m.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),e.shellIntegrationArgs.set(m.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),e.shellIntegrationArgs.set(m.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(m.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),e.shellIntegrationArgs.set(m.Zsh,["-i"]),e.shellIntegrationArgs.set(m.ZshLogin,["-il"]),e.shellIntegrationArgs.set(m.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const g=["-login","-l"],p=["-nol","-nologo"];function d(h){return typeof h=="string"?g.includes(h.toLowerCase()):h.length===1&&g.includes(h[0].toLowerCase())||h.length===2&&(g.includes(h[0].toLowerCase())||g.includes(h[1].toLowerCase()))&&(p.includes(h[0].toLowerCase())||p.includes(h[1].toLowerCase()))}function v(h){return typeof h=="string"?p.includes(h.toLowerCase()):h.length===0||h?.length===1&&p.includes(h[0].toLowerCase())}function c(h){return h==="string"&&g.includes(h.toLowerCase())||typeof h!="string"&&h.length===1&&g.includes(h[0].toLowerCase())}}),define(ve[236],be([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var b;(function(S){S.DARK="dark",S.LIGHT="light",S.HIGH_CONTRAST_DARK="hcDark",S.HIGH_CONTRAST_LIGHT="hcLight"})(b=e.ColorScheme||(e.ColorScheme={}));function t(S){return S===b.HIGH_CONTRAST_DARK||S===b.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function k(S){return S===b.DARK||S===b.HIGH_CONTRAST_DARK}e.isDark=k}),define(ve[114],be([1,0,40,6,2,5,35,236]),function(ie,e,b,t,k,S,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,S.createDecorator)("themeService");var E;(function(p){function d(v){return v&&typeof v=="object"&&typeof v.id=="string"}p.isThemeColor=d})(E=e.ThemeColor||(e.ThemeColor={}));function y(p){return{id:p}}e.themeColorFromId=y;var D;(function(p){function d(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(typeof o.color>"u"||E.isThemeColor(o.color))}p.isThemeIcon=d;const v=new RegExp(`^\\$\\((${b.CSSIcon.iconNameExpression}(?:${b.CSSIcon.iconModifierExpression})?)\\)$`);function c(o){const a=v.exec(o);if(!a)return;const[,l]=a;return{id:l}}p.fromString=c;function h(o){return{id:o}}p.fromId=h;function f(o,a){let l=o.id;const s=l.lastIndexOf("~");return s!==-1&&(l=l.substring(0,s)),a&&(l=`${l}~${a}`),{id:l}}p.modify=f;function i(o){const a=o.id.lastIndexOf("~");if(a!==-1)return o.id.substring(a+1)}p.getModifier=i;function n(o,a){return o.id===a.id&&o.color?.id===a.color?.id}p.isEqual=n;function r(o,a){return{id:o.id,color:a?y(a):void 0}}p.asThemeIcon=r,p.asClassNameArray=b.CSSIcon.asClassNameArray,p.asClassName=b.CSSIcon.asClassName,p.asCSSSelector=b.CSSIcon.asCSSSelector})(D=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=b.Codicon.file,e.FolderThemeIcon=b.Codicon.folder;function T(p){switch(p){case A.ColorScheme.DARK:return"vs-dark";case A.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case A.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=T,e.Extensions={ThemingContribution:"base.contributions.theming"};class C{constructor(){this.a=[],this.a=[],this.b=new t.Emitter}onColorThemeChange(d){return this.a.push(d),this.b.fire(d),(0,k.toDisposable)(()=>{const v=this.a.indexOf(d);this.a.splice(v,1)})}get onThemingParticipantAdded(){return this.b.event}getThemingParticipants(){return this.a}}const w=new C;I.Registry.add(e.Extensions.ThemingContribution,w);function m(p){return w.onColorThemeChange(p)}e.registerThemingParticipant=m;class g extends k.Disposable{constructor(d){super(),this.k=d,this.h=d.getColorTheme(),this.B(this.k.onDidColorThemeChange(v=>this.n(v)))}n(d){this.h=d,this.updateStyles()}updateStyles(){}w(d,v){let c=this.h.getColor(d);return c&&v&&(c=v(c,this.h)),c?c.toString():null}}e.Themable=g}),define(ve[237],be([1,0,40,4,182,114]),function(ie,e,b,t,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function I(C,w){const m=[{name:null,description:(0,k.localize)(0,null)}];return m.push(...C.map(g=>({name:g.profileName,description:A(g)}))),w&&m.push(...w.map(g=>({name:g.title,description:E(g)}))),{values:m.map(g=>g.name),markdownDescriptions:m.map(g=>g.description)}}e.createProfileSchemaEnums=I;function A(C){let w=`$(${S.ThemeIcon.isThemeIcon(C.icon)?C.icon.id:C.icon?C.icon:b.Codicon.terminal.id}) ${C.profileName}
- path: ${C.path}`;return C.args&&(typeof C.args=="string"?w+=`
- args: "${C.args}"`:w+=`
- args: [${C.args.length===0?"":`'${C.args.join("','")}'`}]`),C.overrideName!==void 0&&(w+=`
- overrideName: ${C.overrideName}`),C.color&&(w+=`
- color: ${C.color}`),C.env&&(w+=`
- env: ${JSON.stringify(C.env)}`),w}function E(C){return`$(${S.ThemeIcon.isThemeIcon(C.icon)?C.icon.id:C.icon?C.icon:b.Codicon.terminal.id}) ${C.title}
- extensionIdentifier: ${C.extensionIdentifier}`}function y(C,w){if(!C&&!w)return!0;if(typeof C=="string"&&typeof w=="string")return C===w;if(Array.isArray(C)&&Array.isArray(w)){if(C.length!==w.length)return!1;for(let m=0;m<C.length;m++)if(C[m]!==w[m])return!1;return!0}return!1}e.terminalProfileArgsMatch=y;function D(C,w){if(!C&&!w)return!0;if(!C||!w)return!1;if(S.ThemeIcon.isThemeIcon(C)&&S.ThemeIcon.isThemeIcon(w))return C.id===w.id&&C.color===w.color;if(typeof C=="object"&&"light"in C&&"dark"in C&&typeof w=="object"&&"light"in w&&"dark"in w){const m=C,g=w;if((t.URI.isUri(m.light)||T(m.light))&&(t.URI.isUri(m.dark)||T(m.dark))&&(t.URI.isUri(g.light)||T(g.light))&&(t.URI.isUri(g.dark)||T(g.dark)))return m.light.path===g.light.path&&m.dark.path===g.dark.path}if(t.URI.isUri(C)&&t.URI.isUri(w)||T(C)||T(w)){const m=C,g=w;return m.path===g.path&&m.scheme===g.scheme}return!1}e.terminalIconsEqual=D;function T(C){return C?typeof C.path=="string"&&typeof C.scheme=="string":!1}e.isUriComponents=T}),define(ve[238],be([1,0,40,181,51,35,237]),function(ie,e,b,t,k,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from(b.Codicon.getAll(),h=>h.id),markdownEnumDescriptions:Array.from(b.Codicon.getAll(),h=>`$(${h.id})`)};const A={args:{description:(0,t.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,t.localize)(1,null),type:"boolean"},icon:{description:(0,t.localize)(2,null),...e.terminalIconSchema},color:{description:(0,t.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,t.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},E={type:"object",required:["path"],properties:{path:{description:(0,t.localize)(5,null),type:["string","array"],items:{type:"string"}},...A}},y={type:"object",required:["path"],properties:{path:{description:(0,t.localize)(6,null),type:["string"],items:{type:"string"}},...A}},D=(0,t.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),T=(0,t.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),C=(0,t.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),w=(0,t.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),m=(0,t.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),g=(0,t.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),p={id:"terminal",order:100,title:(0,t.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:w},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:m},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:g},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(17,null,"`terminal.integrated.automationShell.linux`"),type:["object","null"],default:null,anyOf:[{type:"null"},y],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(18,null,"`terminal.integrated.automationShell.osx`"),type:["object","null"],default:null,anyOf:[{type:"null"},y],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(19,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},y],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:D},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:T},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:C},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:D},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:T},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,t.localize)(26,null)}},{type:"string",markdownDescription:(0,t.localize)(27,null)}],default:[],markdownDeprecationMessage:C},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,t.localize)(29,null),enum:["PowerShell","Git Bash"]},...A}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(30,null),type:"string"},id:{description:(0,t.localize)(31,null),type:"string"},title:{description:(0,t.localize)(32,null),type:"string"},...A}},{type:"null"},E]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(34,null),type:"string"},id:{description:(0,t.localize)(35,null),type:"string"},title:{description:(0,t.localize)(36,null),type:"string"},...A}},{type:"null"},E]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,t.localize)(38,null),type:"string"},id:{description:(0,t.localize)(39,null),type:"string"},title:{description:(0,t.localize)(40,null),type:"string"},...A}},{type:"null"},E]}},["terminal.integrated.useWslProfiles"]:{description:(0,t.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,t.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,t.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,t.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,t.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function d(){S.Registry.as(k.Extensions.Configuration).registerConfiguration(p),c()}e.registerTerminalPlatformConfiguration=d;let v;function c(h,f){const i=S.Registry.as(k.Extensions.Configuration);let n;h&&(n=(0,I.createProfileSchemaEnums)(h?.profiles,f));const r=v;v={id:"terminal",order:100,title:(0,t.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,t.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:h?.os===3?n?.values:void 0,markdownEnumDescriptions:h?.os===3?n?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,t.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:h?.os===2?n?.values:void 0,markdownEnumDescriptions:h?.os===2?n?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,t.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:h?.os===1?n?.values:void 0,markdownEnumDescriptions:h?.os===1?n?.markdownDescriptions:void 0}}},i.updateConfigurations({add:[v],remove:r?[r]:[]})}e.registerTerminalDefaultProfileConfiguration=c}),define(ve[239],be([1,0,48,40,7,3,21,94,235,114]),function(ie,e,b,t,k,S,I,A,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let D,T=!0;function C(n,r,o,a,l=process.env,s,u,P,F){return s=s||{existsFile:I.SymlinkSupport.existsFile,readFile:I.Promises.readFile},S.isWindows?w(o,s,l,u,a.getValue("terminal.integrated.useWslProfiles")!==!1,n&&typeof n=="object"?{...n}:a.getValue("terminal.integrated.profiles.windows"),typeof r=="string"?r:a.getValue("terminal.integrated.defaultProfile.windows"),F,P):h(s,u,o,n&&typeof n=="object"?{...n}:a.getValue(S.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof r=="string"?r:a.getValue(S.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),F,P,l)}e.detectAvailableProfiles=C;async function w(n,r,o,a,l,s,u,P,F){const K=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),ne=`${process.env.windir}\\${K?"Sysnative":"System32"}`;let ue=!1;(0,E.getWindowsBuildNumber)()>=16299&&(ue=!0),await p(P);const se=new Map;n&&(se.set("PowerShell",{source:"PowerShell",icon:t.Codicon.terminalPowershell,isAutoDetected:!0}),se.set("Windows PowerShell",{path:`${ne}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:t.Codicon.terminalPowershell,isAutoDetected:!0}),se.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),se.set("Command Prompt",{path:`${ne}\\cmd.exe`,icon:t.Codicon.terminalCmd,isAutoDetected:!0})),f(s,se);const U=await m(se.entries(),u,r,o,a,F);if(n||l)try{const Q=await v(`${ne}\\${ue?"wsl":"bash"}.exe`,u);for(const z of Q)(!s||!(z.profileName in s))&&U.push(z)}catch{T&&(a?.info("WSL is not installed, so could not detect WSL profiles"),T=!1)}return U}async function m(n,r,o,a=process.env,l,s){const u=[];for(const[P,F]of n){if(F===null)continue;let K,ne,ue;if("source"in F){const Q=D?.get(F.source);if(!Q)continue;K=Q.paths,ne=F.args||Q.args,F.icon?ue=g(F.icon):Q.icon&&(ue=Q.icon)}else K=Array.isArray(F.path)?F.path:[F.path],ne=S.isWindows||Array.isArray(F.args)?F.args:void 0,ue=g(F.icon);const se=await s?.(K)||K.slice(),U=await i(P,r,se,o,a,ne,F.env,F.overrideName,F.isAutoDetected,l);U?(U.isAutoDetected=F.isAutoDetected,U.icon=ue,U.color=F.color,u.push(U)):l?.debug("Terminal profile not validated",P,K)}return l?.debug("Validated terminal profiles",u),u}function g(n){return typeof n=="string"?{id:n}:n}async function p(n){D&&!n||(D=new Map,D.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login","-i"]}),D.set("PowerShell",{profileName:"PowerShell",paths:n||await d(),icon:y.ThemeIcon.asThemeIcon(t.Codicon.terminalPowershell)}))}async function d(){const n=[];for await(const r of(0,A.enumeratePowerShellInstallations)())n.push(r.exePath);return n}async function v(n,r){const o=[],a=await new Promise((u,P)=>{b.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(F,K)=>{if(F)return P("Problem occurred when getting wsl distros");u(K)})});if(!a)return[];const l=new RegExp(/[\r?\n]/),s=a.split(l).filter(u=>u.trim().length>0&&u!=="");for(const u of s){if(u===""||u.startsWith("docker-desktop"))continue;const P=`${u} (WSL)`,F={profileName:P,path:n,args:["-d",`${u}`],isDefault:P===r,icon:c(u),isAutoDetected:!1};o.push(F)}return o}function c(n){return n.includes("Ubuntu")?y.ThemeIcon.asThemeIcon(t.Codicon.terminalUbuntu):n.includes("Debian")?y.ThemeIcon.asThemeIcon(t.Codicon.terminalDebian):y.ThemeIcon.asThemeIcon(t.Codicon.terminalLinux)}async function h(n,r,o,a,l,s,u,P){const F=new Map;if(o){const K=(await n.readFile("/etc/shells")).toString(),ne=s||K.split(`
`).filter(se=>se.trim().indexOf("#")!==0&&se.trim().length>0),ue=new Map;for(const se of ne){let U=(0,k.basename)(se),Q=ue.get(U)||0;Q++,Q>1&&(U=`${U} (${Q})`),ue.set(U,Q),F.set(U,{path:se,isAutoDetected:!0})}}return f(a,F),await m(F.entries(),l,n,P,r,u)}function f(n,r){if(!!n)for(const[o,a]of Object.entries(n))a===null||!("path"in a)&&!("source"in a)?r.delete(o):(a.icon=a.icon||r.get(o)?.icon,r.set(o,a))}async function i(n,r,o,a,l,s,u,P,F,K){if(o.length===0)return Promise.resolve(void 0);const ne=o.shift();if(ne==="")return i(n,r,o,a,l,s,u,P,F);const ue={profileName:n,path:ne,args:s,env:u,overrideName:P,isAutoDetected:F,isDefault:n===r};if((0,k.basename)(ne)===ne){const U=l.PATH?l.PATH.split(k.delimiter):void 0,Q=await(0,E.findExecutable)(ne,void 0,U,void 0,a.existsFile);return Q?(ue.path=Q,ue.isFromPath=!0,ue):i(n,r,o,a,l,s)}return await a.existsFile((0,k.normalize)(ne))?ue:i(n,r,o,a,l,s,u,P,F)}}),define(ve[240],be([1,0,6,2,13,3,41,98,24,28,99,80,12,104,233,113,238,239]),function(ie,e,b,t,k,S,I,A,E,y,D,T,C,w,m,g,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var v;(function(f){f[f.MaxRestarts=5]="MaxRestarts"})(v||(v={}));let c=0,h=class extends t.Disposable{constructor(i,n,r,o){super(),this.C=i,this.D=n,this.F=r,this.G=o,this.g=0,this.h=!0,this.i=!1,this.l=this.B(new b.Emitter),this.onPtyHostExit=this.l.event,this.m=this.B(new b.Emitter),this.onPtyHostStart=this.m.event,this.n=this.B(new b.Emitter),this.onPtyHostUnresponsive=this.n.event,this.p=this.B(new b.Emitter),this.onPtyHostResponsive=this.p.event,this.r=this.B(new b.Emitter),this.onPtyHostRequestResolveVariables=this.r.event,this.s=this.B(new b.Emitter),this.onProcessData=this.s.event,this.t=this.B(new b.Emitter),this.onProcessReady=this.t.event,this.u=this.B(new b.Emitter),this.onProcessReplay=this.u.event,this.v=this.B(new b.Emitter),this.onProcessOrphanQuestion=this.v.event,this.w=this.B(new b.Emitter),this.onDidRequestDetach=this.w.event,this.y=this.B(new b.Emitter),this.onDidChangeProperty=this.y.event,this.z=this.B(new b.Emitter),this.onProcessExit=this.z.event,(0,p.registerTerminalPlatformConfiguration)(),this.c=this.J(),this.B((0,t.toDisposable)(()=>this.M())),this.f=this.B(new m.RequestStore(void 0,this.G)),this.f.onCreateRequest(this.r.fire,this.r),[this.a,this.b]=this.L(),this.B(this.D.onDidChangeConfiguration(async a=>{a.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.I()}))}initialize(){this.I()}get H(){return this.D.getValue("terminal.integrated.ignoreProcessNames")}async I(){return this.b.refreshIgnoreProcessNames?.(this.H)}async J(){if(S.isWindows)return process.env;try{return await(0,T.getResolvedShellEnv)(this.G,{_:[]},process.env)}catch(i){return this.G.error("ptyHost was unable to resolve shell environment",i),{}}}L(){const i={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this.F.logsPath],env:{VSCODE_LAST_PTY_ID:c,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this.C.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this.C.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this.C.scrollback}},n=(0,D.parsePtyHostPort)(this.F.args,this.F.isBuilt);n&&(n.break&&n.port?i.debugBrk=n.port:!n.break&&n.port&&(i.debug=n.port));const r=new A.Client(k.FileAccess.asFileUri("bootstrap-fork").fsPath,i);this.m.fire(),I.ProxyChannel.toService(r.getChannel(g.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.N()),this.N(),this.B(r.onDidProcessExit(s=>{this.l.fire(s.code),this.i||(this.g<=v.MaxRestarts?(this.G.error(`ptyHost terminated unexpectedly with code ${s.code}`),this.g++,this.restartPtyHost()):this.G.error(`ptyHost terminated unexpectedly with code ${s.code}, giving up`))}));const a=r.getChannel(g.TerminalIpcChannels.Log);w.LogLevelChannelClient.setLevel(a,this.G.getLevel()),this.B(this.G.onDidChangeLogLevel(()=>{w.LogLevelChannelClient.setLevel(a,this.G.getLevel())}));const l=I.ProxyChannel.toService(r.getChannel(g.TerminalIpcChannels.PtyHost));return this.B(l.onProcessData(s=>this.s.fire(s))),this.B(l.onProcessReady(s=>this.t.fire(s))),this.B(l.onProcessExit(s=>this.z.fire(s))),this.B(l.onDidChangeProperty(s=>this.y.fire(s))),this.B(l.onProcessReplay(s=>this.u.fire(s))),this.B(l.onProcessOrphanQuestion(s=>this.v.fire(s))),this.B(l.onDidRequestDetach(s=>this.w.fire(s))),[r,l]}dispose(){this.i=!0,super.dispose()}async createProcess(i,n,r,o,a,l,s,u,P,F,K){const ne=setTimeout(()=>this.Q(),g.HeartbeatConstants.CreateProcessTimeout),ue=await this.b.createProcess(i,n,r,o,a,l,s,u,P,F,K);return clearTimeout(ne),c=Math.max(c,ue),ue}updateTitle(i,n,r){return this.b.updateTitle(i,n,r)}updateIcon(i,n,r,o){return this.b.updateIcon(i,n,r,o)}attachToProcess(i){return this.b.attachToProcess(i)}detachFromProcess(i,n){return this.b.detachFromProcess(i,n)}listProcesses(){return this.b.listProcesses()}reduceConnectionGraceTime(){return this.b.reduceConnectionGraceTime()}start(i){return this.b.start(i)}shutdown(i,n){return this.b.shutdown(i,n)}input(i,n){return this.b.input(i,n)}processBinary(i,n){return this.b.processBinary(i,n)}resize(i,n,r){return this.b.resize(i,n,r)}acknowledgeDataEvent(i,n){return this.b.acknowledgeDataEvent(i,n)}setUnicodeVersion(i,n){return this.b.setUnicodeVersion(i,n)}getInitialCwd(i){return this.b.getInitialCwd(i)}getCwd(i){return this.b.getCwd(i)}getLatency(i){return this.b.getLatency(i)}orphanQuestionReply(i){return this.b.orphanQuestionReply(i)}installAutoReply(i,n){return this.b.installAutoReply(i,n)}uninstallAllAutoReplies(){return this.b.uninstallAllAutoReplies()}uninstallAutoReply(i){return this.b.uninstallAutoReply(i)}getDefaultSystemShell(i){return this.b.getDefaultSystemShell(i)}async getProfiles(i,n,r,o=!1){const a=await this.c;return(0,d.detectAvailableProfiles)(n,r,o,this.D,a,void 0,this.G,this.S.bind(this,i))}getEnvironment(){return this.b.getEnvironment()}getWslPath(i){return this.b.getWslPath(i)}getRevivedPtyNewId(i){return this.b.getRevivedPtyNewId(i)}setTerminalLayoutInfo(i){return this.b.setTerminalLayoutInfo(i)}async getTerminalLayoutInfo(i){return await this.b.getTerminalLayoutInfo(i)}async requestDetachInstance(i,n){return this.b.requestDetachInstance(i,n)}async acceptDetachInstanceReply(i,n){return this.b.acceptDetachInstanceReply(i,n)}async freePortKillProcess(i){if(!this.b.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.b.freePortKillProcess(i)}async serializeTerminalState(i){return this.b.serializeTerminalState(i)}async reviveTerminalProcesses(i,n){return this.b.reviveTerminalProcesses(i,n)}async refreshProperty(i,n){return this.b.refreshProperty(i,n)}async updateProperty(i,n,r){return this.b.updateProperty(i,n,r)}async restartPtyHost(){this.h=!0,this.M(),[this.a,this.b]=this.L()}M(){this.b.shutdownAll?.(),this.a.dispose()}N(){this.R(),this.j=setTimeout(()=>this.O(),g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier),this.h||(this.h=!0,this.p.fire())}O(){this.G.warn(`No ptyHost heartbeat after ${g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.j=void 0,this.k=setTimeout(()=>this.P(),g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.SecondWaitMultiplier)}P(){this.G.error(`No ptyHost heartbeat after ${(g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier+g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.k=void 0,this.h&&(this.h=!1,this.n.fire())}Q(){this.R(),this.G.error(`No ptyHost response to createProcess after ${g.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.h&&(this.h=!1,this.n.fire())}R(){this.j&&(clearTimeout(this.j),this.j=void 0),this.k&&(clearTimeout(this.k),this.k=void 0)}S(i,n){return this.f.createRequest({workspaceId:i,originalText:n})}async acceptPtyHostResolvedVariables(i,n){this.f.acceptReply(i,n)}};h=Le([Oe(1,E.IConfigurationService),Oe(2,y.IEnvironmentService),Oe(3,C.ILogService)],h),e.PtyHostService=h}),define(ve[38],be([1,0,5]),function(ie,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,b.createDecorator)("IUriIdentityService")}),define(ve[115],be([1,0,38,197,17,20,138,6,2]),function(ie,e,b,t,k,S,I,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class y{constructor(C){this.uri=C,this.time=y._clock++}touch(){return this.time=y._clock++,this}}y._clock=0;let D=class{constructor(C){this.g=C,this.c=new E.DisposableStore,this.f=2**16;const w=new Map,m=g=>{let p=w.get(g.scheme);return p===void 0&&(p=C.hasProvider(g)&&!this.g.hasCapability(g,1024),w.set(g.scheme,p)),p};this.c.add(A.Event.any(C.onDidChangeFileSystemProviderRegistrations,C.onDidChangeFileSystemProviderCapabilities)(g=>{w.delete(g.scheme)})),this.extUri=new S.ExtUri(m),this.d=new I.SkipList((g,p)=>this.extUri.compare(g,p,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(C){this.g.hasProvider(C)&&(C=(0,S.normalizePath)(C));const w=this.d.get(C);return w?w.touch().uri.with({fragment:C.fragment}):(this.d.set(C,new y(C)),this.h(),C)}h(){if(this.d.size<this.f)return;const C=[...this.d.entries()].sort((m,g)=>m[1].touch<g[1].touch?1:m[1].touch>g[1].touch?-1:0);y._clock=0,this.d.clear();const w=this.f*.5;for(let m=0;m<w;m++)this.d.set(C[m][0],C[m][1].touch())}};D=Le([Oe(0,k.IFileService)],D),e.UriIdentityService=D,(0,t.registerSingleton)(b.IUriIdentityService,D,1)}),define(ve[81],be([1,0,184,7,58,20,4,5,13]),function(ie,e,b,t,k,S,I,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");function y(n){const r=n;return typeof r?.id=="string"&&I.URI.isUri(r.uri)}e.isSingleFolderWorkspaceIdentifier=y,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function D(n,r){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,t.basename)(n)}:r?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const o=n;if(o.configuration)return{id:o.id,configPath:o.configuration};if(o.folders.length===1)return{id:o.id,uri:o.folders[0].uri}}e.toWorkspaceIdentifier=D;function T(n){const r=n;return typeof r?.id=="string"&&I.URI.isUri(r.configPath)}e.isWorkspaceIdentifier=T;function C(n){const r=n;if(r?.uri)return{id:r.id,uri:I.URI.revive(r.uri)};const o=n;if(o?.configPath)return{id:o.id,configPath:I.URI.revive(o.configPath)};if(n?.id)return{id:n.id}}e.reviveIdentifier=C;var w;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(w=e.WorkbenchState||(e.WorkbenchState={}));function m(n){const r=n;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&Array.isArray(r.folders))}e.isWorkspace=m;function g(n){const r=n;return!!(r&&typeof r=="object"&&I.URI.isUri(r.uri)&&typeof r.name=="string"&&typeof r.toResource=="function")}e.isWorkspaceFolder=g;class p{constructor(r,o,a,l,s){this.h=r,this.j=a,this.k=l,this.l=s,this.c=k.TernarySearchTree.forUris(this.l,()=>!0),this.folders=o}update(r){this.h=r.id,this.k=r.configuration,this.j=r.transient,this.l=r.l,this.folders=r.folders}get folders(){return this.g}set folders(r){this.g=r,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(r){this.k=r}getFolder(r){return r&&this.c.findSubstr(r)||null}n(){this.c=k.TernarySearchTree.forUris(this.l,()=>!0);for(const r of this.folders)this.c.set(r.uri,r)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=p;class d{constructor(r,o){this.raw=o,this.uri=r.uri,this.index=r.index,this.name=r.name}toResource(r){return(0,S.joinPath)(this.uri,r)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=d;function v(n){return new d({uri:n,index:0,name:(0,S.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=v,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,b.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function c(n,r){return S.extUriBiasedIgnorePathCase.isEqualOrParent(n,r.untitledWorkspacesHome)}e.isUntitledWorkspace=c;function h(n){let r;return I.URI.isUri(n)?r=n:r=n.configuration,r?.scheme===E.Schemas.tmp}e.isTemporaryWorkspace=h;function f(n,r){return!c(n,r)&&!h(n)}e.isSavedWorkspace=f;function i(n){return(typeof n=="string"?(0,t.extname)(n):(0,S.extname)(n))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=i}),define(ve[36],be([1,0,91,6,2,20,4,183,28,17,5,12,81,26,38,14,22,15,11]),function(ie,e,b,t,k,S,I,A,E,y,D,T,C,w,m,g,p,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function c(r){const o=r;return!!(o&&typeof o=="object"&&typeof o.id=="string"&&typeof o.isDefault=="boolean"&&typeof o.name=="string"&&I.URI.isUri(o.location)&&I.URI.isUri(o.globalStorageHome)&&I.URI.isUri(o.settingsResource)&&I.URI.isUri(o.keybindingsResource)&&I.URI.isUri(o.tasksResource)&&I.URI.isUri(o.snippetsHome)&&I.URI.isUri(o.extensionsResource))}e.isUserDataProfile=c,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,D.createDecorator)("IUserDataProfilesService");function h(r,o){return{id:r.id,isDefault:r.isDefault,name:r.name,shortName:r.shortName,location:I.URI.revive(r.location).with({scheme:o}),globalStorageHome:I.URI.revive(r.globalStorageHome).with({scheme:o}),settingsResource:I.URI.revive(r.settingsResource).with({scheme:o}),keybindingsResource:I.URI.revive(r.keybindingsResource).with({scheme:o}),tasksResource:I.URI.revive(r.tasksResource).with({scheme:o}),snippetsHome:I.URI.revive(r.snippetsHome).with({scheme:o}),extensionsResource:I.URI.revive(r.extensionsResource)?.with({scheme:o}),useDefaultFlags:r.useDefaultFlags,isTransient:r.isTransient}}e.reviveProfile=h;function f(r,o,a,l){return{id:r,name:o,location:a,isDefault:!1,shortName:l?.shortName,globalStorageHome:(0,S.joinPath)(a,"globalStorage"),settingsResource:(0,S.joinPath)(a,"settings.json"),keybindingsResource:(0,S.joinPath)(a,"keybindings.json"),tasksResource:(0,S.joinPath)(a,"tasks.json"),snippetsHome:(0,S.joinPath)(a,"snippets"),extensionsResource:(0,S.joinPath)(a,"extensions.json"),useDefaultFlags:l?.useDefaultFlags,isTransient:l?.transient}}e.toUserDataProfile=f;let i=class extends k.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.u.profiles,...this.l.profiles]}constructor(o,a,l,s){super(),this.m=o,this.n=a,this.r=l,this.s=s,this.f=!1,this.g=this.B(new t.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.B(new t.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.B(new t.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.B(new t.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new w.ResourceMap},this.profilesHome=(0,S.joinPath)(this.m.userRoamingDataHome,"profiles")}setEnablement(o){this.f!==o&&(this.t=void 0,this.f=o)}isEnabled(){return this.f}get u(){if(!this.t){const o=[];if(this.f)for(const u of this.H()){if(!u.name||!(0,v.isString)(u.name)||!u.location){this.s.warn("Skipping the invalid stored profile",u.location||u.name);continue}o.push(f((0,S.basename)(u.location),u.name,u.location,{shortName:u.shortName,useDefaultFlags:u.useDefaultFlags}))}let a;const l=new w.ResourceMap,s=f((0,b.hash)(this.m.userRoamingDataHome.path).toString(16),(0,A.localize)(0,null),this.m.userRoamingDataHome);if(o.unshift({...s,extensionsResource:this.M()??s.extensionsResource,isDefault:!0}),o.length){const u=this.J();if(u.workspaces)for(const[P,F]of Object.entries(u.workspaces)){const K=I.URI.parse(P),ne=I.URI.parse(F),ue=o.find(se=>this.r.extUri.isEqual(se.location,ne));ue&&l.set(K,ue)}if(u.emptyWindow){const P=I.URI.parse(u.emptyWindow);a=o.find(F=>this.r.extUri.isEqual(F.location,P))}}this.t={profiles:o,workspaces:l,emptyWindow:a}}return this.t}async createTransientProfile(o){const a="Temp",l=new RegExp(`${(0,d.escapeRegExpCharacters)(a)}\\s(\\d+)`);let s=0;for(const P of this.profiles){const F=l.exec(P.name),K=F?parseInt(F[1]):0;s=K>s?K:s}const u=`${a} ${s+1}`;return this.createProfile((0,b.hash)((0,p.generateUuid)()).toString(16),u,{transient:!0},o)}async createNamedProfile(o,a,l){return this.createProfile((0,b.hash)((0,p.generateUuid)()).toString(16),o,a,l)}async createProfile(o,a,l,s){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const u=await this.v(o,a,l);return s&&await this.setProfileForWorkspace(s,u),u}async v(o,a,l){if(!(0,v.isString)(a)||!a)throw new Error("Name of the profile is mandatory and must be of type `string`");let s=this.k.get(a);return s||(s=(async()=>{try{const u=this.profiles.find(K=>K.name===a||K.id===o);if(u)return u;const P=f(o,a,(0,S.joinPath)(this.profilesHome,o),l);await this.n.createFolder(P.location);const F=[];return this.h.fire({profile:P,join(K){F.push(K)}}),await g.Promises.settled(F),this.C([P],[],[]),P}finally{this.k.delete(a)}})(),this.k.set(a,s)),s}async updateProfile(o,a){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let l=this.profiles.find(s=>s.id===o.id);if(!l)throw new Error(`Profile '${o.name}' does not exist`);return l=f(l.id,a.name??l.name,l.location,{shortName:a.shortName??l.shortName,transient:a.transient??l.isTransient,useDefaultFlags:a.useDefaultFlags??l.useDefaultFlags}),this.C([],[],[l]),l}async removeProfile(o){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(o.isDefault)throw new Error("Cannot remove default profile");const a=this.profiles.find(s=>s.id===o.id);if(!a)throw new Error(`Profile '${o.name}' does not exist`);const l=[];this.i.fire({profile:a,join(s){l.push(s)}});try{await Promise.allSettled(l)}catch(s){this.s.error(s)}a.id===this.u.emptyWindow?.id&&(this.u.emptyWindow=void 0);for(const s of[...this.u.workspaces.keys()])a.id===this.u.workspaces.get(s)?.id&&this.u.workspaces.delete(s);this.G(),this.C([],[a],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(a.location,{recursive:!0})}catch(s){this.s.error(s)}}getOrSetProfileForWorkspace(o,a=this.defaultProfile){if(!this.f)return this.defaultProfile;let l=this.w(o);return l||(l=a,this.profiles.length>1&&this.setProfileForWorkspaceSync(o,l)),l}async setProfileForWorkspace(o,a){this.setProfileForWorkspaceSync(o,a)}setProfileForWorkspaceSync(o,a){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const l=this.profiles.find(s=>s.id===a.id);if(!l)throw new Error(`Profile '${a.name}' does not exist`);this.F(o,l)}unsetWorkspace(o,a){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.F(o,void 0,a)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindow=void 0,this.u.workspaces.clear(),this.u.emptyWindow=void 0,this.G(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const o=await this.n.resolve(this.profilesHome);await Promise.all((o.children||[]).filter(a=>a.isDirectory&&this.profiles.every(l=>!this.r.extUri.isEqual(l.location,a.resource))).map(a=>this.n.del(a.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const o=this.l.profiles.filter(a=>!this.z(a));await Promise.allSettled(o.map(a=>this.removeProfile(a)))}w(o){const a=this.y(o);return I.URI.isUri(a)?this.l.workspaces.get(a)??this.u.workspaces.get(a):this.l.emptyWindow??this.u.emptyWindow}y(o){return(0,C.isSingleFolderWorkspaceIdentifier)(o)?o.uri:(0,C.isWorkspaceIdentifier)(o)?o.configPath:"empty-window"}z(o){return!!(this.r.extUri.isEqual(this.l.emptyWindow?.location,o.location)||[...this.l.workspaces.values()].some(a=>this.r.extUri.isEqual(a.location,o.location))||this.r.extUri.isEqual(this.u.emptyWindow?.location,o.location)||[...this.u.workspaces.values()].some(a=>this.r.extUri.isEqual(a.location,o.location)))}C(o,a,l){const s=[...this.profiles,...o],u=[];this.l.profiles=[];for(let P of s)P.isDefault||a.some(F=>P.id===F.id)||(P=l.find(F=>P.id===F.id)??P,P.isTransient?this.l.profiles.push(P):u.push({location:P.location,name:P.name,shortName:P.shortName,useDefaultFlags:P.useDefaultFlags}));this.I(u),this.t=void 0,this.D(o,a,l)}D(o,a,l){this.g.fire({added:o,removed:a,updated:l,all:this.profiles})}F(o,a,l){l=a?.isTransient?!0:l,l||this.F(o,void 0,!0);const s=this.y(o),u=l?this.l:this.u;I.URI.isUri(s)?(u.workspaces.delete(s),a&&u.workspaces.set(s,a)):u.emptyWindow=a,l||this.G()}G(){const o={};for(const[l,s]of this.u.workspaces.entries())o[l.toString()]=s.location.toString();const a=this.u.emptyWindow?.location.toString();this.L({workspaces:o,emptyWindow:a}),this.t=void 0}H(){return[]}I(o){throw new Error("not implemented")}J(){return{}}L(o){throw new Error("not implemented")}M(){}};i.b="userDataProfiles",i.c="profileAssociations",i=Le([Oe(0,E.IEnvironmentService),Oe(1,y.IFileService),Oe(2,m.IUriIdentityService),Oe(3,T.ILogService)],i),e.UserDataProfilesService=i;class n extends i{constructor(){super(...arguments),this.a=[],this.P={}}H(){return this.a}I(o){this.a=o}J(){return this.P}L(o){this.P=o}}e.InMemoryUserDataProfilesService=n}),define(ve[241],be([1,0,18,14,19,8,6,2,3,4,164,31,33,32,12,25,34,36]),function(ie,e,b,t,k,S,I,A,E,y,D,T,C,w,m,g,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let v=class extends A.Disposable{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}constructor(r,o,a,l,s){super(),this.t=r,this.u=o,this.v=a,this.w=l,this.y=s,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new I.Emitter),this.m=this.B(new I.Emitter),this.n=this.B(new I.Emitter),this.p=this.B(new I.Emitter),this.s=[],this.B((0,A.toDisposable)(()=>{this.j.forEach(({task:u})=>u.cancel()),this.k.forEach(u=>u.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(r){const o=await this.getTargetPlatform();return r.allTargetPlatforms.some(a=>(0,T.isTargetPlatformCompatible)(a,r.allTargetPlatforms,o))}async installFromGallery(r,o={}){try{if(!this.t.isEnabled())throw new T.ExtensionManagementError(D.localize(0,null),T.ExtensionManagementErrorCode.Internal);const a=await this.G(r,!!o.installGivenVersion,!!o.installPreReleaseVersion);return await this.z(a.manifest,a.extension,o)}catch(a){throw f(this.u,"extensionGallery:install",{extensionData:(0,C.getGalleryExtensionTelemetryData)(r),error:a}),this.v.error("Failed to install extension.",r.identifier.id),this.v.error(a),h(a)}}async uninstall(r,o={}){return this.v.trace("ExtensionManagementService#uninstall",r.identifier.id),this.I(r,o)}getExtensionsControlManifest(){const r=new Date().getTime();return(!this.g||r-this.h>1e3*60*5)&&(this.g=this.O(),this.h=r),this.g}registerParticipant(r){this.s.push(r)}async z(r,o,a){const l={...a,installOnlyNewlyAddedFromExtensionPack:y.URI.isUri(o)?a.installOnlyNewlyAddedFromExtensionPack:!0,profileLocation:(0,w.isApplicationScopedExtension)(r)?this.y.defaultProfile.extensionsResource:a.profileLocation??this.P()},s=ue=>`${C.ExtensionKey.create(ue).toString()}${l.profileLocation?`-${l.profileLocation.toString()}`:""}`;if(!y.URI.isUri(o)){const ue=this.j.get(s(o));if(ue){this.v.info("Extensions is already requested to install",o.identifier.id);const{local:se}=await ue.task.waitUntilTaskIsFinished();return se}}const u=[],P=[],F=[],K=this.Q(r,o,l);y.URI.isUri(o)||this.j.set(s(o),{task:K,waitingTasks:[]}),this.l.fire({identifier:K.identifier,source:o,profileLocation:l.profileLocation}),this.v.info("Installing extension:",K.identifier.id),u.push({task:K,manifest:r});let ne=!1;try{if(l.donotIncludePackAndDependencies)this.v.info("Installing the extension without checking dependencies and pack",K.identifier.id);else try{const se=await this.F(K.identifier,r,!!l.installOnlyNewlyAddedFromExtensionPack,!!l.installPreReleaseVersion,l.profileLocation),U=await this.getInstalled(void 0,l.profileLocation);for(const{gallery:Q,manifest:z}of(0,b.distinct)(se,({gallery:G})=>G.identifier.id)){ne=ne||!!z.extensionDependencies?.some(ce=>(0,C.areSameExtensions)({id:ce},K.identifier));const G=s(Q),X=this.j.get(G);if(X){if(this.C(K,X.task)){const ce=X.task.identifier;this.v.info("Waiting for already requested installing extension",ce.id,K.identifier.id),X.waitingTasks.push(K),P.push(I.Event.toPromise(I.Event.filter(this.onDidInstallExtensions,L=>L.some(N=>(0,C.areSameExtensions)(N.identifier,ce)))).then(L=>{if(this.v.info("Finished waiting for already requested installing extension",ce.id,K.identifier.id),!L.find(V=>(0,C.areSameExtensions)(V.identifier,ce))?.local)throw new Error(`Extension ${ce.id} is not installed`)}))}}else if(!U.some(({identifier:ce})=>(0,C.areSameExtensions)(ce,Q.identifier))){const ce=this.Q(z,Q,{...l,donotIncludePackAndDependencies:!0});this.j.set(G,{task:ce,waitingTasks:[K]}),this.l.fire({identifier:ce.identifier,source:Q,profileLocation:l.profileLocation}),this.v.info("Installing extension:",ce.identifier.id,K.identifier.id),u.push({task:ce,manifest:z})}}}catch(se){if(y.URI.isUri(K.source))(0,b.isNonEmptyArray)(r.extensionDependencies)&&this.v.warn("Cannot install dependencies of extension:",K.identifier.id,se.message),(0,b.isNonEmptyArray)(r.extensionPack)&&this.v.warn("Cannot install packed extensions of extension:",K.identifier.id,se.message);else throw this.v.error("Error while preparing to install dependencies and extension packs of the extension:",K.identifier.id),se}const ue=u.reduce((se,{task:U,manifest:Q})=>(se.set(U.identifier.id.toLowerCase(),{task:U,manifest:Q}),se),new Map);for(;ue.size;){let se;const U=[...ue.values()].filter(({manifest:Q})=>!Q.extensionDependencies?.some(z=>ue.has(z.toLowerCase())));U.length?se=ue.size===1?U:U.filter(({task:Q})=>!(Q===K&&!ne)):(this.v.info("Found extensions with circular dependencies",U.map(({task:Q})=>Q.identifier.id)),se=[...ue.values()]),await this.D(se.map(async({task:Q})=>{const z=new Date().getTime();try{const{local:G}=await Q.run();if(await this.D(this.s.map(X=>X.postInstall(G,Q.source,l,k.CancellationToken.None))),!y.URI.isUri(Q.source)){const X=Q.operation===3,ce=X?void 0:(new Date().getTime()-Q.source.lastUpdated)/1e3;if(f(this.u,X?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,C.getGalleryExtensionTelemetryData)(Q.source),wasVerified:Q.wasVerified,duration:new Date().getTime()-z,durationSinceUpdate:ce}),E.isWeb&&Q.operation!==3)try{await this.t.reportStatistic(G.manifest.publisher,G.manifest.name,G.manifest.version,"install")}catch{}}F.push({local:G,identifier:Q.identifier,operation:Q.operation,source:Q.source,context:l.context,profileLocation:l.profileLocation,applicationScoped:G.isApplicationScoped})}catch(G){throw y.URI.isUri(Q.source)||f(this.u,Q.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,C.getGalleryExtensionTelemetryData)(Q.source),wasVerified:Q.wasVerified,duration:new Date().getTime()-z,error:G}),this.v.error("Error while installing the extension:",Q.identifier.id),G}finally{ue.delete(Q.identifier.id.toLowerCase())}}))}return P.length&&await this.D(P),F.forEach(({identifier:se})=>this.v.info("Extension installed successfully:",se.id)),this.m.fire(F),F.filter(({identifier:se})=>(0,C.areSameExtensions)(se,K.identifier))[0].local}catch(ue){if(u.forEach(({task:se})=>se.cancel()),F.length)try{const se=await Promise.allSettled(F.map(({local:U})=>this.R(U,{versionOnly:!0,profileLocation:l.profileLocation}).run()));for(let U=0;U<se.length;U++){const Q=se[U],{identifier:z}=F[U];Q.status==="fulfilled"?this.v.info("Rollback: Uninstalled extension",z.id):this.v.warn("Rollback: Error while uninstalling extension",z.id,(0,S.getErrorMessage)(Q.reason))}}catch(se){this.v.warn("Error while rolling back extensions",(0,S.getErrorMessage)(se),F.map(({identifier:U})=>U.id))}throw this.m.fire(u.map(({task:se})=>({identifier:se.identifier,operation:2,source:se.source,context:l.context,profileLocation:l.profileLocation}))),ue}finally{for(const{task:ue}of u)ue.source&&!y.URI.isUri(ue.source)&&this.j.delete(s(ue.source))}}C(r,o){for(const[,{task:a,waitingTasks:l}]of this.j.entries())if(a===r&&(l.includes(o)||l.some(s=>this.C(s,o)))||a===o&&l[0]&&!this.C(r,l[0]))return!1;return!0}async D(r){const o=[],a=[],l=await Promise.allSettled(r);for(const s of l)s.status==="fulfilled"?o.push(s.value):a.push(s.reason);if(a.length)throw c(a);return o}async F(r,o,a,l,s){if(!this.t.isEnabled())return[];const u=await this.getInstalled(void 0,s),P=[],F=[],K=async(ne,ue)=>{P.push(ne);const se=ue.extensionDependencies||[],U=[...se];if(ue.extensionPack){const Q=a?u.find(z=>(0,C.areSameExtensions)(z.identifier,ne)):void 0;for(const z of ue.extensionPack)Q&&Q.manifest.extensionPack&&Q.manifest.extensionPack.some(G=>(0,C.areSameExtensions)({id:G},{id:z}))||U.every(G=>!(0,C.areSameExtensions)({id:G},{id:z}))&&U.push(z)}if(U.length){const Q=U.filter(z=>P.every(G=>!(0,C.areSameExtensions)(G,{id:z})));if(Q.length){const z=await this.t.getExtensions(Q.map(G=>({id:G,preRelease:l})),k.CancellationToken.None);for(const G of z){if(P.find(L=>(0,C.areSameExtensions)(L,G.identifier)))continue;const X=se.some(L=>(0,C.areSameExtensions)({id:L},G.identifier));let ce;try{ce=await this.G(G,!1,l)}catch(L){if(L instanceof T.ExtensionManagementError&&L.code===T.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!X){this.v.info("Skipping the packed extension as it cannot be installed",G.identifier.id);continue}else throw L}F.push({gallery:ce.extension,manifest:ce.manifest}),await K(ce.extension.identifier,ce.manifest)}}}};return await K(r,o),F}async G(r,o,a){if((await this.getExtensionsControlManifest()).malicious.some(P=>(0,C.areSameExtensions)(r.identifier,P)))throw new T.ExtensionManagementError(D.localize(1,null,r.identifier.id),T.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(r)){const P=await this.getTargetPlatform();throw new T.ExtensionManagementError(D.localize(2,null,r.identifier.id,this.w.nameLong,(0,T.TargetPlatformToString)(P)),T.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const s=await this.H(r,o,a);if(s){if(a&&!o&&r.hasPreReleaseVersion&&!s.properties.isPreReleaseVersion)throw new T.ExtensionManagementError(D.localize(3,null,r.identifier.id,this.w.nameLong,this.w.version),T.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!a&&r.properties.isPreReleaseVersion&&(await this.t.getExtensions([r.identifier],k.CancellationToken.None))[0]?new T.ExtensionManagementError(D.localize(4,null,r.identifier.id),T.ExtensionManagementErrorCode.ReleaseVersionNotFound):new T.ExtensionManagementError(D.localize(5,null,r.identifier.id,this.w.nameLong,this.w.version),T.ExtensionManagementErrorCode.Incompatible);this.v.info("Getting Manifest...",s.identifier.id);const u=await this.t.getManifest(s,k.CancellationToken.None);if(u===null)throw new T.ExtensionManagementError(`Missing manifest for extension ${r.identifier.id}`,T.ExtensionManagementErrorCode.Invalid);if(u.version!==s.version)throw new T.ExtensionManagementError(`Cannot install '${r.identifier.id}' extension because of version mismatch in Marketplace`,T.ExtensionManagementErrorCode.Invalid);return{extension:s,manifest:u}}async H(r,o,a){const l=await this.getTargetPlatform();let s=null;return!o&&r.hasPreReleaseVersion&&r.properties.isPreReleaseVersion!==a&&(s=(await this.t.getExtensions([{...r.identifier,preRelease:a}],{targetPlatform:l,compatible:!0},k.CancellationToken.None))[0]||null),!s&&await this.t.isExtensionCompatible(r,a,l)&&(s=r),s||(o?s=(await this.t.getExtensions([{...r.identifier,version:r.version}],{targetPlatform:l,compatible:!0},k.CancellationToken.None))[0]||null:s=await this.t.getCompatibleExtension(r,a,l)),s}async I(r,o){const a={...o,profileLocation:r.isApplicationScoped?this.y.defaultProfile.extensionsResource:o.profileLocation??this.P()},l=ne=>`${ne.id.toLowerCase()}${a.versionOnly?`-${r.manifest.version}`:""}${a.profileLocation?`@${a.profileLocation.toString()}`:""}`,s=this.k.get(l(r.identifier));if(s)return this.v.info("Extensions is already requested to uninstall",r.identifier.id),s.waitUntilTaskIsFinished();const u=ne=>{const ue=this.R(ne,a);return this.k.set(l(ue.extension.identifier),ue),a.profileLocation?this.v.info("Uninstalling extension from the profile:",`${ne.identifier.id}@${ne.manifest.version}`,a.profileLocation.toString()):this.v.info("Uninstalling extension:",`${ne.identifier.id}@${ne.manifest.version}`),this.n.fire({identifier:ne.identifier,profileLocation:a.profileLocation,applicationScoped:ne.isApplicationScoped}),ue},P=(ne,ue)=>{ue?a.profileLocation?this.v.error("Failed to uninstall extension from the profile:",`${ne.identifier.id}@${ne.manifest.version}`,a.profileLocation.toString(),ue.message):this.v.error("Failed to uninstall extension:",`${ne.identifier.id}@${ne.manifest.version}`,ue.message):a.profileLocation?this.v.info("Successfully uninstalled extension from the profile",`${ne.identifier.id}@${ne.manifest.version}`,a.profileLocation.toString()):this.v.info("Successfully uninstalled extension:",`${ne.identifier.id}@${ne.manifest.version}`),f(this.u,"extensionGallery:uninstall",{extensionData:(0,C.getLocalExtensionTelemetryData)(ne),error:ue}),this.p.fire({identifier:ne.identifier,error:ue?.code,profileLocation:a.profileLocation,applicationScoped:ne.isApplicationScoped})},F=[],K=[];try{F.push(u(r));const ne=await this.getInstalled(1,a.profileLocation);if(a.donotIncludePack)this.v.info("Uninstalling the extension without including packed extension",`${r.identifier.id}@${r.manifest.version}`);else{const ue=this.M(r,ne);for(const se of ue)this.k.has(l(se.identifier))?this.v.info("Extensions is already requested to uninstall",se.identifier.id):F.push(u(se))}a.donotCheckDependents?this.v.info("Uninstalling the extension without checking dependents",`${r.identifier.id}@${r.manifest.version}`):this.J(F.map(ue=>ue.extension),ne,r),await this.D(F.map(async ue=>{try{if(await ue.run(),await this.D(this.s.map(se=>se.postUninstall(ue.extension,a,k.CancellationToken.None))),ue.extension.identifier.uuid)try{await this.t.reportStatistic(ue.extension.manifest.publisher,ue.extension.manifest.name,ue.extension.manifest.version,"uninstall")}catch{}P(ue.extension)}catch(se){const U=se instanceof T.ExtensionManagementError?se:new T.ExtensionManagementError((0,S.getErrorMessage)(se),T.ExtensionManagementErrorCode.Internal);throw P(ue.extension,U),U}finally{K.push(ue)}}))}catch(ne){const ue=ne instanceof T.ExtensionManagementError?ne:new T.ExtensionManagementError((0,S.getErrorMessage)(ne),T.ExtensionManagementErrorCode.Internal);for(const se of F){try{se.cancel()}catch{}K.includes(se)||P(se.extension,ue)}throw ue}finally{for(const ne of F)this.k.delete(l(ne.extension.identifier))||this.v.warn("Uninstallation task is not found in the cache",ne.extension.identifier.id)}}J(r,o,a){for(const l of r){const s=this.N(l,o);if(s.length){const u=s.filter(P=>!r.some(F=>(0,C.areSameExtensions)(F.identifier,P.identifier)));if(u.length)throw new Error(this.L(l,u,a))}}}L(r,o,a){return a===r?o.length===1?D.localize(6,null,a.manifest.displayName||a.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?D.localize(7,null,a.manifest.displayName||a.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):D.localize(8,null,a.manifest.displayName||a.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):o.length===1?D.localize(9,null,a.manifest.displayName||a.manifest.name,r.manifest.displayName||r.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?D.localize(10,null,a.manifest.displayName||a.manifest.name,r.manifest.displayName||r.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):D.localize(11,null,a.manifest.displayName||a.manifest.name,r.manifest.displayName||r.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name)}M(r,o,a=[]){if(a.indexOf(r)!==-1)return[];a.push(r);const l=r.manifest.extensionPack?r.manifest.extensionPack:[];if(l.length){const s=o.filter(P=>!P.isBuiltin&&l.some(F=>(0,C.areSameExtensions)({id:F},P.identifier))),u=[];for(const P of s)u.push(...this.M(P,o,a));return[...s,...u]}return[]}N(r,o){return o.filter(a=>a.manifest.extensionDependencies&&a.manifest.extensionDependencies.some(l=>(0,C.areSameExtensions)({id:l},r.identifier)))}async O(){try{this.v.trace("ExtensionManagementService.refreshReportedCache");const r=await this.t.getExtensionsControlManifest();return this.v.trace("ExtensionManagementService.refreshControlCache",r),r}catch{return this.v.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};v=Le([Oe(0,T.IExtensionGalleryService),Oe(1,p.ITelemetryService),Oe(2,m.ILogService),Oe(3,g.IProductService),Oe(4,d.IUserDataProfilesService)],v),e.AbstractExtensionManagementService=v;function c(n){const r=Array.isArray(n)?n:[n];return r.length===1?r[0]instanceof Error?r[0]:new Error(r[0]):r.reduce((o,a)=>new Error(`${o.message}${o.message?",":""}${a instanceof Error?a.message:a}`),new Error(""))}e.joinErrors=c;function h(n){if(n instanceof T.ExtensionManagementError)return n;const r=new T.ExtensionManagementError(n.message,T.ExtensionManagementErrorCode.Internal);return r.stack=n.stack,r}function f(n,r,{extensionData:o,wasVerified:a,duration:l,error:s,durationSinceUpdate:u}){let P,F;s&&(s instanceof T.ExtensionManagementError?(P=s.code,s.code===T.ExtensionManagementErrorCode.Signature&&(F=s.message)):P=T.ExtensionManagementErrorCode.Internal),n.publicLog(r,{...o,wasVerified:a,success:!s,duration:l,errorcode:P,errorcodeDetail:F,durationSinceUpdate:u})}e.reportTelemetry=f;class i{constructor(){this.d=new t.Barrier}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,t.createCancelablePromise)(r=>this.h(r))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,t.createCancelablePromise)(r=>new Promise((o,a)=>{const l=r.onCancellationRequested(()=>{l.dispose(),a(new S.CancellationError)})})),this.d.open()),this.g.cancel()}}e.AbstractExtensionTask=i}),define(ve[53],be([1,0,14,16,2,6,26,4,33,32,17,5,12,36,38]),function(ie,e,b,t,k,S,I,A,E,y,D,T,C,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,T.createDecorator)("IExtensionsProfileScannerService");let g=class extends k.Disposable{constructor(v,c,h,f){super(),this.h=v,this.i=c,this.j=h,this.k=f,this.a=this.B(new S.Emitter),this.onAddExtensions=this.a.event,this.b=this.B(new S.Emitter),this.onDidAddExtensions=this.b.event,this.c=this.B(new S.Emitter),this.onRemoveExtensions=this.c.event,this.f=this.B(new S.Emitter),this.onDidRemoveExtensions=this.f.event,this.g=new I.ResourceMap}scanProfileExtensions(v){return this.l(v)}async addExtensionsToProfile(v,c){const h=[],f=[];try{return await this.l(c,i=>{const n=[];for(const r of i)v.some(([o])=>(0,E.areSameExtensions)(o.identifier,r.identifier)&&o.manifest.version!==r.version)?h.push(r):n.push(r);for(const[r,o]of v)if(!n.some(a=>(0,E.areSameExtensions)(a.identifier,r.identifier)&&a.version===r.manifest.version)){const a={identifier:r.identifier,version:r.manifest.version,location:r.location,metadata:o};f.push(a),n.push(a)}return f.length&&this.a.fire({extensions:f,profileLocation:c}),h.length&&this.c.fire({extensions:h,profileLocation:c}),n}),f.length&&this.b.fire({extensions:f,profileLocation:c}),h.length&&this.f.fire({extensions:h,profileLocation:c}),f}catch(i){throw f.length&&this.b.fire({extensions:f,error:i,profileLocation:c}),h.length&&this.f.fire({extensions:h,error:i,profileLocation:c}),i}}async removeExtensionFromProfile(v,c){const h=[];this.c.fire({extensions:h,profileLocation:c});try{await this.l(c,f=>{const i=[];for(const n of f)(0,E.areSameExtensions)(n.identifier,v.identifier)?h.push(n):i.push(n);return h.length&&this.c.fire({extensions:h,profileLocation:c}),i}),h.length&&this.f.fire({extensions:h,profileLocation:c})}catch(f){throw h.length&&this.f.fire({extensions:h,error:f,profileLocation:c}),f}}async l(v,c){return this.p(v).queue(async()=>{let h=[],f;try{const i=await this.h.readFile(v);f=JSON.parse(i.value.toString())}catch(i){if((0,D.toFileOperationResult)(i)!==1)throw i;this.j.extUri.isEqual(v,this.i.defaultProfile.extensionsResource)&&(f=await this.n())}if(f)for(const i of f){if(!i.identifier){this.k.info("Ignoring invalid extension while scanning. Identifier does not exist.",i);continue}if(!i.location){this.k.info("Ignoring invalid extension while scanning. Location does not exist.",i);continue}if(!i.version){this.k.info("Ignoring invalid extension while scanning. Version does not exist.",i);continue}h.push({identifier:i.identifier,location:A.URI.revive(i.location),version:i.version,metadata:i.metadata})}if(c){h=c(h);const i=h.map(n=>({identifier:n.identifier,version:n.version,location:n.location.toJSON(),metadata:n.metadata}));await this.h.writeFile(v,t.VSBuffer.fromString(JSON.stringify(i)))}return h})}async n(){return this.m||(this.m=(async()=>{const v=this.j.extUri.joinPath(this.i.defaultProfile.location,"extensions.json");let c;try{c=(await this.h.readFile(v)).value.toString()}catch(f){if((0,D.toFileOperationResult)(f)===1)return;throw f}this.k.info("Migrating extensions from old default profile location",v.toString());let h;try{const f=JSON.parse(c);Array.isArray(f)&&f.every(i=>!!(i&&typeof i=="object"&&(0,y.isIExtensionIdentifier)(i.identifier)&&p(i.location)&&i.version&&typeof i.version=="string"))?h=f:this.k.warn("Skipping migrating from old default profile locaiton: Found invalid data",f)}catch(f){this.k.error(f)}if(h)try{await this.h.createFile(this.i.defaultProfile.extensionsResource,t.VSBuffer.fromString(JSON.stringify(h)),{overwrite:!1}),this.k.info("Migrated extensions from old default profile location to new location",v.toString(),this.i.defaultProfile.extensionsResource.toString())}catch(f){if((0,D.toFileOperationResult)(f)===3)this.k.info("Migration from old default profile location to new location is done by another window",v.toString(),this.i.defaultProfile.extensionsResource.toString());else throw f}try{await this.h.del(v)}catch(f){(0,D.toFileOperationResult)(f)!==1&&this.k.error(f)}return h})()),this.m}p(v){let c=this.g.get(v);return c||(c=new b.Queue,this.g.set(v,c)),c}};g=Le([Oe(0,D.IFileService),Oe(1,w.IUserDataProfilesService),Oe(2,m.IUriIdentityService),Oe(3,C.ILogService)],g),e.ExtensionsProfileScannerService=g;function p(d){return d?typeof d.path=="string"&&typeof d.scheme=="string":!1}}),define(ve[54],be([1,0,18,14,23,16,8,69,147,2,13,7,3,20,49,70,11,4,168,28,33,32,73,17,5,12,25,6,47,53,36,38,194,195]),function(ie,e,b,t,k,S,I,A,E,y,D,T,C,w,m,g,p,d,v,c,h,f,i,n,r,o,a,l,s,u,P,F,K,ne){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var ue;(function(ce){function L(N,V){if(N===V)return!0;const ee=Object.keys(N),oe=new Set;for(const ge of Object.keys(V))oe.add(ge);if(ee.length!==oe.size)return!1;for(const ge of ee){if(N[ge]!==V[ge])return!1;oe.delete(ge)}return oe.size===0}ce.equals=L})(ue=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,r.createDecorator)("IExtensionsScannerService");let se=class extends y.Disposable{constructor(L,N,V,ee,oe,ge,fe,R,M,W,Y,re){super(),this.systemExtensionsLocation=L,this.userExtensionsLocation=N,this.l=V,this.m=ee,this.n=oe,this.p=ge,this.r=fe,this.s=R,this.t=M,this.u=W,this.v=Y,this.w=re,this.g=this.B(new l.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,w.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.w.createInstance(z,(0,w.joinPath)(this.m,f.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.B(this.w.createInstance(z,(0,w.joinPath)(this.m,f.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.B(this.w.createInstance(Q,this.h)),this.z=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.y||(this.y=(0,h.computeTargetPlatform)(this.r,this.s)),this.y}async scanAllExtensions(L,N,V){const[ee,oe]=await Promise.all([this.scanSystemExtensions(L),this.scanUserExtensions(N)]),ge=V?await this.scanExtensionsUnderDevelopment(L,[...ee,...oe]):[];return this.D(ee,oe,ge,await this.getTargetPlatform(),!0)}async scanSystemExtensions(L){const N=[];N.push(this.F(!!L.useCache,L.language)),N.push(this.G(L.language,!!L.checkControlFile));const[V,ee]=await Promise.all(N);return this.C([...V,...ee],0,L,!1)}async scanUserExtensions(L){const N=L.profileLocation??this.userExtensionsLocation;this.s.trace("Started scanning user extensions",N);const V=await this.I(N,!!L.profileLocation,1,!L.includeUninstalled,L.language);let oe=await(L.useCache&&!V.devMode&&V.excludeObsolete?this.j:this.k).scanExtensions(V);return oe=await this.C(oe,1,L,!0),this.s.trace("Scanned user extensions:",oe.length),oe}async scanExtensionsUnderDevelopment(L,N){if(this.t.isExtensionDevelopment&&this.t.extensionDevelopmentLocationURI){const V=(await Promise.all(this.t.extensionDevelopmentLocationURI.filter(ee=>ee.scheme===D.Schemas.file).map(async ee=>{const oe=await this.I(ee,!1,1,!0,L.language,!1);return(await this.k.scanOneOrMultipleExtensions(oe)).map(fe=>(fe.type=N.find(R=>(0,h.areSameExtensions)(R.identifier,fe.identifier))?.type??fe.type,this.k.validate(fe,oe)))}))).flat();return this.C(V,"development",L,!0)}return[]}async scanExistingExtension(L,N,V){const ee=await this.I(L,!1,N,!0,V.language),oe=await this.k.scanExtension(ee);return!oe||!V.includeInvalid&&!oe.isValid?null:oe}async scanOneOrMultipleExtensions(L,N,V){const ee=await this.I(L,!1,N,!0,V.language),oe=await this.k.scanOneOrMultipleExtensions(ee);return this.C(oe,N,V,!0)}async scanMetadata(L){const N=(0,w.joinPath)(L,"package.json"),V=(await this.r.readFile(N)).value.toString();return JSON.parse(V).__metadata}async updateMetadata(L,N){const V=(0,w.joinPath)(L,"package.json"),ee=(await this.r.readFile(V)).value.toString(),oe=JSON.parse(ee);N.isMachineScoped=N.isMachineScoped||void 0,N.isBuiltin=N.isBuiltin||void 0,N.installedTimestamp=N.installedTimestamp||void 0,oe.__metadata={...oe.__metadata,...N},await this.r.writeFile((0,w.joinPath)(L,"package.json"),S.VSBuffer.fromString(JSON.stringify(oe,null,"	")))}initializeDefaultProfileExtensions(){return this.z||(this.z=(async()=>{try{const L=this.v.extUri.joinPath(this.userExtensionsLocation,".init-default-profile-extensions");if(await this.r.exists(L))return;if(!await this.r.exists(this.n.defaultProfile.extensionsResource)&&!await this.r.exists(this.v.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"))){this.s.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const N=await this.scanUserExtensions({includeInvalid:!0});await this.p.addExtensionsToProfile(N.map(V=>[V,V.metadata]),this.n.defaultProfile.extensionsResource),this.s.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}try{await this.r.createFile(L,S.VSBuffer.fromString(""))}catch(N){(0,n.toFileOperationResult)(N)!==1&&this.s.warn("Failed to create default profile extensions initialize marker in extensions installation folder.",this.userExtensionsLocation.toString(),(0,I.getErrorMessage)(N))}}catch(L){throw this.s.error(L),L}})()),this.z}async C(L,N,V,ee){return V.includeAllVersions||(L=this.D(N===0?L:void 0,N===1?L:void 0,N==="development"?L:void 0,await this.getTargetPlatform(),ee)),V.includeInvalid||(L=L.filter(oe=>oe.isValid)),L.sort((oe,ge)=>{const fe=T.basename(oe.location.fsPath),R=T.basename(ge.location.fsPath);return fe<R?-1:fe>R?1:0})}D(L,N,V,ee,oe){const ge=(R,M,W)=>{if(R.isValid&&!M.isValid)return!1;if(R.isValid===M.isValid){if(oe&&m.gt(R.manifest.version,M.manifest.version))return this.s.debug(`Skipping extension ${M.location.path} with lower version ${M.manifest.version} in favour of ${R.location.path} with version ${R.manifest.version}`),!1;if(m.eq(R.manifest.version,M.manifest.version)){if(R.type===0)return this.s.debug(`Skipping extension ${M.location.path} in favour of system extension ${R.location.path} with same version`),!1;if(R.targetPlatform===ee)return this.s.debug(`Skipping extension ${M.location.path} from different target platform ${M.targetPlatform}`),!1}}return W?this.s.warn(`Overwriting user extension ${R.location.path} with ${M.location.path}.`):this.s.debug(`Overwriting user extension ${R.location.path} with ${M.location.path}.`),!0},fe=new Map;return L?.forEach(R=>{const M=f.ExtensionIdentifier.toKey(R.identifier.id),W=fe.get(M);(!W||ge(W,R,!1))&&fe.set(M,R)}),N?.forEach(R=>{const M=f.ExtensionIdentifier.toKey(R.identifier.id),W=fe.get(M);if(!W&&L&&R.type===0){this.s.debug(`Skipping obsolete system extension ${R.location.path}.`);return}(!W||ge(W,R,!1))&&fe.set(M,R)}),V?.forEach(R=>{const M=f.ExtensionIdentifier.toKey(R.identifier.id),W=fe.get(M);(!W||ge(W,R,!0))&&fe.set(M,R),fe.set(M,R)}),[...fe.values()]}async F(L,N){this.s.trace("Started scanning system extensions");const V=await this.I(this.systemExtensionsLocation,!1,0,!0,N),oe=await(L&&!V.devMode?this.i:this.k).scanExtensions(V);return this.s.trace("Scanned system extensions:",oe.length),oe}async G(L,N){const V=this.t.isBuilt?[]:this.u.builtInExtensions;if(!V?.length)return[];this.s.trace("Started scanning dev system extensions");const ee=N?await this.H():{},oe=[],ge=d.URI.file(T.normalize(T.join(D.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const R of V){const M=ee[R.name]||"marketplace";switch(M){case"disabled":break;case"marketplace":oe.push((0,w.joinPath)(ge,R.name));break;default:oe.push(d.URI.file(M));break}}const fe=await Promise.all(oe.map(async R=>this.k.scanExtension(await this.I(R,!1,0,!0,L))));return this.s.trace("Scanned dev system extensions:",fe.length),(0,b.coalesce)(fe)}async H(){try{const L=await this.r.readFile(this.l);return JSON.parse(L.value.toString())}catch{return{}}}async I(L,N,V,ee,oe,ge=!0){const fe=await this.f(oe??C.language),R=await this.J(L),M=N&&!this.v.extUri.isEqual(L,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,W=M?await this.J(M):void 0;return new U(L,R,M,W,N,V,ee,ge,this.u.version,this.u.date,this.u.commit,!this.t.isBuilt,oe,fe)}async J(L){try{const N=await this.r.stat(L);if(typeof N.mtime=="number")return N.mtime}catch{}}};se=Le([Oe(4,P.IUserDataProfilesService),Oe(5,u.IExtensionsProfileScannerService),Oe(6,n.IFileService),Oe(7,o.ILogService),Oe(8,c.IEnvironmentService),Oe(9,a.IProductService),Oe(10,F.IUriIdentityService),Oe(11,r.IInstantiationService)],se),e.AbstractExtensionsScannerService=se;class U{constructor(L,N,V,ee,oe,ge,fe,R,M,W,Y,re,me,$){this.location=L,this.mtime=N,this.applicationExtensionslocation=V,this.applicationExtensionslocationMtime=ee,this.profile=oe,this.type=ge,this.excludeObsolete=fe,this.validate=R,this.productVersion=M,this.productDate=W,this.productCommit=Y,this.devMode=re,this.language=me,this.translations=$}static createNlsConfiguration(L){return{language:L.language,pseudo:L.language==="pseudo",devMode:L.devMode,translations:L.translations}}static equals(L,N){return(0,w.isEqual)(L.location,N.location)&&L.mtime===N.mtime&&(0,w.isEqual)(L.applicationExtensionslocation,N.applicationExtensionslocation)&&L.applicationExtensionslocationMtime===N.applicationExtensionslocationMtime&&L.profile===N.profile&&L.type===N.type&&L.excludeObsolete===N.excludeObsolete&&L.validate===N.validate&&L.productVersion===N.productVersion&&L.productDate===N.productDate&&L.productCommit===N.productCommit&&L.devMode===N.devMode&&L.language===N.language&&ue.equals(L.translations,N.translations)}}let Q=class extends y.Disposable{constructor(L,N,V,ee,oe){super(),this.f=L,this.g=N,this.h=V,this.i=ee,this.j=oe}async scanExtensions(L){const N=L.profile?await this.l(L):await this.k(L);let V={};if(L.excludeObsolete&&L.type===1)try{const ee=(await this.i.readFile(this.f)).value.toString();V=JSON.parse(ee)}catch{}return(0,p.isEmptyObject)(V)?N:N.filter(ee=>!V[h.ExtensionKey.create(ee).toString()])}async k(L){const N=await this.i.resolve(L.location);if(!N.children?.length)return[];const V=await Promise.all(N.children.map(async ee=>{if(!ee.isDirectory||L.type===1&&(0,w.basename)(ee.resource).indexOf(".")===0)return null;const oe=new U(ee.resource,L.mtime,L.applicationExtensionslocation,L.applicationExtensionslocationMtime,L.profile,L.type,L.excludeObsolete,L.validate,L.productVersion,L.productDate,L.productCommit,L.devMode,L.language,L.translations);return this.scanExtension(oe)}));return(0,b.coalesce)(V).sort((ee,oe)=>ee.location.path<oe.location.path?-1:1)}async l(L){let N=await this.m(L.location,()=>!0,L);if(L.applicationExtensionslocation&&!this.h.extUri.isEqual(L.location,L.applicationExtensionslocation)){N=N.filter(ee=>!ee.metadata?.isApplicationScoped);const V=await this.m(L.applicationExtensionslocation,ee=>!!ee.metadata?.isApplicationScoped,L);N.push(...V)}return N}async m(L,N,V){const ee=await this.g.scanProfileExtensions(L);if(!ee.length)return[];const oe=await Promise.all(ee.map(async ge=>{if(N(ge)){const fe=new U(ge.location,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(fe,ge.metadata)}return null}));return(0,b.coalesce)(oe)}async scanOneOrMultipleExtensions(L){try{if(await this.i.exists((0,w.joinPath)(L.location,"package.json"))){const N=await this.scanExtension(L);return N?[N]:[]}else return await this.scanExtensions(L)}catch(N){return this.j.error(`Error scanning extensions at ${L.location.path}:`,(0,I.getErrorMessage)(N)),[]}}async scanExtension(L,N){try{let V=await this.scanExtensionManifest(L.location);if(V){V.publisher||(V.publisher=f.UNDEFINED_PUBLISHER),N=N??V.__metadata,delete V.__metadata;const ee=(0,h.getGalleryExtensionId)(V.publisher,V.name),oe=N?.id?{id:ee,uuid:N.id}:{id:ee},ge=N?.isSystem?0:L.type,fe=ge===0||!!N?.isBuiltin;ne.ImplicitActivationEvents.updateManifest(V),V=await this.n(L.location,V,U.createNlsConfiguration(L));const R={type:ge,identifier:oe,manifest:V,location:L.location,isBuiltin:fe,targetPlatform:N?.targetPlatform??"undefined",metadata:N,isValid:!0,validations:[]};return L.validate?this.validate(R,L):R}}catch(V){L.type!==0&&this.j.error(V)}return null}validate(L,N){let V=!0;const ee=(0,i.validateExtensionManifest)(N.productVersion,N.productDate,N.location,L.manifest,L.isBuiltin);for(const[oe,ge]of ee)oe===g.default.Error&&(V=!1,this.j.error(this.t(N.location,ge)));return L.isValid=V,L.validations=ee,L}async scanExtensionManifest(L){const N=(0,w.joinPath)(L,"package.json");let V;try{V=(await this.i.readFile(N)).value.toString()}catch(oe){return(0,n.toFileOperationResult)(oe)!==1&&this.j.error(this.t(L,(0,v.localize)(0,null,N.path,oe.message))),null}let ee;try{ee=JSON.parse(V)}catch{const ge=[];(0,A.parse)(V,ge);for(const fe of ge)this.j.error(this.t(L,(0,v.localize)(1,null,N.path,fe.offset,fe.length,(0,E.getParseErrorMessage)(fe.error))));return null}return(0,A.getNodeType)(ee)!=="object"?(this.j.error(this.t(L,(0,v.localize)(2,null,N.path))),null):ee}async n(L,N,V){const ee=await this.p(L,N,V);if(ee)try{const oe=[],ge=await this.r(ee.default,oe);if(oe.length>0)return oe.forEach(R=>{this.j.error(this.t(L,(0,v.localize)(3,null,ee.default?.path,(0,E.getParseErrorMessage)(R.error))))}),N;if((0,A.getNodeType)(ee)!=="object")return this.j.error(this.t(L,(0,v.localize)(4,null,ee.default?.path))),N;const fe=ee.values||Object.create(null);return(0,K.localizeManifest)(N,fe,ge)}catch{}return N}async p(L,N,V){const ee=(0,w.joinPath)(L,"package.nls.json"),oe=(M,W)=>{W.forEach(Y=>{this.j.error(this.t(L,(0,v.localize)(5,null,M?.path,(0,E.getParseErrorMessage)(Y.error))))})},ge=M=>{this.j.error(this.t(L,(0,v.localize)(6,null,M?.path)))},fe=`${N.publisher}.${N.name}`,R=V.translations[fe];if(R)try{const M=d.URI.file(R),W=(await this.i.readFile(M)).value.toString(),Y=[],re=(0,A.parse)(W,Y);return Y.length>0?(oe(M,Y),{values:void 0,default:ee}):(0,A.getNodeType)(re)!=="object"?(ge(M),{values:void 0,default:ee}):{values:re.contents?re.contents.package:void 0,default:ee}}catch{return{values:void 0,default:ee}}else{if(!await this.i.exists(ee))return;let W;try{W=await this.s(L,V)}catch{return}if(!W.localized)return{values:void 0,default:W.original};try{const Y=(await this.i.readFile(W.localized)).value.toString(),re=[],me=(0,A.parse)(Y,re);return re.length>0?(oe(W.localized,re),{values:void 0,default:W.original}):(0,A.getNodeType)(me)!=="object"?(ge(W.localized),{values:void 0,default:W.original}):{values:me,default:W.original}}catch{return{values:void 0,default:W.original}}}}async r(L,N){if(L)try{const V=(await this.i.readFile(L)).value.toString();return(0,A.parse)(V,N)}catch{}}s(L,N){return new Promise((V,ee)=>{const oe=ge=>{const fe=(0,w.joinPath)(L,`package.nls.${ge}.json`);this.i.exists(fe).then(R=>{R&&V({localized:fe,original:(0,w.joinPath)(L,"package.nls.json")});const M=ge.lastIndexOf("-");M===-1?V({localized:(0,w.joinPath)(L,"package.nls.json"),original:null}):(ge=ge.substring(0,M),oe(ge))})};if(N.devMode||N.pseudo||!N.language)return V({localized:(0,w.joinPath)(L,"package.nls.json"),original:null});oe(N.language)})}t(L,N){return`[${L.path}]: ${N}`}};Q=Le([Oe(1,u.IExtensionsProfileScannerService),Oe(2,F.IUriIdentityService),Oe(3,n.IFileService),Oe(4,o.ILogService)],Q);let z=class extends Q{constructor(L,N,V,ee,oe,ge){super(N,V,ee,oe,ge),this.y=L,this.v=this.B(new t.ThrottledDelayer(3e3)),this.w=this.B(new l.Emitter),this.onDidChangeCache=this.w.event}async scanExtensions(L){const N=await this.z();if(this.u=L,N&&N.input&&U.equals(N.input,this.u))return this.v.trigger(()=>this.D()),N.result.map(ee=>(ee.location=d.URI.revive(ee.location),ee));const V=await super.scanExtensions(L);return await this.C({input:L,result:V}),V}async z(){try{const L=await this.i.readFile(this.y),N=JSON.parse(L.value.toString());return{result:N.result,input:(0,s.revive)(N.input)}}catch(L){this.j.debug("Error while reading the extension cache file:",this.y.path,(0,I.getErrorMessage)(L))}return null}async C(L){try{await this.i.writeFile(this.y,S.VSBuffer.fromString(JSON.stringify(L)))}catch(N){this.j.debug("Error while writing the extension cache file:",this.y.path,(0,I.getErrorMessage)(N))}}async D(){if(!this.u)return;const L=await this.z();if(!L)return;const N=L.result,V=JSON.parse(JSON.stringify(await super.scanExtensions(this.u)));if(!k.equals(V,N))try{await this.i.del(this.y),this.w.fire()}catch(ee){this.j.error(ee)}}};z=Le([Oe(2,u.IExtensionsProfileScannerService),Oe(3,F.IUriIdentityService),Oe(4,n.IFileService),Oe(5,o.ILogService)],z);function G(ce,L){const N=(0,h.getExtensionId)(ce.manifest.publisher,ce.manifest.name);return{id:N,identifier:new f.ExtensionIdentifier(N),isBuiltin:ce.type===0,isUserBuiltin:ce.type===1&&ce.isBuiltin,isUnderDevelopment:L,extensionLocation:ce.location,uuid:ce.identifier.uuid,targetPlatform:ce.targetPlatform,...ce.manifest}}e.toExtensionDescription=G;class X extends se{constructor(L,N,V,ee,oe,ge,fe,R,M,W,Y,re){super(L,N,(0,w.joinPath)(V,".vscode-oss-dev","extensions","control.json"),(0,w.joinPath)(ee,f.MANIFEST_CACHE_FOLDER),oe,ge,fe,R,M,W,Y,re),this.L=(async()=>{if(C.translationsConfigFile)try{const me=await this.r.readFile(d.URI.file(C.translationsConfigFile));return JSON.parse(me.value.toString())}catch{}return Object.create(null)})()}f(L){return this.L}}e.NativeExtensionsScannerService=X}),define(ve[242],be([1,0,48,14,39,6,2,13,7,21,12,36]),function(ie,e,b,t,k,S,I,A,E,y,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let C=class extends I.Disposable{constructor(m,g){super(),this.b=m,this.f=g,this.a=new t.Limiter(5)}async postUninstall(m){const g=this.g(m,"uninstall");return g&&(this.f.info(m.identifier.id,m.manifest.version,"Running post uninstall script"),await this.a.queue(()=>this.h(g.script,"uninstall",g.args,!0,m).then(()=>this.f.info(m.identifier.id,m.manifest.version,"Finished running post uninstall script"),p=>this.f.error(m.identifier.id,m.manifest.version,`Failed to run post uninstall script: ${p}`)))),y.Promises.rm(this.j(m)).then(void 0,p=>this.f.error("Error while removing extension storage path",p))}g(m,g){const p=`vscode:${g}`;if(m.location.scheme===A.Schemas.file&&m.manifest&&m.manifest.scripts&&typeof m.manifest.scripts[p]=="string"){const d=m.manifest.scripts[p].split(" ");return d.length<2||d[0]!=="node"||!d[1]?(this.f.warn(m.identifier.id,m.manifest.version,`${p} should be a node script`),null):{script:(0,E.join)(m.location.fsPath,d[1]),args:d.slice(2)||[]}}return null}h(m,g,p,d,v){return new Promise((c,h)=>{const f=this.i(m,g,p,v);let i;const n=r=>{i&&(clearTimeout(i),i=null),r?h(r):c(void 0)};f.on("error",r=>{n((0,k.toErrorMessage)(r)||"Unknown")}),f.on("exit",(r,o)=>{n(r?`post-${g} process exited with code ${r}`:void 0)}),d&&(i=setTimeout(()=>{i=null,f.kill(),h("timed out")},5e3))})}i(m,g,p,d){const v={silent:!0,execArgv:void 0},c=(0,b.fork)(m,[`--type=extension-post-${g}`,...p],v);c.stdout.setEncoding("utf8"),c.stderr.setEncoding("utf8");const h=S.Event.fromNodeEventEmitter(c.stdout,"data"),f=S.Event.fromNodeEventEmitter(c.stderr,"data");h(r=>this.f.info(d.identifier.id,d.manifest.version,`post-${g}`,r)),f(r=>this.f.error(d.identifier.id,d.manifest.version,`post-${g}`,r));const i=S.Event.any(S.Event.map(h,r=>({data:`%c${r}`,format:[""]})),S.Event.map(f,r=>({data:`%c${r}`,format:["color: red"]})));return S.Event.debounce(i,(r,o)=>r?{data:r.data+o.data,format:[...r.format,...o.format]}:{data:o.data,format:o.format},100)(r=>{console.group(d.identifier.id),console.log(r.data,...r.format),console.groupEnd()}),c}j(m){return(0,E.join)(this.b.defaultProfile.globalStorageHome.fsPath,m.identifier.id.toLowerCase())}};C=Le([Oe(0,T.IUserDataProfilesService),Oe(1,D.ILogService)],C),e.ExtensionsLifecycle=C}),define(ve[243],be([1,0,14,6,2,45,11,157,5,36]),function(ie,e,b,t,k,S,I,A,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,E.createDecorator)("storageService");var D;(function(v){v[v.NONE=0]="NONE",v[v.SHUTDOWN=1]="SHUTDOWN"})(D=e.WillSaveStateReason||(e.WillSaveStateReason={}));var T;(function(v){v[v.APPLICATION=-1]="APPLICATION",v[v.PROFILE=0]="PROFILE",v[v.WORKSPACE=1]="WORKSPACE"})(T=e.StorageScope||(e.StorageScope={}));var C;(function(v){v[v.USER=0]="USER",v[v.MACHINE=1]="MACHINE"})(C=e.StorageTarget||(e.StorageTarget={}));function w(v){const c=v.get(e.TARGET_KEY);if(c)try{return JSON.parse(c)}catch{}return Object.create(null)}e.loadKeyTargets=w;class m extends k.Disposable{constructor(c={flushInterval:m.a}){super(),this.j=c,this.b=this.B(new t.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new t.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new t.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new b.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new k.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,b.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,k.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,S.mark)("code/willInitStorage");try{await this.J()}finally{(0,S.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(c,h){if(h===e.TARGET_KEY){switch(c){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:c})}else this.b.fire({scope:c,key:h,target:this.F(c)[h]})}r(c){this.f.fire({reason:c})}get(c,h,f){return this.L(h)?.get(c,f)}getBoolean(c,h,f){return this.L(h)?.getBoolean(c,f)}getNumber(c,h,f){return this.L(h)?.getNumber(c,f)}store(c,h,f,i){if((0,I.isUndefinedOrNull)(h)){this.remove(c,f);return}this.t(()=>{this.u(c,f,i),this.L(f)?.set(c,h)})}remove(c,h){this.t(()=>{this.u(c,h,void 0),this.L(h)?.delete(c)})}t(c){this.b.pause(),this.c.pause();try{c()}finally{this.b.resume(),this.c.resume()}}keys(c,h){const f=[],i=this.F(c);for(const n of Object.keys(i))i[n]===h&&f.push(n);return f}u(c,h,f){const i=this.F(h);typeof f=="number"?i[c]!==f&&(i[c]=f,this.L(h)?.set(e.TARGET_KEY,JSON.stringify(i))):typeof i[c]=="number"&&(delete i[c],this.L(h)?.set(e.TARGET_KEY,JSON.stringify(i)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(c){switch(c){case-1:return this.D;case 0:return this.z;default:return this.w}}G(c){const h=this.L(c);return h?w(h):Object.create(null)}isNew(c){return this.getBoolean(e.IS_NEW_KEY,c)===!0}async flush(c=D.NONE){this.f.fire({reason:c});const h=this.L(-1),f=this.L(0),i=this.L(1);switch(c){case D.NONE:await b.Promises.settled([h?.whenFlushed()??Promise.resolve(),f?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case D.SHUTDOWN:await b.Promises.settled([h?.flush(0)??Promise.resolve(),f?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const c=this.L(-1)?.items??new Map,h=this.L(0)?.items??new Map,f=this.L(1)?.items??new Map;return d(c,h,f,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(c,h){return this.r(D.NONE),(0,y.isUserDataProfile)(c)?this.N(c,h):this.O(c,h)}H(c,h){return!(c.id===h.id||g(h)&&g(c))}I(c,h,f,i){this.t(()=>{if(i)for(const[n,r]of c)h.set(n,r);else{const n=new Set;for(const[r,o]of c)n.add(r),h.get(r)!==o&&this.n(f,r);for(const[r]of h.items)n.has(r)||this.n(f,r)}})}}e.AbstractStorageService=m,m.a=60*1e3;function g(v){return v.isDefault||!!v.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=g;class p extends m{constructor(){super(),this.p=this.B(new A.Storage(new A.InMemoryStorageDatabase,{hint:A.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new A.Storage(new A.InMemoryStorageDatabase,{hint:A.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new A.Storage(new A.InMemoryStorageDatabase,{hint:A.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(c=>this.n(1,c))),this.B(this.P.onDidChangeStorage(c=>this.n(0,c))),this.B(this.p.onDidChangeStorage(c=>this.n(-1,c)))}L(c){switch(c){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(c){switch(c){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(c){return!1}}e.InMemoryStorageService=p;async function d(v,c,h,f,i,n){const r=ne=>{try{return JSON.parse(ne)}catch{return ne}},o=new Map,a=new Map;v.forEach((ne,ue)=>{o.set(ue,ne),a.set(ue,r(ne))});const l=new Map,s=new Map;c.forEach((ne,ue)=>{l.set(ue,ne),s.set(ue,r(ne))});const u=new Map,P=new Map;h.forEach((ne,ue)=>{u.set(ue,ne),P.set(ue,r(ne))}),console.group(f!==i?`Storage: Application (path: ${f})`:`Storage: Application & Profile (path: ${f}, default profile)`);const F=[];if(o.forEach((ne,ue)=>{F.push({key:ue,value:ne})}),console.table(F),console.groupEnd(),console.log(a),f!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const ne=[];l.forEach((ue,se)=>{ne.push({key:se,value:ue})}),console.table(ne),console.groupEnd(),console.log(s)}console.group(`Storage: Workspace (path: ${n})`);const K=[];u.forEach((ne,ue)=>{K.push({key:ue,value:ne})}),console.table(K),console.groupEnd(),console.log(P)}e.logStorage=d}),define(ve[116],be([1,0,18,19,8,3,27,11,4,24,28,31,33,73,17,12,25,52,227,243,34]),function(ie,e,b,t,k,S,I,A,E,y,D,T,C,w,m,g,p,d,v,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const f=S.isWeb?"web":(0,T.getTargetPlatform)(S.platform,I.arch);var i;(function(R){R[R.None=0]="None",R[R.IncludeVersions=1]="IncludeVersions",R[R.IncludeFiles=2]="IncludeFiles",R[R.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",R[R.IncludeSharedAccounts=8]="IncludeSharedAccounts",R[R.IncludeVersionProperties=16]="IncludeVersionProperties",R[R.ExcludeNonValidated=32]="ExcludeNonValidated",R[R.IncludeInstallationTargets=64]="IncludeInstallationTargets",R[R.IncludeAssetUri=128]="IncludeAssetUri",R[R.IncludeStatistics=256]="IncludeStatistics",R[R.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",R[R.Unpublished=4096]="Unpublished",R[R.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(i||(i={}));function n(...R){return String(R.reduce((M,W)=>M|W,0))}var r;(function(R){R[R.Tag=1]="Tag",R[R.ExtensionId=4]="ExtensionId",R[R.Category=5]="Category",R[R.ExtensionName=7]="ExtensionName",R[R.Target=8]="Target",R[R.Featured=9]="Featured",R[R.SearchText=10]="SearchText",R[R.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},s={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:i.None,criteria:[],assetTypes:[]};class u{constructor(M=s){this.d=M}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(M,W=this.d.pageSize){return new u({...this.d,pageNumber:M,pageSize:W})}withFilter(M,...W){const Y=[...this.d.criteria,...W.length?W.map(re=>({filterType:M,value:re})):[{filterType:M}]];return new u({...this.d,criteria:Y})}withSortBy(M){return new u({...this.d,sortBy:M})}withSortOrder(M){return new u({...this.d,sortOrder:M})}withFlags(...M){return new u({...this.d,flags:M.reduce((W,Y)=>W|Y,0)})}withAssetTypes(...M){return new u({...this.d,assetTypes:M})}withSource(M){return new u({...this.d,source:M})}get raw(){const{criteria:M,pageNumber:W,pageSize:Y,sortBy:re,sortOrder:me,flags:$,assetTypes:J}=this.d;return{filters:[{criteria:M,pageNumber:W,pageSize:Y,sortBy:re,sortOrder:me}],assetTypes:J,flags:$}}get searchText(){const M=this.d.criteria.filter(W=>W.filterType===r.SearchText)[0];return M&&M.value?M.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(M=>String(M.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function P(R,M){const W=(R||[]).filter(Y=>Y.statisticName===M)[0];return W?W.value:0}function F(R){const M="Microsoft.VisualStudio.Code.Translation.";return R.files.filter(Y=>Y.assetType.indexOf(M)===0).reduce((Y,re)=>{const me=ue(R,re.assetType);return me&&Y.push([re.assetType.substring(M.length),me]),Y},[])}function K(R){if(R.properties){const M=R.properties.filter(re=>re.key===o.Repository),W=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),Y=M.filter(re=>W.test(re.value))[0];return Y?{uri:Y.value,fallbackUri:Y.value}:null}return ue(R,o.Repository)}function ne(R){return{uri:`${R.fallbackAssetUri}/${o.VSIX}?redirect=true${R.targetPlatform?`&targetPlatform=${R.targetPlatform}`:""}`,fallbackUri:`${R.fallbackAssetUri}/${o.VSIX}${R.targetPlatform?`?targetPlatform=${R.targetPlatform}`:""}`}}function ue(R,M){return R.files.filter(Y=>Y.assetType===M)[0]?{uri:`${R.assetUri}/${M}${R.targetPlatform?`?targetPlatform=${R.targetPlatform}`:""}`,fallbackUri:`${R.fallbackAssetUri}/${M}${R.targetPlatform?`?targetPlatform=${R.targetPlatform}`:""}`}:null}function se(R,M){const W=R.properties?R.properties.filter(re=>re.key===M):[],Y=W.length>0&&W[0].value;return Y?Y.split(",").map(re=>(0,C.adoptToGalleryExtensionId)(re)):[]}function U(R){const M=R.properties?R.properties.filter(W=>W.key===a.Engine):[];return M.length>0&&M[0].value||""}function Q(R){const M=R.properties?R.properties.filter(W=>W.key===a.PreRelease):[];return M.length>0&&M[0].value==="true"}function z(R){const M=R.properties?R.properties.filter(Y=>Y.key===a.LocalizedLanguages):[],W=M.length>0&&M[0].value||"";return W?W.split(","):[]}function G(R){return R.properties?.find(M=>M.key===a.SponsorLink)?.value}function X(R){return R.indexOf("preview")!==-1}function ce(R){return R.targetPlatform?(0,T.toTargetPlatform)(R.targetPlatform):"undefined"}function L(R){const M=(0,b.distinct)(R.versions.map(ce)),W=!!R.tags?.includes(T.WEB_EXTENSION_TAG),Y=M.indexOf("web");return W?Y===-1&&M.push("web"):Y!==-1&&M.splice(Y,1),M}function N(R,M){const W=(0,T.getFallbackTargetPlarforms)(M);for(let Y=0;Y<R.length;Y++){const re=R[Y];if(re.version===R[Y-1]?.version){let me=Y;const $=ce(re);if($===M)for(;me>0&&R[me-1].version===re.version;)me--;else if(W.includes($))for(;me>0&&R[me-1].version===re.version&&ce(R[me-1])!==M;)me--;me!==Y&&(R.splice(Y,1),R.splice(me,0,re))}}return R}e.sortExtensionVersions=N;function V(R,M,W){R.telemetryData={index:M,querySource:W}}function ee(R,M,W){const Y=R.versions[0],re={manifest:ue(M,o.Manifest),readme:ue(M,o.Details),changelog:ue(M,o.Changelog),license:ue(M,o.License),repository:K(M),download:ne(M),icon:ue(M,o.Icon),signature:ue(M,o.Signature),coreTranslations:F(M)};return{identifier:{id:(0,C.getGalleryExtensionId)(R.publisher.publisherName,R.extensionName),uuid:R.extensionId},name:R.extensionName,version:M.version,displayName:R.displayName,publisherId:R.publisher.publisherId,publisher:R.publisher.publisherName,publisherDisplayName:R.publisher.displayName,publisherDomain:R.publisher.domain?{link:R.publisher.domain,verified:!!R.publisher.isDomainVerified}:void 0,publisherSponsorLink:G(Y),description:R.shortDescription||"",installCount:P(R.statistics,"install"),rating:P(R.statistics,"averagerating"),ratingCount:P(R.statistics,"ratingcount"),categories:R.categories||[],tags:R.tags||[],releaseDate:Date.parse(R.releaseDate),lastUpdated:Date.parse(R.lastUpdated),allTargetPlatforms:W,assets:re,properties:{dependencies:se(M,a.Dependency),extensionPack:se(M,a.ExtensionPack),engine:U(M),localizedLanguages:z(M),targetPlatform:ce(M),isPreReleaseVersion:Q(M)},hasPreReleaseVersion:Q(Y),hasReleaseVersion:!0,preview:X(R.flags),isSigned:!!re.signature}}let oe=class{constructor(M,W,Y,re,me,$,J,_){this.k=W,this.l=Y,this.n=re,this.o=me,this.q=$,this.u=J,this.w=_;const j=J.extensionsGallery,H=j?.servicePPEUrl&&_.getValue("_extensionsGallery.enablePPE");this.d=H?j.servicePPEUrl:j?.serviceUrl,this.g=H?void 0:j?.searchUrl,this.h=j?.controlUrl,this.j=(0,v.resolveMarketplaceHeaders)(J.version,J,this.n,this.w,this.q,M,this.o)}x(M=""){return`${this.d}${M}`}isEnabled(){return!!this.d}async getExtensions(M,W,Y){const re=t.CancellationToken.isCancellationToken(W)?{}:W,me=t.CancellationToken.isCancellationToken(W)?W:Y,$=[],J=[],_=[],j=[];let H=!0;for(const ae of M){ae.uuid?J.push(ae.uuid):$.push(ae.id);const we=!!(ae.version||ae.preRelease);_.push({id:ae.id,uuid:ae.uuid,includePreRelease:we}),ae.version&&j.push({id:ae.id,uuid:ae.uuid,version:ae.version}),H=H&&!!ae.hasPreRelease&&!we}if(!J.length&&!$.length)return[];let q=new u().withPage(1,M.length);J.length&&(q=q.withFilter(r.ExtensionId,...J)),$.length&&(q=q.withFilter(r.ExtensionName,...$)),(re.queryAllVersions||H)&&(q=q.withFlags(q.flags,i.IncludeVersions)),re.source&&(q=q.withSource(re.source));const{extensions:Z}=await this.z(q,{targetPlatform:re.targetPlatform??f,includePreRelease:_,versions:j,compatible:!!re.compatible},me);return re.source&&Z.forEach((ae,we)=>V(ae,we,re.source)),Z}async getCompatibleExtension(M,W,Y){if((0,T.isNotWebExtensionInWebTargetPlatform)(M.allTargetPlatforms,Y))return null;if(await this.isExtensionCompatible(M,W,Y))return M;const re=new u().withFlags(i.IncludeVersions).withPage(1,1).withFilter(r.ExtensionId,M.identifier.uuid),{extensions:me}=await this.z(re,{targetPlatform:Y,compatible:!0,includePreRelease:W},t.CancellationToken.None);return me[0]||null}async isExtensionCompatible(M,W,Y){if(!(0,T.isTargetPlatformCompatible)(M.properties.targetPlatform,M.allTargetPlatforms,Y)||!W&&M.properties.isPreReleaseVersion)return!1;let re=M.properties.engine;if(!re){const me=await this.getManifest(M,t.CancellationToken.None);if(!me)throw new Error("Manifest was not found");re=me.engines.vscode}return(0,w.isEngineValid)(re,this.u.version,this.u.date)}async y(M,W,Y,re,me){if(!(0,T.isTargetPlatformCompatible)(ce(M),re,me)||W!=="any"&&Q(M)!==(W==="prerelease"))return!1;if(Y)try{const $=await this.E(M);if(!(0,w.isEngineValid)($,this.u.version,this.u.date))return!1}catch($){return this.l.error(`Error while getting the engine for the version ${M.version}.`,(0,k.getErrorMessage)($)),!1}return!0}async query(M,W){let Y=M.text||"";const re=M.pageSize??50;let me=new u().withPage(1,re);Y?(Y=Y.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(H,q,Z)=>(me=me.withFilter(r.Category,Z||q),"")),Y=Y.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(H,q,Z)=>(me=me.withFilter(r.Tag,Z||q),"")),Y=Y.replace(/\bfeatured(\s+|\b|$)/g,()=>(me=me.withFilter(r.Featured),"")),Y=Y.trim(),Y&&(Y=Y.length<200?Y:Y.substring(0,200),me=me.withFilter(r.SearchText,Y)),me=me.withSortBy(0)):M.ids?me=me.withFilter(r.ExtensionId,...M.ids):M.names?me=me.withFilter(r.ExtensionName,...M.names):me=me.withSortBy(4),typeof M.sortBy=="number"&&(me=me.withSortBy(M.sortBy)),typeof M.sortOrder=="number"&&(me=me.withSortOrder(M.sortOrder)),M.source&&(me=me.withSource(M.source));const $=async(H,q)=>{const{extensions:Z,total:ae}=await this.z(H,{targetPlatform:f,compatible:!1,includePreRelease:!!M.includePreRelease},q);return Z.forEach((we,ke)=>V(we,(H.pageNumber-1)*H.pageSize+ke,M.source)),{extensions:Z,total:ae}},{extensions:J,total:_}=await $(me,W),j=async(H,q)=>{if(q.isCancellationRequested)throw new k.CancellationError;const{extensions:Z}=await $(me.withPage(H+1),q);return Z};return{firstPage:J,total:_,pageSize:me.pageSize,getPage:j}}async z(M,W,Y){const re=M.flags;!!(M.flags&i.IncludeLatestVersionOnly)&&!!(M.flags&i.IncludeVersions)&&(M=M.withFlags(M.flags&~i.IncludeVersions,i.IncludeLatestVersionOnly)),!(M.flags&i.IncludeLatestVersionOnly)&&!(M.flags&i.IncludeVersions)&&(M=M.withFlags(M.flags,i.IncludeLatestVersionOnly)),W.versions?.length&&(M=M.withFlags(M.flags&~i.IncludeLatestVersionOnly,i.IncludeVersions)),M=M.withFlags(M.flags,i.IncludeAssetUri,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeStatistics,i.IncludeVersionProperties);const{galleryExtensions:me,total:$}=await this.B(M,Y);if(!(M.flags&i.IncludeLatestVersionOnly)){const H=[];for(const q of me){const Z=await this.A(q,W);Z&&H.push(Z)}return{extensions:H,total:$}}const _=[],j=new Map;for(let H=0;H<me.length;H++){const q=me[H],Z={id:(0,C.getGalleryExtensionId)(q.publisher.publisherName,q.extensionName),uuid:q.extensionId},ae=(0,A.isBoolean)(W.includePreRelease)?W.includePreRelease:!!W.includePreRelease.find(ke=>(0,C.areSameExtensions)(ke,Z))?.includePreRelease;if(W.compatible&&(0,T.isNotWebExtensionInWebTargetPlatform)(L(q),W.targetPlatform))continue;const we=await this.A(q,W);!we||we.properties.isPreReleaseVersion&&(!ae||!we.hasReleaseVersion)||!we.properties.isPreReleaseVersion&&we.properties.targetPlatform!==W.targetPlatform&&we.hasPreReleaseVersion?j.set(q.extensionId,H):_.push([H,we])}if(j.size){const H=new Date().getTime(),q=new u().withFlags(re&~i.IncludeLatestVersionOnly,i.IncludeVersions).withPage(1,j.size).withFilter(r.ExtensionId,...j.keys()),{extensions:Z}=await this.z(q,W,Y);this.o.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-H,count:j.size});for(const ae of Z){const we=j.get(ae.identifier.uuid);_.push([we,ae])}}return{extensions:_.sort((H,q)=>H[0]-q[0]).map(([,H])=>H),total:$}}async A(M,W){const Y={id:(0,C.getGalleryExtensionId)(M.publisher.publisherName,M.extensionName),uuid:M.extensionId},re=W.versions?.find(_=>(0,C.areSameExtensions)(_,Y))?.version,me=(0,A.isBoolean)(W.includePreRelease)?W.includePreRelease:!!W.includePreRelease.find(_=>(0,C.areSameExtensions)(_,Y))?.includePreRelease,$=L(M),J=N(M.versions,W.targetPlatform);if(W.compatible&&(0,T.isNotWebExtensionInWebTargetPlatform)($,W.targetPlatform))return null;for(let _=0;_<J.length;_++){const j=J[_];if(!(re&&j.version!==re)){if(await this.y(j,me?"any":"release",W.compatible,$,W.targetPlatform))return ee(M,j,$);if(re&&j.version===re)return null}}return re||W.compatible?null:ee(M,M.versions[0],$)}async B(M,W){if(!this.isEnabled())throw new Error("No extension gallery service configured.");M=M.withFlags(M.flags,i.ExcludeNonValidated).withFilter(r.Target,"Microsoft.VisualStudio.Code").withFilter(r.ExcludeWithFlags,n(i.Unpublished));const Y=await this.j,re=JSON.stringify(M.raw),me={...Y,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(re.length)},$=new Date().getTime();let J,_,j=0;try{if(J=await this.k.request({type:"POST",url:this.g&&M.criteria.some(q=>q.filterType===r.SearchText)?this.g:this.x("/extensionquery"),data:re,headers:me},W),J.res.statusCode&&J.res.statusCode>=400&&J.res.statusCode<500)return{galleryExtensions:[],total:j};const H=await(0,d.asJson)(J);if(H){const q=H.results[0],Z=q.extensions,ae=q.resultMetadata&&q.resultMetadata.filter(we=>we.metadataType==="ResultCount")[0];return j=ae&&ae.metadataItems.filter(we=>we.name==="TotalCount")[0].count||0,{galleryExtensions:Z,total:j}}return{galleryExtensions:[],total:j}}catch(H){throw _=H,H}finally{this.o.publicLog2("galleryService:query",{...M.telemetryData,requestBodySize:String(re.length),duration:new Date().getTime()-$,success:!!J&&(0,d.isSuccess)(J),responseBodySize:J?.res.headers["Content-Length"],statusCode:J?String(J.res.statusCode):void 0,errorCode:_?(0,k.isCancellationError)(_)?"canceled":(0,k.getErrorMessage)(_).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(j)})}}async reportStatistic(M,W,Y,re){if(!this.isEnabled())return;const me=S.isWeb?this.x(`/itemName/${M}.${W}/version/${Y}/statType/${re==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${M}/extensions/${W}/${Y}/stats?statType=${re}`),$=S.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",_={...await this.j,Accept:$};try{await this.k.request({type:"POST",url:me,headers:_},t.CancellationToken.None)}catch{}}async download(M,W,Y){this.l.trace("ExtensionGalleryService#download",M.identifier.id);const re=(0,C.getGalleryExtensionTelemetryData)(M),me=new Date().getTime(),$=H=>this.o.publicLog("galleryService:downloadVSIX",{...re,duration:H}),J=Y===2?"install":Y===3?"update":"",_=J?{uri:`${M.assets.download.uri}${E.URI.parse(M.assets.download.uri).query?"&":"?"}${J}=true`,fallbackUri:`${M.assets.download.fallbackUri}${E.URI.parse(M.assets.download.fallbackUri).query?"&":"?"}${J}=true`}:M.assets.download,j=await this.D(_);await this.q.writeFile(W,j.stream),$(new Date().getTime()-me)}async downloadSignatureArchive(M,W){if(!M.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",M.identifier.id);const Y=await this.D(M.assets.signature);await this.q.writeFile(W,Y.stream)}async getReadme(M,W){if(M.assets.readme){const Y=await this.D(M.assets.readme,{},W);return await(0,d.asTextOrError)(Y)||""}return""}async getManifest(M,W){if(M.assets.manifest){const Y=await this.D(M.assets.manifest,{},W),re=await(0,d.asTextOrError)(Y);return re?JSON.parse(re):null}return null}async C(M,W){const Y=ue(M,o.Manifest);if(!Y)throw new Error("Manifest was not found");const re={"Accept-Encoding":"gzip"},me=await this.D(Y,{headers:re});return await(0,d.asJson)(me)}async getCoreTranslation(M,W){const Y=M.assets.coreTranslations.filter(re=>re[0]===W.toUpperCase())[0];if(Y){const re=await this.D(Y[1]),me=await(0,d.asTextOrError)(re);return me?JSON.parse(me):null}return null}async getChangelog(M,W){if(M.assets.changelog){const Y=await this.D(M.assets.changelog,{},W);return await(0,d.asTextOrError)(Y)||""}return""}async getAllCompatibleVersions(M,W,Y){let re=new u().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1);M.identifier.uuid?re=re.withFilter(r.ExtensionId,M.identifier.uuid):re=re.withFilter(r.ExtensionName,M.identifier.id);const{galleryExtensions:me}=await this.B(re,t.CancellationToken.None);if(!me.length)return[];const $=L(me[0]);if((0,T.isNotWebExtensionInWebTargetPlatform)($,Y))return[];const J=[];await Promise.all(me[0].versions.map(async H=>{try{await this.y(H,W?"any":"release",!0,$,Y)&&J.push(H)}catch{}}));const _=[],j=new Set;for(const H of N(J,Y))j.has(H.version)||(j.add(H.version),_.push({version:H.version,date:H.lastUpdated,isPreReleaseVersion:Q(H)}));return _}async D(M,W={},Y=t.CancellationToken.None){const re=await this.j,me={type:"GET"},$={...re,...W.headers||{}};W={...W,...me,headers:$};const J=M.uri,_=M.fallbackUri,j={...W,url:J};try{const H=await this.k.request(j,Y);if(H.res.statusCode===200)return H;const q=await(0,d.asTextOrError)(H);throw new Error(`Expected 200, got back ${H.res.statusCode} instead.

${q}`)}catch(H){if((0,k.isCancellationError)(H))throw H;const q=(0,k.getErrorMessage)(H);this.o.publicLog2("galleryService:cdnFallback",{url:J,message:q});const Z={...W,url:_};return this.k.request(Z,Y)}}async E(M){let W=U(M);if(!W){const Y=await this.C(M,t.CancellationToken.None);if(!Y)throw new Error("Manifest was not found");W=Y.engines.vscode}return W}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{}};const M=await this.k.request({type:"GET",url:this.h},t.CancellationToken.None);if(M.res.statusCode!==200)throw new Error("Could not get extensions report.");const W=await(0,d.asJson)(M),Y=[],re={};if(W){for(const me of W.malicious)Y.push({id:me});if(W.migrateToPreRelease)for(const[me,$]of Object.entries(W.migrateToPreRelease))(!$.engine||(0,w.isEngineValid)($.engine,this.u.version,this.u.date))&&(re[me.toLowerCase()]={disallowInstall:!0,extension:{id:$.id,displayName:$.displayName,autoMigrate:{storage:!!$.migrateStorage},preRelease:!0}});if(W.deprecated)for(const[me,$]of Object.entries(W.deprecated))$&&(re[me.toLowerCase()]=(0,A.isBoolean)($)?{}:$)}return{malicious:Y,deprecated:re}}};oe=Le([Oe(1,d.IRequestService),Oe(2,g.ILogService),Oe(3,D.IEnvironmentService),Oe(4,h.ITelemetryService),Oe(5,m.IFileService),Oe(6,p.IProductService),Oe(7,y.IConfigurationService)],oe);let ge=class extends oe{constructor(M,W,Y,re,me,$,J,_){super(M,W,Y,re,me,$,J,_)}};ge=Le([Oe(0,c.IStorageService),Oe(1,d.IRequestService),Oe(2,g.ILogService),Oe(3,D.IEnvironmentService),Oe(4,h.ITelemetryService),Oe(5,m.IFileService),Oe(6,p.IProductService),Oe(7,y.IConfigurationService)],ge),e.ExtensionGalleryService=ge;let fe=class extends oe{constructor(M,W,Y,re,me,$,J){super(void 0,M,W,Y,re,me,$,J)}};fe=Le([Oe(0,d.IRequestService),Oe(1,g.ILogService),Oe(2,D.IEnvironmentService),Oe(3,h.ITelemetryService),Oe(4,m.IFileService),Oe(5,p.IProductService),Oe(6,y.IConfigurationService)],fe),e.ExtensionGalleryServiceWithNoStorageService=fe}),define(ve[117],be([1,0,5]),function(ie,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStatusService=e.IExtensionHostStatusService=void 0,e.IExtensionHostStatusService=(0,b.createDecorator)("extensionHostStatusService");class t{constructor(){this.a=new Map}setExitInfo(S,I){this.a.set(S,I)}getExitInfo(S){return this.a.get(S)||null}}e.ExtensionHostStatusService=t}),define(ve[244],be([1,0,6,14]),function(ie,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ManagementConnection=void 0;function k(I){let A=0,E=0,y=0;I>=1e3&&(y=Math.floor(I/1e3),I-=y*1e3),y>=60&&(E=Math.floor(y/60),y-=E*60),E>=60&&(A=Math.floor(E/60),E-=A*60);const D=A?`${A}h`:"",T=E?`${E}m`:"",C=y?`${y}s`:"",w=I?`${I}ms`:"";return`${D}${T}${C}${w}`}class S{constructor(A,E,y,D){this.i=A,this.j=E,this.a=new b.Emitter,this.onClose=this.a.event,this.b=108e5,this.c=3e5,this.d=y,this.protocol=D,this.e=!1,this.f=new t.ProcessTimeRunOnceScheduler(()=>{this.k(`The reconnection grace time of ${k(this.b)} has expired, so the connection will be disposed.`),this.l()},this.b),this.g=new t.ProcessTimeRunOnceScheduler(()=>{this.k(`The reconnection short grace time of ${k(this.c)} has expired, so the connection will be disposed.`),this.l()},this.c),this.protocol.onDidDispose(()=>{this.k("The client has disconnected gracefully, so the connection will be disposed."),this.l()}),this.protocol.onSocketClose(()=>{this.k(`The client has disconnected, will wait for reconnection ${k(this.b)} before disposing...`),this.f.schedule()}),this.k("New connection established.")}k(A){this.i.info(`[${this.d}][${this.j.substr(0,8)}][ManagementConnection] ${A}`)}shortenReconnectionGraceTimeIfNecessary(){this.g.isScheduled()||this.f.isScheduled()&&(this.k(`Another client has connected, will shorten the wait for reconnection ${k(this.c)} before disposing...`),this.g.schedule())}l(){if(this.e)return;this.e=!0,this.f.dispose(),this.g.dispose();const A=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),A.end(),this.a.fire(void 0)}acceptReconnection(A,E,y){this.d=A,this.k("The client has reconnected."),this.f.cancel(),this.g.cancel(),this.protocol.beginAcceptReconnection(E,y),this.protocol.endAcceptReconnection()}}e.ManagementConnection=S}),define(ve[118],be([1,0,29,13,7,140,50]),function(ie,e,b,t,k,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InternalNLSConfiguration=e.getNLSConfiguration=void 0;const A=k.join(t.FileAccess.asFileUri("").fsPath,"nls.metadata.json"),E=new Map;function y(C){return new Promise(w=>b.exists(C,w))}function D(C,w){return y(A).then(m=>{if(!m||!I.default.commit)return Promise.resolve({locale:"en",availableLanguages:{}});const g=`${C}||${w}`;let p=E.get(g);return p||(p=S.getNLSConfiguration(I.default.commit,w,A,C).then(d=>(T.is(d)&&(d._languagePackSupport=!0),d)),E.set(g,p)),p})}e.getNLSConfiguration=D;var T;(function(C){function w(m){const g=m;return g&&typeof g._languagePackId=="string"}C.is=w})(T=e.InternalNLSConfiguration||(e.InternalNLSConfiguration={}))}),define(ve[119],be([1,0,20,4,28,53,54,32,17,5,12,25,38,36,118]),function(ie,e,b,t,k,S,I,A,E,y,D,T,C,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let g=class extends I.AbstractExtensionsScannerService{constructor(d,v,c,h,f,i,n,r){super(t.URI.file(f.builtinExtensionsPath),t.URI.file(f.extensionsPath),(0,b.joinPath)(f.userHome,".vscode-oss-dev","extensions","control.json"),(0,b.joinPath)(t.URI.file(f.userDataPath),A.MANIFEST_CACHE_FOLDER),d,v,c,h,f,i,n,r),this.L=f}async f(d){const v=await(0,m.getNLSConfiguration)(d,this.L.userDataPath);if(m.InternalNLSConfiguration.is(v))try{const c=await this.r.readFile(t.URI.file(v._translationsConfigFile));return JSON.parse(c.value.toString())}catch{}return Object.create(null)}};g=Le([Oe(0,w.IUserDataProfilesService),Oe(1,S.IExtensionsProfileScannerService),Oe(2,E.IFileService),Oe(3,D.ILogService),Oe(4,k.INativeEnvironmentService),Oe(5,T.IProductService),Oe(6,C.IUriIdentityService),Oe(7,y.IInstantiationService)],g),e.ExtensionsScannerService=g}),define(ve[245],be([1,0,246,29,7,22,13,21]),function(ie,e,b,t,k,S,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.requestHasValidConnectionToken=e.determineServerConnectionToken=e.parseServerConnectionToken=e.ServerConnectionTokenParseError=e.MandatoryServerConnectionToken=e.OptionalServerConnectionToken=e.NoneServerConnectionToken=e.ServerConnectionTokenType=void 0;const E=/^[0-9A-Za-z_-]+$/;var y;(function(d){d[d.None=0]="None",d[d.Optional=1]="Optional",d[d.Mandatory=2]="Mandatory"})(y=e.ServerConnectionTokenType||(e.ServerConnectionTokenType={}));class D{constructor(){this.type=0}validate(v){return!0}}e.NoneServerConnectionToken=D;class T{constructor(v){this.value=v,this.type=1}validate(v){return v===this.value}}e.OptionalServerConnectionToken=T;class C{constructor(v){this.value=v,this.type=2}validate(v){return v===this.value}}e.MandatoryServerConnectionToken=C;class w{constructor(v){this.message=v}}e.ServerConnectionTokenParseError=w;async function m(d,v){const c=d["without-connection-token"],h=d["connection-token"],f=d["connection-token-file"],i=d.compatibility==="1.63";if(c)return typeof h<"u"||typeof f<"u"?new w("Please do not use the argument '--connection-token' or '--connection-token-file' at the same time as '--without-connection-token'."):new D;if(typeof f<"u"){if(typeof h<"u")return new w("Please do not use the argument '--connection-token' at the same time as '--connection-token-file'.");let n;try{n=t.readFileSync(f).toString().replace(/\r?\n$/,"")}catch{return new w(`Unable to read the connection token file at '${f}'.`)}return E.test(n)?new C(n):new w(`The connection token defined in '${f} does not adhere to the characters 0-9, a-z, A-Z, _, or -.`)}return typeof h<"u"?E.test(h)?i?new T(h):new C(h):new w(`The connection token '${h} does not adhere to the characters 0-9, a-z, A-Z, _, or -.`):i?(console.log("Breaking change in the next release: Please use one of the following arguments: '--connection-token', '--connection-token-file' or '--without-connection-token'."),new T(await v())):new C(await v())}e.parseServerConnectionToken=m;async function g(d){return m(d,async()=>{if(!d["user-data-dir"])return(0,S.generateUuid)();const c=k.join(d["user-data-dir"],"token");try{const i=(await A.Promises.readFile(c)).toString().replace(/\r?\n$/,"");if(E.test(i))return i}catch{}const h=(0,S.generateUuid)();try{await A.Promises.writeFile(c,h,{mode:384})}catch{}return h})}e.determineServerConnectionToken=g;function p(d,v,c){if(d.validate(c.query[I.connectionTokenQueryName]))return!0;const h=b.parse(v.headers.cookie||"");return d.validate(h[I.connectionTokenCookieName])}e.requestHasValidConnectionToken=p}),define(ve[43],be([1,0,185,193,60,5,28]),function(ie,e,b,t,k,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerEnvironmentService=e.IServerEnvironmentService=e.serverOptions=void 0,e.serverOptions={host:{type:"string",cat:"o",args:"ip-address",description:b.localize(0,null)},port:{type:"string",cat:"o",args:"port | port range",description:b.localize(1,null)},"socket-path":{type:"string",cat:"o",args:"path",description:b.localize(2,null)},"connection-token":{type:"string",cat:"o",args:"token",deprecates:["connectionToken"],description:b.localize(3,null)},"connection-token-file":{type:"string",cat:"o",args:"path",deprecates:["connection-secret","connectionTokenFile"],description:b.localize(4,null)},"without-connection-token":{type:"boolean",cat:"o",description:b.localize(5,null)},"disable-websocket-compression":{type:"boolean"},"print-startup-performance":{type:"boolean"},"print-ip-address":{type:"boolean"},"accept-server-license-terms":{type:"boolean",cat:"o",description:b.localize(6,null)},"server-data-dir":{type:"string",cat:"o",description:b.localize(7,null)},"telemetry-level":{type:"string",cat:"o",args:"level",description:b.localize(8,null)},"user-data-dir":k.OPTIONS["user-data-dir"],"enable-smoke-test-driver":k.OPTIONS["enable-smoke-test-driver"],"disable-telemetry":k.OPTIONS["disable-telemetry"],"disable-workspace-trust":k.OPTIONS["disable-workspace-trust"],"file-watcher-polling":{type:"string",deprecates:["fileWatcherPolling"]},log:k.OPTIONS.log,logsPath:k.OPTIONS.logsPath,"force-disable-user-env":k.OPTIONS["force-disable-user-env"],folder:{type:"string",deprecationMessage:"No longer supported. Folder needs to be provided in the browser URL or with `default-folder`."},workspace:{type:"string",deprecationMessage:"No longer supported. Workspace needs to be provided in the browser URL or with `default-workspace`."},"default-folder":{type:"string",description:b.localize(9,null)},"default-workspace":{type:"string",description:b.localize(10,null)},"enable-sync":{type:"boolean"},"github-auth":{type:"string"},"extensions-dir":k.OPTIONS["extensions-dir"],"extensions-download-dir":k.OPTIONS["extensions-download-dir"],"builtin-extensions-dir":k.OPTIONS["builtin-extensions-dir"],"install-extension":k.OPTIONS["install-extension"],"install-builtin-extension":k.OPTIONS["install-builtin-extension"],"uninstall-extension":k.OPTIONS["uninstall-extension"],"list-extensions":k.OPTIONS["list-extensions"],"locate-extension":k.OPTIONS["locate-extension"],"show-versions":k.OPTIONS["show-versions"],category:k.OPTIONS.category,force:k.OPTIONS.force,"do-not-sync":k.OPTIONS["do-not-sync"],"pre-release":k.OPTIONS["pre-release"],"start-server":{type:"boolean",cat:"e",description:b.localize(11,null)},"enable-remote-auto-shutdown":{type:"boolean"},"remote-auto-shutdown-without-delay":{type:"boolean"},"use-host-proxy":{type:"boolean"},"without-browser-env-var":{type:"boolean"},help:k.OPTIONS.help,version:k.OPTIONS.version,"locate-shell-integration-path":k.OPTIONS["locate-shell-integration-path"],compatibility:{type:"string"},_:k.OPTIONS._},e.IServerEnvironmentService=(0,S.refineServiceDecorator)(I.IEnvironmentService);class A extends t.NativeEnvironmentService{get args(){return super.args}}e.ServerEnvironmentService=A}),define(ve[247],be([1,0,29,88,79,246,111,37,56,3,12,43,7,13,22,25,52,19,4,16,11,65]),function(ie,e,b,t,k,S,I,A,E,y,D,T,C,w,m,g,p,d,v,c,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebClientServer=e.serveFile=e.CacheControl=e.serveError=void 0;const i={".html":"text/html",".js":"text/javascript",".json":"application/json",".css":"text/css",".svg":"image/svg+xml"};async function n(s,u,P,F){u.writeHead(P,{"Content-Type":"text/plain"}),u.end(F)}e.serveError=n;var r;(function(s){s[s.NO_CACHING=0]="NO_CACHING",s[s.ETAG=1]="ETAG",s[s.NO_EXPIRY=2]="NO_EXPIRY"})(r=e.CacheControl||(e.CacheControl={}));async function o(s,u,P,F,K,ne){try{const ue=await b.promises.stat(s);if(u===1){const se=`W/"${[ue.ino,ue.size,ue.mtime.getTime()].join("-")}"`;if(F.headers["if-none-match"]===se)return K.writeHead(304),void K.end();ne.Etag=se}else u===2?ne["Cache-Control"]="public, max-age=31536000":u===0&&(ne["Cache-Control"]="no-store");ne["Content-Type"]=i[(0,C.extname)(s)]||(0,E.getMediaMime)(s)||"text/plain",K.writeHead(200,ne),(0,b.createReadStream)(s).pipe(K)}catch(ue){return ue.code!=="ENOENT"?(P.error(ue),console.error(ue.toString())):console.error(`File not found: ${s}`),K.writeHead(404,{"Content-Type":"text/plain"}),void K.end("Not found")}}e.serveFile=o;const a=(0,C.dirname)(w.FileAccess.asFileUri("").fsPath);let l=class{constructor(u,P,F,K,ne){this.f=u,this.g=P,this.h=F,this.i=K,this.j=ne,this.a=this.j.extensionsGallery?.resourceUrlTemplate?v.URI.parse(this.j.extensionsGallery.resourceUrlTemplate):void 0;const ue=(0,f.getRemoteServerRootPath)(ne);this.b=`${ue}/static`,this.c=`${ue}/callback`,this.d=`${ue}/web-extension-resource`}async handle(u,P,F){try{const K=F.pathname;return K.startsWith(this.b)&&K.charCodeAt(this.b.length)===47?this.k(u,P,F):K==="/"?this.n(u,P,F):K===this.c?this.p(P):K.startsWith(this.d)&&K.charCodeAt(this.d.length)===47?this.m(u,P,F):n(u,P,404,"Not found.")}catch(K){return this.h.error(K),console.error(K.toString()),n(u,P,500,"Internal Server Error.")}}async k(u,P,F){const K=Object.create(null),ue=decodeURIComponent(F.pathname).substring(this.b.length+1),se=(0,C.join)(a,ue);return(0,A.isEqualOrParent)(se,a,!y.isLinux)?o(se,this.g.isBuilt?2:1,this.h,u,P,K):n(u,P,400,"Bad request.")}l(u){const P=u.authority.indexOf(".");return P!==-1?u.authority.substring(P+1):void 0}async m(u,P,F){if(!this.a)return n(u,P,500,"No extension gallery service configured.");const K=decodeURIComponent(F.pathname),ne=(0,C.normalize)(K.substring(this.d.length+1)),ue=v.URI.parse(ne).with({scheme:this.a.scheme,authority:ne.substring(0,ne.indexOf("/")),path:ne.substring(ne.indexOf("/")+1)});if(this.l(this.a)!==this.l(ue))return n(u,P,403,"Request Forbidden");const se={},U=L=>{const N=u.headers[L];N&&((0,h.isString)(N)||N[0])?se[L]=(0,h.isString)(N)?N:N[0]:L!==L.toLowerCase()&&U(L.toLowerCase())};U("X-Client-Name"),U("X-Client-Version"),U("X-Machine-Id"),U("X-Client-Commit");const Q=await this.i.request({type:"GET",url:ue.toString(!0),headers:se},d.CancellationToken.None),z=Q.res.statusCode||500;if(z!==200){let L=null;try{L=await(0,p.asTextOrError)(Q)}catch{}return n(u,P,z,L||`Request failed with status ${z}`)}const G=Object.create(null),X=L=>{const N=Q.res.headers[L];N?G[L]=N:L!==L.toLowerCase()&&X(L.toLowerCase())};X("Cache-Control"),X("Content-Type"),P.writeHead(200,G);const ce=await(0,c.streamToBuffer)(Q.stream);return void P.end(ce.buffer)}async n(u,P,F){const K=F.query[w.connectionTokenQueryName];if(typeof K=="string"){const oe=Object.create(null);oe["Set-Cookie"]=S.serialize(w.connectionTokenCookieName,K,{sameSite:"lax",maxAge:60*60*24*7});const ge=Object.create(null);for(const R in F.query)R!==w.connectionTokenQueryName&&(ge[R]=F.query[R]);const fe=k.format({pathname:"/",query:ge});return oe.Location=fe,P.writeHead(302,oe),void P.end()}const ne=oe=>{const ge=u.headers[oe];return Array.isArray(ge)?ge[0]:ge},ue=ne("x-original-host")||ne("x-forwarded-host")||u.headers.host;if(!ue)return n(u,P,400,"Bad request.");function se(oe){return JSON.stringify(oe).replace(/"/g,"&quot;")}let U;this.g.args["enable-smoke-test-driver"]&&(U=!1);const Q=oe=>oe&&v.URI.file(t.resolve(oe)).with({scheme:w.Schemas.vscodeRemote,authority:ue}),z=w.FileAccess.asFileUri(this.g.isBuilt?"vs/code/browser/workbench/workbench.html":"vs/code/browser/workbench/workbench-dev.html").fsPath,G=!this.g.isBuilt&&this.g.args["github-auth"]?{id:(0,m.generateUuid)(),providerId:"github",accessToken:this.g.args["github-auth"],scopes:[["user:email"],["repo"]]}:void 0,X={remoteAuthority:ue,_wrapWebWorkerExtHostInIframe:U,developmentOptions:{enableSmokeTestDriver:this.g.args["enable-smoke-test-driver"]?!0:void 0,logLevel:this.h.getLevel()},settingsSyncOptions:!this.g.isBuilt&&this.g.args["enable-sync"]?{enabled:!0}:void 0,enableWorkspaceTrust:!this.g.args["disable-workspace-trust"],folderUri:Q(this.g.args["default-folder"]),workspaceUri:Q(this.g.args["default-workspace"]),productConfiguration:{embedderIdentifier:"server-distro",extensionsGallery:this.a?{...this.j.extensionsGallery,resourceUrlTemplate:this.a.with({scheme:"http",authority:ue,path:`${this.d}/${this.a.authority}${this.a.path}`}).toString(!0)}:void 0},callbackRoute:this.c},ce=this.j.extensionsGallery?.nlsBaseUrl,L={WORKBENCH_WEB_CONFIGURATION:se(X),WORKBENCH_AUTH_SESSION:G?se(G):"",WORKBENCH_WEB_BASE_URL:this.b,WORKBENCH_NLS_BASE_URL:ce?`${ce}${ce.endsWith("/")?"":"/"}${this.j.commit}/${this.j.version}/`:""};let N;try{N=(await b.promises.readFile(z)).toString().replace(/\{\{([^}]+)\}\}/g,(ge,fe)=>L[fe]??"undefined")}catch{return P.writeHead(404,{"Content-Type":"text/plain"}),void P.end("Not found")}const V=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'self';",`script-src 'self' 'unsafe-eval' ${this.o(N).join(" ")} 'sha256-fh3TwPMflhsEIpR8g1OYTIMVWhXTLcjQ9kh2tIpmv54=' http://${ue};`,"child-src 'self';","frame-src 'self' https://*.vscode-cdn.net data:;","worker-src 'self' data:;","style-src 'self' 'unsafe-inline';","connect-src 'self' ws: wss: https:;","font-src 'self' blob:;","manifest-src 'self';"].join(" "),ee={"Content-Type":"text/html","Content-Security-Policy":V};return this.f.type!==0&&(ee["Set-Cookie"]=S.serialize(w.connectionTokenCookieName,this.f.value,{sameSite:"lax",maxAge:60*60*24*7})),P.writeHead(200,ee),void P.end(N)}o(u){const P=/<script>([\s\S]+?)<\/script>/img,F=[];let K;for(;K=P.exec(u);){const ne=I.createHash("sha256"),ue=K[1].replace(/\r\n/g,`
`),se=ne.update(Buffer.from(ue)).digest().toString("base64");F.push(`'sha256-${se}'`)}return F}async p(u){const P=w.FileAccess.asFileUri("vs/code/browser/workbench/callback.html").fsPath,F=(await b.promises.readFile(P)).toString(),K=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'none';",`script-src 'self' ${this.o(F).join(" ")};`,"style-src 'self' 'unsafe-inline';","font-src 'self' blob:;"].join(" ");return u.writeHead(200,{"Content-Type":"text/html","Content-Security-Policy":K}),void u.end(F)}};l=Le([Oe(1,T.IServerEnvironmentService),Oe(2,D.ILogService),Oe(3,p.IRequestService),Oe(4,g.IProductService)],l),e.WebClientServer=l}),define(ve[248],be([1,0,5]),function(ie,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,b.createDecorator)("IExtHostRpcService");class t{constructor(S){this.getProxy=S.getProxy.bind(S),this.set=S.set.bind(S),this.dispose=S.dispose.bind(S),this.assertRegistered=S.assertRegistered.bind(S),this.drain=S.drain.bind(S)}}e.ExtHostRpcService=t}),define(ve[66],be([1,0,72]),function(ie,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function t(S){return{transformIncoming:I=>I.scheme==="vscode-remote"?{scheme:"file",path:I.path,query:I.query,fragment:I.fragment}:I.scheme==="file"?{scheme:"vscode-local",path:I.path,query:I.query,fragment:I.fragment}:I,transformOutgoing:I=>I.scheme==="file"?{scheme:"vscode-remote",authority:S,path:I.path,query:I.query,fragment:I.fragment}:I.scheme==="vscode-local"?{scheme:"file",path:I.path,query:I.query,fragment:I.fragment}:I,transformOutgoingScheme:I=>I==="file"?"vscode-remote":I==="vscode-local"?"file":I}}function k(S){return new b.URITransformer(t(S))}e.createURITransformer=k}),define(ve[249],be([1,0,4,66,63,7,211]),function(ie,e,b,t,k,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentFileSystemProviderChannel=void 0;class A extends I.AbstractDiskFileSystemProviderChannel{constructor(D,T){super(new k.DiskFileSystemProvider(D),D),this.H=T,this.G=new Map,this.B(this.a)}c(D){let T=this.G.get(D.remoteAuthority);return T||(T=(0,t.createURITransformer)(D.remoteAuthority),this.G.set(D.remoteAuthority,T)),T}f(D,T,C=!1){if(C&&T.path==="/vscode-resource"&&T.query){const w=JSON.parse(T.query).requestResourcePath;return b.URI.from({scheme:"file",path:w})}return b.URI.revive(D.transformIncoming(T))}F(D,T){return new E(D,T,this.b,this.H)}}e.RemoteAgentFileSystemProviderChannel=A;class E extends I.AbstractSessionFileWatcher{constructor(D,T,C,w){super(D,T,C,w)}i(D){const T=D.args["file-watcher-polling"];if(T){const C=T.split(S.delimiter),w=Number(C[0]);if(w>0)return{usePolling:C.length>1?C.slice(1):!0,pollingInterval:w}}}j(D){if(D.extensionsPath)return[S.posix.join(D.extensionsPath,"**")]}}}),define(ve[82],be([1,0,186,11,4,2,5,35,17,13]),function(ie,e,b,t,k,S,I,A,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,b.localize)(0,null),providerDisplayName:(0,b.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var D;(function(L){L[L.PROGRAMMATIC=1]="PROGRAMMATIC",L[L.USER=2]="USER",L[L.EDIT=3]="EDIT",L[L.NAVIGATION=4]="NAVIGATION",L[L.JUMP=5]="JUMP"})(D=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var T;(function(L){L[L.IDENTICAL=1]="IDENTICAL",L[L.SIMILAR=2]="SIMILAR",L[L.DIFFERENT=3]="DIFFERENT"})(T=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function C(L){const N=L;return!!N&&typeof N.getSelection=="function"&&!!N.onDidChangeSelection}e.isEditorPaneWithSelection=C;function w(L,N,V){for(const ee of V.visibleEditorPanes)if(ee.group.id===N&&L.matches(ee.input))return ee.getViewState()}e.findViewStateForEditor=w;function m(L){if(a(L))return!1;const N=L;return k.URI.isUri(N?.resource)}e.isResourceEditorInput=m;function g(L){if(a(L))return!1;const N=L;return N?.original!==void 0&&N.modified!==void 0}e.isResourceDiffEditorInput=g;function p(L){if(a(L)||g(L))return!1;const N=L;return N?.primary!==void 0&&N.secondary!==void 0}e.isResourceSideBySideEditorInput=p;function d(L){if(a(L))return!1;const N=L;return N?N.resource===void 0||N.resource.scheme===y.Schemas.untitled||N.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=d;const v=/Untitled-\d+/;function c(L){return L.scheme===y.Schemas.untitled&&L.path.length>1&&!v.test(L.path)}e.isUntitledWithAssociatedResource=c;function h(L){if(a(L))return!1;const N=L;return k.URI.isUri(N?.base?.resource)&&k.URI.isUri(N?.input1?.resource)&&k.URI.isUri(N?.input2?.resource)&&k.URI.isUri(N?.result?.resource)}e.isResourceMergeEditorInput=h;var f;(function(L){L[L.SHORT=0]="SHORT",L[L.MEDIUM=1]="MEDIUM",L[L.LONG=2]="LONG"})(f=e.Verbosity||(e.Verbosity={}));var i;(function(L){L[L.EXPLICIT=1]="EXPLICIT",L[L.AUTO=2]="AUTO",L[L.FOCUS_CHANGE=3]="FOCUS_CHANGE",L[L.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(i=e.SaveReason||(e.SaveReason={}));class n{constructor(){this.a=new Map}registerSource(N,V){let ee=this.a.get(N);return ee||(ee={source:N,label:V},this.a.set(N,ee)),ee.source}getSourceLabel(N){return this.a.get(N)?.label??N}}e.SaveSourceRegistry=new n;var r;(function(L){L[L.None=0]="None",L[L.Readonly=2]="Readonly",L[L.Untitled=4]="Untitled",L[L.Singleton=8]="Singleton",L[L.RequiresTrust=16]="RequiresTrust",L[L.CanSplitInGroup=32]="CanSplitInGroup",L[L.ForceDescription=64]="ForceDescription",L[L.CanDropIntoEditor=128]="CanDropIntoEditor",L[L.MultipleEditors=256]="MultipleEditors"})(r=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class o extends S.Disposable{}e.AbstractEditorInput=o;function a(L){return L instanceof o}e.isEditorInput=a;function l(L){const N=L;return k.URI.isUri(N?.preferredResource)}function s(L){const N=L;return a(N?.primary)&&a(N?.secondary)}e.isSideBySideEditorInput=s;function u(L){const N=L;return a(N?.modified)&&a(N?.original)}e.isDiffEditorInput=u;function P(L){return a(L?.editor)}e.isEditorInputWithOptions=P;function F(L){const N=L;return P(L)&&N?.group!==void 0}e.isEditorInputWithOptionsAndGroup=F;function K(L){const N=L;return typeof N?.groupId=="number"&&a(N.editor)}e.isEditorIdentifier=K;var ne;(function(L){L[L.UNKNOWN=0]="UNKNOWN",L[L.REPLACE=1]="REPLACE",L[L.MOVE=2]="MOVE",L[L.UNPIN=3]="UNPIN"})(ne=e.EditorCloseContext||(e.EditorCloseContext={}));var ue;(function(L){L[L.GROUP_ACTIVE=0]="GROUP_ACTIVE",L[L.GROUP_INDEX=1]="GROUP_INDEX",L[L.GROUP_LOCKED=2]="GROUP_LOCKED",L[L.EDITOR_OPEN=3]="EDITOR_OPEN",L[L.EDITOR_CLOSE=4]="EDITOR_CLOSE",L[L.EDITOR_MOVE=5]="EDITOR_MOVE",L[L.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",L[L.EDITOR_LABEL=7]="EDITOR_LABEL",L[L.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",L[L.EDITOR_PIN=9]="EDITOR_PIN",L[L.EDITOR_STICKY=10]="EDITOR_STICKY",L[L.EDITOR_DIRTY=11]="EDITOR_DIRTY",L[L.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(ue=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var se;(function(L){L[L.PRIMARY=1]="PRIMARY",L[L.SECONDARY=2]="SECONDARY",L[L.BOTH=3]="BOTH",L[L.ANY=4]="ANY"})(se=e.SideBySideEditor||(e.SideBySideEditor={}));class U{getOriginalUri(N,V){if(!N)return;if(h(N))return e.EditorResourceAccessor.getOriginalUri(N.result,V);if(V?.supportSideBySide){const{primary:oe,secondary:ge}=this.a(N);if(oe&&ge){if(V?.supportSideBySide===se.BOTH)return{primary:this.getOriginalUri(oe,{filterByScheme:V.filterByScheme}),secondary:this.getOriginalUri(ge,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===se.ANY)return this.getOriginalUri(oe,{filterByScheme:V.filterByScheme})??this.getOriginalUri(ge,{filterByScheme:V.filterByScheme});N=V.supportSideBySide===se.PRIMARY?oe:ge}}if(g(N)||p(N)||h(N))return;const ee=l(N)?N.preferredResource:N.resource;return!ee||!V||!V.filterByScheme?ee:this.b(ee,V.filterByScheme)}a(N){return s(N)||p(N)?{primary:N.primary,secondary:N.secondary}:u(N)||g(N)?{primary:N.modified,secondary:N.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(N,V){if(!N)return;if(h(N))return e.EditorResourceAccessor.getCanonicalUri(N.result,V);if(V?.supportSideBySide){const{primary:oe,secondary:ge}=this.a(N);if(oe&&ge){if(V?.supportSideBySide===se.BOTH)return{primary:this.getCanonicalUri(oe,{filterByScheme:V.filterByScheme}),secondary:this.getCanonicalUri(ge,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===se.ANY)return this.getCanonicalUri(oe,{filterByScheme:V.filterByScheme})??this.getCanonicalUri(ge,{filterByScheme:V.filterByScheme});N=V.supportSideBySide===se.PRIMARY?oe:ge}}if(g(N)||p(N)||h(N))return;const ee=N.resource;return!ee||!V||!V.filterByScheme?ee:this.b(ee,V.filterByScheme)}b(N,V){if(Array.isArray(V)){if(V.some(ee=>N.scheme===ee))return N}else if(V===N.scheme)return N}}e.EditorResourceAccessor=new U;var Q;(function(L){L[L.LEFT=0]="LEFT",L[L.RIGHT=1]="RIGHT"})(Q=e.CloseDirection||(e.CloseDirection={}));class z{constructor(){this.c=new Map,this.d=new Map}start(N){const V=this.a=N.get(I.IInstantiationService);for(const[ee,oe]of this.c)this.e(ee,oe,V);this.c.clear()}e(N,V,ee){const oe=ee.createInstance(V);this.d.set(N,oe)}registerFileEditorFactory(N){if(this.b)throw new Error("Can only register one file editor factory.");this.b=N}getFileEditorFactory(){return(0,t.assertIsDefined)(this.b)}registerEditorSerializer(N,V){if(this.c.has(N)||this.d.has(N))throw new Error(`A editor serializer with type ID '${N}' was already registered.`);return this.a?this.e(N,V,this.a):this.c.set(N,V),(0,S.toDisposable)(()=>{this.c.delete(N),this.d.delete(N)})}getEditorSerializer(N){return this.d.get(typeof N=="string"?N:N.typeId)}}A.Registry.add(e.EditorExtensions.EditorFactory,new z);async function G(L,N,V){return!L||!L.length?[]:await Promise.all(L.map(async ee=>{const oe=k.URI.revive(ee.fileUri);if(!oe){V.info("Cannot resolve the path because it is not valid.",ee);return}if(!await N.canHandleResource(oe)){V.info("Cannot resolve the path because it cannot be handled",ee);return}let fe=ee.exists,R=ee.type;if(typeof fe!="boolean"||typeof R!="number")try{R=(await N.stat(oe)).isDirectory?E.FileType.Directory:E.FileType.Unknown,fe=!0}catch(W){V.error(W),fe=!1}if(!fe&&ee.openOnlyIfExists){V.info("Cannot resolve the path because it does not exist",ee);return}if(R===E.FileType.Directory){V.info("Cannot resolve the path because it is a directory",ee);return}const M={...ee.options,pinned:!0};return fe?{resource:oe,options:M}:{resource:oe,options:M,forceUntitled:!0}}))}e.pathsToEditors=G;var X;(function(L){L[L.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",L[L.SEQUENTIAL=1]="SEQUENTIAL"})(X=e.EditorsOrder||(e.EditorsOrder={}));function ce(L){const N=L;if(!N)return!1;const V=N;if(V.modified)return ce(V.modified);const ee=N;return!!(ee.contributionsState&&ee.viewState&&Array.isArray(ee.cursorState))}e.isTextEditorViewState=ce}),define(ve[120],be([1,0,16,71,55,56,13,7,3,100]),function(ie,e,b,t,k,S,I,A,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var D;(function(G){G[G.Markup=1]="Markup",G[G.Code=2]="Code"})(D=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",S.Mimes.latex,S.Mimes.markdown,"image/png","image/jpeg",S.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[S.Mimes.latex,S.Mimes.markdown,"application/json",S.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var T;(function(G){G[G.Running=1]="Running",G[G.Idle=2]="Idle"})(T=e.NotebookRunState||(e.NotebookRunState={}));var C;(function(G){G[G.Unconfirmed=1]="Unconfirmed",G[G.Pending=2]="Pending",G[G.Executing=3]="Executing"})(C=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var w;(function(G){G[G.WithHardKernelDependency=0]="WithHardKernelDependency",G[G.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",G[G.Pure=2]="Pure",G[G.Never=3]="Never"})(w=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var m;(function(G){G.Always="always",G.Never="never",G.Optional="optional"})(m=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var g;(function(G){G[G.ModelChange=1]="ModelChange",G[G.Move=2]="Move",G[G.ChangeCellLanguage=5]="ChangeCellLanguage",G[G.Initialize=6]="Initialize",G[G.ChangeCellMetadata=7]="ChangeCellMetadata",G[G.Output=8]="Output",G[G.OutputItem=9]="OutputItem",G[G.ChangeCellContent=10]="ChangeCellContent",G[G.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",G[G.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",G[G.ChangeCellMime=13]="ChangeCellMime",G[G.Unknown=100]="Unknown"})(g=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var p;(function(G){G[G.Handle=0]="Handle",G[G.Index=1]="Index"})(p=e.SelectionStateType||(e.SelectionStateType={}));var d;(function(G){G[G.Replace=1]="Replace",G[G.Output=2]="Output",G[G.Metadata=3]="Metadata",G[G.CellLanguage=4]="CellLanguage",G[G.DocumentMetadata=5]="DocumentMetadata",G[G.Move=6]="Move",G[G.OutputItems=7]="OutputItems",G[G.PartialMetadata=8]="PartialMetadata",G[G.PartialInternalMetadata=9]="PartialInternalMetadata"})(d=e.CellEditType||(e.CellEditType={}));var v;(function(G){G.scheme=I.Schemas.vscodeNotebookCell;const X=["W","X","Y","Z","a","b","c","d","e","f"],ce=new RegExp(`^[${X.join("")}]+`),L=7;function N(R,M){const W=M.toString(L),re=`${W.length<X.length?X[W.length-1]:"z"}${W}s${(0,b.encodeBase64)(b.VSBuffer.fromString(R.scheme),!0,!0)}`;return R.with({scheme:G.scheme,fragment:re})}G.generate=N;function V(R){if(R.scheme!==G.scheme)return;const M=R.fragment.indexOf("s");if(M<0)return;const W=parseInt(R.fragment.substring(0,M).replace(ce,""),L),Y=(0,b.decodeBase64)(R.fragment.substring(M+1)).toString();if(!isNaN(W))return{handle:W,notebook:R.with({scheme:Y,fragment:null})}}G.parse=V;function ee(R,M){return R.with({scheme:I.Schemas.vscodeNotebookCellOutput,fragment:`op${M??""},${R.scheme!==I.Schemas.file?R.scheme:""}`})}G.generateCellOutputUri=ee;function oe(R){if(R.scheme!==I.Schemas.vscodeNotebookCellOutput)return;const M=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(R.fragment);if(!M)return;const W=M[1]&&M[1]!==""?M[1]:void 0,Y=M[2];return{outputId:W,notebook:R.with({scheme:Y||I.Schemas.file,fragment:null})}}G.parseCellOutputUri=oe;function ge(R,M,W){return G.generate(R,M).with({scheme:W})}G.generateCellPropertyUri=ge;function fe(R,M){if(R.scheme===M)return G.parse(R.with({scheme:G.scheme}))}G.parseCellPropertyUri=fe})(v=e.CellUri||(e.CellUri={}));const c=G=>E.isWindows?G.replace(/\//g,"\\"):G;class h{constructor(X=[],ce=e.NOTEBOOK_DISPLAY_ORDER){this.e=ce,this.d=[...new Set(X)].map(L=>({pattern:L,matches:t.parse(c(L))}))}sort(X){const ce=new Map(k.Iterable.map(X,N=>[N,c(N)]));let L=[];for(const{matches:N}of this.d)for(const[V,ee]of ce)if(N(ee)){L.push(V),ce.delete(V);break}return ce.size&&(L=L.concat([...ce.keys()].sort((N,V)=>this.e.indexOf(N)-this.e.indexOf(V)))),L}prioritize(X,ce){const L=this.f(X);if(L===-1){this.d.unshift({pattern:X,matches:t.parse(c(X))});return}const N=new Set(ce.map(ee=>this.f(ee,L)));N.delete(-1);const V=Array.from(N).sort();this.d.splice(L+1,0,...V.map(ee=>this.d[ee]));for(let ee=V.length-1;ee>=0;ee--)this.d.splice(V[ee],1)}toArray(){return this.d.map(X=>X.pattern)}f(X,ce=this.d.length){const L=c(X);for(let N=0;N<ce;N++)if(this.d[N].matches(L))return N;return-1}}e.MimeTypeDisplayOrder=h;function f(G,X,ce,L=(N,V)=>N===V){const N=[];function V(ge,fe,R){if(fe===0&&R.length===0)return;const M=N[N.length-1];M&&M.start+M.deleteCount===ge?(M.deleteCount+=fe,M.toInsert.push(...R)):N.push({start:ge,deleteCount:fe,toInsert:R})}let ee=0,oe=0;for(;;){if(ee===G.length){V(ee,0,X.slice(oe));break}if(oe===X.length){V(ee,G.length-ee,[]);break}const ge=G[ee],fe=X[oe];if(L(ge,fe)){ee+=1,oe+=1;continue}ce(fe)?(V(ee,1,[]),ee+=1):(V(ee,0,[fe]),oe+=1)}return N}e.diff=f,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new y.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(G){G.default="default",G.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function n(G){const X=G;return!!((typeof X.include=="string"||t.isRelativePattern(X.include))&&(typeof X.exclude=="string"||t.isRelativePattern(X.exclude)))}e.isDocumentExcludePattern=n;function r(G,X,ce){if(Array.isArray(G.viewType)&&G.viewType.indexOf(X)>=0||G.viewType===X)return!0;if(G.filenamePattern){const L=n(G.filenamePattern)?G.filenamePattern.include:G.filenamePattern,N=n(G.filenamePattern)?G.filenamePattern.exclude:void 0;if(t.match(L,(0,A.basename)(ce.fsPath).toLowerCase()))return!(N&&t.match(N,(0,A.basename)(ce.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=r,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily",kernelPickerType:"notebook.kernelPicker.type",outputScrolling:"notebook.experimental.outputScrolling"};var o;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(o=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class a{static create(X){return`${a.d}${X}`}static parse(X){if(X.startsWith(a.d))return X.substring(a.d.length)}}e.NotebookWorkingCopyTypeIdentifier=a,a.d="notebook/";function l(G){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(G)}e.isTextStreamMime=l;const s=new TextDecoder;function u(G){const X=[];let ce=!1;for(const L of G)(X.length===0||ce)&&(X.push(L),ce=!0);return ne(X),z(b.VSBuffer.concat(X.map(L=>b.VSBuffer.wrap(L))))}e.compressOutputItemStreams=u;const P=`${String.fromCharCode(27)}[A`,F=P.split("").map(G=>G.charCodeAt(0)),K=10;function ne(G){G.forEach((X,ce)=>{if(ce===0||X.length<P.length)return;const L=G[ce-1],N=X.subarray(0,P.length);if(N[0]===F[0]&&N[1]===F[1]&&N[2]===F[2]){const V=L.lastIndexOf(K);if(V===-1)return;G[ce-1]=L.subarray(0,V),G[ce]=X.subarray(P.length)}})}function ue(G){let X=G;do G=X,X=G.replace(/[^\n]\x08/gm,"");while(X.length<G.length);return G}function se(G){for(G=G.replace(/\r+\n/gm,`
`);G.search(/\r[^$]/g)>-1;){const X=G.match(/^(.*)\r+/m)[1];let ce=G.match(/\r+(.*)$/m)[1];ce=ce+X.slice(ce.length,X.length),G=G.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ce)}return G}const U="\b".charCodeAt(0),Q="\r".charCodeAt(0);function z(G){return!G.buffer.includes(U)&&!G.buffer.includes(Q)?G:b.VSBuffer.fromString(se(ue(s.decode(G.buffer))))}}),define(ve[121],be([1,0,5]),function(ie,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=e.IEnvironmentVariableService=void 0,e.IEnvironmentVariableService=(0,b.createDecorator)("environmentVariableService");var t;(function(k){k[k.Replace=1]="Replace",k[k.Append=2]="Append",k[k.Prepend=3]="Prepend"})(t=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}))}),define(ve[250],be([1,0,3,121]),function(ie,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;class k{constructor(E){this.collections=E,this.map=new Map,E.forEach((y,D)=>{const T=y.map.entries();let C=T.next();for(;!C.done;){const w=C.value[0];let m=this.map.get(w);if(m||(m=[],this.map.set(w,m)),m.length>0&&m[0].type===t.EnvironmentVariableMutatorType.Replace){C=T.next();continue}const g=C.value[1];m.unshift({extensionIdentifier:D,value:g.value,type:g.type}),C=T.next()}})}async applyToProcessEnvironment(E,y){let D;b.isWindows&&(D={},Object.keys(E).forEach(T=>D[T.toLowerCase()]=T));for(const[T,C]of this.map){const w=b.isWindows&&D[T.toLowerCase()]||T;for(const m of C){const g=y?await y(m.value):m.value;switch(m.type){case t.EnvironmentVariableMutatorType.Append:E[w]=(E[w]||"")+g;break;case t.EnvironmentVariableMutatorType.Prepend:E[w]=g+(E[w]||"");break;case t.EnvironmentVariableMutatorType.Replace:E[w]=g;break}}}}diff(E){const y=new Map,D=new Map,T=new Map;if(E.map.forEach((C,w)=>{const m=this.map.get(w),g=S(C,m);g&&y.set(w,g)}),this.map.forEach((C,w)=>{const m=E.map.get(w),g=S(C,m);g&&T.set(w,g)}),this.map.forEach((C,w)=>{const m=E.map.get(w),g=I(C,m);g&&D.set(w,g)}),!(y.size===0&&D.size===0&&T.size===0))return{added:y,changed:D,removed:T}}}e.MergedEnvironmentVariableCollection=k;function S(A,E){if(!E)return A;const y=new Set;E.forEach(T=>y.add(T.extensionIdentifier));const D=[];return A.forEach(T=>{y.has(T.extensionIdentifier)||D.push(T)}),D.length===0?void 0:D}function I(A,E){if(!E)return;const y=new Map;E.forEach(T=>y.set(T.extensionIdentifier,T));const D=[];return A.forEach(T=>{const C=y.get(T.extensionIdentifier);C&&(T.type!==C.type||T.value!==C.value)&&D.push(C)}),D.length===0?void 0:D}}),define(ve[122],be([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function b(I){return[...I.entries()]}e.serializeEnvironmentVariableCollection=b;function t(I){return new Map(I)}e.deserializeEnvironmentVariableCollection=t;function k(I){return Array.from(I.entries()).map(A=>[A[0],b(A[1].map)])}e.serializeEnvironmentVariableCollections=k;function S(I){return new Map(I.map(A=>[A[0],{map:t(A[1])}]))}e.deserializeEnvironmentVariableCollections=S}),define(ve[251],be([1,0,7,57,3,234]),function(ie,e,b,t,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTerminalEnvironment=e.getDefaultShellArgs=e.getDefaultShell=e.createVariableResolver=e.getCwd=e.getLangEnvVariable=e.shouldSetLangEnvVariable=e.addTerminalEnvironmentKeys=e.mergeEnvironments=void 0;function I(h,f){if(!!f)if(k.isWindows)for(const i in f){let n=i;for(const o in h)if(i.toLowerCase()===o.toLowerCase()){n=o;break}const r=f[i];r!==void 0&&A(h,n,r)}else Object.keys(f).forEach(i=>{const n=f[i];n!==void 0&&A(h,i,n)})}e.mergeEnvironments=I;function A(h,f,i){typeof i=="string"?h[f]=i:delete h[f]}function E(h,f,i,n){h.TERM_PROGRAM="vscode",f&&(h.TERM_PROGRAM_VERSION=f),T(h,n)&&(h.LANG=C(i)),h.COLORTERM="truecolor"}e.addTerminalEnvironmentKeys=E;function y(h,f){if(!!f)for(const i of Object.keys(f)){const n=f[i];n&&(h[i]=n)}}async function D(h,f){return await Promise.all(Object.entries(f).map(async([i,n])=>{if(typeof n=="string")try{f[i]=await h(n)}catch{f[i]=n}})),f}function T(h,f){if(f==="on")return!0;if(f==="auto"){const i=h.LANG;return!i||i.search(/\.UTF\-8$/)===-1&&i.search(/\.utf8$/)===-1&&i.search(/\.euc.+/)===-1}return!1}e.shouldSetLangEnvVariable=T;function C(h){const f=h?h.split("-"):[],i=f.length;if(i===0)return"en_US.UTF-8";if(i===1){const n={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};f[0]in n&&f.push(n[f[0]])}else f[1]=f[1].toUpperCase();return f.join("_")+".UTF-8"}e.getLangEnvVariable=C;async function w(h,f,i,n,r,o){if(h.cwd){const l=typeof h.cwd=="object"?h.cwd.fsPath:h.cwd,s=await m(l,i);return(0,S.sanitizeCwd)(s||l)}let a;return!h.ignoreConfigurationCwd&&r&&(i&&(r=await m(r,i,o)),r&&(b.isAbsolute(r)?a=r:n&&(a=b.join(n.fsPath,r)))),a||(a=n?n.fsPath:f||""),(0,S.sanitizeCwd)(a)}e.getCwd=w;async function m(h,f,i){if(f)try{return await f(h)}catch(n){i?.error("Could not resolve terminal cwd",n);return}return h}function g(h,f,i){if(!!i)return n=>i.resolveWithEnvironment(f,h,n)}e.createVariableResolver=g;async function p(h,f,i,n,r,o,a,l=k.platform){let s;a&&(s=v(h,"automationShell",l)),s||(s=v(h,"shell",l));let u=s||f;if(l===3&&!i&&n){const P=b.join(n,"Sysnative").replace(/\//g,"\\").toLowerCase();u&&u.toLowerCase().indexOf(P)===0&&(u=b.join(n,"System32",u.substr(P.length+1)))}if(u&&l===3&&(u=u.replace(/\//g,"\\")),r)try{u=await r(u)}catch(P){o.error("Could not resolve shell",P)}return u}e.getDefaultShell=p;async function d(h,f,i,n,r=k.platform){if(f&&v(h,"automationShell",r))return[];const o=r===3?"windows":r===1?"osx":"linux";let a=h(`terminal.integrated.shellArgs.${o}`);if(!a)return[];if(typeof a=="string"&&r===3)return i?await i(a):a;if(i){const l=[];for(const s of a)try{l.push(await i(s))}catch(u){n.error(`Could not resolve terminal.integrated.shellArgs.${o}`,u),l.push(s)}a=l}return a}e.getDefaultShellArgs=d;function v(h,f,i=k.platform){return h(`terminal.integrated.${f}.${i===3?"windows":i===1?"osx":"linux"}`)}async function c(h,f,i,n,r,o){const a={};if(h.strictEnv)y(a,h.env);else{y(a,o);const l={...f};i&&(l&&await D(i,l),h.env&&await D(i,h.env)),(0,t.sanitizeProcessEnvironment)(a,"VSCODE_IPC_HOOK_CLI"),I(a,l),I(a,h.env),E(a,n,k.locale,r)}return a}e.createTerminalEnvironment=c}),define(ve[67],be([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var b;(function(S){S.Delimiter="\0"})(b=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(S){S[S.IsSame=0]="IsSame",S[S.Disconnected=1]="Disconnected",S[S.IsChild=2]="IsChild",S[S.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class k{static fromExtHostTestItem(I,A,E=I.parent){if(I._isRoot)return new k([A]);const y=[I.id];for(let D=E;D&&D.id!==A;D=D.parent)y.push(D.id);return y.push(A),new k(y.reverse())}static isRoot(I){return!I.includes("\0")}static root(I){const A=I.indexOf("\0");return A===-1?I:I.slice(0,A)}static fromString(I){return new k(I.split("\0"))}static join(I,A){return new k([...I.path,A])}static joinToString(I,A){return I.toString()+"\0"+A}static parentId(I){const A=I.lastIndexOf("\0");return A===-1?void 0:I.slice(0,A)}static compare(I,A){return I===A?0:A.startsWith(I+"\0")?2:I.startsWith(A+"\0")?3:1}constructor(I,A=I.length){if(this.path=I,this.d=A,I.length===0||A<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new k(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let I=1;I<=this.d;I++)yield new k(this.path,I)}*idsToRoot(){for(let I=this.d;I>0;I--)yield new k(this.path,I)}compare(I){if(typeof I=="string")return k.compare(this.toString(),I);for(let A=0;A<I.d&&A<this.d;A++)if(I.path[A]!==this.path[A])return 1;return I.d>this.d?2:I.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let I=1;I<this.d;I++)this.c+="\0",this.c+=this.path[I]}return this.c}}e.TestId=k}),define(ve[83],be([1,0,4,46,67]),function(ie,e,b,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var S;(function(l){l[l.Unset=0]="Unset",l[l.Queued=1]="Queued",l[l.Running=2]="Running",l[l.Passed=3]="Passed",l[l.Failed=4]="Failed",l[l.Skipped=5]="Skipped",l[l.Errored=6]="Errored"})(S=e.TestResultState||(e.TestResultState={}));var I;(function(l){l[l.Run=2]="Run",l[l.Debug=4]="Debug",l[l.Coverage=8]="Coverage",l[l.HasNonDefaultProfile=16]="HasNonDefaultProfile",l[l.HasConfigurable=32]="HasConfigurable"})(I=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var A;(function(l){l.serialize=s=>({range:s.range.toJSON(),uri:s.uri.toJSON()}),l.deserialize=s=>({range:t.Range.lift(s.range),uri:b.URI.revive(s.uri)})})(A=e.IRichLocation||(e.IRichLocation={}));var E;(function(l){l[l.Error=0]="Error",l[l.Output=1]="Output"})(E=e.TestMessageType||(e.TestMessageType={}));var y;(function(l){l.serialize=s=>({message:s.message,type:0,expected:s.expected,actual:s.actual,location:s.location&&A.serialize(s.location)}),l.deserialize=s=>({message:s.message,type:0,expected:s.expected,actual:s.actual,location:s.location&&A.deserialize(s.location)})})(y=e.ITestErrorMessage||(e.ITestErrorMessage={}));const D=(l,s)=>`${s?"s":"e"}${l}`;e.getMarkId=D;var T;(function(l){l.serialize=s=>({message:s.message,type:1,offset:s.offset,length:s.length,location:s.location&&A.serialize(s.location)}),l.deserialize=s=>({message:s.message,type:1,offset:s.offset,length:s.length,location:s.location&&A.deserialize(s.location)})})(T=e.ITestOutputMessage||(e.ITestOutputMessage={}));var C;(function(l){l.serialize=s=>s.type===0?y.serialize(s):T.serialize(s),l.deserialize=s=>s.type===0?y.deserialize(s):T.deserialize(s)})(C=e.ITestMessage||(e.ITestMessage={}));var w;(function(l){l.serializeWithoutMessages=s=>({state:s.state,duration:s.duration,messages:[]}),l.serialize=s=>({state:s.state,duration:s.duration,messages:s.messages.map(C.serialize)}),l.deserialize=s=>({state:s.state,duration:s.duration,messages:s.messages.map(C.deserialize)})})(w=e.ITestTaskState||(e.ITestTaskState={}));const m="\0",g=(l,s)=>l+m+s;e.namespaceTestTag=g;const p=l=>{const s=l.indexOf(m);return{ctrlId:l.slice(0,s),tagId:l.slice(s+1)}};e.denamespaceTestTag=p;var d;(function(l){l.serialize=s=>({extId:s.extId,label:s.label,tags:s.tags,busy:s.busy,children:void 0,uri:s.uri?.toJSON(),range:s.range?.toJSON()||null,description:s.description,error:s.error,sortText:s.sortText}),l.deserialize=s=>({extId:s.extId,label:s.label,tags:s.tags,busy:s.busy,children:void 0,uri:s.uri?b.URI.revive(s.uri):void 0,range:s.range?t.Range.lift(s.range):null,description:s.description,error:s.error,sortText:s.sortText})})(d=e.ITestItem||(e.ITestItem={}));var v;(function(l){l[l.NotExpandable=0]="NotExpandable",l[l.Expandable=1]="Expandable",l[l.BusyExpanding=2]="BusyExpanding",l[l.Expanded=3]="Expanded"})(v=e.TestItemExpandState||(e.TestItemExpandState={}));var c;(function(l){l.serialize=s=>({expand:s.expand,item:d.serialize(s.item)}),l.deserialize=s=>({controllerId:k.TestId.root(s.item.extId),expand:s.expand,item:d.deserialize(s.item)})})(c=e.InternalTestItem||(e.InternalTestItem={}));var h;(function(l){l.serialize=s=>{let u;return s.item&&(u={},s.item.label!==void 0&&(u.label=s.item.label),s.item.tags!==void 0&&(u.tags=s.item.tags),s.item.busy!==void 0&&(u.busy=s.item.busy),s.item.uri!==void 0&&(u.uri=s.item.uri?.toJSON()),s.item.range!==void 0&&(u.range=s.item.range?.toJSON()),s.item.description!==void 0&&(u.description=s.item.description),s.item.error!==void 0&&(u.error=s.item.error),s.item.sortText!==void 0&&(u.sortText=s.item.sortText)),{extId:s.extId,expand:s.expand,item:u}},l.deserialize=s=>{let u;return s.item&&(u={},s.item.label!==void 0&&(u.label=s.item.label),s.item.tags!==void 0&&(u.tags=s.item.tags),s.item.busy!==void 0&&(u.busy=s.item.busy),s.item.range!==void 0&&(u.range=s.item.range?t.Range.lift(s.item.range):null),s.item.description!==void 0&&(u.description=s.item.description),s.item.error!==void 0&&(u.error=s.item.error),s.item.sortText!==void 0&&(u.sortText=s.item.sortText)),{extId:s.extId,expand:s.expand,item:u}}})(h=e.ITestItemUpdate||(e.ITestItemUpdate={}));const f=(l,s)=>{s.expand!==void 0&&(l.expand=s.expand),s.item!==void 0&&(l.item=l.item?Object.assign(l.item,s.item):s.item)};e.applyTestItemUpdate=f;var i;(function(l){l.serializeWithoutMessages=s=>({...c.serialize(s),ownComputedState:s.ownComputedState,computedState:s.computedState,tasks:s.tasks.map(w.serializeWithoutMessages),retired:s.retired}),l.serialize=s=>({...c.serialize(s),ownComputedState:s.ownComputedState,computedState:s.computedState,tasks:s.tasks.map(w.serialize),retired:s.retired}),l.deserialize=s=>({...c.deserialize(s),ownComputedState:s.ownComputedState,computedState:s.computedState,tasks:s.tasks.map(w.deserialize),retired:!0})})(i=e.TestResultItem||(e.TestResultItem={}));var n;(function(l){l[l.Function=0]="Function",l[l.Statement=1]="Statement"})(n=e.DetailType||(e.DetailType={}));var r;(function(l){l[l.Add=0]="Add",l[l.Update=1]="Update",l[l.DocumentSynced=2]="DocumentSynced",l[l.Remove=3]="Remove",l[l.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",l[l.Retire=5]="Retire",l[l.AddTag=6]="AddTag",l[l.RemoveTag=7]="RemoveTag"})(r=e.TestDiffOpType||(e.TestDiffOpType={}));var o;(function(l){l.deserialize=s=>s.op===0?{op:s.op,item:c.deserialize(s.item)}:s.op===1?{op:s.op,item:h.deserialize(s.item)}:s.op===2?{op:s.op,uri:b.URI.revive(s.uri),docv:s.docv}:s,l.serialize=s=>s.op===0?{op:s.op,item:c.serialize(s.item)}:s.op===1?{op:s.op,item:h.serialize(s.item)}:s})(o=e.TestsDiffOp||(e.TestsDiffOp={}));class a{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(s){const u=this.o();for(const P of s)switch(P.op){case 0:this.j(c.deserialize(P.item),u);break;case 1:this.k(h.deserialize(P.item),u);break;case 3:this.l(P.itemId,u);break;case 5:this.m(P.itemId);break;case 4:this.updatePendingRoots(P.amount);break;case 6:this.c.set(P.tag.id,P.tag);break;case 7:this.c.delete(P.id);break}u.complete?.()}j(s,u){const P=k.TestId.parentId(s.item.extId)?.toString();let F;if(!P)F=this.p(s),this.f.add(F),this.d.set(s.item.extId,F);else if(this.d.has(P)){const K=this.d.get(P);K.children.add(s.item.extId),F=this.p(s,K),this.d.set(s.item.extId,F)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(s)}`);return}return u.add?.(F),s.expand===2&&this.g++,F}k(s,u){const P=this.d.get(s.extId);if(!!P)return s.expand!==void 0&&(P.expand===2&&this.g--,s.expand===2&&this.g++),(0,e.applyTestItemUpdate)(P,s),u.update?.(P),P}l(s,u){const P=this.d.get(s);if(!P)return;const F=k.TestId.parentId(P.item.extId)?.toString();F?this.d.get(F).children.delete(P.item.extId):this.f.delete(P);const K=[[s]];for(;K.length;)for(const ne of K.pop()){const ue=this.d.get(ne);ue&&(K.push(ue.children),this.d.delete(ne),u.remove?.(ue,ue!==P),ue.expand===2&&this.g--)}}m(s){}updatePendingRoots(s){this.h+=s}o(){return{}}}e.AbstractIncrementalTestCollection=a}),define(ve[123],be([1,0,14,6,2,85,83,67]),function(ie,e,b,t,k,S,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var E;(function(v){v[v.Upsert=0]="Upsert",v[v.SetTags=1]="SetTags",v[v.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",v[v.RemoveChild=3]="RemoveChild",v[v.SetProp=4]="SetProp",v[v.Bulk=5]="Bulk",v[v.DocumentSynced=6]="DocumentSynced"})(E=e.TestItemEventOp||(e.TestItemEventOp={}));const y=(v,c)=>v===c,T=Object.entries({range:(v,c)=>v===c?!0:!v||!c?!1:v.equalsRange(c),busy:y,label:y,description:y,error:y,sortText:y,tags:(v,c)=>!(v.length!==c.length||v.some(h=>!c.includes(h)))}),C=(v,c)=>{let h;for(const[f,i]of T)i(v[f],c[f])||(h?h[f]=c[f]:h={[f]:c[f]});return h};class w extends k.Disposable{get root(){return this.m.root}constructor(c){super(),this.m=c,this.f=this.B(new b.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.B(new t.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(c){this.h=c;for(const h of this.tree.values())this.G(h)}collectDiff(){const c=this.k;return this.k=[],c}pushDiff(c){switch(c.op){case 2:{for(const h of this.k)if(h.op===2&&h.uri===c.uri){h.docv=c.docv;return}break}case 1:{const h=this.k[this.k.length-1];if(h){if(h.op===1&&h.item.extId===c.item.extId){(0,I.applyTestItemUpdate)(h.item,c.item);return}if(h.op===0&&h.item.item.extId===c.item.extId){(0,I.applyTestItemUpdate)(h.item,c.item);return}}break}}this.k.push(c),this.f.isScheduled()||this.f.schedule()}expand(c,h){const f=this.tree.get(c);if(!!f){if((f.expandLevels===void 0||h>f.expandLevels)&&(f.expandLevels=h),f.expand===1){const i=this.I(f);return i.isOpen()?this.H(f,h-1):i.wait().then(()=>this.H(f,h-1))}else if(f.expand===3)return f.resolveBarrier?.isOpen()===!1?f.resolveBarrier.wait().then(()=>this.H(f,h-1)):this.H(f,h-1)}}dispose(){for(const c of this.tree.values())this.m.getApiFor(c.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(c,h){switch(h.op){case 3:this.L(A.TestId.joinToString(c.fullId,h.id));break;case 0:this.u(h.item,c);break;case 5:for(const f of h.ops)this.p(c,f);break;case 1:this.w(h.new,h.old,c.fullId.toString());break;case 2:this.G(c);break;case 4:this.pushDiff({op:1,item:{extId:c.fullId.toString(),item:h.update}});break;case 6:this.s(c.actual.uri);break;default:(0,S.assertNever)(h)}}s(c){c&&this.pushDiff({op:2,uri:c,docv:this.m.getDocumentVersion(c)})}u(c,h){const f=A.TestId.fromExtHostTestItem(c,this.root.id,h?.actual),i=this.m.getApiFor(c);i.parent&&i.parent!==h?.actual&&this.m.getChildren(i.parent).delete(c.id);let n=this.tree.get(f.toString());if(!n){n={fullId:f,actual:c,expandLevels:h?.expandLevels?h.expandLevels-1:void 0,expand:0},c.tags.forEach(this.y,this),this.tree.set(n.fullId.toString(),n),this.C(c,h),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:n.expand,item:this.m.toITestItem(c)}}),this.F(c,n,h);return}if(n.actual===c){this.D(c,n,h);return}if(n.actual.uri?.toString()!==c.uri?.toString())return this.L(f.toString()),this.u(c,h);const r=this.m.getChildren(n.actual),o=n.actual,a=C(this.m.toITestItem(o),this.m.toITestItem(c));this.m.getApiFor(o).listener=void 0,n.actual=c,n.expand=0,a&&(a.hasOwnProperty("tags")&&(this.w(c.tags,o.tags,f.toString()),delete a.tags),this.p(n,{op:4,update:a})),this.F(c,n,h);for(const[l,s]of r)this.m.getChildren(c).get(s.id)||this.L(A.TestId.joinToString(f,s.id));this.s(n.actual.uri)}w(c,h,f){const i=new Set(h.map(n=>n.id));for(const n of c)i.delete(n.id)||this.y(n);this.pushDiff({op:1,item:{extId:f,item:{tags:c.map(n=>(0,I.namespaceTestTag)(this.m.controllerId,n.id))}}}),i.forEach(this.z,this)}y(c){const h=this.j.get(c.id);h?h.refCount++:(this.j.set(c.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,I.namespaceTestTag)(this.m.controllerId,c.id)}}))}z(c){const h=this.j.get(c);h&&!--h.refCount&&(this.j.delete(c),this.pushDiff({op:7,id:(0,I.namespaceTestTag)(this.m.controllerId,c)}))}C(c,h){this.m.getApiFor(c).parent=h&&h.actual!==this.root?h.actual:void 0}D(c,h,f){this.C(c,f);const i=this.m.getApiFor(c);i.parent=f?.actual,i.listener=n=>this.p(h,n),this.G(h)}F(c,h,f){this.D(c,h,f);for(const[i,n]of this.m.getChildren(c))this.u(n,h)}G(c){let h;this.h?c.resolveBarrier?h=c.resolveBarrier.isOpen()?3:2:h=c.actual.canResolveChildren?1:0:h=0,h!==c.expand&&(c.expand=h,this.pushDiff({op:1,item:{extId:c.fullId.toString(),expand:h}}),h===1&&c.expandLevels!==void 0&&this.I(c))}H(c,h){if(h<0)return;const f=[];for(const[i,n]of this.m.getChildren(c.actual)){const r=this.expand(A.TestId.joinToString(c.fullId,n.id),h);(0,b.isThenable)(r)&&f.push(r)}if(f.length)return Promise.all(f).then(()=>{})}I(c){if(c.resolveBarrier)return c.resolveBarrier;if(!this.h){const n=new b.Barrier;return n.open(),n}c.expand=2,this.J(c);const h=c.resolveBarrier=new b.Barrier,f=n=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,n)};let i;try{i=this.h(c.actual===this.root?void 0:c.actual)}catch(n){f(n)}return(0,b.isThenable)(i)?i.catch(f).then(()=>{h.open(),this.G(c)}):(h.open(),this.G(c)),c.resolveBarrier}J(c){this.pushDiff({op:1,item:{extId:c.fullId.toString(),expand:c.expand}})}L(c){const h=this.tree.get(c);if(!h)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:c});const f=[h];for(;f.length;){const i=f.pop();if(!!i){this.m.getApiFor(i.actual).listener=void 0;for(const n of i.actual.tags)this.z(n.id);this.tree.delete(i.fullId.toString());for(const[n,r]of this.m.getChildren(i.actual))f.push(this.tree.get(A.TestId.joinToString(i.fullId,r.id)))}}}flushDiff(){const c=this.collectDiff();c.length&&this.g.fire(c)}}e.TestItemCollection=w;class m extends Error{constructor(c){super(`Attempted to insert a duplicate test item ID ${c}`)}}e.DuplicateTestItemError=m;class g extends Error{constructor(c){super(`TestItem with ID "${c}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=g;class p extends Error{constructor(c,h,f){super(`TestItem with ID "${c}" is from controller "${h}" and cannot be added as a child of an item from controller "${f}".`)}}e.MixedTestItemController=p;const d=(v,c,h)=>{let f=new Map;return{get size(){return f.size},forEach(i,n){for(const r of f.values())i.call(n,r,this)},[Symbol.iterator](){return f.entries()},replace(i){const n=new Map,r=new Set(f.keys()),o={op:5,ops:[]};for(const a of i){if(!(a instanceof h))throw new g(a.id);const l=c(a).controllerId;if(l!==v.controllerId)throw new p(a.id,l,v.controllerId);if(n.has(a.id))throw new m(a.id);n.set(a.id,a),r.delete(a.id),o.ops.push({op:0,item:a})}for(const a of r.keys())o.ops.push({op:3,id:a});v.listener?.(o),f=n},add(i){if(!(i instanceof h))throw new g(i.id);f.set(i.id,i),v.listener?.({op:0,item:i})},delete(i){f.delete(i)&&v.listener?.({op:3,id:i})},get(i){return f.get(i)},toJSON(){return Array.from(f.values())}}};e.createTestItemChildren=d}),define(ve[124],be([1,0,123]),function(ie,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const t=new WeakMap,k=(I,A)=>{const E={controllerId:A};return t.set(I,E),E};e.createPrivateApiFor=k;const S=I=>{const A=t.get(I);if(!A)throw new b.InvalidTestItemError(I?.id||"<unknown>");return A};e.getPrivateApiFor=S}),define(ve[252],be([1,0,24,5]),function(ie,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TASKS_DEFAULT=e.IWorkbenchConfigurationService=e.USER_STANDALONE_CONFIGURATIONS=e.WORKSPACE_STANDALONE_CONFIGURATIONS=e.LAUNCH_CONFIGURATION_KEY=e.TASKS_CONFIGURATION_KEY=e.FOLDER_SCOPES=e.WORKSPACE_SCOPES=e.REMOTE_MACHINE_SCOPES=e.LOCAL_MACHINE_SCOPES=e.LOCAL_MACHINE_PROFILE_SCOPES=e.PROFILE_SCOPES=e.APPLICATION_SCOPES=e.tasksSchemaId=e.launchSchemaId=e.folderSettingsSchemaId=e.workspaceSettingsSchemaId=e.machineSettingsSchemaId=e.profileSettingsSchemaId=e.userSettingsSchemaId=e.defaultSettingsSchemaId=e.FOLDER_SETTINGS_PATH=e.FOLDER_SETTINGS_NAME=e.FOLDER_CONFIG_FOLDER_NAME=void 0,e.FOLDER_CONFIG_FOLDER_NAME=".vscode",e.FOLDER_SETTINGS_NAME="settings",e.FOLDER_SETTINGS_PATH=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.FOLDER_SETTINGS_NAME}.json`,e.defaultSettingsSchemaId="vscode://schemas/settings/default",e.userSettingsSchemaId="vscode://schemas/settings/user",e.profileSettingsSchemaId="vscode://schemas/settings/profile",e.machineSettingsSchemaId="vscode://schemas/settings/machine",e.workspaceSettingsSchemaId="vscode://schemas/settings/workspace",e.folderSettingsSchemaId="vscode://schemas/settings/folder",e.launchSchemaId="vscode://schemas/launch",e.tasksSchemaId="vscode://schemas/tasks",e.APPLICATION_SCOPES=[1],e.PROFILE_SCOPES=[2,3,4,5],e.LOCAL_MACHINE_PROFILE_SCOPES=[3,4,5],e.LOCAL_MACHINE_SCOPES=[1,...e.LOCAL_MACHINE_PROFILE_SCOPES],e.REMOTE_MACHINE_SCOPES=[2,3,4,5,6],e.WORKSPACE_SCOPES=[3,4,5,6],e.FOLDER_SCOPES=[4,5,6],e.TASKS_CONFIGURATION_KEY="tasks",e.LAUNCH_CONFIGURATION_KEY="launch",e.WORKSPACE_STANDALONE_CONFIGURATIONS=Object.create(null),e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.TASKS_CONFIGURATION_KEY}.json`,e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.LAUNCH_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.LAUNCH_CONFIGURATION_KEY}.json`,e.USER_STANDALONE_CONFIGURATIONS=Object.create(null),e.USER_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.TASKS_CONFIGURATION_KEY}.json`,e.IWorkbenchConfigurationService=(0,t.refineServiceDecorator)(b.IConfigurationService),e.TASKS_DEFAULT=`{
	"version": "2.0.0",
	"tasks": []
}`}),define(ve[125],be([1,0,5]),function(ie,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,b.createDecorator)("configurationResolverService");var t;(function(S){S.Unknown="unknown",S.Env="env",S.Config="config",S.Command="command",S.Input="input",S.ExtensionInstallFolder="extensionInstallFolder",S.WorkspaceFolder="workspaceFolder",S.Cwd="cwd",S.WorkspaceFolderBasename="workspaceFolderBasename",S.UserHome="userHome",S.LineNumber="lineNumber",S.SelectedText="selectedText",S.File="file",S.FileWorkspaceFolder="fileWorkspaceFolder",S.RelativeFile="relativeFile",S.RelativeFileDirname="relativeFileDirname",S.FileDirname="fileDirname",S.FileExtname="fileExtname",S.FileBasename="fileBasename",S.FileBasenameNoExtension="fileBasenameNoExtension",S.FileDirnameBasename="fileDirnameBasename",S.ExecPath="execPath",S.ExecInstallFolder="execInstallFolder",S.PathSeparator="pathSeparator"})(t=e.VariableKind||(e.VariableKind={}));class k extends Error{constructor(I,A){super(A),this.variable=I}}e.VariableError=k}),define(ve[253],be([1,0,7,27,11,23,3,154,187,125,15]),function(ie,e,b,t,k,S,I,A,E,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class T{constructor(w,m,g,p){this.g=new Map,this.a=w,this.b=m,this.d=g,p&&(this.c=p.then(d=>this.h(d)))}h(w){if(I.isWindows){const m=Object.create(null);return Object.keys(w).forEach(g=>{m[g.toLowerCase()]=w[g]}),m}return w}resolveWithEnvironment(w,m,g){return this.j({env:this.h(w),userHome:void 0},m?m.uri:void 0,g)}async resolveAsync(w,m){const g={env:await this.c,userHome:await this.d};return this.j(g,w?w.uri:void 0,m)}async i(w,m,g,p){const d=S.deepClone(m);I.isWindows&&d.windows?Object.keys(d.windows).forEach(c=>d[c]=d.windows[c]):I.isMacintosh&&d.osx?Object.keys(d.osx).forEach(c=>d[c]=d.osx[c]):I.isLinux&&d.linux&&Object.keys(d.linux).forEach(c=>d[c]=d.linux[c]),delete d.windows,delete d.osx,delete d.linux;const v={env:await this.c,userHome:await this.d};return this.j(v,w?w.uri:void 0,d,g,p)}async resolveAnyAsync(w,m,g){return this.i(w,m,g)}async resolveAnyMap(w,m,g){const p=new Map;return{newConfig:await this.i(w,m,g,p),resolvedVariables:p}}resolveWithInteractionReplace(w,m,g,p){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(w,m,g,p){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(w,m){if(this.g.has(w))throw new Error("Variable "+w+" is contributed twice.");this.g.set(w,m)}async j(w,m,g,p,d){if(k.isString(g))return this.l(w,m,g,p,d);if(Array.isArray(g))return Promise.all(g.map(v=>this.j(w,m,v,p,d)));if(k.isObject(g)){const v=Object.create(null),c=await Promise.all(Object.keys(g).map(async h=>[await this.l(w,m,h,p,d),await this.j(w,m,g[h],p,d)]));for(const[h,f]of c)v[h]=f;return v}return g}l(w,m,g,p,d){return(0,D.replaceAsync)(g,T.VARIABLE_REGEXP,async(v,c)=>{if(c.includes(T.VARIABLE_LHS))return v;let h=await this.n(w,v,c,m,p);return d?.set(c,h),h!==v&&k.isString(h)&&h.match(T.VARIABLE_REGEXP)&&(h=await this.l(w,m,h,p,d)),h})}m(w){return this.b?this.b.getUriLabel(w,{noPrefix:!0}):w.fsPath}async n(w,m,g,p,d){let v;const c=g.split(":");c.length>1&&(g=c[0],v=c[1]);const h=n=>{const r=this.a.getFilePath();if(r)return r;throw new y.VariableError(n,(0,E.localize)(0,null,m))},f=n=>{const r=h(n);if(this.a.getWorkspaceFolderPathForFile){const o=this.a.getWorkspaceFolderPathForFile();if(o)return o}throw new y.VariableError(n,(0,E.localize)(1,null,m,b.basename(r)))},i=n=>{if(v){const r=this.a.getFolderUri(v);if(r)return r;throw new y.VariableError(n,(0,E.localize)(2,null,m,v))}if(p)return p;throw this.a.getWorkspaceFolderCount()>1?new y.VariableError(n,(0,E.localize)(3,null,m)):new y.VariableError(n,(0,E.localize)(4,null,m))};switch(g){case"env":if(v){if(w.env){const n=w.env[I.isWindows?v.toLowerCase():v];if(k.isString(n))return n}return""}throw new y.VariableError(y.VariableKind.Env,(0,E.localize)(5,null,m));case"config":if(v){const n=this.a.getConfigurationValue(p,v);if(k.isUndefinedOrNull(n))throw new y.VariableError(y.VariableKind.Config,(0,E.localize)(6,null,m,v));if(k.isObject(n))throw new y.VariableError(y.VariableKind.Config,(0,E.localize)(7,null,m,v));return n}throw new y.VariableError(y.VariableKind.Config,(0,E.localize)(8,null,m));case"command":return this.o(y.VariableKind.Command,m,v,d,"command");case"input":return this.o(y.VariableKind.Input,m,v,d,"input");case"extensionInstallFolder":if(v){const n=await this.a.getExtension(v);if(!n)throw new y.VariableError(y.VariableKind.ExtensionInstallFolder,(0,E.localize)(9,null,m,v));return this.m(n.extensionLocation)}throw new y.VariableError(y.VariableKind.ExtensionInstallFolder,(0,E.localize)(10,null,m));default:switch(g){case"workspaceRoot":case"workspaceFolder":return(0,A.normalizeDriveLetter)(this.m(i(y.VariableKind.WorkspaceFolder)));case"cwd":return p||v?(0,A.normalizeDriveLetter)(this.m(i(y.VariableKind.Cwd))):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return b.basename(this.m(i(y.VariableKind.WorkspaceFolderBasename)));case"userHome":{if(w.userHome)return w.userHome;throw new y.VariableError(y.VariableKind.UserHome,(0,E.localize)(11,null,m))}case"lineNumber":{const n=this.a.getLineNumber();if(n)return n;throw new y.VariableError(y.VariableKind.LineNumber,(0,E.localize)(12,null,m))}case"selectedText":{const n=this.a.getSelectedText();if(n)return n;throw new y.VariableError(y.VariableKind.SelectedText,(0,E.localize)(13,null,m))}case"file":return h(y.VariableKind.File);case"fileWorkspaceFolder":return f(y.VariableKind.FileWorkspaceFolder);case"relativeFile":return p||v?b.relative(this.m(i(y.VariableKind.RelativeFile)),h(y.VariableKind.RelativeFile)):h(y.VariableKind.RelativeFile);case"relativeFileDirname":{const n=b.dirname(h(y.VariableKind.RelativeFileDirname));if(p||v){const r=b.relative(this.m(i(y.VariableKind.RelativeFileDirname)),n);return r.length===0?".":r}return n}case"fileDirname":return b.dirname(h(y.VariableKind.FileDirname));case"fileExtname":return b.extname(h(y.VariableKind.FileExtname));case"fileBasename":return b.basename(h(y.VariableKind.FileBasename));case"fileBasenameNoExtension":{const n=b.basename(h(y.VariableKind.FileBasenameNoExtension));return n.slice(0,n.length-b.extname(n).length)}case"fileDirnameBasename":return b.basename(b.dirname(h(y.VariableKind.FileDirnameBasename)));case"execPath":{const n=this.a.getExecPath();return n||m}case"execInstallFolder":{const n=this.a.getAppRoot();return n||m}case"pathSeparator":return b.sep;default:try{const n=v?`${g}:${v}`:g;return this.o(y.VariableKind.Unknown,m,n,d,void 0)}catch{return m}}}}o(w,m,g,p,d){if(g&&p){const v=d===void 0?p[g]:p[d+":"+g];if(typeof v=="string")return v;throw new y.VariableError(w,(0,E.localize)(14,null,m))}return m}}e.AbstractVariableResolverService=T,T.VARIABLE_LHS="${",T.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ve[254],be([1,0,5,82]),function(ie,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,b.createDecorator)("editorGroupsService");var k;(function(m){m[m.UP=0]="UP",m[m.DOWN=1]="DOWN",m[m.LEFT=2]="LEFT",m[m.RIGHT=3]="RIGHT"})(k=e.GroupDirection||(e.GroupDirection={}));var S;(function(m){m[m.HORIZONTAL=0]="HORIZONTAL",m[m.VERTICAL=1]="VERTICAL"})(S=e.GroupOrientation||(e.GroupOrientation={}));var I;(function(m){m[m.FIRST=0]="FIRST",m[m.LAST=1]="LAST",m[m.NEXT=2]="NEXT",m[m.PREVIOUS=3]="PREVIOUS"})(I=e.GroupLocation||(e.GroupLocation={}));var A;(function(m){m[m.MAXIMIZE=0]="MAXIMIZE",m[m.EVEN=1]="EVEN",m[m.TOGGLE=2]="TOGGLE"})(A=e.GroupsArrangement||(e.GroupsArrangement={}));var E;(function(m){m[m.COPY_EDITORS=0]="COPY_EDITORS",m[m.MOVE_EDITORS=1]="MOVE_EDITORS"})(E=e.MergeGroupMode||(e.MergeGroupMode={}));function y(m){const g=m;return(0,t.isEditorInput)(g?.editor)&&(0,t.isEditorInput)(g?.replacement)}e.isEditorReplacement=y;var D;(function(m){m[m.CREATION_TIME=0]="CREATION_TIME",m[m.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",m[m.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(D=e.GroupsOrder||(e.GroupsOrder={}));var T;(function(m){m[m.NEW_EDITOR=1]="NEW_EDITOR",m[m.MOVE_EDITOR=2]="MOVE_EDITOR",m[m.COPY_EDITOR=3]="COPY_EDITOR"})(T=e.OpenEditorContext||(e.OpenEditorContext={}));function C(m){const g=m;return!!g&&typeof g.id=="number"&&Array.isArray(g.editors)}e.isEditorGroup=C;function w(m){return m.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=w}),define(ve[126],be([1,0,5,254]),function(ie,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,b.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function k(S){const I=S;return typeof S=="number"||(0,t.isEditorGroup)(I)}e.isPreferredGroup=k}),define(ve[255],be([1,0,11,252,12,108,81,122,125,82,126,13,207,121]),function(ie,e,b,t,k,S,I,A,E,y,D,T,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannelClient=e.REMOTE_TERMINAL_CHANNEL_NAME=void 0,e.REMOTE_TERMINAL_CHANNEL_NAME="remoteterminal";let m=class{get onPtyHostExit(){return this.b.listen("$onPtyHostExitEvent")}get onPtyHostStart(){return this.b.listen("$onPtyHostStartEvent")}get onPtyHostUnresponsive(){return this.b.listen("$onPtyHostUnresponsiveEvent")}get onPtyHostResponsive(){return this.b.listen("$onPtyHostResponsiveEvent")}get onPtyHostRequestResolveVariables(){return this.b.listen("$onPtyHostRequestResolveVariablesEvent")}get onProcessData(){return this.b.listen("$onProcessDataEvent")}get onProcessExit(){return this.b.listen("$onProcessExitEvent")}get onProcessReady(){return this.b.listen("$onProcessReadyEvent")}get onProcessReplay(){return this.b.listen("$onProcessReplayEvent")}get onProcessOrphanQuestion(){return this.b.listen("$onProcessOrphanQuestion")}get onExecuteCommand(){return this.b.listen("$onExecuteCommand")}get onDidRequestDetach(){return this.b.listen("$onDidRequestDetach")}get onDidChangeProperty(){return this.b.listen("$onDidChangeProperty")}constructor(p,d,v,c,h,f,i,n,r,o){this.a=p,this.b=d,this.c=v,this.d=c,this.e=h,this.f=f,this.g=i,this.h=n,this.i=r,this.j=o}restartPtyHost(){return this.b.call("$restartPtyHost",[])}async createProcess(p,d,v,c,h,f,i,n){await this.c.whenRemoteConfigurationLoaded();const r=Object.create(null),o=v?(0,b.withNullAsUndefined)(this.d.getWorkspaceFolder(v)):void 0;let a;try{a=(await this.e.resolveAnyMap(o,{shellLaunchConfig:p,configuration:d})).resolvedVariables}catch(se){this.h.error(se)}if(a)for(const[se,U]of a.entries())(/^config:/.test(se)||se==="selectedText"||se==="lineNumber")&&(r[se]=U);const l=[];for(const[se,U]of this.f.collections.entries())l.push([se,(0,A.serializeEnvironmentVariableCollection)(U.map)]);const s=await this.g.resolveAuthority(this.a),u=s.options&&s.options.extensionHostEnv,P=this.d.getWorkspace(),F=P.folders,K=v?this.d.getWorkspaceFolder(v):null,ne=y.EditorResourceAccessor.getOriginalUri(this.i.activeEditor,{supportSideBySide:y.SideBySideEditor.PRIMARY,filterByScheme:[T.Schemas.file,T.Schemas.vscodeUserData,T.Schemas.vscodeRemote]}),ue={configuration:d,resolvedVariables:r,envVariableCollections:l,shellLaunchConfig:p,workspaceId:P.id,workspaceName:this.j.getWorkspaceLabel(P),workspaceFolders:F,activeWorkspaceFolder:K,activeFileResource:ne,shouldPersistTerminal:h,options:c,cols:f,rows:i,unicodeVersion:n,resolverEnv:u};return await this.b.call("$createProcess",ue)}requestDetachInstance(p,d){return this.b.call("$requestDetachInstance",[p,d])}acceptDetachInstanceReply(p,d){return this.b.call("$acceptDetachInstanceReply",[p,d])}attachToProcess(p){return this.b.call("$attachToProcess",[p])}detachFromProcess(p,d){return this.b.call("$detachFromProcess",[p,d])}listProcesses(){return this.b.call("$listProcesses")}reduceConnectionGraceTime(){return this.b.call("$reduceConnectionGraceTime")}processBinary(p,d){return this.b.call("$processBinary",[p,d])}start(p){return this.b.call("$start",[p])}input(p,d){return this.b.call("$input",[p,d])}acknowledgeDataEvent(p,d){return this.b.call("$acknowledgeDataEvent",[p,d])}setUnicodeVersion(p,d){return this.b.call("$setUnicodeVersion",[p,d])}shutdown(p,d){return this.b.call("$shutdown",[p,d])}resize(p,d,v){return this.b.call("$resize",[p,d,v])}getInitialCwd(p){return this.b.call("$getInitialCwd",[p])}getCwd(p){return this.b.call("$getCwd",[p])}orphanQuestionReply(p){return this.b.call("$orphanQuestionReply",[p])}sendCommandResult(p,d,v){return this.b.call("$sendCommandResult",[p,d,v])}freePortKillProcess(p){return this.b.call("$freePortKillProcess",[p])}installAutoReply(p,d){return this.b.call("$installAutoReply",[p,d])}uninstallAllAutoReplies(){return this.b.call("$uninstallAllAutoReplies",[])}getDefaultSystemShell(p){return this.b.call("$getDefaultSystemShell",[p])}getProfiles(p,d,v){return this.b.call("$getProfiles",[this.d.getWorkspace().id,p,d,v])}acceptPtyHostResolvedVariables(p,d){return this.b.call("$acceptPtyHostResolvedVariables",[p,d])}getEnvironment(){return this.b.call("$getEnvironment")}getWslPath(p){return this.b.call("$getWslPath",[p])}setTerminalLayoutInfo(p){const v={workspaceId:this.d.getWorkspace().id,tabs:p?p.tabs:[]};return this.b.call("$setTerminalLayoutInfo",v)}updateTitle(p,d,v){return this.b.call("$updateTitle",[p,d,v])}updateIcon(p,d,v,c){return this.b.call("$updateIcon",[p,d,v,c])}refreshProperty(p,d){return this.b.call("$refreshProperty",[p,d])}updateProperty(p,d,v){return this.b.call("$updateProperty",[p,d,v])}getTerminalLayoutInfo(){const d={workspaceId:this.d.getWorkspace().id};return this.b.call("$getTerminalLayoutInfo",d)}reviveTerminalProcesses(p,d){return this.b.call("$reviveTerminalProcesses",[p,d])}getRevivedPtyNewId(p){return this.b.call("$getRevivedPtyNewId",[p])}serializeTerminalState(p){return this.b.call("$serializeTerminalState",[p])}};m=Le([Oe(2,t.IWorkbenchConfigurationService),Oe(3,I.IWorkspaceContextService),Oe(4,E.IConfigurationResolverService),Oe(5,w.IEnvironmentVariableService),Oe(6,S.IRemoteAuthorityResolverService),Oe(7,k.ILogService),Oe(8,D.IEditorService),Oe(9,C.ILabelService)],m),e.RemoteTerminalChannelClient=m}),define(ve[256],be([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var b;(function(D){D[D.IPC=1]="IPC",D[D.Socket=2]="Socket",D[D.MessagePort=3]="MessagePort"})(b=e.ExtHostConnectionType||(e.ExtHostConnectionType={}));class t{constructor(T){this.pipeName=T,this.type=1}serialize(T){T[t.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=t,t.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class k{constructor(){this.type=2}serialize(T){T[k.ENV_KEY]="1"}}e.SocketExtHostConnection=k,k.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class S{constructor(){this.type=3}serialize(T){T[S.ENV_KEY]="1"}}e.MessagePortExtHostConnection=S,S.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function I(D){delete D[t.ENV_KEY],delete D[k.ENV_KEY],delete D[S.ENV_KEY]}function A(D,T){I(T),D.serialize(T)}e.writeExtHostConnection=A;function E(D){if(D[t.ENV_KEY])return y(D,new t(D[t.ENV_KEY]));if(D[k.ENV_KEY])return y(D,new k);if(D[S.ENV_KEY])return y(D,new S);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=E;function y(D,T){return I(D),T}}),define(ve[127],be([1,0,48,89,118,13,7,16,6,59,80,12,43,3,57,117,2,256]),function(ie,e,b,t,k,S,I,A,E,y,D,T,C,w,m,g,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostConnection=e.buildUserEnvironment=void 0;async function v(r={},o,a,l,s){const u=await(0,k.getNLSConfiguration)(a,l.userDataPath);let P={};if(o)try{P=await(0,D.getResolvedShellEnv)(s,l.args,process.env)}catch(U){s.error("ExtensionHostConnection#buildUserEnvironment resolving shell environment failed",U)}const K={...process.env,...P,VSCODE_AMD_ENTRYPOINT:"vs/workbench/api/node/extensionHostProcess",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_NLS_CONFIG:JSON.stringify(u,void 0,0),...r},ne=l.isBuilt?(0,I.join)(l.appRoot,"bin"):(0,I.join)(l.appRoot,"resources","server","bin-dev"),ue=(0,I.join)(ne,"remote-cli");let se=f(K,"PATH");return se?se=ue+I.delimiter+se:se=ue,i(K,"PATH",se),l.args["without-browser-env-var"]||(K.BROWSER=(0,I.join)(ne,"helpers",w.isWindows?"browser.cmd":"browser.sh")),n(K),K}e.buildUserEnvironment=v;class c{constructor(o,a){this.socket=o,this.initialDataChunk=a}socketDrain(){return this.socket.drain()}toIExtHostSocketMessage(){let o,a,l;return this.socket instanceof y.NodeSocket?(o=!0,a=!1,l=A.VSBuffer.alloc(0)):(o=!1,a=this.socket.permessageDeflate,l=this.socket.recordedInflateBytes),{type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:this.initialDataChunk.buffer.toString("base64"),skipWebSocketFrames:o,permessageDeflate:a,inflateBytes:l.buffer.toString("base64")}}}let h=class{constructor(o,a,l,s,u,P,F){this.i=o,this.j=u,this.l=P,this.m=F,this.b=new E.Emitter,this.onClose=this.b.event,this.c=!w.isWindows||!this.j.args["socket-path"],this.d=!1,this.f=a,this.g=null,this.h=new c(l,s),this.o("New connection established.")}get n(){return`[${this.f}][${this.i.substr(0,8)}][ExtensionHostConnection] `}o(o){this.l.info(`${this.n}${o}`)}p(o){this.l.error(`${this.n}${o}`)}async q(o,a){const l=new p.DisposableStore;l.add(a.socket),l.add((0,p.toDisposable)(()=>{o.destroy()}));const s=()=>{l.dispose()};l.add(a.socket.onEnd(s)),l.add(a.socket.onClose(s)),l.add(E.Event.fromNodeEventEmitter(o,"end")(s)),l.add(E.Event.fromNodeEventEmitter(o,"close")(s)),l.add(E.Event.fromNodeEventEmitter(o,"error")(s)),l.add(a.socket.onData(u=>o.write(u.buffer))),l.add(E.Event.fromNodeEventEmitter(o,"data")(u=>{a.socket.write(A.VSBuffer.wrap(u))})),a.initialDataChunk.byteLength>0&&o.write(a.initialDataChunk.buffer)}async r(o,a){await a.socketDrain();const l=a.toIExtHostSocketMessage();let s;a.socket instanceof y.NodeSocket?s=a.socket.socket:s=a.socket.socket.socket,o.send(l,s)}shortenReconnectionGraceTimeIfNecessary(){if(!this.g)return;const o={type:"VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"};this.g.send(o)}acceptReconnection(o,a,l){this.f=o,this.o("The client has reconnected.");const s=new c(a,l);if(!this.g){this.h=s;return}this.r(this.g,s)}s(){this.d||(this.d=!0,this.h&&(this.h.socket.end(),this.h=null),this.g&&(this.g.kill(),this.g=null),this.b.fire(void 0))}async start(o){try{let a=process.execArgv?process.execArgv.filter(se=>!/^--inspect(-brk)?=/.test(se)):[];o.port&&!process.pkg&&(a=[`--inspect${o.break?"-brk":""}=${o.port}`]);const l=await v(o.env,!0,o.language,this.j,this.l);(0,m.removeDangerousEnvVariables)(l);let s;if(this.c)(0,d.writeExtHostConnection)(new d.SocketExtHostConnection,l),s=null;else{const{namedPipeServer:se,pipeName:U}=await this.t();(0,d.writeExtHostConnection)(new d.IPCExtHostConnection(U),l),s=se}const u={env:l,execArgv:a,silent:!0},P=["--type=extensionHost","--transformURIs"],F=this.j.args["use-host-proxy"];P.push(`--useHostProxy=${F?"true":"false"}`),this.g=b.fork(S.FileAccess.asFileUri("bootstrap-fork").fsPath,P,u);const K=this.g.pid;this.o(`<${K}> Launched Extension Host Process.`),this.g.stdout.setEncoding("utf8"),this.g.stderr.setEncoding("utf8");const ne=E.Event.fromNodeEventEmitter(this.g.stdout,"data"),ue=E.Event.fromNodeEventEmitter(this.g.stderr,"data");if(ne(se=>this.o(`<${K}> ${se}`)),ue(se=>this.o(`<${K}><stderr> ${se}`)),this.g.on("error",se=>{this.p(`<${K}> Extension Host Process had an error`),this.l.error(se),this.s()}),this.g.on("exit",(se,U)=>{this.m.setExitInfo(this.i,{code:se,signal:U}),this.o(`<${K}> Extension Host Process exited with code: ${se}, signal: ${U}.`),this.s()}),s)s.on("connection",se=>{s.close(),this.q(se,this.h)});else{const se=U=>{U.type==="VSCODE_EXTHOST_IPC_READY"&&(this.g.removeListener("message",se),this.r(this.g,this.h),this.h=null)};this.g.on("message",se)}}catch(a){console.error("ExtensionHostConnection errored"),a&&console.error(a)}}t(){return new Promise((o,a)=>{const l=(0,y.createRandomIPCHandle)(),s=t.createServer();s.on("error",a),s.listen(l,()=>{s?.removeListener("error",a),o({pipeName:l,namedPipeServer:s})})})}};h=Le([Oe(4,C.IServerEnvironmentService),Oe(5,T.ILogService),Oe(6,g.IExtensionHostStatusService)],h),e.ExtensionHostConnection=h;function f(r,o){const a=Object.keys(r).filter(s=>s.toLowerCase()===o.toLowerCase()),l=a.length>0?a[0]:o;return r[l]}function i(r,o,a){const l=Object.keys(r).filter(u=>u.toLowerCase()===o.toLowerCase()),s=l.length>0?l[0]:o;r[s]=a}function n(r){for(const o of Object.keys(r))r[o]===null&&delete r[o]}}),define(ve[257],be([1,0,6,4,5,32,33]),function(ie,e,b,t,k,S,I){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.webWorkerExtHostLog=e.remoteExtHostLog=e.localExtHostLog=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new S.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:t.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,k.createDecorator)("extensionService");class E{constructor(l){this.affinity=l,this.kind=1}equals(l){return this.kind===l.kind&&this.affinity===l.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=E;class y{constructor(l){this.affinity=l,this.kind=2}equals(l){return this.kind===l.kind&&this.affinity===l.affinity}asString(){return this.affinity===0?"LocalWebWorker":`LocalWebWorker${this.affinity}`}}e.LocalWebWorkerRunningLocation=y;class D{constructor(){this.kind=3,this.affinity=0}equals(l){return this.kind===l.kind}asString(){return"Remote"}}e.RemoteRunningLocation=D;class T{constructor(l){this.dependency=l}}e.MissingExtensionDependency=T;var C;(function(a){a[a.LocalProcess=1]="LocalProcess",a[a.LocalWebWorker=2]="LocalWebWorker",a[a.Remote=3]="Remote"})(C=e.ExtensionHostKind||(e.ExtensionHostKind={}));function w(a){if(a===null)return"None";switch(a){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=w;class m{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,myToRemove:[],myToAdd:this.d}}set(l,s){const u=[],P=[],F=[],K=[],ne=d(this.c),ue=d(l),se=(G,X)=>G.extensionLocation.toString()===X.extensionLocation.toString()||G.isBuiltin===X.isBuiltin||G.isUserBuiltin===X.isUserBuiltin||G.isUnderDevelopment===X.isUnderDevelopment;for(const G of this.c){const X=ue.get(S.ExtensionIdentifier.toKey(G.identifier));if(!X){u.push(G.identifier),ne.delete(S.ExtensionIdentifier.toKey(G.identifier));continue}if(!se(G,X)){u.push(G.identifier),ne.delete(S.ExtensionIdentifier.toKey(G.identifier));continue}}for(const G of l){const X=ne.get(S.ExtensionIdentifier.toKey(G.identifier));if(!X){P.push(G);continue}if(!se(X,G)){u.push(X.identifier),ne.delete(S.ExtensionIdentifier.toKey(X.identifier));continue}}const U=p(this.d),Q=p(s);for(const G of this.d)Q.has(S.ExtensionIdentifier.toKey(G))||F.push(G);for(const G of s)U.has(S.ExtensionIdentifier.toKey(G))||K.push(G);const z={toRemove:u,toAdd:P,myToRemove:F,myToAdd:K};return this.delta(z),z}delta(l){const{toRemove:s,toAdd:u,myToRemove:P,myToAdd:F}=l,K=p(s),ne=p(P);for(let ue=0;ue<this.c.length;ue++)K.has(S.ExtensionIdentifier.toKey(this.c[ue].identifier))&&(this.c.splice(ue,1),ue--);for(let ue=0;ue<this.d.length;ue++)ne.has(S.ExtensionIdentifier.toKey(this.d[ue]))&&(this.d.splice(ue,1),ue--);for(const ue of u)this.c.push(ue);for(const ue of F)this.d.push(ue)}containsExtension(l){for(const s of this.d)if(S.ExtensionIdentifier.equals(s,l))return!0;return!1}}e.ExtensionHostExtensions=m;class g{constructor(l){if(this[A]="ExtensionIdentifierSet",this.c=new Map,this.d=S.ExtensionIdentifier.toKey,l)for(const s of l)this.add(s)}get size(){return this.c.size}add(l){return this.c.set(this.d(l),l),this}clear(){this.c.clear()}delete(l){return this.c.delete(this.d(l))}has(l){return this.c.has(this.d(l))}forEach(l,s){this.c.forEach(u=>l.call(s,u,u,this))}*entries(){for(const[l,s]of this.c)yield[s,s]}keys(){return this.c.values()}values(){return this.c.values()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.c.values()}}e.ExtensionIdentifierSet=g;function p(a){const l=new Set;for(const s of a)l.add(S.ExtensionIdentifier.toKey(s));return l}e.extensionIdentifiersArrayToSet=p;function d(a){const l=new Map;for(const s of a)l.set(S.ExtensionIdentifier.toKey(s.identifier),s);return l}function v(a,l){return a.enabledApiProposals?a.enabledApiProposals.includes(l):!1}e.isProposedApiEnabled=v;function c(a,l){if(!v(a,l))throw new Error(`Extension '${a.identifier.value}' CANNOT use API proposal: ${l}.
Its package.json#enabledApiProposals-property declares: ${a.enabledApiProposals?.join(", ")??"[]"} but NOT ${l}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${a.identifier.value}`)}e.checkProposedApiEnabled=c;class h{constructor(l,s,u,P){this.codeLoadingTime=l,this.activateCallTime=s,this.activateResolvedTime=u,this.activationReason=P}}e.ActivationTimes=h;class f{constructor(l,s){this.description=l,this.value=s}}e.ExtensionPointContribution=f,e.ExtensionHostLogFileName="exthost",e.localExtHostLog="extHostLog",e.remoteExtHostLog="remoteExtHostLog",e.webWorkerExtHostLog="webWorkerExtHostLog";var i;(function(a){a[a.Normal=0]="Normal",a[a.Immediate=1]="Immediate"})(i=e.ActivationKind||(e.ActivationKind={}));function n(a){return{type:a.isBuiltin?0:1,isBuiltin:a.isBuiltin||a.isUserBuiltin,identifier:{id:(0,I.getGalleryExtensionId)(a.publisher,a.name),uuid:a.uuid},manifest:a,location:a.extensionLocation,targetPlatform:a.targetPlatform,validations:[],isValid:!0}}e.toExtension=n;function r(a,l){return{identifier:new S.ExtensionIdentifier((0,I.getExtensionId)(a.manifest.publisher,a.manifest.name)),isBuiltin:a.type===0,isUserBuiltin:a.type===1&&a.isBuiltin,isUnderDevelopment:!!l,extensionLocation:a.location,...a.manifest,uuid:a.identifier.uuid,targetPlatform:a.targetPlatform,browserNlsBundleUris:a.browserNlsBundleUris}}e.toExtensionDescription=r;class o{constructor(){this.onDidRegisterExtensions=b.Event.None,this.onDidChangeExtensionsStatus=b.Event.None,this.onDidChangeExtensions=b.Event.None,this.onWillActivateByEvent=b.Event.None,this.onDidChangeResponsiveChange=b.Event.None,this.extensions=[]}activateByEvent(l){return Promise.resolve(void 0)}activationEventIsDone(l){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(l){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(l,s){return Promise.resolve(0)}getInspectPorts(l,s){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(l){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=o});var Lt=this&&this.__classPrivateFieldSet||function(ie,e,b,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!k:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(ie,b):k?k.value=b:e.set(ie,b),b},nt=this&&this.__classPrivateFieldGet||function(ie,e,b,t){if(b==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!t:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?t:b==="a"?t.call(ie):t?t.value:e.get(ie)};define(ve[128],be([1,0,18,8,92,26,56,15,11,4,22,17,108,120,257]),function(ie,e,b,t,k,S,I,A,E,y,D,T,C,w,m){"use strict";var g,p,d,v,c,h,f,i,n,r,o,a,l,s,u,P,F,K,ne,ue,se,U,Q;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function z(B){return Object.assign(B,{apply:function(){const te=arguments.length===1?[]:arguments[1];return Reflect.construct(B,te,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(B,[]);{const[te,...pe]=arguments;return Reflect.construct(B,pe,te.constructor)}}})}var G;(function(B){B.top="top",B.bottom="bottom"})(G=e.TerminalOutputAnchor||(e.TerminalOutputAnchor={}));var X;(function(B){B.command="command",B.opener="opener"})(X=e.TerminalQuickFixType||(e.TerminalQuickFixType={}));let ce=h=class{static from(...O){let te=O;return new h(function(){if(te){for(const pe of te)pe&&typeof pe.dispose=="function"&&pe.dispose();te=void 0}})}constructor(O){g.set(this,void 0),Lt(this,g,O,"f")}dispose(){typeof nt(this,g,"f")=="function"&&(nt(this,g,"f").call(this),Lt(this,g,void 0,"f"))}};g=new WeakMap,ce=h=Le([z],ce),e.Disposable=ce;let L=f=class{static Min(...O){if(O.length===0)throw new TypeError;let te=O[0];for(let pe=1;pe<O.length;pe++){const Ue=O[pe];Ue.isBefore(te)&&(te=Ue)}return te}static Max(...O){if(O.length===0)throw new TypeError;let te=O[0];for(let pe=1;pe<O.length;pe++){const Ue=O[pe];Ue.isAfter(te)&&(te=Ue)}return te}static isPosition(O){if(!O)return!1;if(O instanceof f)return!0;const{line:te,character:pe}=O;return typeof te=="number"&&typeof pe=="number"}static of(O){if(O instanceof f)return O;if(this.isPosition(O))return new f(O.line,O.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(O,te){if(O<0)throw(0,t.illegalArgument)("line must be non-negative");if(te<0)throw(0,t.illegalArgument)("character must be non-negative");this.c=O,this.e=te}isBefore(O){return this.c<O.c?!0:O.c<this.c?!1:this.e<O.e}isBeforeOrEqual(O){return this.c<O.c?!0:O.c<this.c?!1:this.e<=O.e}isAfter(O){return!this.isBeforeOrEqual(O)}isAfterOrEqual(O){return!this.isBefore(O)}isEqual(O){return this.c===O.c&&this.e===O.e}compareTo(O){return this.c<O.c?-1:this.c>O.line?1:this.e<O.e?-1:this.e>O.e?1:0}translate(O,te=0){if(O===null||te===null)throw(0,t.illegalArgument)();let pe;return typeof O>"u"?pe=0:typeof O=="number"?pe=O:(pe=typeof O.lineDelta=="number"?O.lineDelta:0,te=typeof O.characterDelta=="number"?O.characterDelta:0),pe===0&&te===0?this:new f(this.line+pe,this.character+te)}with(O,te=this.character){if(O===null||te===null)throw(0,t.illegalArgument)();let pe;return typeof O>"u"?pe=this.line:typeof O=="number"?pe=O:(pe=typeof O.line=="number"?O.line:this.line,te=typeof O.character=="number"?O.character:this.character),pe===this.line&&te===this.character?this:new f(pe,te)}toJSON(){return{line:this.line,character:this.character}}};L=f=Le([z],L),e.Position=L;let N=i=class{static isRange(O){return O instanceof i?!0:O?L.isPosition(O.start)&&L.isPosition(O.end):!1}static of(O){if(O instanceof i)return O;if(this.isRange(O))return new i(O.start,O.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(O,te,pe,Ue){let He,Ze;if(typeof O=="number"&&typeof te=="number"&&typeof pe=="number"&&typeof Ue=="number"?(He=new L(O,te),Ze=new L(pe,Ue)):L.isPosition(O)&&L.isPosition(te)&&(He=L.of(O),Ze=L.of(te)),!He||!Ze)throw new Error("Invalid arguments");He.isBefore(Ze)?(this.c=He,this.e=Ze):(this.c=Ze,this.e=He)}contains(O){return i.isRange(O)?this.contains(O.start)&&this.contains(O.end):L.isPosition(O)?!(L.of(O).isBefore(this.c)||this.e.isBefore(O)):!1}isEqual(O){return this.c.isEqual(O.c)&&this.e.isEqual(O.e)}intersection(O){const te=L.Max(O.start,this.c),pe=L.Min(O.end,this.e);if(!te.isAfter(pe))return new i(te,pe)}union(O){if(this.contains(O))return this;if(O.contains(this))return O;const te=L.Min(O.start,this.c),pe=L.Max(O.end,this.end);return new i(te,pe)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(O,te=this.end){if(O===null||te===null)throw(0,t.illegalArgument)();let pe;return O?L.isPosition(O)?pe=O:(pe=O.start||this.start,te=O.end||this.end):pe=this.start,pe.isEqual(this.c)&&te.isEqual(this.end)?this:new i(pe,te)}toJSON(){return[this.start,this.end]}};N=i=Le([z],N),e.Range=N;let V=n=class extends N{static isSelection(O){return O instanceof n?!0:O?N.isRange(O)&&L.isPosition(O.anchor)&&L.isPosition(O.active)&&typeof O.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(O,te,pe,Ue){let He,Ze;if(typeof O=="number"&&typeof te=="number"&&typeof pe=="number"&&typeof Ue=="number"?(He=new L(O,te),Ze=new L(pe,Ue)):L.isPosition(O)&&L.isPosition(te)&&(He=L.of(O),Ze=L.of(te)),!He||!Ze)throw new Error("Invalid arguments");super(He,Ze),this.f=He,this.g=Ze}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};V=n=Le([z],V),e.Selection=V;class ee{constructor(O,te,pe){if(typeof O!="string"||O.length===0)throw(0,t.illegalArgument)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,t.illegalArgument)("port");if(typeof pe<"u"&&(typeof pe!="string"||pe.length===0||!/^[0-9A-Za-z_\-]+$/.test(pe)))throw(0,t.illegalArgument)("connectionToken");this.host=O,this.port=Math.round(te),this.connectionToken=pe}}e.ResolvedAuthority=ee;class oe extends Error{static NotAvailable(O,te){return new oe(O,C.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(O){return new oe(O,C.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(O,te=C.RemoteAuthorityResolverErrorCode.Unknown,pe){super(O),this._message=O,this._code=te,this._detail=pe,Object.setPrototypeOf(this,oe.prototype)}}e.RemoteAuthorityResolverError=oe;var ge;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(ge=e.EndOfLine||(e.EndOfLine={}));var fe;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(fe=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let R=r=class{static isTextEdit(O){return O instanceof r?!0:O?N.isRange(O)&&typeof O.newText=="string":!1}static replace(O,te){return new r(O,te)}static insert(O,te){return r.replace(new N(O,O),te)}static delete(O){return r.replace(O,"")}static setEndOfLine(O){const te=new r(new N(new L(0,0),new L(0,0)),"");return te.newEol=O,te}get range(){return this.c}set range(O){if(O&&!N.isRange(O))throw(0,t.illegalArgument)("range");this.c=O}get newText(){return this.e||""}set newText(O){if(O&&typeof O!="string")throw(0,t.illegalArgument)("newText");this.e=O}get newEol(){return this.f}set newEol(O){if(O&&typeof O!="number")throw(0,t.illegalArgument)("newEol");this.f=O}constructor(O,te){this.c=O,this.e=te}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};R=r=Le([z],R),e.TextEdit=R;let M=o=class{static isNotebookCellEdit(O){return O instanceof o?!0:O?Tt.isNotebookRange(O)&&Array.isArray(O.newCells):!1}static replaceCells(O,te){return new o(O,te)}static insertCells(O,te){return new o(new Tt(O,O),te)}static deleteCells(O){return new o(O,[])}static updateCellMetadata(O,te){const pe=new o(new Tt(O,O),[]);return pe.newCellMetadata=te,pe}static updateNotebookMetadata(O){const te=new o(new Tt(0,0),[]);return te.newNotebookMetadata=O,te}constructor(O,te){this.range=O,this.newCells=te}};M=o=Le([z],M),e.NotebookEdit=M;class W{static isSnippetTextEdit(O){return O instanceof W?!0:O?N.isRange(O.range)&&me.isSnippetString(O.snippet):!1}static replace(O,te){return new W(O,te)}static insert(O,te){return W.replace(new N(O,O),te)}constructor(O,te){this.range=O,this.snippet=te}}e.SnippetTextEdit=W;var Y;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellReplace=5]="CellReplace",B[B.Snippet=6]="Snippet"})(Y=e.FileEditType||(e.FileEditType={}));let re=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(O,te,pe,Ue){this.c.push({_type:1,from:O,to:te,options:pe,metadata:Ue})}createFile(O,te,pe){this.c.push({_type:1,from:void 0,to:O,options:te,metadata:pe})}deleteFile(O,te,pe){this.c.push({_type:1,from:O,to:void 0,options:te,metadata:pe})}e(O,te,pe){this.c.push({_type:3,metadata:pe,uri:O,edit:{editType:5,metadata:te},notebookMetadata:te})}f(O,te,pe,Ue){const He=te.start,Ze=te.end;(He!==Ze||pe.length>0)&&this.c.push({_type:5,uri:O,index:He,count:Ze-He,cells:pe,metadata:Ue})}g(O,te,pe,Ue){this.c.push({_type:3,metadata:Ue,uri:O,edit:{editType:8,index:te,metadata:pe}})}replace(O,te,pe,Ue){this.c.push({_type:2,uri:O,edit:new R(te,pe),metadata:Ue})}insert(O,te,pe,Ue){this.replace(O,new N(te,te),pe,Ue)}delete(O,te,pe){this.replace(O,te,"",pe)}has(O){return this.c.some(te=>te._type===2&&te.uri.toString()===O.toString())}set(O,te){if(te)for(const pe of te){if(!pe)continue;let Ue,He;Array.isArray(pe)?(Ue=pe[0],He=pe[1]):Ue=pe,M.isNotebookCellEdit(Ue)?Ue.newCellMetadata?this.g(O,Ue.range.start,Ue.newCellMetadata,He):Ue.newNotebookMetadata?this.e(O,Ue.newNotebookMetadata,He):this.f(O,Ue.range,Ue.newCells,He):W.isSnippetTextEdit(Ue)?this.c.push({_type:6,uri:O,range:Ue.range,edit:Ue.snippet,metadata:He}):this.c.push({_type:2,uri:O,edit:Ue,metadata:He})}else{for(let pe=0;pe<this.c.length;pe++){const Ue=this.c[pe];switch(Ue._type){case 2:case 6:case 3:case 5:Ue.uri.toString()===O.toString()&&(this.c[pe]=void 0);break}}(0,b.coalesceInPlace)(this.c)}}get(O){const te=[];for(const pe of this.c)pe._type===2&&pe.uri.toString()===O.toString()&&te.push(pe.edit);return te}entries(){const O=new S.ResourceMap;for(const te of this.c)if(te._type===2){let pe=O.get(te.uri);pe||(pe=[te.uri,[]],O.set(te.uri,pe)),pe[1].push(te.edit)}return[...O.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};re=Le([z],re),e.WorkspaceEdit=re;let me=a=class{static isSnippetString(O){return O instanceof a?!0:O?typeof O.value=="string":!1}static c(O){return O.replace(/\$|}|\\/g,"\\$&")}constructor(O){this.e=1,this.value=O||""}appendText(O){return this.value+=a.c(O),this}appendTabstop(O=this.e++){return this.value+="$",this.value+=O,this}appendPlaceholder(O,te=this.e++){if(typeof O=="function"){const pe=new a;pe.e=this.e,O(pe),this.e=pe.e,O=pe.value}else O=a.c(O);return this.value+="${",this.value+=te,this.value+=":",this.value+=O,this.value+="}",this}appendChoice(O,te=this.e++){const pe=O.map(Ue=>Ue.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=pe,this.value+="|}",this}appendVariable(O,te){if(typeof te=="function"){const pe=new a;pe.e=this.e,te(pe),this.e=pe.e,te=pe.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=O,te&&(this.value+=":",this.value+=te),this.value+="}",this}};me=a=Le([z],me),e.SnippetString=me;var $;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})($=e.DiagnosticTag||(e.DiagnosticTag={}));var J;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(J=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let _=l=class{static isLocation(O){return O instanceof l?!0:O?N.isRange(O.range)&&y.URI.isUri(O.uri):!1}constructor(O,te){if(this.uri=O,te)if(N.isRange(te))this.range=N.of(te);else if(L.isPosition(te))this.range=new N(te,te);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};_=l=Le([z],_),e.Location=_;let j=class{static is(O){return O?typeof O.message=="string"&&O.location&&N.isRange(O.location.range)&&y.URI.isUri(O.location.uri):!1}constructor(O,te){this.location=O,this.message=te}static isEqual(O,te){return O===te?!0:!O||!te?!1:O.message===te.message&&O.location.range.isEqual(te.location.range)&&O.location.uri.toString()===te.location.uri.toString()}};j=Le([z],j),e.DiagnosticRelatedInformation=j;let H=class{constructor(O,te,pe=J.Error){if(!N.isRange(O))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=O,this.message=te,this.severity=pe}toJSON(){return{severity:J[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(O,te){return O===te?!0:!O||!te?!1:O.message===te.message&&O.severity===te.severity&&O.code===te.code&&O.severity===te.severity&&O.source===te.source&&O.range.isEqual(te.range)&&(0,b.equals)(O.tags,te.tags)&&(0,b.equals)(O.relatedInformation,te.relatedInformation,j.isEqual)}};H=Le([z],H),e.Diagnostic=H;let q=class{constructor(O,te){if(!O)throw new Error("Illegal argument, contents must be defined");Array.isArray(O)?this.contents=O:this.contents=[O],this.range=te}};q=Le([z],q),e.Hover=q;var Z;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(Z=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let ae=class{constructor(O,te=Z.Text){this.range=O,this.kind=te}toJSON(){return{range:this.range,kind:Z[this.kind]}}};ae=Le([z],ae),e.DocumentHighlight=ae;var we;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(we=e.SymbolKind||(e.SymbolKind={}));var ke;(function(B){B[B.Deprecated=1]="Deprecated"})(ke=e.SymbolTag||(e.SymbolTag={}));let Ae=s=class{static validate(O){if(!O.name)throw new Error("name must not be falsy")}constructor(O,te,pe,Ue,He){this.name=O,this.kind=te,this.containerName=He,typeof pe=="string"&&(this.containerName=pe),Ue instanceof _?this.location=Ue:pe instanceof N&&(this.location=new _(Ue,pe)),s.validate(this)}toJSON(){return{name:this.name,kind:we[this.kind],location:this.location,containerName:this.containerName}}};Ae=s=Le([z],Ae),e.SymbolInformation=Ae;let Me=u=class{static validate(O){if(!O.name)throw new Error("name must not be falsy");if(!O.range.contains(O.selectionRange))throw new Error("selectionRange must be contained in fullRange");O.children?.forEach(u.validate)}constructor(O,te,pe,Ue,He){this.name=O,this.detail=te,this.kind=pe,this.range=Ue,this.selectionRange=He,this.children=[],u.validate(this)}};Me=u=Le([z],Me),e.DocumentSymbol=Me;var ze;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(ze=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let de=class{constructor(O,te){this.title=O,this.kind=te}};de=Le([z],de),e.CodeAction=de;let Ee=P=class{constructor(O){this.value=O}append(O){return new P(this.value?this.value+P.c+O:O)}intersects(O){return this.contains(O)||O.contains(this)}contains(O){return this.value===O.value||O.value.startsWith(this.value+P.c)}};Ee.c=".",Ee=P=Le([z],Ee),e.CodeActionKind=Ee,Ee.Empty=new Ee(""),Ee.QuickFix=Ee.Empty.append("quickfix"),Ee.Refactor=Ee.Empty.append("refactor"),Ee.RefactorExtract=Ee.Refactor.append("extract"),Ee.RefactorInline=Ee.Refactor.append("inline"),Ee.RefactorMove=Ee.Refactor.append("move"),Ee.RefactorRewrite=Ee.Refactor.append("rewrite"),Ee.Source=Ee.Empty.append("source"),Ee.SourceOrganizeImports=Ee.Source.append("organizeImports"),Ee.SourceFixAll=Ee.Source.append("fixAll");let ye=class{constructor(O,te){if(this.range=O,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ye=Le([z],ye),e.SelectionRange=ye;class Fe{constructor(O,te,pe,Ue,He,Ze){this.kind=O,this.name=te,this.detail=pe,this.uri=Ue,this.range=He,this.selectionRange=Ze}}e.CallHierarchyItem=Fe;class Be{constructor(O,te){this.fromRanges=te,this.from=O}}e.CallHierarchyIncomingCall=Be;class Ye{constructor(O,te){this.fromRanges=te,this.to=O}}e.CallHierarchyOutgoingCall=Ye;var Ve;(function(B){B[B.Information=0]="Information",B[B.Warning=1]="Warning",B[B.Error=2]="Error"})(Ve=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Je=class{constructor(O,te){this.range=O,this.command=te}get isResolved(){return!!this.command}};Je=Le([z],Je),e.CodeLens=Je;let Xe=F=class{static isMarkdownString(O){return O instanceof F?!0:O&&O.appendCodeblock&&O.appendMarkdown&&O.appendText&&O.value!==void 0}constructor(O,te=!1){p.set(this,void 0),Lt(this,p,new k.MarkdownString(O,{supportThemeIcons:te}),"f")}get value(){return nt(this,p,"f").value}set value(O){nt(this,p,"f").value=O}get isTrusted(){return nt(this,p,"f").isTrusted}set isTrusted(O){nt(this,p,"f").isTrusted=O}get supportThemeIcons(){return nt(this,p,"f").supportThemeIcons}set supportThemeIcons(O){nt(this,p,"f").supportThemeIcons=O}get supportHtml(){return nt(this,p,"f").supportHtml}set supportHtml(O){nt(this,p,"f").supportHtml=O}get baseUri(){return nt(this,p,"f").baseUri}set baseUri(O){nt(this,p,"f").baseUri=O}appendText(O){return nt(this,p,"f").appendText(O),this}appendMarkdown(O){return nt(this,p,"f").appendMarkdown(O),this}appendCodeblock(O,te){return nt(this,p,"f").appendCodeblock(te??"",O),this}};p=new WeakMap,Xe=F=Le([z],Xe),e.MarkdownString=Xe;let tt=class{constructor(O,te){this.label=O,this.documentation=te}};tt=Le([z],tt),e.ParameterInformation=tt;let qe=class{constructor(O,te){this.label=O,this.documentation=te,this.parameters=[]}};qe=Le([z],qe),e.SignatureInformation=qe;let $e=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};$e=Le([z],$e),e.SignatureHelp=$e;var xe;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(xe=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var le;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(le=e.InlayHintKind||(e.InlayHintKind={}));let Ce=class{constructor(O){this.value=O}};Ce=Le([z],Ce),e.InlayHintLabelPart=Ce;let De=class{constructor(O,te,pe){this.position=O,this.label=te,this.kind=pe}};De=Le([z],De),e.InlayHint=De;var Te;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Te=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ne;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(Ne=e.CompletionItemKind||(e.CompletionItemKind={}));var We;(function(B){B[B.Deprecated=1]="Deprecated"})(We=e.CompletionItemTag||(e.CompletionItemTag={}));let Ge=class{constructor(O,te){this.label=O,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&Ne[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ge=Le([z],Ge),e.CompletionItem=Ge;let rt=class{constructor(O=[],te=!1){this.items=O,this.isIncomplete=te}};rt=Le([z],rt),e.CompletionList=rt;let it=class{constructor(O,te,pe){this.insertText=O,this.range=te,this.command=pe}};it=Le([z],it),e.InlineSuggestion=it;let Qe=class{constructor(O){this.commands=void 0,this.items=O}};Qe=Le([z],Qe),e.InlineSuggestionList=Qe;var ot;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(ot=e.ViewColumn||(e.ViewColumn={}));var lt;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(lt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ft;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative"})(ft=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var vt;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(vt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var kt;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(kt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var At;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(At=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Et;(function(B){B[B.Undo=1]="Undo",B[B.Redo=2]="Redo"})(Et=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Ot;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(Ot=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(B){function O(te){switch(te){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=O}(At=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let mt=class{constructor(O,te){if(te&&!y.URI.isUri(te))throw(0,t.illegalArgument)("target");if(!N.isRange(O)||O.isEmpty)throw(0,t.illegalArgument)("range");this.range=O,this.target=te}};mt=Le([z],mt),e.DocumentLink=mt;let St=class{constructor(O,te,pe,Ue){this.red=O,this.green=te,this.blue=pe,this.alpha=Ue}};St=Le([z],St),e.Color=St;let st=class{constructor(O,te){if(te&&!(te instanceof St))throw(0,t.illegalArgument)("color");if(!N.isRange(O)||O.isEmpty)throw(0,t.illegalArgument)("range");this.range=O,this.color=te}};st=Le([z],st),e.ColorInformation=st;let ut=class{constructor(O){if(!O||typeof O!="string")throw(0,t.illegalArgument)("label");this.label=O}};ut=Le([z],ut),e.ColorPresentation=ut;var gt;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(gt=e.ColorFormat||(e.ColorFormat={}));var Rt;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(Rt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var Mt;(function(B){B[B.Unknown=0]="Unknown",B[B.Shutdown=1]="Shutdown",B[B.Process=2]="Process",B[B.User=3]="User",B[B.Extension=4]="Extension"})(Mt=e.TerminalExitReason||(e.TerminalExitReason={}));class Se{constructor(O,te,pe){if(this.startIndex=O,this.length=te,this.tooltip=pe,typeof O!="number"||O<0)throw(0,t.illegalArgument)("startIndex");if(typeof te!="number"||te<1)throw(0,t.illegalArgument)("length");if(pe!==void 0&&typeof pe!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=Se;var Ie;(function(B){B[B.Panel=1]="Panel",B[B.Editor=2]="Editor"})(Ie=e.TerminalLocation||(e.TerminalLocation={}));class he{constructor(O){if(this.options=O,typeof O!="object")throw(0,t.illegalArgument)("options")}}e.TerminalProfile=he;var x;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(x=e.TaskRevealKind||(e.TaskRevealKind={}));var Pe;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(Pe=e.TaskPanelKind||(e.TaskPanelKind={}));let Re=K=class{static from(O){switch(O){case"clean":return K.Clean;case"build":return K.Build;case"rebuild":return K.Rebuild;case"test":return K.Test;default:return}}constructor(O,te){if(this.label=te,typeof O!="string"||typeof te!="string")throw(0,t.illegalArgument)("name");this.c=O}get id(){return this.c}};Re.Clean=new K("clean","Clean"),Re.Build=new K("build","Build"),Re.Rebuild=new K("rebuild","Rebuild"),Re.Test=new K("test","Test"),Re=K=Le([z],Re),e.TaskGroup=Re;function Ke(B){let O="";for(let te=0;te<B.length;te++)O+=B[te].replace(/,/g,",,")+",";return O}let je=class{constructor(O,te,pe){if(typeof O!="string")throw(0,t.illegalArgument)("process");this.e=[],this.c=O,te!==void 0&&(Array.isArray(te)?(this.e=te,this.f=pe):this.f=te)}get process(){return this.c}set process(O){if(typeof O!="string")throw(0,t.illegalArgument)("process");this.c=O}get args(){return this.e}set args(O){Array.isArray(O)||(O=[]),this.e=O}get options(){return this.f}set options(O){this.f=O}computeId(){const O=[];if(O.push("process"),this.c!==void 0&&O.push(this.c),this.e&&this.e.length>0)for(const te of this.e)O.push(te);return Ke(O)}};je=Le([z],je),e.ProcessExecution=je;let et=class{constructor(O,te,pe){if(this.f=[],Array.isArray(te)){if(!O)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof O!="string"&&typeof O.value!="string")throw(0,t.illegalArgument)("command");this.e=O,this.f=te,this.g=pe}else{if(typeof O!="string")throw(0,t.illegalArgument)("commandLine");this.c=O,this.g=te}}get commandLine(){return this.c}set commandLine(O){if(typeof O!="string")throw(0,t.illegalArgument)("commandLine");this.c=O}get command(){return this.e?this.e:""}set command(O){if(typeof O!="string"&&typeof O.value!="string")throw(0,t.illegalArgument)("command");this.e=O}get args(){return this.f}set args(O){this.f=O||[]}get options(){return this.g}set options(O){this.g=O}computeId(){const O=[];if(O.push("shell"),this.c!==void 0&&O.push(this.c),this.e!==void 0&&O.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const te of this.f)O.push(typeof te=="string"?te:te.value);return Ke(O)}};et=Le([z],et),e.ShellExecution=et;var ht;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(ht=e.ShellQuoting||(e.ShellQuoting={}));var Ct;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(Ct=e.TaskScope||(e.TaskScope={}));class bt{constructor(O){this.c=O}computeId(){return"customExecution"+(0,D.generateUuid)()}set callback(O){this.c=O}get callback(){return this.c}}e.CustomExecution=bt;let at=ne=class{constructor(O,te,pe,Ue,He,Ze){this.j=!1,this.k=this.definition=O;let _e;typeof te=="string"?(this.m=this.name=te,this.t=this.source=pe,this.execution=Ue,_e=He,this.j=!0):te===Ct.Global||te===Ct.Workspace?(this.target=te,this.m=this.name=pe,this.t=this.source=Ue,this.execution=He,_e=Ze):(this.target=te,this.m=this.name=pe,this.t=this.source=Ue,this.execution=He,_e=Ze),typeof _e=="string"?(this.o=[_e],this.q=!0):Array.isArray(_e)?(this.o=_e,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(O){this.h=O}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof je?this.k={type:ne.e,id:this.n.computeId()}:this.n instanceof et?this.k={type:ne.f,id:this.n.computeId()}:this.n instanceof bt?this.k={type:ne.c,id:this.n.computeId()}:this.k={type:ne.g,id:(0,D.generateUuid)()}}get definition(){return this.k}set definition(O){if(O==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=O}get scope(){return this.l}set target(O){this.y(),this.l=O}get name(){return this.m}set name(O){if(typeof O!="string")throw(0,t.illegalArgument)("name");this.y(),this.m=O}get execution(){return this.n}set execution(O){O===null&&(O=void 0),this.y(),this.n=O;const te=this.k.type;(ne.g===te||ne.e===te||ne.f===te||ne.c===te)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(O){if(Array.isArray(O))this.y(),this.o=O,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(O){O!==!0&&O!==!1&&(O=!1),this.y(),this.r=O}get source(){return this.t}set source(O){if(typeof O!="string"||O.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.y(),this.t=O}get group(){return this.u}set group(O){O===null&&(O=void 0),this.y(),this.u=O}get detail(){return this.x}set detail(O){O===null&&(O=void 0),this.x=O}get presentationOptions(){return this.v}set presentationOptions(O){O==null&&(O=Object.create(null)),this.y(),this.v=O}get runOptions(){return this.w}set runOptions(O){O==null&&(O=Object.create(null)),this.y(),this.w=O}};at.c="customExecution",at.e="process",at.f="shell",at.g="$empty",at=ne=Le([z],at),e.Task=at;var It;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(It=e.ProgressLocation||(e.ProgressLocation={}));var Dn;(function(B){function O(te){const pe=te;return(0,E.isNumber)(pe.value)?pe.tooltip&&!(0,E.isString)(pe.tooltip)?(console.log("INVALID view badge, invalid tooltip",pe.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",pe.value),!1)}B.isViewBadge=O})(Dn=e.ViewBadge||(e.ViewBadge={}));let Vt=ue=class{static isTreeItem(O,te){if(O instanceof ue)return!0;const pe=O;if(pe.label!==void 0&&!(0,E.isString)(pe.label)&&!pe.label?.label)return console.log("INVALID tree item, invalid label",pe.label),!1;if(pe.id!==void 0&&!(0,E.isString)(pe.id))return console.log("INVALID tree item, invalid id",pe.id),!1;if(pe.iconPath!==void 0&&!(0,E.isString)(pe.iconPath)&&!y.URI.isUri(pe.iconPath)&&(!pe.iconPath||!(0,E.isString)(pe.iconPath.id))){const Ue=pe.iconPath;if(!Ue||!(0,E.isString)(Ue.light)&&!y.URI.isUri(Ue.light)&&!(0,E.isString)(Ue.dark)&&!y.URI.isUri(Ue.dark))return console.log("INVALID tree item, invalid iconPath",pe.iconPath),!1}if(pe.description!==void 0&&!(0,E.isString)(pe.description)&&typeof pe.description!="boolean")return console.log("INVALID tree item, invalid description",pe.description),!1;if(pe.resourceUri!==void 0&&!y.URI.isUri(pe.resourceUri))return console.log("INVALID tree item, invalid resourceUri",pe.resourceUri),!1;if(pe.tooltip!==void 0&&!(0,E.isString)(pe.tooltip)&&!(pe.tooltip instanceof Xe))return console.log("INVALID tree item, invalid tooltip",pe.tooltip),!1;if(pe.command!==void 0&&!pe.command.command)return console.log("INVALID tree item, invalid command",pe.command),!1;if(pe.collapsibleState!==void 0&&pe.collapsibleState<jt.None&&pe.collapsibleState>jt.Expanded)return console.log("INVALID tree item, invalid collapsibleState",pe.collapsibleState),!1;if(pe.contextValue!==void 0&&!(0,E.isString)(pe.contextValue))return console.log("INVALID tree item, invalid contextValue",pe.contextValue),!1;if(pe.accessibilityInformation!==void 0&&!pe.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",pe.accessibilityInformation),!1;if(pe.checkboxState!==void 0){(0,m.checkProposedApiEnabled)(te,"treeItemCheckbox");const Ue=(0,E.isNumber)(pe.checkboxState)?pe.checkboxState:(0,E.isObject)(pe.checkboxState)&&(0,E.isNumber)(pe.checkboxState.state)?pe.checkboxState.state:void 0,He=!(0,E.isNumber)(pe.checkboxState)&&(0,E.isObject)(pe.checkboxState)?pe.checkboxState.tooltip:void 0;if(Ue===void 0||Ue!==qt.Checked&&Ue!==qt.Unchecked||He!==void 0&&!(0,E.isString)(He))return console.log("INVALID tree item, invalid checkboxState",pe.checkboxState),!1}return!0}constructor(O,te=jt.None){this.collapsibleState=te,y.URI.isUri(O)?this.resourceUri=O:this.label=O}};Vt=ue=Le([z],Vt),e.TreeItem=Vt;var jt;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})(jt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var qt;(function(B){B[B.Unchecked=0]="Unchecked",B[B.Checked=1]="Checked"})(qt=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let Gt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(O,te){this.value=O,this.id=te??(0,D.generateUuid)()}};Gt=Le([z],Gt),e.DataTransferItem=Gt;let Kt=class{constructor(O){d.set(this,new Map);for(const[te,pe]of O??[]){const Ue=nt(this,d,"f").get(te);Ue?Ue.push(pe):nt(this,d,"f").set(te,[pe])}}get(O){return nt(this,d,"f").get(O)?.[0]}set(O,te){nt(this,d,"f").set(O,[te])}forEach(O,te){for(const[pe,Ue]of nt(this,d,"f"))for(const He of Ue)O.call(te,He,pe,this)}*[(d=new WeakMap,Symbol.iterator)](){for(const[O,te]of nt(this,d,"f"))for(const pe of te)yield[O,pe]}};Kt=Le([z],Kt),e.DataTransfer=Kt;let xt=class{constructor(O){this.insertText=O}};xt=Le([z],xt),e.DocumentDropEdit=xt;let Jt=class{constructor(O){this.insertText=O}};Jt=Le([z],Jt),e.DocumentPasteEdit=Jt;let Dt=class{constructor(O,te){this.id=O,this.color=te}static isThemeIcon(O){return typeof O.id!="string"?(console.log("INVALID ThemeIcon, invalid id",O.id),!1):!0}};Dt=Le([z],Dt),e.ThemeIcon=Dt,Dt.File=new Dt("file"),Dt.Folder=new Dt("folder");let Yt=class{constructor(O){this.id=O}};Yt=Le([z],Yt),e.ThemeColor=Yt;var Pn;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(Pn=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Xt=class{get base(){return this.c}set base(O){this.c=O,this.e=y.URI.file(O)}get baseUri(){return this.e}set baseUri(O){this.e=O,this.c=O.fsPath}constructor(O,te){if(typeof O!="string"&&(!O||!y.URI.isUri(O)&&!y.URI.isUri(O.uri)))throw(0,t.illegalArgument)("base");if(typeof te!="string")throw(0,t.illegalArgument)("pattern");typeof O=="string"?this.baseUri=y.URI.file(O):y.URI.isUri(O)?this.baseUri=O:this.baseUri=O.uri,this.pattern=te}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};Xt=Le([z],Xt),e.RelativePattern=Xt;let Nt=class{constructor(O,te,pe,Ue){this.enabled=typeof O=="boolean"?O:!0,typeof te=="string"&&(this.condition=te),typeof pe=="string"&&(this.hitCondition=pe),typeof Ue=="string"&&(this.logMessage=Ue)}get id(){return this.c||(this.c=(0,D.generateUuid)()),this.c}};Nt=Le([z],Nt),e.Breakpoint=Nt;let Qt=class extends Nt{constructor(O,te,pe,Ue,He){if(super(te,pe,Ue,He),O===null)throw(0,t.illegalArgument)("location");this.location=O}};Qt=Le([z],Qt),e.SourceBreakpoint=Qt;let Zt=class extends Nt{constructor(O,te,pe,Ue,He){super(te,pe,Ue,He),this.functionName=O}};Zt=Le([z],Zt),e.FunctionBreakpoint=Zt;let _t=class extends Nt{constructor(O,te,pe,Ue,He,Ze,_e){if(super(Ue,He,Ze,_e),!te)throw(0,t.illegalArgument)("dataId");this.label=O,this.dataId=te,this.canPersist=pe}};_t=Le([z],_t),e.DataBreakpoint=_t;let en=class{constructor(O,te,pe){this.command=O,this.args=te||[],this.options=pe}};en=Le([z],en),e.DebugAdapterExecutable=en;let tn=class{constructor(O,te){this.port=O,this.host=te}};tn=Le([z],tn),e.DebugAdapterServer=tn;let nn=class{constructor(O){this.path=O}};nn=Le([z],nn),e.DebugAdapterNamedPipeServer=nn;let rn=class{constructor(O){this.implementation=O}};rn=Le([z],rn),e.DebugAdapterInlineImplementation=rn;let sn=class{constructor(O,te){this.range=O,this.expression=te}};sn=Le([z],sn),e.EvaluatableExpression=sn;var kn;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(kn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let on=class{constructor(O,te){this.range=O,this.text=te}};on=Le([z],on),e.InlineValueText=on;let an=class{constructor(O,te,pe=!0){this.range=O,this.variableName=te,this.caseSensitiveLookup=pe}};an=Le([z],an),e.InlineValueVariableLookup=an;let ln=class{constructor(O,te){this.range=O,this.expression=te}};ln=Le([z],ln),e.InlineValueEvaluatableExpression=ln;let cn=class{constructor(O,te){this.frameId=O,this.stoppedLocation=te}};cn=Le([z],cn),e.InlineValueContext=cn;var An;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(An=e.FileChangeType||(e.FileChangeType={}));let un=se=class extends Error{static FileExists(O){return new se(O,T.FileSystemProviderErrorCode.FileExists,se.FileExists)}static FileNotFound(O){return new se(O,T.FileSystemProviderErrorCode.FileNotFound,se.FileNotFound)}static FileNotADirectory(O){return new se(O,T.FileSystemProviderErrorCode.FileNotADirectory,se.FileNotADirectory)}static FileIsADirectory(O){return new se(O,T.FileSystemProviderErrorCode.FileIsADirectory,se.FileIsADirectory)}static NoPermissions(O){return new se(O,T.FileSystemProviderErrorCode.NoPermissions,se.NoPermissions)}static Unavailable(O){return new se(O,T.FileSystemProviderErrorCode.Unavailable,se.Unavailable)}constructor(O,te=T.FileSystemProviderErrorCode.Unknown,pe){super(y.URI.isUri(O)?O.toString(!0):O),this.code=pe?.name??"Unknown",(0,T.markAsFileSystemProviderError)(this,te),Object.setPrototypeOf(this,se.prototype),typeof Error.captureStackTrace=="function"&&typeof pe=="function"&&Error.captureStackTrace(this,pe)}};un=se=Le([z],un),e.FileSystemError=un;let fn=class{constructor(O,te,pe){this.start=O,this.end=te,this.kind=pe}};fn=Le([z],fn),e.FoldingRange=fn;var Tn;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(Tn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Rn;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(Rn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Ln;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(Ln=e.CommentMode||(e.CommentMode={}));var On;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(On=e.CommentThreadState||(e.CommentThreadState={}));class Nn{constructor(O,te=[]){this.tokenTypes=O,this.tokenModifiers=te}}e.SemanticTokensLegend=Nn;function Fn(B){return typeof B>"u"||(0,E.isStringArray)(B)}class hn{constructor(O){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,O){this.l=!0;for(let te=0,pe=O.tokenTypes.length;te<pe;te++)this.j.set(O.tokenTypes[te],te);for(let te=0,pe=O.tokenModifiers.length;te<pe;te++)this.k.set(O.tokenModifiers[te],te)}}push(O,te,pe,Ue,He){if(typeof O=="number"&&typeof te=="number"&&typeof pe=="number"&&typeof Ue=="number"&&(typeof He=="number"||typeof He>"u"))return typeof He>"u"&&(He=0),this.n(O,te,pe,Ue,He);if(N.isRange(O)&&typeof te=="string"&&Fn(pe))return this.m(O,te,pe);throw(0,t.illegalArgument)()}m(O,te,pe){if(!this.l)throw new Error("Legend must be provided in constructor");if(O.start.line!==O.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(te))throw new Error("`tokenType` is not in the provided legend");const Ue=O.start.line,He=O.start.character,Ze=O.end.character-O.start.character,_e=this.j.get(te);let ct=0;if(pe)for(const dt of pe){if(!this.k.has(dt))throw new Error("`tokenModifier` is not in the provided legend");const wt=this.k.get(dt);ct|=1<<wt>>>0}this.n(Ue,He,Ze,_e,ct)}n(O,te,pe,Ue,He){if(this.f&&(O<this.c||O===this.c&&te<this.e)){this.f=!1;const ct=this.g.length/5|0;let dt=0,wt=0;for(let yt=0;yt<ct;yt++){let Pt=this.g[5*yt],Ut=this.g[5*yt+1];Pt===0?(Pt=dt,Ut+=wt):Pt+=dt,this.g[5*yt]=Pt,this.g[5*yt+1]=Ut,dt=Pt,wt=Ut}}let Ze=O,_e=te;this.f&&this.h>0&&(Ze-=this.c,Ze===0&&(_e-=this.e)),this.g[this.h++]=Ze,this.g[this.h++]=_e,this.g[this.h++]=pe,this.g[this.h++]=Ue,this.g[this.h++]=He,this.c=O,this.e=te}static o(O){const te=[],pe=O.length/5|0;for(let _e=0;_e<pe;_e++)te[_e]=_e;te.sort((_e,ct)=>{const dt=O[5*_e],wt=O[5*ct];if(dt===wt){const yt=O[5*_e+1],Pt=O[5*ct+1];return yt-Pt}return dt-wt});const Ue=new Uint32Array(O.length);let He=0,Ze=0;for(let _e=0;_e<pe;_e++){const ct=5*te[_e],dt=O[ct+0],wt=O[ct+1],yt=O[ct+2],Pt=O[ct+3],Ut=O[ct+4],In=dt-He,bi=In===0?wt-Ze:wt,Bt=5*_e;Ue[Bt+0]=In,Ue[Bt+1]=bi,Ue[Bt+2]=yt,Ue[Bt+3]=Pt,Ue[Bt+4]=Ut,He=dt,Ze=wt}return Ue}build(O){return this.f?new dn(new Uint32Array(this.g),O):new dn(hn.o(this.g),O)}}e.SemanticTokensBuilder=hn;class dn{constructor(O,te){this.resultId=te,this.data=O}}e.SemanticTokens=dn;class Mn{constructor(O,te,pe){this.start=O,this.deleteCount=te,this.data=pe}}e.SemanticTokensEdit=Mn;class Un{constructor(O,te){this.resultId=te,this.edits=O}}e.SemanticTokensEdits=Un;var Bn;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(Bn=e.DebugConsoleMode||(e.DebugConsoleMode={}));let zt=class{constructor(){}};zt.Back={iconPath:new Dt("arrow-left")},zt=Le([z],zt),e.QuickInputButtons=zt;var jn;(function(B){B[B.Separator=-1]="Separator",B[B.Default=0]="Default"})(jn=e.QuickPickItemKind||(e.QuickPickItemKind={}));var zn;(function(B){B[B.Info=1]="Info",B[B.Warning=2]="Warning",B[B.Error=3]="Error"})(zn=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var $n;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})($n=e.ExtensionKind||(e.ExtensionKind={}));class Wn{static validate(O){if(typeof O.badge=="string"){let te=(0,A.nextCharLength)(O.badge,0);if(te<O.badge.length&&(te+=(0,A.nextCharLength)(O.badge,te)),O.badge.length>te)throw new Error("The 'badge'-property must be undefined or a short character")}else if(O.badge&&!Dt.isThemeIcon(O.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!O.color&&!O.badge&&!O.tooltip)throw new Error("The decoration is empty");return!0}constructor(O,te,pe){this.badge=O,this.tooltip=te,this.color=pe}}e.FileDecoration=Wn;let mn=class{constructor(O){this.kind=O}};mn=Le([z],mn),e.ColorTheme=mn;var Hn;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast",B[B.HighContrastLight=4]="HighContrastLight"})(Hn=e.ColorThemeKind||(e.ColorThemeKind={}));class Tt{static isNotebookRange(O){return O instanceof Tt?!0:O?typeof O.start=="number"&&typeof O.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(O,te){if(O<0)throw(0,t.illegalArgument)("start must be positive");if(te<0)throw(0,t.illegalArgument)("end must be positive");O<=te?(this.c=O,this.e=te):(this.c=te,this.e=O)}with(O){let te=this.c,pe=this.e;return O.start!==void 0&&(te=O.start),O.end!==void 0&&(pe=O.end),te===this.c&&pe===this.e?this:new Tt(te,pe)}}e.NotebookRange=Tt;class $t{static validate(O){if(typeof O.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof O.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof O.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(O){return Array.isArray(O)&&O.every(te=>$t.isNotebookCellData(te))}static isNotebookCellData(O){return!0}constructor(O,te,pe,Ue,He,Ze,_e){this.kind=O,this.value=te,this.languageId=pe,this.mime=Ue,this.outputs=He??[],this.metadata=Ze,this.executionSummary=_e,$t.validate(this)}}e.NotebookCellData=$t;class Vn{constructor(O){this.cells=O}}e.NotebookData=Vn;class pt{static isNotebookCellOutputItem(O){return O instanceof pt?!0:O?typeof O.mime=="string"&&O.data instanceof Uint8Array:!1}static error(O){const te={name:O.name,message:O.message,stack:O.stack};return pt.json(te,"application/vnd.code.notebook.error")}static stdout(O){return pt.text(O,"application/vnd.code.notebook.stdout")}static stderr(O){return pt.text(O,"application/vnd.code.notebook.stderr")}static bytes(O,te="application/octet-stream"){return new pt(O,te)}static text(O,te=I.Mimes.text){const pe=nt(pt,v,"f",c).encode(String(O));return new pt(pe,te)}static json(O,te="text/x-json"){const pe=JSON.stringify(O,void 0,"	");return pt.text(pe,te)}constructor(O,te){this.data=O,this.mime=te;const pe=(0,I.normalizeMimeType)(te,!0);if(!pe)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=pe}}e.NotebookCellOutputItem=pt,v=pt,c={value:new TextEncoder};class Wt{static isNotebookCellOutput(O){return O instanceof Wt?!0:!O||typeof O!="object"?!1:typeof O.id=="string"&&Array.isArray(O.items)}static ensureUniqueMimeTypes(O,te=!1){const pe=new Set,Ue=new Set;for(let He=0;He<O.length;He++){const Ze=O[He],_e=(0,I.normalizeMimeType)(Ze.mime);if(!pe.has(_e)||(0,w.isTextStreamMime)(_e)){pe.add(_e);continue}Ue.add(He),te&&console.warn(`DUPLICATED mime type '${Ze.mime}' will be dropped`)}return Ue.size===0?O:O.filter((He,Ze)=>!Ue.has(Ze))}constructor(O,te,pe){this.items=Wt.ensureUniqueMimeTypes(O,!0),typeof te=="string"?(this.id=te,this.metadata=pe):(this.id=(0,D.generateUuid)(),this.metadata=te??pe)}}e.NotebookCellOutput=Wt;var qn;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(qn=e.NotebookCellKind||(e.NotebookCellKind={}));var Gn;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(Gn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Kn;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(Kn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var xn;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(xn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Jn{constructor(O,te){this.text=O,this.alignment=te}}e.NotebookCellStatusBarItem=Jn;var Yn;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})(Yn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var Xn;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred",B[B.Hidden=-1]="Hidden"})(Xn=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class Qn{constructor(O,te=[]){this.uri=O,this.provides=(0,b.asArray)(te)}}e.NotebookRendererScript=Qn;class Zn{constructor(O){this.label=O}}e.NotebookKernelSourceAction=Zn;let gn=class{constructor(O,te){this.label=O,this.timestamp=te}};gn=Le([z],gn),e.TimelineItem=gn;var _n;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(_n=e.ExtensionMode||(e.ExtensionMode={}));var ei;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(ei=e.ExtensionRuntime||(e.ExtensionRuntime={}));var ti;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(ti=e.StandardTokenType||(e.StandardTokenType={}));class ni{constructor(O,te){this.ranges=O,this.wordPattern=te}}e.LinkedEditingRanges=ni;class ii{constructor(O,te){this.c=O,this.e=te}get port(){return this.c}get autoForwardAction(){return this.e}}e.PortAttributes=ii;var ri;(function(B){B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(ri=e.TestResultState||(e.TestResultState={}));var si;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(si=e.TestRunProfileKind||(e.TestRunProfileKind={}));let pn=class{constructor(O=void 0,te=void 0,pe=void 0){this.include=O,this.exclude=te,this.profile=pe}};pn=Le([z],pn),e.TestRunRequest=pn;let wn=U=class{static diff(O,te,pe){const Ue=new U(O);return Ue.expectedOutput=te,Ue.actualOutput=pe,Ue}constructor(O){this.message=O}};wn=U=Le([z],wn),e.TestMessage=wn;let vn=class{constructor(O){this.id=O}};vn=Le([z],vn),e.TestTag=vn;let Ft=class{constructor(O,te){this.covered=O,this.total=te}};Ft=Le([z],Ft),e.CoveredCount=Ft;let bn=Q=class{static fromDetails(O,te){const pe=new Ft(0,0),Ue=new Ft(0,0),He=new Ft(0,0);for(const _e of te)if("branches"in _e){pe.total+=1,pe.covered+=_e.executionCount>0?1:0;for(const ct of _e.branches)Ue.total+=1,Ue.covered+=ct.executionCount>0?1:0}else He.total+=1,He.covered+=_e.executionCount>0?1:0;const Ze=new Q(O,pe,Ue.total>0?Ue:void 0,He.total>0?He:void 0);return Ze.detailedCoverage=te,Ze}constructor(O,te,pe,Ue){this.uri=O,this.statementCoverage=te,this.branchCoverage=pe,this.functionCoverage=Ue}};bn=Q=Le([z],bn),e.FileCoverage=bn;let yn=class{constructor(O,te,pe=[]){this.executionCount=O,this.location=te,this.branches=pe}};yn=Le([z],yn),e.StatementCoverage=yn;let En=class{constructor(O,te){this.executionCount=O,this.location=te}};En=Le([z],En),e.BranchCoverage=En;let Sn=class{constructor(O,te){this.executionCount=O,this.location=te}};Sn=Le([z],Sn),e.FunctionCoverage=Sn;var oi;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(oi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var ai;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(ai=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var li;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore",B[B.OpenBrowserOnce=6]="OpenBrowserOnce"})(li=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class ci{constructor(O,te,pe,Ue,He,Ze){this.kind=O,this.name=te,this.detail=pe,this.uri=Ue,this.range=He,this.selectionRange=Ze}}e.TypeHierarchyItem=ci;class ui{constructor(O){this.uri=O}}e.TextTabInput=ui;class fi{constructor(O,te){this.original=O,this.modified=te}}e.TextDiffTabInput=fi;class hi{constructor(O,te,pe,Ue){this.base=O,this.input1=te,this.input2=pe,this.result=Ue}}e.TextMergeTabInput=hi;class di{constructor(O,te){this.uri=O,this.viewType=te}}e.CustomEditorTabInput=di;class mi{constructor(O){this.viewType=O}}e.WebviewEditorTabInput=mi;class gi{constructor(O,te){this.uri=O,this.notebookType=te}}e.NotebookEditorTabInput=gi;class pi{constructor(O,te,pe){this.original=O,this.modified=te,this.notebookType=pe}}e.NotebookDiffEditorTabInput=pi;class wi{constructor(){}}e.TerminalEditorTabInput=wi;class vi{constructor(O,te){this.uri=O,this.inputBoxUri=te}}e.InteractiveWindowInput=vi}),define(ve[129],be([1,0,18,16,139,68,92,26,137,47,56,23,11,4,46,159,214,124,82,120,67,83,126,128]),function(ie,e,b,t,k,S,I,A,E,y,D,T,C,w,m,g,p,d,v,c,h,f,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var r;(function(Se){function Ie(x){const{selectionStartLineNumber:Pe,selectionStartColumn:Re,positionLineNumber:Ke,positionColumn:je}=x,et=new n.Position(Pe-1,Re-1),ht=new n.Position(Ke-1,je-1);return new n.Selection(et,ht)}Se.to=Ie;function he(x){const{anchor:Pe,active:Re}=x;return{selectionStartLineNumber:Pe.line+1,selectionStartColumn:Pe.character+1,positionLineNumber:Re.line+1,positionColumn:Re.character+1}}Se.from=he})(r=e.Selection||(e.Selection={}));var o;(function(Se){function Ie(x){if(!x)return;const{start:Pe,end:Re}=x;return{startLineNumber:Pe.line+1,startColumn:Pe.character+1,endLineNumber:Re.line+1,endColumn:Re.character+1}}Se.from=Ie;function he(x){if(!x)return;const{startLineNumber:Pe,startColumn:Re,endLineNumber:Ke,endColumn:je}=x;return new n.Range(Pe-1,Re-1,Ke-1,je-1)}Se.to=he})(o=e.Range||(e.Range={}));var a;(function(Se){function Ie(he){switch(he){case 1:return n.StandardTokenType.Comment;case 0:return n.StandardTokenType.Other;case 3:return n.StandardTokenType.RegEx;case 2:return n.StandardTokenType.String}}Se.to=Ie})(a=e.TokenType||(e.TokenType={}));var l;(function(Se){function Ie(x){return new n.Position(x.lineNumber-1,x.column-1)}Se.to=Ie;function he(x){return{lineNumber:x.line+1,column:x.character+1}}Se.from=he})(l=e.Position||(e.Position={}));var s;(function(Se){function Ie(Pe,Re){return(0,b.coalesce)((0,b.asArray)(Pe).map(Ke=>he(Ke,Re)))}Se.from=Ie;function he(Pe,Re){if(typeof Pe=="string")return{$serialized:!0,language:Pe};if(Pe)return{$serialized:!0,language:Pe.language,scheme:x(Pe.scheme,Re),pattern:le.from(Pe.pattern)??void 0,exclusive:Pe.exclusive,notebookType:Pe.notebookType}}function x(Pe,Re){return Re&&typeof Pe=="string"?Re.transformOutgoingScheme(Pe):Pe}})(s=e.DocumentSelector||(e.DocumentSelector={}));var u;(function(Se){function Ie(x){switch(x){case n.DiagnosticTag.Unnecessary:return 1;case n.DiagnosticTag.Deprecated:return 2}}Se.from=Ie;function he(x){switch(x){case 1:return n.DiagnosticTag.Unnecessary;case 2:return n.DiagnosticTag.Deprecated;default:return}}Se.to=he})(u=e.DiagnosticTag||(e.DiagnosticTag={}));var P;(function(Se){function Ie(x){let Pe;return x.code&&((0,C.isString)(x.code)||(0,C.isNumber)(x.code)?Pe=String(x.code):Pe={value:String(x.code.value),target:x.code.target}),{...o.from(x.range),message:x.message,source:x.source,code:Pe,severity:K.from(x.severity),relatedInformation:x.relatedInformation&&x.relatedInformation.map(F.from),tags:Array.isArray(x.tags)?(0,b.coalesce)(x.tags.map(u.from)):void 0}}Se.from=Ie;function he(x){const Pe=new n.Diagnostic(o.to(x),x.message,K.to(x.severity));return Pe.source=x.source,Pe.code=(0,C.isString)(x.code)?x.code:x.code?.value,Pe.relatedInformation=x.relatedInformation&&x.relatedInformation.map(F.to),Pe.tags=x.tags&&(0,b.coalesce)(x.tags.map(u.to)),Pe}Se.to=he})(P=e.Diagnostic||(e.Diagnostic={}));var F;(function(Se){function Ie(x){return{...o.from(x.location.range),message:x.message,resource:x.location.uri}}Se.from=Ie;function he(x){return new n.DiagnosticRelatedInformation(new n.Location(x.resource,o.to(x)),x.message)}Se.to=he})(F=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var K;(function(Se){function Ie(x){switch(x){case n.DiagnosticSeverity.Error:return p.MarkerSeverity.Error;case n.DiagnosticSeverity.Warning:return p.MarkerSeverity.Warning;case n.DiagnosticSeverity.Information:return p.MarkerSeverity.Info;case n.DiagnosticSeverity.Hint:return p.MarkerSeverity.Hint}return p.MarkerSeverity.Error}Se.from=Ie;function he(x){switch(x){case p.MarkerSeverity.Info:return n.DiagnosticSeverity.Information;case p.MarkerSeverity.Warning:return n.DiagnosticSeverity.Warning;case p.MarkerSeverity.Error:return n.DiagnosticSeverity.Error;case p.MarkerSeverity.Hint:return n.DiagnosticSeverity.Hint;default:return n.DiagnosticSeverity.Error}}Se.to=he})(K=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var ne;(function(Se){function Ie(x){return typeof x=="number"&&x>=n.ViewColumn.One?x-1:x===n.ViewColumn.Beside?i.SIDE_GROUP:i.ACTIVE_GROUP}Se.from=Ie;function he(x){if(typeof x=="number"&&x>=0)return x+1;throw new Error("invalid 'EditorGroupColumn'")}Se.to=he})(ne=e.ViewColumn||(e.ViewColumn={}));function ue(Se){return typeof Se.range<"u"}function se(Se){return Se.length===0?!0:!!ue(Se[0])}e.isDecorationOptionsArr=se;var U;(function(Se){function Ie(je){return je.map(Se.from)}Se.fromMany=Ie;function he(je){return je&&typeof je=="object"&&typeof je.language=="string"&&typeof je.value=="string"}function x(je){let et;if(he(je)){const{language:at,value:It}=je;et={value:"```"+at+`
`+It+"\n```\n"}}else n.MarkdownString.isMarkdownString(je)?et={value:je.value,isTrusted:je.isTrusted,supportThemeIcons:je.supportThemeIcons,supportHtml:je.supportHtml,baseUri:je.baseUri}:typeof je=="string"?et={value:je}:et={value:""};const ht=Object.create(null);et.uris=ht;const Ct=at=>{try{let It=w.URI.parse(at,!0);It=It.with({query:Pe(It.query,ht)}),ht[at]=It}catch{}return""},bt=new E.marked.Renderer;return bt.link=Ct,bt.image=at=>typeof at=="string"?Ct(I.parseHrefAndDimensions(at).href):"",(0,E.marked)(et.value,{renderer:bt}),et}Se.from=x;function Pe(je,et){if(!je)return je;let ht;try{ht=(0,y.parse)(je)}catch{}if(!ht)return je;let Ct=!1;return ht=(0,T.cloneAndChange)(ht,bt=>{if(w.URI.isUri(bt)){const at=`__uri_${Math.random().toString(16).slice(2,8)}`;return et[at]=bt,Ct=!0,at}else return}),Ct?JSON.stringify(ht):je}function Re(je){const et=new n.MarkdownString(je.value,je.supportThemeIcons);return et.isTrusted=je.isTrusted,et.supportHtml=je.supportHtml,et.baseUri=je.baseUri?w.URI.from(je.baseUri):void 0,et}Se.to=Re;function Ke(je){if(!!je)return typeof je=="string"?je:Se.from(je)}Se.fromStrict=Ke})(U=e.MarkdownString||(e.MarkdownString={}));function Q(Se){return se(Se)?Se.map(Ie=>({range:o.from(Ie.range),hoverMessage:Array.isArray(Ie.hoverMessage)?U.fromMany(Ie.hoverMessage):Ie.hoverMessage?U.from(Ie.hoverMessage):void 0,renderOptions:Ie.renderOptions})):Se.map(Ie=>({range:o.from(Ie)}))}e.fromRangeOrRangeWithMessage=Q;function z(Se){return typeof Se>"u"?Se:typeof Se=="string"?w.URI.file(Se):Se}e.pathOrURIToURI=z;var G;(function(Se){function Ie(he){return typeof he>"u"?he:{contentText:he.contentText,contentIconPath:he.contentIconPath?z(he.contentIconPath):void 0,border:he.border,borderColor:he.borderColor,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,color:he.color,backgroundColor:he.backgroundColor,margin:he.margin,width:he.width,height:he.height}}Se.from=Ie})(G=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var X;(function(Se){function Ie(he){return typeof he>"u"?he:{backgroundColor:he.backgroundColor,outline:he.outline,outlineColor:he.outlineColor,outlineStyle:he.outlineStyle,outlineWidth:he.outlineWidth,border:he.border,borderColor:he.borderColor,borderRadius:he.borderRadius,borderSpacing:he.borderSpacing,borderStyle:he.borderStyle,borderWidth:he.borderWidth,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,cursor:he.cursor,color:he.color,opacity:he.opacity,letterSpacing:he.letterSpacing,gutterIconPath:he.gutterIconPath?z(he.gutterIconPath):void 0,gutterIconSize:he.gutterIconSize,overviewRulerColor:he.overviewRulerColor,before:he.before?G.from(he.before):void 0,after:he.after?G.from(he.after):void 0}}Se.from=Ie})(X=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var ce;(function(Se){function Ie(he){if(typeof he>"u")return he;switch(he){case n.DecorationRangeBehavior.OpenOpen:return 0;case n.DecorationRangeBehavior.ClosedClosed:return 1;case n.DecorationRangeBehavior.OpenClosed:return 2;case n.DecorationRangeBehavior.ClosedOpen:return 3}}Se.from=Ie})(ce=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var L;(function(Se){function Ie(he){return{isWholeLine:he.isWholeLine,rangeBehavior:he.rangeBehavior?ce.from(he.rangeBehavior):void 0,overviewRulerLane:he.overviewRulerLane,light:he.light?X.from(he.light):void 0,dark:he.dark?X.from(he.dark):void 0,backgroundColor:he.backgroundColor,outline:he.outline,outlineColor:he.outlineColor,outlineStyle:he.outlineStyle,outlineWidth:he.outlineWidth,border:he.border,borderColor:he.borderColor,borderRadius:he.borderRadius,borderSpacing:he.borderSpacing,borderStyle:he.borderStyle,borderWidth:he.borderWidth,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,cursor:he.cursor,color:he.color,opacity:he.opacity,letterSpacing:he.letterSpacing,gutterIconPath:he.gutterIconPath?z(he.gutterIconPath):void 0,gutterIconSize:he.gutterIconSize,overviewRulerColor:he.overviewRulerColor,before:he.before?G.from(he.before):void 0,after:he.after?G.from(he.after):void 0}}Se.from=Ie})(L=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var N;(function(Se){function Ie(x){return{text:x.newText,eol:x.newEol&&Xe.from(x.newEol),range:o.from(x.range)}}Se.from=Ie;function he(x){const Pe=new n.TextEdit(o.to(x.range),x.text);return Pe.newEol=typeof x.eol>"u"?void 0:Xe.to(x.eol),Pe}Se.to=he})(N=e.TextEdit||(e.TextEdit={}));var V;(function(Se){function Ie(x,Pe){const Re={edits:[]};if(x instanceof n.WorkspaceEdit){const Ke=new A.ResourceSet;for(const je of x._allEntries())je._type===1&&w.URI.isUri(je.to)&&je.from===void 0&&Ke.add(je.to);for(const je of x._allEntries())je._type===1?Re.edits.push({oldResource:je.from,newResource:je.to,options:{...je.options,contentsBase64:je.options?.contents&&(0,t.encodeBase64)(t.VSBuffer.wrap(je.options.contents))},metadata:je.metadata}):je._type===2?Re.edits.push({resource:je.uri,textEdit:N.from(je.edit),versionId:Ke.has(je.uri)?void 0:Pe?.getTextDocumentVersion(je.uri),metadata:je.metadata}):je._type===6?Re.edits.push({resource:je.uri,textEdit:{range:o.from(je.range),text:je.edit.value,insertAsSnippet:!0},versionId:Ke.has(je.uri)?void 0:Pe?.getTextDocumentVersion(je.uri),metadata:je.metadata}):je._type===3?Re.edits.push({metadata:je.metadata,resource:je.uri,cellEdit:je.edit,notebookMetadata:je.notebookMetadata,notebookVersionId:Pe?.getNotebookDocumentVersion(je.uri)}):je._type===5&&Re.edits.push({metadata:je.metadata,resource:je.uri,notebookVersionId:Pe?.getNotebookDocumentVersion(je.uri),cellEdit:{editType:1,index:je.index,count:je.count,cells:je.cells.map(rt.from)}})}return Re}Se.from=Ie;function he(x){const Pe=new n.WorkspaceEdit;for(const Re of x.edits)Re.textEdit?Pe.replace(w.URI.revive(Re.resource),o.to(Re.textEdit.range),Re.textEdit.text):Pe.renameFile(w.URI.revive(Re.oldResource),w.URI.revive(Re.newResource),Re.options);return Pe}Se.to=he})(V=e.WorkspaceEdit||(e.WorkspaceEdit={}));var ee;(function(Se){const Ie=Object.create(null);Ie[n.SymbolKind.File]=0,Ie[n.SymbolKind.Module]=1,Ie[n.SymbolKind.Namespace]=2,Ie[n.SymbolKind.Package]=3,Ie[n.SymbolKind.Class]=4,Ie[n.SymbolKind.Method]=5,Ie[n.SymbolKind.Property]=6,Ie[n.SymbolKind.Field]=7,Ie[n.SymbolKind.Constructor]=8,Ie[n.SymbolKind.Enum]=9,Ie[n.SymbolKind.Interface]=10,Ie[n.SymbolKind.Function]=11,Ie[n.SymbolKind.Variable]=12,Ie[n.SymbolKind.Constant]=13,Ie[n.SymbolKind.String]=14,Ie[n.SymbolKind.Number]=15,Ie[n.SymbolKind.Boolean]=16,Ie[n.SymbolKind.Array]=17,Ie[n.SymbolKind.Object]=18,Ie[n.SymbolKind.Key]=19,Ie[n.SymbolKind.Null]=20,Ie[n.SymbolKind.EnumMember]=21,Ie[n.SymbolKind.Struct]=22,Ie[n.SymbolKind.Event]=23,Ie[n.SymbolKind.Operator]=24,Ie[n.SymbolKind.TypeParameter]=25;function he(Pe){return typeof Ie[Pe]=="number"?Ie[Pe]:6}Se.from=he;function x(Pe){for(const Re in Ie)if(Ie[Re]===Pe)return Number(Re);return n.SymbolKind.Property}Se.to=x})(ee=e.SymbolKind||(e.SymbolKind={}));var oe;(function(Se){function Ie(x){switch(x){case n.SymbolTag.Deprecated:return 1}}Se.from=Ie;function he(x){switch(x){case 1:return n.SymbolTag.Deprecated}}Se.to=he})(oe=e.SymbolTag||(e.SymbolTag={}));var ge;(function(Se){function Ie(x){return{name:x.name,kind:ee.from(x.kind),tags:x.tags&&x.tags.map(oe.from),containerName:x.containerName,location:Y.from(x.location)}}Se.from=Ie;function he(x){const Pe=new n.SymbolInformation(x.name,ee.to(x.kind),x.containerName,Y.to(x.location));return Pe.tags=x.tags&&x.tags.map(oe.to),Pe}Se.to=he})(ge=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var fe;(function(Se){function Ie(x){const Pe={name:x.name||"!!MISSING: name!!",detail:x.detail,range:o.from(x.range),selectionRange:o.from(x.selectionRange),kind:ee.from(x.kind),tags:x.tags?.map(oe.from)??[]};return x.children&&(Pe.children=x.children.map(Ie)),Pe}Se.from=Ie;function he(x){const Pe=new n.DocumentSymbol(x.name,x.detail,ee.to(x.kind),o.to(x.range),o.to(x.selectionRange));return(0,b.isNonEmptyArray)(x.tags)&&(Pe.tags=x.tags.map(oe.to)),x.children&&(Pe.children=x.children.map(he)),Pe}Se.to=he})(fe=e.DocumentSymbol||(e.DocumentSymbol={}));var R;(function(Se){function Ie(x){const Pe=new n.CallHierarchyItem(ee.to(x.kind),x.name,x.detail||"",w.URI.revive(x.uri),o.to(x.range),o.to(x.selectionRange));return Pe._sessionId=x._sessionId,Pe._itemId=x._itemId,Pe}Se.to=Ie;function he(x,Pe,Re){if(Pe=Pe??x._sessionId,Re=Re??x._itemId,Pe===void 0||Re===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Re,name:x.name,detail:x.detail,kind:ee.from(x.kind),uri:x.uri,range:o.from(x.range),selectionRange:o.from(x.selectionRange),tags:x.tags?.map(oe.from)}}Se.from=he})(R=e.CallHierarchyItem||(e.CallHierarchyItem={}));var M;(function(Se){function Ie(he){return new n.CallHierarchyIncomingCall(R.to(he.from),he.fromRanges.map(x=>o.to(x)))}Se.to=Ie})(M=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var W;(function(Se){function Ie(he){return new n.CallHierarchyOutgoingCall(R.to(he.to),he.fromRanges.map(x=>o.to(x)))}Se.to=Ie})(W=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Y;(function(Se){function Ie(x){return{range:x.range&&o.from(x.range),uri:x.uri}}Se.from=Ie;function he(x){return new n.Location(w.URI.revive(x.uri),o.to(x.range))}Se.to=he})(Y=e.location||(e.location={}));var re;(function(Se){function Ie(x){const Pe=x,Re=x;return{originSelectionRange:Pe.originSelectionRange?o.from(Pe.originSelectionRange):void 0,uri:Pe.targetUri?Pe.targetUri:Re.uri,range:o.from(Pe.targetRange?Pe.targetRange:Re.range),targetSelectionRange:Pe.targetSelectionRange?o.from(Pe.targetSelectionRange):void 0}}Se.from=Ie;function he(x){return{targetUri:w.URI.revive(x.uri),targetRange:o.to(x.range),targetSelectionRange:x.targetSelectionRange?o.to(x.targetSelectionRange):void 0,originSelectionRange:x.originSelectionRange?o.to(x.originSelectionRange):void 0}}Se.to=he})(re=e.DefinitionLink||(e.DefinitionLink={}));var me;(function(Se){function Ie(x){return{range:o.from(x.range),contents:U.fromMany(x.contents)}}Se.from=Ie;function he(x){return new n.Hover(x.contents.map(U.to),o.to(x.range))}Se.to=he})(me=e.Hover||(e.Hover={}));var $;(function(Se){function Ie(x){return{range:o.from(x.range),expression:x.expression}}Se.from=Ie;function he(x){return new n.EvaluatableExpression(o.to(x.range),x.expression)}Se.to=he})($=e.EvaluatableExpression||(e.EvaluatableExpression={}));var J;(function(Se){function Ie(x){if(x instanceof n.InlineValueText)return{type:"text",range:o.from(x.range),text:x.text};if(x instanceof n.InlineValueVariableLookup)return{type:"variable",range:o.from(x.range),variableName:x.variableName,caseSensitiveLookup:x.caseSensitiveLookup};if(x instanceof n.InlineValueEvaluatableExpression)return{type:"expression",range:o.from(x.range),expression:x.expression};throw new Error("Unknown 'InlineValue' type")}Se.from=Ie;function he(x){switch(x.type){case"text":return{range:o.to(x.range),text:x.text};case"variable":return{range:o.to(x.range),variableName:x.variableName,caseSensitiveLookup:x.caseSensitiveLookup};case"expression":return{range:o.to(x.range),expression:x.expression}}}Se.to=he})(J=e.InlineValue||(e.InlineValue={}));var _;(function(Se){function Ie(x){return{frameId:x.frameId,stoppedLocation:o.from(x.stoppedLocation)}}Se.from=Ie;function he(x){return new n.InlineValueContext(x.frameId,o.to(x.stoppedLocation))}Se.to=he})(_=e.InlineValueContext||(e.InlineValueContext={}));var j;(function(Se){function Ie(x){return{range:o.from(x.range),kind:x.kind}}Se.from=Ie;function he(x){return new n.DocumentHighlight(o.to(x.range),x.kind)}Se.to=he})(j=e.DocumentHighlight||(e.DocumentHighlight={}));var H;(function(Se){function Ie(he){switch(he){case 1:return n.CompletionTriggerKind.TriggerCharacter;case 2:return n.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return n.CompletionTriggerKind.Invoke}}Se.to=Ie})(H=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var q;(function(Se){function Ie(he){return{triggerKind:H.to(he.triggerKind),triggerCharacter:he.triggerCharacter}}Se.to=Ie})(q=e.CompletionContext||(e.CompletionContext={}));var Z;(function(Se){function Ie(x){switch(x){case n.CompletionItemTag.Deprecated:return 1}}Se.from=Ie;function he(x){switch(x){case 1:return n.CompletionItemTag.Deprecated}}Se.to=he})(Z=e.CompletionItemTag||(e.CompletionItemTag={}));var ae;(function(Se){const Ie=new Map([[n.CompletionItemKind.Method,0],[n.CompletionItemKind.Function,1],[n.CompletionItemKind.Constructor,2],[n.CompletionItemKind.Field,3],[n.CompletionItemKind.Variable,4],[n.CompletionItemKind.Class,5],[n.CompletionItemKind.Interface,7],[n.CompletionItemKind.Struct,6],[n.CompletionItemKind.Module,8],[n.CompletionItemKind.Property,9],[n.CompletionItemKind.Unit,12],[n.CompletionItemKind.Value,13],[n.CompletionItemKind.Constant,14],[n.CompletionItemKind.Enum,15],[n.CompletionItemKind.EnumMember,16],[n.CompletionItemKind.Keyword,17],[n.CompletionItemKind.Snippet,27],[n.CompletionItemKind.Text,18],[n.CompletionItemKind.Color,19],[n.CompletionItemKind.File,20],[n.CompletionItemKind.Reference,21],[n.CompletionItemKind.Folder,23],[n.CompletionItemKind.Event,10],[n.CompletionItemKind.Operator,11],[n.CompletionItemKind.TypeParameter,24],[n.CompletionItemKind.Issue,26],[n.CompletionItemKind.User,25]]);function he(Re){return Ie.get(Re)??9}Se.from=he;const x=new Map([[0,n.CompletionItemKind.Method],[1,n.CompletionItemKind.Function],[2,n.CompletionItemKind.Constructor],[3,n.CompletionItemKind.Field],[4,n.CompletionItemKind.Variable],[5,n.CompletionItemKind.Class],[7,n.CompletionItemKind.Interface],[6,n.CompletionItemKind.Struct],[8,n.CompletionItemKind.Module],[9,n.CompletionItemKind.Property],[12,n.CompletionItemKind.Unit],[13,n.CompletionItemKind.Value],[14,n.CompletionItemKind.Constant],[15,n.CompletionItemKind.Enum],[16,n.CompletionItemKind.EnumMember],[17,n.CompletionItemKind.Keyword],[27,n.CompletionItemKind.Snippet],[18,n.CompletionItemKind.Text],[19,n.CompletionItemKind.Color],[20,n.CompletionItemKind.File],[21,n.CompletionItemKind.Reference],[23,n.CompletionItemKind.Folder],[10,n.CompletionItemKind.Event],[11,n.CompletionItemKind.Operator],[24,n.CompletionItemKind.TypeParameter],[25,n.CompletionItemKind.User],[26,n.CompletionItemKind.Issue]]);function Pe(Re){return x.get(Re)??n.CompletionItemKind.Property}Se.to=Pe})(ae=e.CompletionItemKind||(e.CompletionItemKind={}));var we;(function(Se){function Ie(he,x){const Pe=new n.CompletionItem(he.label);return Pe.insertText=he.insertText,Pe.kind=ae.to(he.kind),Pe.tags=he.tags?.map(Z.to),Pe.detail=he.detail,Pe.documentation=I.isMarkdownString(he.documentation)?U.to(he.documentation):he.documentation,Pe.sortText=he.sortText,Pe.filterText=he.filterText,Pe.preselect=he.preselect,Pe.commitCharacters=he.commitCharacters,m.Range.isIRange(he.range)?Pe.range=o.to(he.range):typeof he.range=="object"&&(Pe.range={inserting:o.to(he.range.insert),replacing:o.to(he.range.replace)}),Pe.keepWhitespace=typeof he.insertTextRules>"u"?!1:Boolean(he.insertTextRules&1),typeof he.insertTextRules<"u"&&he.insertTextRules&4?Pe.insertText=new n.SnippetString(he.insertText):(Pe.insertText=he.insertText,Pe.textEdit=Pe.range instanceof n.Range?new n.TextEdit(Pe.range,Pe.insertText):void 0),he.additionalTextEdits&&he.additionalTextEdits.length>0&&(Pe.additionalTextEdits=he.additionalTextEdits.map(Re=>N.to(Re))),Pe.command=x&&he.command?x.fromInternal(he.command):void 0,Pe}Se.to=Ie})(we=e.CompletionItem||(e.CompletionItem={}));var ke;(function(Se){function Ie(x){if(typeof x.label!="string"&&!Array.isArray(x.label))throw new TypeError("Invalid label");return{label:x.label,documentation:U.fromStrict(x.documentation)}}Se.from=Ie;function he(x){return{label:x.label,documentation:I.isMarkdownString(x.documentation)?U.to(x.documentation):x.documentation}}Se.to=he})(ke=e.ParameterInformation||(e.ParameterInformation={}));var Ae;(function(Se){function Ie(x){return{label:x.label,documentation:U.fromStrict(x.documentation),parameters:Array.isArray(x.parameters)?x.parameters.map(ke.from):[],activeParameter:x.activeParameter}}Se.from=Ie;function he(x){return{label:x.label,documentation:I.isMarkdownString(x.documentation)?U.to(x.documentation):x.documentation,parameters:Array.isArray(x.parameters)?x.parameters.map(ke.to):[],activeParameter:x.activeParameter}}Se.to=he})(Ae=e.SignatureInformation||(e.SignatureInformation={}));var Me;(function(Se){function Ie(x){return{activeSignature:x.activeSignature,activeParameter:x.activeParameter,signatures:Array.isArray(x.signatures)?x.signatures.map(Ae.from):[]}}Se.from=Ie;function he(x){return{activeSignature:x.activeSignature,activeParameter:x.activeParameter,signatures:Array.isArray(x.signatures)?x.signatures.map(Ae.to):[]}}Se.to=he})(Me=e.SignatureHelp||(e.SignatureHelp={}));var ze;(function(Se){function Ie(he,x){const Pe=new n.InlayHint(l.to(x.position),typeof x.label=="string"?x.label:x.label.map(de.to.bind(void 0,he)),x.kind&&Ee.to(x.kind));return Pe.textEdits=x.textEdits&&x.textEdits.map(N.to),Pe.tooltip=I.isMarkdownString(x.tooltip)?U.to(x.tooltip):x.tooltip,Pe.paddingLeft=x.paddingLeft,Pe.paddingRight=x.paddingRight,Pe}Se.to=Ie})(ze=e.InlayHint||(e.InlayHint={}));var de;(function(Se){function Ie(he,x){const Pe=new n.InlayHintLabelPart(x.label);return Pe.tooltip=I.isMarkdownString(x.tooltip)?U.to(x.tooltip):x.tooltip,g.Command.is(x.command)&&(Pe.command=he.fromInternal(x.command)),x.location&&(Pe.location=Y.to(x.location)),Pe}Se.to=Ie})(de=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var Ee;(function(Se){function Ie(x){return x}Se.from=Ie;function he(x){return x}Se.to=he})(Ee=e.InlayHintKind||(e.InlayHintKind={}));var ye;(function(Se){function Ie(x){return{range:o.from(x.range),url:x.target,tooltip:x.tooltip}}Se.from=Ie;function he(x){let Pe;if(x.url)try{Pe=typeof x.url=="string"?w.URI.parse(x.url,!0):w.URI.revive(x.url)}catch{}return new n.DocumentLink(o.to(x.range),Pe)}Se.to=he})(ye=e.DocumentLink||(e.DocumentLink={}));var Fe;(function(Se){function Ie(x){const Pe=new n.ColorPresentation(x.label);return x.textEdit&&(Pe.textEdit=N.to(x.textEdit)),x.additionalTextEdits&&(Pe.additionalTextEdits=x.additionalTextEdits.map(Re=>N.to(Re))),Pe}Se.to=Ie;function he(x){return{label:x.label,textEdit:x.textEdit?N.from(x.textEdit):void 0,additionalTextEdits:x.additionalTextEdits?x.additionalTextEdits.map(Pe=>N.from(Pe)):void 0}}Se.from=he})(Fe=e.ColorPresentation||(e.ColorPresentation={}));var Be;(function(Se){function Ie(x){return new n.Color(x[0],x[1],x[2],x[3])}Se.to=Ie;function he(x){return[x.red,x.green,x.blue,x.alpha]}Se.from=he})(Be=e.Color||(e.Color={}));var Ye;(function(Se){function Ie(x){return{range:o.from(x.range)}}Se.from=Ie;function he(x){return new n.SelectionRange(o.to(x.range))}Se.to=he})(Ye=e.SelectionRange||(e.SelectionRange={}));var Ve;(function(Se){function Ie(he){switch(he){case 2:return n.TextDocumentSaveReason.AfterDelay;case 1:return n.TextDocumentSaveReason.Manual;case 3:case 4:return n.TextDocumentSaveReason.FocusOut}}Se.to=Ie})(Ve=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Je;(function(Se){function Ie(x){switch(x){case n.TextEditorLineNumbersStyle.Off:return 0;case n.TextEditorLineNumbersStyle.Relative:return 2;case n.TextEditorLineNumbersStyle.On:default:return 1}}Se.from=Ie;function he(x){switch(x){case 0:return n.TextEditorLineNumbersStyle.Off;case 2:return n.TextEditorLineNumbersStyle.Relative;case 1:default:return n.TextEditorLineNumbersStyle.On}}Se.to=he})(Je=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Xe;(function(Se){function Ie(x){if(x===n.EndOfLine.CRLF)return 1;if(x===n.EndOfLine.LF)return 0}Se.from=Ie;function he(x){if(x===1)return n.EndOfLine.CRLF;if(x===0)return n.EndOfLine.LF}Se.to=he})(Xe=e.EndOfLine||(e.EndOfLine={}));var tt;(function(Se){function Ie(he){if(typeof he=="object")return he.viewId;switch(he){case n.ProgressLocation.SourceControl:return 3;case n.ProgressLocation.Window:return 10;case n.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Se.from=Ie})(tt=e.ProgressLocation||(e.ProgressLocation={}));var qe;(function(Se){function Ie(he){const x={start:he.start+1,end:he.end+1};return he.kind&&(x.kind=$e.from(he.kind)),x}Se.from=Ie})(qe=e.FoldingRange||(e.FoldingRange={}));var $e;(function(Se){function Ie(he){if(he)switch(he){case n.FoldingRangeKind.Comment:return g.FoldingRangeKind.Comment;case n.FoldingRangeKind.Imports:return g.FoldingRangeKind.Imports;case n.FoldingRangeKind.Region:return g.FoldingRangeKind.Region}}Se.from=Ie})($e=e.FoldingRangeKind||(e.FoldingRangeKind={}));var xe;(function(Se){function Ie(he){if(he)return{pinned:typeof he.preview=="boolean"?!he.preview:void 0,inactive:he.background,preserveFocus:he.preserveFocus,selection:typeof he.selection=="object"?o.from(he.selection):void 0,override:typeof he.override=="boolean"?v.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Se.from=Ie})(xe=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var le;(function(Se){function Ie(Re){return Re instanceof n.RelativePattern?Re.toJSON():typeof Re=="string"?Re:he(Re)||x(Re)?new n.RelativePattern(Re.baseUri??Re.base,Re.pattern).toJSON():Re}Se.from=Ie;function he(Re){const Ke=Re;return Ke?w.URI.isUri(Ke.baseUri)&&typeof Ke.pattern=="string":!1}function x(Re){const Ke=Re;return Ke?typeof Ke.base=="string"&&typeof Ke.pattern=="string":!1}function Pe(Re){return typeof Re=="string"?Re:new n.RelativePattern(w.URI.revive(Re.baseUri),Re.pattern)}Se.to=Pe})(le=e.GlobPattern||(e.GlobPattern={}));var Ce;(function(Se){function Ie(he){if(he){if(Array.isArray(he))return he.map(Ie);if(typeof he=="string")return he;{const x=he;return{language:x.language,scheme:x.scheme,pattern:le.from(x.pattern),exclusive:x.exclusive,notebookType:x.notebookType}}}else return}Se.from=Ie})(Ce=e.LanguageSelector||(e.LanguageSelector={}));var De;(function(Se){function Ie(x){return{start:x.start,end:x.end}}Se.from=Ie;function he(x){return new n.NotebookRange(x.start,x.end)}Se.to=he})(De=e.NotebookRange||(e.NotebookRange={}));var Te;(function(Se){function Ie(x){return{timing:typeof x.runStartTime=="number"&&typeof x.runEndTime=="number"?{startTime:x.runStartTime,endTime:x.runEndTime}:void 0,executionOrder:x.executionOrder,success:x.lastRunSuccess}}Se.to=Ie;function he(x){return{lastRunSuccess:x.success,runStartTime:x.timing?.startTime,runEndTime:x.timing?.endTime,executionOrder:x.executionOrder}}Se.from=he})(Te=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Ne;(function(Se){function Ie(he){if(he===c.NotebookCellExecutionState.Unconfirmed)return n.NotebookCellExecutionState.Pending;if(he===c.NotebookCellExecutionState.Pending)return;if(he===c.NotebookCellExecutionState.Executing)return n.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${he}`)}Se.to=Ie})(Ne=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var We;(function(Se){function Ie(x){switch(x){case n.NotebookCellKind.Markup:return c.CellKind.Markup;case n.NotebookCellKind.Code:default:return c.CellKind.Code}}Se.from=Ie;function he(x){switch(x){case c.CellKind.Markup:return n.NotebookCellKind.Markup;case c.CellKind.Code:default:return n.NotebookCellKind.Code}}Se.to=he})(We=e.NotebookCellKind||(e.NotebookCellKind={}));var Ge;(function(Se){function Ie(x){const Pe={metadata:x.metadata??Object.create(null),cells:[]};for(const Re of x.cells)n.NotebookCellData.validate(Re),Pe.cells.push(rt.from(Re));return Pe}Se.from=Ie;function he(x){const Pe=new n.NotebookData(x.cells.map(rt.to));return(0,C.isEmptyObject)(x.metadata)||(Pe.metadata=x.metadata),Pe}Se.to=he})(Ge=e.NotebookData||(e.NotebookData={}));var rt;(function(Se){function Ie(x){return{cellKind:We.from(x.kind),language:x.languageId,mime:x.mime,source:x.value,metadata:x.metadata,internalMetadata:Te.from(x.executionSummary??{}),outputs:x.outputs?x.outputs.map(Qe.from):[]}}Se.from=Ie;function he(x){return new n.NotebookCellData(We.to(x.cellKind),x.source,x.language,x.mime,x.outputs?x.outputs.map(Qe.to):void 0,x.metadata,x.internalMetadata?Te.to(x.internalMetadata):void 0)}Se.to=he})(rt=e.NotebookCellData||(e.NotebookCellData={}));var it;(function(Se){function Ie(x){return{mime:x.mime,valueBytes:t.VSBuffer.wrap(x.data)}}Se.from=Ie;function he(x){return new n.NotebookCellOutputItem(x.valueBytes.buffer,x.mime)}Se.to=he})(it=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Qe;(function(Se){function Ie(x){return{outputId:x.id,items:x.items.map(it.from),metadata:x.metadata}}Se.from=Ie;function he(x){const Pe=x.items.map(it.to);return new n.NotebookCellOutput(Pe,x.outputId,x.metadata)}Se.to=he})(Qe=e.NotebookCellOutput||(e.NotebookCellOutput={}));var ot;(function(Se){function Ie(Pe){return x(Pe)?{include:(0,C.withNullAsUndefined)(le.from(Pe.include)),exclude:(0,C.withNullAsUndefined)(le.from(Pe.exclude))}:(0,C.withNullAsUndefined)(le.from(Pe))}Se.from=Ie;function he(Pe){return x(Pe)?{include:le.to(Pe.include),exclude:le.to(Pe.exclude)}:le.to(Pe)}Se.to=he;function x(Pe){const Re=Pe;return Re?!(0,C.isUndefinedOrNull)(Re.include)&&!(0,C.isUndefinedOrNull)(Re.exclude):!1}})(ot=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var lt;(function(Se){function Ie(he,x,Pe){const Re=typeof he.command=="string"?{title:"",command:he.command}:he.command;return{alignment:he.alignment===n.NotebookCellStatusBarAlignment.Left?1:2,command:x.toInternal(Re,Pe),text:he.text,tooltip:he.tooltip,accessibilityInformation:he.accessibilityInformation,priority:he.priority}}Se.from=Ie})(lt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ft;(function(Se){function Ie(he,x,Pe){const Re=typeof he.command=="string"?{title:"",command:he.command}:he.command;return{command:x.toInternal(Re,Pe),label:he.label,description:he.description,detail:he.detail}}Se.from=Ie})(ft=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var vt;(function(Se){function Ie(he){return{transientOutputs:he?.transientOutputs??!1,transientCellMetadata:he?.transientCellMetadata??{},transientDocumentMetadata:he?.transientDocumentMetadata??{},cellContentMetadata:he?.cellContentMetadata??{}}}Se.from=Ie})(vt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var kt;(function(Se){function Ie(x){return{uri:x.uri,provides:x.provides}}Se.from=Ie;function he(x){return new n.NotebookRendererScript(w.URI.revive(x.uri),x.provides)}Se.to=he})(kt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var At;(function(Se){function Ie(x){return{message:U.fromStrict(x.message)||"",type:0,expected:x.expectedOutput,actual:x.actualOutput,location:x.location&&{range:o.from(x.location.range),uri:x.location.uri}}}Se.from=Ie;function he(x){const Pe=new n.TestMessage(typeof x.message=="string"?x.message:U.to(x.message));return Pe.actualOutput=x.actual,Pe.expectedOutput=x.expected,Pe.location=x.location?Y.to(x.location):void 0,Pe}Se.to=he})(At=e.TestMessage||(e.TestMessage={}));var Et;(function(Se){Se.namespace=f.namespaceTestTag,Se.denamespace=f.denamespaceTestTag})(Et=e.TestTag||(e.TestTag={}));var Ot;(function(Se){function Ie(x){const Pe=(0,d.getPrivateApiFor)(x).controllerId;return{extId:h.TestId.fromExtHostTestItem(x,Pe).toString(),label:x.label,uri:w.URI.revive(x.uri),busy:x.busy,tags:x.tags.map(Re=>Et.namespace(Pe,Re.id)),range:m.Range.lift(o.from(x.range)),description:x.description||null,sortText:x.sortText||null,error:x.error&&U.fromStrict(x.error)||null}}Se.from=Ie;function he(x){return{parent:void 0,error:void 0,id:h.TestId.fromString(x.extId).localId,label:x.label,uri:w.URI.revive(x.uri),tags:(x.tags||[]).map(Pe=>{const{tagId:Re}=Et.denamespace(Pe);return new n.TestTag(Re)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:o.to(x.range||void 0),canResolveChildren:!1,busy:x.busy,description:x.description||void 0,sortText:x.sortText||void 0}}Se.toPlain=he})(Ot=e.TestItem||(e.TestItem={})),function(Se){function Ie(x){return{id:x.id}}Se.from=Ie;function he(x){return new n.TestTag(x.id)}Se.to=he}(Et=e.TestTag||(e.TestTag={}));var mt;(function(Se){const Ie=(x,Pe)=>{const Re=[];for(const[je,et]of Pe)h.TestId.compare(et.item.extId,je)===2&&(Pe.delete(je),Re.push(et));const Ke={...Ot.toPlain(x.item),parent:void 0,taskStates:x.tasks.map(je=>({state:je.state,duration:je.duration,messages:je.messages.filter(et=>et.type===0).map(At.to)})),children:Re.map(je=>Ie(je,Pe))};for(const je of Ke.children)je.parent=Ke;return Ke};function he(x){const Pe=[],Re=new Map;for(const Ke of x.items){Re.set(Ke.item.extId,Ke);const je=h.TestId.root(Ke.item.extId);x.request.targets.some(et=>et.controllerId===je&&et.testIds.includes(Ke.item.extId))&&Pe.push(Ke)}return{completedAt:x.completedAt,results:Pe.map(Ke=>Ie(Ke,Re))}}Se.to=he})(mt=e.TestResults||(e.TestResults={}));var St;(function(Se){function Ie(Re){return{covered:Re.covered,total:Re.covered}}function he(Re){return"line"in Re?l.from(Re):o.from(Re)}function x(Re){return"branches"in Re?{count:Re.executionCount,location:he(Re.location),type:1,branches:Re.branches.length?Re.branches.map(Ke=>({count:Ke.executionCount,location:Ke.location&&he(Ke.location)})):void 0}:{type:0,count:Re.executionCount,location:he(Re.location)}}Se.fromDetailed=x;function Pe(Re){return{uri:Re.uri,statement:Ie(Re.statementCoverage),branch:Re.branchCoverage&&Ie(Re.branchCoverage),function:Re.functionCoverage&&Ie(Re.functionCoverage),details:Re.detailedCoverage?.map(x)}}Se.fromFile=Pe})(St=e.TestCoverage||(e.TestCoverage={}));var st;(function(Se){function Ie(he){switch(he){case 1:return n.CodeActionTriggerKind.Invoke;case 2:return n.CodeActionTriggerKind.Automatic}}Se.to=Ie})(st=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var ut;(function(Se){function Ie(x){const Pe=new n.TypeHierarchyItem(ee.to(x.kind),x.name,x.detail||"",w.URI.revive(x.uri),o.to(x.range),o.to(x.selectionRange));return Pe._sessionId=x._sessionId,Pe._itemId=x._itemId,Pe}Se.to=Ie;function he(x,Pe,Re){if(Pe=Pe??x._sessionId,Re=Re??x._itemId,Pe===void 0||Re===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Re,kind:ee.from(x.kind),name:x.name,detail:x.detail??"",uri:x.uri,range:o.from(x.range),selectionRange:o.from(x.selectionRange),tags:x.tags?.map(oe.from)}}Se.from=he})(ut=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var gt;(function(Se){function Ie(he){if(!!he)return{value:he.value,tooltip:he.tooltip}}Se.from=Ie})(gt=e.ViewBadge||(e.ViewBadge={}));var Rt;(function(Se){function Ie(Re,Ke,je){const et=Ke.fileData;return et?new class extends n.DataTransferItem{asFile(){return{name:et.name,uri:w.URI.revive(et.uri),data:(0,S.once)(()=>je())}}}("",Ke.id):Re===D.Mimes.uriList&&Ke.uriListData?new n.DataTransferItem(Pe(Ke.uriListData)):new n.DataTransferItem(Ke.asString)}Se.to=Ie;async function he(Re,Ke){const je=await Ke.asString();if(Re===D.Mimes.uriList)return{id:Ke.id,asString:"",fileData:void 0,uriListData:x(je)};const et=Ke.asFile();return{id:Ke.id,asString:je,fileData:et?{name:et.name,uri:et.uri}:void 0}}Se.from=he;function x(Re){return k.UriList.split(Re).map(Ke=>{if(Ke.startsWith("#"))return Ke;try{return w.URI.parse(Ke)}catch{}return Ke})}function Pe(Re){return k.UriList.create(Re.map(Ke=>typeof Ke=="string"?Ke:w.URI.revive(Ke)))}})(Rt=e.DataTransferItem||(e.DataTransferItem={}));var Mt;(function(Se){function Ie(x,Pe){const Re=x.items.map(([Ke,je])=>[Ke,Rt.to(Ke,je,()=>Pe(je.id))]);return new n.DataTransfer(Re)}Se.toDataTransfer=Ie;async function he(x){const Pe={items:[]},Re=[];return x.forEach((Ke,je)=>{Re.push((async()=>{Pe.items.push([je,await Rt.from(je,Ke)])})())}),await Promise.all(Re),Pe}Se.toDataTransferDTO=he})(Mt=e.DataTransfer||(e.DataTransfer={}))}),define(ve[258],be([1,0,46,124,67,123,83,129,4]),function(ie,e,b,t,k,S,I,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const y=(c,h,f,i)=>{let n=h;return{enumerable:!0,configurable:!1,get(){return n},set(r){if(!f(n,r)){const o=n;n=r,c.listener?.(i(r,o))}}}},D=(c,h)=>c===h,T={range:(c,h)=>c===h?!0:!c||!h?!1:c.isEqual(h),label:D,description:D,sortText:D,busy:D,error:D,canResolveChildren:D,tags:(c,h)=>!(c.length!==h.length||c.some(f=>!h.find(i=>f.id===i.id)))},C=c=>h=>({op:4,update:c(h)}),w=(c,h)=>({range:(()=>{let f;const i=C(n=>({range:b.Range.lift(A.Range.from(n))}));return{enumerable:!0,configurable:!1,get(){return f},set(n){c.listener?.({op:6}),T.range(f,n)||(f=n,c.listener?.(i(n)))}}})(),label:y(c,h,T.label,C(f=>({label:f}))),description:y(c,void 0,T.description,C(f=>({description:f}))),sortText:y(c,void 0,T.sortText,C(f=>({sortText:f}))),canResolveChildren:y(c,!1,T.canResolveChildren,f=>({op:2,state:f})),busy:y(c,!1,T.busy,C(f=>({busy:f}))),error:y(c,void 0,T.error,C(f=>({error:A.MarkdownString.fromStrict(f)||null}))),tags:y(c,[],T.tags,(f,i)=>({op:1,new:f.map(A.TestTag.from),old:i.map(A.TestTag.from)}))}),m=c=>{const h=k.TestId.fromString(c.extId),f=new p(h.controllerId,h.localId,c.label,E.URI.revive(c.uri)||void 0);return f.range=A.Range.to(c.range||void 0),f.description=c.description||void 0,f.sortText=c.sortText||void 0,f.tags=c.tags.map(i=>A.TestTag.to({id:(0,I.denamespaceTestTag)(i).tagId})),f},g=c=>{let h;for(const f of c.tests){const i=m(f.item);(0,t.getPrivateApiFor)(i).parent=h,h=i}return h};e.toItemFromContext=g;class p{constructor(h,f,i,n){if(f.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(f)} symbol`);const r=(0,t.createPrivateApiFor)(this,h);Object.defineProperties(this,{id:{value:f,enumerable:!0,writable:!1},uri:{value:n,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof d?void 0:r.parent}},children:{value:(0,S.createTestItemChildren)(r,t.getPrivateApiFor,p),enumerable:!0,writable:!1},...w(r,i)})}}e.TestItemImpl=p;class d extends p{constructor(h,f){super(h,h,f,void 0),this._isRoot=!0}}e.TestItemRootImpl=d;class v extends S.TestItemCollection{constructor(h,f,i){super({controllerId:h,getDocumentVersion:n=>n&&i.getDocument(n)?.version,getApiFor:t.getPrivateApiFor,getChildren:n=>n.children,root:new d(h,f),toITestItem:A.TestItem.from})}}e.ExtHostTestItemCollection=v}),define(ve[259],be([1,0,32,188,49]),function(ie,e,b,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.dedupExtensions=void 0;function S(I,A,E,y){const D=new Map;I.forEach(C=>{const w=b.ExtensionIdentifier.toKey(C.identifier),m=D.get(w);m&&y.warn((0,t.localize)(0,null,m.extensionLocation.fsPath,C.extensionLocation.fsPath)),D.set(w,C)}),A.forEach(C=>{const w=b.ExtensionIdentifier.toKey(C.identifier),m=D.get(w);if(m)if(m.isBuiltin){if(k.gte(m.version,C.version)){y.warn(`Skipping extension ${C.extensionLocation.path} in favour of the builtin extension ${m.extensionLocation.path}.`);return}C.isBuiltin=!0}else y.warn((0,t.localize)(1,null,m.extensionLocation.fsPath,C.extensionLocation.fsPath));else if(C.isBuiltin){y.warn(`Skipping obsolete builtin extension ${C.extensionLocation.path}`);return}D.set(w,C)}),E.forEach(C=>{y.info((0,t.localize)(2,null,C.extensionLocation.fsPath));const w=b.ExtensionIdentifier.toKey(C.identifier),m=D.get(w);m&&m.isBuiltin&&(C.isBuiltin=!0),D.set(w,C)});const T=[];return D.forEach(C=>T.push(C)),T}e.dedupExtensions=S}),define(ve[260],be([1,0,3,45,4,66,13,72,100,96,226,7,27,54,259]),function(ie,e,b,t,k,S,I,A,E,y,D,T,C,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentEnvironmentChannel=void 0;class g{constructor(d,v,c,h,f,i,n){if(this.c=d,this.d=v,this.f=c,this.g=f,this.h=i,this.i=n,v.args["install-builtin-extension"]){const o={isMachineScoped:!!v.args["do-not-sync"],installPreReleaseVersion:!!v.args["pre-release"]};this.b=h.installExtensions([],v.args["install-builtin-extension"],o,!!v.args.force).then(null,a=>{f.error(a)})}else this.b=Promise.resolve();const r=v.args["install-extension"];if(r){const o=r.map(a=>/\.vsix$/i.test(a)?k.URI.file((0,T.isAbsolute)(a)?a:(0,T.join)((0,C.cwd)(),a)):a);this.b.then(()=>h.installExtensions(o,[],{isMachineScoped:!!v.args["do-not-sync"],installPreReleaseVersion:!!v.args["pre-release"]},!!v.args.force)).then(null,a=>{f.error(a)})}}async call(d,v,c){switch(v){case"getEnvironmentData":{const h=c,f=(0,S.createURITransformer)(h.remoteAuthority);let i=await this.k();return i=(0,A.transformOutgoingURIs)(i,f),i}case"getExtensionHostExitInfo":{const h=c;return this.h.getExitInfo(h.reconnectionToken)}case"whenExtensionsReady":{await this.b;return}case"scanExtensions":{await this.b;const h=c,f=h.language;this.g.trace(`Scanning extensions using UI language: ${f}`);const i=(0,S.createURITransformer)(h.remoteAuthority),n=h.extensionDevelopmentPath&&h.extensionDevelopmentPath.map(a=>k.URI.revive(i.transformIncoming(a))),r=n?n.filter(a=>a.scheme===I.Schemas.file).map(a=>a.fsPath):void 0;let o=await this.l(f,r);return o=(0,A.transformOutgoingURIs)(o,i),this.g.trace("Scanned Extensions",o),g.j(o),o}case"scanSingleExtension":{await this.b;const h=c,f=h.language,i=h.isBuiltin,n=(0,S.createURITransformer)(h.remoteAuthority),r=k.URI.revive(n.transformIncoming(h.extensionLocation)),o=r.scheme===I.Schemas.file?r.fsPath:null;if(!o)return null;let a=await this.p(o,i,f);return a?(a=(0,A.transformOutgoingURIs)(a,n),g.j([a]),a):null}case"getDiagnosticInfo":{const h=c,f={machineInfo:(0,D.getMachineInfo)()},i=h.includeProcesses?(0,y.listProcesses)(process.pid):Promise.resolve();let n=[];const r={};if(h.folders){const o=(0,S.createURITransformer)("");n=h.folders.map(l=>k.URI.revive(o.transformIncoming(l))).filter(l=>l.scheme==="file").map(l=>(0,D.collectWorkspaceStats)(l.fsPath,["node_modules",".git"]).then(s=>{r[(0,T.basename)(l.fsPath)]=s}))}return Promise.all([i,...n]).then(([o,a])=>(f.processes=o||void 0,f.workspaceMetadata=h.folders?r:void 0,f))}}throw new Error(`IPC Command ${v} not found`)}listen(d,v,c){throw new Error("Not supported")}static j(d){const v=(r,o)=>r.replace(/file/g,"vscode-remote"),c=r=>{let o="";return o+=r.global?"g":"",o+=r.ignoreCase?"i":"",o+=r.multiline?"m":"",new RegExp(v(r.source,!0),o)},h=new class{mapDefined(r){return E.ContextKeyDefinedExpr.create(r)}mapNot(r){return E.ContextKeyNotExpr.create(r)}mapEquals(r,o){return r==="resourceScheme"&&typeof o=="string"?E.ContextKeyEqualsExpr.create(r,v(o,!1)):E.ContextKeyEqualsExpr.create(r,o)}mapNotEquals(r,o){return r==="resourceScheme"&&typeof o=="string"?E.ContextKeyNotEqualsExpr.create(r,v(o,!1)):E.ContextKeyNotEqualsExpr.create(r,o)}mapGreater(r,o){return E.ContextKeyGreaterExpr.create(r,o)}mapGreaterEquals(r,o){return E.ContextKeyGreaterEqualsExpr.create(r,o)}mapSmaller(r,o){return E.ContextKeySmallerExpr.create(r,o)}mapSmallerEquals(r,o){return E.ContextKeySmallerEqualsExpr.create(r,o)}mapRegex(r,o){return r==="resourceScheme"&&o?E.ContextKeyRegexExpr.create(r,c(o)):E.ContextKeyRegexExpr.create(r,o)}mapIn(r,o){return E.ContextKeyInExpr.create(r,o)}mapNotIn(r,o){return E.ContextKeyNotInExpr.create(r,o)}},f=r=>{if(!r||!r.when||!/resourceScheme/.test(r.when))return;const o=E.ContextKeyExpr.deserialize(r.when);if(!o)return;const a=o.map(h);r.when=a.serialize()},i=r=>{if(Array.isArray(r))for(const o of r)f(o);else f(r)},n=r=>{for(const o in r)i(r[o])};d.forEach(r=>{r.contributes&&(r.contributes.menus&&n(r.contributes.menus),r.contributes.keybindings&&i(r.contributes.keybindings),r.contributes.views&&n(r.contributes.views))})}async k(){return{pid:process.pid,connectionToken:this.c.type!==0?this.c.value:"",appRoot:k.URI.file(this.d.appRoot),settingsPath:this.d.machineSettingsResource,logsPath:k.URI.file(this.d.logsPath),extensionsPath:k.URI.file(this.d.extensionsPath),extensionHostLogsPath:k.URI.file((0,T.join)(this.d.logsPath,`exthost${g.a++}`)),globalStorageHome:this.f.defaultProfile.globalStorageHome,workspaceStorageHome:this.d.workspaceStorageHome,localHistoryHome:this.d.localHistoryHome,userHome:this.d.userHome,os:b.OS,arch:process.arch,marks:t.getMarks(),useHostProxy:!!this.d.args["use-host-proxy"]}}async l(d,v){const[c,h,f]=await Promise.all([this.n(d),this.o(d),this.m(d,v)]);return(0,m.dedupExtensions)(c,h,f,this.g)}async m(d,v){return v?(await Promise.all(v.map(c=>this.i.scanOneOrMultipleExtensions(k.URI.file((0,T.resolve)(c)),1,{language:d})))).flat().map(c=>(0,w.toExtensionDescription)(c,!0)):[]}async n(d){return(await this.i.scanSystemExtensions({language:d,useCache:!0})).map(c=>(0,w.toExtensionDescription)(c,!1))}async o(d){return await this.i.initializeDefaultProfileExtensions(),(await this.i.scanUserExtensions({language:d,useCache:!0})).map(c=>(0,w.toExtensionDescription)(c,!1))}async p(d,v,c){const h=k.URI.file((0,T.resolve)(d)),f=v?0:1,i=await this.i.scanExistingExtension(h,f,{language:c});return i?(0,w.toExtensionDescription)(i,!1):null}}e.RemoteAgentEnvironmentChannel=g,g.a=1}),define(ve[130],be([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class b{constructor(E){this._proxyIdentifierBrand=void 0,this.sid=E,this.nid=++b.count}}e.ProxyIdentifier=b,b.count=0;const t=[];function k(A){const E=new b(A);return t[E.nid]=E,E}e.createProxyIdentifier=k;function S(A){return t[A].sid}e.getStringIdentifierForProxy=S;class I{constructor(E){this.value=E}}e.SerializableObjectWithBuffers=I}),define(ve[261],be([1,0,130]),function(ie,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var t;(function(g){g[g.Default=0]="Default",g[g.InCenter=1]="InCenter",g[g.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",g[g.AtTop=3]="AtTop"})(t=e.TextEditorRevealType||(e.TextEditorRevealType={}));var k;(function(g){g[g.UnknownInput=0]="UnknownInput",g[g.TextInput=1]="TextInput",g[g.TextDiffInput=2]="TextDiffInput",g[g.TextMergeInput=3]="TextMergeInput",g[g.NotebookInput=4]="NotebookInput",g[g.NotebookDiffInput=5]="NotebookDiffInput",g[g.CustomEditorInput=6]="CustomEditorInput",g[g.WebviewEditorInput=7]="WebviewEditorInput",g[g.TerminalEditorInput=8]="TerminalEditorInput",g[g.InteractiveEditorInput=9]="InteractiveEditorInput"})(k=e.TabInputKind||(e.TabInputKind={}));var S;(function(g){g[g.TAB_OPEN=0]="TAB_OPEN",g[g.TAB_CLOSE=1]="TAB_CLOSE",g[g.TAB_UPDATE=2]="TAB_UPDATE",g[g.TAB_MOVE=3]="TAB_MOVE"})(S=e.TabModelOperationKind||(e.TabModelOperationKind={}));var I;(function(g){g[g.Editable=0]="Editable",g[g.SupportsHotExit=1]="SupportsHotExit"})(I=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var A;(function(g){g[g.Int8Array=1]="Int8Array",g[g.Uint8Array=2]="Uint8Array",g[g.Uint8ClampedArray=3]="Uint8ClampedArray",g[g.Int16Array=4]="Int16Array",g[g.Uint16Array=5]="Uint16Array",g[g.Int32Array=6]="Int32Array",g[g.Uint32Array=7]="Uint32Array",g[g.Float32Array=8]="Float32Array",g[g.Float64Array=9]="Float64Array",g[g.BigInt64Array=10]="BigInt64Array",g[g.BigUint64Array=11]="BigUint64Array"})(A=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var E;(function(g){g[g.Text=1]="Text",g[g.Error=2]="Error",g[g.Rich=3]="Rich"})(E=e.CellOutputKind||(e.CellOutputKind={}));var y;(function(g){g[g.Default=0]="Default",g[g.InCenter=1]="InCenter",g[g.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",g[g.AtTop=3]="AtTop"})(y=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var D;(function(g){g[g.None=0]="None",g[g.Process=1]="Process",g[g.Output=2]="Output"})(D=e.CandidatePortSource||(e.CandidatePortSource={}));class T{static mixin(p){return p._id=T.a++,p}}e.IdObject=T,T.a=0;var C;(function(g){g.label="a",g.kind="b",g.detail="c",g.documentation="d",g.sortText="e",g.filterText="f",g.preselect="g",g.insertText="h",g.insertTextRules="i",g.range="j",g.commitCharacters="k",g.additionalTextEdits="l",g.kindModifier="m",g.commandIdent="n",g.commandId="o",g.commandArguments="p"})(C=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var w;(function(g){g.defaultRanges="a",g.completions="b",g.isIncomplete="c",g.duration="d"})(w=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var m;(function(g){g[g.Workspace=0]="Workspace",g[g.TextDocument=1]="TextDocument"})(m=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,b.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,b.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,b.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,b.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,b.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,b.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,b.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,b.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,b.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,b.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,b.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,b.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,b.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,b.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,b.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,b.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,b.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,b.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,b.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,b.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,b.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,b.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,b.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,b.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,b.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,b.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,b.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,b.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,b.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,b.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,b.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,b.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,b.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,b.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,b.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,b.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,b.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,b.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,b.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,b.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,b.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,b.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,b.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,b.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,b.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,b.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,b.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,b.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,b.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,b.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,b.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,b.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,b.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,b.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,b.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,b.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,b.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,b.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,b.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,b.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,b.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,b.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,b.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,b.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,b.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,b.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,b.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,b.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,b.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,b.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,b.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,b.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,b.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,b.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,b.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,b.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,b.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,b.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,b.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,b.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,b.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,b.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,b.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,b.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,b.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,b.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,b.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,b.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,b.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,b.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,b.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,b.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,b.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,b.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,b.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,b.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,b.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,b.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,b.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,b.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,b.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,b.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,b.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,b.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,b.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,b.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,b.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,b.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,b.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,b.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,b.createProxyIdentifier)("ExtHostLocalization")}});var Lt=this&&this.__classPrivateFieldSet||function(ie,e,b,t,k){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!k:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?k.call(ie,b):k?k.value=b:e.set(ie,b),b},nt=this&&this.__classPrivateFieldGet||function(ie,e,b,t){if(b==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!t:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?t:b==="a"?t.call(ie):t?t.value:e.get(ie)};define(ve[262],be([1,0,11,128,129,23,261,18,12,47,46,90,4,2,5,248,258,16,130,39]),function(ie,e,b,t,k,S,I,A,E,y,D,T,C,w,m,g,p,d,v,c){"use strict";var h,f;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let i=class{constructor(s,u){h.set(this,void 0),this.b=new Map,this.c=new Map,f.set(this,void 0),Lt(this,h,s.getProxy(I.MainContext.MainThreadCommands),"f"),this.d=u,Lt(this,f,s.getProxy(I.MainContext.MainThreadTelemetry),"f"),this.converter=new n(this,P=>{const F=this.c.get(P);return F?.result===o.Void?F:void 0},u),this.f=[{processArgument(P){return(0,y.revive)(P)}},{processArgument(P){return(0,S.cloneAndChange)(P,function(F){if(D.Range.isIRange(F))return k.Range.to(F);if(T.Position.isIPosition(F))return k.Position.to(F);if(D.Range.isIRange(F.range)&&C.URI.isUri(F.uri))return k.location.to(F);if(F instanceof d.VSBuffer)return F.buffer.buffer;if(!Array.isArray(F))return F})}}]}registerArgumentProcessor(s){this.f.push(s)}registerApiCommand(s){const u=this.registerCommand(!1,s.id,async(...P)=>{const F=s.args.map((ne,ue)=>{if(!ne.validate(P[ue]))throw new Error(`Invalid argument '${ne.name}' when running '${s.id}', received: ${P[ue]}`);return ne.convert(P[ue])}),K=await this.executeCommand(s.internalId,...F);return s.result.convert(K,P,this.converter)},void 0,{description:s.description,args:s.args,returns:s.result.description});return this.c.set(s.id,s),new t.Disposable(()=>{u.dispose(),this.c.delete(s.id)})}registerCommand(s,u,P,F,K,ne){if(this.d.trace("ExtHostCommands#registerCommand",u),!u.trim().length)throw new Error("invalid id");if(this.b.has(u))throw new Error(`command '${u}' already exists`);return this.b.set(u,{callback:P,thisArg:F,description:K,extension:ne}),s&&nt(this,h,"f").$registerCommand(u),new t.Disposable(()=>{this.b.delete(u)&&s&&nt(this,h,"f").$unregisterCommand(u)})}executeCommand(s,...u){return this.d.trace("ExtHostCommands#executeCommand",s),this.g(s,u,!0)}async g(s,u,P){if(this.b.has(s))return nt(this,h,"f").$fireCommandActivationEvent(s),this.h(s,u,!1);{let F=!1;const K=(0,S.cloneAndChange)(u,function(ne){if(ne instanceof t.Position)return k.Position.from(ne);if(ne instanceof t.Range)return k.Range.from(ne);if(ne instanceof t.Location)return k.location.from(ne);if(t.NotebookRange.isNotebookRange(ne))return k.NotebookRange.from(ne);if(ne instanceof ArrayBuffer)return F=!0,d.VSBuffer.wrap(new Uint8Array(ne));if(ne instanceof Uint8Array)return F=!0,d.VSBuffer.wrap(ne);if(ne instanceof d.VSBuffer)return F=!0,ne;if(!Array.isArray(ne))return ne});try{const ne=await nt(this,h,"f").$executeCommand(s,F?new v.SerializableObjectWithBuffers(K):K,P);return(0,y.revive)(ne)}catch(ne){if(ne instanceof Error&&ne.message==="$executeCommand:retry")return this.g(s,u,!1);throw ne}}}async h(s,u,P){const F=this.b.get(s);if(!F)throw new Error("Unknown command");const{callback:K,thisArg:ne,description:ue}=F;if(ue)for(let U=0;U<ue.args.length;U++)try{(0,b.validateConstraint)(u[U],ue.args[U].constraint)}catch{throw new Error(`Running the contributed command: '${s}' failed. Illegal argument '${ue.args[U].name}' - ${ue.args[U].description}`)}const se=Date.now();try{return await K.apply(ne,u)}catch(U){if(s===this.converter.delegatingCommandId){const Q=this.converter.getActualCommand(...u);Q&&(s=Q.command)}throw this.d.error(U,s,F.extension?.identifier),P?new class extends Error{constructor(){super((0,c.toErrorMessage)(U)),this.id=s,this.source=F.extension?.displayName??F.extension?.name}}:U}finally{this.j(F,s,Date.now()-se)}}j(s,u,P){!s.extension||s.extension.isBuiltin||nt(this,f,"f").$publicLog2("Extension:ActionExecuted",{extensionId:s.extension.identifier.value,id:u,duration:P})}$executeContributedCommand(s,...u){return this.d.trace("ExtHostCommands#$executeContributedCommand",s),this.b.has(s)?(u=u.map(P=>this.f.reduce((F,K)=>K.processArgument(F),P)),this.h(s,u,!0)):Promise.reject(new Error(`Contributed command '${s}' does not exist.`))}getCommands(s=!1){return this.d.trace("ExtHostCommands#getCommands",s),nt(this,h,"f").$getCommands().then(u=>(s&&(u=u.filter(P=>P[0]!=="_")),u))}$getContributedCommandHandlerDescriptions(){const s=Object.create(null);for(const[u,P]of this.b){const{description:F}=P;F&&(s[u]=F)}return Promise.resolve(s)}};h=new WeakMap,f=new WeakMap,i=Le([Oe(0,g.IExtHostRpcService),Oe(1,E.ILogService)],i),e.ExtHostCommands=i,e.IExtHostCommands=(0,m.createDecorator)("IExtHostCommands");class n{constructor(s,u,P){this.d=s,this.f=u,this.g=P,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(s,u){if(!s)return;const P={$ident:void 0,id:s.command,title:s.title,tooltip:s.tooltip};if(!s.command)return P;const F=this.f(s.command);if(F)P.id=F.internalId,P.arguments=F.args.map((K,ne)=>K.convert(s.arguments&&s.arguments[ne]));else if((0,A.isNonEmptyArray)(s.arguments)){const K=`${s.command}/${++this.c}`;this.b.set(K,s),u.add((0,w.toDisposable)(()=>{this.b.delete(K),this.g.trace("CommandsConverter#DISPOSE",K)})),P.$ident=K,P.id=this.delegatingCommandId,P.arguments=[K],this.g.trace("CommandsConverter#CREATE",s.command,K)}return P}fromInternal(s){return typeof s.$ident=="string"?this.b.get(s.$ident):{command:s.id,title:s.title,arguments:s.arguments}}getActualCommand(...s){return this.b.get(s[0])}h(...s){const u=this.getActualCommand(...s);return this.g.trace("CommandsConverter#EXECUTE",s[0],u?u.command:"MISSING"),u?this.d.executeCommand(u.command,...u.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${s[0]}`)}}e.CommandsConverter=n;class r{constructor(s,u,P,F){this.name=s,this.description=u,this.validate=P,this.convert=F}optional(){return new r(this.name,`(optional) ${this.description}`,s=>s==null||this.validate(s),s=>s===void 0?void 0:s===null?null:this.convert(s))}with(s,u){return new r(s??this.name,u??this.description,this.validate,this.convert)}}e.ApiCommandArgument=r,r.Uri=new r("uri","Uri of a text document",l=>C.URI.isUri(l),l=>l),r.Position=new r("position","A position in a text document",l=>t.Position.isPosition(l),k.Position.from),r.Range=new r("range","A range in a text document",l=>t.Range.isRange(l),k.Range.from),r.Selection=new r("selection","A selection in a text document",l=>t.Selection.isSelection(l),k.Selection.from),r.Number=new r("number","",l=>typeof l=="number",l=>l),r.String=new r("string","",l=>typeof l=="string",l=>l),r.CallHierarchyItem=new r("item","A call hierarchy item",l=>l instanceof t.CallHierarchyItem,k.CallHierarchyItem.from),r.TypeHierarchyItem=new r("item","A type hierarchy item",l=>l instanceof t.TypeHierarchyItem,k.TypeHierarchyItem.from),r.TestItem=new r("testItem","A VS Code TestItem",l=>l instanceof p.TestItemImpl,k.TestItem.from);class o{constructor(s,u){this.description=s,this.convert=u}}e.ApiCommandResult=o,o.Void=new o("no result",l=>l);class a{constructor(s,u,P,F,K){this.id=s,this.internalId=u,this.description=P,this.args=F,this.result=K}}e.ApiCommand=a}),define(ve[263],be([1,0,59,276,29,262,4,12,81]),function(ie,e,b,t,k,S,I,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class y{constructor(C,w,m){this.b=C,this.c=w,this.f=m,this.a=t.createServer((g,p)=>this.h(g,p)),this.g().catch(g=>(w.error(g),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",C=>this.c.error(C))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(C,w){const m=(p,d)=>{w.writeHead(p,{"content-type":"application/json"}),w.end(JSON.stringify(d||null),v=>v&&this.c.error(v))},g=[];C.setEncoding("utf8"),C.on("data",p=>g.push(p)),C.on("end",async()=>{try{const p=JSON.parse(g.join(""));let d;switch(p.type){case"open":d=await this.i(p);break;case"openExternal":d=await this.j(p);break;case"status":d=await this.l(p);break;case"extensionManagement":d=await this.k(p);break;default:m(404,`Unknown message type: ${p.type}`);break}m(200,d)}catch(p){const d=p instanceof Error?p.message:JSON.stringify(p);m(500,d),this.c.error("Error while processing pipe request",p)}})}async i(C){const{fileURIs:w,folderURIs:m,forceNewWindow:g,diffMode:p,mergeMode:d,addMode:v,forceReuseWindow:c,gotoLineMode:h,waitMarkerFilePath:f,remoteAuthority:i}=C,n=[];if(Array.isArray(m))for(const l of m)try{n.push({folderUri:I.URI.parse(l)})}catch{}if(Array.isArray(w))for(const l of w)try{(0,E.hasWorkspaceFileExtension)(l)?n.push({workspaceUri:I.URI.parse(l)}):n.push({fileUri:I.URI.parse(l)})}catch{}const r=f?I.URI.file(f):void 0,a={forceNewWindow:g,diffMode:p,mergeMode:d,addMode:v,gotoLineMode:h,forceReuseWindow:c,preferNewWindow:!c&&!r&&!v,waitMarkerFileURI:r,remoteAuthority:i};return this.b.executeCommand("_remoteCLI.windowOpen",n,a),""}async j(C){for(const w of C.uris){const m=I.URI.parse(w),g=m.scheme==="file"?m:w;await this.b.executeCommand("_remoteCLI.openExternal",g)}}async k(C){const w=g=>g?.map(p=>/\.vsix$/i.test(p)?I.URI.parse(p):p),m={list:C.list,install:w(C.install),uninstall:w(C.uninstall),force:C.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",m)}async l(C){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&k.existsSync(this.f)&&k.unlinkSync(this.f)}}e.CLIServerBase=y;let D=class extends y{constructor(C,w){super(C,w,(0,b.createRandomIPCHandle)())}};D=Le([Oe(0,S.IExtHostCommands),Oe(1,A.ILogService)],D),e.CLIServer=D}),define(ve[264],be([1,0,30,6,23,2,7,3,4,59,66,263,250,122,251,253,127]),function(ie,e,b,t,k,S,I,A,E,y,D,T,C,w,m,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannel=void 0;class d extends g.AbstractVariableResolverService{constructor(h,f,i,n,r){super({getFolderUri:o=>{const a=f.filter(l=>l.name===o);if(a&&a.length>0)return a[0].uri},getWorkspaceFolderCount:()=>f.length,getConfigurationValue:(o,a)=>n[`config:${a}`],getExecPath:()=>h.VSCODE_EXEC_PATH,getAppRoot:()=>h.VSCODE_CWD,getFilePath:()=>{if(i)return I.normalize(i.fsPath)},getSelectedText:()=>n.selectedText,getLineNumber:()=>n.lineNumber,getExtension:async o=>{const l=(await r.getInstalled()).find(s=>s.identifier.id===o);return l&&{extensionLocation:l.location}}},void 0,Promise.resolve(b.homedir()),Promise.resolve(h))}}class v extends S.Disposable{constructor(h,f,i,n,r){super(),this.g=h,this.h=f,this.i=i,this.j=n,this.l=r,this.a=0,this.b=new Map,this.c=this.B(new t.Emitter),this.onExecuteCommand=this.c.event}async call(h,f,i){switch(f){case"$restartPtyHost":return this.i.restartPtyHost?.apply(this.i,i);case"$createProcess":{const n=(0,D.createURITransformer)(h.remoteAuthority);return this.m(n,i)}case"$attachToProcess":return this.i.attachToProcess.apply(this.i,i);case"$detachFromProcess":return this.i.detachFromProcess.apply(this.i,i);case"$listProcesses":return this.i.listProcesses.apply(this.i,i);case"$orphanQuestionReply":return this.i.orphanQuestionReply.apply(this.i,i);case"$acceptPtyHostResolvedVariables":return this.i.acceptPtyHostResolvedVariables?.apply(this.i,i);case"$start":return this.i.start.apply(this.i,i);case"$input":return this.i.input.apply(this.i,i);case"$acknowledgeDataEvent":return this.i.acknowledgeDataEvent.apply(this.i,i);case"$shutdown":return this.i.shutdown.apply(this.i,i);case"$resize":return this.i.resize.apply(this.i,i);case"$getInitialCwd":return this.i.getInitialCwd.apply(this.i,i);case"$getCwd":return this.i.getCwd.apply(this.i,i);case"$processBinary":return this.i.processBinary.apply(this.i,i);case"$sendCommandResult":return this.p(i[0],i[1],i[2]);case"$installAutoReply":return this.i.installAutoReply.apply(this.i,i);case"$uninstallAllAutoReplies":return this.i.uninstallAllAutoReplies.apply(this.i,i);case"$getDefaultSystemShell":return this.r.apply(this,i);case"$getProfiles":return this.s.apply(this,i);case"$getEnvironment":return this.t();case"$getWslPath":return this.u(i[0]);case"$getTerminalLayoutInfo":return this.i.getTerminalLayoutInfo(i);case"$setTerminalLayoutInfo":return this.i.setTerminalLayoutInfo(i);case"$serializeTerminalState":return this.i.serializeTerminalState.apply(this.i,i);case"$reviveTerminalProcesses":return this.i.reviveTerminalProcesses.apply(this.i,i);case"$getRevivedPtyNewId":return this.i.getRevivedPtyNewId.apply(this.i,i);case"$setUnicodeVersion":return this.i.setUnicodeVersion.apply(this.i,i);case"$reduceConnectionGraceTime":return this.w();case"$updateIcon":return this.i.updateIcon.apply(this.i,i);case"$updateTitle":return this.i.updateTitle.apply(this.i,i);case"$updateProperty":return this.i.updateProperty.apply(this.i,i);case"$refreshProperty":return this.i.refreshProperty.apply(this.i,i);case"$requestDetachInstance":return this.i.requestDetachInstance(i[0],i[1]);case"$acceptDetachedInstance":return this.i.acceptDetachInstanceReply(i[0],i[1]);case"$freePortKillProcess":return this.i.freePortKillProcess?.apply(this.i,i)}throw new Error(`IPC Command ${f} not found`)}listen(h,f,i){switch(f){case"$onPtyHostExitEvent":return this.i.onPtyHostExit||t.Event.None;case"$onPtyHostStartEvent":return this.i.onPtyHostStart||t.Event.None;case"$onPtyHostUnresponsiveEvent":return this.i.onPtyHostUnresponsive||t.Event.None;case"$onPtyHostResponsiveEvent":return this.i.onPtyHostResponsive||t.Event.None;case"$onPtyHostRequestResolveVariablesEvent":return this.i.onPtyHostRequestResolveVariables||t.Event.None;case"$onProcessDataEvent":return this.i.onProcessData;case"$onProcessReadyEvent":return this.i.onProcessReady;case"$onProcessExitEvent":return this.i.onProcessExit;case"$onProcessReplayEvent":return this.i.onProcessReplay;case"$onProcessOrphanQuestion":return this.i.onProcessOrphanQuestion;case"$onExecuteCommand":return this.onExecuteCommand;case"$onDidRequestDetach":return this.i.onDidRequestDetach||t.Event.None;case"$onDidChangeProperty":return this.i.onDidChangeProperty;default:break}throw new Error("Not supported")}async m(h,f){const i={name:f.shellLaunchConfig.name,executable:f.shellLaunchConfig.executable,args:f.shellLaunchConfig.args,cwd:typeof f.shellLaunchConfig.cwd=="string"||typeof f.shellLaunchConfig.cwd>"u"?f.shellLaunchConfig.cwd:E.URI.revive(h.transformIncoming(f.shellLaunchConfig.cwd)),env:f.shellLaunchConfig.env,useShellEnvironment:f.shellLaunchConfig.useShellEnvironment,reconnectionProperties:f.shellLaunchConfig.reconnectionProperties,type:f.shellLaunchConfig.type,isFeatureTerminal:f.shellLaunchConfig.isFeatureTerminal},n=await(0,p.buildUserEnvironment)(f.resolverEnv,!!f.shellLaunchConfig.useShellEnvironment,A.language,this.g,this.h);this.h.trace("baseEnv",n);const r=z=>({uri:E.URI.revive(h.transformIncoming(z.uri)),name:z.name,index:z.index,toResource:()=>{throw new Error("Not implemented")}}),o=f.workspaceFolders.map(r),a=f.activeWorkspaceFolder?r(f.activeWorkspaceFolder):void 0,l=f.activeFileResource?E.URI.revive(h.transformIncoming(f.activeFileResource)):void 0,s=new d(n,o,l,f.resolvedVariables,this.l),u=m.createVariableResolver(a,process.env,s),P=await m.getCwd(i,b.homedir(),u,a?.uri,f.configuration["terminal.integrated.cwd"],this.h);i.cwd=P;const F=A.isWindows?"terminal.integrated.env.windows":A.isMacintosh?"terminal.integrated.env.osx":"terminal.integrated.env.linux",K=f.configuration[F],ne=await m.createTerminalEnvironment(i,K,u,this.j.version,f.configuration["terminal.integrated.detectLocale"],n);if(!i.strictEnv){const z=[];for(const[ce,L]of f.envVariableCollections)z.push([ce,{map:(0,w.deserializeEnvironmentVariableCollection)(L)}]);const G=new Map(z);await new C.MergedEnvironmentVariableCollection(G).applyToProcessEnvironment(ne,u)}this.h.debug("Terminal process launching on remote agent",{shellLaunchConfig:i,initialCwd:P,cols:f.cols,rows:f.rows,env:ne});const ue=(0,y.createRandomIPCHandle)();ne.VSCODE_IPC_HOOK_CLI=ue;const se=await this.i.createProcess(i,P,f.cols,f.rows,f.unicodeVersion,ne,n,f.options,f.shouldPersistTerminal,f.workspaceId,f.workspaceName),U={executeCommand:(z,...G)=>this.n(se,z,G,h)},Q=new T.CLIServerBase(U,this.h,ue);return this.i.onProcessExit(z=>z.id===se&&Q.dispose()),{persistentTerminalId:se,resolvedShellLaunchConfig:i}}n(h,f,i,n){let r,o;const a=new Promise((u,P)=>{r=u,o=P}),l=++this.a;this.b.set(l,{resolve:r,reject:o,uriTransformer:n});const s=(0,k.cloneAndChange)(i,u=>{if(u&&u.$mid===1)return n.transformOutgoing(u);if(u&&u instanceof E.URI)return n.transformOutgoingURI(u)});return this.c.fire({reqId:l,persistentProcessId:h,commandId:f,commandArgs:s}),a}p(h,f,i){const n=this.b.get(h);if(!n)return;this.b.delete(h);const r=(0,k.cloneAndChange)(i,o=>{if(o&&o.$mid===1)return n.uriTransformer.transformIncoming(o)});f?n.reject(r):n.resolve(r)}r(h){return this.i.getDefaultSystemShell(h)}async s(h,f,i,n){return this.i.getProfiles?.(h,f,i,n)||[]}t(){return{...process.env}}u(h){return this.i.getWslPath(h)}w(){return this.i.reduceConnectionGraceTime()}}e.RemoteTerminalChannel=v}),define(ve[131],be([1,0,5]),function(ie,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,b.createDecorator)("remoteAgentService")}),define(ve[265],be([1,0,8,2,13,202]),function(ie,e,b,t,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteFileSystemProviderClient=e.REMOTE_FILE_SYSTEM_CHANNEL_NAME=void 0,e.REMOTE_FILE_SYSTEM_CHANNEL_NAME="remoteFilesystem";class I extends S.DiskFileSystemProviderClient{static register(E,y,D){const T=E.getConnection();if(!T)return t.Disposable.None;const C=new t.DisposableStore,w=(async()=>{try{const m=await E.getRawEnvironment();m?y.registerProvider(k.Schemas.vscodeRemote,C.add(new I(m,T))):D.error("Cannot register remote filesystem provider. Remote environment doesnot exist.")}catch(m){D.error("Cannot register remote filesystem provider. Error while fetching remote environment.",(0,b.getErrorMessage)(m))}})();return C.add(y.onWillActivateFileSystemProvider(m=>{m.scheme===k.Schemas.vscodeRemote&&m.join(w)})),C}constructor(E,y){super(y.getChannel(e.REMOTE_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:E.os===3})}}e.RemoteFileSystemProviderClient=I}),define(ve[132],be([1,0,29,14,7,11,21,160,277,278]),function(ie,e,b,t,k,S,I,A,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class D extends Error{constructor(i,n){let r=n.message;switch(i){case"CorruptZip":r=`Corrupt ZIP: ${r}`;break}super(r),this.type=i,this.cause=n}}e.ExtractError=D;function T(f){const i=f.externalFileAttributes>>16||33188;return[448,56,7].map(n=>i&n).reduce((n,r)=>n+r,i&61440)}function C(f){if(f instanceof D)return f;let i;return/end of central directory record signature not found/.test(f.message)&&(i="CorruptZip"),new D(i,f)}function w(f,i,n,r,o,a){const l=k.dirname(i),s=k.join(r,l);if(!s.startsWith(r))return Promise.reject(new Error(A.localize(0,null,i)));const u=k.join(r,i);let P;return a.onCancellationRequested(()=>{P?.destroy()}),Promise.resolve(I.Promises.mkdir(s,{recursive:!0})).then(()=>new Promise((F,K)=>{if(!a.isCancellationRequested)try{P=(0,b.createWriteStream)(u,{mode:n}),P.once("close",()=>F()),P.once("error",K),f.once("error",K),f.pipe(P)}catch(ne){K(ne)}}))}function m(f,i,n,r){let o=(0,t.createCancelablePromise)(()=>Promise.resolve()),a=0;return r.onCancellationRequested(()=>{o.cancel(),f.close()}),new Promise((l,s)=>{const u=new t.Sequencer,P=F=>{F.isCancellationRequested||(a++,f.readEntry())};f.once("error",s),f.once("close",()=>o.then(()=>{r.isCancellationRequested||f.entryCount===a?l():s(new D("Incomplete",new Error(A.localize(1,null,a,f.entryCount))))},s)),f.readEntry(),f.on("entry",F=>{if(r.isCancellationRequested)return;if(!n.sourcePathRegex.test(F.fileName)){P(r);return}const K=F.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(K)){const se=k.join(i,K);o=(0,t.createCancelablePromise)(U=>I.Promises.mkdir(se,{recursive:!0}).then(()=>P(U)).then(void 0,s));return}const ne=p(f,F),ue=T(F);o=(0,t.createCancelablePromise)(se=>u.queue(()=>ne.then(U=>w(U,K,ue,i,n,se).then(()=>P(se)))).then(null,s))})})}function g(f,i=!1){return new Promise((n,r)=>{(0,E.open)(f,i?{lazyEntries:!0}:void 0,(o,a)=>{o?r(C(o)):n((0,S.assertIsDefined)(a))})})}function p(f,i){return new Promise((n,r)=>{f.openReadStream(i,(o,a)=>{o?r(C(o)):n((0,S.assertIsDefined)(a))})})}function d(f,i){return new Promise((n,r)=>{const o=new y.ZipFile;i.forEach(l=>{l.contents?o.addBuffer(typeof l.contents=="string"?Buffer.from(l.contents,"utf8"):l.contents,l.path):l.localPath&&o.addFile(l.localPath,l.path)}),o.end();const a=(0,b.createWriteStream)(f);o.outputStream.pipe(a),o.outputStream.once("error",r),a.once("error",r),a.once("finish",()=>n(f))})}e.zip=d;function v(f,i,n={},r){const o=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let a=g(f,!0);return n.overwrite&&(a=a.then(l=>I.Promises.rm(i).then(()=>l))),a.then(l=>m(l,i,{sourcePathRegex:o},r))}e.extract=v;function c(f,i){return g(f).then(n=>new Promise((r,o)=>{n.on("entry",a=>{a.fileName===i&&p(n,a).then(l=>r(l),l=>o(l))}),n.once("close",()=>o(new Error(A.localize(2,null,i))))}))}function h(f,i){return c(f,i).then(n=>new Promise((r,o)=>{const a=[];n.once("error",o),n.on("data",l=>a.push(l)),n.on("end",()=>r(Buffer.concat(a)))}))}e.buffer=h}),define(ve[266],be([1,0,132,170]),function(ie,e,b,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function k(S){return(0,b.buffer)(S,"extension/package.json").then(I=>{try{return JSON.parse(I.toString("utf8"))}catch{throw new Error((0,t.localize)(0,null))}})}e.getManifest=k}),define(ve[133],be([1,0,14,19,39,8,6,2,26,13,7,3,20,49,11,4,22,21,132,169,75,28,241,31,33,53,54,218,242,266,219,220,32,73,17,5,12,25,34,38,36]),function(ie,e,b,t,k,S,I,A,E,y,D,T,C,w,m,g,p,d,v,c,h,f,i,n,r,o,a,l,s,u,P,F,K,ne,ue,se,U,Q,z,G,X){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,se.refineServiceDecorator)(n.IExtensionManagementService);let ce=class extends i.AbstractExtensionManagementService{constructor(R,M,W,Y,re,me,$,J,_,j,H,q){super(R,M,W,j,q),this.Y=re,this.Z=me,this.ab=$,this.bb=_,this.cb=H,this.X=new Map,this.kb=new E.ResourceSet;const Z=this.B(J.createInstance(s.ExtensionsLifecycle));this.S=this.B(J.createInstance(L,we=>Z.postUninstall(we))),this.U=this.B(new P.ExtensionsManifestCache(Y,this)),this.W=this.B(J.createInstance(l.ExtensionsDownloader,this.getTargetPlatform()));const ae=this.B(new F.ExtensionsWatcher(this,this.Y,q,me,H,_,W));this.B(ae.onDidChangeExtensionsByAnotherSource(we=>this.jb(we))),this.lb()}getTargetPlatform(){return this.db||(this.db=(0,r.computeTargetPlatform)(this.bb,this.v)),this.db}async zip(R){this.v.trace("ExtensionManagementService#zip",R.identifier.id);const M=await this.ib(R),W=await(0,v.zip)((0,C.joinPath)(this.W.extensionsDownloadDir,(0,p.generateUuid)()).fsPath,M);return g.URI.file(W)}async unzip(R){return this.v.trace("ExtensionManagementService#unzip",R.toString()),(await this.install(R)).identifier}async getManifest(R){const{location:M,cleanup:W}=await this.eb(R),Y=D.resolve(M.fsPath);try{return await(0,u.getManifest)(Y)}finally{await W()}}getInstalled(R,M){return this.S.scanExtensions(R??null,M)}getAllUserInstalled(){return this.S.scanAllUserExtensions(!1)}async install(R,M={}){this.v.trace("ExtensionManagementService#install",R.toString());const{location:W,cleanup:Y}=await this.eb(R);try{const re=await(0,u.getManifest)(D.resolve(W.fsPath));if(re.engines&&re.engines.vscode&&!(0,ne.isEngineValid)(re.engines.vscode,this.w.version,this.w.date))throw new Error(c.localize(0,null,(0,r.getGalleryExtensionId)(re.publisher,re.name),this.w.version));return await this.z(re,W,M)}finally{await Y()}}async installFromLocation(R,M){this.v.trace("ExtensionManagementService#installFromLocation",R.toString());const W=await this.S.scanUserExtensionAtLocation(R);if(!W)throw new Error(`Cannot find a valid extension from the location ${R.toString()}`);return await this.nb([W],M),this.v.info("Successfully installed extension",W.identifier.id,M.toString()),W}getMetadata(R){return this.Y.scanMetadata(R.location)}async updateMetadata(R,M){this.v.trace("ExtensionManagementService#updateMetadata",R.identifier.id);const W={...M};return M.isPreReleaseVersion&&(W.preRelease=!0),R=await this.S.updateMetadata(R,W),this.U.invalidate(),R}async updateExtensionScope(R,M){return this.v.trace("ExtensionManagementService#updateExtensionScope",R.identifier.id),R=await this.S.updateMetadata(R,{isMachineScoped:M}),this.U.invalidate(),R}async reinstallFromGallery(R){if(this.v.trace("ExtensionManagementService#reinstallFromGallery",R.identifier.id),!this.t.isEnabled())throw new Error(c.localize(1,null));const M=await this.getTargetPlatform(),[W]=await this.t.getExtensions([{...R.identifier,preRelease:R.preRelease}],{targetPlatform:M,compatible:!0},t.CancellationToken.None);if(!W)throw new Error(c.localize(2,null));await this.S.setUninstalled(R);try{await this.S.removeUninstalledExtension(R)}catch(Y){throw new Error(c.localize(3,null,(0,k.toErrorMessage)(Y)))}await this.installFromGallery(W)}markAsUninstalled(...R){return this.S.setUninstalled(...R)}removeUninstalledExtensions(){return this.S.cleanUp()}async download(R,M){const{location:W}=await this.W.download(R,M);return W}async eb(R){if(R.scheme===y.Schemas.file)return{location:R,async cleanup(){}};this.v.trace("Downloading extension from",R.toString());const M=(0,C.joinPath)(this.W.extensionsDownloadDir,(0,p.generateUuid)());return await this.ab.download(R,M),this.v.info("Downloaded extension to",M.toString()),{location:M,cleanup:async()=>{try{await this.bb.del(M)}catch(Y){this.v.error(Y)}}}}P(){return this.y.defaultProfile.extensionsResource}Q(R,M,W){let Y;if(g.URI.isUri(M))Y=new ee(R,M,W,this.t,this.S,this.v);else{const re=r.ExtensionKey.create(M).toString();Y=this.X.get(re),Y||(this.X.set(re,Y=new V(R,M,W,this.W,this.S,this.v)),Y.waitUntilTaskIsFinished().then(()=>this.X.delete(re)))}return new oe(Y,W.profileLocation,this.Z)}R(R,M){return new ge(R,M.profileLocation,this.Z)}async ib(R){const M=async Y=>{let re=await d.Promises.readdir(Y);re=re.map(J=>D.join(Y,J));const me=await Promise.all(re.map(J=>d.Promises.stat(J)));let $=Promise.resolve([]);return me.forEach((J,_)=>{const j=re[_];J.isFile()&&($=$.then(H=>[...H,j])),J.isDirectory()&&($=$.then(H=>M(j).then(q=>[...H,...q])))}),$};return(await M(R.location.fsPath)).map(Y=>({path:`extension/${D.relative(R.location.fsPath,Y)}`,localPath:Y}))}async jb({added:R,removed:M}){if(M)for(const W of M.extensions)this.v.info("Extensions removed from another source",W.id,M.profileLocation.toString()),this.p.fire({identifier:W,profileLocation:M.profileLocation});if(R){const Y=(await this.S.scanExtensions(1,R.profileLocation)).filter(re=>R.extensions.some(me=>(0,r.areSameExtensions)(me,re.identifier)));this.m.fire(Y.map(re=>(this.v.info("Extensions added from another source",re.identifier.id,R.profileLocation.toString()),{identifier:re.identifier,local:re,profileLocation:R.profileLocation,operation:1})))}}async lb(){this.B(this.S.onExtract(M=>this.kb.add(M)));const R=await this.bb.resolve(this.Y.userExtensionsLocation);for(const M of R.children??[])M.isDirectory&&this.kb.add(M.resource);this.B(this.bb.watch(this.Y.userExtensionsLocation)),this.B(this.bb.onDidFilesChange(M=>this.mb(M)))}async mb(R){const M=[];for(const W of R.rawAdded){if(this.kb.has(W)||!this.cb.extUri.isEqual(this.cb.extUri.dirname(W),this.Y.userExtensionsLocation)||this.cb.extUri.isEqual(W,this.cb.extUri.joinPath(this.Y.userExtensionsLocation,".obsolete"))||this.cb.extUri.basename(W).startsWith(".")||!(await this.bb.stat(W)).isDirectory)continue;const Y=await this.S.scanUserExtensionAtLocation(W);Y&&Y.installedTimestamp===void 0&&(this.kb.add(W),M.push(Y))}M.length&&(await this.nb(M,this.y.defaultProfile.extensionsResource),this.v.info("Added extensions to default profile from external source",M.map(W=>W.identifier.id)))}async nb(R,M){await this.Z.addExtensionsToProfile(R.map(W=>[W,void 0]),M),this.m.fire(R.map(W=>({local:W,identifier:W.identifier,operation:1,profileLocation:M})))}};ce=Le([Oe(0,n.IExtensionGalleryService),Oe(1,z.ITelemetryService),Oe(2,U.ILogService),Oe(3,f.INativeEnvironmentService),Oe(4,a.IExtensionsScannerService),Oe(5,o.IExtensionsProfileScannerService),Oe(6,h.IDownloadService),Oe(7,se.IInstantiationService),Oe(8,ue.IFileService),Oe(9,Q.IProductService),Oe(10,G.IUriIdentityService),Oe(11,X.IUserDataProfilesService)],ce),e.ExtensionManagementService=ce;let L=class extends A.Disposable{constructor(R,M,W,Y){super(),this.j=R,this.k=M,this.l=W,this.m=Y,this.h=this.B(new I.Emitter),this.onExtract=this.h.event,this.c=(0,C.joinPath)(this.l.userExtensionsLocation,".obsolete").fsPath,this.g=new b.Queue}async cleanUp(){await this.v()}async scanExtensions(R,M){await this.l.initializeDefaultProfileExtensions();const W={includeInvalid:!0,profileLocation:M};let Y=[];return R===null||R===0?Y.push(...await this.l.scanAllExtensions({includeInvalid:!0},W,!1)):R===1&&Y.push(...await this.l.scanUserExtensions(W)),Y=R!==null?Y.filter(re=>re.type===R):Y,Promise.all(Y.map(re=>this.u(re)))}async scanAllUserExtensions(R){const M=await this.l.scanUserExtensions({includeAllVersions:!R,includeInvalid:!0});return Promise.all(M.map(W=>this.u(W)))}async scanUserExtensionAtLocation(R){try{const M=await this.l.scanExistingExtension(R,1,{includeInvalid:!0});if(M)return await this.u(M)}catch(M){this.m.error(M)}return null}async extractUserExtension(R,M,W,Y){await this.l.initializeDefaultProfileExtensions();const re=R.toString(),me=D.join(this.l.userExtensionsLocation.fsPath,`.${(0,p.generateUuid)()}`),$=D.join(this.l.userExtensionsLocation.fsPath,re);try{await d.Promises.rm($)}catch{throw new n.ExtensionManagementError(c.localize(4,null,$,R.id),n.ExtensionManagementErrorCode.Delete)}await this.p(R,M,me,Y),await this.l.updateMetadata(g.URI.file(me),W);try{this.h.fire(g.URI.file($)),await this.s(R,me,$,Date.now()+2*60*1e3),this.m.info("Renamed to",$)}catch(J){try{await d.Promises.rm(me)}catch{}if(J.code==="ENOTEMPTY")this.m.info("Rename failed because extension was installed by another source. So ignoring renaming.",R.id);else throw this.m.info(`Rename failed because of ${(0,S.getErrorMessage)(J)}. Deleted from extracted location`,me),J}return this.t(g.URI.file($),1)}async updateMetadata(R,M){return await this.l.updateMetadata(R.location,M),this.t(R.location,R.type)}getUninstalledExtensions(){return this.n()}async setUninstalled(...R){const M=R.map(W=>r.ExtensionKey.create(W));await this.n(W=>M.forEach(Y=>{W[Y.toString()]=!0,this.m.info("Marked extension as uninstalled",Y.toString())}))}async setInstalled(R){await this.n(Y=>delete Y[R.toString()]);const W=(await this.scanAllUserExtensions(!0)).find(Y=>r.ExtensionKey.create(Y).equals(R))||null;return W?this.updateMetadata(W,{installedTimestamp:Date.now()}):null}async removeExtension(R,M){this.m.trace(`Deleting ${M} extension from disk`,R.identifier.id,R.location.fsPath),await d.Promises.rm(R.location.fsPath),this.m.info("Deleted from disk",R.identifier.id,R.location.fsPath)}async removeUninstalledExtension(R){await this.removeExtension(R,"uninstalled"),await this.n(M=>delete M[r.ExtensionKey.create(R).toString()])}async n(R){return this.g.queue(async()=>{let M;try{M=await d.Promises.readFile(this.c,"utf8")}catch(Y){if(Y.code!=="ENOENT")throw Y}let W={};if(M)try{W=JSON.parse(M)}catch{}return R&&(R(W),Object.keys(W).length?await d.Promises.writeFile(this.c,JSON.stringify(W)):await d.Promises.rm(this.c)),W})}async p(R,M,W,Y){this.m.trace(`Started extracting the extension from ${M} to ${W}`);try{await d.Promises.rm(W)}catch(re){throw new n.ExtensionManagementError(this.w(re).message,n.ExtensionManagementErrorCode.Delete)}try{await(0,v.extract)(M,W,{sourcePath:"extension",overwrite:!0},Y),this.m.info(`Extracted extension to ${W}:`,R.id)}catch(re){try{await d.Promises.rm(W)}catch{}let me=n.ExtensionManagementErrorCode.Extract;throw re instanceof v.ExtractError&&(re.type==="CorruptZip"?me=n.ExtensionManagementErrorCode.CorruptZip:re.type==="Incomplete"&&(me=n.ExtensionManagementErrorCode.IncompleteZip)),new n.ExtensionManagementError(re.message,me)}}async s(R,M,W,Y){try{await d.Promises.rename(M,W)}catch(re){if(T.isWindows&&re&&re.code==="EPERM"&&Date.now()<Y)return this.m.info(`Failed renaming ${M} to ${W} with 'EPERM' error. Trying again...`,R.id),this.s(R,M,W,Y);throw new n.ExtensionManagementError(re.message||c.localize(5,null,M,W),re.code||n.ExtensionManagementErrorCode.Rename)}}async t(R,M){const W=await this.l.scanExistingExtension(R,M,{includeInvalid:!0});if(W)return this.u(W);throw new Error(c.localize(6,null,R.path))}async u(R){const M=await this.k.resolve(R.location);let W,Y;return M.children&&(W=M.children.find(({name:re})=>/^readme(\.txt|\.md|)$/i.test(re))?.resource,Y=M.children.find(({name:re})=>/^changelog(\.txt|\.md|)$/i.test(re))?.resource),{identifier:R.identifier,type:R.type,isBuiltin:R.isBuiltin||!!R.metadata?.isBuiltin,location:R.location,manifest:R.manifest,targetPlatform:R.targetPlatform,validations:R.validations,isValid:R.isValid,readmeUrl:W,changelogUrl:Y,publisherDisplayName:R.metadata?.publisherDisplayName||null,publisherId:R.metadata?.publisherId||null,isApplicationScoped:!!R.metadata?.isApplicationScoped,isMachineScoped:!!R.metadata?.isMachineScoped,isPreReleaseVersion:!!R.metadata?.isPreReleaseVersion,preRelease:!!R.metadata?.preRelease,installedTimestamp:R.metadata?.installedTimestamp,updated:!!R.metadata?.updated}}async v(){const R=await this.getUninstalledExtensions(),M=await this.l.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),W=new Set;for(const me of M)R[r.ExtensionKey.create(me).toString()]||W.add(me.identifier.id.toLowerCase());const Y=(0,r.groupByExtension)(M,me=>me.identifier);await b.Promises.settled(Y.map(async me=>{const $=me.sort((J,_)=>w.rcompare(J.manifest.version,_.manifest.version))[0];W.has($.identifier.id.toLowerCase())||await this.j(await this.u($))}));const re=M.filter(me=>me.metadata&&R[r.ExtensionKey.create(me).toString()]);await b.Promises.settled(re.map(me=>this.removeUninstalledExtension(me)))}w(R){const M=Array.isArray(R)?R:[R];return M.length===1?M[0]instanceof Error?M[0]:new Error(M[0]):M.reduce((W,Y)=>new Error(`${W.message}${W.message?",":""}${Y instanceof Error?Y.message:Y}`),new Error(""))}};L=Le([Oe(1,ue.IFileService),Oe(2,a.IExtensionsScannerService),Oe(3,U.ILogService)],L),e.ExtensionsScanner=L;class N extends i.AbstractExtensionTask{get operation(){return(0,m.isUndefined)(this.k.operation)?this.j:this.k.operation}constructor(R,M,W,Y,re){super(),this.identifier=R,this.source=M,this.k=W,this.l=Y,this.m=re,this.wasVerified=!1,this.j=2}async n(R,M){try{const W=await this.o(R.key);if(W)return this.l.updateMetadata(W,R.metadata)}catch{throw T.isMacintosh?new n.ExtensionManagementError(c.localize(7,null),n.ExtensionManagementErrorCode.Internal):new n.ExtensionManagementError(c.localize(8,null),n.ExtensionManagementErrorCode.Internal)}return this.q(R,M)}async o(R){if(!await this.p(R))return null;this.m.trace("Removing the extension from uninstalled list:",R.id);const W=await this.l.setInstalled(R);return this.m.info("Removed the extension from uninstalled list:",R.id),W}async p(R){return!!(await this.l.getUninstalledExtensions())[R.toString()]}async q({zipPath:R,key:M,metadata:W},Y){const re=await this.l.extractUserExtension(M,R,W,Y);return this.m.info("Extracting completed.",M.id),re}}class V extends N{constructor(R,M,W,Y,re,me){super(M.identifier,M,W,re,me),this.s=R,this.t=M,this.u=Y}async h(R){const W=(await this.l.scanExtensions(null,void 0)).find($=>(0,r.areSameExtensions)($.identifier,this.t.identifier));W&&(this.j=3);const Y={id:this.t.identifier.uuid,publisherId:this.t.publisherId,publisherDisplayName:this.t.publisherDisplayName,targetPlatform:this.t.properties.targetPlatform,isApplicationScoped:(0,K.isApplicationScopedExtension)(this.s),isMachineScoped:this.k.isMachineScoped||W?.isMachineScoped,isBuiltin:this.k.isBuiltin||W?.isBuiltin,isSystem:W?.type===0?!0:void 0,updated:!!W,isPreReleaseVersion:this.t.properties.isPreReleaseVersion,installedTimestamp:Date.now(),preRelease:this.t.properties.isPreReleaseVersion||((0,m.isBoolean)(this.k.installPreReleaseVersion)?this.k.installPreReleaseVersion:W?.preRelease)};if(W?.manifest.version===this.t.version)return{local:await this.l.updateMetadata(W,Y),metadata:Y};const{location:re,verified:me}=await this.u.download(this.t,this.j);try{return this.wasVerified=!!me,this.w(re.fsPath),{local:await this.n({zipPath:re.fsPath,key:r.ExtensionKey.create(this.t),metadata:Y},R),metadata:Y}}catch($){try{await this.u.delete(re)}catch(J){this.m.warn("Error while deleting the downloaded file",re.toString(),(0,S.getErrorMessage)(J))}throw $}}async w(R){try{await(0,u.getManifest)(R)}catch(M){throw new n.ExtensionManagementError((0,i.joinErrors)(M).message,n.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=V;class ee extends N{constructor(R,M,W,Y,re,me){super({id:(0,r.getGalleryExtensionId)(R.publisher,R.name)},M,W,re,me),this.s=R,this.t=M,this.u=Y}async h(R){const M=new r.ExtensionKey(this.identifier,this.s.version),Y=(await this.l.scanExtensions(1,void 0)).find($=>(0,r.areSameExtensions)(this.identifier,$.identifier)),re=await this.w(this.identifier.id,this.s.version,R);if(re.isApplicationScoped=(0,K.isApplicationScopedExtension)(this.s),re.isMachineScoped=this.k.isMachineScoped||Y?.isMachineScoped,re.isBuiltin=this.k.isBuiltin||Y?.isBuiltin,re.installedTimestamp=Date.now(),Y)if(this.j=3,M.equals(new r.ExtensionKey(Y.identifier,Y.manifest.version)))try{await this.l.removeExtension(Y,"existing")}catch{throw new Error(c.localize(9,null,this.s.displayName||this.s.name))}else!this.k.profileLocation&&w.gt(Y.manifest.version,this.s.version)&&await this.l.setUninstalled(Y);else{const $=await this.o(M);if($)try{await this.l.removeExtension($,"existing")}catch{throw new Error(c.localize(10,null,this.s.displayName||this.s.name))}}return{local:await this.n({zipPath:D.resolve(this.t.fsPath),key:M,metadata:re},R),metadata:re}}async w(R,M,W){try{let[Y]=await this.u.getExtensions([{id:R,version:M}],W);if(Y||([Y]=await this.u.getExtensions([{id:R}],W)),Y)return{id:Y.identifier.uuid,publisherDisplayName:Y.publisherDisplayName,publisherId:Y.publisherId,isPreReleaseVersion:Y.properties.isPreReleaseVersion,preRelease:Y.properties.isPreReleaseVersion||this.k.installPreReleaseVersion}}catch{}return{}}}class oe{constructor(R,M,W){this.d=R,this.g=M,this.h=W,this.identifier=this.d.identifier,this.source=this.d.source,this.operation=this.d.operation,this.c=this.j()}async j(){const R=await this.d.waitUntilTaskIsFinished();return await this.h.addExtensionsToProfile([[R.local,R.metadata]],this.g),R}async run(){return await this.d.run(),this.c}waitUntilTaskIsFinished(){return this.c}cancel(){return this.d.cancel()}}class ge extends i.AbstractExtensionTask{constructor(R,M,W){super(),this.extension=R,this.j=M,this.k=W}async h(R){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(ve[134],be([1,0,79,14,16,8,2,11,24,28,80,12,223,279]),function(ie,e,b,t,k,S,I,A,E,y,D,T,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let m=class extends I.Disposable{constructor(p,d,v){super(),this.h=d,this.i=v,this.j(p.getValue()),this.B(p.onDidChangeConfiguration(()=>this.j(p.getValue()),this))}j(p){this.a=p.http&&p.http.proxy,this.b=!!(p.http&&p.http.proxyStrictSSL),this.f=p.http&&p.http.proxyAuthorization}async request(p,d){this.i.trace("RequestService#request (node) - begin",p.url);const{a:v,b:c}=this;let h;try{h=await(0,D.getResolvedShellEnv)(this.i,this.h.args,process.env)}catch(n){this.g||(this.g=!0,this.i.error("RequestService#request (node) resolving shell environment failed",n))}const f={...process.env,...h},i=p.agent?p.agent:await(0,C.getProxyAgent)(p.url||"",f,{proxyUrl:v,strictSSL:c});p.agent=i,p.strictSSL=c,this.f&&(p.headers={...p.headers||{},"Proxy-Authorization":this.f});try{const n=await this.l(p,d);return this.i.trace("RequestService#request (node) - success",p.url),n}catch(n){throw this.i.trace("RequestService#request (node) - error",p.url,n),n}}async k(p){return((0,b.parse)(p.url).protocol==="https:"?await new Promise((c,h)=>{ie(["https"],c,h)}):await new Promise((c,h)=>{ie(["http"],c,h)})).request}l(p,d){return t.Promises.withAsyncBody(async(v,c)=>{const h=(0,b.parse)(p.url),f=p.getRawRequest?p.getRawRequest(p):await this.k(p),i={hostname:h.hostname,port:h.port?parseInt(h.port):h.protocol==="https:"?443:80,protocol:h.protocol,path:h.path,method:p.type||"GET",headers:p.headers,agent:p.agent,rejectUnauthorized:(0,A.isBoolean)(p.strictSSL)?p.strictSSL:!0};p.user&&p.password&&(i.auth=p.user+":"+p.password);const n=f(i,r=>{const o=(0,A.isNumber)(p.followRedirects)?p.followRedirects:3;if(r.statusCode&&r.statusCode>=300&&r.statusCode<400&&o>0&&r.headers.location)this.l({...p,url:r.headers.location,followRedirects:o-1},d).then(v,c);else{let a=r;!p.isChromiumNetwork&&r.headers["content-encoding"]==="gzip"&&(a=r.pipe((0,w.createGunzip)())),v({res:r,stream:(0,k.streamToBufferReadableStream)(a)})}});n.on("error",c),p.timeout&&n.setTimeout(p.timeout),p.isChromiumNetwork&&n.removeHeader("Content-Length"),p.data&&typeof p.data=="string"&&n.write(p.data),n.end(),d.onCancellationRequested(()=>{n.abort(),c(new S.CancellationError)})})}async resolveProxy(p){}};m=Le([Oe(0,E.IConfigurationService),Oe(1,y.INativeEnvironmentService),Oe(2,T.ILogService)],m),e.RequestService=m}),define(ve[267],be([1,0,77,12,61,107,24,52,134,42,34,31,116,133,76,102,50,2,103,63,13,17,25,105,131,43,109,78,110,8,4,7,27,221,75,38,115,60,3,54,119,36,53,64]),function(ie,e,b,t,k,S,I,A,E,y,D,T,C,w,m,g,p,d,v,c,h,f,i,n,r,o,a,l,s,u,P,F,K,ne,ue,se,U,Q,z,G,X,ce,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.run=void 0;class V extends d.Disposable{constructor(fe,R){super(),this.a=fe,this.b=R,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const fe=await this.f();await fe.invokeFunction(async R=>{const M=R.get(t.ILogService);try{await this.g(fe.createInstance(a.ExtensionManagementCLI))}catch(W){throw M.error(W),console.error((0,u.getErrorMessage)(W)),W}})}async f(){const fe=new b.ServiceCollection,R={_serviceBrand:void 0,...p.default};fe.set(i.IProductService,R);const M=new o.ServerEnvironmentService(this.a,R);fe.set(o.IServerEnvironmentService,M);const W=new t.LogService(new n.SpdLogLogger(r.RemoteExtensionLogFileName,(0,F.join)(M.logsPath,`${r.RemoteExtensionLogFileName}.log`),!0,!1,(0,t.getLogLevel)(M)));fe.set(t.ILogService,W),W.trace(`Remote configuration data at ${this.b}`),W.trace("process arguments:",this.a);const Y=this.B(new v.FileService(W));fe.set(f.IFileService,Y),Y.registerProvider(h.Schemas.file,this.B(new c.DiskFileSystemProvider(W)));const re=new U.UriIdentityService(Y);fe.set(se.IUriIdentityService,re);const me=this.B(new ce.UserDataProfilesService(M,Y,re,W));fe.set(ce.IUserDataProfilesService,me);const $=this.B(new S.ConfigurationService(me.defaultProfile.settingsResource,Y,new N.NullPolicyService,W));return await $.initialize(),fe.set(I.IConfigurationService,$),fe.set(A.IRequestService,new k.SyncDescriptor(E.RequestService)),fe.set(ue.IDownloadService,new k.SyncDescriptor(ne.DownloadService)),fe.set(D.ITelemetryService,y.NullTelemetryService),fe.set(T.IExtensionGalleryService,new k.SyncDescriptor(C.ExtensionGalleryServiceWithNoStorageService)),fe.set(L.IExtensionsProfileScannerService,new k.SyncDescriptor(L.ExtensionsProfileScannerService)),fe.set(G.IExtensionsScannerService,new k.SyncDescriptor(X.ExtensionsScannerService)),fe.set(m.IExtensionSignatureVerificationService,new k.SyncDescriptor(m.ExtensionSignatureVerificationService)),fe.set(w.INativeServerExtensionManagementService,new k.SyncDescriptor(w.ExtensionManagementService)),fe.set(l.ILanguagePackService,new k.SyncDescriptor(s.NativeLanguagePackService)),new g.InstantiationService(fe)}async g(fe){if(this.a["list-extensions"])return fe.listExtensions(!!this.a["show-versions"],this.a.category);if(this.a["install-extension"]||this.a["install-builtin-extension"]){const R={isMachineScoped:!!this.a["do-not-sync"],installPreReleaseVersion:!!this.a["pre-release"]};return fe.installExtensions(this.h(this.a["install-extension"]||[]),this.a["install-builtin-extension"]||[],R,!!this.a.force)}else{if(this.a["uninstall-extension"])return fe.uninstallExtensions(this.h(this.a["uninstall-extension"]),!!this.a.force);if(this.a["locate-extension"])return fe.locateExtension(this.a["locate-extension"])}}h(fe){return fe.map(R=>/\.vsix$/i.test(R)?P.URI.file((0,F.isAbsolute)(R)?R:(0,F.join)((0,K.cwd)(),R)):R)}}function ee(ge){setTimeout(()=>process.exit(ge),0)}async function oe(ge,fe,R){if(ge.help){const W=p.default.serverApplicationName+(z.isWindows?".cmd":"");console.log((0,Q.buildHelpMessage)(p.default.nameLong,W,p.default.version,R,{noInputFiles:!0,noPipe:!0}));return}if(ge.version){console.log((0,Q.buildVersionMessage)(p.default.version,p.default.commit));return}const M=new V(ge,fe);try{await M.run(),ee(0)}catch{ee(1)}finally{M.dispose()}}e.run=oe}),define(ve[268],be([1,0,30,6,2,13,7,93,21,41,24,107,74,215,189,75,190,200,209,28,116,31,76,109,201,133,17,103,63,61,102,77,78,110,12,104,50,25,52,222,134,112,34,42,232,113,240,38,115,260,249,225,230,264,66,43,255,131,265,117,54,119,53,36,64,231,213,4,212]),function(ie,e,b,t,k,S,I,A,E,y,D,T,C,w,m,g,p,d,v,c,h,f,i,n,r,o,a,l,s,u,P,F,K,ne,ue,se,U,Q,z,G,X,ce,L,N,V,ee,oe,ge,fe,R,M,W,Y,re,me,$,J,_,j,H,q,Z,ae,we,ke,Ae,Me,ze,de){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SocketServer=e.setupServerServices=void 0;const Ee="monacoworkbench";async function ye(qe,$e,xe,le){const Ce=new F.ServiceCollection,De=new Ye,Te={_serviceBrand:void 0,...U.default};Ce.set(Q.IProductService,Te);const Ne=new $.ServerEnvironmentService($e,Te);Ce.set(c.IEnvironmentService,Ne),Ce.set(c.INativeEnvironmentService,Ne);const We=new de.BufferLogService,Ge=new ue.MultiplexLogService([new Ve((0,ue.getLogLevel)(Ne)),We]);Ce.set(ue.ILogService,Ge),setTimeout(()=>tt(Ne.logsPath).then(null,st=>Ge.error(st)),1e4);const rt=new Me.LoggerService(Ge);We.logger=rt.createLogger(ze.URI.file(I.join(Ne.logsPath,`${_.RemoteExtensionLogFileName}.log`)),{name:_.RemoteExtensionLogFileName}),Ge.trace(`Remote configuration data at ${xe}`),Ge.trace("process arguments:",Ne.args),Array.isArray(Te.serverGreeting)&&Ge.info(`

${Te.serverGreeting.join(`
`)}

`),De.registerChannel(m.ExtensionHostDebugBroadcastChannel.ChannelName,new m.ExtensionHostDebugBroadcastChannel);const it=new y.StaticRouter(st=>st.clientId==="renderer");De.registerChannel("logger",new se.LogLevelChannel(Ge,rt));const Qe=le.add(new l.FileService(Ge));Ce.set(a.IFileService,Qe),Qe.registerProvider(S.Schemas.file,le.add(new s.DiskFileSystemProvider(Ge)));const ot=new fe.UriIdentityService(Qe);Ce.set(ge.IUriIdentityService,ot);const lt=new we.UserDataProfilesService(Ne,Qe,ot,Ge);Ce.set(we.IUserDataProfilesService,lt);const ft=new T.ConfigurationService(Ne.machineSettingsResource,Qe,new ke.NullPolicyService,Ge);Ce.set(D.IConfigurationService,ft),await ft.initialize();const vt=new H.ExtensionHostStatusService;Ce.set(H.IExtensionHostStatusService,vt),Ce.set(z.IRequestService,new u.SyncDescriptor(X.RequestService));let kt=N.NullAppender;const At=await(0,A.getMachineId)(),Et=(0,N.isInternalTelemetry)(Te,ft);if((0,N.supportsTelemetry)(Te,Ne)){Te.aiConfig&&Te.aiConfig.ariaKey&&(kt=new Ae.OneDataSystemAppender(Et,Ee,null,Te.aiConfig.ariaKey),le.add((0,k.toDisposable)(()=>kt?.flush())));const st={appenders:[kt],commonProperties:(0,ce.resolveCommonProperties)(Qe,(0,b.release)(),(0,b.hostname)(),process.arch,Te.commit,Te.version+"-remote",At,Et,Ne.installSourcePath,"remoteAgent"),piiPaths:(0,N.getPiiPathsFromEnvironment)(Ne)},ut=Ne.args["telemetry-level"];let gt=3;ut==="all"?gt=3:ut==="error"?gt=2:ut==="crash"?gt=1:ut!==void 0&&(gt=0),Ce.set(Y.IServerTelemetryService,new u.SyncDescriptor(Y.ServerTelemetryService,[st,gt]))}else Ce.set(Y.IServerTelemetryService,Y.ServerNullTelemetryService);Ce.set(f.IExtensionGalleryService,new u.SyncDescriptor(h.ExtensionGalleryServiceWithNoStorageService));const Ot=De.getChannel("download",it);Ce.set(g.IDownloadService,new p.DownloadServiceChannelClient(Ot,()=>Be("renderer"))),Ce.set(ae.IExtensionsProfileScannerService,new u.SyncDescriptor(ae.ExtensionsProfileScannerService)),Ce.set(q.IExtensionsScannerService,new u.SyncDescriptor(Z.ExtensionsScannerService)),Ce.set(i.IExtensionSignatureVerificationService,new u.SyncDescriptor(i.ExtensionSignatureVerificationService)),Ce.set(o.INativeServerExtensionManagementService,new u.SyncDescriptor(o.ExtensionManagementService));const mt=new P.InstantiationService(Ce);Ce.set(K.ILanguagePackService,mt.createInstance(ne.NativeLanguagePackService));const St=mt.createInstance(oe.PtyHostService,{graceTime:108e5,shortGraceTime:3e5,scrollback:ft.getValue("terminal.integrated.persistentSessionScrollback")??100});return Ce.set(ee.IPtyService,St),Ce.set(d.IEncryptionMainService,new u.SyncDescriptor(v.EncryptionMainService,[At])),Ce.set(C.ICredentialsMainService,new u.SyncDescriptor(w.CredentialsWebMainService)),mt.invokeFunction(st=>{const ut=st.get(o.INativeServerExtensionManagementService),gt=st.get(q.IExtensionsScannerService),Rt=new R.RemoteAgentEnvironmentChannel(qe,Ne,lt,mt.createInstance(n.ExtensionManagementCLI),Ge,vt,gt);De.registerChannel("remoteextensionsenvironment",Rt);const Mt=new W.ServerTelemetryChannel(st.get(Y.IServerTelemetryService),kt);De.registerChannel("telemetry",Mt),De.registerChannel(J.REMOTE_TERMINAL_CHANNEL_NAME,new re.RemoteTerminalChannel(Ne,Ge,St,Te,ut));const Se=new M.RemoteAgentFileSystemProviderChannel(Ge,Ne);De.registerChannel(j.REMOTE_FILE_SYSTEM_CHANNEL_NAME,Se),De.registerChannel("request",new G.RequestChannel(st.get(z.IRequestService)));const Ie=new r.ExtensionManagementChannel(ut,Pe=>Be(Pe.remoteAuthority));De.registerChannel("extensions",Ie);const he=y.ProxyChannel.fromService(st.get(d.IEncryptionMainService));De.registerChannel("encryption",he);const x=y.ProxyChannel.fromService(st.get(C.ICredentialsMainService));return De.registerChannel("credentials",x),ut.removeUninstalledExtensions(),le.add(new V.default(st.get(L.ITelemetryService))),{telemetryService:st.get(L.ITelemetryService)}}),{socketServer:De,instantiationService:mt}}e.setupServerServices=ye;const Fe=Object.create(null);function Be(qe){return Fe[qe]||(Fe[qe]=(0,me.createURITransformer)(qe)),Fe[qe]}class Ye extends y.IPCServer{constructor(){const $e=new t.Emitter;super($e.event),this.b=$e}acceptConnection($e,xe){this.b.fire({protocol:$e,onDidClientDisconnect:xe})}}e.SocketServer=Ye;class Ve extends ue.AbstractLogger{constructor($e=ue.DEFAULT_LOG_LEVEL){super(),this.setLevel($e),this.g=Boolean(process.stdout.isTTY)}trace($e,...xe){this.f(ue.LogLevel.Trace)&&(this.g?console.log(`\x1B[90m[${Je()}]\x1B[0m`,$e,...xe):console.log(`[${Je()}]`,$e,...xe))}debug($e,...xe){this.f(ue.LogLevel.Debug)&&(this.g?console.log(`\x1B[90m[${Je()}]\x1B[0m`,$e,...xe):console.log(`[${Je()}]`,$e,...xe))}info($e,...xe){this.f(ue.LogLevel.Info)&&(this.g?console.log(`\x1B[90m[${Je()}]\x1B[0m`,$e,...xe):console.log(`[${Je()}]`,$e,...xe))}warn($e,...xe){this.f(ue.LogLevel.Warning)&&(this.g?console.warn(`\x1B[93m[${Je()}]\x1B[0m`,$e,...xe):console.warn(`[${Je()}]`,$e,...xe))}error($e,...xe){this.f(ue.LogLevel.Error)&&(this.g?console.error(`\x1B[91m[${Je()}]\x1B[0m`,$e,...xe):console.error(`[${Je()}]`,$e,...xe))}dispose(){}flush(){}}function Je(){const qe=new Date;return`${Xe(qe.getHours())}:${Xe(qe.getMinutes())}:${Xe(qe.getSeconds())}`}function Xe(qe){return qe<10?`0${qe}`:String(qe)}async function tt(qe){const $e=I.basename(qe),xe=I.dirname(qe),De=(await E.Promises.readdir(xe)).filter(Ne=>/^\d{8}T\d{6}$/.test(Ne)).sort().filter(Ne=>Ne!==$e),Te=De.slice(0,Math.max(0,De.length-9));await Promise.all(Te.map(Ne=>E.Promises.rm(I.join(xe,Ne))))}}),define(ve[269],be([1,0,111,29,89,270,79,135,16,8,37,2,13,7,45,3,15,4,22,142,97,59,5,12,25,65,34,127,244,245,43,268,247]),function(ie,e,b,t,k,S,I,A,E,y,D,T,C,w,m,g,p,d,v,c,h,f,i,n,r,o,a,l,s,u,P,F,K){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=void 0;const ne=5*60*1e3;let ue=class extends T.Disposable{constructor(z,G,X,ce,L,N,V,ee){super(),this.k=z,this.l=G,this.m=X,this.n=L,this.p=N,this.r=V,this.s=ee,this.h=U.create(this.p),this.i=(0,o.getRemoteServerRootPath)(N),this.a=Object.create(null),this.b=Object.create(null),this.f=new Set,this.g=ce?this.s.createInstance(K.WebClientServer,this.l):null,this.r.info("Extension host agent started.")}async handleRequest(z,G){if(z.method!=="GET")return(0,K.serveError)(z,G,405,`Unsupported method ${z.method}`);if(!z.url)return(0,K.serveError)(z,G,400,"Bad request.");const X=I.parse(z.url,!0);let ce=X.pathname;if(!ce)return(0,K.serveError)(z,G,400,"Bad request.");if(ce.startsWith(this.i)&&ce.charCodeAt(this.i.length)===47&&(ce=ce.substring(this.i.length)),ce==="/version")return G.writeHead(200,{"Content-Type":"text/plain"}),void G.end(this.p.commit||"");if(ce==="/delay-shutdown")return this.H(),G.writeHead(200),void G.end("OK");if(!(0,u.requestHasValidConnectionToken)(this.l,z,X))return(0,K.serveError)(z,G,403,"Forbidden.");if(ce==="/vscode-remote-resource"){const L=X.query.path;if(typeof L!="string")return(0,K.serveError)(z,G,400,"Bad request.");let N;try{N=d.URI.from({scheme:C.Schemas.file,path:L}).fsPath}catch{return(0,K.serveError)(z,G,400,"Bad request.")}const V=Object.create(null);this.n.isBuilt&&((0,D.isEqualOrParent)(N,this.n.builtinExtensionsPath,!g.isLinux)||(0,D.isEqualOrParent)(N,this.n.extensionsPath,!g.isLinux))&&(V["Cache-Control"]="public, max-age=31536000"),V.Vary="Origin";const ee=z.headers.origin;return ee&&this.h.matches(ee)&&(V["Access-Control-Allow-Origin"]=ee),(0,K.serveFile)(N,1,this.r,z,G,V)}if(this.g){this.g.handle(z,G,X);return}return G.writeHead(404,{"Content-Type":"text/plain"}),void G.end("Not found")}handleUpgrade(z,G){let X=(0,v.generateUuid)(),ce=!1,L=!1;if(z.url){const fe=I.parse(z.url,!0).query;typeof fe.reconnectionToken=="string"&&(X=fe.reconnectionToken),fe.reconnection==="true"&&(ce=!0),fe.skipWebSocketFrames==="true"&&(L=!0)}if(z.headers.upgrade===void 0||z.headers.upgrade.toLowerCase()!=="websocket"){G.end("HTTP/1.1 400 Bad Request");return}const N=z.headers["sec-websocket-key"],V=b.createHash("sha1");V.update(N+"258EAFA5-E914-47DA-95CA-C5AB0DC85B11");const ee=V.digest("base64"),oe=["HTTP/1.1 101 Switching Protocols","Upgrade: websocket","Connection: Upgrade",`Sec-WebSocket-Accept: ${ee}`];let ge=!1;if(!L&&!this.n.args["disable-websocket-compression"]&&z.headers["sec-websocket-extensions"]){const fe=Array.isArray(z.headers["sec-websocket-extensions"])?z.headers["sec-websocket-extensions"]:[z.headers["sec-websocket-extensions"]];for(const R of fe)if(!/\b((server_max_window_bits)|(server_no_context_takeover)|(client_no_context_takeover))\b/.test(R)){if(/\b(permessage-deflate)\b/.test(R)){ge=!0,oe.push("Sec-WebSocket-Extensions: permessage-deflate");break}if(/\b(x-webkit-deflate-frame)\b/.test(R)){ge=!0,oe.push("Sec-WebSocket-Extensions: x-webkit-deflate-frame");break}}}G.write(oe.join(`\r
`)+`\r
\r
`),G.setTimeout(0),G.setNoDelay(!0),L?this.v(new f.NodeSocket(G,`server-connection-${X}`),ce,X):this.v(new f.WebSocketNodeSocket(new f.NodeSocket(G,`server-connection-${X}`),ge,null,!0),ce,X)}handleServerError(z){this.r.error("Error occurred in server"),this.r.error(z)}t(z){let G;return z instanceof f.NodeSocket?G=z.socket:G=z.socket.socket,G.remoteAddress||"<unknown>"}async u(z,G,X){const ce=G.getSocket();this.r.error(`${z} ${X}.`);const L={type:"error",reason:X};G.sendControl(E.VSBuffer.fromString(JSON.stringify(L))),G.dispose(),await ce.drain(),ce.dispose()}v(z,G,X){const ce=this.t(z),L=`[${ce}][${X.substr(0,8)}]`,N=new h.PersistentProtocol(z),V=this.m?new this.m.validator:null,ee=this.m?new this.m.signer:null;let oe;(function(M){M[M.WaitingForAuth=0]="WaitingForAuth",M[M.WaitingForConnectionType=1]="WaitingForConnectionType",M[M.Done=2]="Done",M[M.Error=3]="Error"})(oe||(oe={}));let ge=0;const fe=M=>{ge=3,R.dispose(),this.u(L,N,M)},R=N.onControlMessage(M=>{if(ge===0){let W;try{W=JSON.parse(M.toString())}catch{return fe("Malformed first message")}if(W.type!=="auth")return fe("Invalid first message");if(this.l.type===2&&!this.l.validate(W.auth))return fe("Unauthorized client refused: auth mismatch");let Y=(0,v.generateUuid)();if(ee)try{Y=ee.sign(W.data)}catch{}let re=(0,v.generateUuid)();if(V)try{re=V.createNewMessage(re)}catch{}const me={type:"sign",data:re,signedData:Y};N.sendControl(E.VSBuffer.fromString(JSON.stringify(me))),ge=1}else if(ge===1){let W;try{W=JSON.parse(M.toString())}catch{return fe("Malformed second message")}if(W.type!=="connectionType")return fe("Invalid second message");if(typeof W.signedData!="string")return fe("Invalid second message field type");const Y=W.commit,re=this.p.commit;if(Y&&re&&Y!==re)return fe("Client refused: version mismatch");let me=!1;if(!V)me=!0;else if(this.l.validate(W.signedData))me=!0;else try{me=V.validate(W.signedData)==="ok"}catch{}if(!me){if(this.n.isBuilt)return fe("Unauthorized client refused");this.r.error(`${L} Unauthorized client handshake failed but we proceed because of dev mode.`)}for(const $ in this.b)this.b[$].shortenReconnectionGraceTimeIfNecessary();for(const $ in this.a)this.a[$].shortenReconnectionGraceTimeIfNecessary();ge=2,R.dispose(),this.w(ce,L,N,z,G,X,W)}})}async w(z,G,X,ce,L,N,V){const ee=V.desiredConnectionType===1?`${G}[ManagementConnection]`:V.desiredConnectionType===2?`${G}[ExtensionHostConnection]`:G;if(V.desiredConnectionType===1)if(L){if(!this.b[N])return this.f.has(N)?this.u(ee,X,"Unknown reconnection token (seen before)"):this.u(ee,X,"Unknown reconnection token (never seen)");X.sendControl(E.VSBuffer.fromString(JSON.stringify({type:"ok"})));const oe=X.readEntireBuffer();X.dispose(),this.b[N].acceptReconnection(z,ce,oe)}else{if(this.b[N])return this.u(ee,X,"Duplicate reconnection token");X.sendControl(E.VSBuffer.fromString(JSON.stringify({type:"ok"})));const oe=new s.ManagementConnection(this.r,N,z,X);this.k.acceptConnection(oe.protocol,oe.onClose),this.b[N]=oe,this.f.add(N),oe.onClose(()=>{delete this.b[N]})}else if(V.desiredConnectionType===2){const oe=V.args||{language:"en"},ge=await this.C(oe);if(ge.port&&this.r.trace(`${ee} - startParams debug port ${ge.port}`),this.r.trace(`${ee} - startParams language: ${ge.language}`),this.r.trace(`${ee} - startParams env: ${JSON.stringify(ge.env)}`),L){if(!this.a[N])return this.f.has(N)?this.u(ee,X,"Unknown reconnection token (seen before)"):this.u(ee,X,"Unknown reconnection token (never seen)");X.sendPause(),X.sendControl(E.VSBuffer.fromString(JSON.stringify(ge.port?{debugPort:ge.port}:{})));const fe=X.readEntireBuffer();X.dispose(),this.a[N].acceptReconnection(z,ce,fe)}else{if(this.a[N])return this.u(ee,X,"Duplicate reconnection token");X.sendPause(),X.sendControl(E.VSBuffer.fromString(JSON.stringify(ge.port?{debugPort:ge.port}:{})));const fe=X.readEntireBuffer();X.dispose();const R=this.s.createInstance(l.ExtensionHostConnection,N,z,ce,fe);this.a[N]=R,this.f.add(N),R.onClose(()=>{delete this.a[N],this.D()}),R.start(ge)}}else if(V.desiredConnectionType===3){const oe=V.args;this.y(X,oe)}else return this.u(ee,X,"Unknown initial data received")}async y(z,G){const X=z.getSocket().socket,ce=z.readEntireBuffer();z.dispose(),X.pause();const L=await this.z(G.host,G.port);ce.byteLength>0&&L.write(ce.buffer),L.on("end",()=>X.end()),L.on("close",()=>X.end()),L.on("error",()=>X.destroy()),X.on("end",()=>L.end()),X.on("close",()=>L.end()),X.on("error",()=>L.destroy()),L.pipe(X),X.pipe(L)}z(z,G){return new Promise((X,ce)=>{const L=k.createConnection({host:z,port:G},()=>{L.removeListener("error",ce),L.pause(),X(L)});L.once("error",ce)})}C(z){return typeof z.port=="number"?(0,c.findFreePort)(z.port,10,5e3).then(G=>(z.port=G,z)):(z.debugId=void 0,z.port=void 0,z.break=void 0,Promise.resolve(z))}async D(){if(!this.n.args["enable-remote-auto-shutdown"])return;this.I(),!!Object.keys(this.a).length||(console.log("Last EH closed, waiting before shutting down"),this.r.info("Last EH closed, waiting before shutting down"),this.F())}F(){!this.n.args["enable-remote-auto-shutdown"]||(this.n.args["remote-auto-shutdown-without-delay"]?this.G():this.j=setTimeout(()=>{this.j=void 0,this.G()},ne))}G(){if(!!Object.keys(this.a).length){console.log("New EH opened, aborting shutdown"),this.r.info("New EH opened, aborting shutdown");return}else console.log("Last EH closed, shutting down"),this.r.info("Last EH closed, shutting down"),this.dispose(),process.exit(0)}H(){this.j&&(console.log("Got delay-shutdown request while in shutdown timeout, delaying"),this.r.info("Got delay-shutdown request while in shutdown timeout, delaying"),this.I(),this.F())}I(){this.j&&(console.log("Cancelling previous shutdown timeout"),this.r.info("Cancelling previous shutdown timeout"),clearTimeout(this.j),this.j=void 0)}};ue=Le([Oe(4,P.IServerEnvironmentService),Oe(5,r.IProductService),Oe(6,n.ILogService),Oe(7,i.IInstantiationService)],ue);async function se(Q,z,G){const X=await(0,u.determineServerConnectionToken)(z);X instanceof u.ServerConnectionTokenParseError&&(console.warn(X.message),process.exit(1));const ce=new T.DisposableStore,{socketServer:L,instantiationService:N}=await(0,F.setupServerServices)(X,z,G,ce);N.invokeFunction(W=>{const Y=W.get(n.ILogService);(0,y.setUnexpectedErrorHandler)(re=>{re&&re.code==="EPIPE"&&re.syscall==="write"&&re.stack&&/unexpectedErrorHandler/.test(re.stack)||Y.error(re)}),process.on("SIGPIPE",()=>{(0,y.onUnexpectedError)(new Error("Unexpected SIGPIPE"))})}),N.invokeFunction(W=>{const Y=W.get(n.ILogService);if(process.platform==="win32"&&process.env.HOMEDRIVE&&process.env.HOMEPATH){const re=(0,w.join)(process.env.HOMEDRIVE,"node_modules"),me=(0,w.dirname)((0,w.join)(process.env.HOMEDRIVE,process.env.HOMEPATH)),$=(0,w.join)(me,"node_modules");if(t.existsSync(re)||t.existsSync($)){const J=`

*
* !!!! Server terminated due to presence of CVE-2020-1416 !!!!
*
* Please remove the following directories and re-try
* ${re}
* ${$}
*
* For more information on the vulnerability https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-1416
*

`;Y.warn(J),console.warn(J),process.exit(0)}}});const V=N.invokeFunction(W=>{const Y=W.get(n.ILogService);if(t.existsSync((0,w.join)(C.FileAccess.asFileUri("").fsPath,"../node_modules/vsda")))try{return globalThis._VSCODE_NODE_MODULES.vsda}catch(me){Y.error(me)}return null}),ee=t.existsSync(C.FileAccess.asFileUri("vs/code/browser/workbench/workbench.html").fsPath);if(ee&&Q&&typeof Q!="string"){const W=X.type!==0?`?${C.connectionTokenQueryName}=${X.value}`:"";console.log(`Web UI available at http://localhost${Q.port===80?"":`:${Q.port}`}/${W}`)}const oe=N.createInstance(ue,L,X,V,ee);m.mark("code/server/ready");const ge=S.performance.now(),fe=global.vscodeServerStartTime,R=global.vscodeServerListenTime,M=global.vscodeServerCodeLoadedTime;if(N.invokeFunction(W=>{W.get(a.ITelemetryService).publicLog2("serverStart",{startTime:fe,startedTime:R,codeLoadedTime:M,readyTime:ge})}),z["print-startup-performance"]){const W=A.LoaderStats.get();let Y="";Y+=`

### Load AMD-module
`,Y+=A.LoaderStats.toMarkdownTable(["Module","Duration"],W.amdLoad),Y+=`

### Load commonjs-module
`,Y+=A.LoaderStats.toMarkdownTable(["Module","Duration"],W.nodeRequire),Y+=`

### Invoke AMD-module factory
`,Y+=A.LoaderStats.toMarkdownTable(["Module","Duration"],W.amdInvoke),Y+=`

### Invoke commonjs-module
`,Y+=A.LoaderStats.toMarkdownTable(["Module","Duration"],W.nodeEval),Y+=`Start-up time: ${R-fe}
`,Y+=`Code loading time: ${M-fe}
`,Y+=`Initialized time: ${ge-fe}
`,Y+=`
`,console.log(Y)}return oe}e.createServer=se;class U{static create(z){const G=z.webEndpointUrlTemplate,X=z.commit,ce=z.quality;if(!G||!X||!ce)return new U(null);const L=(0,v.generateUuid)(),V=new URL(G.replace("{{uuid}}",L).replace("{{commit}}",X).replace("{{quality}}",ce)).origin,ee=(0,p.escapeRegExpCharacters)(V).replace(L,"[a-zA-Z0-9\\-]+");try{const oe=(0,p.createRegExp)(`^${ee}$`,!0,{matchCase:!1});return new U(oe)}catch{return new U(null)}}constructor(z){this.a=z}matches(z){return this.a?this.a.test(z):!1}}}),define(ve[280],be([1,0,30,29,13,267,269,60,7,270,43,50,45]),function(ie,e,b,t,k,S,I,A,E,y,D,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.spawnCli=void 0,C.mark("code/server/codeLoaded"),global.vscodeServerCodeLoadedTime=y.performance.now();const w={onMultipleValues:(o,a)=>{console.error(`Option '${o}' can only be defined once. Using value ${a}.`)},onEmptyValue:o=>{console.error(`Ignoring option '${o}': Value must not be empty.`)},onUnknownOption:o=>{console.error(`Ignoring option '${o}': not supported for server.`)},onDeprecatedOption:(o,a)=>{console.warn(`Option '${o}' is deprecated: ${a}`)}},m=(0,A.parseArgs)(process.argv.slice(2),D.serverOptions,w),g=m["server-data-dir"]||process.env.VSCODE_AGENT_FOLDER||(0,E.join)(b.homedir(),T.default.serverDataFolderName||".vscode-remote"),p=(0,E.join)(g,"data"),d=(0,E.join)(p,"User"),v=(0,E.join)(d,"globalStorage"),c=(0,E.join)(d,"History"),h=(0,E.join)(p,"Machine");m["user-data-dir"]=p;const f=(0,E.dirname)(k.FileAccess.asFileUri("").fsPath),i=(0,E.join)(f,"extensions");m["builtin-extensions-dir"]=i,m["extensions-dir"]=m["extensions-dir"]||(0,E.join)(g,"extensions"),[g,m["extensions-dir"],p,d,h,v,c].forEach(o=>{try{t.existsSync(o)||t.mkdirSync(o,{mode:448})}catch(a){console.error(a)}});function n(){(0,S.run)(m,g,D.serverOptions)}e.spawnCli=n;function r(o){return(0,I.createServer)(o,m,g)}e.createServer=r})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/e8a3071ea4344d9d48ef8a4df2c097372b0c5161/core/vs/server/node/server.main.js.map
